(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("4dc5e717-751e-430d-a689-ad561f93e52a");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '4dc5e717-751e-430d-a689-ad561f93e52a' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"6fd49b44-eabd-4336-9106-dad88356663e":{"roots":{"references":[{"attributes":{},"id":"1365","type":"CategoricalTicker"},{"attributes":{"below":[{"id":"1364"}],"center":[{"id":"1366"},{"id":"1370"},{"id":"1399"}],"left":[{"id":"1367"}],"plot_height":350,"renderers":[{"id":"1389"}],"title":{"id":"1354"},"toolbar":{"id":"1378"},"toolbar_location":null,"x_range":{"id":"1356"},"x_scale":{"id":"1360"},"y_range":{"id":"1358"},"y_scale":{"id":"1362"}},"id":"1353","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"1393"},"ticker":{"id":"1365"}},"id":"1364","type":"CategoricalAxis"},{"attributes":{},"id":"1397","type":"Selection"},{"attributes":{},"id":"1372","type":"WheelZoomTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"1371"},{"id":"1372"},{"id":"1373"},{"id":"1374"},{"id":"1375"},{"id":"1376"}]},"id":"1378","type":"Toolbar"},{"attributes":{"factors":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"id":"1356","type":"FactorRange"},{"attributes":{},"id":"1376","type":"HelpTool"},{"attributes":{"data":{"counts":[5,3,4,2,4,6],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"1397"},"selection_policy":{"id":"1396"}},"id":"1352","type":"ColumnDataSource"},{"attributes":{},"id":"1362","type":"LinearScale"},{"attributes":{},"id":"1371","type":"PanTool"},{"attributes":{"label":{"field":"fruits"},"renderers":[{"id":"1389"}]},"id":"1400","type":"LegendItem"},{"attributes":{"items":[{"id":"1400"}],"location":"top_center","orientation":"horizontal"},"id":"1399","type":"Legend"},{"attributes":{"end":9,"start":0},"id":"1358","type":"DataRange1d"},{"attributes":{"factors":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"],"palette":["#3288bd","#99d594","#e6f598","#fee08b","#fc8d59","#d53e4f"]},"id":"1385","type":"CategoricalColorMapper"},{"attributes":{"fill_color":{"field":"fruits","transform":{"id":"1385"}},"line_color":{"value":"white"},"top":{"field":"counts"},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"1387","type":"VBar"},{"attributes":{"data_source":{"id":"1352"},"glyph":{"id":"1387"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"1388"},"selection_glyph":null,"view":{"id":"1390"}},"id":"1389","type":"GlyphRenderer"},{"attributes":{},"id":"1393","type":"CategoricalTickFormatter"},{"attributes":{},"id":"1395","type":"BasicTickFormatter"},{"attributes":{},"id":"1374","type":"SaveTool"},{"attributes":{"text":"Fruit Counts"},"id":"1354","type":"Title"},{"attributes":{"source":{"id":"1352"}},"id":"1390","type":"CDSView"},{"attributes":{"overlay":{"id":"1377"}},"id":"1373","type":"BoxZoomTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"1377","type":"BoxAnnotation"},{"attributes":{},"id":"1360","type":"CategoricalScale"},{"attributes":{"formatter":{"id":"1395"},"ticker":{"id":"1368"}},"id":"1367","type":"LinearAxis"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fruits","transform":{"id":"1385"}},"line_alpha":{"value":0.1},"line_color":{"value":"white"},"top":{"field":"counts"},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"1388","type":"VBar"},{"attributes":{},"id":"1396","type":"UnionRenderers"},{"attributes":{"axis":{"id":"1364"},"grid_line_color":null,"ticker":null},"id":"1366","type":"Grid"},{"attributes":{},"id":"1368","type":"BasicTicker"},{"attributes":{},"id":"1375","type":"ResetTool"},{"attributes":{"axis":{"id":"1367"},"dimension":1,"ticker":null},"id":"1370","type":"Grid"}],"root_ids":["1353"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"6fd49b44-eabd-4336-9106-dad88356663e","root_ids":["1353"],"roots":{"1353":"4dc5e717-751e-430d-a689-ad561f93e52a"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();