(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("01bcafa2-c321-4530-952e-0d85a04967a3");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '01bcafa2-c321-4530-952e-0d85a04967a3' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"7e8b8dc9-98b6-4940-b2f7-768eccf337a1":{"roots":{"references":[{"attributes":{"data_source":{"id":"1495"},"glyph":{"id":"1546"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"1547"},"selection_glyph":null,"view":{"id":"1549"}},"id":"1548","type":"GlyphRenderer"},{"attributes":{"items":[{"id":"1529"},{"id":"1543"},{"id":"1557"}],"location":"top_left","orientation":"horizontal"},"id":"1528","type":"Legend"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"1514","type":"Toolbar"},{"attributes":{"text":"Fruit Counts by Year"},"id":"1497","type":"Title"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#c9d9d3"},"line_alpha":{"value":0.1},"line_color":{"value":"#c9d9d3"},"top":{"field":"2015"},"width":{"value":0.2},"x":{"field":"fruits","transform":{"id":"1515"}}},"id":"1518","type":"VBar"},{"attributes":{"formatter":{"id":"1525"},"ticker":{"id":"1511"}},"id":"1510","type":"LinearAxis"},{"attributes":{"fill_color":{"value":"#c9d9d3"},"line_color":{"value":"#c9d9d3"},"top":{"field":"2015"},"width":{"value":0.2},"x":{"field":"fruits","transform":{"id":"1515"}}},"id":"1517","type":"VBar"},{"attributes":{},"id":"1503","type":"CategoricalScale"},{"attributes":{},"id":"1505","type":"LinearScale"},{"attributes":{"end":10},"id":"1501","type":"Range1d"},{"attributes":{"source":{"id":"1495"}},"id":"1535","type":"CDSView"},{"attributes":{"data_source":{"id":"1495"},"glyph":{"id":"1517"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"1518"},"selection_glyph":null,"view":{"id":"1520"}},"id":"1519","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#718dbf"},"line_alpha":{"value":0.1},"line_color":{"value":"#718dbf"},"top":{"field":"2016"},"width":{"value":0.2},"x":{"field":"fruits","transform":{"id":"1530"}}},"id":"1533","type":"VBar"},{"attributes":{"label":{"value":"2015"},"renderers":[{"id":"1519"}]},"id":"1529","type":"LegendItem"},{"attributes":{"axis":{"id":"1510"},"dimension":1,"ticker":null},"id":"1513","type":"Grid"},{"attributes":{},"id":"1526","type":"UnionRenderers"},{"attributes":{"range":{"id":"1499"}},"id":"1530","type":"Dodge"},{"attributes":{"label":{"value":"2016"},"renderers":[{"id":"1534"}]},"id":"1543","type":"LegendItem"},{"attributes":{"data_source":{"id":"1495"},"glyph":{"id":"1532"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"1533"},"selection_glyph":null,"view":{"id":"1535"}},"id":"1534","type":"GlyphRenderer"},{"attributes":{"label":{"value":"2017"},"renderers":[{"id":"1548"}]},"id":"1557","type":"LegendItem"},{"attributes":{"factors":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"],"range_padding":0.1},"id":"1499","type":"FactorRange"},{"attributes":{"source":{"id":"1495"}},"id":"1520","type":"CDSView"},{"attributes":{},"id":"1511","type":"BasicTicker"},{"attributes":{},"id":"1523","type":"CategoricalTickFormatter"},{"attributes":{},"id":"1525","type":"BasicTickFormatter"},{"attributes":{},"id":"1508","type":"CategoricalTicker"},{"attributes":{"range":{"id":"1499"},"value":0.25},"id":"1544","type":"Dodge"},{"attributes":{"data":{"2015":[2,1,4,3,2,4],"2016":[5,3,3,2,4,6],"2017":[3,2,4,4,5,3],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"1527"},"selection_policy":{"id":"1526"}},"id":"1495","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#e84d60"},"line_alpha":{"value":0.1},"line_color":{"value":"#e84d60"},"top":{"field":"2017"},"width":{"value":0.2},"x":{"field":"fruits","transform":{"id":"1544"}}},"id":"1547","type":"VBar"},{"attributes":{},"id":"1527","type":"Selection"},{"attributes":{"below":[{"id":"1507"}],"center":[{"id":"1509"},{"id":"1513"},{"id":"1528"}],"left":[{"id":"1510"}],"plot_height":350,"renderers":[{"id":"1519"},{"id":"1534"},{"id":"1548"}],"title":{"id":"1497"},"toolbar":{"id":"1514"},"toolbar_location":null,"x_range":{"id":"1499"},"x_scale":{"id":"1503"},"y_range":{"id":"1501"},"y_scale":{"id":"1505"}},"id":"1496","subtype":"Figure","type":"Plot"},{"attributes":{"axis":{"id":"1507"},"grid_line_color":null,"ticker":null},"id":"1509","type":"Grid"},{"attributes":{"fill_color":{"value":"#e84d60"},"line_color":{"value":"#e84d60"},"top":{"field":"2017"},"width":{"value":0.2},"x":{"field":"fruits","transform":{"id":"1544"}}},"id":"1546","type":"VBar"},{"attributes":{"formatter":{"id":"1523"},"ticker":{"id":"1508"}},"id":"1507","type":"CategoricalAxis"},{"attributes":{"source":{"id":"1495"}},"id":"1549","type":"CDSView"},{"attributes":{"range":{"id":"1499"},"value":-0.25},"id":"1515","type":"Dodge"},{"attributes":{"fill_color":{"value":"#718dbf"},"line_color":{"value":"#718dbf"},"top":{"field":"2016"},"width":{"value":0.2},"x":{"field":"fruits","transform":{"id":"1530"}}},"id":"1532","type":"VBar"}],"root_ids":["1496"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"7e8b8dc9-98b6-4940-b2f7-768eccf337a1","root_ids":["1496"],"roots":{"1496":"01bcafa2-c321-4530-952e-0d85a04967a3"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();