(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("c39e8ba3-10e1-4ba3-954d-3256cf08f2d4");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'c39e8ba3-10e1-4ba3-954d-3256cf08f2d4' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"eec3afc5-15a7-4ab0-b30f-6b9bd0c9b526":{"roots":{"references":[{"attributes":{"data":{"x":["a","b","c","d","e","f"],"y":{"__ndarray__":"KqW2HYj9BEBGXMsmlzoHQP3RgFRM2w9A+f1xZC6hDUCIEPan1ggSQDIONAURbhJA","dtype":"float64","order":"little","shape":[6]}},"selected":{"id":"2454"},"selection_policy":{"id":"2453"}},"id":"2427","type":"ColumnDataSource"},{"attributes":{"fill_color":{"value":"#1f77b4"},"height":{"units":"data","value":0.01},"width":{"units":"data","value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"2428","type":"Rect"},{"attributes":{},"id":"2446","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"height":{"units":"data","value":0.01},"line_alpha":{"value":0.1},"width":{"units":"data","value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"2429","type":"Rect"},{"attributes":{"text":""},"id":"2437","type":"Title"},{"attributes":{"source":{"id":"2432"}},"id":"2436","type":"CDSView"},{"attributes":{"axis":{"id":"2397"},"dimension":1,"grid_line_color":"white","grid_line_width":2,"ticker":null},"id":"2400","type":"Grid"},{"attributes":{"source":{"id":"2427"}},"id":"2431","type":"CDSView"},{"attributes":{},"id":"2388","type":"DataRange1d"},{"attributes":{"data":{"x0":["a","b","c","d","e","f"],"x1":["a","b","c","d","e","f"],"y0":{"__ndarray__":"KqW2HYj9BEBGXMsmlzoHQP3RgFRM2w9A+f1xZC6hDUCIEPan1ggSQDIONAURbhJA","dtype":"float64","order":"little","shape":[6]},"y1":{"__ndarray__":"QjjtX7g75T9KBqBi0InpP4rjwIrPrvs/Lki1q3JF+j+qS8SU3CoGQIR84pcntAVA","dtype":"float64","order":"little","shape":[6]}},"selected":{"id":"2444"},"selection_policy":{"id":"2443"}},"id":"2402","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"2422"},"glyph":{"id":"2423"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2424"},"selection_glyph":null,"view":{"id":"2426"}},"id":"2425","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"2427"},"glyph":{"id":"2428"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2429"},"selection_glyph":null,"view":{"id":"2431"}},"id":"2430","type":"GlyphRenderer"},{"attributes":{"source":{"id":"2402"}},"id":"2406","type":"CDSView"},{"attributes":{},"id":"2450","type":"Selection"},{"attributes":{"source":{"id":"2407"}},"id":"2411","type":"CDSView"},{"attributes":{},"id":"2456","type":"Selection"},{"attributes":{"data_source":{"id":"2402"},"glyph":{"id":"2403"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2404"},"selection_glyph":null,"view":{"id":"2406"}},"id":"2405","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"2442"},"ticker":{"id":"2398"}},"id":"2397","type":"LinearAxis"},{"attributes":{"data":{"x":["a","b","c","d","e","f"],"y":{"__ndarray__":"xu08nBLUBMBAetnp02EFwBDYDdVcSPm/wCwhvDGU+L8MlJ5vY+Xgv0D3tpU8A+K/","dtype":"float64","order":"little","shape":[6]}},"selected":{"id":"2452"},"selection_policy":{"id":"2451"}},"id":"2422","type":"ColumnDataSource"},{"attributes":{},"id":"2455","type":"UnionRenderers"},{"attributes":{},"id":"2454","type":"Selection"},{"attributes":{"source":{"id":"2422"}},"id":"2426","type":"CDSView"},{"attributes":{},"id":"2453","type":"UnionRenderers"},{"attributes":{"fill_color":{"value":"#1f77b4"},"height":{"units":"data","value":0.01},"width":{"units":"data","value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"2423","type":"Rect"},{"attributes":{},"id":"2452","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"height":{"units":"data","value":0.01},"line_alpha":{"value":0.1},"width":{"units":"data","value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"2424","type":"Rect"},{"attributes":{"source":{"id":"2417"}},"id":"2421","type":"CDSView"},{"attributes":{},"id":"2449","type":"UnionRenderers"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":"#3B8686"},"top":{"field":"top"},"width":{"value":0.7},"x":{"field":"x"}},"id":"2418","type":"VBar"},{"attributes":{"data_source":{"id":"2417"},"glyph":{"id":"2418"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2419"},"selection_glyph":null,"view":{"id":"2421"}},"id":"2420","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.1},"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2404","type":"Segment"},{"attributes":{},"id":"2448","type":"Selection"},{"attributes":{"source":{"id":"2412"}},"id":"2416","type":"CDSView"},{"attributes":{"data_source":{"id":"2412"},"glyph":{"id":"2413"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2414"},"selection_glyph":null,"view":{"id":"2416"}},"id":"2415","type":"GlyphRenderer"},{"attributes":{"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2403","type":"Segment"},{"attributes":{"data":{"x":["a","a","b","b","c","d","d","f"],"y":[-2.7383576466867665,2.867473603476629,3.4711468505021728,3.192078939297718,4.137392076813487,3.9147185266904065,3.7668073805647477,-1.2100627034233957]},"selected":{"id":"2456"},"selection_policy":{"id":"2455"}},"id":"2432","type":"ColumnDataSource"},{"attributes":{"factors":["a","b","c","d","e","f"]},"id":"2386","type":"FactorRange"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":"#E08E79"},"top":{"field":"top"},"width":{"value":0.7},"x":{"field":"x"}},"id":"2413","type":"VBar"},{"attributes":{"line_alpha":{"value":0.1},"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2409","type":"Segment"},{"attributes":{"fill_alpha":{"value":0.6},"fill_color":{"value":"#F38630"},"line_color":{"value":"#F38630"},"size":{"units":"screen","value":6},"x":{"field":"x"},"y":{"field":"y"}},"id":"2433","type":"Circle"},{"attributes":{"data":{"x0":["a","b","c","d","e","f"],"x1":["a","b","c","d","e","f"],"y0":{"__ndarray__":"xu08nBLUBMBAetnp02EFwBDYDdVcSPm/wCwhvDGU+L8MlJ5vY+Xgv0D3tpU8A+K/","dtype":"float64","order":"little","shape":[6]},"y1":{"__ndarray__":"rloGWuKV5L9ClhPDN2Hjv01vWF/2TM0/AOytCwUe0T+u6XuMrUj2P/hjHmUjcfY/","dtype":"float64","order":"little","shape":[6]}},"selected":{"id":"2446"},"selection_policy":{"id":"2445"}},"id":"2407","type":"ColumnDataSource"},{"attributes":{},"id":"2398","type":"BasicTicker"},{"attributes":{},"id":"2451","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"2407"},"glyph":{"id":"2408"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2409"},"selection_glyph":null,"view":{"id":"2411"}},"id":"2410","type":"GlyphRenderer"},{"attributes":{},"id":"2392","type":"LinearScale"},{"attributes":{},"id":"2440","type":"CategoricalTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"2401","type":"Toolbar"},{"attributes":{"data_source":{"id":"2432"},"glyph":{"id":"2433"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2434"},"selection_glyph":null,"view":{"id":"2436"}},"id":"2435","type":"GlyphRenderer"},{"attributes":{},"id":"2390","type":"CategoricalScale"},{"attributes":{"data":{"bottom":{"__ndarray__":"xQ4Imt4toT+iI9iE9pG+P9D+D/jPqO8/Z3L2CqNA7z9/F/b5bbUAQM+tYnVBKABA","dtype":"float64","order":"little","shape":[6]},"top":{"__ndarray__":"rloGWuKV5L9ClhPDN2Hjv01vWF/2TM0/AOytCwUe0T+u6XuMrUj2P/hjHmUjcfY/","dtype":"float64","order":"little","shape":[6]},"x":["a","b","c","d","e","f"]},"selected":{"id":"2450"},"selection_policy":{"id":"2449"}},"id":"2417","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#F38630"},"line_alpha":{"value":0.1},"line_color":{"value":"#F38630"},"size":{"units":"screen","value":6},"x":{"field":"x"},"y":{"field":"y"}},"id":"2434","type":"Circle"},{"attributes":{},"id":"2447","type":"UnionRenderers"},{"attributes":{"background_fill_color":"#efefef","below":[{"id":"2394"}],"center":[{"id":"2396"},{"id":"2400"}],"left":[{"id":"2397"}],"renderers":[{"id":"2405"},{"id":"2410"},{"id":"2415"},{"id":"2420"},{"id":"2425"},{"id":"2430"},{"id":"2435"}],"title":{"id":"2437"},"toolbar":{"id":"2401"},"toolbar_location":null,"x_range":{"id":"2386"},"x_scale":{"id":"2390"},"y_range":{"id":"2388"},"y_scale":{"id":"2392"}},"id":"2385","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"2440"},"major_label_text_font_size":"16px","ticker":{"id":"2395"}},"id":"2394","type":"CategoricalAxis"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#E08E79"},"line_alpha":{"value":0.1},"top":{"field":"top"},"width":{"value":0.7},"x":{"field":"x"}},"id":"2414","type":"VBar"},{"attributes":{},"id":"2395","type":"CategoricalTicker"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#3B8686"},"line_alpha":{"value":0.1},"top":{"field":"top"},"width":{"value":0.7},"x":{"field":"x"}},"id":"2419","type":"VBar"},{"attributes":{},"id":"2443","type":"UnionRenderers"},{"attributes":{"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2408","type":"Segment"},{"attributes":{},"id":"2442","type":"BasicTickFormatter"},{"attributes":{"data":{"bottom":{"__ndarray__":"QjjtX7g75T9KBqBi0InpP4rjwIrPrvs/Lki1q3JF+j+qS8SU3CoGQIR84pcntAVA","dtype":"float64","order":"little","shape":[6]},"top":{"__ndarray__":"xQ4Imt4toT+iI9iE9pG+P9D+D/jPqO8/Z3L2CqNA7z9/F/b5bbUAQM+tYnVBKABA","dtype":"float64","order":"little","shape":[6]},"x":["a","b","c","d","e","f"]},"selected":{"id":"2448"},"selection_policy":{"id":"2447"}},"id":"2412","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"2394"},"grid_line_color":null,"grid_line_width":2,"ticker":null},"id":"2396","type":"Grid"},{"attributes":{},"id":"2444","type":"Selection"},{"attributes":{},"id":"2445","type":"UnionRenderers"}],"root_ids":["2385"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"eec3afc5-15a7-4ab0-b30f-6b9bd0c9b526","root_ids":["2385"],"roots":{"2385":"c39e8ba3-10e1-4ba3-954d-3256cf08f2d4"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();