(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("b73c9caa-3581-4aa7-b949-741eaa3bfc79");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'b73c9caa-3581-4aa7-b949-741eaa3bfc79' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"72b78f20-6528-4ef7-a946-197bd27a38ac":{"roots":{"references":[{"attributes":{"label":{"value":"2017"},"renderers":[{"id":"2019"}]},"id":"2032","type":"LegendItem"},{"attributes":{"bottom":{"expr":{"id":"1982"}},"fill_alpha":{"value":0.1},"fill_color":{"value":"#e84d60"},"line_alpha":{"value":0.1},"line_color":{"value":"#e84d60"},"top":{"expr":{"id":"1983"}},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"2018","type":"VBar"},{"attributes":{},"id":"2030","type":"UnionRenderers"},{"attributes":{"source":{"id":"2015"}},"id":"2020","type":"CDSView"},{"attributes":{},"id":"2012","type":"UnionRenderers"},{"attributes":{"factors":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"],"range_padding":0.1},"id":"1960","type":"FactorRange"},{"attributes":{"label":{"value":"2015"},"renderers":[{"id":"1988"}]},"id":"1998","type":"LegendItem"},{"attributes":{"data":{"2015":[2,1,4,3,2,4],"2016":[5,3,4,2,4,6],"2017":[3,2,4,4,5,3],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"2031"},"selection_policy":{"id":"2030"}},"id":"2015","type":"ColumnDataSource"},{"attributes":{"data":{"2015":[2,1,4,3,2,4],"2016":[5,3,4,2,4,6],"2017":[3,2,4,4,5,3],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"2013"},"selection_policy":{"id":"2012"}},"id":"1999","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"1968"},"grid_line_color":null,"ticker":null},"id":"1970","type":"Grid"},{"attributes":{},"id":"1992","type":"CategoricalTickFormatter"},{"attributes":{},"id":"1995","type":"UnionRenderers"},{"attributes":{},"id":"1964","type":"CategoricalScale"},{"attributes":{"bottom":{"expr":{"id":"1980"}},"fill_color":{"value":"#718dbf"},"line_color":{"value":"#718dbf"},"top":{"expr":{"id":"1981"}},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"2001","type":"VBar"},{"attributes":{},"id":"1972","type":"BasicTicker"},{"attributes":{"axis":{"id":"1971"},"dimension":1,"ticker":null},"id":"1974","type":"Grid"},{"attributes":{"data_source":{"id":"1984"},"glyph":{"id":"1986"},"hover_glyph":null,"muted_glyph":null,"name":"2015","nonselection_glyph":{"id":"1987"},"selection_glyph":null,"view":{"id":"1989"}},"id":"1988","type":"GlyphRenderer"},{"attributes":{},"id":"1994","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"2015"},"glyph":{"id":"2017"},"hover_glyph":null,"muted_glyph":null,"name":"2017","nonselection_glyph":{"id":"2018"},"selection_glyph":null,"view":{"id":"2020"}},"id":"2019","type":"GlyphRenderer"},{"attributes":{},"id":"1969","type":"CategoricalTicker"},{"attributes":{"formatter":{"id":"1994"},"minor_tick_line_color":null,"ticker":{"id":"1972"}},"id":"1971","type":"LinearAxis"},{"attributes":{"formatter":{"id":"1992"},"minor_tick_line_color":null,"ticker":{"id":"1969"}},"id":"1968","type":"CategoricalAxis"},{"attributes":{"fields":["2015","2016","2017"]},"id":"1983","type":"Stack"},{"attributes":{"data":{"2015":[2,1,4,3,2,4],"2016":[5,3,4,2,4,6],"2017":[3,2,4,4,5,3],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"1996"},"selection_policy":{"id":"1995"}},"id":"1984","type":"ColumnDataSource"},{"attributes":{},"id":"1996","type":"Selection"},{"attributes":{"bottom":{"expr":{"id":"1978"}},"fill_alpha":{"value":0.1},"fill_color":{"value":"#c9d9d3"},"line_alpha":{"value":0.1},"line_color":{"value":"#c9d9d3"},"top":{"expr":{"id":"1979"}},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"1987","type":"VBar"},{"attributes":{"fields":["2015","2016"]},"id":"1982","type":"Stack"},{"attributes":{"bottom":{"expr":{"id":"1978"}},"fill_color":{"value":"#c9d9d3"},"line_color":{"value":"#c9d9d3"},"top":{"expr":{"id":"1979"}},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"1986","type":"VBar"},{"attributes":{"fields":["2015","2016"]},"id":"1981","type":"Stack"},{"attributes":{"items":[{"id":"1998"},{"id":"2014"},{"id":"2032"}],"location":"top_left","orientation":"horizontal"},"id":"1997","type":"Legend"},{"attributes":{"source":{"id":"1999"}},"id":"2004","type":"CDSView"},{"attributes":{"callback":null,"tooltips":"$name @fruits: @$name"},"id":"1975","type":"HoverTool"},{"attributes":{},"id":"2013","type":"Selection"},{"attributes":{"below":[{"id":"1968"}],"center":[{"id":"1970"},{"id":"1974"},{"id":"1997"}],"left":[{"id":"1971"}],"outline_line_color":null,"plot_height":250,"renderers":[{"id":"1988"},{"id":"2003"},{"id":"2019"}],"title":{"id":"1958"},"toolbar":{"id":"1976"},"toolbar_location":null,"x_range":{"id":"1960"},"x_scale":{"id":"1964"},"y_range":{"id":"1962"},"y_scale":{"id":"1966"}},"id":"1957","subtype":"Figure","type":"Plot"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"1975"}]},"id":"1976","type":"Toolbar"},{"attributes":{"source":{"id":"1984"}},"id":"1989","type":"CDSView"},{"attributes":{"fields":[]},"id":"1978","type":"Stack"},{"attributes":{"fields":["2015"]},"id":"1979","type":"Stack"},{"attributes":{},"id":"2031","type":"Selection"},{"attributes":{"text":"Fruit Counts by Year"},"id":"1958","type":"Title"},{"attributes":{"start":0},"id":"1962","type":"DataRange1d"},{"attributes":{"label":{"value":"2016"},"renderers":[{"id":"2003"}]},"id":"2014","type":"LegendItem"},{"attributes":{"bottom":{"expr":{"id":"1982"}},"fill_color":{"value":"#e84d60"},"line_color":{"value":"#e84d60"},"top":{"expr":{"id":"1983"}},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"2017","type":"VBar"},{"attributes":{"bottom":{"expr":{"id":"1980"}},"fill_alpha":{"value":0.1},"fill_color":{"value":"#718dbf"},"line_alpha":{"value":0.1},"line_color":{"value":"#718dbf"},"top":{"expr":{"id":"1981"}},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"2002","type":"VBar"},{"attributes":{"fields":["2015"]},"id":"1980","type":"Stack"},{"attributes":{"data_source":{"id":"1999"},"glyph":{"id":"2001"},"hover_glyph":null,"muted_glyph":null,"name":"2016","nonselection_glyph":{"id":"2002"},"selection_glyph":null,"view":{"id":"2004"}},"id":"2003","type":"GlyphRenderer"},{"attributes":{},"id":"1966","type":"LinearScale"}],"root_ids":["1957"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"72b78f20-6528-4ef7-a946-197bd27a38ac","root_ids":["1957"],"roots":{"1957":"b73c9caa-3581-4aa7-b949-741eaa3bfc79"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();