(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("13d46561-f198-4e18-8332-6e26305d700a");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '13d46561-f198-4e18-8332-6e26305d700a' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"f63bb62b-a854-4833-9f7a-397cf232ce7a":{"roots":{"references":[{"attributes":{"end_angle":{"field":"end_angle","units":"rad"},"fill_alpha":{"value":0.1},"fill_color":{"value":"black"},"inner_radius":{"units":"data","value":80},"line_alpha":{"value":0.1},"outer_radius":{"units":"data","value":300},"start_angle":{"field":"start_angle","units":"rad"},"x":{"value":0},"y":{"value":0}},"id":"2574","type":"AnnularWedge"},{"attributes":{},"id":"2531","type":"SaveTool"},{"attributes":{"end_angle":{"field":"end_angle","units":"rad"},"fill_color":{"value":"black"},"inner_radius":{"units":"data","value":80},"outer_radius":{"units":"data","value":300},"start_angle":{"field":"start_angle","units":"rad"},"x":{"value":0},"y":{"value":0}},"id":"2573","type":"AnnularWedge"},{"attributes":{"end_angle":{"field":"end_angle","units":"rad"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#0d3362"},"inner_radius":{"units":"data","value":90},"line_alpha":{"value":0.1},"line_color":{"value":"#0d3362"},"outer_radius":{"field":"outer_radius","units":"data"},"start_angle":{"field":"start_angle","units":"rad"},"x":{"value":0},"y":{"value":0}},"id":"2549","type":"AnnularWedge"},{"attributes":{"data":{"end_angle":{"__ndarray__":"eWh3JypD8D/Iyt29krLkPz+JmVmivdE/TAwiIoOnt79nj6rqY5Hdv95NZoZznOq/A6q7ixo4878ZLURU+yH5vy2wzBzcC/+/oJmqct56AsAr2+7Wzm8FwLUcMzu/ZAjAP153n69ZC8DJn7sDoE4OwKvw/zPIoRDAbxEiZkAcEsA=","dtype":"float64","order":"little","shape":[16]},"start_angle":{"__ndarray__":"eWh3JypD8D/Iyt29krLkPz+JmVmivdE/TAwiIoOnt79nj6rqY5Hdv95NZoZznOq/A6q7ixo4878ZLURU+yH5vy2wzBzcC/+/oJmqct56AsAr2+7Wzm8FwLUcMzu/ZAjAP153n69ZC8DJn7sDoE4OwKvw/zPIoRDAbxEiZkAcEsA=","dtype":"float64","order":"little","shape":[16]}},"selected":{"id":"2616"},"selection_policy":{"id":"2615"}},"id":"2572","type":"ColumnDataSource"},{"attributes":{},"id":"2603","type":"UnionRenderers"},{"attributes":{"data":{"end_angle":{"__ndarray__":"Zv0QQcZU9T+i9BDxytXuP3ru/18JAuM/RKG7Ox+5zD9kd4gI55XCvwQkM1M7eeC/LCpE5PxM7L8smKo6XxD0v0AbMwNA+vm/U567yyDk/7+0ECLKAOcCwD5SZi7x2wXAyJOqkuHQCMBS1e720cULwN8WM1vCug7ANKy7X9nXEMA=","dtype":"float64","order":"little","shape":[16]},"outer_radius":{"__ndarray__":"bLZfBPAOV0Cg0sRXLXlhQDLrDr5nTGNA1FIAQwHoVkAGyYzXMg9lQNRSAEMB6FZAFEU4zHF2XEAGyYzXMg9lQHi2fdUW2VZAAAAAAAAgckAGyYzXMg9lQIaiNChEiGtA/HdeznjObkAAAAAAACByQKYExgH2o29ApgTGAfajb0A=","dtype":"float64","order":"little","shape":[16]},"start_angle":{"__ndarray__":"Pw8ikoF89D9UGDOTQSXtPysSIgKAUeE/CDBExPn2xT+g6P9/DFjJv1IAEbHEKeK/egYiQob97b9Thpnpo+j0v2cJIrKE0vq/PUZVvTJeAMDIh5khI1MDwFLJ3YUTSAbA3Aoi6gM9CcBmTGZO9DEMwPONqrLkJg/Avmd3i+oNEcA=","dtype":"float64","order":"little","shape":[16]}},"selected":{"id":"2606"},"selection_policy":{"id":"2605"}},"id":"2547","type":"ColumnDataSource"},{"attributes":{"end_angle":{"field":"end_angle","units":"rad"},"fill_color":{"value":"#c64737"},"inner_radius":{"units":"data","value":90},"line_color":{"value":"#c64737"},"outer_radius":{"field":"outer_radius","units":"data"},"start_angle":{"field":"start_angle","units":"rad"},"x":{"value":0},"y":{"value":0}},"id":"2553","type":"AnnularWedge"},{"attributes":{"data":{"angle":{"__ndarray__":"BKq7ixo48z/dTWaGc5zqP2iPqupjkd0/WgwiIoOntz8+iZlZor3Rv8nK3b2SsuS/eGh3JypD8L+O6//vCi32v47r/+8KLfY/emh3JypD8D/Iyt29krLkP0CJmVmivdE/QAwiIoOnt79gj6rqY5Hdv+BNZoZznOq/BKq7ixo4878=","dtype":"float64","order":"little","shape":[16]},"text":["Mycobacterium tuberculosis","Salmonella schottmuelleri","Proteus vulgaris","Klebsiella pneumoniae","Brucella abortus","Pseudomonas aeruginosa","Escherichia coli","Salmonella (Eberthella) typhosa","Aerobacter aerogenes","Brucella antracis","Streptococcus fecalis","Staphylococcus aureus","Staphylococcus albus","Streptococcus hemolyticus","Streptococcus viridans","Diplococcus pneumoniae"],"x":{"__ndarray__":"cGn7M6UwWkA0VkZE5WtoQKq2lcOOOXBAjuBL4jQMckDOGdT43m5xQMF6BpGZ7WxA7SBXXEoVY0AXTcs3yKRKQBJNyzfIpErA6CBXXEoVY8DBegaRme1swM4Z1PjebnHAj+BL4jQMcsCrtpXDjjlwwDJWRkTla2jAcWn7M6UwWsA=","dtype":"float64","order":"little","shape":[16]},"y":{"__ndarray__":"aywf0KvmcEAmrFe0AMpqQKfycbJzKGBAv6EJxQDCOkC6LG9iL9dTwNZbjg1z2GXAdpVS2APSbsAYUkjE/tBxwBhSSMT+0HHAepVS2APSbsDWW44Nc9hlwL8sb2Iv11PAmaEJxQDCOkCi8nGycyhgQCasV7QAympAaywf0KvmcEA=","dtype":"float64","order":"little","shape":[16]}},"selected":{"id":"2618"},"selection_policy":{"id":"2617"}},"id":"2577","type":"ColumnDataSource"},{"attributes":{},"id":"2604","type":"Selection"},{"attributes":{},"id":"2605","type":"UnionRenderers"},{"attributes":{"end_angle":{"field":"end_angle","units":"rad"},"fill_color":{"value":"#0d3362"},"inner_radius":{"units":"data","value":90},"line_color":{"value":"#0d3362"},"outer_radius":{"field":"outer_radius","units":"data"},"start_angle":{"field":"start_angle","units":"rad"},"x":{"value":0},"y":{"value":0}},"id":"2548","type":"AnnularWedge"},{"attributes":{},"id":"2532","type":"ResetTool"},{"attributes":{},"id":"2606","type":"Selection"},{"attributes":{"end_angle":{"field":"end_angle","units":"rad"},"fill_color":{"field":"fill_color"},"inner_radius":{"units":"data","value":90},"line_color":{"field":"line_color"},"outer_radius":{"units":"data","value":290},"start_angle":{"field":"start_angle","units":"rad"},"x":{"value":0},"y":{"value":0}},"id":"2543","type":"AnnularWedge"},{"attributes":{"source":{"id":"2547"}},"id":"2551","type":"CDSView"},{"attributes":{"source":{"id":"2572"}},"id":"2576","type":"CDSView"},{"attributes":{},"id":"2607","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"2572"},"glyph":{"id":"2573"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2574"},"selection_glyph":null,"view":{"id":"2576"}},"id":"2575","type":"GlyphRenderer"},{"attributes":{},"id":"2533","type":"HelpTool"},{"attributes":{"angle":{"field":"angle","units":"rad"},"text_align":"center","text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"12px"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2578","type":"Text"},{"attributes":{"end":420,"start":-420},"id":"2522","type":"Range1d"},{"attributes":{},"id":"2608","type":"Selection"},{"attributes":{"data":{"fill_color":["#e69584","#aeaeb8"],"line_color":["#e69584","#aeaeb8"],"x":[-40,-40],"y":[-370,-390]},"selected":{"id":"2620"},"selection_policy":{"id":"2619"}},"id":"2582","type":"ColumnDataSource"},{"attributes":{},"id":"2609","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"2547"},"glyph":{"id":"2548"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2549"},"selection_glyph":null,"view":{"id":"2551"}},"id":"2550","type":"GlyphRenderer"},{"attributes":{"fill_color":{"field":"fill_color"},"line_color":{"field":"line_color"},"radius":{"units":"data","value":5},"x":{"field":"x"},"y":{"field":"y"}},"id":"2583","type":"Circle"},{"attributes":{"source":{"id":"2597"}},"id":"2601","type":"CDSView"},{"attributes":{"source":{"id":"2582"}},"id":"2586","type":"CDSView"},{"attributes":{},"id":"2610","type":"Selection"},{"attributes":{"text":""},"id":"2518","type":"Title"},{"attributes":{},"id":"2611","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"2577"},"glyph":{"id":"2578"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2579"},"selection_glyph":null,"view":{"id":"2581"}},"id":"2580","type":"GlyphRenderer"},{"attributes":{"end_angle":{"field":"end_angle","units":"rad"},"fill_color":{"value":"black"},"inner_radius":{"units":"data","value":90},"outer_radius":{"field":"outer_radius","units":"data"},"start_angle":{"field":"start_angle","units":"rad"},"x":{"value":0},"y":{"value":0}},"id":"2558","type":"AnnularWedge"},{"attributes":{},"id":"2612","type":"Selection"},{"attributes":{"end_angle":{"field":"end_angle","units":"rad"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#c64737"},"inner_radius":{"units":"data","value":90},"line_alpha":{"value":0.1},"line_color":{"value":"#c64737"},"outer_radius":{"field":"outer_radius","units":"data"},"start_angle":{"field":"start_angle","units":"rad"},"x":{"value":0},"y":{"value":0}},"id":"2554","type":"AnnularWedge"},{"attributes":{"source":{"id":"2542"}},"id":"2546","type":"CDSView"},{"attributes":{"data":{"end_angle":{"__ndarray__":"FyEz4zyk8z8EPFU1uHTrP7hriEjtQd8/ln2Zmahpvj/urLv7GA3Qv6Lc7g5O2uO/yuL/nw+u7797dIiY6MD1v4/3EGHJqvu/Ub3MFFXKAMDc/hB5Rb8DwGZAVd01tAbA8IGZQSapCcB6w92lFp4MwAcFIgoHkw/ARyMzt/tDEcA=","dtype":"float64","order":"little","shape":[16]},"outer_radius":{"__ndarray__":"pmlXNAGDYkDWwF0C/m1lQDjj0CUzIWlAZ+OHhpjCZECbzPtu2O9jQJvM+27Y72NAHRgJcjWcZkAdGAlyNZxmQAbJjNcyD2VAx3MGqjT1bUAGyYzXMg9lQIaiNChEiGtAOOPQJTMhaUDoDDhWBvtgQKDSxFcteWFASjEX/kFVYUA=","dtype":"float64","order":"little","shape":[16]},"start_angle":{"__ndarray__":"8DJENPjL8j+1X3fXLsTpPxqzzIza4Ns/Hpuqql3lsD+MZXe3K27Tv/G4zGzXiuW/jN/ufkyv8L+iYndHLZn2v7bl/w8Og/y/ZTREbHc2AcDwdYjQZysEwHq3zDRYIAfABPkQmUgVCsCOOlX9OAoNwBt8mWEp/w/A0d7u4gx6EcA=","dtype":"float64","order":"little","shape":[16]}},"selected":{"id":"2608"},"selection_policy":{"id":"2607"}},"id":"2552","type":"ColumnDataSource"},{"attributes":{"angle":{"field":"angle","units":"rad"},"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"12px"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2579","type":"Text"},{"attributes":{},"id":"2613","type":"UnionRenderers"},{"attributes":{"source":{"id":"2577"}},"id":"2581","type":"CDSView"},{"attributes":{"data":{"text":["Gram-negative","Gram-positive"],"x":[-30,-30],"y":[-370,-390]},"selected":{"id":"2622"},"selection_policy":{"id":"2621"}},"id":"2587","type":"ColumnDataSource"},{"attributes":{},"id":"2614","type":"Selection"},{"attributes":{"data_source":{"id":"2582"},"glyph":{"id":"2583"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2584"},"selection_glyph":null,"view":{"id":"2586"}},"id":"2585","type":"GlyphRenderer"},{"attributes":{},"id":"2615","type":"UnionRenderers"},{"attributes":{"background_fill_color":"#f0e1d2","min_border":0,"outline_line_color":"black","plot_height":800,"plot_width":800,"renderers":[{"id":"2545"},{"id":"2550"},{"id":"2555"},{"id":"2560"},{"id":"2565"},{"id":"2570"},{"id":"2575"},{"id":"2580"},{"id":"2585"},{"id":"2590"},{"id":"2595"},{"id":"2600"}],"title":{"id":"2518"},"toolbar":{"id":"2535"},"x_range":{"id":"2520"},"x_scale":{"id":"2524"},"y_range":{"id":"2522"},"y_scale":{"id":"2526"}},"id":"2517","subtype":"Figure","type":"Plot"},{"attributes":{"data_source":{"id":"2562"},"glyph":{"id":"2563"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2564"},"selection_glyph":null,"view":{"id":"2566"}},"id":"2565","type":"GlyphRenderer"},{"attributes":{"end":420,"start":-420},"id":"2520","type":"Range1d"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"line_alpha":{"value":0.1},"line_color":{"value":"white"},"radius":{"field":"radius","units":"data"},"x":{"value":0},"y":{"value":0}},"id":"2564","type":"Circle"},{"attributes":{},"id":"2616","type":"Selection"},{"attributes":{"source":{"id":"2552"}},"id":"2556","type":"CDSView"},{"attributes":{"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"9px"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2588","type":"Text"},{"attributes":{},"id":"2617","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fill_color"},"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"radius":{"units":"data","value":5},"x":{"field":"x"},"y":{"field":"y"}},"id":"2584","type":"Circle"},{"attributes":{},"id":"2618","type":"Selection"},{"attributes":{"data":{"fill_color":["#0d3362","#c64737","black"],"line_color":["#0d3362","#c64737","black"],"x":[-40,-40,-40],"y":[18,0,-18]},"selected":{"id":"2624"},"selection_policy":{"id":"2623"}},"id":"2592","type":"ColumnDataSource"},{"attributes":{},"id":"2619","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"2552"},"glyph":{"id":"2553"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2554"},"selection_glyph":null,"view":{"id":"2556"}},"id":"2555","type":"GlyphRenderer"},{"attributes":{},"id":"2620","type":"Selection"},{"attributes":{"fill_color":{"field":"fill_color"},"height":{"units":"data","value":13},"line_color":{"field":"line_color"},"width":{"units":"data","value":30},"x":{"field":"x"},"y":{"field":"y"}},"id":"2593","type":"Rect"},{"attributes":{},"id":"2621","type":"UnionRenderers"},{"attributes":{"source":{"id":"2587"}},"id":"2591","type":"CDSView"},{"attributes":{"data_source":{"id":"2587"},"glyph":{"id":"2588"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2589"},"selection_glyph":null,"view":{"id":"2591"}},"id":"2590","type":"GlyphRenderer"},{"attributes":{},"id":"2622","type":"Selection"},{"attributes":{"fill_color":{"value":null},"line_color":{"value":"white"},"radius":{"field":"radius","units":"data"},"x":{"value":0},"y":{"value":0}},"id":"2563","type":"Circle"},{"attributes":{},"id":"2623","type":"UnionRenderers"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"2534","type":"BoxAnnotation"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"9px"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2589","type":"Text"},{"attributes":{"data":{"end_angle":{"__ndarray__":"yERVhbPz8T9mg5l5pRPoP3v6ENHHf9g/KMXd3ZUIiz8rHjNzPs/Wv0CVqspgO+e/tM3dLZGH8b/KUGb2cXH3v97T7r5SW/2/eKu7w5miAcAD7f8nipcEwI0uRIx6jAfAF3CI8GqBCsChscxUW3YNwJd5iNylNRDAW5qqDh6wEcA=","dtype":"float64","order":"little","shape":[16]},"outer_radius":{"__ndarray__":"m8z7btjvY0D9PDy5w1RpQDjj0CUzIWlABsmM1zIPZUChS31Y0mVsQB0YCXI1nGZAOOPQJTMhaUCyh+QAGnxuQM3Wg944S2RA/HdeznjObkA449AlMyFpQAAAAAAAIHJAAAAAAAAgckCg0sRXLXlhQFhbROgM+V5AoNLEVy15YUA=","dtype":"float64","order":"little","shape":[16]},"start_angle":{"__ndarray__":"oVZm1m4b8T8Xp7sbHGPmP91BVRW1HtU/p1NmZnBGpL/J1u4uUTDav49xiCjq6+i/27vM3NVf8r/xPlWltkn4vwXC3W2XM/6/jCIzG7wOAsAXZHd/rAMFwKGlu+Oc+AfAK+f/R43tCsC1KESsfeINwCE1RAi3axDA5VVmOi/mEcA=","dtype":"float64","order":"little","shape":[16]}},"selected":{"id":"2610"},"selection_policy":{"id":"2609"}},"id":"2557","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fill_color"},"height":{"units":"data","value":13},"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"width":{"units":"data","value":30},"x":{"field":"x"},"y":{"field":"y"}},"id":"2594","type":"Rect"},{"attributes":{},"id":"2624","type":"Selection"},{"attributes":{"end_angle":{"field":"end_angle","units":"rad"},"fill_alpha":{"value":0.1},"fill_color":{"value":"black"},"inner_radius":{"units":"data","value":90},"line_alpha":{"value":0.1},"outer_radius":{"field":"outer_radius","units":"data"},"start_angle":{"field":"start_angle","units":"rad"},"x":{"value":0},"y":{"value":0}},"id":"2559","type":"AnnularWedge"},{"attributes":{"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"12px"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2598","type":"Text"},{"attributes":{"source":{"id":"2562"}},"id":"2566","type":"CDSView"},{"attributes":{"source":{"id":"2592"}},"id":"2596","type":"CDSView"},{"attributes":{"end_angle":{"field":"end_angle","units":"rad"},"fill_alpha":{"value":0.1},"fill_color":{"field":"fill_color"},"inner_radius":{"units":"data","value":90},"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"outer_radius":{"units":"data","value":290},"start_angle":{"field":"start_angle","units":"rad"},"x":{"value":0},"y":{"value":0}},"id":"2544","type":"AnnularWedge"},{"attributes":{},"id":"2625","type":"UnionRenderers"},{"attributes":{"data":{"text":["Penicillin","Streptomycin","Neomycin"],"x":[-15,-15,-15],"y":[18,0,-18]},"selected":{"id":"2626"},"selection_policy":{"id":"2625"}},"id":"2597","type":"ColumnDataSource"},{"attributes":{},"id":"2524","type":"LinearScale"},{"attributes":{},"id":"2626","type":"Selection"},{"attributes":{"overlay":{"id":"2534"}},"id":"2530","type":"BoxZoomTool"},{"attributes":{"data_source":{"id":"2542"},"glyph":{"id":"2543"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2544"},"selection_glyph":null,"view":{"id":"2546"}},"id":"2545","type":"GlyphRenderer"},{"attributes":{},"id":"2526","type":"LinearScale"},{"attributes":{"data_source":{"id":"2592"},"glyph":{"id":"2593"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2594"},"selection_glyph":null,"view":{"id":"2596"}},"id":"2595","type":"GlyphRenderer"},{"attributes":{"data":{"text":["0.001","0.01","0.1","1.0","10.0","100.0"],"y":{"__ndarray__":"AAAAAAAgckDHcwaqNPVtQDjj0CUzIWlABsmM1zIPZUCg0sRXLXlhQBRFOMxxdlxA","dtype":"float64","order":"little","shape":[6]}},"selected":{"id":"2614"},"selection_policy":{"id":"2613"}},"id":"2567","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"11px"},"x":{"value":0},"y":{"field":"y"}},"id":"2569","type":"Text"},{"attributes":{"data_source":{"id":"2597"},"glyph":{"id":"2598"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2599"},"selection_glyph":null,"view":{"id":"2601"}},"id":"2600","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"2567"},"glyph":{"id":"2568"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2569"},"selection_glyph":null,"view":{"id":"2571"}},"id":"2570","type":"GlyphRenderer"},{"attributes":{},"id":"2529","type":"WheelZoomTool"},{"attributes":{"text_align":"center","text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"11px"},"x":{"value":0},"y":{"field":"y"}},"id":"2568","type":"Text"},{"attributes":{"data":{"end_angle":{"__ndarray__":"juv/7wot9j95aHcnKkPwP8nK3b2SsuQ/QImZWaK90T9QDCIig6e3v2iPqupjkd2/3E1mhnOc6r8EqruLGjjzvxgtRFT7Ifm/LLDMHNwL/7+hmapy3noCwCvb7tbObwXAtRwzO79kCMA/Xnefr1kLwMufuwOgTg7AqvD/M8ihEMA=","dtype":"float64","order":"little","shape":[16]},"fill_color":["#e69584","#e69584","#e69584","#e69584","#e69584","#e69584","#e69584","#e69584","#e69584","#aeaeb8","#aeaeb8","#aeaeb8","#aeaeb8","#aeaeb8","#aeaeb8","#aeaeb8"],"line_color":["#e69584","#e69584","#e69584","#e69584","#e69584","#e69584","#e69584","#e69584","#e69584","#aeaeb8","#aeaeb8","#aeaeb8","#aeaeb8","#aeaeb8","#aeaeb8","#aeaeb8"],"start_angle":{"__ndarray__":"eWh3JypD8D/Iyt29krLkPz+JmVmivdE/TAwiIoOnt79nj6rqY5Hdv95NZoZznOq/A6q7ixo4878ZLURU+yH5vy2wzBzcC/+/oJmqct56AsAr2+7Wzm8FwLUcMzu/ZAjAP153n69ZC8DJn7sDoE4OwKvw/zPIoRDAbxEiZkAcEsA=","dtype":"float64","order":"little","shape":[16]}},"selected":{"id":"2604"},"selection_policy":{"id":"2603"}},"id":"2542","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"2557"},"glyph":{"id":"2558"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2559"},"selection_glyph":null,"view":{"id":"2561"}},"id":"2560","type":"GlyphRenderer"},{"attributes":{"source":{"id":"2567"}},"id":"2571","type":"CDSView"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"12px"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2599","type":"Text"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"2528"},{"id":"2529"},{"id":"2530"},{"id":"2531"},{"id":"2532"},{"id":"2533"}]},"id":"2535","type":"Toolbar"},{"attributes":{"source":{"id":"2557"}},"id":"2561","type":"CDSView"},{"attributes":{},"id":"2528","type":"PanTool"},{"attributes":{"data":{"radius":{"__ndarray__":"AAAAAAAgckDHcwaqNPVtQDjj0CUzIWlABsmM1zIPZUCg0sRXLXlhQBRFOMxxdlxAAAAAAACAVkA=","dtype":"float64","order":"little","shape":[7]}},"selected":{"id":"2612"},"selection_policy":{"id":"2611"}},"id":"2562","type":"ColumnDataSource"}],"root_ids":["2517"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"f63bb62b-a854-4833-9f7a-397cf232ce7a","root_ids":["2517"],"roots":{"2517":"13d46561-f198-4e18-8332-6e26305d700a"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();