(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("4056bf78-5b7e-4307-bdae-d67028333c33");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '4056bf78-5b7e-4307-bdae-d67028333c33' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"d2ca4d37-c668-4f22-a4f1-feb5270831b5":{"roots":{"references":[{"attributes":{"formatter":{"id":"1326"},"ticker":{"id":"1312"}},"id":"1311","type":"CategoricalAxis"},{"attributes":{"start":0},"id":"1305","type":"DataRange1d"},{"attributes":{},"id":"1315","type":"BasicTicker"},{"attributes":{"text":"Fruit Counts"},"id":"1301","type":"Title"},{"attributes":{"axis":{"id":"1314"},"dimension":1,"ticker":null},"id":"1317","type":"Grid"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"1318","type":"Toolbar"},{"attributes":{"source":{"id":"1319"}},"id":"1323","type":"CDSView"},{"attributes":{"axis":{"id":"1311"},"grid_line_color":null,"ticker":null},"id":"1313","type":"Grid"},{"attributes":{},"id":"1312","type":"CategoricalTicker"},{"attributes":{},"id":"1328","type":"BasicTickFormatter"},{"attributes":{"below":[{"id":"1311"}],"center":[{"id":"1313"},{"id":"1317"}],"left":[{"id":"1314"}],"plot_height":350,"renderers":[{"id":"1322"}],"title":{"id":"1301"},"toolbar":{"id":"1318"},"toolbar_location":null,"x_range":{"id":"1303"},"x_scale":{"id":"1307"},"y_range":{"id":"1305"},"y_scale":{"id":"1309"}},"id":"1300","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"1328"},"ticker":{"id":"1315"}},"id":"1314","type":"LinearAxis"},{"attributes":{"data_source":{"id":"1319"},"glyph":{"id":"1320"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"1321"},"selection_glyph":null,"view":{"id":"1323"}},"id":"1322","type":"GlyphRenderer"},{"attributes":{},"id":"1309","type":"LinearScale"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"top":{"field":"top"},"width":{"value":0.9},"x":{"field":"x"}},"id":"1321","type":"VBar"},{"attributes":{},"id":"1330","type":"Selection"},{"attributes":{"data":{"top":[5,3,4,2,4,6],"x":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"1330"},"selection_policy":{"id":"1329"}},"id":"1319","type":"ColumnDataSource"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"top":{"field":"top"},"width":{"value":0.9},"x":{"field":"x"}},"id":"1320","type":"VBar"},{"attributes":{},"id":"1307","type":"CategoricalScale"},{"attributes":{},"id":"1326","type":"CategoricalTickFormatter"},{"attributes":{},"id":"1329","type":"UnionRenderers"},{"attributes":{"factors":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"id":"1303","type":"FactorRange"}],"root_ids":["1300"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"d2ca4d37-c668-4f22-a4f1-feb5270831b5","root_ids":["1300"],"roots":{"1300":"4056bf78-5b7e-4307-bdae-d67028333c33"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();