(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("39d5d8e2-a5e1-4e1d-8acd-5aebf06108e9");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '39d5d8e2-a5e1-4e1d-8acd-5aebf06108e9' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"e46f2a53-c6be-4061-85a7-9a4714a5cd20":{"roots":{"references":[{"attributes":{},"id":"2086","type":"CategoricalScale"},{"attributes":{"label":{"value":"2016 imports"},"renderers":[{"id":"2185"}]},"id":"2197","type":"LegendItem"},{"attributes":{"label":{"value":"2016 exports"},"renderers":[{"id":"2134"}]},"id":"2144","type":"LegendItem"},{"attributes":{"source":{"id":"2159"}},"id":"2186","type":"CDSView"},{"attributes":{"data_source":{"id":"2159"},"glyph":{"id":"2199"},"hover_glyph":null,"muted_glyph":null,"name":"2017","nonselection_glyph":{"id":"2200"},"selection_glyph":null,"view":{"id":"2202"}},"id":"2201","type":"GlyphRenderer"},{"attributes":{"data":{"2015":[2,1,4,3,2,4],"2016":[5,3,4,2,4,6],"2017":[3,2,4,4,5,3],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"2127"},"selection_policy":{"id":"2126"}},"id":"2109","type":"ColumnDataSource"},{"attributes":{},"id":"2084","type":"LinearScale"},{"attributes":{"axis":{"id":"2088"},"ticker":null},"id":"2091","type":"Grid"},{"attributes":{"source":{"id":"2159"}},"id":"2202","type":"CDSView"},{"attributes":{"formatter":{"id":"2123"},"minor_tick_line_color":null,"ticker":{"id":"2089"}},"id":"2088","type":"LinearAxis"},{"attributes":{"fill_color":{"value":"#a8ddb5"},"height":{"value":0.9},"left":{"expr":{"id":"2112"}},"line_color":{"value":"#a8ddb5"},"right":{"expr":{"id":"2113"}},"y":{"field":"fruits"}},"id":"2132","type":"HBar"},{"attributes":{},"id":"2089","type":"BasicTicker"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#e0f3db"},"height":{"value":0.9},"left":{"expr":{"id":"2114"}},"line_alpha":{"value":0.1},"line_color":{"value":"#e0f3db"},"right":{"expr":{"id":"2115"}},"y":{"field":"fruits"}},"id":"2147","type":"HBar"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"2101","type":"BoxAnnotation"},{"attributes":{"fields":["2015","2016"]},"id":"2113","type":"Stack"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#43a2ca"},"height":{"value":0.9},"left":{"expr":{"id":"2110"}},"line_alpha":{"value":0.1},"line_color":{"value":"#43a2ca"},"right":{"expr":{"id":"2111"}},"y":{"field":"fruits"}},"id":"2118","type":"HBar"},{"attributes":{"fill_color":{"value":"#fee8c8"},"height":{"value":0.9},"left":{"expr":{"id":"2164"}},"line_color":{"value":"#fee8c8"},"right":{"expr":{"id":"2165"}},"y":{"field":"fruits"}},"id":"2199","type":"HBar"},{"attributes":{"fields":["2015","2016"]},"id":"2114","type":"Stack"},{"attributes":{"data_source":{"id":"2109"},"glyph":{"id":"2117"},"hover_glyph":null,"muted_glyph":null,"name":"2015","nonselection_glyph":{"id":"2118"},"selection_glyph":null,"view":{"id":"2120"}},"id":"2119","type":"GlyphRenderer"},{"attributes":{"fields":["2015","2016","2017"]},"id":"2115","type":"Stack"},{"attributes":{"label":{"value":"2017 imports"},"renderers":[{"id":"2201"}]},"id":"2213","type":"LegendItem"},{"attributes":{"fill_color":{"value":"#43a2ca"},"height":{"value":0.9},"left":{"expr":{"id":"2110"}},"line_color":{"value":"#43a2ca"},"right":{"expr":{"id":"2111"}},"y":{"field":"fruits"}},"id":"2117","type":"HBar"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#fee8c8"},"height":{"value":0.9},"left":{"expr":{"id":"2164"}},"line_alpha":{"value":0.1},"line_color":{"value":"#fee8c8"},"right":{"expr":{"id":"2165"}},"y":{"field":"fruits"}},"id":"2200","type":"HBar"},{"attributes":{"label":{"value":"2017 exports"},"renderers":[{"id":"2148"}]},"id":"2158","type":"LegendItem"},{"attributes":{"fields":[]},"id":"2110","type":"Stack"},{"attributes":{"items":[{"id":"2130"},{"id":"2144"},{"id":"2158"},{"id":"2181"},{"id":"2197"},{"id":"2213"}],"location":"top_left"},"id":"2129","type":"Legend"},{"attributes":{"source":{"id":"2109"}},"id":"2120","type":"CDSView"},{"attributes":{},"id":"2100","type":"HelpTool"},{"attributes":{"data_source":{"id":"2109"},"glyph":{"id":"2146"},"hover_glyph":null,"muted_glyph":null,"name":"2017","nonselection_glyph":{"id":"2147"},"selection_glyph":null,"view":{"id":"2149"}},"id":"2148","type":"GlyphRenderer"},{"attributes":{},"id":"2123","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"2109"}},"id":"2135","type":"CDSView"},{"attributes":{"factors":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"],"range_padding":0.1},"id":"2082","type":"FactorRange"},{"attributes":{},"id":"2126","type":"UnionRenderers"},{"attributes":{},"id":"2125","type":"CategoricalTickFormatter"},{"attributes":{},"id":"2095","type":"PanTool"},{"attributes":{},"id":"2127","type":"Selection"},{"attributes":{"text":"Fruit import/export, by year"},"id":"2078","type":"Title"},{"attributes":{"label":{"value":"2015 exports"},"renderers":[{"id":"2119"}]},"id":"2130","type":"LegendItem"},{"attributes":{"source":{"id":"2109"}},"id":"2149","type":"CDSView"},{"attributes":{"fields":[]},"id":"2160","type":"Stack"},{"attributes":{"end":16,"start":-16},"id":"2080","type":"Range1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"2095"},{"id":"2096"},{"id":"2097"},{"id":"2098"},{"id":"2099"},{"id":"2100"}]},"id":"2102","type":"Toolbar"},{"attributes":{},"id":"2178","type":"UnionRenderers"},{"attributes":{"fields":["2015"]},"id":"2111","type":"Stack"},{"attributes":{"data_source":{"id":"2159"},"glyph":{"id":"2183"},"hover_glyph":null,"muted_glyph":null,"name":"2016","nonselection_glyph":{"id":"2184"},"selection_glyph":null,"view":{"id":"2186"}},"id":"2185","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"2125"},"minor_tick_line_color":null,"ticker":{"id":"2093"}},"id":"2092","type":"CategoricalAxis"},{"attributes":{"fields":["2015"]},"id":"2161","type":"Stack"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#a8ddb5"},"height":{"value":0.9},"left":{"expr":{"id":"2112"}},"line_alpha":{"value":0.1},"line_color":{"value":"#a8ddb5"},"right":{"expr":{"id":"2113"}},"y":{"field":"fruits"}},"id":"2133","type":"HBar"},{"attributes":{},"id":"2099","type":"ResetTool"},{"attributes":{"data_source":{"id":"2109"},"glyph":{"id":"2132"},"hover_glyph":null,"muted_glyph":null,"name":"2016","nonselection_glyph":{"id":"2133"},"selection_glyph":null,"view":{"id":"2135"}},"id":"2134","type":"GlyphRenderer"},{"attributes":{"label":{"value":"2015 imports"},"renderers":[{"id":"2169"}]},"id":"2181","type":"LegendItem"},{"attributes":{"fields":["2015"]},"id":"2162","type":"Stack"},{"attributes":{"data":{"2015":[-1,0,-1,-3,-2,-1],"2016":[-2,-1,-3,-1,-2,-2],"2017":[-1,-2,-1,0,-2,-2],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"2179"},"selection_policy":{"id":"2178"}},"id":"2159","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#e34a33"},"height":{"value":0.9},"left":{"expr":{"id":"2160"}},"line_alpha":{"value":0.1},"line_color":{"value":"#e34a33"},"right":{"expr":{"id":"2161"}},"y":{"field":"fruits"}},"id":"2168","type":"HBar"},{"attributes":{"fields":["2015"]},"id":"2112","type":"Stack"},{"attributes":{"below":[{"id":"2088"}],"center":[{"id":"2091"},{"id":"2094"},{"id":"2129"}],"left":[{"id":"2092"}],"outline_line_color":null,"plot_height":350,"renderers":[{"id":"2119"},{"id":"2134"},{"id":"2148"},{"id":"2169"},{"id":"2185"},{"id":"2201"}],"title":{"id":"2078"},"toolbar":{"id":"2102"},"toolbar_location":null,"x_range":{"id":"2080"},"x_scale":{"id":"2084"},"y_range":{"id":"2082"},"y_scale":{"id":"2086"}},"id":"2077","subtype":"Figure","type":"Plot"},{"attributes":{"source":{"id":"2159"}},"id":"2170","type":"CDSView"},{"attributes":{"fill_color":{"value":"#e0f3db"},"height":{"value":0.9},"left":{"expr":{"id":"2114"}},"line_color":{"value":"#e0f3db"},"right":{"expr":{"id":"2115"}},"y":{"field":"fruits"}},"id":"2146","type":"HBar"},{"attributes":{"fields":["2015","2016"]},"id":"2163","type":"Stack"},{"attributes":{"overlay":{"id":"2101"}},"id":"2097","type":"BoxZoomTool"},{"attributes":{"fields":["2015","2016"]},"id":"2164","type":"Stack"},{"attributes":{"axis":{"id":"2092"},"dimension":1,"grid_line_color":null,"ticker":null},"id":"2094","type":"Grid"},{"attributes":{},"id":"2179","type":"Selection"},{"attributes":{"fields":["2015","2016","2017"]},"id":"2165","type":"Stack"},{"attributes":{"data_source":{"id":"2159"},"glyph":{"id":"2167"},"hover_glyph":null,"muted_glyph":null,"name":"2015","nonselection_glyph":{"id":"2168"},"selection_glyph":null,"view":{"id":"2170"}},"id":"2169","type":"GlyphRenderer"},{"attributes":{"fill_color":{"value":"#e34a33"},"height":{"value":0.9},"left":{"expr":{"id":"2160"}},"line_color":{"value":"#e34a33"},"right":{"expr":{"id":"2161"}},"y":{"field":"fruits"}},"id":"2167","type":"HBar"},{"attributes":{},"id":"2096","type":"WheelZoomTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#fdbb84"},"height":{"value":0.9},"left":{"expr":{"id":"2162"}},"line_alpha":{"value":0.1},"line_color":{"value":"#fdbb84"},"right":{"expr":{"id":"2163"}},"y":{"field":"fruits"}},"id":"2184","type":"HBar"},{"attributes":{},"id":"2098","type":"SaveTool"},{"attributes":{},"id":"2093","type":"CategoricalTicker"},{"attributes":{"fill_color":{"value":"#fdbb84"},"height":{"value":0.9},"left":{"expr":{"id":"2162"}},"line_color":{"value":"#fdbb84"},"right":{"expr":{"id":"2163"}},"y":{"field":"fruits"}},"id":"2183","type":"HBar"}],"root_ids":["2077"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"e46f2a53-c6be-4061-85a7-9a4714a5cd20","root_ids":["2077"],"roots":{"2077":"39d5d8e2-a5e1-4e1d-8acd-5aebf06108e9"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();