(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("462c09e0-06e5-4e92-ab5d-c8832ba50a7b");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '462c09e0-06e5-4e92-ab5d-c8832ba50a7b' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"f50954e8-4710-41ae-9659-c35e8017300c":{"roots":{"references":[{"attributes":{"text":"Categorical Heatmap"},"id":"3345","type":"Title"},{"attributes":{"factors":["foo 123","bar:0.2","baz-10"]},"id":"3349","type":"FactorRange"},{"attributes":{"data_source":{"id":"3334"},"glyph":{"id":"3335"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"3336"},"selection_glyph":null,"view":{"id":"3338"}},"id":"3337","type":"GlyphRenderer"},{"attributes":{"source":{"id":"3364"}},"id":"3368","type":"CDSView"},{"attributes":{"below":[{"id":"3355"}],"center":[{"id":"3357"},{"id":"3360"}],"left":[{"id":"3358"}],"renderers":[{"id":"3367"}],"sizing_mode":"scale_width","title":{"id":"3345"},"toolbar":{"id":"3362"},"toolbar_location":null,"x_range":{"id":"3347"},"x_scale":{"id":"3351"},"y_range":{"id":"3349"},"y_scale":{"id":"3353"}},"id":"3344","subtype":"Figure","type":"Plot"},{"attributes":{"data_source":{"id":"3364"},"glyph":{"id":"3365"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"3366"},"selection_glyph":null,"view":{"id":"3368"}},"id":"3367","type":"GlyphRenderer"},{"attributes":{},"id":"3385","type":"Selection"},{"attributes":{"children":[{"id":"3344"},{"id":"3315"}],"sizing_mode":"scale_width"},"id":"3369","type":"Row"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"green"},"line_width":{"value":2},"x0":{"value":0},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"3336","type":"Segment"},{"attributes":{},"id":"3384","type":"UnionRenderers"},{"attributes":{},"id":"3375","type":"CategoricalTickFormatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"green"},"line_width":{"value":3},"size":{"units":"screen","value":15},"x":{"field":"x"},"y":{"field":"y"}},"id":"3341","type":"Circle"},{"attributes":{"below":[{"id":"3326"}],"center":[{"id":"3329"},{"id":"3332"}],"left":[{"id":"3330"}],"renderers":[{"id":"3337"},{"id":"3342"}],"sizing_mode":"scale_width","title":{"id":"3316"},"toolbar":{"id":"3333"},"toolbar_location":null,"x_range":{"id":"3318"},"x_scale":{"id":"3322"},"y_range":{"id":"3320"},"y_scale":{"id":"3324"}},"id":"3315","subtype":"Figure","type":"Plot"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"3361"}]},"id":"3362","type":"Toolbar"},{"attributes":{"data_source":{"id":"3339"},"glyph":{"id":"3340"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"3341"},"selection_glyph":null,"view":{"id":"3343"}},"id":"3342","type":"GlyphRenderer"},{"attributes":{},"id":"3322","type":"LinearScale"},{"attributes":{},"id":"3373","type":"CategoricalTickFormatter"},{"attributes":{},"id":"3383","type":"Selection"},{"attributes":{"factors":["a","b","c","d","e","f","g","h"]},"id":"3320","type":"FactorRange"},{"attributes":{"callback":null},"id":"3361","type":"HoverTool"},{"attributes":{},"id":"3377","type":"BasicTickFormatter"},{"attributes":{"line_color":{"value":"green"},"line_width":{"value":2},"x0":{"value":0},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"3335","type":"Segment"},{"attributes":{"fill_color":{"value":"orange"},"line_color":{"value":"green"},"line_width":{"value":3},"size":{"units":"screen","value":15},"x":{"field":"x"},"y":{"field":"y"}},"id":"3340","type":"Circle"},{"attributes":{"text":"Categorical Dot Plot"},"id":"3316","type":"Title"},{"attributes":{},"id":"3379","type":"CategoricalTickFormatter"},{"attributes":{},"id":"3381","type":"Selection"},{"attributes":{},"id":"3351","type":"CategoricalScale"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fill_color"},"height":{"units":"data","value":1},"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"width":{"units":"data","value":1},"x":{"field":"x"},"y":{"field":"y"}},"id":"3366","type":"Rect"},{"attributes":{},"id":"3324","type":"CategoricalScale"},{"attributes":{"data":{"x":[50,40,65,10,25,37,80,60],"y":["a","b","c","d","e","f","g","h"]},"selected":{"id":"3385"},"selection_policy":{"id":"3384"}},"id":"3339","type":"ColumnDataSource"},{"attributes":{},"id":"3380","type":"UnionRenderers"},{"attributes":{"source":{"id":"3334"}},"id":"3338","type":"CDSView"},{"attributes":{"source":{"id":"3339"}},"id":"3343","type":"CDSView"},{"attributes":{"end":100},"id":"3318","type":"Range1d"},{"attributes":{"factors":["foo 123","bar:0.2","baz-10"]},"id":"3347","type":"FactorRange"},{"attributes":{"formatter":{"id":"3377"},"ticker":{"id":"3327"}},"id":"3326","type":"LinearAxis"},{"attributes":{"fill_color":{"field":"fill_color"},"height":{"units":"data","value":1},"line_color":{"field":"line_color"},"width":{"units":"data","value":1},"x":{"field":"x"},"y":{"field":"y"}},"id":"3365","type":"Rect"},{"attributes":{},"id":"3331","type":"CategoricalTicker"},{"attributes":{"axis":{"id":"3358"},"dimension":1,"ticker":null},"id":"3360","type":"Grid"},{"attributes":{},"id":"3327","type":"BasicTicker"},{"attributes":{"axis":{"id":"3355"},"ticker":null},"id":"3357","type":"Grid"},{"attributes":{"formatter":{"id":"3375"},"ticker":{"id":"3359"}},"id":"3358","type":"CategoricalAxis"},{"attributes":{"axis":{"id":"3326"},"ticker":null},"id":"3329","type":"Grid"},{"attributes":{"data":{"fill_color":["#0B486B","#79BD9A","#CFF09E","#79BD9A","#0B486B","#79BD9A","#CFF09E","#79BD9A","#0B486B"],"line_color":["#0B486B","#79BD9A","#CFF09E","#79BD9A","#0B486B","#79BD9A","#CFF09E","#79BD9A","#0B486B"],"x":["foo 123","foo 123","foo 123","bar:0.2","bar:0.2","bar:0.2","baz-10","baz-10","baz-10"],"y":["foo 123","bar:0.2","baz-10","foo 123","bar:0.2","baz-10","foo 123","bar:0.2","baz-10"]},"selected":{"id":"3381"},"selection_policy":{"id":"3380"}},"id":"3364","type":"ColumnDataSource"},{"attributes":{},"id":"3382","type":"UnionRenderers"},{"attributes":{"formatter":{"id":"3373"},"ticker":{"id":"3356"}},"id":"3355","type":"CategoricalAxis"},{"attributes":{"axis":{"id":"3330"},"dimension":1,"ticker":null},"id":"3332","type":"Grid"},{"attributes":{},"id":"3359","type":"CategoricalTicker"},{"attributes":{"formatter":{"id":"3379"},"ticker":{"id":"3331"}},"id":"3330","type":"CategoricalAxis"},{"attributes":{},"id":"3356","type":"CategoricalTicker"},{"attributes":{},"id":"3353","type":"CategoricalScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"3333","type":"Toolbar"},{"attributes":{"data":{"x1":[50,40,65,10,25,37,80,60],"y0":["a","b","c","d","e","f","g","h"],"y1":["a","b","c","d","e","f","g","h"]},"selected":{"id":"3383"},"selection_policy":{"id":"3382"}},"id":"3334","type":"ColumnDataSource"}],"root_ids":["3369"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"f50954e8-4710-41ae-9659-c35e8017300c","root_ids":["3369"],"roots":{"3369":"462c09e0-06e5-4e92-ab5d-c8832ba50a7b"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();