(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("3acdc965-eeb9-4acd-83df-3620d07da0f0");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '3acdc965-eeb9-4acd-83df-3620d07da0f0' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"5460ab60-2dc7-489a-8a99-d248bea96ea1":{"roots":{"references":[{"attributes":{"end":100},"id":"2851","type":"Range1d"},{"attributes":{},"id":"2910","type":"BasicTickFormatter"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"green"},"line_width":{"value":2},"x0":{"value":0},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2869","type":"Segment"},{"attributes":{},"id":"2912","type":"CategoricalTickFormatter"},{"attributes":{"text":"Categorical Dot Plot"},"id":"2849","type":"Title"},{"attributes":{"source":{"id":"2897"}},"id":"2901","type":"CDSView"},{"attributes":{"source":{"id":"2867"}},"id":"2871","type":"CDSView"},{"attributes":{"line_color":{"value":"green"},"line_width":{"value":2},"x0":{"value":0},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"2868","type":"Segment"},{"attributes":{},"id":"2913","type":"UnionRenderers"},{"attributes":{"text":"Categorical Heatmap"},"id":"2878","type":"Title"},{"attributes":{"below":[{"id":"2859"}],"center":[{"id":"2862"},{"id":"2865"}],"left":[{"id":"2863"}],"renderers":[{"id":"2870"},{"id":"2875"}],"sizing_mode":"scale_width","title":{"id":"2849"},"toolbar":{"id":"2866"},"toolbar_location":null,"x_range":{"id":"2851"},"x_scale":{"id":"2855"},"y_range":{"id":"2853"},"y_scale":{"id":"2857"}},"id":"2848","subtype":"Figure","type":"Plot"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"green"},"line_width":{"value":3},"size":{"units":"screen","value":15},"x":{"field":"x"},"y":{"field":"y"}},"id":"2874","type":"Circle"},{"attributes":{"data_source":{"id":"2897"},"glyph":{"id":"2898"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2899"},"selection_glyph":null,"view":{"id":"2901"}},"id":"2900","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"2872"},"glyph":{"id":"2873"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2874"},"selection_glyph":null,"view":{"id":"2876"}},"id":"2875","type":"GlyphRenderer"},{"attributes":{},"id":"2855","type":"LinearScale"},{"attributes":{},"id":"2917","type":"UnionRenderers"},{"attributes":{},"id":"2906","type":"CategoricalTickFormatter"},{"attributes":{"fill_color":{"field":"fill_color"},"height":{"units":"data","value":1},"line_color":{"field":"line_color"},"width":{"units":"data","value":1},"x":{"field":"x"},"y":{"field":"y"}},"id":"2898","type":"Rect"},{"attributes":{},"id":"2918","type":"Selection"},{"attributes":{"axis":{"id":"2888"},"ticker":null},"id":"2890","type":"Grid"},{"attributes":{"data_source":{"id":"2867"},"glyph":{"id":"2868"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"2869"},"selection_glyph":null,"view":{"id":"2871"}},"id":"2870","type":"GlyphRenderer"},{"attributes":{},"id":"2889","type":"CategoricalTicker"},{"attributes":{},"id":"2860","type":"BasicTicker"},{"attributes":{"formatter":{"id":"2908"},"ticker":{"id":"2892"}},"id":"2891","type":"CategoricalAxis"},{"attributes":{"formatter":{"id":"2906"},"ticker":{"id":"2889"}},"id":"2888","type":"CategoricalAxis"},{"attributes":{"axis":{"id":"2859"},"ticker":null},"id":"2862","type":"Grid"},{"attributes":{},"id":"2892","type":"CategoricalTicker"},{"attributes":{},"id":"2916","type":"Selection"},{"attributes":{},"id":"2915","type":"UnionRenderers"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"2894"}]},"id":"2895","type":"Toolbar"},{"attributes":{"axis":{"id":"2891"},"dimension":1,"ticker":null},"id":"2893","type":"Grid"},{"attributes":{},"id":"2886","type":"CategoricalScale"},{"attributes":{"formatter":{"id":"2910"},"ticker":{"id":"2860"}},"id":"2859","type":"LinearAxis"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fill_color"},"height":{"units":"data","value":1},"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"width":{"units":"data","value":1},"x":{"field":"x"},"y":{"field":"y"}},"id":"2899","type":"Rect"},{"attributes":{},"id":"2864","type":"CategoricalTicker"},{"attributes":{"factors":["foo 123","bar:0.2","baz-10"]},"id":"2882","type":"FactorRange"},{"attributes":{"callback":null},"id":"2894","type":"HoverTool"},{"attributes":{"data":{"x1":[50,40,65,10,25,37,80,60],"y0":["a","b","c","d","e","f","g","h"],"y1":["a","b","c","d","e","f","g","h"]},"selected":{"id":"2916"},"selection_policy":{"id":"2915"}},"id":"2867","type":"ColumnDataSource"},{"attributes":{},"id":"2884","type":"CategoricalScale"},{"attributes":{},"id":"2857","type":"CategoricalScale"},{"attributes":{"data":{"x":[50,40,65,10,25,37,80,60],"y":["a","b","c","d","e","f","g","h"]},"selected":{"id":"2918"},"selection_policy":{"id":"2917"}},"id":"2872","type":"ColumnDataSource"},{"attributes":{"children":[{"id":"2877"},{"id":"2848"}],"sizing_mode":"scale_width"},"id":"2902","type":"Row"},{"attributes":{"formatter":{"id":"2912"},"ticker":{"id":"2864"}},"id":"2863","type":"CategoricalAxis"},{"attributes":{"axis":{"id":"2863"},"dimension":1,"ticker":null},"id":"2865","type":"Grid"},{"attributes":{"data":{"fill_color":["#0B486B","#79BD9A","#CFF09E","#79BD9A","#0B486B","#79BD9A","#CFF09E","#79BD9A","#0B486B"],"line_color":["#0B486B","#79BD9A","#CFF09E","#79BD9A","#0B486B","#79BD9A","#CFF09E","#79BD9A","#0B486B"],"x":["foo 123","foo 123","foo 123","bar:0.2","bar:0.2","bar:0.2","baz-10","baz-10","baz-10"],"y":["foo 123","bar:0.2","baz-10","foo 123","bar:0.2","baz-10","foo 123","bar:0.2","baz-10"]},"selected":{"id":"2914"},"selection_policy":{"id":"2913"}},"id":"2897","type":"ColumnDataSource"},{"attributes":{},"id":"2908","type":"CategoricalTickFormatter"},{"attributes":{"fill_color":{"value":"orange"},"line_color":{"value":"green"},"line_width":{"value":3},"size":{"units":"screen","value":15},"x":{"field":"x"},"y":{"field":"y"}},"id":"2873","type":"Circle"},{"attributes":{"factors":["a","b","c","d","e","f","g","h"]},"id":"2853","type":"FactorRange"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"2866","type":"Toolbar"},{"attributes":{},"id":"2914","type":"Selection"},{"attributes":{"source":{"id":"2872"}},"id":"2876","type":"CDSView"},{"attributes":{"factors":["foo 123","bar:0.2","baz-10"]},"id":"2880","type":"FactorRange"},{"attributes":{"below":[{"id":"2888"}],"center":[{"id":"2890"},{"id":"2893"}],"left":[{"id":"2891"}],"renderers":[{"id":"2900"}],"sizing_mode":"scale_width","title":{"id":"2878"},"toolbar":{"id":"2895"},"toolbar_location":null,"x_range":{"id":"2880"},"x_scale":{"id":"2884"},"y_range":{"id":"2882"},"y_scale":{"id":"2886"}},"id":"2877","subtype":"Figure","type":"Plot"}],"root_ids":["2902"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"5460ab60-2dc7-489a-8a99-d248bea96ea1","root_ids":["2902"],"roots":{"2902":"3acdc965-eeb9-4acd-83df-3620d07da0f0"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();