(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("8d5a82c1-184f-4286-90af-1a3faa62418c");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '8d5a82c1-184f-4286-90af-1a3faa62418c' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"37a57f9c-ea08-4bf0-ac22-2851ab4548ef":{"roots":{"references":[{"attributes":{"axis_line_color":null,"formatter":{"id":"1100"},"ticker":{"id":"1043"}},"id":"1041","type":"LinearAxis"},{"attributes":{"source":{"id":"1001"}},"id":"1052","type":"CDSView"},{"attributes":{"axis_line_color":null,"formatter":{"id":"1074"},"ticker":{"id":"1011"}},"id":"1009","type":"LinearAxis"},{"attributes":{},"id":"1069","type":"LinearScale"},{"attributes":{"axis_line_color":null,"formatter":{"id":"1102"},"ticker":{"id":"1045"}},"id":"1042","type":"LinearAxis"},{"attributes":{"line_color":"#666699","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"1047","type":"Line"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"1072","type":"Toolbar"},{"attributes":{"axis_line_color":null,"formatter":{"id":"1089"},"ticker":{"id":"1029"}},"id":"1026","type":"LinearAxis"},{"attributes":{"data_source":{"id":"1002"},"glyph":{"id":"1047"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"1049"}},"id":"1048","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"1002"},"glyph":{"id":"1015"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"1017"}},"id":"1016","type":"GlyphRenderer"},{"attributes":{"axis_line_color":null,"formatter":{"id":"1076"},"ticker":{"id":"1013"}},"id":"1010","type":"LinearAxis"},{"attributes":{"data_source":{"id":"1001"},"glyph":{"id":"1018"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"1020"}},"id":"1019","type":"GlyphRenderer"},{"attributes":{"children":[{"id":"1122"},{"id":"1121"}],"sizing_mode":"scale_width"},"id":"1123","type":"Column"},{"attributes":{"axis":null,"ticker":{"id":"1043"}},"id":"1044","type":"Grid"},{"attributes":{"source":{"id":"1001"}},"id":"1068","type":"CDSView"},{"attributes":{"sizing_mode":"scale_width","text":"\\n&lt;h1&gt;Anscombe&#x27;s Quartet&lt;/h1&gt;\\n&lt;p&gt;Anscombe&#x27;s quartet is a collection of four small datasets that have nearly\\nidentical simple descriptive statistics (mean, variance, correlation, and linear\\nregression lines), yet appear very different when graphed.\\n&lt;/p&gt;\\n"},"id":"1122","type":"Div"},{"attributes":{},"id":"1011","type":"BasicTicker"},{"attributes":{},"id":"1045","type":"BasicTicker"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#cc6633"},"line_color":{"value":"#cc6633"},"size":{"units":"screen","value":12},"x":{"field":"xiii"},"y":{"field":"yiii"}},"id":"1050","type":"Circle"},{"attributes":{},"id":"1071","type":"LinearScale"},{"attributes":{},"id":"1113","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"1001"}},"id":"1020","type":"CDSView"},{"attributes":{"axis":null,"ticker":{"id":"1011"}},"id":"1012","type":"Grid"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#cc6633"},"line_color":{"value":"#cc6633"},"size":{"units":"screen","value":12},"x":{"field":"xiv"},"y":{"field":"yiv"}},"id":"1066","type":"Circle"},{"attributes":{"children":[[{"id":"1005"},0,0],[{"id":"1021"},0,1],[{"id":"1037"},1,0],[{"id":"1053"},1,1]],"sizing_mode":"scale_width"},"id":"1121","type":"GridBox"},{"attributes":{"data_source":{"id":"1001"},"glyph":{"id":"1066"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"1068"}},"id":"1067","type":"GlyphRenderer"},{"attributes":{"line_color":"#666699","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"1015","type":"Line"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"1111","type":"Toolbar"},{"attributes":{"source":{"id":"1002"}},"id":"1065","type":"CDSView"},{"attributes":{},"id":"1080","type":"Selection"},{"attributes":{},"id":"1013","type":"BasicTicker"},{"attributes":{"source":{"id":"1002"}},"id":"1017","type":"CDSView"},{"attributes":{},"id":"1108","type":"LinearScale"},{"attributes":{"background_fill_color":"#efefef","below":[{"id":"1041"}],"center":[{"id":"1044"},{"id":"1046"}],"left":[{"id":"1042"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"1048"},{"id":"1051"}],"title":{"id":"1040"},"toolbar":{"id":"1098"},"toolbar_location":null,"x_range":{"id":"1003"},"x_scale":{"id":"1095"},"y_range":{"id":"1004"},"y_scale":{"id":"1097"}},"id":"1037","type":"Plot"},{"attributes":{"line_color":"#666699","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"1063","type":"Line"},{"attributes":{},"id":"1077","type":"UnionRenderers"},{"attributes":{"end":20.5,"start":-0.5},"id":"1003","type":"Range1d"},{"attributes":{},"id":"1043","type":"BasicTicker"},{"attributes":{},"id":"1061","type":"BasicTicker"},{"attributes":{"source":{"id":"1002"}},"id":"1033","type":"CDSView"},{"attributes":{},"id":"1100","type":"BasicTickFormatter"},{"attributes":{"axis":null,"ticker":{"id":"1027"}},"id":"1028","type":"Grid"},{"attributes":{"axis":null,"dimension":1,"ticker":{"id":"1061"}},"id":"1062","type":"Grid"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#cc6633"},"line_color":{"value":"#cc6633"},"size":{"units":"screen","value":12},"x":{"field":"xi"},"y":{"field":"yi"}},"id":"1018","type":"Circle"},{"attributes":{},"id":"1102","type":"BasicTickFormatter"},{"attributes":{},"id":"1074","type":"BasicTickFormatter"},{"attributes":{"line_color":"#666699","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"1031","type":"Line"},{"attributes":{"background_fill_color":"#efefef","below":[{"id":"1009"}],"center":[{"id":"1012"},{"id":"1014"}],"left":[{"id":"1010"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"1016"},{"id":"1019"}],"title":{"id":"1008"},"toolbar":{"id":"1072"},"toolbar_location":null,"x_range":{"id":"1003"},"x_scale":{"id":"1069"},"y_range":{"id":"1004"},"y_scale":{"id":"1071"}},"id":"1005","type":"Plot"},{"attributes":{},"id":"1110","type":"LinearScale"},{"attributes":{"axis":null,"dimension":1,"ticker":{"id":"1029"}},"id":"1030","type":"Grid"},{"attributes":{"data_source":{"id":"1001"},"glyph":{"id":"1050"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"1052"}},"id":"1051","type":"GlyphRenderer"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"1098","type":"Toolbar"},{"attributes":{},"id":"1079","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"1001"},"glyph":{"id":"1034"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"1036"}},"id":"1035","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"1002"},"glyph":{"id":"1063"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"1065"}},"id":"1064","type":"GlyphRenderer"},{"attributes":{"text":"I"},"id":"1008","type":"Title"},{"attributes":{},"id":"1076","type":"BasicTickFormatter"},{"attributes":{},"id":"1095","type":"LinearScale"},{"attributes":{"data":{"x":{"__ndarray__":"AAAAAAAA4L9WVVVVVVX9P6uqqqqqqhBAAAAAAAAAGkCrqqqqqqohQFZVVVVVVSZAAAAAAAAAK0CsqqqqqqovQKuqqqqqKjJAAAAAAACANEA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"AAAAAAAABkBWVVVVVVUPQFZVVVVVVRRAAAAAAAAAGUCrqqqqqqodQKuqqqqqKiFAAAAAAACAI0BWVVVVVdUlQKuqqqqqKihAAAAAAACAKkA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"1078"},"selection_policy":{"id":"1077"}},"id":"1002","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#cc6633"},"line_color":{"value":"#cc6633"},"size":{"units":"screen","value":12},"x":{"field":"xii"},"y":{"field":"yii"}},"id":"1034","type":"Circle"},{"attributes":{},"id":"1059","type":"BasicTicker"},{"attributes":{"axis":null,"ticker":{"id":"1059"}},"id":"1060","type":"Grid"},{"attributes":{"axis_line_color":null,"formatter":{"id":"1115"},"ticker":{"id":"1061"}},"id":"1058","type":"LinearAxis"},{"attributes":{"end":20.5,"start":-0.5},"id":"1004","type":"Range1d"},{"attributes":{"text":"III"},"id":"1040","type":"Title"},{"attributes":{},"id":"1087","type":"BasicTickFormatter"},{"attributes":{},"id":"1115","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"1001"}},"id":"1036","type":"CDSView"},{"attributes":{},"id":"1029","type":"BasicTicker"},{"attributes":{"axis":null,"dimension":1,"ticker":{"id":"1045"}},"id":"1046","type":"Grid"},{"attributes":{"axis_line_color":null,"formatter":{"id":"1113"},"ticker":{"id":"1059"}},"id":"1057","type":"LinearAxis"},{"attributes":{},"id":"1089","type":"BasicTickFormatter"},{"attributes":{"axis_line_color":null,"formatter":{"id":"1087"},"ticker":{"id":"1027"}},"id":"1025","type":"LinearAxis"},{"attributes":{"background_fill_color":"#efefef","below":[{"id":"1025"}],"center":[{"id":"1028"},{"id":"1030"}],"left":[{"id":"1026"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"1032"},{"id":"1035"}],"title":{"id":"1024"},"toolbar":{"id":"1085"},"toolbar_location":null,"x_range":{"id":"1003"},"x_scale":{"id":"1082"},"y_range":{"id":"1004"},"y_scale":{"id":"1084"}},"id":"1021","type":"Plot"},{"attributes":{"text":"II"},"id":"1024","type":"Title"},{"attributes":{"background_fill_color":"#efefef","below":[{"id":"1057"}],"center":[{"id":"1060"},{"id":"1062"}],"left":[{"id":"1058"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"1064"},{"id":"1067"}],"title":{"id":"1056"},"toolbar":{"id":"1111"},"toolbar_location":null,"x_range":{"id":"1003"},"x_scale":{"id":"1108"},"y_range":{"id":"1004"},"y_scale":{"id":"1110"}},"id":"1053","type":"Plot"},{"attributes":{},"id":"1078","type":"Selection"},{"attributes":{},"id":"1097","type":"LinearScale"},{"attributes":{"source":{"id":"1002"}},"id":"1049","type":"CDSView"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"1085","type":"Toolbar"},{"attributes":{},"id":"1082","type":"LinearScale"},{"attributes":{},"id":"1027","type":"BasicTicker"},{"attributes":{"axis":null,"dimension":1,"ticker":{"id":"1013"}},"id":"1014","type":"Grid"},{"attributes":{"data_source":{"id":"1002"},"glyph":{"id":"1031"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"1033"}},"id":"1032","type":"GlyphRenderer"},{"attributes":{"data":{"xi":{"__ndarray__":"AAAAAAAAJEAAAAAAAAAgQAAAAAAAACpAAAAAAAAAIkAAAAAAAAAmQAAAAAAAACxAAAAAAAAAGEAAAAAAAAAQQAAAAAAAAChAAAAAAAAAHEAAAAAAAAAUQA==","dtype":"float64","order":"little","shape":[11]},"xii":{"__ndarray__":"AAAAAAAAJEAAAAAAAAAgQAAAAAAAACpAAAAAAAAAIkAAAAAAAAAmQAAAAAAAACxAAAAAAAAAGEAAAAAAAAAQQAAAAAAAAChAAAAAAAAAHEAAAAAAAAAUQA==","dtype":"float64","order":"little","shape":[11]},"xiii":{"__ndarray__":"AAAAAAAAJEAAAAAAAAAgQAAAAAAAACpAAAAAAAAAIkAAAAAAAAAmQAAAAAAAACxAAAAAAAAAGEAAAAAAAAAQQAAAAAAAAChAAAAAAAAAHEAAAAAAAAAUQA==","dtype":"float64","order":"little","shape":[11]},"xiv":{"__ndarray__":"AAAAAAAAIEAAAAAAAAAgQAAAAAAAACBAAAAAAAAAIEAAAAAAAAAgQAAAAAAAACBAAAAAAAAAIEAAAAAAAAAzQAAAAAAAACBAAAAAAAAAIEAAAAAAAAAgQA==","dtype":"float64","order":"little","shape":[11]},"yi":{"__ndarray__":"FK5H4XoUIEDNzMzMzMwbQFK4HoXrUR5AH4XrUbieIUApXI/C9aggQOxRuB6F6yNA9ihcj8L1HEAK16NwPQoRQK5H4XoUriVASOF6FK5HE0C4HoXrUbgWQA==","dtype":"float64","order":"little","shape":[11]},"yii":{"__ndarray__":"SOF6FK5HIkBI4XoUrkcgQHsUrkfheiFACtejcD2KIUCF61G4HoUiQDMzMzMzMyBAhetRuB6FGEDNzMzMzMwIQMP1KFyPQiJACtejcD0KHUD2KFyPwvUSQA==","dtype":"float64","order":"little","shape":[11]},"yiii":{"__ndarray__":"16NwPQrXHUAUrkfhehQbQHsUrkfheilAcT0K16NwHEA9CtejcD0fQK5H4XoUriFAUrgehetRGECPwvUoXI8VQM3MzMzMTCBArkfhehSuGUDsUbgehesWQA==","dtype":"float64","order":"little","shape":[11]},"yiv":{"__ndarray__":"UrgehetRGkAK16NwPQoXQNejcD0K1x5ArkfhehSuIUBxPQrXo/AgQClcj8L1KBxAAAAAAAAAFUAAAAAAAAApQD0K16NwPRZApHA9CtejH0CPwvUoXI8bQA==","dtype":"float64","order":"little","shape":[11]}},"selected":{"id":"1080"},"selection_policy":{"id":"1079"}},"id":"1001","type":"ColumnDataSource"},{"attributes":{"text":"IV"},"id":"1056","type":"Title"},{"attributes":{},"id":"1084","type":"LinearScale"}],"root_ids":["1123"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"37a57f9c-ea08-4bf0-ac22-2851ab4548ef","root_ids":["1123"],"roots":{"1123":"8d5a82c1-184f-4286-90af-1a3faa62418c"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();