(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("08dd89ab-3761-4fe2-b1e8-143bd278df8e");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '08dd89ab-3761-4fe2-b1e8-143bd278df8e' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"8f4248cc-2f83-4b60-83d1-9126468681c1":{"roots":{"references":[{"attributes":{"fields":[]},"id":"7637","type":"Stack"},{"attributes":{"data_source":{"id":"7692"},"glyph":{"id":"7694"},"hover_glyph":null,"muted_glyph":null,"name":"y2","nonselection_glyph":{"id":"7695"},"selection_glyph":null,"view":{"id":"7697"}},"id":"7696","type":"GlyphRenderer"},{"attributes":{"label":{"value":"y9"},"renderers":[{"id":"7878"}]},"id":"7907","type":"LegendItem"},{"attributes":{},"id":"7708","type":"UnionRenderers"},{"attributes":{"fields":["y0"]},"id":"7638","type":"Stack"},{"attributes":{},"id":"7730","type":"UnionRenderers"},{"attributes":{"source":{"id":"7784"}},"id":"7789","type":"CDSView"},{"attributes":{},"id":"7709","type":"Selection"},{"attributes":{},"id":"7613","type":"LinearScale"},{"attributes":{"source":{"id":"7692"}},"id":"7697","type":"CDSView"},{"attributes":{},"id":"7809","type":"Selection"},{"attributes":{},"id":"7611","type":"LinearScale"},{"attributes":{},"id":"7838","type":"UnionRenderers"},{"attributes":{"fields":["y0"]},"id":"7639","type":"Stack"},{"attributes":{"data":{"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14],"y0":[58,55,13,57,98,50,84,40,48,83,48,78,57,68,72],"y1":[65,37,32,36,91,36,94,72,20,31,95,19,38,49,91],"y2":[46,27,64,50,33,89,42,64,18,49,52,85,66,63,55],"y3":[83,53,21,99,19,62,13,53,67,64,33,93,61,26,31],"y4":[22,77,15,59,84,58,61,55,64,41,56,58,17,35,35],"y5":[32,99,18,55,61,99,48,47,67,21,25,84,17,79,54],"y6":[11,40,59,69,29,17,96,40,88,17,57,56,83,56,50],"y7":[38,46,33,43,54,99,75,23,29,55,61,40,85,72,47],"y8":[88,52,94,52,99,56,98,26,82,97,73,74,77,42,59],"y9":[94,69,97,96,30,38,96,45,56,48,58,95,19,99,77]},"selected":{"id":"7709"},"selection_policy":{"id":"7708"}},"id":"7692","type":"ColumnDataSource"},{"attributes":{"label":{"value":"y2"},"renderers":[{"id":"7696"}]},"id":"7711","type":"LegendItem"},{"attributes":{},"id":"7808","type":"UnionRenderers"},{"attributes":{"fill_alpha":0.1,"fill_color":"#66c2a5","x":{"field":"index"},"y1":{"expr":{"id":"7641"}},"y2":{"expr":{"id":"7642"}}},"id":"7695","type":"VArea"},{"attributes":{"fields":["y0","y1"]},"id":"7640","type":"Stack"},{"attributes":{"label":{"value":"y6"},"renderers":[{"id":"7788"}]},"id":"7811","type":"LegendItem"},{"attributes":{"formatter":{"id":"7666"},"ticker":{"id":"7616"}},"id":"7615","type":"LinearAxis"},{"attributes":{"fill_color":"#abdda4","x":{"field":"index"},"y1":{"expr":{"id":"7643"}},"y2":{"expr":{"id":"7644"}}},"id":"7714","type":"VArea"},{"attributes":{"fields":["y0","y1"]},"id":"7641","type":"Stack"},{"attributes":{"data_source":{"id":"7784"},"glyph":{"id":"7786"},"hover_glyph":null,"muted_glyph":null,"name":"y6","nonselection_glyph":{"id":"7787"},"selection_glyph":null,"view":{"id":"7789"}},"id":"7788","type":"GlyphRenderer"},{"attributes":{},"id":"7620","type":"BasicTicker"},{"attributes":{},"id":"7616","type":"BasicTicker"},{"attributes":{"fill_color":"#f46d43","x":{"field":"index"},"y1":{"expr":{"id":"7651"}},"y2":{"expr":{"id":"7652"}}},"id":"7814","type":"VArea"},{"attributes":{"fields":["y0","y1","y2"]},"id":"7642","type":"Stack"},{"attributes":{"axis":{"id":"7615"},"minor_grid_line_color":"#eeeeee","ticker":null},"id":"7618","type":"Grid"},{"attributes":{"fields":["y0","y1","y2","y3","y4","y5","y6","y7"]},"id":"7653","type":"Stack"},{"attributes":{"fields":["y0","y1","y2"]},"id":"7643","type":"Stack"},{"attributes":{"data":{"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14],"y0":[58,55,13,57,98,50,84,40,48,83,48,78,57,68,72],"y1":[65,37,32,36,91,36,94,72,20,31,95,19,38,49,91],"y2":[46,27,64,50,33,89,42,64,18,49,52,85,66,63,55],"y3":[83,53,21,99,19,62,13,53,67,64,33,93,61,26,31],"y4":[22,77,15,59,84,58,61,55,64,41,56,58,17,35,35],"y5":[32,99,18,55,61,99,48,47,67,21,25,84,17,79,54],"y6":[11,40,59,69,29,17,96,40,88,17,57,56,83,56,50],"y7":[38,46,33,43,54,99,75,23,29,55,61,40,85,72,47],"y8":[88,52,94,52,99,56,98,26,82,97,73,74,77,42,59],"y9":[94,69,97,96,30,38,96,45,56,48,58,95,19,99,77]},"selected":{"id":"7731"},"selection_policy":{"id":"7730"}},"id":"7712","type":"ColumnDataSource"},{"attributes":{"fill_alpha":0.1,"fill_color":"#fdae61","x":{"field":"index"},"y1":{"expr":{"id":"7649"}},"y2":{"expr":{"id":"7650"}}},"id":"7787","type":"VArea"},{"attributes":{"fields":["y0","y1","y2","y3","y4","y5","y6"]},"id":"7650","type":"Stack"},{"attributes":{"fields":["y0","y1","y2","y3"]},"id":"7644","type":"Stack"},{"attributes":{"fill_color":"#9e0142","x":{"field":"index"},"y1":{"expr":{"id":"7655"}},"y2":{"expr":{"id":"7656"}}},"id":"7876","type":"VArea"},{"attributes":{"fields":["y0","y1","y2","y3","y4"]},"id":"7646","type":"Stack"},{"attributes":{"axis":{"id":"7619"},"dimension":1,"minor_grid_line_color":"#eeeeee","ticker":null},"id":"7622","type":"Grid"},{"attributes":{},"id":"7731","type":"Selection"},{"attributes":{"fields":["y0","y1","y2","y3","y4"]},"id":"7647","type":"Stack"},{"attributes":{"formatter":{"id":"7668"},"ticker":{"id":"7620"}},"id":"7619","type":"LinearAxis"},{"attributes":{"fill_alpha":0.1,"fill_color":"#abdda4","x":{"field":"index"},"y1":{"expr":{"id":"7643"}},"y2":{"expr":{"id":"7644"}}},"id":"7715","type":"VArea"},{"attributes":{"data":{"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14],"y0":[58,55,13,57,98,50,84,40,48,83,48,78,57,68,72],"y1":[65,37,32,36,91,36,94,72,20,31,95,19,38,49,91],"y2":[46,27,64,50,33,89,42,64,18,49,52,85,66,63,55],"y3":[83,53,21,99,19,62,13,53,67,64,33,93,61,26,31],"y4":[22,77,15,59,84,58,61,55,64,41,56,58,17,35,35],"y5":[32,99,18,55,61,99,48,47,67,21,25,84,17,79,54],"y6":[11,40,59,69,29,17,96,40,88,17,57,56,83,56,50],"y7":[38,46,33,43,54,99,75,23,29,55,61,40,85,72,47],"y8":[88,52,94,52,99,56,98,26,82,97,73,74,77,42,59],"y9":[94,69,97,96,30,38,96,45,56,48,58,95,19,99,77]},"selected":{"id":"7839"},"selection_policy":{"id":"7838"}},"id":"7812","type":"ColumnDataSource"},{"attributes":{"source":{"id":"7712"}},"id":"7717","type":"CDSView"},{"attributes":{"fields":["y0","y1","y2","y3"]},"id":"7645","type":"Stack"},{"attributes":{},"id":"7870","type":"UnionRenderers"},{"attributes":{"fields":["y0","y1","y2","y3","y4","y5"]},"id":"7649","type":"Stack"},{"attributes":{},"id":"7839","type":"Selection"},{"attributes":{"fill_alpha":0.1,"fill_color":"#f46d43","x":{"field":"index"},"y1":{"expr":{"id":"7651"}},"y2":{"expr":{"id":"7652"}}},"id":"7815","type":"VArea"},{"attributes":{"fields":["y0","y1","y2","y3","y4","y5","y6","y7","y8"]},"id":"7654","type":"Stack"},{"attributes":{"data_source":{"id":"7712"},"glyph":{"id":"7714"},"hover_glyph":null,"muted_glyph":null,"name":"y3","nonselection_glyph":{"id":"7715"},"selection_glyph":null,"view":{"id":"7717"}},"id":"7716","type":"GlyphRenderer"},{"attributes":{"source":{"id":"7812"}},"id":"7817","type":"CDSView"},{"attributes":{"text":""},"id":"7663","type":"Title"},{"attributes":{"fields":["y0","y1","y2","y3","y4","y5","y6","y7","y8"]},"id":"7655","type":"Stack"},{"attributes":{},"id":"7754","type":"UnionRenderers"},{"attributes":{},"id":"7666","type":"BasicTickFormatter"},{"attributes":{"fields":["y0","y1","y2","y3","y4","y5"]},"id":"7648","type":"Stack"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"7623"},{"id":"7624"},{"id":"7625"},{"id":"7626"},{"id":"7627"},{"id":"7628"}]},"id":"7630","type":"Toolbar"},{"attributes":{"label":{"value":"y7"},"renderers":[{"id":"7816"}]},"id":"7841","type":"LegendItem"},{"attributes":{"data_source":{"id":"7812"},"glyph":{"id":"7814"},"hover_glyph":null,"muted_glyph":null,"name":"y7","nonselection_glyph":{"id":"7815"},"selection_glyph":null,"view":{"id":"7817"}},"id":"7816","type":"GlyphRenderer"},{"attributes":{"fill_color":"#d53e4f","x":{"field":"index"},"y1":{"expr":{"id":"7653"}},"y2":{"expr":{"id":"7654"}}},"id":"7844","type":"VArea"},{"attributes":{},"id":"7623","type":"PanTool"},{"attributes":{"source":{"id":"7734"}},"id":"7739","type":"CDSView"},{"attributes":{},"id":"7668","type":"BasicTickFormatter"},{"attributes":{"label":{"value":"y4"},"renderers":[{"id":"7738"}]},"id":"7757","type":"LegendItem"},{"attributes":{},"id":"7669","type":"UnionRenderers"},{"attributes":{},"id":"7624","type":"WheelZoomTool"},{"attributes":{},"id":"7670","type":"Selection"},{"attributes":{"fields":["y0","y1","y2","y3","y4","y5","y6"]},"id":"7651","type":"Stack"},{"attributes":{"fill_alpha":0.1,"fill_color":"#e6f598","x":{"field":"index"},"y1":{"expr":{"id":"7645"}},"y2":{"expr":{"id":"7646"}}},"id":"7737","type":"VArea"},{"attributes":{"overlay":{"id":"7629"}},"id":"7625","type":"BoxZoomTool"},{"attributes":{"fill_color":"#3288bd","x":{"field":"index"},"y1":{"expr":{"id":"7639"}},"y2":{"expr":{"id":"7640"}}},"id":"7676","type":"VArea"},{"attributes":{"data":{"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14],"y0":[58,55,13,57,98,50,84,40,48,83,48,78,57,68,72],"y1":[65,37,32,36,91,36,94,72,20,31,95,19,38,49,91],"y2":[46,27,64,50,33,89,42,64,18,49,52,85,66,63,55],"y3":[83,53,21,99,19,62,13,53,67,64,33,93,61,26,31],"y4":[22,77,15,59,84,58,61,55,64,41,56,58,17,35,35],"y5":[32,99,18,55,61,99,48,47,67,21,25,84,17,79,54],"y6":[11,40,59,69,29,17,96,40,88,17,57,56,83,56,50],"y7":[38,46,33,43,54,99,75,23,29,55,61,40,85,72,47],"y8":[88,52,94,52,99,56,98,26,82,97,73,74,77,42,59],"y9":[94,69,97,96,30,38,96,45,56,48,58,95,19,99,77]},"selected":{"id":"7689"},"selection_policy":{"id":"7688"}},"id":"7674","type":"ColumnDataSource"},{"attributes":{"fields":["y0","y1","y2","y3","y4","y5","y6","y7"]},"id":"7652","type":"Stack"},{"attributes":{"data_source":{"id":"7734"},"glyph":{"id":"7736"},"hover_glyph":null,"muted_glyph":null,"name":"y4","nonselection_glyph":{"id":"7737"},"selection_glyph":null,"view":{"id":"7739"}},"id":"7738","type":"GlyphRenderer"},{"attributes":{},"id":"7626","type":"SaveTool"},{"attributes":{"data":{"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14],"y0":[58,55,13,57,98,50,84,40,48,83,48,78,57,68,72],"y1":[65,37,32,36,91,36,94,72,20,31,95,19,38,49,91],"y2":[46,27,64,50,33,89,42,64,18,49,52,85,66,63,55],"y3":[83,53,21,99,19,62,13,53,67,64,33,93,61,26,31],"y4":[22,77,15,59,84,58,61,55,64,41,56,58,17,35,35],"y5":[32,99,18,55,61,99,48,47,67,21,25,84,17,79,54],"y6":[11,40,59,69,29,17,96,40,88,17,57,56,83,56,50],"y7":[38,46,33,43,54,99,75,23,29,55,61,40,85,72,47],"y8":[88,52,94,52,99,56,98,26,82,97,73,74,77,42,59],"y9":[94,69,97,96,30,38,96,45,56,48,58,95,19,99,77]},"selected":{"id":"7871"},"selection_policy":{"id":"7870"}},"id":"7842","type":"ColumnDataSource"},{"attributes":{},"id":"7627","type":"ResetTool"},{"attributes":{"fields":["y0","y1","y2","y3","y4","y5","y6","y7","y8","y9"]},"id":"7656","type":"Stack"},{"attributes":{"fill_color":"#5e4fa2","x":{"field":"index"},"y1":{"expr":{"id":"7637"}},"y2":{"expr":{"id":"7638"}}},"id":"7659","type":"VArea"},{"attributes":{"source":{"id":"7674"}},"id":"7679","type":"CDSView"},{"attributes":{},"id":"7755","type":"Selection"},{"attributes":{},"id":"7905","type":"Selection"},{"attributes":{},"id":"7628","type":"HelpTool"},{"attributes":{"data":{"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14],"y0":[58,55,13,57,98,50,84,40,48,83,48,78,57,68,72],"y1":[65,37,32,36,91,36,94,72,20,31,95,19,38,49,91],"y2":[46,27,64,50,33,89,42,64,18,49,52,85,66,63,55],"y3":[83,53,21,99,19,62,13,53,67,64,33,93,61,26,31],"y4":[22,77,15,59,84,58,61,55,64,41,56,58,17,35,35],"y5":[32,99,18,55,61,99,48,47,67,21,25,84,17,79,54],"y6":[11,40,59,69,29,17,96,40,88,17,57,56,83,56,50],"y7":[38,46,33,43,54,99,75,23,29,55,61,40,85,72,47],"y8":[88,52,94,52,99,56,98,26,82,97,73,74,77,42,59],"y9":[94,69,97,96,30,38,96,45,56,48,58,95,19,99,77]},"selected":{"id":"7781"},"selection_policy":{"id":"7780"}},"id":"7758","type":"ColumnDataSource"},{"attributes":{"fill_alpha":0.1,"fill_color":"#d53e4f","x":{"field":"index"},"y1":{"expr":{"id":"7653"}},"y2":{"expr":{"id":"7654"}}},"id":"7845","type":"VArea"},{"attributes":{},"id":"7689","type":"Selection"},{"attributes":{"source":{"id":"7842"}},"id":"7847","type":"CDSView"},{"attributes":{"data":{"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14],"y0":[58,55,13,57,98,50,84,40,48,83,48,78,57,68,72],"y1":[65,37,32,36,91,36,94,72,20,31,95,19,38,49,91],"y2":[46,27,64,50,33,89,42,64,18,49,52,85,66,63,55],"y3":[83,53,21,99,19,62,13,53,67,64,33,93,61,26,31],"y4":[22,77,15,59,84,58,61,55,64,41,56,58,17,35,35],"y5":[32,99,18,55,61,99,48,47,67,21,25,84,17,79,54],"y6":[11,40,59,69,29,17,96,40,88,17,57,56,83,56,50],"y7":[38,46,33,43,54,99,75,23,29,55,61,40,85,72,47],"y8":[88,52,94,52,99,56,98,26,82,97,73,74,77,42,59],"y9":[94,69,97,96,30,38,96,45,56,48,58,95,19,99,77]},"selected":{"id":"7670"},"selection_policy":{"id":"7669"}},"id":"7657","type":"ColumnDataSource"},{"attributes":{"fill_color":"#fee08b","x":{"field":"index"},"y1":{"expr":{"id":"7647"}},"y2":{"expr":{"id":"7648"}}},"id":"7760","type":"VArea"},{"attributes":{},"id":"7871","type":"Selection"},{"attributes":{"label":{"value":"y3"},"renderers":[{"id":"7716"}]},"id":"7733","type":"LegendItem"},{"attributes":{"source":{"id":"7657"}},"id":"7662","type":"CDSView"},{"attributes":{"fill_alpha":0.1,"fill_color":"#fee08b","x":{"field":"index"},"y1":{"expr":{"id":"7647"}},"y2":{"expr":{"id":"7648"}}},"id":"7761","type":"VArea"},{"attributes":{"label":{"value":"y1"},"renderers":[{"id":"7678"}]},"id":"7691","type":"LegendItem"},{"attributes":{"data_source":{"id":"7842"},"glyph":{"id":"7844"},"hover_glyph":null,"muted_glyph":null,"name":"y8","nonselection_glyph":{"id":"7845"},"selection_glyph":null,"view":{"id":"7847"}},"id":"7846","type":"GlyphRenderer"},{"attributes":{"data":{"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14],"y0":[58,55,13,57,98,50,84,40,48,83,48,78,57,68,72],"y1":[65,37,32,36,91,36,94,72,20,31,95,19,38,49,91],"y2":[46,27,64,50,33,89,42,64,18,49,52,85,66,63,55],"y3":[83,53,21,99,19,62,13,53,67,64,33,93,61,26,31],"y4":[22,77,15,59,84,58,61,55,64,41,56,58,17,35,35],"y5":[32,99,18,55,61,99,48,47,67,21,25,84,17,79,54],"y6":[11,40,59,69,29,17,96,40,88,17,57,56,83,56,50],"y7":[38,46,33,43,54,99,75,23,29,55,61,40,85,72,47],"y8":[88,52,94,52,99,56,98,26,82,97,73,74,77,42,59],"y9":[94,69,97,96,30,38,96,45,56,48,58,95,19,99,77]},"selected":{"id":"7755"},"selection_policy":{"id":"7754"}},"id":"7734","type":"ColumnDataSource"},{"attributes":{"data":{"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14],"y0":[58,55,13,57,98,50,84,40,48,83,48,78,57,68,72],"y1":[65,37,32,36,91,36,94,72,20,31,95,19,38,49,91],"y2":[46,27,64,50,33,89,42,64,18,49,52,85,66,63,55],"y3":[83,53,21,99,19,62,13,53,67,64,33,93,61,26,31],"y4":[22,77,15,59,84,58,61,55,64,41,56,58,17,35,35],"y5":[32,99,18,55,61,99,48,47,67,21,25,84,17,79,54],"y6":[11,40,59,69,29,17,96,40,88,17,57,56,83,56,50],"y7":[38,46,33,43,54,99,75,23,29,55,61,40,85,72,47],"y8":[88,52,94,52,99,56,98,26,82,97,73,74,77,42,59],"y9":[94,69,97,96,30,38,96,45,56,48,58,95,19,99,77]},"selected":{"id":"7809"},"selection_policy":{"id":"7808"}},"id":"7784","type":"ColumnDataSource"},{"attributes":{},"id":"7688","type":"UnionRenderers"},{"attributes":{"items":[{"id":"7907"},{"id":"7873"},{"id":"7841"},{"id":"7811"},{"id":"7783"},{"id":"7757"},{"id":"7733"},{"id":"7711"},{"id":"7691"},{"id":"7673"}]},"id":"7672","type":"Legend"},{"attributes":{"source":{"id":"7758"}},"id":"7763","type":"CDSView"},{"attributes":{},"id":"7904","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"7657"},"glyph":{"id":"7659"},"hover_glyph":null,"muted_glyph":null,"name":"y0","nonselection_glyph":{"id":"7660"},"selection_glyph":null,"view":{"id":"7662"}},"id":"7661","type":"GlyphRenderer"},{"attributes":{"data":{"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14],"y0":[58,55,13,57,98,50,84,40,48,83,48,78,57,68,72],"y1":[65,37,32,36,91,36,94,72,20,31,95,19,38,49,91],"y2":[46,27,64,50,33,89,42,64,18,49,52,85,66,63,55],"y3":[83,53,21,99,19,62,13,53,67,64,33,93,61,26,31],"y4":[22,77,15,59,84,58,61,55,64,41,56,58,17,35,35],"y5":[32,99,18,55,61,99,48,47,67,21,25,84,17,79,54],"y6":[11,40,59,69,29,17,96,40,88,17,57,56,83,56,50],"y7":[38,46,33,43,54,99,75,23,29,55,61,40,85,72,47],"y8":[88,52,94,52,99,56,98,26,82,97,73,74,77,42,59],"y9":[94,69,97,96,30,38,96,45,56,48,58,95,19,99,77]},"selected":{"id":"7905"},"selection_policy":{"id":"7904"}},"id":"7874","type":"ColumnDataSource"},{"attributes":{"label":{"value":"y0"},"renderers":[{"id":"7661"}]},"id":"7673","type":"LegendItem"},{"attributes":{"below":[{"id":"7615"}],"center":[{"id":"7618"},{"id":"7622"},{"id":"7672"}],"left":[{"id":"7619"}],"renderers":[{"id":"7661"},{"id":"7678"},{"id":"7696"},{"id":"7716"},{"id":"7738"},{"id":"7762"},{"id":"7788"},{"id":"7816"},{"id":"7846"},{"id":"7878"}],"title":{"id":"7663"},"toolbar":{"id":"7630"},"x_range":{"id":"7607"},"x_scale":{"id":"7611"},"y_range":{"id":"7609"},"y_scale":{"id":"7613"}},"id":"7606","subtype":"Figure","type":"Plot"},{"attributes":{"fill_alpha":0.1,"fill_color":"#3288bd","x":{"field":"index"},"y1":{"expr":{"id":"7639"}},"y2":{"expr":{"id":"7640"}}},"id":"7677","type":"VArea"},{"attributes":{"fill_color":"#fdae61","x":{"field":"index"},"y1":{"expr":{"id":"7649"}},"y2":{"expr":{"id":"7650"}}},"id":"7786","type":"VArea"},{"attributes":{"data_source":{"id":"7674"},"glyph":{"id":"7676"},"hover_glyph":null,"muted_glyph":null,"name":"y1","nonselection_glyph":{"id":"7677"},"selection_glyph":null,"view":{"id":"7679"}},"id":"7678","type":"GlyphRenderer"},{"attributes":{"end":800},"id":"7609","type":"Range1d"},{"attributes":{"fill_color":"#66c2a5","x":{"field":"index"},"y1":{"expr":{"id":"7641"}},"y2":{"expr":{"id":"7642"}}},"id":"7694","type":"VArea"},{"attributes":{},"id":"7780","type":"UnionRenderers"},{"attributes":{"end":14},"id":"7607","type":"Range1d"},{"attributes":{"label":{"value":"y8"},"renderers":[{"id":"7846"}]},"id":"7873","type":"LegendItem"},{"attributes":{"data_source":{"id":"7874"},"glyph":{"id":"7876"},"hover_glyph":null,"muted_glyph":null,"name":"y9","nonselection_glyph":{"id":"7877"},"selection_glyph":null,"view":{"id":"7879"}},"id":"7878","type":"GlyphRenderer"},{"attributes":{"fill_alpha":0.1,"fill_color":"#5e4fa2","x":{"field":"index"},"y1":{"expr":{"id":"7637"}},"y2":{"expr":{"id":"7638"}}},"id":"7660","type":"VArea"},{"attributes":{"data_source":{"id":"7758"},"glyph":{"id":"7760"},"hover_glyph":null,"muted_glyph":null,"name":"y5","nonselection_glyph":{"id":"7761"},"selection_glyph":null,"view":{"id":"7763"}},"id":"7762","type":"GlyphRenderer"},{"attributes":{"source":{"id":"7874"}},"id":"7879","type":"CDSView"},{"attributes":{"fill_color":"#e6f598","x":{"field":"index"},"y1":{"expr":{"id":"7645"}},"y2":{"expr":{"id":"7646"}}},"id":"7736","type":"VArea"},{"attributes":{"fill_alpha":0.1,"fill_color":"#9e0142","x":{"field":"index"},"y1":{"expr":{"id":"7655"}},"y2":{"expr":{"id":"7656"}}},"id":"7877","type":"VArea"},{"attributes":{},"id":"7781","type":"Selection"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"7629","type":"BoxAnnotation"},{"attributes":{"label":{"value":"y5"},"renderers":[{"id":"7762"}]},"id":"7783","type":"LegendItem"}],"root_ids":["7606"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"8f4248cc-2f83-4b60-83d1-9126468681c1","root_ids":["7606"],"roots":{"7606":"08dd89ab-3761-4fe2-b1e8-143bd278df8e"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();