(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("e225fd29-8774-4f87-b0a3-47b85e3a22fe");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'e225fd29-8774-4f87-b0a3-47b85e3a22fe' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"e3fad3bd-3506-4636-8b6b-c30bb23f8a6d":{"roots":{"references":[{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"top":{"field":"top"},"width":{"value":0.9},"x":{"field":"x"}},"id":"1675","type":"VBar"},{"attributes":{"data_source":{"id":"1673"},"glyph":{"id":"1674"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"1675"},"selection_glyph":null,"view":{"id":"1677"}},"id":"1676","type":"GlyphRenderer"},{"attributes":{},"id":"1669","type":"BasicTicker"},{"attributes":{},"id":"1691","type":"UnionRenderers"},{"attributes":{},"id":"1692","type":"Selection"},{"attributes":{},"id":"1666","type":"CategoricalTicker"},{"attributes":{},"id":"1690","type":"Selection"},{"attributes":{"data":{"top":[10,12,16,9,10,8,12,13,14,14,12,16],"x":[["Q1","jan"],["Q1","feb"],["Q1","mar"],["Q2","apr"],["Q2","may"],["Q2","jun"],["Q3","jul"],["Q3","aug"],["Q3","sep"],["Q4","oct"],["Q4","nov"],["Q4","dec"]]},"selected":{"id":"1690"},"selection_policy":{"id":"1689"}},"id":"1673","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"1686"},"major_label_orientation":1,"ticker":{"id":"1666"}},"id":"1665","type":"CategoricalAxis"},{"attributes":{"text":""},"id":"1683","type":"Title"},{"attributes":{},"id":"1686","type":"CategoricalTickFormatter"},{"attributes":{"source":{"id":"1678"}},"id":"1682","type":"CDSView"},{"attributes":{},"id":"1663","type":"LinearScale"},{"attributes":{"data_source":{"id":"1678"},"glyph":{"id":"1679"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"1680"},"selection_glyph":null,"view":{"id":"1682"}},"id":"1681","type":"GlyphRenderer"},{"attributes":{"factors":[["Q1","jan"],["Q1","feb"],["Q1","mar"],["Q2","apr"],["Q2","may"],["Q2","jun"],["Q3","jul"],["Q3","aug"],["Q3","sep"],["Q4","oct"],["Q4","nov"],["Q4","dec"]],"range_padding":0.1},"id":"1656","type":"FactorRange"},{"attributes":{"axis":{"id":"1665"},"grid_line_color":null,"ticker":null},"id":"1667","type":"Grid"},{"attributes":{},"id":"1689","type":"UnionRenderers"},{"attributes":{"line_color":"red","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"1679","type":"Line"},{"attributes":{},"id":"1661","type":"CategoricalScale"},{"attributes":{},"id":"1688","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"1668"},"dimension":1,"ticker":null},"id":"1671","type":"Grid"},{"attributes":{"data":{"x":["Q1","Q2","Q3","Q4"],"y":[12,9,13,14]},"selected":{"id":"1692"},"selection_policy":{"id":"1691"}},"id":"1678","type":"ColumnDataSource"},{"attributes":{"start":0},"id":"1659","type":"DataRange1d"},{"attributes":{"formatter":{"id":"1688"},"ticker":{"id":"1669"}},"id":"1668","type":"LinearAxis"},{"attributes":{"below":[{"id":"1665"}],"center":[{"id":"1667"},{"id":"1671"}],"left":[{"id":"1668"}],"plot_height":350,"renderers":[{"id":"1676"},{"id":"1681"}],"title":{"id":"1683"},"toolbar":{"id":"1672"},"toolbar_location":null,"x_range":{"id":"1656"},"x_scale":{"id":"1661"},"y_range":{"id":"1659"},"y_scale":{"id":"1663"}},"id":"1657","subtype":"Figure","type":"Plot"},{"attributes":{"line_alpha":0.1,"line_color":"red","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"1680","type":"Line"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"1672","type":"Toolbar"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.5},"line_color":{"value":"#1f77b4"},"top":{"field":"top"},"width":{"value":0.9},"x":{"field":"x"}},"id":"1674","type":"VBar"},{"attributes":{"source":{"id":"1673"}},"id":"1677","type":"CDSView"}],"root_ids":["1657"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"e3fad3bd-3506-4636-8b6b-c30bb23f8a6d","root_ids":["1657"],"roots":{"1657":"e225fd29-8774-4f87-b0a3-47b85e3a22fe"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();