(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("61fbe44a-2016-480b-a5b4-e6118fe1215d");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '61fbe44a-2016-480b-a5b4-e6118fe1215d' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"8816baa0-55f2-40a1-81e4-d8918117b484":{"roots":{"references":[{"attributes":{"axis":{"id":"20185"},"ticker":null},"id":"20188","type":"Grid"},{"attributes":{},"id":"20217","type":"BasicTickFormatter"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"20199","type":"BoxAnnotation"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#CAB2D6"},"height":{"units":"screen","value":20},"line_alpha":{"value":0.1},"line_color":{"value":"#CAB2D6"},"width":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"20209","type":"Rect"},{"attributes":{},"id":"20194","type":"WheelZoomTool"},{"attributes":{"text":""},"id":"20212","type":"Title"},{"attributes":{},"id":"20183","type":"LinearScale"},{"attributes":{"axis":{"id":"20189"},"dimension":1,"ticker":null},"id":"20192","type":"Grid"},{"attributes":{},"id":"20181","type":"LinearScale"},{"attributes":{},"id":"20186","type":"BasicTicker"},{"attributes":{},"id":"20179","type":"DataRange1d"},{"attributes":{},"id":"20193","type":"PanTool"},{"attributes":{},"id":"20215","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"20217"},"ticker":{"id":"20190"}},"id":"20189","type":"LinearAxis"},{"attributes":{"data_source":{"id":"20207"},"glyph":{"id":"20208"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"20209"},"selection_glyph":null,"view":{"id":"20211"}},"id":"20210","type":"GlyphRenderer"},{"attributes":{"fill_color":{"value":"#CAB2D6"},"height":{"units":"screen","value":20},"line_color":{"value":"#CAB2D6"},"width":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"20208","type":"Rect"},{"attributes":{"below":[{"id":"20185"}],"center":[{"id":"20188"},{"id":"20192"}],"left":[{"id":"20189"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"20210"}],"title":{"id":"20212"},"toolbar":{"id":"20200"},"x_range":{"id":"20177"},"x_scale":{"id":"20181"},"y_range":{"id":"20179"},"y_scale":{"id":"20183"}},"id":"20176","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"20198","type":"HelpTool"},{"attributes":{},"id":"20196","type":"SaveTool"},{"attributes":{},"id":"20177","type":"DataRange1d"},{"attributes":{"source":{"id":"20207"}},"id":"20211","type":"CDSView"},{"attributes":{"overlay":{"id":"20199"}},"id":"20195","type":"BoxZoomTool"},{"attributes":{},"id":"20197","type":"ResetTool"},{"attributes":{},"id":"20218","type":"UnionRenderers"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"20219"},"selection_policy":{"id":"20218"}},"id":"20207","type":"ColumnDataSource"},{"attributes":{},"id":"20219","type":"Selection"},{"attributes":{},"id":"20190","type":"BasicTicker"},{"attributes":{"formatter":{"id":"20215"},"ticker":{"id":"20186"}},"id":"20185","type":"LinearAxis"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"20193"},{"id":"20194"},{"id":"20195"},{"id":"20196"},{"id":"20197"},{"id":"20198"}]},"id":"20200","type":"Toolbar"}],"root_ids":["20176"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"8816baa0-55f2-40a1-81e4-d8918117b484","root_ids":["20176"],"roots":{"20176":"61fbe44a-2016-480b-a5b4-e6118fe1215d"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();