(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("940803e4-0c60-432c-9325-b8b04f866a55");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '940803e4-0c60-432c-9325-b8b04f866a55' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"e7992a7b-5af7-42aa-82ea-51ac445bb677":{"roots":{"references":[{"attributes":{},"id":"22019","type":"Selection"},{"attributes":{"formatter":{"id":"22015"},"ticker":{"id":"21986"}},"id":"21985","type":"LinearAxis"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"21999","type":"BoxAnnotation"},{"attributes":{"below":[{"id":"21985"}],"center":[{"id":"21988"},{"id":"21992"}],"left":[{"id":"21989"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"22010"}],"title":{"id":"22012"},"toolbar":{"id":"22000"},"x_range":{"id":"21977"},"x_scale":{"id":"21981"},"y_range":{"id":"21979"},"y_scale":{"id":"21983"}},"id":"21976","subtype":"Figure","type":"Plot"},{"attributes":{"overlay":{"id":"21999"}},"id":"21995","type":"BoxZoomTool"},{"attributes":{},"id":"21997","type":"ResetTool"},{"attributes":{},"id":"21993","type":"PanTool"},{"attributes":{},"id":"21994","type":"WheelZoomTool"},{"attributes":{"formatter":{"id":"22017"},"ticker":{"id":"21990"}},"id":"21989","type":"LinearAxis"},{"attributes":{"source":{"id":"22007"}},"id":"22011","type":"CDSView"},{"attributes":{"axis":{"id":"21985"},"ticker":null},"id":"21988","type":"Grid"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"22019"},"selection_policy":{"id":"22018"}},"id":"22007","type":"ColumnDataSource"},{"attributes":{"fill_color":{"value":null},"height":{"units":"data","value":20},"line_color":{"value":"#386CB0"},"line_width":{"value":2},"width":{"units":"data","value":30},"x":{"field":"x"},"y":{"field":"y"}},"id":"22008","type":"Ellipse"},{"attributes":{},"id":"21998","type":"HelpTool"},{"attributes":{},"id":"22015","type":"BasicTickFormatter"},{"attributes":{},"id":"22018","type":"UnionRenderers"},{"attributes":{},"id":"21977","type":"DataRange1d"},{"attributes":{},"id":"21986","type":"BasicTicker"},{"attributes":{},"id":"22017","type":"BasicTickFormatter"},{"attributes":{},"id":"21983","type":"LinearScale"},{"attributes":{},"id":"21990","type":"BasicTicker"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"21993"},{"id":"21994"},{"id":"21995"},{"id":"21996"},{"id":"21997"},{"id":"21998"}]},"id":"22000","type":"Toolbar"},{"attributes":{},"id":"21979","type":"DataRange1d"},{"attributes":{},"id":"21981","type":"LinearScale"},{"attributes":{"text":""},"id":"22012","type":"Title"},{"attributes":{},"id":"21996","type":"SaveTool"},{"attributes":{"axis":{"id":"21989"},"dimension":1,"ticker":null},"id":"21992","type":"Grid"},{"attributes":{"data_source":{"id":"22007"},"glyph":{"id":"22008"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"22009"},"selection_glyph":null,"view":{"id":"22011"}},"id":"22010","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"height":{"units":"data","value":20},"line_alpha":{"value":0.1},"line_color":{"value":"#386CB0"},"line_width":{"value":2},"width":{"units":"data","value":30},"x":{"field":"x"},"y":{"field":"y"}},"id":"22009","type":"Ellipse"}],"root_ids":["21976"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"e7992a7b-5af7-42aa-82ea-51ac445bb677","root_ids":["21976"],"roots":{"21976":"940803e4-0c60-432c-9325-b8b04f866a55"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();