(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("599fdc05-a6bf-41f9-983b-e7e28a5e998a");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '599fdc05-a6bf-41f9-983b-e7e28a5e998a' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"34418eb8-0bbe-40e3-9e32-73f34a07c479":{"roots":{"references":[{"attributes":{},"id":"18859","type":"BasicTickFormatter"},{"attributes":{"below":[{"id":"18827"}],"center":[{"id":"18830"},{"id":"18834"}],"left":[{"id":"18831"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"18852"}],"title":{"id":"18854"},"toolbar":{"id":"18842"},"x_range":{"id":"18819"},"x_scale":{"id":"18823"},"y_range":{"id":"18821"},"y_scale":{"id":"18825"}},"id":"18818","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"18836","type":"WheelZoomTool"},{"attributes":{},"id":"18832","type":"BasicTicker"},{"attributes":{},"id":"18835","type":"PanTool"},{"attributes":{},"id":"18860","type":"UnionRenderers"},{"attributes":{},"id":"18823","type":"LinearScale"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"line_alpha":{"value":0.1},"line_color":{"value":"#386CB0"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18851","type":"DiamondDot"},{"attributes":{},"id":"18825","type":"LinearScale"},{"attributes":{"text":""},"id":"18854","type":"Title"},{"attributes":{},"id":"18838","type":"SaveTool"},{"attributes":{"axis":{"id":"18827"},"ticker":null},"id":"18830","type":"Grid"},{"attributes":{},"id":"18821","type":"DataRange1d"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"18841","type":"BoxAnnotation"},{"attributes":{"fill_color":{"value":null},"line_color":{"value":"#386CB0"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18850","type":"DiamondDot"},{"attributes":{"source":{"id":"18849"}},"id":"18853","type":"CDSView"},{"attributes":{"formatter":{"id":"18857"},"ticker":{"id":"18828"}},"id":"18827","type":"LinearAxis"},{"attributes":{},"id":"18819","type":"DataRange1d"},{"attributes":{"formatter":{"id":"18859"},"ticker":{"id":"18832"}},"id":"18831","type":"LinearAxis"},{"attributes":{},"id":"18857","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"18861"},"selection_policy":{"id":"18860"}},"id":"18849","type":"ColumnDataSource"},{"attributes":{},"id":"18861","type":"Selection"},{"attributes":{"overlay":{"id":"18841"}},"id":"18837","type":"BoxZoomTool"},{"attributes":{},"id":"18840","type":"HelpTool"},{"attributes":{"data_source":{"id":"18849"},"glyph":{"id":"18850"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"18851"},"selection_glyph":null,"view":{"id":"18853"}},"id":"18852","type":"GlyphRenderer"},{"attributes":{},"id":"18828","type":"BasicTicker"},{"attributes":{"axis":{"id":"18831"},"dimension":1,"ticker":null},"id":"18834","type":"Grid"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"18835"},{"id":"18836"},{"id":"18837"},{"id":"18838"},{"id":"18839"},{"id":"18840"}]},"id":"18842","type":"Toolbar"},{"attributes":{},"id":"18839","type":"ResetTool"}],"root_ids":["18818"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"34418eb8-0bbe-40e3-9e32-73f34a07c479","root_ids":["18818"],"roots":{"18818":"599fdc05-a6bf-41f9-983b-e7e28a5e998a"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();