(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("97e24dbf-ce26-466e-a343-85a5375e03cc");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '97e24dbf-ce26-466e-a343-85a5375e03cc' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"a2255845-9de7-4240-a423-b49b194023f2":{"roots":{"references":[{"attributes":{"text":"contrast","text_color":{"value":"#000000"},"text_font":"Helvetica","text_font_size":{"value":"1.15em"}},"id":"24211","type":"Title"},{"attributes":{"source":{"id":"24243"}},"id":"24247","type":"CDSView"},{"attributes":{},"id":"24226","type":"BasicTicker"},{"attributes":{},"id":"24232","type":"SaveTool"},{"attributes":{"axis":{"id":"24221"},"grid_line_alpha":0.25,"grid_line_color":"#E0E0E0","ticker":null},"id":"24224","type":"Grid"},{"attributes":{},"id":"24250","type":"BasicTickFormatter"},{"attributes":{"axis_label_standoff":10,"axis_label_text_color":"#000000","axis_label_text_font":"Helvetica","axis_label_text_font_size":"1.25em","axis_label_text_font_style":"normal","axis_line_alpha":0,"axis_line_color":"#000000","formatter":{"id":"24250"},"major_label_text_color":"#000000","major_label_text_font":"Helvetica","major_label_text_font_size":"1.025em","major_tick_line_alpha":0,"major_tick_line_color":"#000000","minor_tick_line_alpha":0,"minor_tick_line_color":"#000000","ticker":{"id":"24222"}},"id":"24221","type":"LinearAxis"},{"attributes":{"overlay":{"id":"24235"}},"id":"24231","type":"BoxZoomTool"},{"attributes":{},"id":"24229","type":"PanTool"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,6,4,5]},"selected":{"id":"24254"},"selection_policy":{"id":"24253"}},"id":"24243","type":"ColumnDataSource"},{"attributes":{},"id":"24234","type":"HelpTool"},{"attributes":{},"id":"24215","type":"DataRange1d"},{"attributes":{},"id":"24252","type":"BasicTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"24229"},{"id":"24230"},{"id":"24231"},{"id":"24232"},{"id":"24233"},{"id":"24234"}]},"id":"24236","type":"Toolbar"},{"attributes":{},"id":"24213","type":"DataRange1d"},{"attributes":{},"id":"24253","type":"UnionRenderers"},{"attributes":{},"id":"24219","type":"LinearScale"},{"attributes":{},"id":"24217","type":"LinearScale"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"24235","type":"BoxAnnotation"},{"attributes":{"data_source":{"id":"24243"},"glyph":{"id":"24244"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"24245"},"selection_glyph":null,"view":{"id":"24247"}},"id":"24246","type":"GlyphRenderer"},{"attributes":{},"id":"24222","type":"BasicTicker"},{"attributes":{},"id":"24233","type":"ResetTool"},{"attributes":{"axis_label_standoff":10,"axis_label_text_color":"#000000","axis_label_text_font":"Helvetica","axis_label_text_font_size":"1.25em","axis_label_text_font_style":"normal","axis_line_alpha":0,"axis_line_color":"#000000","formatter":{"id":"24252"},"major_label_text_color":"#000000","major_label_text_font":"Helvetica","major_label_text_font_size":"1.025em","major_tick_line_alpha":0,"major_tick_line_color":"#000000","minor_tick_line_alpha":0,"minor_tick_line_color":"#000000","ticker":{"id":"24226"}},"id":"24225","type":"LinearAxis"},{"attributes":{},"id":"24230","type":"WheelZoomTool"},{"attributes":{"axis":{"id":"24225"},"dimension":1,"grid_line_alpha":0.25,"grid_line_color":"#E0E0E0","ticker":null},"id":"24228","type":"Grid"},{"attributes":{},"id":"24254","type":"Selection"},{"attributes":{"background_fill_color":"#000000","below":[{"id":"24221"}],"border_fill_color":"#FFFFFF","center":[{"id":"24224"},{"id":"24228"}],"left":[{"id":"24225"}],"outline_line_alpha":0.25,"outline_line_color":"#000000","plot_height":300,"plot_width":300,"renderers":[{"id":"24246"}],"title":{"id":"24211"},"toolbar":{"id":"24236"},"x_range":{"id":"24213"},"x_scale":{"id":"24217"},"y_range":{"id":"24215"},"y_scale":{"id":"24219"}},"id":"24210","subtype":"Figure","type":"Plot"},{"attributes":{"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"24244","type":"Line"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"24245","type":"Line"}],"root_ids":["24210"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"a2255845-9de7-4240-a423-b49b194023f2","root_ids":["24210"],"roots":{"24210":"97e24dbf-ce26-466e-a343-85a5375e03cc"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();