(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("d9099277-f371-4817-ba92-e3d9cb66edf3");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'd9099277-f371-4817-ba92-e3d9cb66edf3' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"1421dfe5-1a3e-4092-b762-db01d73e36fc":{"roots":{"references":[{"attributes":{"formatter":{"id":"22233"},"ticker":{"id":"22206"}},"id":"22205","type":"LinearAxis"},{"attributes":{"text":""},"id":"22228","type":"Title"},{"attributes":{"overlay":{"id":"22215"}},"id":"22211","type":"BoxZoomTool"},{"attributes":{"below":[{"id":"22201"}],"center":[{"id":"22204"},{"id":"22208"}],"left":[{"id":"22205"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"22226"}],"title":{"id":"22228"},"toolbar":{"id":"22216"},"x_range":{"id":"22193"},"x_scale":{"id":"22197"},"y_range":{"id":"22195"},"y_scale":{"id":"22199"}},"id":"22192","subtype":"Figure","type":"Plot"},{"attributes":{"axis":{"id":"22205"},"dimension":1,"ticker":null},"id":"22208","type":"Grid"},{"attributes":{},"id":"22235","type":"Selection"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"22215","type":"BoxAnnotation"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#74ADD1"},"line_alpha":{"value":0.1},"line_color":{"value":"#74ADD1"},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"22225","type":"Hex"},{"attributes":{},"id":"22212","type":"SaveTool"},{"attributes":{},"id":"22209","type":"PanTool"},{"attributes":{},"id":"22213","type":"ResetTool"},{"attributes":{},"id":"22233","type":"BasicTickFormatter"},{"attributes":{},"id":"22231","type":"BasicTickFormatter"},{"attributes":{},"id":"22195","type":"DataRange1d"},{"attributes":{},"id":"22197","type":"LinearScale"},{"attributes":{},"id":"22202","type":"BasicTicker"},{"attributes":{},"id":"22214","type":"HelpTool"},{"attributes":{"formatter":{"id":"22231"},"ticker":{"id":"22202"}},"id":"22201","type":"LinearAxis"},{"attributes":{"source":{"id":"22223"}},"id":"22227","type":"CDSView"},{"attributes":{},"id":"22206","type":"BasicTicker"},{"attributes":{},"id":"22210","type":"WheelZoomTool"},{"attributes":{},"id":"22193","type":"DataRange1d"},{"attributes":{"fill_color":{"value":"#74ADD1"},"line_color":{"value":"#74ADD1"},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"22224","type":"Hex"},{"attributes":{"axis":{"id":"22201"},"ticker":null},"id":"22204","type":"Grid"},{"attributes":{},"id":"22199","type":"LinearScale"},{"attributes":{},"id":"22234","type":"UnionRenderers"},{"attributes":{"data":{"size":[10,20,30],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"22235"},"selection_policy":{"id":"22234"}},"id":"22223","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"22223"},"glyph":{"id":"22224"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"22225"},"selection_glyph":null,"view":{"id":"22227"}},"id":"22226","type":"GlyphRenderer"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"22209"},{"id":"22210"},{"id":"22211"},{"id":"22212"},{"id":"22213"},{"id":"22214"}]},"id":"22216","type":"Toolbar"}],"root_ids":["22192"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"1421dfe5-1a3e-4092-b762-db01d73e36fc","root_ids":["22192"],"roots":{"22192":"d9099277-f371-4817-ba92-e3d9cb66edf3"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();