(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("064adbfd-4ccf-4a6a-902f-26ab1dbf836e");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '064adbfd-4ccf-4a6a-902f-26ab1dbf836e' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"cd79e98e-4261-47f4-9d5f-1405e5ba5d89":{"roots":{"references":[{"attributes":{},"id":"23132","type":"BasicTicker"},{"attributes":{},"id":"23125","type":"LinearScale"},{"attributes":{},"id":"23161","type":"Selection"},{"attributes":{},"id":"23123","type":"LinearScale"},{"attributes":{"formatter":{"id":"23157"},"ticker":{"id":"23128"}},"id":"23127","type":"LinearAxis"},{"attributes":{"line_color":{"value":"#F4A582"},"line_width":{"value":3},"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"23150","type":"Segment"},{"attributes":{"overlay":{"id":"23141"}},"id":"23137","type":"BoxZoomTool"},{"attributes":{},"id":"23138","type":"SaveTool"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#F4A582"},"line_width":{"value":3},"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"23151","type":"Segment"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"23141","type":"BoxAnnotation"},{"attributes":{},"id":"23119","type":"DataRange1d"},{"attributes":{},"id":"23135","type":"PanTool"},{"attributes":{"axis":{"id":"23131"},"dimension":1,"ticker":null},"id":"23134","type":"Grid"},{"attributes":{"data":{"x0":[1,2,3],"x1":[1,2,3],"y0":[1,2,3],"y1":[1.2,2.5,3.7]},"selected":{"id":"23161"},"selection_policy":{"id":"23160"}},"id":"23149","type":"ColumnDataSource"},{"attributes":{},"id":"23160","type":"UnionRenderers"},{"attributes":{"formatter":{"id":"23159"},"ticker":{"id":"23132"}},"id":"23131","type":"LinearAxis"},{"attributes":{"text":""},"id":"23154","type":"Title"},{"attributes":{},"id":"23159","type":"BasicTickFormatter"},{"attributes":{},"id":"23136","type":"WheelZoomTool"},{"attributes":{"below":[{"id":"23127"}],"center":[{"id":"23130"},{"id":"23134"}],"left":[{"id":"23131"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"23152"}],"title":{"id":"23154"},"toolbar":{"id":"23142"},"x_range":{"id":"23119"},"x_scale":{"id":"23123"},"y_range":{"id":"23121"},"y_scale":{"id":"23125"}},"id":"23118","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"23157","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"23127"},"ticker":null},"id":"23130","type":"Grid"},{"attributes":{},"id":"23140","type":"HelpTool"},{"attributes":{"source":{"id":"23149"}},"id":"23153","type":"CDSView"},{"attributes":{},"id":"23121","type":"DataRange1d"},{"attributes":{},"id":"23128","type":"BasicTicker"},{"attributes":{"data_source":{"id":"23149"},"glyph":{"id":"23150"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"23151"},"selection_glyph":null,"view":{"id":"23153"}},"id":"23152","type":"GlyphRenderer"},{"attributes":{},"id":"23139","type":"ResetTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"23135"},{"id":"23136"},{"id":"23137"},{"id":"23138"},{"id":"23139"},{"id":"23140"}]},"id":"23142","type":"Toolbar"}],"root_ids":["23118"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"cd79e98e-4261-47f4-9d5f-1405e5ba5d89","root_ids":["23118"],"roots":{"23118":"064adbfd-4ccf-4a6a-902f-26ab1dbf836e"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();