(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("07ff9ae1-ce49-46f6-b8f9-d6ee6536fa41");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '07ff9ae1-ce49-46f6-b8f9-d6ee6536fa41' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"f78a292b-c5f9-4243-86e8-30c2d6c653f7":{"roots":{"references":[{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"24159"},{"id":"24160"},{"id":"24161"},{"id":"24162"},{"id":"24163"},{"id":"24164"}]},"id":"24166","type":"Toolbar"},{"attributes":{},"id":"24143","type":"DataRange1d"},{"attributes":{},"id":"24163","type":"ResetTool"},{"attributes":{},"id":"24162","type":"SaveTool"},{"attributes":{},"id":"24145","type":"DataRange1d"},{"attributes":{"text":"night_sky","text_color":{"value":"#E0E0E0"},"text_font":"Helvetica","text_font_size":{"value":"1.15em"}},"id":"24141","type":"Title"},{"attributes":{},"id":"24160","type":"WheelZoomTool"},{"attributes":{},"id":"24149","type":"LinearScale"},{"attributes":{"axis":{"id":"24155"},"dimension":1,"grid_line_alpha":0.25,"grid_line_color":"#E0E0E0","ticker":null},"id":"24158","type":"Grid"},{"attributes":{},"id":"24147","type":"LinearScale"},{"attributes":{"axis_label_standoff":10,"axis_label_text_color":"#E0E0E0","axis_label_text_font":"Helvetica","axis_label_text_font_size":"1.25em","axis_label_text_font_style":"normal","axis_line_alpha":0,"axis_line_color":"#E0E0E0","formatter":{"id":"24182"},"major_label_text_color":"#E0E0E0","major_label_text_font":"Helvetica","major_label_text_font_size":"1.025em","major_tick_line_alpha":0,"major_tick_line_color":"#E0E0E0","minor_tick_line_alpha":0,"minor_tick_line_color":"#E0E0E0","ticker":{"id":"24156"}},"id":"24155","type":"LinearAxis"},{"attributes":{},"id":"24184","type":"Selection"},{"attributes":{},"id":"24156","type":"BasicTicker"},{"attributes":{},"id":"24182","type":"BasicTickFormatter"},{"attributes":{"axis_label_standoff":10,"axis_label_text_color":"#E0E0E0","axis_label_text_font":"Helvetica","axis_label_text_font_size":"1.25em","axis_label_text_font_style":"normal","axis_line_alpha":0,"axis_line_color":"#E0E0E0","formatter":{"id":"24180"},"major_label_text_color":"#E0E0E0","major_label_text_font":"Helvetica","major_label_text_font_size":"1.025em","major_tick_line_alpha":0,"major_tick_line_color":"#E0E0E0","minor_tick_line_alpha":0,"minor_tick_line_color":"#E0E0E0","ticker":{"id":"24152"}},"id":"24151","type":"LinearAxis"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"24175","type":"Line"},{"attributes":{"background_fill_color":"#2C001E","below":[{"id":"24151"}],"border_fill_color":"#15191C","center":[{"id":"24154"},{"id":"24158"}],"left":[{"id":"24155"}],"outline_line_alpha":0.25,"outline_line_color":"#E0E0E0","plot_height":300,"plot_width":300,"renderers":[{"id":"24176"}],"title":{"id":"24141"},"toolbar":{"id":"24166"},"x_range":{"id":"24143"},"x_scale":{"id":"24147"},"y_range":{"id":"24145"},"y_scale":{"id":"24149"}},"id":"24140","subtype":"Figure","type":"Plot"},{"attributes":{"source":{"id":"24173"}},"id":"24177","type":"CDSView"},{"attributes":{},"id":"24180","type":"BasicTickFormatter"},{"attributes":{"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"24174","type":"Line"},{"attributes":{},"id":"24183","type":"UnionRenderers"},{"attributes":{"axis":{"id":"24151"},"grid_line_alpha":0.25,"grid_line_color":"#E0E0E0","ticker":null},"id":"24154","type":"Grid"},{"attributes":{},"id":"24164","type":"HelpTool"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,6,4,5]},"selected":{"id":"24184"},"selection_policy":{"id":"24183"}},"id":"24173","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"24173"},"glyph":{"id":"24174"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"24175"},"selection_glyph":null,"view":{"id":"24177"}},"id":"24176","type":"GlyphRenderer"},{"attributes":{"overlay":{"id":"24165"}},"id":"24161","type":"BoxZoomTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"24165","type":"BoxAnnotation"},{"attributes":{},"id":"24159","type":"PanTool"},{"attributes":{},"id":"24152","type":"BasicTicker"}],"root_ids":["24140"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"f78a292b-c5f9-4243-86e8-30c2d6c653f7","root_ids":["24140"],"roots":{"24140":"07ff9ae1-ce49-46f6-b8f9-d6ee6536fa41"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();