(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("317e8779-a87b-4d3c-bfc9-531923cdd0cf");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '317e8779-a87b-4d3c-bfc9-531923cdd0cf' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"871ff8cc-3c1d-46a4-be89-58dfc1d6667d":{"roots":{"references":[{"attributes":{},"id":"21852","type":"SaveTool"},{"attributes":{},"id":"21873","type":"BasicTickFormatter"},{"attributes":{},"id":"21846","type":"BasicTicker"},{"attributes":{"below":[{"id":"21841"}],"center":[{"id":"21844"},{"id":"21848"}],"left":[{"id":"21845"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"21866"}],"title":{"id":"21868"},"toolbar":{"id":"21856"},"x_range":{"id":"21833"},"x_scale":{"id":"21837"},"y_range":{"id":"21835"},"y_scale":{"id":"21839"}},"id":"21832","subtype":"Figure","type":"Plot"},{"attributes":{"axis":{"id":"21845"},"dimension":1,"ticker":null},"id":"21848","type":"Grid"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"21849"},{"id":"21850"},{"id":"21851"},{"id":"21852"},{"id":"21853"},{"id":"21854"}]},"id":"21856","type":"Toolbar"},{"attributes":{"source":{"id":"21863"}},"id":"21867","type":"CDSView"},{"attributes":{},"id":"21871","type":"BasicTickFormatter"},{"attributes":{"overlay":{"id":"21855"}},"id":"21851","type":"BoxZoomTool"},{"attributes":{},"id":"21833","type":"DataRange1d"},{"attributes":{},"id":"21853","type":"ResetTool"},{"attributes":{"fill_color":{"value":"#1C9099"},"line_color":{"value":"#1C9099"},"line_width":{"value":2},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"21864","type":"Diamond"},{"attributes":{"data_source":{"id":"21863"},"glyph":{"id":"21864"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"21865"},"selection_glyph":null,"view":{"id":"21867"}},"id":"21866","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1C9099"},"line_alpha":{"value":0.1},"line_color":{"value":"#1C9099"},"line_width":{"value":2},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"21865","type":"Diamond"},{"attributes":{},"id":"21850","type":"WheelZoomTool"},{"attributes":{},"id":"21875","type":"Selection"},{"attributes":{},"id":"21854","type":"HelpTool"},{"attributes":{},"id":"21835","type":"DataRange1d"},{"attributes":{},"id":"21874","type":"UnionRenderers"},{"attributes":{"formatter":{"id":"21871"},"ticker":{"id":"21842"}},"id":"21841","type":"LinearAxis"},{"attributes":{},"id":"21842","type":"BasicTicker"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"21855","type":"BoxAnnotation"},{"attributes":{},"id":"21837","type":"LinearScale"},{"attributes":{"text":""},"id":"21868","type":"Title"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"21875"},"selection_policy":{"id":"21874"}},"id":"21863","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"21841"},"ticker":null},"id":"21844","type":"Grid"},{"attributes":{"formatter":{"id":"21873"},"ticker":{"id":"21846"}},"id":"21845","type":"LinearAxis"},{"attributes":{},"id":"21839","type":"LinearScale"},{"attributes":{},"id":"21849","type":"PanTool"}],"root_ids":["21832"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"871ff8cc-3c1d-46a4-be89-58dfc1d6667d","root_ids":["21832"],"roots":{"21832":"317e8779-a87b-4d3c-bfc9-531923cdd0cf"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();