(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("f2203aed-435b-4182-92fe-37f379c15fbd");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'f2203aed-435b-4182-92fe-37f379c15fbd' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"02034175-9a2e-4445-b56b-6e3f6b60951d":{"roots":{"references":[{"attributes":{"data_source":{"id":"19847"},"glyph":{"id":"19848"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"19849"},"selection_glyph":null,"view":{"id":"19851"}},"id":"19850","type":"GlyphRenderer"},{"attributes":{"fill_alpha":0.1,"fill_color":"#99d8c9","line_alpha":0.1,"line_color":"#99d8c9","x":{"field":"x"},"y":{"field":"y"}},"id":"19849","type":"Patch"},{"attributes":{"formatter":{"id":"19857"},"ticker":{"id":"19830"}},"id":"19829","type":"LinearAxis"},{"attributes":{},"id":"19817","type":"DataRange1d"},{"attributes":{},"id":"19837","type":"ResetTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"19833"},{"id":"19834"},{"id":"19835"},{"id":"19836"},{"id":"19837"},{"id":"19838"}]},"id":"19840","type":"Toolbar"},{"attributes":{"text":""},"id":"19852","type":"Title"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"19839","type":"BoxAnnotation"},{"attributes":{"formatter":{"id":"19855"},"ticker":{"id":"19826"}},"id":"19825","type":"LinearAxis"},{"attributes":{},"id":"19823","type":"LinearScale"},{"attributes":{"source":{"id":"19847"}},"id":"19851","type":"CDSView"},{"attributes":{"overlay":{"id":"19839"}},"id":"19835","type":"BoxZoomTool"},{"attributes":{},"id":"19858","type":"UnionRenderers"},{"attributes":{},"id":"19855","type":"BasicTickFormatter"},{"attributes":{},"id":"19821","type":"LinearScale"},{"attributes":{},"id":"19857","type":"BasicTickFormatter"},{"attributes":{},"id":"19836","type":"SaveTool"},{"attributes":{"axis":{"id":"19829"},"dimension":1,"ticker":null},"id":"19832","type":"Grid"},{"attributes":{},"id":"19819","type":"DataRange1d"},{"attributes":{},"id":"19830","type":"BasicTicker"},{"attributes":{},"id":"19838","type":"HelpTool"},{"attributes":{},"id":"19859","type":"Selection"},{"attributes":{},"id":"19834","type":"WheelZoomTool"},{"attributes":{"fill_color":"#99d8c9","line_color":"#99d8c9","x":{"field":"x"},"y":{"field":"y"}},"id":"19848","type":"Patch"},{"attributes":{},"id":"19833","type":"PanTool"},{"attributes":{},"id":"19826","type":"BasicTicker"},{"attributes":{"below":[{"id":"19825"}],"center":[{"id":"19828"},{"id":"19832"}],"left":[{"id":"19829"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"19850"}],"title":{"id":"19852"},"toolbar":{"id":"19840"},"x_range":{"id":"19817"},"x_scale":{"id":"19821"},"y_range":{"id":"19819"},"y_scale":{"id":"19823"}},"id":"19816","subtype":"Figure","type":"Plot"},{"attributes":{"data":{"x":[1,2,3,2],"y":[6,7,2,2]},"selected":{"id":"19859"},"selection_policy":{"id":"19858"}},"id":"19847","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"19825"},"ticker":null},"id":"19828","type":"Grid"}],"root_ids":["19816"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"02034175-9a2e-4445-b56b-6e3f6b60951d","root_ids":["19816"],"roots":{"19816":"f2203aed-435b-4182-92fe-37f379c15fbd"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();