(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("9251b4fa-9e40-4438-8396-2981c7be9751");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '9251b4fa-9e40-4438-8396-2981c7be9751' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"da565c89-95ca-4383-9cad-c99933b54f7e":{"roots":{"references":[{"attributes":{},"id":"22125","type":"LinearScale"},{"attributes":{},"id":"22140","type":"SaveTool"},{"attributes":{},"id":"22159","type":"BasicTickFormatter"},{"attributes":{},"id":"22138","type":"WheelZoomTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#CAB2D6"},"height":{"value":0.5},"line_alpha":{"value":0.1},"line_color":{"value":"#CAB2D6"},"right":{"field":"right"},"y":{"field":"y"}},"id":"22153","type":"HBar"},{"attributes":{},"id":"22130","type":"BasicTicker"},{"attributes":{"axis":{"id":"22133"},"dimension":1,"ticker":null},"id":"22136","type":"Grid"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"22143","type":"BoxAnnotation"},{"attributes":{},"id":"22163","type":"Selection"},{"attributes":{},"id":"22127","type":"LinearScale"},{"attributes":{},"id":"22121","type":"DataRange1d"},{"attributes":{"text":""},"id":"22156","type":"Title"},{"attributes":{},"id":"22137","type":"PanTool"},{"attributes":{"source":{"id":"22151"}},"id":"22155","type":"CDSView"},{"attributes":{},"id":"22142","type":"HelpTool"},{"attributes":{"formatter":{"id":"22159"},"ticker":{"id":"22130"}},"id":"22129","type":"LinearAxis"},{"attributes":{},"id":"22141","type":"ResetTool"},{"attributes":{},"id":"22162","type":"UnionRenderers"},{"attributes":{"axis":{"id":"22129"},"ticker":null},"id":"22132","type":"Grid"},{"attributes":{},"id":"22134","type":"BasicTicker"},{"attributes":{},"id":"22161","type":"BasicTickFormatter"},{"attributes":{"overlay":{"id":"22143"}},"id":"22139","type":"BoxZoomTool"},{"attributes":{"data":{"right":[1,2,3],"y":[1,2,3]},"selected":{"id":"22163"},"selection_policy":{"id":"22162"}},"id":"22151","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"22151"},"glyph":{"id":"22152"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"22153"},"selection_glyph":null,"view":{"id":"22155"}},"id":"22154","type":"GlyphRenderer"},{"attributes":{"below":[{"id":"22129"}],"center":[{"id":"22132"},{"id":"22136"}],"left":[{"id":"22133"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"22154"}],"title":{"id":"22156"},"toolbar":{"id":"22144"},"x_range":{"id":"22121"},"x_scale":{"id":"22125"},"y_range":{"id":"22123"},"y_scale":{"id":"22127"}},"id":"22120","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"22123","type":"DataRange1d"},{"attributes":{"fill_color":{"value":"#CAB2D6"},"height":{"value":0.5},"line_color":{"value":"#CAB2D6"},"right":{"field":"right"},"y":{"field":"y"}},"id":"22152","type":"HBar"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"22137"},{"id":"22138"},{"id":"22139"},{"id":"22140"},{"id":"22141"},{"id":"22142"}]},"id":"22144","type":"Toolbar"},{"attributes":{"formatter":{"id":"22161"},"ticker":{"id":"22134"}},"id":"22133","type":"LinearAxis"}],"root_ids":["22120"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"da565c89-95ca-4383-9cad-c99933b54f7e","root_ids":["22120"],"roots":{"22120":"9251b4fa-9e40-4438-8396-2981c7be9751"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();