(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("28e5d941-f22c-419f-95ba-e72bf42baa84");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '28e5d941-f22c-419f-95ba-e72bf42baa84' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"bfaf6875-4ef7-452f-af9b-b4e35c4971df":{"roots":{"references":[{"attributes":{"axis":{"id":"18759"},"dimension":1,"ticker":null},"id":"18762","type":"Grid"},{"attributes":{"text":""},"id":"18782","type":"Title"},{"attributes":{"axis":{"id":"18755"},"ticker":null},"id":"18758","type":"Grid"},{"attributes":{"data_source":{"id":"18777"},"glyph":{"id":"18778"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"18779"},"selection_glyph":null,"view":{"id":"18781"}},"id":"18780","type":"GlyphRenderer"},{"attributes":{},"id":"18753","type":"LinearScale"},{"attributes":{},"id":"18785","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"line_alpha":{"value":0.1},"line_color":{"value":"#386CB0"},"line_width":{"value":2},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18779","type":"DiamondCross"},{"attributes":{},"id":"18767","type":"ResetTool"},{"attributes":{"below":[{"id":"18755"}],"center":[{"id":"18758"},{"id":"18762"}],"left":[{"id":"18759"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"18780"}],"title":{"id":"18782"},"toolbar":{"id":"18770"},"x_range":{"id":"18747"},"x_scale":{"id":"18751"},"y_range":{"id":"18749"},"y_scale":{"id":"18753"}},"id":"18746","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"18760","type":"BasicTicker"},{"attributes":{"source":{"id":"18777"}},"id":"18781","type":"CDSView"},{"attributes":{},"id":"18756","type":"BasicTicker"},{"attributes":{"overlay":{"id":"18769"}},"id":"18765","type":"BoxZoomTool"},{"attributes":{},"id":"18787","type":"BasicTickFormatter"},{"attributes":{},"id":"18763","type":"PanTool"},{"attributes":{},"id":"18766","type":"SaveTool"},{"attributes":{},"id":"18747","type":"DataRange1d"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"18769","type":"BoxAnnotation"},{"attributes":{"formatter":{"id":"18785"},"ticker":{"id":"18756"}},"id":"18755","type":"LinearAxis"},{"attributes":{},"id":"18788","type":"UnionRenderers"},{"attributes":{},"id":"18764","type":"WheelZoomTool"},{"attributes":{},"id":"18768","type":"HelpTool"},{"attributes":{},"id":"18789","type":"Selection"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"18789"},"selection_policy":{"id":"18788"}},"id":"18777","type":"ColumnDataSource"},{"attributes":{},"id":"18749","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"18763"},{"id":"18764"},{"id":"18765"},{"id":"18766"},{"id":"18767"},{"id":"18768"}]},"id":"18770","type":"Toolbar"},{"attributes":{},"id":"18751","type":"LinearScale"},{"attributes":{"fill_color":{"value":null},"line_color":{"value":"#386CB0"},"line_width":{"value":2},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18778","type":"DiamondCross"},{"attributes":{"formatter":{"id":"18787"},"ticker":{"id":"18760"}},"id":"18759","type":"LinearAxis"}],"root_ids":["18746"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"bfaf6875-4ef7-452f-af9b-b4e35c4971df","root_ids":["18746"],"roots":{"18746":"28e5d941-f22c-419f-95ba-e72bf42baa84"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();