(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("628c2231-08a8-4450-b453-1ad5d4666b7d");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '628c2231-08a8-4450-b453-1ad5d4666b7d' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"f7b96f5b-7578-45c5-a431-2a6e5fce989a":{"roots":{"references":[{"attributes":{},"id":"24016","type":"BasicTicker"},{"attributes":{},"id":"24042","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"24033"},"glyph":{"id":"24034"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"24035"},"selection_glyph":null,"view":{"id":"24037"}},"id":"24036","type":"GlyphRenderer"},{"attributes":{"axis_label_standoff":10,"axis_label_text_color":"#E0E0E0","axis_label_text_font":"Helvetica","axis_label_text_font_size":"1.25em","axis_label_text_font_style":"normal","axis_line_alpha":0,"axis_line_color":"#E0E0E0","formatter":{"id":"24042"},"major_label_text_color":"#E0E0E0","major_label_text_font":"Helvetica","major_label_text_font_size":"1.025em","major_tick_line_alpha":0,"major_tick_line_color":"#E0E0E0","minor_tick_line_alpha":0,"minor_tick_line_color":"#E0E0E0","ticker":{"id":"24016"}},"id":"24015","type":"LinearAxis"},{"attributes":{"text":"dark_minimal","text_color":{"value":"#E0E0E0"},"text_font":"Helvetica","text_font_size":{"value":"1.15em"}},"id":"24001","type":"Title"},{"attributes":{},"id":"24020","type":"WheelZoomTool"},{"attributes":{},"id":"24043","type":"UnionRenderers"},{"attributes":{"axis":{"id":"24015"},"dimension":1,"grid_line_alpha":0.25,"grid_line_color":"#E0E0E0","ticker":null},"id":"24018","type":"Grid"},{"attributes":{"axis_label_standoff":10,"axis_label_text_color":"#E0E0E0","axis_label_text_font":"Helvetica","axis_label_text_font_size":"1.25em","axis_label_text_font_style":"normal","axis_line_alpha":0,"axis_line_color":"#E0E0E0","formatter":{"id":"24040"},"major_label_text_color":"#E0E0E0","major_label_text_font":"Helvetica","major_label_text_font_size":"1.025em","major_tick_line_alpha":0,"major_tick_line_color":"#E0E0E0","minor_tick_line_alpha":0,"minor_tick_line_color":"#E0E0E0","ticker":{"id":"24012"}},"id":"24011","type":"LinearAxis"},{"attributes":{},"id":"24003","type":"DataRange1d"},{"attributes":{"overlay":{"id":"24025"}},"id":"24021","type":"BoxZoomTool"},{"attributes":{},"id":"24009","type":"LinearScale"},{"attributes":{},"id":"24044","type":"Selection"},{"attributes":{"background_fill_color":"#20262B","below":[{"id":"24011"}],"border_fill_color":"#15191C","center":[{"id":"24014"},{"id":"24018"}],"left":[{"id":"24015"}],"outline_line_alpha":0.25,"outline_line_color":"#E0E0E0","plot_height":300,"plot_width":300,"renderers":[{"id":"24036"}],"title":{"id":"24001"},"toolbar":{"id":"24026"},"x_range":{"id":"24003"},"x_scale":{"id":"24007"},"y_range":{"id":"24005"},"y_scale":{"id":"24009"}},"id":"24000","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"24022","type":"SaveTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"24019"},{"id":"24020"},{"id":"24021"},{"id":"24022"},{"id":"24023"},{"id":"24024"}]},"id":"24026","type":"Toolbar"},{"attributes":{},"id":"24012","type":"BasicTicker"},{"attributes":{},"id":"24019","type":"PanTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"24025","type":"BoxAnnotation"},{"attributes":{},"id":"24040","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"24011"},"grid_line_alpha":0.25,"grid_line_color":"#E0E0E0","ticker":null},"id":"24014","type":"Grid"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"24035","type":"Line"},{"attributes":{},"id":"24024","type":"HelpTool"},{"attributes":{},"id":"24005","type":"DataRange1d"},{"attributes":{},"id":"24007","type":"LinearScale"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,6,4,5]},"selected":{"id":"24044"},"selection_policy":{"id":"24043"}},"id":"24033","type":"ColumnDataSource"},{"attributes":{"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"24034","type":"Line"},{"attributes":{},"id":"24023","type":"ResetTool"},{"attributes":{"source":{"id":"24033"}},"id":"24037","type":"CDSView"}],"root_ids":["24000"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"f7b96f5b-7578-45c5-a431-2a6e5fce989a","root_ids":["24000"],"roots":{"24000":"628c2231-08a8-4450-b453-1ad5d4666b7d"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();