(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("9ff02280-0066-49a1-aea8-5f59392217e7");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '9ff02280-0066-49a1-aea8-5f59392217e7' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"7aef74c1-fe98-4cb6-bd59-8cd543f30cef":{"roots":{"references":[{"attributes":{},"id":"23972","type":"BasicTickFormatter"},{"attributes":{"text":"caliber","text_color":{"value":"#5B5B5B"},"text_font":"Calibri Light","text_font_size":{"value":"1.25em"},"text_font_style":"bold"},"id":"23931","type":"Title"},{"attributes":{},"id":"23954","type":"HelpTool"},{"attributes":{"axis":{"id":"23945"},"dimension":1,"ticker":null},"id":"23948","type":"Grid"},{"attributes":{},"id":"23970","type":"BasicTickFormatter"},{"attributes":{},"id":"23974","type":"Selection"},{"attributes":{},"id":"23952","type":"SaveTool"},{"attributes":{},"id":"23935","type":"DataRange1d"},{"attributes":{},"id":"23950","type":"WheelZoomTool"},{"attributes":{"axis":{"id":"23941"},"ticker":null},"id":"23944","type":"Grid"},{"attributes":{"axis_label_standoff":10,"axis_label_text_color":"#5B5B5B","axis_label_text_font":"Calibri Light","axis_label_text_font_size":"1.15em","axis_label_text_font_style":"bold","axis_line_alpha":1,"axis_line_color":"#5B5B5B","formatter":{"id":"23970"},"major_label_text_color":"#5B5B5B","major_label_text_font":"Calibri Light","major_label_text_font_size":"0.95em","major_label_text_font_style":"bold","major_tick_in":0,"major_tick_line_alpha":0.25,"major_tick_line_color":"#5B5B5B","major_tick_out":3,"minor_tick_line_alpha":0.25,"minor_tick_line_color":"#5B5B5B","ticker":{"id":"23942"}},"id":"23941","type":"LinearAxis"},{"attributes":{},"id":"23939","type":"LinearScale"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"23955","type":"BoxAnnotation"},{"attributes":{"axis_label_standoff":10,"axis_label_text_color":"#5B5B5B","axis_label_text_font":"Calibri Light","axis_label_text_font_size":"1.15em","axis_label_text_font_style":"bold","axis_line_alpha":1,"axis_line_color":"#5B5B5B","formatter":{"id":"23972"},"major_label_text_color":"#5B5B5B","major_label_text_font":"Calibri Light","major_label_text_font_size":"0.95em","major_label_text_font_style":"bold","major_tick_in":0,"major_tick_line_alpha":0.25,"major_tick_line_color":"#5B5B5B","major_tick_out":3,"minor_tick_line_alpha":0.25,"minor_tick_line_color":"#5B5B5B","ticker":{"id":"23946"}},"id":"23945","type":"LinearAxis"},{"attributes":{},"id":"23942","type":"BasicTicker"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"23965","type":"Line"},{"attributes":{},"id":"23933","type":"DataRange1d"},{"attributes":{},"id":"23949","type":"PanTool"},{"attributes":{},"id":"23946","type":"BasicTicker"},{"attributes":{},"id":"23953","type":"ResetTool"},{"attributes":{},"id":"23937","type":"LinearScale"},{"attributes":{"source":{"id":"23963"}},"id":"23967","type":"CDSView"},{"attributes":{"data_source":{"id":"23963"},"glyph":{"id":"23964"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"23965"},"selection_glyph":null,"view":{"id":"23967"}},"id":"23966","type":"GlyphRenderer"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"23949"},{"id":"23950"},{"id":"23951"},{"id":"23952"},{"id":"23953"},{"id":"23954"}]},"id":"23956","type":"Toolbar"},{"attributes":{},"id":"23973","type":"UnionRenderers"},{"attributes":{"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"23964","type":"Line"},{"attributes":{"below":[{"id":"23941"}],"center":[{"id":"23944"},{"id":"23948"}],"left":[{"id":"23945"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"23966"}],"title":{"id":"23931"},"toolbar":{"id":"23956"},"x_range":{"id":"23933"},"x_scale":{"id":"23937"},"y_range":{"id":"23935"},"y_scale":{"id":"23939"}},"id":"23930","subtype":"Figure","type":"Plot"},{"attributes":{"overlay":{"id":"23955"}},"id":"23951","type":"BoxZoomTool"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,6,4,5]},"selected":{"id":"23974"},"selection_policy":{"id":"23973"}},"id":"23963","type":"ColumnDataSource"}],"root_ids":["23930"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"7aef74c1-fe98-4cb6-bd59-8cd543f30cef","root_ids":["23930"],"roots":{"23930":"9ff02280-0066-49a1-aea8-5f59392217e7"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();