(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("3718c860-7c7b-406e-bd6f-7587eb161247");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '3718c860-7c7b-406e-bd6f-7587eb161247' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"6409bb2d-d9ed-481b-b93a-a250a7707211":{"roots":{"references":[{"attributes":{"axis":{"id":"23707"},"dimension":1,"ticker":null},"id":"23710","type":"Grid"},{"attributes":{},"id":"23708","type":"BasicTicker"},{"attributes":{"below":[{"id":"23703"}],"center":[{"id":"23706"},{"id":"23710"}],"left":[{"id":"23707"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"23728"}],"title":{"id":"23730"},"toolbar":{"id":"23718"},"x_range":{"id":"23695"},"x_scale":{"id":"23699"},"y_range":{"id":"23697"},"y_scale":{"id":"23701"}},"id":"23694","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"23701","type":"LinearScale"},{"attributes":{},"id":"23697","type":"DataRange1d"},{"attributes":{},"id":"23737","type":"Selection"},{"attributes":{"formatter":{"id":"23735"},"ticker":{"id":"23708"}},"id":"23707","type":"LinearAxis"},{"attributes":{},"id":"23736","type":"UnionRenderers"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"23711"},{"id":"23712"},{"id":"23713"},{"id":"23714"},{"id":"23715"},{"id":"23716"}]},"id":"23718","type":"Toolbar"},{"attributes":{},"id":"23733","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"23737"},"selection_policy":{"id":"23736"}},"id":"23725","type":"ColumnDataSource"},{"attributes":{"end_angle":{"units":"rad","value":4.1},"fill_alpha":{"value":0.1},"fill_color":{"value":"#2b8cbe"},"line_alpha":{"value":0.1},"line_color":{"value":"#2b8cbe"},"radius":{"units":"screen","value":15},"start_angle":{"units":"rad","value":0.6},"x":{"field":"x"},"y":{"field":"y"}},"id":"23727","type":"Wedge"},{"attributes":{},"id":"23704","type":"BasicTicker"},{"attributes":{},"id":"23699","type":"LinearScale"},{"attributes":{"axis":{"id":"23703"},"ticker":null},"id":"23706","type":"Grid"},{"attributes":{},"id":"23715","type":"ResetTool"},{"attributes":{"source":{"id":"23725"}},"id":"23729","type":"CDSView"},{"attributes":{"overlay":{"id":"23717"}},"id":"23713","type":"BoxZoomTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"23717","type":"BoxAnnotation"},{"attributes":{},"id":"23714","type":"SaveTool"},{"attributes":{},"id":"23711","type":"PanTool"},{"attributes":{"end_angle":{"units":"rad","value":4.1},"fill_color":{"value":"#2b8cbe"},"line_color":{"value":"#2b8cbe"},"radius":{"units":"screen","value":15},"start_angle":{"units":"rad","value":0.6},"x":{"field":"x"},"y":{"field":"y"}},"id":"23726","type":"Wedge"},{"attributes":{"data_source":{"id":"23725"},"glyph":{"id":"23726"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"23727"},"selection_glyph":null,"view":{"id":"23729"}},"id":"23728","type":"GlyphRenderer"},{"attributes":{},"id":"23712","type":"WheelZoomTool"},{"attributes":{},"id":"23695","type":"DataRange1d"},{"attributes":{"formatter":{"id":"23733"},"ticker":{"id":"23704"}},"id":"23703","type":"LinearAxis"},{"attributes":{},"id":"23735","type":"BasicTickFormatter"},{"attributes":{},"id":"23716","type":"HelpTool"},{"attributes":{"text":""},"id":"23730","type":"Title"}],"root_ids":["23694"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"6409bb2d-d9ed-481b-b93a-a250a7707211","root_ids":["23694"],"roots":{"23694":"3718c860-7c7b-406e-bd6f-7587eb161247"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();