(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("76dad5af-2896-408e-830f-918b380c9c26");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '76dad5af-2896-408e-830f-918b380c9c26' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"9220d74e-ef1e-45ba-af28-05e28c59fffb":{"roots":{"references":[{"attributes":{},"id":"20406","type":"BasicTicker"},{"attributes":{},"id":"20402","type":"BasicTicker"},{"attributes":{},"id":"20409","type":"PanTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"line_alpha":{"value":0.1},"line_color":{"value":"#7FC97F"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20425","type":"SquareCross"},{"attributes":{},"id":"20433","type":"BasicTickFormatter"},{"attributes":{"text":""},"id":"20428","type":"Title"},{"attributes":{},"id":"20399","type":"LinearScale"},{"attributes":{},"id":"20434","type":"UnionRenderers"},{"attributes":{},"id":"20393","type":"DataRange1d"},{"attributes":{},"id":"20431","type":"BasicTickFormatter"},{"attributes":{},"id":"20414","type":"HelpTool"},{"attributes":{},"id":"20410","type":"WheelZoomTool"},{"attributes":{},"id":"20412","type":"SaveTool"},{"attributes":{"below":[{"id":"20401"}],"center":[{"id":"20404"},{"id":"20408"}],"left":[{"id":"20405"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"20426"}],"title":{"id":"20428"},"toolbar":{"id":"20416"},"x_range":{"id":"20393"},"x_scale":{"id":"20397"},"y_range":{"id":"20395"},"y_scale":{"id":"20399"}},"id":"20392","subtype":"Figure","type":"Plot"},{"attributes":{"overlay":{"id":"20415"}},"id":"20411","type":"BoxZoomTool"},{"attributes":{"data":{"size":[10,20,25],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"20435"},"selection_policy":{"id":"20434"}},"id":"20423","type":"ColumnDataSource"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"20409"},{"id":"20410"},{"id":"20411"},{"id":"20412"},{"id":"20413"},{"id":"20414"}]},"id":"20416","type":"Toolbar"},{"attributes":{"axis":{"id":"20405"},"dimension":1,"ticker":null},"id":"20408","type":"Grid"},{"attributes":{"formatter":{"id":"20433"},"ticker":{"id":"20406"}},"id":"20405","type":"LinearAxis"},{"attributes":{"axis":{"id":"20401"},"ticker":null},"id":"20404","type":"Grid"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"20415","type":"BoxAnnotation"},{"attributes":{"formatter":{"id":"20431"},"ticker":{"id":"20402"}},"id":"20401","type":"LinearAxis"},{"attributes":{"fill_color":{"value":null},"line_color":{"value":"#7FC97F"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20424","type":"SquareCross"},{"attributes":{},"id":"20397","type":"LinearScale"},{"attributes":{},"id":"20413","type":"ResetTool"},{"attributes":{"source":{"id":"20423"}},"id":"20427","type":"CDSView"},{"attributes":{},"id":"20435","type":"Selection"},{"attributes":{"data_source":{"id":"20423"},"glyph":{"id":"20424"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"20425"},"selection_glyph":null,"view":{"id":"20427"}},"id":"20426","type":"GlyphRenderer"},{"attributes":{},"id":"20395","type":"DataRange1d"}],"root_ids":["20392"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"9220d74e-ef1e-45ba-af28-05e28c59fffb","root_ids":["20392"],"roots":{"20392":"76dad5af-2896-408e-830f-918b380c9c26"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();