(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("f354ae13-b4da-4505-8f85-f647fdd9b6da");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'f354ae13-b4da-4505-8f85-f647fdd9b6da' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"756e259c-564b-4e94-8ceb-7f9a40879fc2":{"roots":{"references":[{"attributes":{"formatter":{"id":"20575"},"ticker":{"id":"20546"}},"id":"20545","type":"LinearAxis"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"line_alpha":{"value":0.1},"line_color":{"value":"#7FC97F"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20569","type":"SquarePin"},{"attributes":{},"id":"20578","type":"UnionRenderers"},{"attributes":{},"id":"20541","type":"LinearScale"},{"attributes":{},"id":"20537","type":"DataRange1d"},{"attributes":{},"id":"20575","type":"BasicTickFormatter"},{"attributes":{},"id":"20550","type":"BasicTicker"},{"attributes":{"source":{"id":"20567"}},"id":"20571","type":"CDSView"},{"attributes":{"fill_color":{"value":null},"line_color":{"value":"#7FC97F"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20568","type":"SquarePin"},{"attributes":{},"id":"20577","type":"BasicTickFormatter"},{"attributes":{},"id":"20557","type":"ResetTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"20553"},{"id":"20554"},{"id":"20555"},{"id":"20556"},{"id":"20557"},{"id":"20558"}]},"id":"20560","type":"Toolbar"},{"attributes":{"formatter":{"id":"20577"},"ticker":{"id":"20550"}},"id":"20549","type":"LinearAxis"},{"attributes":{},"id":"20539","type":"DataRange1d"},{"attributes":{},"id":"20543","type":"LinearScale"},{"attributes":{},"id":"20579","type":"Selection"},{"attributes":{"overlay":{"id":"20559"}},"id":"20555","type":"BoxZoomTool"},{"attributes":{},"id":"20556","type":"SaveTool"},{"attributes":{},"id":"20546","type":"BasicTicker"},{"attributes":{},"id":"20553","type":"PanTool"},{"attributes":{"data":{"size":[10,20,25],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"20579"},"selection_policy":{"id":"20578"}},"id":"20567","type":"ColumnDataSource"},{"attributes":{},"id":"20558","type":"HelpTool"},{"attributes":{"text":""},"id":"20572","type":"Title"},{"attributes":{},"id":"20554","type":"WheelZoomTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"20559","type":"BoxAnnotation"},{"attributes":{"axis":{"id":"20545"},"ticker":null},"id":"20548","type":"Grid"},{"attributes":{"data_source":{"id":"20567"},"glyph":{"id":"20568"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"20569"},"selection_glyph":null,"view":{"id":"20571"}},"id":"20570","type":"GlyphRenderer"},{"attributes":{"axis":{"id":"20549"},"dimension":1,"ticker":null},"id":"20552","type":"Grid"},{"attributes":{"below":[{"id":"20545"}],"center":[{"id":"20548"},{"id":"20552"}],"left":[{"id":"20549"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"20570"}],"title":{"id":"20572"},"toolbar":{"id":"20560"},"x_range":{"id":"20537"},"x_scale":{"id":"20541"},"y_range":{"id":"20539"},"y_scale":{"id":"20543"}},"id":"20536","subtype":"Figure","type":"Plot"}],"root_ids":["20536"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"756e259c-564b-4e94-8ceb-7f9a40879fc2","root_ids":["20536"],"roots":{"20536":"f354ae13-b4da-4505-8f85-f647fdd9b6da"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();