(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("dc5738d7-9a85-4291-aa7e-a5ba44733920");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'dc5738d7-9a85-4291-aa7e-a5ba44733920' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"a4e404ec-6ff9-4037-8ae1-c70db7e7879c":{"roots":{"references":[{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"20003"},"selection_policy":{"id":"20002"}},"id":"19991","type":"ColumnDataSource"},{"attributes":{},"id":"19980","type":"SaveTool"},{"attributes":{"formatter":{"id":"19999"},"ticker":{"id":"19970"}},"id":"19969","type":"LinearAxis"},{"attributes":{},"id":"19963","type":"DataRange1d"},{"attributes":{},"id":"19974","type":"BasicTicker"},{"attributes":{},"id":"20002","type":"UnionRenderers"},{"attributes":{},"id":"19977","type":"PanTool"},{"attributes":{"overlay":{"id":"19983"}},"id":"19979","type":"BoxZoomTool"},{"attributes":{"fill_color":{"value":"#DE2D26"},"line_color":{"value":"#DE2D26"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"19992","type":"Plus"},{"attributes":{"source":{"id":"19991"}},"id":"19995","type":"CDSView"},{"attributes":{"data_source":{"id":"19991"},"glyph":{"id":"19992"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"19993"},"selection_glyph":null,"view":{"id":"19995"}},"id":"19994","type":"GlyphRenderer"},{"attributes":{"axis":{"id":"19973"},"dimension":1,"ticker":null},"id":"19976","type":"Grid"},{"attributes":{},"id":"19999","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"19969"},"ticker":null},"id":"19972","type":"Grid"},{"attributes":{},"id":"20003","type":"Selection"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"19977"},{"id":"19978"},{"id":"19979"},{"id":"19980"},{"id":"19981"},{"id":"19982"}]},"id":"19984","type":"Toolbar"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#DE2D26"},"line_alpha":{"value":0.1},"line_color":{"value":"#DE2D26"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"19993","type":"Plus"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"19983","type":"BoxAnnotation"},{"attributes":{"formatter":{"id":"20001"},"ticker":{"id":"19974"}},"id":"19973","type":"LinearAxis"},{"attributes":{},"id":"19978","type":"WheelZoomTool"},{"attributes":{},"id":"19982","type":"HelpTool"},{"attributes":{"below":[{"id":"19969"}],"center":[{"id":"19972"},{"id":"19976"}],"left":[{"id":"19973"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"19994"}],"title":{"id":"19996"},"toolbar":{"id":"19984"},"x_range":{"id":"19961"},"x_scale":{"id":"19965"},"y_range":{"id":"19963"},"y_scale":{"id":"19967"}},"id":"19960","subtype":"Figure","type":"Plot"},{"attributes":{"text":""},"id":"19996","type":"Title"},{"attributes":{},"id":"19961","type":"DataRange1d"},{"attributes":{},"id":"19981","type":"ResetTool"},{"attributes":{},"id":"20001","type":"BasicTickFormatter"},{"attributes":{},"id":"19965","type":"LinearScale"},{"attributes":{},"id":"19967","type":"LinearScale"},{"attributes":{},"id":"19970","type":"BasicTicker"}],"root_ids":["19960"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"a4e404ec-6ff9-4037-8ae1-c70db7e7879c","root_ids":["19960"],"roots":{"19960":"dc5738d7-9a85-4291-aa7e-a5ba44733920"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();