(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("9c22b02a-6712-4373-96d8-d8be5565a330");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '9c22b02a-6712-4373-96d8-d8be5565a330' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"c44fddb2-a9f9-4162-bb53-92c6b98102e0":{"roots":{"references":[{"attributes":{},"id":"19192","type":"BasicTicker"},{"attributes":{"formatter":{"id":"19219"},"ticker":{"id":"19192"}},"id":"19191","type":"LinearAxis"},{"attributes":{"source":{"id":"19209"}},"id":"19213","type":"CDSView"},{"attributes":{},"id":"19185","type":"LinearScale"},{"attributes":{"axis":{"id":"19187"},"ticker":null},"id":"19190","type":"Grid"},{"attributes":{},"id":"19181","type":"DataRange1d"},{"attributes":{},"id":"19199","type":"ResetTool"},{"attributes":{"axis":{"id":"19191"},"dimension":1,"ticker":null},"id":"19194","type":"Grid"},{"attributes":{},"id":"19200","type":"HelpTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#74ADD1"},"line_alpha":{"value":0.1},"line_color":{"value":"#74ADD1"},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"19211","type":"Hex"},{"attributes":{},"id":"19219","type":"BasicTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"19195"},{"id":"19196"},{"id":"19197"},{"id":"19198"},{"id":"19199"},{"id":"19200"}]},"id":"19202","type":"Toolbar"},{"attributes":{"below":[{"id":"19187"}],"center":[{"id":"19190"},{"id":"19194"}],"left":[{"id":"19191"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"19212"}],"title":{"id":"19214"},"toolbar":{"id":"19202"},"x_range":{"id":"19179"},"x_scale":{"id":"19183"},"y_range":{"id":"19181"},"y_scale":{"id":"19185"}},"id":"19178","subtype":"Figure","type":"Plot"},{"attributes":{"overlay":{"id":"19201"}},"id":"19197","type":"BoxZoomTool"},{"attributes":{"fill_color":{"value":"#74ADD1"},"line_color":{"value":"#74ADD1"},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"19210","type":"Hex"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"19201","type":"BoxAnnotation"},{"attributes":{"data_source":{"id":"19209"},"glyph":{"id":"19210"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"19211"},"selection_glyph":null,"view":{"id":"19213"}},"id":"19212","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"19217"},"ticker":{"id":"19188"}},"id":"19187","type":"LinearAxis"},{"attributes":{},"id":"19179","type":"DataRange1d"},{"attributes":{},"id":"19195","type":"PanTool"},{"attributes":{},"id":"19183","type":"LinearScale"},{"attributes":{},"id":"19198","type":"SaveTool"},{"attributes":{},"id":"19188","type":"BasicTicker"},{"attributes":{"data":{"size":[10,20,30],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"19221"},"selection_policy":{"id":"19220"}},"id":"19209","type":"ColumnDataSource"},{"attributes":{},"id":"19221","type":"Selection"},{"attributes":{},"id":"19196","type":"WheelZoomTool"},{"attributes":{},"id":"19217","type":"BasicTickFormatter"},{"attributes":{"text":""},"id":"19214","type":"Title"},{"attributes":{},"id":"19220","type":"UnionRenderers"}],"root_ids":["19178"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"c44fddb2-a9f9-4162-bb53-92c6b98102e0","root_ids":["19178"],"roots":{"19178":"9c22b02a-6712-4373-96d8-d8be5565a330"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();