(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("6da37f39-a525-48ed-8f66-1f6cd6eb493d");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '6da37f39-a525-48ed-8f66-1f6cd6eb493d' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"36b3988a-8a5e-4eed-9779-650d4643c551":{"roots":{"references":[{"attributes":{"axis":{"id":"22987"},"dimension":1,"ticker":null},"id":"22990","type":"Grid"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"22991"},{"id":"22992"},{"id":"22993"},{"id":"22994"},{"id":"22995"},{"id":"22996"}]},"id":"22998","type":"Toolbar"},{"attributes":{"axis":{"id":"22983"},"ticker":null},"id":"22986","type":"Grid"},{"attributes":{},"id":"22975","type":"DataRange1d"},{"attributes":{"formatter":{"id":"23013"},"ticker":{"id":"22984"}},"id":"22983","type":"LinearAxis"},{"attributes":{},"id":"22991","type":"PanTool"},{"attributes":{},"id":"22979","type":"LinearScale"},{"attributes":{"data_source":{"id":"23005"},"glyph":{"id":"23006"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"23007"},"selection_glyph":null,"view":{"id":"23009"}},"id":"23008","type":"GlyphRenderer"},{"attributes":{},"id":"22995","type":"ResetTool"},{"attributes":{},"id":"23016","type":"UnionRenderers"},{"attributes":{"below":[{"id":"22983"}],"center":[{"id":"22986"},{"id":"22990"}],"left":[{"id":"22987"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"23008"}],"title":{"id":"23010"},"toolbar":{"id":"22998"},"x_range":{"id":"22975"},"x_scale":{"id":"22979"},"y_range":{"id":"22977"},"y_scale":{"id":"22981"}},"id":"22974","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"23015","type":"BasicTickFormatter"},{"attributes":{},"id":"22994","type":"SaveTool"},{"attributes":{},"id":"23013","type":"BasicTickFormatter"},{"attributes":{},"id":"22977","type":"DataRange1d"},{"attributes":{},"id":"23017","type":"Selection"},{"attributes":{"formatter":{"id":"23015"},"ticker":{"id":"22988"}},"id":"22987","type":"LinearAxis"},{"attributes":{},"id":"22988","type":"BasicTicker"},{"attributes":{},"id":"22981","type":"LinearScale"},{"attributes":{"angle":{"units":"rad","value":-0.7},"length":{"units":"data","value":45},"line_color":{"value":"#FB8072"},"line_width":{"value":2},"x":{"field":"x"},"y":{"field":"y"}},"id":"23006","type":"Ray"},{"attributes":{"overlay":{"id":"22997"}},"id":"22993","type":"BoxZoomTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"22997","type":"BoxAnnotation"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"23017"},"selection_policy":{"id":"23016"}},"id":"23005","type":"ColumnDataSource"},{"attributes":{"source":{"id":"23005"}},"id":"23009","type":"CDSView"},{"attributes":{},"id":"22996","type":"HelpTool"},{"attributes":{},"id":"22992","type":"WheelZoomTool"},{"attributes":{},"id":"22984","type":"BasicTicker"},{"attributes":{"angle":{"units":"rad","value":-0.7},"length":{"units":"data","value":45},"line_alpha":{"value":0.1},"line_color":{"value":"#FB8072"},"line_width":{"value":2},"x":{"field":"x"},"y":{"field":"y"}},"id":"23007","type":"Ray"},{"attributes":{"text":""},"id":"23010","type":"Title"}],"root_ids":["22974"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"36b3988a-8a5e-4eed-9779-650d4643c551","root_ids":["22974"],"roots":{"22974":"6da37f39-a525-48ed-8f66-1f6cd6eb493d"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();