(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("40346d0a-ee4f-463e-a47c-deb74d018931");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '40346d0a-ee4f-463e-a47c-deb74d018931' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"26e5fd1f-be7b-434b-b60b-3d6fe3363e39":{"roots":{"references":[{"attributes":{"data_source":{"id":"19563"},"glyph":{"id":"19564"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"19565"},"selection_glyph":null,"view":{"id":"19567"}},"id":"19566","type":"GlyphRenderer"},{"attributes":{},"id":"19533","type":"DataRange1d"},{"attributes":{},"id":"19549","type":"PanTool"},{"attributes":{},"id":"19550","type":"WheelZoomTool"},{"attributes":{"text":"line"},"id":"19531","type":"Title"},{"attributes":{},"id":"19537","type":"LinearScale"},{"attributes":{},"id":"19552","type":"SaveTool"},{"attributes":{},"id":"19572","type":"BasicTickFormatter"},{"attributes":{},"id":"19535","type":"DataRange1d"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,2,4,5]},"selected":{"id":"19574"},"selection_policy":{"id":"19573"}},"id":"19563","type":"ColumnDataSource"},{"attributes":{"below":[{"id":"19541"}],"center":[{"id":"19544"},{"id":"19548"}],"left":[{"id":"19545"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"19566"}],"title":{"id":"19531"},"toolbar":{"id":"19556"},"x_range":{"id":"19533"},"x_scale":{"id":"19537"},"y_range":{"id":"19535"},"y_scale":{"id":"19539"}},"id":"19530","subtype":"Figure","type":"Plot"},{"attributes":{"overlay":{"id":"19555"}},"id":"19551","type":"BoxZoomTool"},{"attributes":{"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"19564","type":"Line"},{"attributes":{},"id":"19570","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"19563"}},"id":"19567","type":"CDSView"},{"attributes":{"formatter":{"id":"19572"},"ticker":{"id":"19546"}},"id":"19545","type":"LinearAxis"},{"attributes":{},"id":"19553","type":"ResetTool"},{"attributes":{"axis":{"id":"19545"},"dimension":1,"ticker":null},"id":"19548","type":"Grid"},{"attributes":{},"id":"19542","type":"BasicTicker"},{"attributes":{"axis":{"id":"19541"},"ticker":null},"id":"19544","type":"Grid"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"19565","type":"Line"},{"attributes":{},"id":"19546","type":"BasicTicker"},{"attributes":{},"id":"19573","type":"UnionRenderers"},{"attributes":{},"id":"19539","type":"LinearScale"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"19555","type":"BoxAnnotation"},{"attributes":{"formatter":{"id":"19570"},"ticker":{"id":"19542"}},"id":"19541","type":"LinearAxis"},{"attributes":{},"id":"19574","type":"Selection"},{"attributes":{},"id":"19554","type":"HelpTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"19549"},{"id":"19550"},{"id":"19551"},{"id":"19552"},{"id":"19553"},{"id":"19554"}]},"id":"19556","type":"Toolbar"}],"root_ids":["19530"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"26e5fd1f-be7b-434b-b60b-3d6fe3363e39","root_ids":["19530"],"roots":{"19530":"40346d0a-ee4f-463e-a47c-deb74d018931"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();