(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("f5787acc-0de5-4236-9c29-c7d1f86f779b");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'f5787acc-0de5-4236-9c29-c7d1f86f779b' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"b30bcd35-832f-4f6a-8477-8751c99bb369":{"roots":{"references":[{"attributes":{"axis":{"id":"24085"},"dimension":1,"ticker":null},"id":"24088","type":"Grid"},{"attributes":{"axis":{"id":"24081"},"ticker":null},"id":"24084","type":"Grid"},{"attributes":{},"id":"24079","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"24089"},{"id":"24090"},{"id":"24091"},{"id":"24092"},{"id":"24093"},{"id":"24094"}]},"id":"24096","type":"Toolbar"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,6,4,5]},"selected":{"id":"24114"},"selection_policy":{"id":"24113"}},"id":"24103","type":"ColumnDataSource"},{"attributes":{"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"24104","type":"Line"},{"attributes":{},"id":"24092","type":"SaveTool"},{"attributes":{"axis_label_standoff":10,"axis_label_text_color":"#5B5B5B","axis_label_text_font":"Calibri Light","axis_label_text_font_size":"1.15em","axis_label_text_font_style":"bold","axis_line_alpha":1,"axis_line_color":"#5B5B5B","formatter":{"id":"24110"},"major_label_text_color":"#5B5B5B","major_label_text_font":"Calibri Light","major_label_text_font_size":"0.95em","major_label_text_font_style":"bold","major_tick_in":0,"major_tick_line_alpha":0.25,"major_tick_line_color":"#5B5B5B","major_tick_out":3,"minor_tick_line_alpha":0.25,"minor_tick_line_color":"#5B5B5B","ticker":{"id":"24082"}},"id":"24081","type":"LinearAxis"},{"attributes":{},"id":"24082","type":"BasicTicker"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"24095","type":"BoxAnnotation"},{"attributes":{},"id":"24114","type":"Selection"},{"attributes":{},"id":"24094","type":"HelpTool"},{"attributes":{},"id":"24112","type":"BasicTickFormatter"},{"attributes":{},"id":"24086","type":"BasicTicker"},{"attributes":{},"id":"24093","type":"ResetTool"},{"attributes":{},"id":"24113","type":"UnionRenderers"},{"attributes":{},"id":"24089","type":"PanTool"},{"attributes":{"below":[{"id":"24081"}],"center":[{"id":"24084"},{"id":"24088"}],"left":[{"id":"24085"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"24106"}],"title":{"id":"24071"},"toolbar":{"id":"24096"},"x_range":{"id":"24073"},"x_scale":{"id":"24077"},"y_range":{"id":"24075"},"y_scale":{"id":"24079"}},"id":"24070","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"24073","type":"DataRange1d"},{"attributes":{},"id":"24110","type":"BasicTickFormatter"},{"attributes":{"overlay":{"id":"24095"}},"id":"24091","type":"BoxZoomTool"},{"attributes":{"data_source":{"id":"24103"},"glyph":{"id":"24104"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"24105"},"selection_glyph":null,"view":{"id":"24107"}},"id":"24106","type":"GlyphRenderer"},{"attributes":{"axis_label_standoff":10,"axis_label_text_color":"#5B5B5B","axis_label_text_font":"Calibri Light","axis_label_text_font_size":"1.15em","axis_label_text_font_style":"bold","axis_line_alpha":1,"axis_line_color":"#5B5B5B","formatter":{"id":"24112"},"major_label_text_color":"#5B5B5B","major_label_text_font":"Calibri Light","major_label_text_font_size":"0.95em","major_label_text_font_style":"bold","major_tick_in":0,"major_tick_line_alpha":0.25,"major_tick_line_color":"#5B5B5B","major_tick_out":3,"minor_tick_line_alpha":0.25,"minor_tick_line_color":"#5B5B5B","ticker":{"id":"24086"}},"id":"24085","type":"LinearAxis"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"24105","type":"Line"},{"attributes":{},"id":"24077","type":"LinearScale"},{"attributes":{"source":{"id":"24103"}},"id":"24107","type":"CDSView"},{"attributes":{},"id":"24090","type":"WheelZoomTool"},{"attributes":{},"id":"24075","type":"DataRange1d"},{"attributes":{"text":"light_minimal","text_color":{"value":"#5B5B5B"},"text_font":"Calibri Light","text_font_size":{"value":"1.25em"},"text_font_style":"bold"},"id":"24071","type":"Title"}],"root_ids":["24070"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"b30bcd35-832f-4f6a-8477-8751c99bb369","root_ids":["24070"],"roots":{"24070":"f5787acc-0de5-4236-9c29-c7d1f86f779b"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();