(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("71adf13e-27a8-4956-93f4-3140fb64dfff");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '71adf13e-27a8-4956-93f4-3140fb64dfff' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"7550feaf-c6a5-4e20-9715-801e72fb13c0":{"roots":{"references":[{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"18043"},{"id":"18044"},{"id":"18045"},{"id":"18046"},{"id":"18047"},{"id":"18048"}]},"id":"18050","type":"Toolbar"},{"attributes":{},"id":"18029","type":"DataRange1d"},{"attributes":{"below":[{"id":"18035"}],"center":[{"id":"18038"},{"id":"18042"}],"left":[{"id":"18039"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"18060"}],"title":{"id":"18062"},"toolbar":{"id":"18050"},"x_range":{"id":"18027"},"x_scale":{"id":"18031"},"y_range":{"id":"18029"},"y_scale":{"id":"18033"}},"id":"18026","subtype":"Figure","type":"Plot"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#7FC97F"},"inner_radius":{"units":"data","value":0.2},"line_alpha":{"value":0.1},"line_color":{"value":"#7FC97F"},"outer_radius":{"units":"data","value":0.5},"x":{"field":"x"},"y":{"field":"y"}},"id":"18059","type":"Annulus"},{"attributes":{},"id":"18048","type":"HelpTool"},{"attributes":{},"id":"18047","type":"ResetTool"},{"attributes":{},"id":"18031","type":"LinearScale"},{"attributes":{"axis":{"id":"18039"},"dimension":1,"ticker":null},"id":"18042","type":"Grid"},{"attributes":{"formatter":{"id":"18065"},"ticker":{"id":"18036"}},"id":"18035","type":"LinearAxis"},{"attributes":{},"id":"18036","type":"BasicTicker"},{"attributes":{"formatter":{"id":"18067"},"ticker":{"id":"18040"}},"id":"18039","type":"LinearAxis"},{"attributes":{},"id":"18044","type":"WheelZoomTool"},{"attributes":{"source":{"id":"18057"}},"id":"18061","type":"CDSView"},{"attributes":{},"id":"18033","type":"LinearScale"},{"attributes":{"text":""},"id":"18062","type":"Title"},{"attributes":{},"id":"18040","type":"BasicTicker"},{"attributes":{"axis":{"id":"18035"},"ticker":null},"id":"18038","type":"Grid"},{"attributes":{},"id":"18067","type":"BasicTickFormatter"},{"attributes":{},"id":"18046","type":"SaveTool"},{"attributes":{},"id":"18065","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"18057"},"glyph":{"id":"18058"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"18059"},"selection_glyph":null,"view":{"id":"18061"}},"id":"18060","type":"GlyphRenderer"},{"attributes":{"overlay":{"id":"18049"}},"id":"18045","type":"BoxZoomTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"18049","type":"BoxAnnotation"},{"attributes":{"fill_color":{"value":"#7FC97F"},"inner_radius":{"units":"data","value":0.2},"line_color":{"value":"#7FC97F"},"outer_radius":{"units":"data","value":0.5},"x":{"field":"x"},"y":{"field":"y"}},"id":"18058","type":"Annulus"},{"attributes":{},"id":"18068","type":"UnionRenderers"},{"attributes":{},"id":"18043","type":"PanTool"},{"attributes":{},"id":"18069","type":"Selection"},{"attributes":{},"id":"18027","type":"DataRange1d"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"18069"},"selection_policy":{"id":"18068"}},"id":"18057","type":"ColumnDataSource"}],"root_ids":["18026"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"7550feaf-c6a5-4e20-9715-801e72fb13c0","root_ids":["18026"],"roots":{"18026":"71adf13e-27a8-4956-93f4-3140fb64dfff"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();