(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("f1986a85-0e5d-46de-8235-f5cff31a500e");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'f1986a85-0e5d-46de-8235-f5cff31a500e' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"6733fcbb-7a30-4a14-9d23-a3dd1d0d2c36":{"roots":{"references":[{"attributes":{},"id":"22920","type":"WheelZoomTool"},{"attributes":{},"id":"22944","type":"UnionRenderers"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":"#B3DE69"},"left":{"field":"left"},"line_color":{"value":"#B3DE69"},"right":{"field":"right"},"top":{"field":"top"}},"id":"22934","type":"Quad"},{"attributes":{},"id":"22924","type":"HelpTool"},{"attributes":{},"id":"22912","type":"BasicTicker"},{"attributes":{},"id":"22903","type":"DataRange1d"},{"attributes":{},"id":"22909","type":"LinearScale"},{"attributes":{},"id":"22941","type":"BasicTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"22919"},{"id":"22920"},{"id":"22921"},{"id":"22922"},{"id":"22923"},{"id":"22924"}]},"id":"22926","type":"Toolbar"},{"attributes":{"data_source":{"id":"22933"},"glyph":{"id":"22934"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"22935"},"selection_glyph":null,"view":{"id":"22937"}},"id":"22936","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"22943"},"ticker":{"id":"22916"}},"id":"22915","type":"LinearAxis"},{"attributes":{"text":""},"id":"22938","type":"Title"},{"attributes":{"overlay":{"id":"22925"}},"id":"22921","type":"BoxZoomTool"},{"attributes":{"data":{"bottom":[1,2,3],"left":[1,2,3],"right":[1.2,2.5,3.7],"top":[2,3,4]},"selected":{"id":"22945"},"selection_policy":{"id":"22944"}},"id":"22933","type":"ColumnDataSource"},{"attributes":{"below":[{"id":"22911"}],"center":[{"id":"22914"},{"id":"22918"}],"left":[{"id":"22915"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"22936"}],"title":{"id":"22938"},"toolbar":{"id":"22926"},"x_range":{"id":"22903"},"x_scale":{"id":"22907"},"y_range":{"id":"22905"},"y_scale":{"id":"22909"}},"id":"22902","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"22919","type":"PanTool"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#B3DE69"},"left":{"field":"left"},"line_alpha":{"value":0.1},"line_color":{"value":"#B3DE69"},"right":{"field":"right"},"top":{"field":"top"}},"id":"22935","type":"Quad"},{"attributes":{},"id":"22943","type":"BasicTickFormatter"},{"attributes":{},"id":"22922","type":"SaveTool"},{"attributes":{"source":{"id":"22933"}},"id":"22937","type":"CDSView"},{"attributes":{},"id":"22916","type":"BasicTicker"},{"attributes":{},"id":"22907","type":"LinearScale"},{"attributes":{"axis":{"id":"22911"},"ticker":null},"id":"22914","type":"Grid"},{"attributes":{},"id":"22923","type":"ResetTool"},{"attributes":{},"id":"22945","type":"Selection"},{"attributes":{"formatter":{"id":"22941"},"ticker":{"id":"22912"}},"id":"22911","type":"LinearAxis"},{"attributes":{},"id":"22905","type":"DataRange1d"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"22925","type":"BoxAnnotation"},{"attributes":{"axis":{"id":"22915"},"dimension":1,"ticker":null},"id":"22918","type":"Grid"}],"root_ids":["22902"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"6733fcbb-7a30-4a14-9d23-a3dd1d0d2c36","root_ids":["22902"],"roots":{"22902":"f1986a85-0e5d-46de-8235-f5cff31a500e"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();