(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("5fef72ee-29d4-4804-a4c9-987a050c42fd");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '5fef72ee-29d4-4804-a4c9-987a050c42fd' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"01ce9e7d-5f6a-4ab2-97af-a12cba6c6084":{"roots":{"references":[{"attributes":{},"id":"19340","type":"WheelZoomTool"},{"attributes":{},"id":"19327","type":"LinearScale"},{"attributes":{"text":""},"id":"19358","type":"Title"},{"attributes":{},"id":"19339","type":"PanTool"},{"attributes":{"formatter":{"id":"19363"},"ticker":{"id":"19336"}},"id":"19335","type":"LinearAxis"},{"attributes":{"fill_color":{"value":"#74ADD1"},"line_color":{"value":"#1f77b4"},"q":{"field":"q"},"r":{"field":"r"}},"id":"19354","type":"HexTile"},{"attributes":{},"id":"19336","type":"BasicTicker"},{"attributes":{},"id":"19332","type":"BasicTicker"},{"attributes":{"formatter":{"id":"19361"},"ticker":{"id":"19332"}},"id":"19331","type":"LinearAxis"},{"attributes":{},"id":"19365","type":"Selection"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"19345","type":"BoxAnnotation"},{"attributes":{"axis":{"id":"19331"},"ticker":null},"id":"19334","type":"Grid"},{"attributes":{},"id":"19323","type":"DataRange1d"},{"attributes":{"overlay":{"id":"19345"}},"id":"19341","type":"BoxZoomTool"},{"attributes":{},"id":"19344","type":"HelpTool"},{"attributes":{"data":{"q":[1,2,2],"r":[0,0,1]},"selected":{"id":"19365"},"selection_policy":{"id":"19364"}},"id":"19353","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"19335"},"dimension":1,"ticker":null},"id":"19338","type":"Grid"},{"attributes":{},"id":"19342","type":"SaveTool"},{"attributes":{},"id":"19329","type":"LinearScale"},{"attributes":{"source":{"id":"19353"}},"id":"19357","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#74ADD1"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"q":{"field":"q"},"r":{"field":"r"}},"id":"19355","type":"HexTile"},{"attributes":{},"id":"19343","type":"ResetTool"},{"attributes":{"data_source":{"id":"19353"},"glyph":{"id":"19354"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"19355"},"selection_glyph":null,"view":{"id":"19357"}},"id":"19356","type":"GlyphRenderer"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"19339"},{"id":"19340"},{"id":"19341"},{"id":"19342"},{"id":"19343"},{"id":"19344"}]},"id":"19346","type":"Toolbar"},{"attributes":{},"id":"19325","type":"DataRange1d"},{"attributes":{},"id":"19363","type":"BasicTickFormatter"},{"attributes":{},"id":"19364","type":"UnionRenderers"},{"attributes":{},"id":"19361","type":"BasicTickFormatter"},{"attributes":{"below":[{"id":"19331"}],"center":[{"id":"19334"},{"id":"19338"}],"left":[{"id":"19335"}],"match_aspect":true,"plot_height":300,"plot_width":300,"renderers":[{"id":"19356"}],"title":{"id":"19358"},"toolbar":{"id":"19346"},"x_range":{"id":"19323"},"x_scale":{"id":"19327"},"y_range":{"id":"19325"},"y_scale":{"id":"19329"}},"id":"19322","subtype":"Figure","type":"Plot"}],"root_ids":["19322"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"01ce9e7d-5f6a-4ab2-97af-a12cba6c6084","root_ids":["19322"],"roots":{"19322":"5fef72ee-29d4-4804-a4c9-987a050c42fd"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();