(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("0c6031cc-3d5f-43b1-b272-e75e22491f79");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '0c6031cc-3d5f-43b1-b272-e75e22491f79' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"96eb0085-1667-4233-bb73-fadaeea583ed":{"roots":{"references":[{"attributes":{"text":""},"id":"23442","type":"Title"},{"attributes":{},"id":"23413","type":"LinearScale"},{"attributes":{},"id":"23416","type":"BasicTicker"},{"attributes":{},"id":"23448","type":"UnionRenderers"},{"attributes":{},"id":"23428","type":"HelpTool"},{"attributes":{"line_color":{"value":"#FB8072"},"x":{"field":"x"},"y":{"field":"y"}},"id":"23438","type":"Step"},{"attributes":{},"id":"23426","type":"SaveTool"},{"attributes":{"axis":{"id":"23415"},"ticker":null},"id":"23418","type":"Grid"},{"attributes":{},"id":"23411","type":"LinearScale"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#FB8072"},"x":{"field":"x"},"y":{"field":"y"}},"id":"23439","type":"Step"},{"attributes":{"axis":{"id":"23419"},"dimension":1,"ticker":null},"id":"23422","type":"Grid"},{"attributes":{"formatter":{"id":"23447"},"ticker":{"id":"23420"}},"id":"23419","type":"LinearAxis"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"23429","type":"BoxAnnotation"},{"attributes":{"below":[{"id":"23415"}],"center":[{"id":"23418"},{"id":"23422"}],"left":[{"id":"23419"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"23440"}],"title":{"id":"23442"},"toolbar":{"id":"23430"},"x_range":{"id":"23407"},"x_scale":{"id":"23411"},"y_range":{"id":"23409"},"y_scale":{"id":"23413"}},"id":"23406","subtype":"Figure","type":"Plot"},{"attributes":{"source":{"id":"23437"}},"id":"23441","type":"CDSView"},{"attributes":{},"id":"23423","type":"PanTool"},{"attributes":{"data_source":{"id":"23437"},"glyph":{"id":"23438"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"23439"},"selection_glyph":null,"view":{"id":"23441"}},"id":"23440","type":"GlyphRenderer"},{"attributes":{},"id":"23420","type":"BasicTicker"},{"attributes":{"overlay":{"id":"23429"}},"id":"23425","type":"BoxZoomTool"},{"attributes":{},"id":"23407","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"23423"},{"id":"23424"},{"id":"23425"},{"id":"23426"},{"id":"23427"},{"id":"23428"}]},"id":"23430","type":"Toolbar"},{"attributes":{},"id":"23447","type":"BasicTickFormatter"},{"attributes":{},"id":"23427","type":"ResetTool"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[1,2,3,2,5]},"selected":{"id":"23449"},"selection_policy":{"id":"23448"}},"id":"23437","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"23445"},"ticker":{"id":"23416"}},"id":"23415","type":"LinearAxis"},{"attributes":{},"id":"23445","type":"BasicTickFormatter"},{"attributes":{},"id":"23409","type":"DataRange1d"},{"attributes":{},"id":"23424","type":"WheelZoomTool"},{"attributes":{},"id":"23449","type":"Selection"}],"root_ids":["23406"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"96eb0085-1667-4233-bb73-fadaeea583ed","root_ids":["23406"],"roots":{"23406":"0c6031cc-3d5f-43b1-b272-e75e22491f79"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();