(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("5b207876-d4d5-4b80-a24a-3c5785a8fb19");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '5b207876-d4d5-4b80-a24a-3c5785a8fb19' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"97319577-ea13-4e4f-ac2b-efd7e9c240f9":{"roots":{"references":[{"attributes":{},"id":"23063","type":"PanTool"},{"attributes":{},"id":"23047","type":"DataRange1d"},{"attributes":{"formatter":{"id":"23085"},"ticker":{"id":"23056"}},"id":"23055","type":"LinearAxis"},{"attributes":{},"id":"23067","type":"ResetTool"},{"attributes":{},"id":"23089","type":"Selection"},{"attributes":{"below":[{"id":"23055"}],"center":[{"id":"23058"},{"id":"23062"}],"left":[{"id":"23059"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"23080"}],"title":{"id":"23082"},"toolbar":{"id":"23070"},"x_range":{"id":"23047"},"x_scale":{"id":"23051"},"y_range":{"id":"23049"},"y_scale":{"id":"23053"}},"id":"23046","subtype":"Figure","type":"Plot"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"23089"},"selection_policy":{"id":"23088"}},"id":"23077","type":"ColumnDataSource"},{"attributes":{},"id":"23053","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"23063"},{"id":"23064"},{"id":"23065"},{"id":"23066"},{"id":"23067"},{"id":"23068"}]},"id":"23070","type":"Toolbar"},{"attributes":{},"id":"23049","type":"DataRange1d"},{"attributes":{"fill_color":{"value":"#CAB2D6"},"height":{"units":"screen","value":20},"line_color":{"value":"#CAB2D6"},"width":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"23078","type":"Rect"},{"attributes":{"overlay":{"id":"23069"}},"id":"23065","type":"BoxZoomTool"},{"attributes":{},"id":"23088","type":"UnionRenderers"},{"attributes":{},"id":"23068","type":"HelpTool"},{"attributes":{},"id":"23064","type":"WheelZoomTool"},{"attributes":{"source":{"id":"23077"}},"id":"23081","type":"CDSView"},{"attributes":{},"id":"23051","type":"LinearScale"},{"attributes":{"formatter":{"id":"23087"},"ticker":{"id":"23060"}},"id":"23059","type":"LinearAxis"},{"attributes":{"text":""},"id":"23082","type":"Title"},{"attributes":{},"id":"23056","type":"BasicTicker"},{"attributes":{},"id":"23087","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"23055"},"ticker":null},"id":"23058","type":"Grid"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#CAB2D6"},"height":{"units":"screen","value":20},"line_alpha":{"value":0.1},"line_color":{"value":"#CAB2D6"},"width":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"23079","type":"Rect"},{"attributes":{"axis":{"id":"23059"},"dimension":1,"ticker":null},"id":"23062","type":"Grid"},{"attributes":{"data_source":{"id":"23077"},"glyph":{"id":"23078"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"23079"},"selection_glyph":null,"view":{"id":"23081"}},"id":"23080","type":"GlyphRenderer"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"23069","type":"BoxAnnotation"},{"attributes":{},"id":"23066","type":"SaveTool"},{"attributes":{},"id":"23085","type":"BasicTickFormatter"},{"attributes":{},"id":"23060","type":"BasicTicker"}],"root_ids":["23046"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"97319577-ea13-4e4f-ac2b-efd7e9c240f9","root_ids":["23046"],"roots":{"23046":"5b207876-d4d5-4b80-a24a-3c5785a8fb19"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();