(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("83ea2782-3c3d-4719-97a3-b7bd02186d38");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '83ea2782-3c3d-4719-97a3-b7bd02186d38' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"bc3f16b6-3e05-4c1c-990b-87a18a9f3637":{"roots":{"references":[{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"line_alpha":{"value":0.1},"line_color":{"value":"#FDAE6B"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20641","type":"SquareX"},{"attributes":{"data":{"size":[10,20,25],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"20651"},"selection_policy":{"id":"20650"}},"id":"20639","type":"ColumnDataSource"},{"attributes":{},"id":"20651","type":"Selection"},{"attributes":{"text":""},"id":"20644","type":"Title"},{"attributes":{"axis":{"id":"20621"},"dimension":1,"ticker":null},"id":"20624","type":"Grid"},{"attributes":{},"id":"20650","type":"UnionRenderers"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"20631","type":"BoxAnnotation"},{"attributes":{},"id":"20647","type":"BasicTickFormatter"},{"attributes":{"fill_color":{"value":null},"line_color":{"value":"#FDAE6B"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20640","type":"SquareX"},{"attributes":{"formatter":{"id":"20647"},"ticker":{"id":"20618"}},"id":"20617","type":"LinearAxis"},{"attributes":{"axis":{"id":"20617"},"ticker":null},"id":"20620","type":"Grid"},{"attributes":{},"id":"20622","type":"BasicTicker"},{"attributes":{},"id":"20611","type":"DataRange1d"},{"attributes":{"formatter":{"id":"20649"},"ticker":{"id":"20622"}},"id":"20621","type":"LinearAxis"},{"attributes":{"source":{"id":"20639"}},"id":"20643","type":"CDSView"},{"attributes":{},"id":"20613","type":"LinearScale"},{"attributes":{},"id":"20609","type":"DataRange1d"},{"attributes":{},"id":"20626","type":"WheelZoomTool"},{"attributes":{},"id":"20629","type":"ResetTool"},{"attributes":{},"id":"20625","type":"PanTool"},{"attributes":{},"id":"20630","type":"HelpTool"},{"attributes":{},"id":"20628","type":"SaveTool"},{"attributes":{"data_source":{"id":"20639"},"glyph":{"id":"20640"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"20641"},"selection_glyph":null,"view":{"id":"20643"}},"id":"20642","type":"GlyphRenderer"},{"attributes":{"below":[{"id":"20617"}],"center":[{"id":"20620"},{"id":"20624"}],"left":[{"id":"20621"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"20642"}],"title":{"id":"20644"},"toolbar":{"id":"20632"},"x_range":{"id":"20609"},"x_scale":{"id":"20613"},"y_range":{"id":"20611"},"y_scale":{"id":"20615"}},"id":"20608","subtype":"Figure","type":"Plot"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"20625"},{"id":"20626"},{"id":"20627"},{"id":"20628"},{"id":"20629"},{"id":"20630"}]},"id":"20632","type":"Toolbar"},{"attributes":{"overlay":{"id":"20631"}},"id":"20627","type":"BoxZoomTool"},{"attributes":{},"id":"20649","type":"BasicTickFormatter"},{"attributes":{},"id":"20615","type":"LinearScale"},{"attributes":{},"id":"20618","type":"BasicTicker"}],"root_ids":["20608"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"bc3f16b6-3e05-4c1c-990b-87a18a9f3637","root_ids":["20608"],"roots":{"20608":"83ea2782-3c3d-4719-97a3-b7bd02186d38"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();