(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("87c972e9-fc2f-483f-90ea-308c00102c39");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '87c972e9-fc2f-483f-90ea-308c00102c39' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"b7090939-ddc0-4a7d-8e39-b9456064bcf2":{"roots":{"references":[{"attributes":{},"id":"23335","type":"DataRange1d"},{"attributes":{},"id":"23377","type":"Selection"},{"attributes":{},"id":"23348","type":"BasicTicker"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"23357","type":"BoxAnnotation"},{"attributes":{},"id":"23355","type":"ResetTool"},{"attributes":{},"id":"23351","type":"PanTool"},{"attributes":{},"id":"23375","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"23365"},"glyph":{"id":"23366"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"23367"},"selection_glyph":null,"view":{"id":"23369"}},"id":"23368","type":"GlyphRenderer"},{"attributes":{},"id":"23344","type":"BasicTicker"},{"attributes":{},"id":"23356","type":"HelpTool"},{"attributes":{},"id":"23376","type":"UnionRenderers"},{"attributes":{},"id":"23352","type":"WheelZoomTool"},{"attributes":{},"id":"23354","type":"SaveTool"},{"attributes":{"source":{"id":"23365"}},"id":"23369","type":"CDSView"},{"attributes":{},"id":"23339","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"23351"},{"id":"23352"},{"id":"23353"},{"id":"23354"},{"id":"23355"},{"id":"23356"}]},"id":"23358","type":"Toolbar"},{"attributes":{"formatter":{"id":"23375"},"ticker":{"id":"23348"}},"id":"23347","type":"LinearAxis"},{"attributes":{},"id":"23373","type":"BasicTickFormatter"},{"attributes":{},"id":"23337","type":"DataRange1d"},{"attributes":{"axis":{"id":"23343"},"ticker":null},"id":"23346","type":"Grid"},{"attributes":{"text":""},"id":"23370","type":"Title"},{"attributes":{"data":{"size":[10,20,25],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"23377"},"selection_policy":{"id":"23376"}},"id":"23365","type":"ColumnDataSource"},{"attributes":{},"id":"23341","type":"LinearScale"},{"attributes":{"formatter":{"id":"23373"},"ticker":{"id":"23344"}},"id":"23343","type":"LinearAxis"},{"attributes":{"fill_color":{"value":null},"line_color":{"value":"#FDAE6B"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"23366","type":"SquareX"},{"attributes":{"below":[{"id":"23343"}],"center":[{"id":"23346"},{"id":"23350"}],"left":[{"id":"23347"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"23368"}],"title":{"id":"23370"},"toolbar":{"id":"23358"},"x_range":{"id":"23335"},"x_scale":{"id":"23339"},"y_range":{"id":"23337"},"y_scale":{"id":"23341"}},"id":"23334","subtype":"Figure","type":"Plot"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"line_alpha":{"value":0.1},"line_color":{"value":"#FDAE6B"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"23367","type":"SquareX"},{"attributes":{"overlay":{"id":"23357"}},"id":"23353","type":"BoxZoomTool"},{"attributes":{"axis":{"id":"23347"},"dimension":1,"ticker":null},"id":"23350","type":"Grid"}],"root_ids":["23334"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"b7090939-ddc0-4a7d-8e39-b9456064bcf2","root_ids":["23334"],"roots":{"23334":"87c972e9-fc2f-483f-90ea-308c00102c39"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();