(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("48915235-f5d6-4b60-a4bc-c3e1f8535134");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '48915235-f5d6-4b60-a4bc-c3e1f8535134' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"ee3076e9-e067-4a0e-b7aa-cb7e95f04594":{"roots":{"references":[{"attributes":{"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"22506","type":"Line"},{"attributes":{},"id":"22481","type":"LinearScale"},{"attributes":{},"id":"22512","type":"BasicTickFormatter"},{"attributes":{"text":"line"},"id":"22473","type":"Title"},{"attributes":{},"id":"22479","type":"LinearScale"},{"attributes":{},"id":"22515","type":"UnionRenderers"},{"attributes":{},"id":"22475","type":"DataRange1d"},{"attributes":{},"id":"22492","type":"WheelZoomTool"},{"attributes":{},"id":"22516","type":"Selection"},{"attributes":{"formatter":{"id":"22514"},"ticker":{"id":"22488"}},"id":"22487","type":"LinearAxis"},{"attributes":{"axis":{"id":"22487"},"dimension":1,"ticker":null},"id":"22490","type":"Grid"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"22507","type":"Line"},{"attributes":{"formatter":{"id":"22512"},"ticker":{"id":"22484"}},"id":"22483","type":"LinearAxis"},{"attributes":{},"id":"22494","type":"SaveTool"},{"attributes":{},"id":"22477","type":"DataRange1d"},{"attributes":{},"id":"22495","type":"ResetTool"},{"attributes":{},"id":"22491","type":"PanTool"},{"attributes":{"data_source":{"id":"22505"},"glyph":{"id":"22506"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"22507"},"selection_glyph":null,"view":{"id":"22509"}},"id":"22508","type":"GlyphRenderer"},{"attributes":{"overlay":{"id":"22497"}},"id":"22493","type":"BoxZoomTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"22491"},{"id":"22492"},{"id":"22493"},{"id":"22494"},{"id":"22495"},{"id":"22496"}]},"id":"22498","type":"Toolbar"},{"attributes":{},"id":"22484","type":"BasicTicker"},{"attributes":{"below":[{"id":"22483"}],"center":[{"id":"22486"},{"id":"22490"}],"left":[{"id":"22487"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"22508"}],"title":{"id":"22473"},"toolbar":{"id":"22498"},"x_range":{"id":"22475"},"x_scale":{"id":"22479"},"y_range":{"id":"22477"},"y_scale":{"id":"22481"}},"id":"22472","subtype":"Figure","type":"Plot"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"22497","type":"BoxAnnotation"},{"attributes":{},"id":"22514","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"22505"}},"id":"22509","type":"CDSView"},{"attributes":{},"id":"22488","type":"BasicTicker"},{"attributes":{},"id":"22496","type":"HelpTool"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,2,4,5]},"selected":{"id":"22516"},"selection_policy":{"id":"22515"}},"id":"22505","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"22483"},"ticker":null},"id":"22486","type":"Grid"}],"root_ids":["22472"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"ee3076e9-e067-4a0e-b7aa-cb7e95f04594","root_ids":["22472"],"roots":{"22472":"48915235-f5d6-4b60-a4bc-c3e1f8535134"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();