(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("0d5b0bcc-2228-4fc6-9124-3e3b89ae0041");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '0d5b0bcc-2228-4fc6-9124-3e3b89ae0041' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"9304c307-3b31-4790-ae0b-d9d773cfe263":{"roots":{"references":[{"attributes":{"axis":{"id":"23631"},"ticker":null},"id":"23634","type":"Grid"},{"attributes":{},"id":"23625","type":"DataRange1d"},{"attributes":{},"id":"23643","type":"ResetTool"},{"attributes":{},"id":"23632","type":"BasicTicker"},{"attributes":{"data":{"top":[1,2,3],"x":[1,2,3]},"selected":{"id":"23665"},"selection_policy":{"id":"23664"}},"id":"23653","type":"ColumnDataSource"},{"attributes":{},"id":"23627","type":"LinearScale"},{"attributes":{},"id":"23629","type":"LinearScale"},{"attributes":{"below":[{"id":"23631"}],"center":[{"id":"23634"},{"id":"23638"}],"left":[{"id":"23635"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"23656"}],"title":{"id":"23658"},"toolbar":{"id":"23646"},"x_range":{"id":"23623"},"x_scale":{"id":"23627"},"y_range":{"id":"23625"},"y_scale":{"id":"23629"}},"id":"23622","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"23644","type":"HelpTool"},{"attributes":{"formatter":{"id":"23661"},"ticker":{"id":"23632"}},"id":"23631","type":"LinearAxis"},{"attributes":{"axis":{"id":"23635"},"dimension":1,"ticker":null},"id":"23638","type":"Grid"},{"attributes":{},"id":"23639","type":"PanTool"},{"attributes":{},"id":"23623","type":"DataRange1d"},{"attributes":{},"id":"23663","type":"BasicTickFormatter"},{"attributes":{},"id":"23636","type":"BasicTicker"},{"attributes":{"formatter":{"id":"23663"},"ticker":{"id":"23636"}},"id":"23635","type":"LinearAxis"},{"attributes":{},"id":"23665","type":"Selection"},{"attributes":{"data_source":{"id":"23653"},"glyph":{"id":"23654"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"23655"},"selection_glyph":null,"view":{"id":"23657"}},"id":"23656","type":"GlyphRenderer"},{"attributes":{},"id":"23661","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"23653"}},"id":"23657","type":"CDSView"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"23639"},{"id":"23640"},{"id":"23641"},{"id":"23642"},{"id":"23643"},{"id":"23644"}]},"id":"23646","type":"Toolbar"},{"attributes":{"fill_color":{"value":"#CAB2D6"},"line_color":{"value":"#CAB2D6"},"top":{"field":"top"},"width":{"value":0.5},"x":{"field":"x"}},"id":"23654","type":"VBar"},{"attributes":{"text":""},"id":"23658","type":"Title"},{"attributes":{},"id":"23642","type":"SaveTool"},{"attributes":{"overlay":{"id":"23645"}},"id":"23641","type":"BoxZoomTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#CAB2D6"},"line_alpha":{"value":0.1},"line_color":{"value":"#CAB2D6"},"top":{"field":"top"},"width":{"value":0.5},"x":{"field":"x"}},"id":"23655","type":"VBar"},{"attributes":{},"id":"23664","type":"UnionRenderers"},{"attributes":{},"id":"23640","type":"WheelZoomTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"23645","type":"BoxAnnotation"}],"root_ids":["23622"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"9304c307-3b31-4790-ae0b-d9d773cfe263","root_ids":["23622"],"roots":{"23622":"0d5b0bcc-2228-4fc6-9124-3e3b89ae0041"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();