(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("476b4469-a757-4459-9944-6384768c8c82");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '476b4469-a757-4459-9944-6384768c8c82' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"7678ffd2-73dc-4ab0-9cad-6f3ad1ba12d6":{"roots":{"references":[{"attributes":{},"id":"22439","type":"BasicTickFormatter"},{"attributes":{},"id":"22410","type":"BasicTicker"},{"attributes":{},"id":"22414","type":"BasicTicker"},{"attributes":{},"id":"22418","type":"WheelZoomTool"},{"attributes":{"overlay":{"id":"22423"}},"id":"22419","type":"BoxZoomTool"},{"attributes":{},"id":"22417","type":"PanTool"},{"attributes":{},"id":"22422","type":"HelpTool"},{"attributes":{"formatter":{"id":"22441"},"ticker":{"id":"22414"}},"id":"22413","type":"LinearAxis"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"22423","type":"BoxAnnotation"},{"attributes":{"formatter":{"id":"22439"},"ticker":{"id":"22410"}},"id":"22409","type":"LinearAxis"},{"attributes":{"data_source":{"id":"22431"},"glyph":{"id":"22432"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"22433"},"selection_glyph":null,"view":{"id":"22435"}},"id":"22434","type":"GlyphRenderer"},{"attributes":{"text":""},"id":"22436","type":"Title"},{"attributes":{},"id":"22407","type":"LinearScale"},{"attributes":{"source":{"id":"22431"}},"id":"22435","type":"CDSView"},{"attributes":{"axis":{"id":"22413"},"dimension":1,"ticker":null},"id":"22416","type":"Grid"},{"attributes":{},"id":"22441","type":"BasicTickFormatter"},{"attributes":{},"id":"22442","type":"UnionRenderers"},{"attributes":{},"id":"22420","type":"SaveTool"},{"attributes":{},"id":"22401","type":"DataRange1d"},{"attributes":{},"id":"22405","type":"LinearScale"},{"attributes":{},"id":"22421","type":"ResetTool"},{"attributes":{"below":[{"id":"22409"}],"center":[{"id":"22412"},{"id":"22416"}],"left":[{"id":"22413"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"22434"}],"title":{"id":"22436"},"toolbar":{"id":"22424"},"x_range":{"id":"22401"},"x_scale":{"id":"22405"},"y_range":{"id":"22403"},"y_scale":{"id":"22407"}},"id":"22400","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"22403","type":"DataRange1d"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#DE2D26"},"line_alpha":{"value":0.1},"line_color":{"value":"#DE2D26"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"22433","type":"InvertedTriangle"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"22443"},"selection_policy":{"id":"22442"}},"id":"22431","type":"ColumnDataSource"},{"attributes":{},"id":"22443","type":"Selection"},{"attributes":{"fill_color":{"value":"#DE2D26"},"line_color":{"value":"#DE2D26"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"22432","type":"InvertedTriangle"},{"attributes":{"axis":{"id":"22409"},"ticker":null},"id":"22412","type":"Grid"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"22417"},{"id":"22418"},{"id":"22419"},{"id":"22420"},{"id":"22421"},{"id":"22422"}]},"id":"22424","type":"Toolbar"}],"root_ids":["22400"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"7678ffd2-73dc-4ab0-9cad-6f3ad1ba12d6","root_ids":["22400"],"roots":{"22400":"476b4469-a757-4459-9944-6384768c8c82"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();