(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("f84593a7-d942-4f72-9553-bcdd832ba21b");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'f84593a7-d942-4f72-9553-bcdd832ba21b' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"4f8b9831-8ff1-4b7e-a666-ba6d5aecf576":{"roots":{"references":[{"attributes":{},"id":"18425","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"18417"}},"id":"18421","type":"CDSView"},{"attributes":{},"id":"18427","type":"BasicTickFormatter"},{"attributes":{},"id":"18408","type":"HelpTool"},{"attributes":{},"id":"18428","type":"UnionRenderers"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"18429"},"selection_policy":{"id":"18428"}},"id":"18417","type":"ColumnDataSource"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"18409","type":"BoxAnnotation"},{"attributes":{},"id":"18429","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.2},"fill_color":{"value":"#DD1C77"},"line_color":{"value":"#DD1C77"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18418","type":"CircleX"},{"attributes":{},"id":"18393","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"18403"},{"id":"18404"},{"id":"18405"},{"id":"18406"},{"id":"18407"},{"id":"18408"}]},"id":"18410","type":"Toolbar"},{"attributes":{"formatter":{"id":"18425"},"ticker":{"id":"18396"}},"id":"18395","type":"LinearAxis"},{"attributes":{"below":[{"id":"18395"}],"center":[{"id":"18398"},{"id":"18402"}],"left":[{"id":"18399"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"18420"}],"title":{"id":"18422"},"toolbar":{"id":"18410"},"x_range":{"id":"18387"},"x_scale":{"id":"18391"},"y_range":{"id":"18389"},"y_scale":{"id":"18393"}},"id":"18386","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"18403","type":"PanTool"},{"attributes":{},"id":"18400","type":"BasicTicker"},{"attributes":{"data_source":{"id":"18417"},"glyph":{"id":"18418"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"18419"},"selection_glyph":null,"view":{"id":"18421"}},"id":"18420","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"18427"},"ticker":{"id":"18400"}},"id":"18399","type":"LinearAxis"},{"attributes":{},"id":"18404","type":"WheelZoomTool"},{"attributes":{},"id":"18396","type":"BasicTicker"},{"attributes":{},"id":"18407","type":"ResetTool"},{"attributes":{},"id":"18387","type":"DataRange1d"},{"attributes":{"overlay":{"id":"18409"}},"id":"18405","type":"BoxZoomTool"},{"attributes":{"axis":{"id":"18395"},"ticker":null},"id":"18398","type":"Grid"},{"attributes":{"text":""},"id":"18422","type":"Title"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#DD1C77"},"line_alpha":{"value":0.1},"line_color":{"value":"#DD1C77"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18419","type":"CircleX"},{"attributes":{},"id":"18406","type":"SaveTool"},{"attributes":{"axis":{"id":"18399"},"dimension":1,"ticker":null},"id":"18402","type":"Grid"},{"attributes":{},"id":"18389","type":"DataRange1d"},{"attributes":{},"id":"18391","type":"LinearScale"}],"root_ids":["18386"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"4f8b9831-8ff1-4b7e-a666-ba6d5aecf576","root_ids":["18386"],"roots":{"18386":"f84593a7-d942-4f72-9553-bcdd832ba21b"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();