(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("cd94046e-2581-46b9-beb7-de6dc219bf32");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'cd94046e-2581-46b9-beb7-de6dc219bf32' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"6b97659a-943c-43dd-98e2-fdc5be5c618e":{"roots":{"references":[{"attributes":{"formatter":{"id":"21585"},"ticker":{"id":"21558"}},"id":"21557","type":"LinearAxis"},{"attributes":{"data_source":{"id":"21575"},"glyph":{"id":"21576"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"21577"},"selection_glyph":null,"view":{"id":"21579"}},"id":"21578","type":"GlyphRenderer"},{"attributes":{},"id":"21585","type":"BasicTickFormatter"},{"attributes":{},"id":"21587","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#FB8072"},"line_alpha":{"value":0.1},"line_color":{"value":"#FB8072"},"line_width":{"value":2},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"21577","type":"CircleCross"},{"attributes":{"overlay":{"id":"21567"}},"id":"21563","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"21583"},"ticker":{"id":"21554"}},"id":"21553","type":"LinearAxis"},{"attributes":{"axis":{"id":"21553"},"ticker":null},"id":"21556","type":"Grid"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"21567","type":"BoxAnnotation"},{"attributes":{},"id":"21554","type":"BasicTicker"},{"attributes":{"below":[{"id":"21553"}],"center":[{"id":"21556"},{"id":"21560"}],"left":[{"id":"21557"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"21578"}],"title":{"id":"21580"},"toolbar":{"id":"21568"},"x_range":{"id":"21545"},"x_scale":{"id":"21549"},"y_range":{"id":"21547"},"y_scale":{"id":"21551"}},"id":"21544","subtype":"Figure","type":"Plot"},{"attributes":{"axis":{"id":"21557"},"dimension":1,"ticker":null},"id":"21560","type":"Grid"},{"attributes":{"data":{"x":[1,2,3],"y":[4,5,6]},"selected":{"id":"21587"},"selection_policy":{"id":"21586"}},"id":"21575","type":"ColumnDataSource"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"21561"},{"id":"21562"},{"id":"21563"},{"id":"21564"},{"id":"21565"},{"id":"21566"}]},"id":"21568","type":"Toolbar"},{"attributes":{},"id":"21561","type":"PanTool"},{"attributes":{},"id":"21558","type":"BasicTicker"},{"attributes":{},"id":"21586","type":"UnionRenderers"},{"attributes":{},"id":"21545","type":"DataRange1d"},{"attributes":{},"id":"21583","type":"BasicTickFormatter"},{"attributes":{},"id":"21566","type":"HelpTool"},{"attributes":{},"id":"21562","type":"WheelZoomTool"},{"attributes":{},"id":"21564","type":"SaveTool"},{"attributes":{"source":{"id":"21575"}},"id":"21579","type":"CDSView"},{"attributes":{"text":""},"id":"21580","type":"Title"},{"attributes":{},"id":"21565","type":"ResetTool"},{"attributes":{},"id":"21551","type":"LinearScale"},{"attributes":{},"id":"21549","type":"LinearScale"},{"attributes":{},"id":"21547","type":"DataRange1d"},{"attributes":{"fill_alpha":{"value":0.2},"fill_color":{"value":"#FB8072"},"line_color":{"value":"#FB8072"},"line_width":{"value":2},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"21576","type":"CircleCross"}],"root_ids":["21544"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"6b97659a-943c-43dd-98e2-fdc5be5c618e","root_ids":["21544"],"roots":{"21544":"cd94046e-2581-46b9-beb7-de6dc219bf32"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();