(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("7a7aa2ef-f3df-4882-b58d-01c1068b11e0");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '7a7aa2ef-f3df-4882-b58d-01c1068b11e0' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"5579c34c-dd29-48dc-bf5a-502a987658cf":{"roots":{"references":[{"attributes":{"below":[{"id":"21337"}],"center":[{"id":"21340"},{"id":"21344"}],"left":[{"id":"21341"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"21362"}],"title":{"id":"21364"},"toolbar":{"id":"21352"},"x_range":{"id":"21329"},"x_scale":{"id":"21333"},"y_range":{"id":"21331"},"y_scale":{"id":"21335"}},"id":"21328","subtype":"Figure","type":"Plot"},{"attributes":{"data_source":{"id":"21359"},"glyph":{"id":"21360"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"21361"},"selection_glyph":null,"view":{"id":"21363"}},"id":"21362","type":"GlyphRenderer"},{"attributes":{},"id":"21348","type":"SaveTool"},{"attributes":{},"id":"21370","type":"UnionRenderers"},{"attributes":{},"id":"21338","type":"BasicTicker"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#7FC97F"},"inner_radius":{"units":"data","value":0.2},"line_alpha":{"value":0.1},"line_color":{"value":"#7FC97F"},"outer_radius":{"units":"data","value":0.5},"x":{"field":"x"},"y":{"field":"y"}},"id":"21361","type":"Annulus"},{"attributes":{},"id":"21331","type":"DataRange1d"},{"attributes":{"formatter":{"id":"21367"},"ticker":{"id":"21338"}},"id":"21337","type":"LinearAxis"},{"attributes":{},"id":"21367","type":"BasicTickFormatter"},{"attributes":{},"id":"21333","type":"LinearScale"},{"attributes":{"axis":{"id":"21341"},"dimension":1,"ticker":null},"id":"21344","type":"Grid"},{"attributes":{},"id":"21346","type":"WheelZoomTool"},{"attributes":{"axis":{"id":"21337"},"ticker":null},"id":"21340","type":"Grid"},{"attributes":{"overlay":{"id":"21351"}},"id":"21347","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"21369"},"ticker":{"id":"21342"}},"id":"21341","type":"LinearAxis"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"21345"},{"id":"21346"},{"id":"21347"},{"id":"21348"},{"id":"21349"},{"id":"21350"}]},"id":"21352","type":"Toolbar"},{"attributes":{"source":{"id":"21359"}},"id":"21363","type":"CDSView"},{"attributes":{},"id":"21371","type":"Selection"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"21351","type":"BoxAnnotation"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"21371"},"selection_policy":{"id":"21370"}},"id":"21359","type":"ColumnDataSource"},{"attributes":{},"id":"21349","type":"ResetTool"},{"attributes":{},"id":"21369","type":"BasicTickFormatter"},{"attributes":{},"id":"21329","type":"DataRange1d"},{"attributes":{},"id":"21342","type":"BasicTicker"},{"attributes":{},"id":"21345","type":"PanTool"},{"attributes":{},"id":"21335","type":"LinearScale"},{"attributes":{},"id":"21350","type":"HelpTool"},{"attributes":{"fill_color":{"value":"#7FC97F"},"inner_radius":{"units":"data","value":0.2},"line_color":{"value":"#7FC97F"},"outer_radius":{"units":"data","value":0.5},"x":{"field":"x"},"y":{"field":"y"}},"id":"21360","type":"Annulus"},{"attributes":{"text":""},"id":"21364","type":"Title"}],"root_ids":["21328"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"5579c34c-dd29-48dc-bf5a-502a987658cf","root_ids":["21328"],"roots":{"21328":"7a7aa2ef-f3df-4882-b58d-01c1068b11e0"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();