(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("27fd8fe0-86a1-4a69-8539-8534bff8c0d2");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '27fd8fe0-86a1-4a69-8539-8534bff8c0d2' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"28bb237a-e0ba-4eda-97c5-4ac91e74cd86":{"roots":{"references":[{"attributes":{"data_source":{"id":"20999"},"glyph":{"id":"21000"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"21001"},"selection_glyph":null,"view":{"id":"21003"}},"id":"21002","type":"GlyphRenderer"},{"attributes":{},"id":"20971","type":"DataRange1d"},{"attributes":{"axis":{"id":"20981"},"dimension":1,"ticker":null},"id":"20984","type":"Grid"},{"attributes":{"text":""},"id":"21004","type":"Title"},{"attributes":{},"id":"20990","type":"HelpTool"},{"attributes":{"data":{"x":[1,2,3],"y1":[0,0,0],"y2":[1,4,2]},"selected":{"id":"21011"},"selection_policy":{"id":"21010"}},"id":"20999","type":"ColumnDataSource"},{"attributes":{},"id":"20988","type":"SaveTool"},{"attributes":{"below":[{"id":"20977"}],"center":[{"id":"20980"},{"id":"20984"}],"left":[{"id":"20981"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"21002"}],"title":{"id":"21004"},"toolbar":{"id":"20992"},"x_range":{"id":"20969"},"x_scale":{"id":"20973"},"y_range":{"id":"20971"},"y_scale":{"id":"20975"}},"id":"20968","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"21007","type":"BasicTickFormatter"},{"attributes":{"fill_color":"#99D594","x":{"field":"x"},"y1":{"field":"y1"},"y2":{"field":"y2"}},"id":"21000","type":"VArea"},{"attributes":{},"id":"20989","type":"ResetTool"},{"attributes":{},"id":"21010","type":"UnionRenderers"},{"attributes":{},"id":"21011","type":"Selection"},{"attributes":{"fill_alpha":0.1,"fill_color":"#99D594","x":{"field":"x"},"y1":{"field":"y1"},"y2":{"field":"y2"}},"id":"21001","type":"VArea"},{"attributes":{},"id":"20985","type":"PanTool"},{"attributes":{"source":{"id":"20999"}},"id":"21003","type":"CDSView"},{"attributes":{},"id":"20982","type":"BasicTicker"},{"attributes":{"formatter":{"id":"21009"},"ticker":{"id":"20982"}},"id":"20981","type":"LinearAxis"},{"attributes":{},"id":"20969","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"20985"},{"id":"20986"},{"id":"20987"},{"id":"20988"},{"id":"20989"},{"id":"20990"}]},"id":"20992","type":"Toolbar"},{"attributes":{},"id":"20978","type":"BasicTicker"},{"attributes":{},"id":"20986","type":"WheelZoomTool"},{"attributes":{"overlay":{"id":"20991"}},"id":"20987","type":"BoxZoomTool"},{"attributes":{},"id":"20975","type":"LinearScale"},{"attributes":{},"id":"20973","type":"LinearScale"},{"attributes":{"axis":{"id":"20977"},"ticker":null},"id":"20980","type":"Grid"},{"attributes":{"formatter":{"id":"21007"},"ticker":{"id":"20978"}},"id":"20977","type":"LinearAxis"},{"attributes":{},"id":"21009","type":"BasicTickFormatter"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"20991","type":"BoxAnnotation"}],"root_ids":["20968"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"28bb237a-e0ba-4eda-97c5-4ac91e74cd86","root_ids":["20968"],"roots":{"20968":"27fd8fe0-86a1-4a69-8539-8534bff8c0d2"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();