(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("5acb44d1-898e-4f80-b9f9-b6616105566d");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '5acb44d1-898e-4f80-b9f9-b6616105566d' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"b7ef93c4-9c76-443a-9e67-6bde0dcfa4ac":{"roots":{"references":[{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"22281"},{"id":"22282"},{"id":"22283"},{"id":"22284"},{"id":"22285"},{"id":"22286"}]},"id":"22288","type":"Toolbar"},{"attributes":{"data":{"q":[1,2,2],"r":[0,0,1]},"selected":{"id":"22307"},"selection_policy":{"id":"22306"}},"id":"22295","type":"ColumnDataSource"},{"attributes":{},"id":"22285","type":"ResetTool"},{"attributes":{},"id":"22303","type":"BasicTickFormatter"},{"attributes":{"fill_color":{"value":"#74ADD1"},"line_color":{"value":"#1f77b4"},"q":{"field":"q"},"r":{"field":"r"}},"id":"22296","type":"HexTile"},{"attributes":{"formatter":{"id":"22303"},"ticker":{"id":"22274"}},"id":"22273","type":"LinearAxis"},{"attributes":{"axis":{"id":"22277"},"dimension":1,"ticker":null},"id":"22280","type":"Grid"},{"attributes":{},"id":"22278","type":"BasicTicker"},{"attributes":{"data_source":{"id":"22295"},"glyph":{"id":"22296"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"22297"},"selection_glyph":null,"view":{"id":"22299"}},"id":"22298","type":"GlyphRenderer"},{"attributes":{"below":[{"id":"22273"}],"center":[{"id":"22276"},{"id":"22280"}],"left":[{"id":"22277"}],"match_aspect":true,"plot_height":300,"plot_width":300,"renderers":[{"id":"22298"}],"title":{"id":"22300"},"toolbar":{"id":"22288"},"x_range":{"id":"22265"},"x_scale":{"id":"22269"},"y_range":{"id":"22267"},"y_scale":{"id":"22271"}},"id":"22264","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"22305"},"ticker":{"id":"22278"}},"id":"22277","type":"LinearAxis"},{"attributes":{},"id":"22306","type":"UnionRenderers"},{"attributes":{},"id":"22307","type":"Selection"},{"attributes":{},"id":"22269","type":"LinearScale"},{"attributes":{},"id":"22305","type":"BasicTickFormatter"},{"attributes":{},"id":"22267","type":"DataRange1d"},{"attributes":{"text":""},"id":"22300","type":"Title"},{"attributes":{"axis":{"id":"22273"},"ticker":null},"id":"22276","type":"Grid"},{"attributes":{},"id":"22274","type":"BasicTicker"},{"attributes":{},"id":"22281","type":"PanTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"22287","type":"BoxAnnotation"},{"attributes":{},"id":"22284","type":"SaveTool"},{"attributes":{},"id":"22282","type":"WheelZoomTool"},{"attributes":{"source":{"id":"22295"}},"id":"22299","type":"CDSView"},{"attributes":{"overlay":{"id":"22287"}},"id":"22283","type":"BoxZoomTool"},{"attributes":{},"id":"22265","type":"DataRange1d"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#74ADD1"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"q":{"field":"q"},"r":{"field":"r"}},"id":"22297","type":"HexTile"},{"attributes":{},"id":"22271","type":"LinearScale"},{"attributes":{},"id":"22286","type":"HelpTool"}],"root_ids":["22264"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"b7ef93c4-9c76-443a-9e67-6bde0dcfa4ac","root_ids":["22264"],"roots":{"22264":"5acb44d1-898e-4f80-b9f9-b6616105566d"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();