(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("5dd5bf69-c1a1-4497-bfd5-69156120c45e");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '5dd5bf69-c1a1-4497-bfd5-69156120c45e' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"079d756f-7bbf-4bd8-bc4d-9aebeb783792":{"roots":{"references":[{"attributes":{"below":[{"id":"19043"}],"center":[{"id":"19046"},{"id":"19050"}],"left":[{"id":"19047"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"19068"}],"title":{"id":"19070"},"toolbar":{"id":"19058"},"x_range":{"id":"19035"},"x_scale":{"id":"19039"},"y_range":{"id":"19037"},"y_scale":{"id":"19041"}},"id":"19034","subtype":"Figure","type":"Plot"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"19051"},{"id":"19052"},{"id":"19053"},{"id":"19054"},{"id":"19055"},{"id":"19056"}]},"id":"19058","type":"Toolbar"},{"attributes":{"source":{"id":"19065"}},"id":"19069","type":"CDSView"},{"attributes":{"formatter":{"id":"19075"},"ticker":{"id":"19048"}},"id":"19047","type":"LinearAxis"},{"attributes":{},"id":"19055","type":"ResetTool"},{"attributes":{"text":""},"id":"19070","type":"Title"},{"attributes":{},"id":"19044","type":"BasicTicker"},{"attributes":{},"id":"19037","type":"DataRange1d"},{"attributes":{},"id":"19077","type":"Selection"},{"attributes":{"fill_color":"#99D594","x1":{"field":"x1"},"x2":{"field":"x2"},"y":{"field":"y"}},"id":"19066","type":"HArea"},{"attributes":{"overlay":{"id":"19057"}},"id":"19053","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"19073"},"ticker":{"id":"19044"}},"id":"19043","type":"LinearAxis"},{"attributes":{"data":{"x1":[0,0,0],"x2":[1,4,2],"y":[1,2,3]},"selected":{"id":"19077"},"selection_policy":{"id":"19076"}},"id":"19065","type":"ColumnDataSource"},{"attributes":{},"id":"19076","type":"UnionRenderers"},{"attributes":{"fill_alpha":0.1,"fill_color":"#99D594","x1":{"field":"x1"},"x2":{"field":"x2"},"y":{"field":"y"}},"id":"19067","type":"HArea"},{"attributes":{},"id":"19048","type":"BasicTicker"},{"attributes":{},"id":"19051","type":"PanTool"},{"attributes":{},"id":"19052","type":"WheelZoomTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"19057","type":"BoxAnnotation"},{"attributes":{"axis":{"id":"19047"},"dimension":1,"ticker":null},"id":"19050","type":"Grid"},{"attributes":{},"id":"19075","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"19065"},"glyph":{"id":"19066"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"19067"},"selection_glyph":null,"view":{"id":"19069"}},"id":"19068","type":"GlyphRenderer"},{"attributes":{},"id":"19039","type":"LinearScale"},{"attributes":{},"id":"19041","type":"LinearScale"},{"attributes":{"axis":{"id":"19043"},"ticker":null},"id":"19046","type":"Grid"},{"attributes":{},"id":"19073","type":"BasicTickFormatter"},{"attributes":{},"id":"19035","type":"DataRange1d"},{"attributes":{},"id":"19056","type":"HelpTool"},{"attributes":{},"id":"19054","type":"SaveTool"}],"root_ids":["19034"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"079d756f-7bbf-4bd8-bc4d-9aebeb783792","root_ids":["19034"],"roots":{"19034":"5dd5bf69-c1a1-4497-bfd5-69156120c45e"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();