(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("5e4ed51f-1298-4a9d-b175-b5eade9fccb9");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '5e4ed51f-1298-4a9d-b175-b5eade9fccb9' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"1f67c7f9-64e9-47bc-a1f5-e2a4e73f37d1":{"roots":{"references":[{"attributes":{"formatter":{"id":"20935"},"ticker":{"id":"20906"}},"id":"20905","type":"LinearAxis"},{"attributes":{},"id":"20939","type":"Selection"},{"attributes":{},"id":"20903","type":"LinearScale"},{"attributes":{"formatter":{"id":"20937"},"ticker":{"id":"20910"}},"id":"20909","type":"LinearAxis"},{"attributes":{},"id":"20913","type":"PanTool"},{"attributes":{},"id":"20910","type":"BasicTicker"},{"attributes":{},"id":"20917","type":"ResetTool"},{"attributes":{},"id":"20897","type":"DataRange1d"},{"attributes":{},"id":"20935","type":"BasicTickFormatter"},{"attributes":{"fill_color":{"value":"#99D594"},"line_color":{"value":"#99D594"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20928","type":"TrianglePin"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"20919","type":"BoxAnnotation"},{"attributes":{},"id":"20916","type":"SaveTool"},{"attributes":{},"id":"20914","type":"WheelZoomTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"20913"},{"id":"20914"},{"id":"20915"},{"id":"20916"},{"id":"20917"},{"id":"20918"}]},"id":"20920","type":"Toolbar"},{"attributes":{},"id":"20901","type":"LinearScale"},{"attributes":{"axis":{"id":"20905"},"ticker":null},"id":"20908","type":"Grid"},{"attributes":{"source":{"id":"20927"}},"id":"20931","type":"CDSView"},{"attributes":{},"id":"20938","type":"UnionRenderers"},{"attributes":{"text":""},"id":"20932","type":"Title"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#99D594"},"line_alpha":{"value":0.1},"line_color":{"value":"#99D594"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20929","type":"TrianglePin"},{"attributes":{"overlay":{"id":"20919"}},"id":"20915","type":"BoxZoomTool"},{"attributes":{"data_source":{"id":"20927"},"glyph":{"id":"20928"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"20929"},"selection_glyph":null,"view":{"id":"20931"}},"id":"20930","type":"GlyphRenderer"},{"attributes":{},"id":"20899","type":"DataRange1d"},{"attributes":{},"id":"20918","type":"HelpTool"},{"attributes":{"below":[{"id":"20905"}],"center":[{"id":"20908"},{"id":"20912"}],"left":[{"id":"20909"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"20930"}],"title":{"id":"20932"},"toolbar":{"id":"20920"},"x_range":{"id":"20897"},"x_scale":{"id":"20901"},"y_range":{"id":"20899"},"y_scale":{"id":"20903"}},"id":"20896","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"20937","type":"BasicTickFormatter"},{"attributes":{},"id":"20906","type":"BasicTicker"},{"attributes":{"data":{"size":[10,20,25],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"20939"},"selection_policy":{"id":"20938"}},"id":"20927","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"20909"},"dimension":1,"ticker":null},"id":"20912","type":"Grid"}],"root_ids":["20896"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"1f67c7f9-64e9-47bc-a1f5-e2a4e73f37d1","root_ids":["20896"],"roots":{"20896":"5e4ed51f-1298-4a9d-b175-b5eade9fccb9"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();