(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("c0ee1df0-8537-4f71-aee1-85be13beb093");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'c0ee1df0-8537-4f71-aee1-85be13beb093' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"0080ee3d-2b68-4272-a38c-c0da9796c5bb":{"roots":{"references":[{"attributes":{},"id":"22833","type":"DataRange1d"},{"attributes":{},"id":"22837","type":"LinearScale"},{"attributes":{},"id":"22835","type":"LinearScale"},{"attributes":{},"id":"22850","type":"SaveTool"},{"attributes":{},"id":"22851","type":"ResetTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fill_color"},"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"22863","type":"Patches"},{"attributes":{"axis":{"id":"22843"},"dimension":1,"ticker":null},"id":"22846","type":"Grid"},{"attributes":{},"id":"22871","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"22871"},"ticker":{"id":"22844"}},"id":"22843","type":"LinearAxis"},{"attributes":{},"id":"22869","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"22861"}},"id":"22865","type":"CDSView"},{"attributes":{"axis":{"id":"22839"},"ticker":null},"id":"22842","type":"Grid"},{"attributes":{},"id":"22831","type":"DataRange1d"},{"attributes":{},"id":"22840","type":"BasicTicker"},{"attributes":{"fill_color":{"field":"fill_color"},"line_color":{"field":"line_color"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"22862","type":"Patches"},{"attributes":{},"id":"22847","type":"PanTool"},{"attributes":{},"id":"22872","type":"UnionRenderers"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"22853","type":"BoxAnnotation"},{"attributes":{"overlay":{"id":"22853"}},"id":"22849","type":"BoxZoomTool"},{"attributes":{"text":""},"id":"22866","type":"Title"},{"attributes":{},"id":"22852","type":"HelpTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"22847"},{"id":"22848"},{"id":"22849"},{"id":"22850"},{"id":"22851"},{"id":"22852"}]},"id":"22854","type":"Toolbar"},{"attributes":{"data":{"fill_color":["#43a2ca","#a8ddb5"],"line_color":["#43a2ca","#a8ddb5"],"xs":[[1,2,3],[4,5,6,5]],"ys":[[1,2,1],[4,5,5,4]]},"selected":{"id":"22873"},"selection_policy":{"id":"22872"}},"id":"22861","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"22861"},"glyph":{"id":"22862"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"22863"},"selection_glyph":null,"view":{"id":"22865"}},"id":"22864","type":"GlyphRenderer"},{"attributes":{"below":[{"id":"22839"}],"center":[{"id":"22842"},{"id":"22846"}],"left":[{"id":"22843"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"22864"}],"title":{"id":"22866"},"toolbar":{"id":"22854"},"x_range":{"id":"22831"},"x_scale":{"id":"22835"},"y_range":{"id":"22833"},"y_scale":{"id":"22837"}},"id":"22830","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"22848","type":"WheelZoomTool"},{"attributes":{},"id":"22844","type":"BasicTicker"},{"attributes":{},"id":"22873","type":"Selection"},{"attributes":{"formatter":{"id":"22869"},"ticker":{"id":"22840"}},"id":"22839","type":"LinearAxis"}],"root_ids":["22830"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"0080ee3d-2b68-4272-a38c-c0da9796c5bb","root_ids":["22830"],"roots":{"22830":"c0ee1df0-8537-4f71-aee1-85be13beb093"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();