(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("de63a642-7ed0-41fd-8cd7-ad10aca571c8");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'de63a642-7ed0-41fd-8cd7-ad10aca571c8' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"da2d7c05-7a59-4504-8264-13147d562d56":{"roots":{"references":[{"attributes":{},"id":"19639","type":"BasicTickFormatter"},{"attributes":{"line_color":{"field":"line_color"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"19632","type":"MultiLine"},{"attributes":{"source":{"id":"19631"}},"id":"19635","type":"CDSView"},{"attributes":{"data":{"line_color":["red","green"],"xs":[[1,2,3],[2,3,4]],"ys":[[6,7,2],[4,5,7]]},"selected":{"id":"19643"},"selection_policy":{"id":"19642"}},"id":"19631","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"19633","type":"MultiLine"},{"attributes":{},"id":"19617","type":"PanTool"},{"attributes":{},"id":"19643","type":"Selection"},{"attributes":{"axis":{"id":"19613"},"dimension":1,"ticker":null},"id":"19616","type":"Grid"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"19617"},{"id":"19618"},{"id":"19619"},{"id":"19620"},{"id":"19621"},{"id":"19622"}]},"id":"19624","type":"Toolbar"},{"attributes":{},"id":"19610","type":"BasicTicker"},{"attributes":{},"id":"19618","type":"WheelZoomTool"},{"attributes":{},"id":"19621","type":"ResetTool"},{"attributes":{"formatter":{"id":"19639"},"ticker":{"id":"19610"}},"id":"19609","type":"LinearAxis"},{"attributes":{"below":[{"id":"19609"}],"center":[{"id":"19612"},{"id":"19616"}],"left":[{"id":"19613"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"19634"}],"title":{"id":"19636"},"toolbar":{"id":"19624"},"x_range":{"id":"19601"},"x_scale":{"id":"19605"},"y_range":{"id":"19603"},"y_scale":{"id":"19607"}},"id":"19600","subtype":"Figure","type":"Plot"},{"attributes":{"text":""},"id":"19636","type":"Title"},{"attributes":{"data_source":{"id":"19631"},"glyph":{"id":"19632"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"19633"},"selection_glyph":null,"view":{"id":"19635"}},"id":"19634","type":"GlyphRenderer"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"19623","type":"BoxAnnotation"},{"attributes":{},"id":"19641","type":"BasicTickFormatter"},{"attributes":{},"id":"19607","type":"LinearScale"},{"attributes":{},"id":"19603","type":"DataRange1d"},{"attributes":{"overlay":{"id":"19623"}},"id":"19619","type":"BoxZoomTool"},{"attributes":{},"id":"19622","type":"HelpTool"},{"attributes":{},"id":"19620","type":"SaveTool"},{"attributes":{"axis":{"id":"19609"},"ticker":null},"id":"19612","type":"Grid"},{"attributes":{},"id":"19605","type":"LinearScale"},{"attributes":{},"id":"19614","type":"BasicTicker"},{"attributes":{"formatter":{"id":"19641"},"ticker":{"id":"19614"}},"id":"19613","type":"LinearAxis"},{"attributes":{},"id":"19601","type":"DataRange1d"},{"attributes":{},"id":"19642","type":"UnionRenderers"}],"root_ids":["19600"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"da2d7c05-7a59-4504-8264-13147d562d56","root_ids":["19600"],"roots":{"19600":"de63a642-7ed0-41fd-8cd7-ad10aca571c8"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();