(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("2da20e0a-97b9-4967-9c0a-f01fe339f940");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '2da20e0a-97b9-4967-9c0a-f01fe339f940' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"b4f24c0f-958f-4577-a012-9c9828e64dbf":{"roots":{"references":[{"attributes":{"axis":{"id":"20689"},"ticker":null},"id":"20692","type":"Grid"},{"attributes":{},"id":"20690","type":"BasicTicker"},{"attributes":{},"id":"20687","type":"LinearScale"},{"attributes":{},"id":"20719","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[1,2,3,2,5]},"selected":{"id":"20723"},"selection_policy":{"id":"20722"}},"id":"20711","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"20721"},"ticker":{"id":"20694"}},"id":"20693","type":"LinearAxis"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"20703","type":"BoxAnnotation"},{"attributes":{},"id":"20681","type":"DataRange1d"},{"attributes":{},"id":"20722","type":"UnionRenderers"},{"attributes":{},"id":"20698","type":"WheelZoomTool"},{"attributes":{},"id":"20685","type":"LinearScale"},{"attributes":{"axis":{"id":"20693"},"dimension":1,"ticker":null},"id":"20696","type":"Grid"},{"attributes":{},"id":"20697","type":"PanTool"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#FB8072"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20713","type":"Step"},{"attributes":{},"id":"20694","type":"BasicTicker"},{"attributes":{"overlay":{"id":"20703"}},"id":"20699","type":"BoxZoomTool"},{"attributes":{"text":""},"id":"20716","type":"Title"},{"attributes":{},"id":"20683","type":"DataRange1d"},{"attributes":{},"id":"20701","type":"ResetTool"},{"attributes":{"line_color":{"value":"#FB8072"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20712","type":"Step"},{"attributes":{},"id":"20721","type":"BasicTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"20697"},{"id":"20698"},{"id":"20699"},{"id":"20700"},{"id":"20701"},{"id":"20702"}]},"id":"20704","type":"Toolbar"},{"attributes":{},"id":"20723","type":"Selection"},{"attributes":{},"id":"20702","type":"HelpTool"},{"attributes":{"source":{"id":"20711"}},"id":"20715","type":"CDSView"},{"attributes":{"formatter":{"id":"20719"},"ticker":{"id":"20690"}},"id":"20689","type":"LinearAxis"},{"attributes":{"data_source":{"id":"20711"},"glyph":{"id":"20712"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"20713"},"selection_glyph":null,"view":{"id":"20715"}},"id":"20714","type":"GlyphRenderer"},{"attributes":{},"id":"20700","type":"SaveTool"},{"attributes":{"below":[{"id":"20689"}],"center":[{"id":"20692"},{"id":"20696"}],"left":[{"id":"20693"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"20714"}],"title":{"id":"20716"},"toolbar":{"id":"20704"},"x_range":{"id":"20681"},"x_scale":{"id":"20685"},"y_range":{"id":"20683"},"y_scale":{"id":"20687"}},"id":"20680","subtype":"Figure","type":"Plot"}],"root_ids":["20680"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"b4f24c0f-958f-4577-a012-9c9828e64dbf","root_ids":["20680"],"roots":{"20680":"2da20e0a-97b9-4967-9c0a-f01fe339f940"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();