(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("8860758c-c99e-460b-a75d-cd7de6fe9af3");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '8860758c-c99e-460b-a75d-cd7de6fe9af3' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"c319e639-ea36-437a-a5f5-ca4239df3cbe":{"roots":{"references":[{"attributes":{"formatter":{"id":"20145"},"ticker":{"id":"20118"}},"id":"20117","type":"LinearAxis"},{"attributes":{"text":""},"id":"20140","type":"Title"},{"attributes":{"source":{"id":"20135"}},"id":"20139","type":"CDSView"},{"attributes":{},"id":"20121","type":"PanTool"},{"attributes":{"axis":{"id":"20117"},"dimension":1,"ticker":null},"id":"20120","type":"Grid"},{"attributes":{"angle":{"units":"rad","value":-0.7},"length":{"units":"data","value":45},"line_alpha":{"value":0.1},"line_color":{"value":"#FB8072"},"line_width":{"value":2},"x":{"field":"x"},"y":{"field":"y"}},"id":"20137","type":"Ray"},{"attributes":{},"id":"20145","type":"BasicTickFormatter"},{"attributes":{"overlay":{"id":"20127"}},"id":"20123","type":"BoxZoomTool"},{"attributes":{},"id":"20111","type":"LinearScale"},{"attributes":{},"id":"20118","type":"BasicTicker"},{"attributes":{},"id":"20147","type":"Selection"},{"attributes":{},"id":"20114","type":"BasicTicker"},{"attributes":{},"id":"20122","type":"WheelZoomTool"},{"attributes":{},"id":"20126","type":"HelpTool"},{"attributes":{},"id":"20143","type":"BasicTickFormatter"},{"attributes":{},"id":"20124","type":"SaveTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"20121"},{"id":"20122"},{"id":"20123"},{"id":"20124"},{"id":"20125"},{"id":"20126"}]},"id":"20128","type":"Toolbar"},{"attributes":{},"id":"20146","type":"UnionRenderers"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"20127","type":"BoxAnnotation"},{"attributes":{},"id":"20107","type":"DataRange1d"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"20147"},"selection_policy":{"id":"20146"}},"id":"20135","type":"ColumnDataSource"},{"attributes":{"below":[{"id":"20113"}],"center":[{"id":"20116"},{"id":"20120"}],"left":[{"id":"20117"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"20138"}],"title":{"id":"20140"},"toolbar":{"id":"20128"},"x_range":{"id":"20105"},"x_scale":{"id":"20109"},"y_range":{"id":"20107"},"y_scale":{"id":"20111"}},"id":"20104","subtype":"Figure","type":"Plot"},{"attributes":{"data_source":{"id":"20135"},"glyph":{"id":"20136"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"20137"},"selection_glyph":null,"view":{"id":"20139"}},"id":"20138","type":"GlyphRenderer"},{"attributes":{},"id":"20109","type":"LinearScale"},{"attributes":{"axis":{"id":"20113"},"ticker":null},"id":"20116","type":"Grid"},{"attributes":{},"id":"20125","type":"ResetTool"},{"attributes":{"formatter":{"id":"20143"},"ticker":{"id":"20114"}},"id":"20113","type":"LinearAxis"},{"attributes":{"angle":{"units":"rad","value":-0.7},"length":{"units":"data","value":45},"line_color":{"value":"#FB8072"},"line_width":{"value":2},"x":{"field":"x"},"y":{"field":"y"}},"id":"20136","type":"Ray"},{"attributes":{},"id":"20105","type":"DataRange1d"}],"root_ids":["20104"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"c319e639-ea36-437a-a5f5-ca4239df3cbe","root_ids":["20104"],"roots":{"20104":"8860758c-c99e-460b-a75d-cd7de6fe9af3"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();