(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("5b025375-41ff-449e-8b5b-6c9c7f3ba960");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '5b025375-41ff-449e-8b5b-6c9c7f3ba960' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"fa9962fa-c055-4707-ac2f-b62d82dd2517":{"roots":{"references":[{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#386CB0"},"line_alpha":{"value":0.1},"line_color":{"value":"#386CB0"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18923","type":"Dot"},{"attributes":{},"id":"18904","type":"BasicTicker"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"18913","type":"BoxAnnotation"},{"attributes":{},"id":"18929","type":"BasicTickFormatter"},{"attributes":{},"id":"18907","type":"PanTool"},{"attributes":{},"id":"18895","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"18907"},{"id":"18908"},{"id":"18909"},{"id":"18910"},{"id":"18911"},{"id":"18912"}]},"id":"18914","type":"Toolbar"},{"attributes":{},"id":"18911","type":"ResetTool"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"18933"},"selection_policy":{"id":"18932"}},"id":"18921","type":"ColumnDataSource"},{"attributes":{"source":{"id":"18921"}},"id":"18925","type":"CDSView"},{"attributes":{},"id":"18932","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"18921"},"glyph":{"id":"18922"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"18923"},"selection_glyph":null,"view":{"id":"18925"}},"id":"18924","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"18931"},"ticker":{"id":"18904"}},"id":"18903","type":"LinearAxis"},{"attributes":{},"id":"18897","type":"LinearScale"},{"attributes":{"axis":{"id":"18899"},"ticker":null},"id":"18902","type":"Grid"},{"attributes":{},"id":"18891","type":"DataRange1d"},{"attributes":{},"id":"18933","type":"Selection"},{"attributes":{"axis":{"id":"18903"},"dimension":1,"ticker":null},"id":"18906","type":"Grid"},{"attributes":{},"id":"18893","type":"DataRange1d"},{"attributes":{"below":[{"id":"18899"}],"center":[{"id":"18902"},{"id":"18906"}],"left":[{"id":"18903"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"18924"}],"title":{"id":"18926"},"toolbar":{"id":"18914"},"x_range":{"id":"18891"},"x_scale":{"id":"18895"},"y_range":{"id":"18893"},"y_scale":{"id":"18897"}},"id":"18890","subtype":"Figure","type":"Plot"},{"attributes":{"fill_color":{"value":"#386CB0"},"line_color":{"value":"#386CB0"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18922","type":"Dot"},{"attributes":{},"id":"18931","type":"BasicTickFormatter"},{"attributes":{"overlay":{"id":"18913"}},"id":"18909","type":"BoxZoomTool"},{"attributes":{},"id":"18912","type":"HelpTool"},{"attributes":{"formatter":{"id":"18929"},"ticker":{"id":"18900"}},"id":"18899","type":"LinearAxis"},{"attributes":{},"id":"18908","type":"WheelZoomTool"},{"attributes":{"text":""},"id":"18926","type":"Title"},{"attributes":{},"id":"18910","type":"SaveTool"},{"attributes":{},"id":"18900","type":"BasicTicker"}],"root_ids":["18890"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"fa9962fa-c055-4707-ac2f-b62d82dd2517","root_ids":["18890"],"roots":{"18890":"5b025375-41ff-449e-8b5b-6c9c7f3ba960"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();