(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("37b7b037-6b3a-4bd9-8438-a7405260dfc6");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '37b7b037-6b3a-4bd9-8438-a7405260dfc6' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"43cc3318-7639-4b74-af7c-caa46cd42d48":{"roots":{"references":[{"attributes":{},"id":"20054","type":"HelpTool"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#B3DE69"},"left":{"field":"left"},"line_alpha":{"value":0.1},"line_color":{"value":"#B3DE69"},"right":{"field":"right"},"top":{"field":"top"}},"id":"20065","type":"Quad"},{"attributes":{"axis":{"id":"20041"},"ticker":null},"id":"20044","type":"Grid"},{"attributes":{"formatter":{"id":"20073"},"ticker":{"id":"20046"}},"id":"20045","type":"LinearAxis"},{"attributes":{},"id":"20071","type":"BasicTickFormatter"},{"attributes":{},"id":"20046","type":"BasicTicker"},{"attributes":{"source":{"id":"20063"}},"id":"20067","type":"CDSView"},{"attributes":{},"id":"20050","type":"WheelZoomTool"},{"attributes":{},"id":"20053","type":"ResetTool"},{"attributes":{},"id":"20033","type":"DataRange1d"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"20055","type":"BoxAnnotation"},{"attributes":{"data":{"bottom":[1,2,3],"left":[1,2,3],"right":[1.2,2.5,3.7],"top":[2,3,4]},"selected":{"id":"20075"},"selection_policy":{"id":"20074"}},"id":"20063","type":"ColumnDataSource"},{"attributes":{},"id":"20039","type":"LinearScale"},{"attributes":{"overlay":{"id":"20055"}},"id":"20051","type":"BoxZoomTool"},{"attributes":{},"id":"20035","type":"DataRange1d"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":"#B3DE69"},"left":{"field":"left"},"line_color":{"value":"#B3DE69"},"right":{"field":"right"},"top":{"field":"top"}},"id":"20064","type":"Quad"},{"attributes":{},"id":"20075","type":"Selection"},{"attributes":{"axis":{"id":"20045"},"dimension":1,"ticker":null},"id":"20048","type":"Grid"},{"attributes":{"formatter":{"id":"20071"},"ticker":{"id":"20042"}},"id":"20041","type":"LinearAxis"},{"attributes":{},"id":"20037","type":"LinearScale"},{"attributes":{"text":""},"id":"20068","type":"Title"},{"attributes":{"data_source":{"id":"20063"},"glyph":{"id":"20064"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"20065"},"selection_glyph":null,"view":{"id":"20067"}},"id":"20066","type":"GlyphRenderer"},{"attributes":{"below":[{"id":"20041"}],"center":[{"id":"20044"},{"id":"20048"}],"left":[{"id":"20045"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"20066"}],"title":{"id":"20068"},"toolbar":{"id":"20056"},"x_range":{"id":"20033"},"x_scale":{"id":"20037"},"y_range":{"id":"20035"},"y_scale":{"id":"20039"}},"id":"20032","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"20049","type":"PanTool"},{"attributes":{},"id":"20052","type":"SaveTool"},{"attributes":{},"id":"20074","type":"UnionRenderers"},{"attributes":{},"id":"20073","type":"BasicTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"20049"},{"id":"20050"},{"id":"20051"},{"id":"20052"},{"id":"20053"},{"id":"20054"}]},"id":"20056","type":"Toolbar"},{"attributes":{},"id":"20042","type":"BasicTicker"}],"root_ids":["20032"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"43cc3318-7639-4b74-af7c-caa46cd42d48","root_ids":["20032"],"roots":{"20032":"37b7b037-6b3a-4bd9-8438-a7405260dfc6"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();