(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("29eeec4c-32d3-4c29-8108-5a949b983972");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '29eeec4c-32d3-4c29-8108-5a949b983972' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"9385fc02-b99f-4344-84d0-5d4da2cfdacd":{"roots":{"references":[{"attributes":{},"id":"22051","type":"DataRange1d"},{"attributes":{"overlay":{"id":"22071"}},"id":"22067","type":"BoxZoomTool"},{"attributes":{"below":[{"id":"22057"}],"center":[{"id":"22060"},{"id":"22064"}],"left":[{"id":"22061"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"22082"}],"title":{"id":"22084"},"toolbar":{"id":"22072"},"x_range":{"id":"22049"},"x_scale":{"id":"22053"},"y_range":{"id":"22051"},"y_scale":{"id":"22055"}},"id":"22048","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"22049","type":"DataRange1d"},{"attributes":{},"id":"22053","type":"LinearScale"},{"attributes":{"axis":{"id":"22061"},"dimension":1,"ticker":null},"id":"22064","type":"Grid"},{"attributes":{},"id":"22089","type":"BasicTickFormatter"},{"attributes":{},"id":"22068","type":"SaveTool"},{"attributes":{},"id":"22065","type":"PanTool"},{"attributes":{},"id":"22090","type":"UnionRenderers"},{"attributes":{},"id":"22066","type":"WheelZoomTool"},{"attributes":{"fill_alpha":0.1,"fill_color":"#99D594","x1":{"field":"x1"},"x2":{"field":"x2"},"y":{"field":"y"}},"id":"22081","type":"HArea"},{"attributes":{},"id":"22069","type":"ResetTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"22071","type":"BoxAnnotation"},{"attributes":{"data":{"x1":[0,0,0],"x2":[1,4,2],"y":[1,2,3]},"selected":{"id":"22091"},"selection_policy":{"id":"22090"}},"id":"22079","type":"ColumnDataSource"},{"attributes":{},"id":"22062","type":"BasicTicker"},{"attributes":{"source":{"id":"22079"}},"id":"22083","type":"CDSView"},{"attributes":{"text":""},"id":"22084","type":"Title"},{"attributes":{"fill_color":"#99D594","x1":{"field":"x1"},"x2":{"field":"x2"},"y":{"field":"y"}},"id":"22080","type":"HArea"},{"attributes":{"axis":{"id":"22057"},"ticker":null},"id":"22060","type":"Grid"},{"attributes":{"formatter":{"id":"22089"},"ticker":{"id":"22062"}},"id":"22061","type":"LinearAxis"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"22065"},{"id":"22066"},{"id":"22067"},{"id":"22068"},{"id":"22069"},{"id":"22070"}]},"id":"22072","type":"Toolbar"},{"attributes":{},"id":"22087","type":"BasicTickFormatter"},{"attributes":{},"id":"22070","type":"HelpTool"},{"attributes":{"formatter":{"id":"22087"},"ticker":{"id":"22058"}},"id":"22057","type":"LinearAxis"},{"attributes":{},"id":"22055","type":"LinearScale"},{"attributes":{},"id":"22091","type":"Selection"},{"attributes":{"data_source":{"id":"22079"},"glyph":{"id":"22080"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"22081"},"selection_glyph":null,"view":{"id":"22083"}},"id":"22082","type":"GlyphRenderer"},{"attributes":{},"id":"22058","type":"BasicTicker"}],"root_ids":["22048"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"9385fc02-b99f-4344-84d0-5d4da2cfdacd","root_ids":["22048"],"roots":{"22048":"29eeec4c-32d3-4c29-8108-5a949b983972"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();