(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("97d8ed86-cad5-4645-a003-b00aa4042650");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '97d8ed86-cad5-4645-a003-b00aa4042650' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"4e9c5506-68cd-4697-9aa8-7ea8cf970a69":{"roots":{"references":[{"attributes":{},"id":"21619","type":"DataRange1d"},{"attributes":{},"id":"21623","type":"LinearScale"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#DD1C77"},"line_alpha":{"value":0.1},"line_color":{"value":"#DD1C77"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"21649","type":"CircleX"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"21639","type":"BoxAnnotation"},{"attributes":{"overlay":{"id":"21639"}},"id":"21635","type":"BoxZoomTool"},{"attributes":{"axis":{"id":"21629"},"dimension":1,"ticker":null},"id":"21632","type":"Grid"},{"attributes":{"formatter":{"id":"21655"},"ticker":{"id":"21626"}},"id":"21625","type":"LinearAxis"},{"attributes":{},"id":"21655","type":"BasicTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"21633"},{"id":"21634"},{"id":"21635"},{"id":"21636"},{"id":"21637"},{"id":"21638"}]},"id":"21640","type":"Toolbar"},{"attributes":{},"id":"21636","type":"SaveTool"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"21659"},"selection_policy":{"id":"21658"}},"id":"21647","type":"ColumnDataSource"},{"attributes":{"source":{"id":"21647"}},"id":"21651","type":"CDSView"},{"attributes":{},"id":"21638","type":"HelpTool"},{"attributes":{"axis":{"id":"21625"},"ticker":null},"id":"21628","type":"Grid"},{"attributes":{},"id":"21633","type":"PanTool"},{"attributes":{"text":""},"id":"21652","type":"Title"},{"attributes":{},"id":"21617","type":"DataRange1d"},{"attributes":{},"id":"21657","type":"BasicTickFormatter"},{"attributes":{"below":[{"id":"21625"}],"center":[{"id":"21628"},{"id":"21632"}],"left":[{"id":"21629"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"21650"}],"title":{"id":"21652"},"toolbar":{"id":"21640"},"x_range":{"id":"21617"},"x_scale":{"id":"21621"},"y_range":{"id":"21619"},"y_scale":{"id":"21623"}},"id":"21616","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"21621","type":"LinearScale"},{"attributes":{"formatter":{"id":"21657"},"ticker":{"id":"21630"}},"id":"21629","type":"LinearAxis"},{"attributes":{},"id":"21637","type":"ResetTool"},{"attributes":{},"id":"21658","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"21647"},"glyph":{"id":"21648"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"21649"},"selection_glyph":null,"view":{"id":"21651"}},"id":"21650","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.2},"fill_color":{"value":"#DD1C77"},"line_color":{"value":"#DD1C77"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"21648","type":"CircleX"},{"attributes":{},"id":"21659","type":"Selection"},{"attributes":{},"id":"21626","type":"BasicTicker"},{"attributes":{},"id":"21630","type":"BasicTicker"},{"attributes":{},"id":"21634","type":"WheelZoomTool"}],"root_ids":["21616"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"4e9c5506-68cd-4697-9aa8-7ea8cf970a69","root_ids":["21616"],"roots":{"21616":"97d8ed86-cad5-4645-a003-b00aa4042650"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();