(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("3c7f921d-5615-45d8-ab9f-5e35fa3bf861");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '3c7f921d-5615-45d8-ab9f-5e35fa3bf861' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"1226bd5c-645e-4654-a601-75100cf4f138":{"roots":{"references":[{"attributes":{"formatter":{"id":"20791"},"ticker":{"id":"20762"}},"id":"20761","type":"LinearAxis"},{"attributes":{},"id":"20753","type":"DataRange1d"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#99D594"},"line_alpha":{"value":0.1},"line_color":{"value":"#99D594"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20785","type":"Triangle"},{"attributes":{"axis":{"id":"20765"},"dimension":1,"ticker":null},"id":"20768","type":"Grid"},{"attributes":{"source":{"id":"20783"}},"id":"20787","type":"CDSView"},{"attributes":{},"id":"20759","type":"LinearScale"},{"attributes":{"axis":{"id":"20761"},"ticker":null},"id":"20764","type":"Grid"},{"attributes":{},"id":"20770","type":"WheelZoomTool"},{"attributes":{"text":""},"id":"20788","type":"Title"},{"attributes":{},"id":"20769","type":"PanTool"},{"attributes":{},"id":"20762","type":"BasicTicker"},{"attributes":{"data":{"size":[10,20,25],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"20795"},"selection_policy":{"id":"20794"}},"id":"20783","type":"ColumnDataSource"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"20775","type":"BoxAnnotation"},{"attributes":{"formatter":{"id":"20793"},"ticker":{"id":"20766"}},"id":"20765","type":"LinearAxis"},{"attributes":{},"id":"20793","type":"BasicTickFormatter"},{"attributes":{},"id":"20794","type":"UnionRenderers"},{"attributes":{},"id":"20755","type":"DataRange1d"},{"attributes":{"fill_color":{"value":"#99D594"},"line_color":{"value":"#99D594"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20784","type":"Triangle"},{"attributes":{},"id":"20795","type":"Selection"},{"attributes":{},"id":"20773","type":"ResetTool"},{"attributes":{},"id":"20774","type":"HelpTool"},{"attributes":{},"id":"20766","type":"BasicTicker"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"20769"},{"id":"20770"},{"id":"20771"},{"id":"20772"},{"id":"20773"},{"id":"20774"}]},"id":"20776","type":"Toolbar"},{"attributes":{},"id":"20772","type":"SaveTool"},{"attributes":{},"id":"20757","type":"LinearScale"},{"attributes":{"below":[{"id":"20761"}],"center":[{"id":"20764"},{"id":"20768"}],"left":[{"id":"20765"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"20786"}],"title":{"id":"20788"},"toolbar":{"id":"20776"},"x_range":{"id":"20753"},"x_scale":{"id":"20757"},"y_range":{"id":"20755"},"y_scale":{"id":"20759"}},"id":"20752","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"20791","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"20783"},"glyph":{"id":"20784"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"20785"},"selection_glyph":null,"view":{"id":"20787"}},"id":"20786","type":"GlyphRenderer"},{"attributes":{"overlay":{"id":"20775"}},"id":"20771","type":"BoxZoomTool"}],"root_ids":["20752"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"1226bd5c-645e-4654-a601-75100cf4f138","root_ids":["20752"],"roots":{"20752":"3c7f921d-5615-45d8-ab9f-5e35fa3bf861"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();