(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("67feb0cd-90a7-4418-a515-4d4f09d25652");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '67feb0cd-90a7-4418-a515-4d4f09d25652' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"82244254-658b-4631-8a75-787c30868f8d":{"roots":{"references":[{"attributes":{},"id":"21420","type":"SaveTool"},{"attributes":{},"id":"21405","type":"LinearScale"},{"attributes":{"axis":{"id":"21409"},"ticker":null},"id":"21412","type":"Grid"},{"attributes":{"text":""},"id":"21436","type":"Title"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#F0027F"},"line_alpha":{"value":0.1},"line_color":{"value":"#F0027F"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"21433","type":"Asterisk"},{"attributes":{"formatter":{"id":"21439"},"ticker":{"id":"21410"}},"id":"21409","type":"LinearAxis"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"21417"},{"id":"21418"},{"id":"21419"},{"id":"21420"},{"id":"21421"},{"id":"21422"}]},"id":"21424","type":"Toolbar"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"21423","type":"BoxAnnotation"},{"attributes":{"axis":{"id":"21413"},"dimension":1,"ticker":null},"id":"21416","type":"Grid"},{"attributes":{},"id":"21414","type":"BasicTicker"},{"attributes":{},"id":"21417","type":"PanTool"},{"attributes":{"data_source":{"id":"21431"},"glyph":{"id":"21432"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"21433"},"selection_glyph":null,"view":{"id":"21435"}},"id":"21434","type":"GlyphRenderer"},{"attributes":{},"id":"21422","type":"HelpTool"},{"attributes":{"fill_color":{"value":"#F0027F"},"line_color":{"value":"#F0027F"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"21432","type":"Asterisk"},{"attributes":{},"id":"21439","type":"BasicTickFormatter"},{"attributes":{"overlay":{"id":"21423"}},"id":"21419","type":"BoxZoomTool"},{"attributes":{"below":[{"id":"21409"}],"center":[{"id":"21412"},{"id":"21416"}],"left":[{"id":"21413"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"21434"}],"title":{"id":"21436"},"toolbar":{"id":"21424"},"x_range":{"id":"21401"},"x_scale":{"id":"21405"},"y_range":{"id":"21403"},"y_scale":{"id":"21407"}},"id":"21400","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"21418","type":"WheelZoomTool"},{"attributes":{},"id":"21403","type":"DataRange1d"},{"attributes":{},"id":"21401","type":"DataRange1d"},{"attributes":{"source":{"id":"21431"}},"id":"21435","type":"CDSView"},{"attributes":{},"id":"21441","type":"BasicTickFormatter"},{"attributes":{},"id":"21410","type":"BasicTicker"},{"attributes":{},"id":"21421","type":"ResetTool"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"21443"},"selection_policy":{"id":"21442"}},"id":"21431","type":"ColumnDataSource"},{"attributes":{},"id":"21407","type":"LinearScale"},{"attributes":{},"id":"21443","type":"Selection"},{"attributes":{},"id":"21442","type":"UnionRenderers"},{"attributes":{"formatter":{"id":"21441"},"ticker":{"id":"21414"}},"id":"21413","type":"LinearAxis"}],"root_ids":["21400"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"82244254-658b-4631-8a75-787c30868f8d","root_ids":["21400"],"roots":{"21400":"67feb0cd-90a7-4418-a515-4d4f09d25652"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();