(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("1dc5dfad-4cf4-40d8-94bd-70daea2f3aee");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '1dc5dfad-4cf4-40d8-94bd-70daea2f3aee' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"ff6c371a-d588-4c62-b8f5-6bfcd9072f5d":{"roots":{"references":[{"attributes":{"axis":{"id":"19263"},"dimension":1,"ticker":null},"id":"19266","type":"Grid"},{"attributes":{},"id":"19291","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"19281"},"glyph":{"id":"19282"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"19283"},"selection_glyph":null,"view":{"id":"19285"}},"id":"19284","type":"GlyphRenderer"},{"attributes":{},"id":"19253","type":"DataRange1d"},{"attributes":{},"id":"19251","type":"DataRange1d"},{"attributes":{},"id":"19272","type":"HelpTool"},{"attributes":{},"id":"19289","type":"BasicTickFormatter"},{"attributes":{"text":""},"id":"19286","type":"Title"},{"attributes":{"axis":{"id":"19259"},"ticker":null},"id":"19262","type":"Grid"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"19267"},{"id":"19268"},{"id":"19269"},{"id":"19270"},{"id":"19271"},{"id":"19272"}]},"id":"19274","type":"Toolbar"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"line_alpha":{"value":0.1},"line_color":{"value":"#74ADD1"},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"19283","type":"Hex"},{"attributes":{},"id":"19267","type":"PanTool"},{"attributes":{},"id":"19255","type":"LinearScale"},{"attributes":{},"id":"19292","type":"UnionRenderers"},{"attributes":{"below":[{"id":"19259"}],"center":[{"id":"19262"},{"id":"19266"}],"left":[{"id":"19263"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"19284"}],"title":{"id":"19286"},"toolbar":{"id":"19274"},"x_range":{"id":"19251"},"x_scale":{"id":"19255"},"y_range":{"id":"19253"},"y_scale":{"id":"19257"}},"id":"19250","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"19271","type":"ResetTool"},{"attributes":{"overlay":{"id":"19273"}},"id":"19269","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"19291"},"ticker":{"id":"19264"}},"id":"19263","type":"LinearAxis"},{"attributes":{},"id":"19270","type":"SaveTool"},{"attributes":{},"id":"19257","type":"LinearScale"},{"attributes":{"formatter":{"id":"19289"},"ticker":{"id":"19260"}},"id":"19259","type":"LinearAxis"},{"attributes":{"source":{"id":"19281"}},"id":"19285","type":"CDSView"},{"attributes":{"fill_color":{"value":null},"line_color":{"value":"#74ADD1"},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"19282","type":"Hex"},{"attributes":{},"id":"19260","type":"BasicTicker"},{"attributes":{"data":{"size":[10,20,30],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"19293"},"selection_policy":{"id":"19292"}},"id":"19281","type":"ColumnDataSource"},{"attributes":{},"id":"19264","type":"BasicTicker"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"19273","type":"BoxAnnotation"},{"attributes":{},"id":"19268","type":"WheelZoomTool"},{"attributes":{},"id":"19293","type":"Selection"}],"root_ids":["19250"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"ff6c371a-d588-4c62-b8f5-6bfcd9072f5d","root_ids":["19250"],"roots":{"19250":"1dc5dfad-4cf4-40d8-94bd-70daea2f3aee"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();