(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("740aa138-bd6a-4281-891d-86cffd3a4abe");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '740aa138-bd6a-4281-891d-86cffd3a4abe' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"2248ce92-e020-4e0b-a05e-3a1b16887fa4":{"roots":{"references":[{"attributes":{},"id":"23897","type":"Selection"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"23865"},{"id":"23866"},{"id":"23867"},{"id":"23868"},{"id":"23869"},{"id":"23870"}]},"id":"23872","type":"Toolbar"},{"attributes":{},"id":"23849","type":"DataRange1d"},{"attributes":{},"id":"23851","type":"DataRange1d"},{"attributes":{"source":{"id":"23879"}},"id":"23883","type":"CDSView"},{"attributes":{"axis":{"id":"23861"},"dimension":1,"ticker":null},"id":"23864","type":"Grid"},{"attributes":{},"id":"23869","type":"ResetTool"},{"attributes":{"below":[{"id":"23857"}],"center":[{"id":"23860"},{"id":"23864"}],"left":[{"id":"23861"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"23882"},{"id":"23887"}],"title":{"id":"23847"},"toolbar":{"id":"23872"},"x_range":{"id":"23849"},"x_scale":{"id":"23853"},"y_range":{"id":"23851"},"y_scale":{"id":"23855"}},"id":"23846","subtype":"Figure","type":"Plot"},{"attributes":{"fill_color":{"value":"white"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"23885","type":"Circle"},{"attributes":{},"id":"23891","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"23879"},"glyph":{"id":"23880"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"23881"},"selection_glyph":null,"view":{"id":"23883"}},"id":"23882","type":"GlyphRenderer"},{"attributes":{},"id":"23866","type":"WheelZoomTool"},{"attributes":{"data_source":{"id":"23884"},"glyph":{"id":"23885"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"23886"},"selection_glyph":null,"view":{"id":"23888"}},"id":"23887","type":"GlyphRenderer"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,6,4,5]},"selected":{"id":"23897"},"selection_policy":{"id":"23896"}},"id":"23884","type":"ColumnDataSource"},{"attributes":{"text":"example"},"id":"23847","type":"Title"},{"attributes":{},"id":"23894","type":"UnionRenderers"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"23871","type":"BoxAnnotation"},{"attributes":{"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"23880","type":"Line"},{"attributes":{},"id":"23865","type":"PanTool"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,6,4,5]},"selected":{"id":"23895"},"selection_policy":{"id":"23894"}},"id":"23879","type":"ColumnDataSource"},{"attributes":{},"id":"23862","type":"BasicTicker"},{"attributes":{},"id":"23896","type":"UnionRenderers"},{"attributes":{},"id":"23853","type":"LinearScale"},{"attributes":{},"id":"23858","type":"BasicTicker"},{"attributes":{},"id":"23893","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"white"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"23886","type":"Circle"},{"attributes":{},"id":"23855","type":"LinearScale"},{"attributes":{"source":{"id":"23884"}},"id":"23888","type":"CDSView"},{"attributes":{"overlay":{"id":"23871"}},"id":"23867","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"23891"},"ticker":{"id":"23858"}},"id":"23857","type":"LinearAxis"},{"attributes":{},"id":"23895","type":"Selection"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"23881","type":"Line"},{"attributes":{},"id":"23870","type":"HelpTool"},{"attributes":{"axis":{"id":"23857"},"ticker":null},"id":"23860","type":"Grid"},{"attributes":{},"id":"23868","type":"SaveTool"},{"attributes":{"formatter":{"id":"23893"},"ticker":{"id":"23862"}},"id":"23861","type":"LinearAxis"}],"root_ids":["23846"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"2248ce92-e020-4e0b-a05e-3a1b16887fa4","root_ids":["23846"],"roots":{"23846":"740aa138-bd6a-4281-891d-86cffd3a4abe"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();