(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("2a4624eb-5f65-4eed-846f-ff540ad244fe");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '2a4624eb-5f65-4eed-846f-ff540ad244fe' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"7793188e-65ca-4da5-9b0e-6b007d729fac":{"roots":{"references":[{"attributes":{"formatter":{"id":"19783"},"ticker":{"id":"19754"}},"id":"19753","type":"LinearAxis"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"19787"},"selection_policy":{"id":"19786"}},"id":"19775","type":"ColumnDataSource"},{"attributes":{},"id":"19747","type":"DataRange1d"},{"attributes":{},"id":"19754","type":"BasicTicker"},{"attributes":{},"id":"19783","type":"BasicTickFormatter"},{"attributes":{"below":[{"id":"19753"}],"center":[{"id":"19756"},{"id":"19760"}],"left":[{"id":"19757"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"19778"}],"title":{"id":"19780"},"toolbar":{"id":"19768"},"x_range":{"id":"19745"},"x_scale":{"id":"19749"},"y_range":{"id":"19747"},"y_scale":{"id":"19751"}},"id":"19744","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"19787","type":"Selection"},{"attributes":{"angle":{"units":"rad","value":-0.7},"fill_color":{"value":"#1D91C0"},"height":{"units":"data","value":0.4},"line_color":{"value":"#1D91C0"},"width":{"units":"data","value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"19776","type":"Oval"},{"attributes":{"source":{"id":"19775"}},"id":"19779","type":"CDSView"},{"attributes":{"overlay":{"id":"19767"}},"id":"19763","type":"BoxZoomTool"},{"attributes":{"axis":{"id":"19757"},"dimension":1,"ticker":null},"id":"19760","type":"Grid"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"19767","type":"BoxAnnotation"},{"attributes":{"text":""},"id":"19780","type":"Title"},{"attributes":{},"id":"19751","type":"LinearScale"},{"attributes":{},"id":"19758","type":"BasicTicker"},{"attributes":{},"id":"19749","type":"LinearScale"},{"attributes":{},"id":"19766","type":"HelpTool"},{"attributes":{},"id":"19761","type":"PanTool"},{"attributes":{},"id":"19785","type":"BasicTickFormatter"},{"attributes":{},"id":"19764","type":"SaveTool"},{"attributes":{"axis":{"id":"19753"},"ticker":null},"id":"19756","type":"Grid"},{"attributes":{},"id":"19745","type":"DataRange1d"},{"attributes":{},"id":"19762","type":"WheelZoomTool"},{"attributes":{"formatter":{"id":"19785"},"ticker":{"id":"19758"}},"id":"19757","type":"LinearAxis"},{"attributes":{"angle":{"units":"rad","value":-0.7},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1D91C0"},"height":{"units":"data","value":0.4},"line_alpha":{"value":0.1},"line_color":{"value":"#1D91C0"},"width":{"units":"data","value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"19777","type":"Oval"},{"attributes":{},"id":"19765","type":"ResetTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"19761"},{"id":"19762"},{"id":"19763"},{"id":"19764"},{"id":"19765"},{"id":"19766"}]},"id":"19768","type":"Toolbar"},{"attributes":{},"id":"19786","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"19775"},"glyph":{"id":"19776"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"19777"},"selection_glyph":null,"view":{"id":"19779"}},"id":"19778","type":"GlyphRenderer"}],"root_ids":["19744"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"7793188e-65ca-4da5-9b0e-6b007d729fac","root_ids":["19744"],"roots":{"19744":"2a4624eb-5f65-4eed-846f-ff540ad244fe"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();