(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("d8a1bc38-26b4-4415-8cb4-aebd9ab9ad04");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'd8a1bc38-26b4-4415-8cb4-aebd9ab9ad04' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"600b55e2-29cf-44f4-8ce9-74ac1247ba95":{"roots":{"references":[{"attributes":{"axis":{"id":"23563"},"dimension":1,"ticker":null},"id":"23566","type":"Grid"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"23567"},{"id":"23568"},{"id":"23569"},{"id":"23570"},{"id":"23571"},{"id":"23572"}]},"id":"23574","type":"Toolbar"},{"attributes":{},"id":"23567","type":"PanTool"},{"attributes":{},"id":"23593","type":"Selection"},{"attributes":{"below":[{"id":"23559"}],"center":[{"id":"23562"},{"id":"23566"}],"left":[{"id":"23563"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"23584"}],"title":{"id":"23586"},"toolbar":{"id":"23574"},"x_range":{"id":"23551"},"x_scale":{"id":"23555"},"y_range":{"id":"23553"},"y_scale":{"id":"23557"}},"id":"23550","subtype":"Figure","type":"Plot"},{"attributes":{"source":{"id":"23581"}},"id":"23585","type":"CDSView"},{"attributes":{"data_source":{"id":"23581"},"glyph":{"id":"23582"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"23583"},"selection_glyph":null,"view":{"id":"23585"}},"id":"23584","type":"GlyphRenderer"},{"attributes":{},"id":"23560","type":"BasicTicker"},{"attributes":{},"id":"23568","type":"WheelZoomTool"},{"attributes":{},"id":"23553","type":"DataRange1d"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"23573","type":"BoxAnnotation"},{"attributes":{"fill_color":"#99D594","x":{"field":"x"},"y1":{"field":"y1"},"y2":{"field":"y2"}},"id":"23582","type":"VArea"},{"attributes":{"axis":{"id":"23559"},"ticker":null},"id":"23562","type":"Grid"},{"attributes":{},"id":"23570","type":"SaveTool"},{"attributes":{},"id":"23571","type":"ResetTool"},{"attributes":{"formatter":{"id":"23589"},"ticker":{"id":"23560"}},"id":"23559","type":"LinearAxis"},{"attributes":{},"id":"23591","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[1,2,3],"y1":[0,0,0],"y2":[1,4,2]},"selected":{"id":"23593"},"selection_policy":{"id":"23592"}},"id":"23581","type":"ColumnDataSource"},{"attributes":{},"id":"23564","type":"BasicTicker"},{"attributes":{"text":""},"id":"23586","type":"Title"},{"attributes":{},"id":"23589","type":"BasicTickFormatter"},{"attributes":{},"id":"23555","type":"LinearScale"},{"attributes":{"formatter":{"id":"23591"},"ticker":{"id":"23564"}},"id":"23563","type":"LinearAxis"},{"attributes":{},"id":"23557","type":"LinearScale"},{"attributes":{"overlay":{"id":"23573"}},"id":"23569","type":"BoxZoomTool"},{"attributes":{},"id":"23572","type":"HelpTool"},{"attributes":{},"id":"23592","type":"UnionRenderers"},{"attributes":{},"id":"23551","type":"DataRange1d"},{"attributes":{"fill_alpha":0.1,"fill_color":"#99D594","x":{"field":"x"},"y1":{"field":"y1"},"y2":{"field":"y2"}},"id":"23583","type":"VArea"}],"root_ids":["23550"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"600b55e2-29cf-44f4-8ce9-74ac1247ba95","root_ids":["23550"],"roots":{"23550":"d8a1bc38-26b4-4415-8cb4-aebd9ab9ad04"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();