(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("84a14bf4-ecd5-4623-a3a4-c2091a5d3cbc");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '84a14bf4-ecd5-4623-a3a4-c2091a5d3cbc' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"40dde2c4-3787-4027-92e5-ef70c1245b22":{"roots":{"references":[{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"20847","type":"BoxAnnotation"},{"attributes":{},"id":"20841","type":"PanTool"},{"attributes":{},"id":"20842","type":"WheelZoomTool"},{"attributes":{"below":[{"id":"20833"}],"center":[{"id":"20836"},{"id":"20840"}],"left":[{"id":"20837"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"20858"}],"title":{"id":"20860"},"toolbar":{"id":"20848"},"x_range":{"id":"20825"},"x_scale":{"id":"20829"},"y_range":{"id":"20827"},"y_scale":{"id":"20831"}},"id":"20824","subtype":"Figure","type":"Plot"},{"attributes":{"text":""},"id":"20860","type":"Title"},{"attributes":{"fill_color":{"value":null},"line_color":{"value":"#99D594"},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20856","type":"TriangleDot"},{"attributes":{},"id":"20865","type":"BasicTickFormatter"},{"attributes":{},"id":"20825","type":"DataRange1d"},{"attributes":{"data":{"size":[10,20,25],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"20867"},"selection_policy":{"id":"20866"}},"id":"20855","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"line_alpha":{"value":0.1},"line_color":{"value":"#99D594"},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20857","type":"TriangleDot"},{"attributes":{"axis":{"id":"20837"},"dimension":1,"ticker":null},"id":"20840","type":"Grid"},{"attributes":{},"id":"20844","type":"SaveTool"},{"attributes":{},"id":"20827","type":"DataRange1d"},{"attributes":{"data_source":{"id":"20855"},"glyph":{"id":"20856"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"20857"},"selection_glyph":null,"view":{"id":"20859"}},"id":"20858","type":"GlyphRenderer"},{"attributes":{"overlay":{"id":"20847"}},"id":"20843","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"20865"},"ticker":{"id":"20838"}},"id":"20837","type":"LinearAxis"},{"attributes":{"source":{"id":"20855"}},"id":"20859","type":"CDSView"},{"attributes":{},"id":"20831","type":"LinearScale"},{"attributes":{},"id":"20863","type":"BasicTickFormatter"},{"attributes":{},"id":"20845","type":"ResetTool"},{"attributes":{},"id":"20834","type":"BasicTicker"},{"attributes":{},"id":"20866","type":"UnionRenderers"},{"attributes":{},"id":"20846","type":"HelpTool"},{"attributes":{},"id":"20829","type":"LinearScale"},{"attributes":{},"id":"20838","type":"BasicTicker"},{"attributes":{"formatter":{"id":"20863"},"ticker":{"id":"20834"}},"id":"20833","type":"LinearAxis"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"20841"},{"id":"20842"},{"id":"20843"},{"id":"20844"},{"id":"20845"},{"id":"20846"}]},"id":"20848","type":"Toolbar"},{"attributes":{"axis":{"id":"20833"},"ticker":null},"id":"20836","type":"Grid"},{"attributes":{},"id":"20867","type":"Selection"}],"root_ids":["20824"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"40dde2c4-3787-4027-92e5-ef70c1245b22","root_ids":["20824"],"roots":{"20824":"84a14bf4-ecd5-4623-a3a4-c2091a5d3cbc"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();