(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("fd0ba361-1e1b-40e5-8e43-2a391abcf7de");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'fd0ba361-1e1b-40e5-8e43-2a391abcf7de' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"7c2031c8-206c-4a3e-a59f-8c89ab10dc02":{"roots":{"references":[{"attributes":{"data_source":{"id":"21287"},"glyph":{"id":"21288"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"21289"},"selection_glyph":null,"view":{"id":"21291"}},"id":"21290","type":"GlyphRenderer"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"21273"},{"id":"21274"},{"id":"21275"},{"id":"21276"},{"id":"21277"},{"id":"21278"}]},"id":"21280","type":"Toolbar"},{"attributes":{},"id":"21270","type":"BasicTicker"},{"attributes":{},"id":"21273","type":"PanTool"},{"attributes":{},"id":"21261","type":"LinearScale"},{"attributes":{},"id":"21276","type":"SaveTool"},{"attributes":{},"id":"21257","type":"DataRange1d"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"21299"},"selection_policy":{"id":"21298"}},"id":"21287","type":"ColumnDataSource"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"21279","type":"BoxAnnotation"},{"attributes":{},"id":"21274","type":"WheelZoomTool"},{"attributes":{"source":{"id":"21287"}},"id":"21291","type":"CDSView"},{"attributes":{"overlay":{"id":"21279"}},"id":"21275","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"21295"},"ticker":{"id":"21266"}},"id":"21265","type":"LinearAxis"},{"attributes":{},"id":"21298","type":"UnionRenderers"},{"attributes":{},"id":"21259","type":"DataRange1d"},{"attributes":{},"id":"21263","type":"LinearScale"},{"attributes":{"axis":{"id":"21269"},"dimension":1,"ticker":null},"id":"21272","type":"Grid"},{"attributes":{},"id":"21299","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#DE2D26"},"line_alpha":{"value":0.1},"line_color":{"value":"#DE2D26"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"21289","type":"Y"},{"attributes":{},"id":"21266","type":"BasicTicker"},{"attributes":{},"id":"21297","type":"BasicTickFormatter"},{"attributes":{"fill_color":{"value":"#DE2D26"},"line_color":{"value":"#DE2D26"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"21288","type":"Y"},{"attributes":{},"id":"21277","type":"ResetTool"},{"attributes":{"text":""},"id":"21292","type":"Title"},{"attributes":{"formatter":{"id":"21297"},"ticker":{"id":"21270"}},"id":"21269","type":"LinearAxis"},{"attributes":{"axis":{"id":"21265"},"ticker":null},"id":"21268","type":"Grid"},{"attributes":{},"id":"21295","type":"BasicTickFormatter"},{"attributes":{},"id":"21278","type":"HelpTool"},{"attributes":{"below":[{"id":"21265"}],"center":[{"id":"21268"},{"id":"21272"}],"left":[{"id":"21269"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"21290"}],"title":{"id":"21292"},"toolbar":{"id":"21280"},"x_range":{"id":"21257"},"x_scale":{"id":"21261"},"y_range":{"id":"21259"},"y_scale":{"id":"21263"}},"id":"21256","subtype":"Figure","type":"Plot"}],"root_ids":["21256"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"7c2031c8-206c-4a3e-a59f-8c89ab10dc02","root_ids":["21256"],"roots":{"21256":"fd0ba361-1e1b-40e5-8e43-2a391abcf7de"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();