(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("0e1af288-9353-497c-95bf-2390063ca7db");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '0e1af288-9353-497c-95bf-2390063ca7db' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"2a6a49ff-0e5c-4679-b1b7-aa9b308f533e":{"roots":{"references":[{"attributes":{},"id":"19476","type":"WheelZoomTool"},{"attributes":{"formatter":{"id":"19499"},"ticker":{"id":"19472"}},"id":"19471","type":"LinearAxis"},{"attributes":{},"id":"19475","type":"PanTool"},{"attributes":{"source":{"id":"19489"}},"id":"19493","type":"CDSView"},{"attributes":{},"id":"19501","type":"Selection"},{"attributes":{},"id":"19480","type":"HelpTool"},{"attributes":{},"id":"19463","type":"LinearScale"},{"attributes":{},"id":"19468","type":"BasicTicker"},{"attributes":{"data_source":{"id":"19489"},"glyph":{"id":"19490"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"19491"},"selection_glyph":null,"view":{"id":"19493"}},"id":"19492","type":"GlyphRenderer"},{"attributes":{},"id":"19459","type":"DataRange1d"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"19481","type":"BoxAnnotation"},{"attributes":{"axis":{"id":"19471"},"dimension":1,"ticker":null},"id":"19474","type":"Grid"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"19501"},"selection_policy":{"id":"19500"}},"id":"19489","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"19467"},"ticker":null},"id":"19470","type":"Grid"},{"attributes":{},"id":"19465","type":"LinearScale"},{"attributes":{"fill_color":{"value":"#DE2D26"},"line_color":{"value":"#DE2D26"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"19490","type":"InvertedTriangle"},{"attributes":{},"id":"19499","type":"BasicTickFormatter"},{"attributes":{},"id":"19478","type":"SaveTool"},{"attributes":{"formatter":{"id":"19497"},"ticker":{"id":"19468"}},"id":"19467","type":"LinearAxis"},{"attributes":{"overlay":{"id":"19481"}},"id":"19477","type":"BoxZoomTool"},{"attributes":{},"id":"19497","type":"BasicTickFormatter"},{"attributes":{},"id":"19461","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"19475"},{"id":"19476"},{"id":"19477"},{"id":"19478"},{"id":"19479"},{"id":"19480"}]},"id":"19482","type":"Toolbar"},{"attributes":{},"id":"19479","type":"ResetTool"},{"attributes":{"text":""},"id":"19494","type":"Title"},{"attributes":{"below":[{"id":"19467"}],"center":[{"id":"19470"},{"id":"19474"}],"left":[{"id":"19471"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"19492"}],"title":{"id":"19494"},"toolbar":{"id":"19482"},"x_range":{"id":"19459"},"x_scale":{"id":"19463"},"y_range":{"id":"19461"},"y_scale":{"id":"19465"}},"id":"19458","subtype":"Figure","type":"Plot"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#DE2D26"},"line_alpha":{"value":0.1},"line_color":{"value":"#DE2D26"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"19491","type":"InvertedTriangle"},{"attributes":{},"id":"19472","type":"BasicTicker"},{"attributes":{},"id":"19500","type":"UnionRenderers"}],"root_ids":["19458"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"2a6a49ff-0e5c-4679-b1b7-aa9b308f533e","root_ids":["19458"],"roots":{"19458":"0e1af288-9353-497c-95bf-2390063ca7db"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();