(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("59b02b89-9820-4f1d-9880-0249443340dd");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '59b02b89-9820-4f1d-9880-0249443340dd' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"5f92e712-4101-4ff7-bc6f-9df0a00c19b6":{"roots":{"references":[{"attributes":{},"id":"22547","type":"LinearScale"},{"attributes":{},"id":"22556","type":"BasicTicker"},{"attributes":{"data":{"line_color":["red","green"],"xs":[[1,2,3],[2,3,4]],"ys":[[6,7,2],[4,5,7]]},"selected":{"id":"22585"},"selection_policy":{"id":"22584"}},"id":"22573","type":"ColumnDataSource"},{"attributes":{},"id":"22584","type":"UnionRenderers"},{"attributes":{},"id":"22552","type":"BasicTicker"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"22575","type":"MultiLine"},{"attributes":{"text":""},"id":"22578","type":"Title"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"22559"},{"id":"22560"},{"id":"22561"},{"id":"22562"},{"id":"22563"},{"id":"22564"}]},"id":"22566","type":"Toolbar"},{"attributes":{"source":{"id":"22573"}},"id":"22577","type":"CDSView"},{"attributes":{"formatter":{"id":"22581"},"ticker":{"id":"22552"}},"id":"22551","type":"LinearAxis"},{"attributes":{},"id":"22543","type":"DataRange1d"},{"attributes":{},"id":"22560","type":"WheelZoomTool"},{"attributes":{},"id":"22563","type":"ResetTool"},{"attributes":{},"id":"22562","type":"SaveTool"},{"attributes":{"data_source":{"id":"22573"},"glyph":{"id":"22574"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"22575"},"selection_glyph":null,"view":{"id":"22577"}},"id":"22576","type":"GlyphRenderer"},{"attributes":{},"id":"22545","type":"DataRange1d"},{"attributes":{},"id":"22559","type":"PanTool"},{"attributes":{"formatter":{"id":"22583"},"ticker":{"id":"22556"}},"id":"22555","type":"LinearAxis"},{"attributes":{},"id":"22564","type":"HelpTool"},{"attributes":{"axis":{"id":"22551"},"ticker":null},"id":"22554","type":"Grid"},{"attributes":{},"id":"22581","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"22555"},"dimension":1,"ticker":null},"id":"22558","type":"Grid"},{"attributes":{},"id":"22583","type":"BasicTickFormatter"},{"attributes":{},"id":"22585","type":"Selection"},{"attributes":{},"id":"22549","type":"LinearScale"},{"attributes":{"line_color":{"field":"line_color"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"22574","type":"MultiLine"},{"attributes":{"below":[{"id":"22551"}],"center":[{"id":"22554"},{"id":"22558"}],"left":[{"id":"22555"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"22576"}],"title":{"id":"22578"},"toolbar":{"id":"22566"},"x_range":{"id":"22543"},"x_scale":{"id":"22547"},"y_range":{"id":"22545"},"y_scale":{"id":"22549"}},"id":"22542","subtype":"Figure","type":"Plot"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"22565","type":"BoxAnnotation"},{"attributes":{"overlay":{"id":"22565"}},"id":"22561","type":"BoxZoomTool"}],"root_ids":["22542"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"5f92e712-4101-4ff7-bc6f-9df0a00c19b6","root_ids":["22542"],"roots":{"22542":"59b02b89-9820-4f1d-9880-0249443340dd"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();