(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("8b764036-efda-4460-824e-622e6bc92cf6");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '8b764036-efda-4460-824e-622e6bc92cf6' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"430f5e60-6d62-4eee-8bd4-177a369da26c":{"roots":{"references":[{"attributes":{},"id":"18540","type":"BasicTicker"},{"attributes":{},"id":"18531","type":"DataRange1d"},{"attributes":{},"id":"18537","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"18547"},{"id":"18548"},{"id":"18549"},{"id":"18550"},{"id":"18551"},{"id":"18552"}]},"id":"18554","type":"Toolbar"},{"attributes":{},"id":"18535","type":"LinearScale"},{"attributes":{},"id":"18569","type":"BasicTickFormatter"},{"attributes":{"overlay":{"id":"18553"}},"id":"18549","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"18569"},"ticker":{"id":"18540"}},"id":"18539","type":"LinearAxis"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"18573"},"selection_policy":{"id":"18572"}},"id":"18561","type":"ColumnDataSource"},{"attributes":{},"id":"18547","type":"PanTool"},{"attributes":{},"id":"18552","type":"HelpTool"},{"attributes":{},"id":"18533","type":"DataRange1d"},{"attributes":{},"id":"18548","type":"WheelZoomTool"},{"attributes":{"fill_color":{"value":"#E6550D"},"line_color":{"value":"#E6550D"},"line_width":{"value":2},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18562","type":"Cross"},{"attributes":{"axis":{"id":"18539"},"ticker":null},"id":"18542","type":"Grid"},{"attributes":{"text":""},"id":"18566","type":"Title"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#E6550D"},"line_alpha":{"value":0.1},"line_color":{"value":"#E6550D"},"line_width":{"value":2},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18563","type":"Cross"},{"attributes":{},"id":"18551","type":"ResetTool"},{"attributes":{},"id":"18544","type":"BasicTicker"},{"attributes":{"source":{"id":"18561"}},"id":"18565","type":"CDSView"},{"attributes":{},"id":"18571","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"18561"},"glyph":{"id":"18562"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"18563"},"selection_glyph":null,"view":{"id":"18565"}},"id":"18564","type":"GlyphRenderer"},{"attributes":{"below":[{"id":"18539"}],"center":[{"id":"18542"},{"id":"18546"}],"left":[{"id":"18543"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"18564"}],"title":{"id":"18566"},"toolbar":{"id":"18554"},"x_range":{"id":"18531"},"x_scale":{"id":"18535"},"y_range":{"id":"18533"},"y_scale":{"id":"18537"}},"id":"18530","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"18572","type":"UnionRenderers"},{"attributes":{"formatter":{"id":"18571"},"ticker":{"id":"18544"}},"id":"18543","type":"LinearAxis"},{"attributes":{},"id":"18573","type":"Selection"},{"attributes":{"axis":{"id":"18543"},"dimension":1,"ticker":null},"id":"18546","type":"Grid"},{"attributes":{},"id":"18550","type":"SaveTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"18553","type":"BoxAnnotation"}],"root_ids":["18530"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"430f5e60-6d62-4eee-8bd4-177a369da26c","root_ids":["18530"],"roots":{"18530":"8b764036-efda-4460-824e-622e6bc92cf6"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();