(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("7c50b19b-bfbe-4f6c-9b2f-6bced4c1f21d");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '7c50b19b-bfbe-4f6c-9b2f-6bced4c1f21d' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"3e5bc028-087d-4b68-ade6-5461390a8b37":{"roots":{"references":[{"attributes":{},"id":"23488","type":"BasicTicker"},{"attributes":{"fill_color":{"value":"#99D594"},"line_color":{"value":"#99D594"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"23510","type":"Triangle"},{"attributes":{},"id":"23495","type":"PanTool"},{"attributes":{},"id":"23521","type":"Selection"},{"attributes":{},"id":"23492","type":"BasicTicker"},{"attributes":{},"id":"23499","type":"ResetTool"},{"attributes":{},"id":"23496","type":"WheelZoomTool"},{"attributes":{"data":{"size":[10,20,25],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"23521"},"selection_policy":{"id":"23520"}},"id":"23509","type":"ColumnDataSource"},{"attributes":{},"id":"23517","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"23491"},"dimension":1,"ticker":null},"id":"23494","type":"Grid"},{"attributes":{"axis":{"id":"23487"},"ticker":null},"id":"23490","type":"Grid"},{"attributes":{"data_source":{"id":"23509"},"glyph":{"id":"23510"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"23511"},"selection_glyph":null,"view":{"id":"23513"}},"id":"23512","type":"GlyphRenderer"},{"attributes":{},"id":"23483","type":"LinearScale"},{"attributes":{"text":""},"id":"23514","type":"Title"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"23501","type":"BoxAnnotation"},{"attributes":{"below":[{"id":"23487"}],"center":[{"id":"23490"},{"id":"23494"}],"left":[{"id":"23491"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"23512"}],"title":{"id":"23514"},"toolbar":{"id":"23502"},"x_range":{"id":"23479"},"x_scale":{"id":"23483"},"y_range":{"id":"23481"},"y_scale":{"id":"23485"}},"id":"23478","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"23498","type":"SaveTool"},{"attributes":{},"id":"23519","type":"BasicTickFormatter"},{"attributes":{},"id":"23485","type":"LinearScale"},{"attributes":{"formatter":{"id":"23517"},"ticker":{"id":"23488"}},"id":"23487","type":"LinearAxis"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#99D594"},"line_alpha":{"value":0.1},"line_color":{"value":"#99D594"},"line_width":{"value":2},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"23511","type":"Triangle"},{"attributes":{},"id":"23481","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"23495"},{"id":"23496"},{"id":"23497"},{"id":"23498"},{"id":"23499"},{"id":"23500"}]},"id":"23502","type":"Toolbar"},{"attributes":{"source":{"id":"23509"}},"id":"23513","type":"CDSView"},{"attributes":{"overlay":{"id":"23501"}},"id":"23497","type":"BoxZoomTool"},{"attributes":{},"id":"23479","type":"DataRange1d"},{"attributes":{},"id":"23500","type":"HelpTool"},{"attributes":{"formatter":{"id":"23519"},"ticker":{"id":"23492"}},"id":"23491","type":"LinearAxis"},{"attributes":{},"id":"23520","type":"UnionRenderers"}],"root_ids":["23478"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"3e5bc028-087d-4b68-ade6-5461390a8b37","root_ids":["23478"],"roots":{"23478":"7c50b19b-bfbe-4f6c-9b2f-6bced4c1f21d"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();