(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("9d499f3d-d881-4afe-b0ba-c7b3229a773f");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '9d499f3d-d881-4afe-b0ba-c7b3229a773f' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"63fc5c68-4cd4-4f9d-8c02-420c078b4372":{"roots":{"references":[{"attributes":{},"id":"22657","type":"Selection"},{"attributes":{"data":{"fill_color":["red","green"],"line_color":["red","green"],"xs":[[[[1,1,2,2]]],[[[1,1,3],[1.5,1.5,2]]]],"ys":[[[[4,3,3,4]]],[[[1,3,1],[1.5,2,1.5]]]]},"selected":{"id":"22657"},"selection_policy":{"id":"22656"}},"id":"22645","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"22655"},"ticker":{"id":"22628"}},"id":"22627","type":"LinearAxis"},{"attributes":{},"id":"22636","type":"HelpTool"},{"attributes":{"fill_color":{"field":"fill_color"},"line_color":{"field":"line_color"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"22646","type":"MultiPolygons"},{"attributes":{},"id":"22635","type":"ResetTool"},{"attributes":{"axis":{"id":"22623"},"ticker":null},"id":"22626","type":"Grid"},{"attributes":{},"id":"22653","type":"BasicTickFormatter"},{"attributes":{"overlay":{"id":"22637"}},"id":"22633","type":"BoxZoomTool"},{"attributes":{},"id":"22621","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"22631"},{"id":"22632"},{"id":"22633"},{"id":"22634"},{"id":"22635"},{"id":"22636"}]},"id":"22638","type":"Toolbar"},{"attributes":{},"id":"22634","type":"SaveTool"},{"attributes":{"formatter":{"id":"22653"},"ticker":{"id":"22624"}},"id":"22623","type":"LinearAxis"},{"attributes":{"axis":{"id":"22627"},"dimension":1,"ticker":null},"id":"22630","type":"Grid"},{"attributes":{},"id":"22631","type":"PanTool"},{"attributes":{},"id":"22615","type":"DataRange1d"},{"attributes":{},"id":"22632","type":"WheelZoomTool"},{"attributes":{"below":[{"id":"22623"}],"center":[{"id":"22626"},{"id":"22630"}],"left":[{"id":"22627"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"22648"}],"title":{"id":"22650"},"toolbar":{"id":"22638"},"x_range":{"id":"22615"},"x_scale":{"id":"22619"},"y_range":{"id":"22617"},"y_scale":{"id":"22621"}},"id":"22614","subtype":"Figure","type":"Plot"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"22637","type":"BoxAnnotation"},{"attributes":{},"id":"22617","type":"DataRange1d"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fill_color"},"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"22647","type":"MultiPolygons"},{"attributes":{"data_source":{"id":"22645"},"glyph":{"id":"22646"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"22647"},"selection_glyph":null,"view":{"id":"22649"}},"id":"22648","type":"GlyphRenderer"},{"attributes":{},"id":"22656","type":"UnionRenderers"},{"attributes":{},"id":"22655","type":"BasicTickFormatter"},{"attributes":{"text":""},"id":"22650","type":"Title"},{"attributes":{"source":{"id":"22645"}},"id":"22649","type":"CDSView"},{"attributes":{},"id":"22619","type":"LinearScale"},{"attributes":{},"id":"22624","type":"BasicTicker"},{"attributes":{},"id":"22628","type":"BasicTicker"}],"root_ids":["22614"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"63fc5c68-4cd4-4f9d-8c02-420c078b4372","root_ids":["22614"],"roots":{"22614":"9d499f3d-d881-4afe-b0ba-c7b3229a773f"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();