(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("83e6207b-da37-49c1-8d4a-df1086376803");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '83e6207b-da37-49c1-8d4a-df1086376803' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"03761745-0f12-4da2-a33d-76a3ec292b66":{"roots":{"references":[{"attributes":{"data":{"x":[1,2,3],"y":[4,5,6]},"selected":{"id":"18357"},"selection_policy":{"id":"18356"}},"id":"18345","type":"ColumnDataSource"},{"attributes":{"overlay":{"id":"18337"}},"id":"18333","type":"BoxZoomTool"},{"attributes":{"axis":{"id":"18327"},"dimension":1,"ticker":null},"id":"18330","type":"Grid"},{"attributes":{"formatter":{"id":"18355"},"ticker":{"id":"18328"}},"id":"18327","type":"LinearAxis"},{"attributes":{},"id":"18319","type":"LinearScale"},{"attributes":{},"id":"18353","type":"BasicTickFormatter"},{"attributes":{"fill_color":{"value":null},"line_color":{"value":"#FB8072"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18346","type":"CircleCross"},{"attributes":{},"id":"18315","type":"DataRange1d"},{"attributes":{"formatter":{"id":"18353"},"ticker":{"id":"18324"}},"id":"18323","type":"LinearAxis"},{"attributes":{},"id":"18331","type":"PanTool"},{"attributes":{},"id":"18332","type":"WheelZoomTool"},{"attributes":{"axis":{"id":"18323"},"ticker":null},"id":"18326","type":"Grid"},{"attributes":{},"id":"18355","type":"BasicTickFormatter"},{"attributes":{},"id":"18317","type":"DataRange1d"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"line_alpha":{"value":0.1},"line_color":{"value":"#FB8072"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18347","type":"CircleCross"},{"attributes":{"source":{"id":"18345"}},"id":"18349","type":"CDSView"},{"attributes":{},"id":"18328","type":"BasicTicker"},{"attributes":{},"id":"18335","type":"ResetTool"},{"attributes":{},"id":"18334","type":"SaveTool"},{"attributes":{"data_source":{"id":"18345"},"glyph":{"id":"18346"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"18347"},"selection_glyph":null,"view":{"id":"18349"}},"id":"18348","type":"GlyphRenderer"},{"attributes":{},"id":"18321","type":"LinearScale"},{"attributes":{"below":[{"id":"18323"}],"center":[{"id":"18326"},{"id":"18330"}],"left":[{"id":"18327"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"18348"}],"title":{"id":"18350"},"toolbar":{"id":"18338"},"x_range":{"id":"18315"},"x_scale":{"id":"18319"},"y_range":{"id":"18317"},"y_scale":{"id":"18321"}},"id":"18314","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"18324","type":"BasicTicker"},{"attributes":{},"id":"18336","type":"HelpTool"},{"attributes":{},"id":"18356","type":"UnionRenderers"},{"attributes":{"text":""},"id":"18350","type":"Title"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"18337","type":"BoxAnnotation"},{"attributes":{},"id":"18357","type":"Selection"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"18331"},{"id":"18332"},{"id":"18333"},{"id":"18334"},{"id":"18335"},{"id":"18336"}]},"id":"18338","type":"Toolbar"}],"root_ids":["18314"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"03761745-0f12-4da2-a33d-76a3ec292b66","root_ids":["18314"],"roots":{"18314":"83e6207b-da37-49c1-8d4a-df1086376803"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();