(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("3c3ca85a-1d89-49bb-a640-3df661569a85");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '3c3ca85a-1d89-49bb-a640-3df661569a85' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"cb8e4a24-7655-4096-a0d5-e21d63fc6f2f":{"roots":{"references":[{"attributes":{},"id":"18979","type":"PanTool"},{"attributes":{"formatter":{"id":"19003"},"ticker":{"id":"18976"}},"id":"18975","type":"LinearAxis"},{"attributes":{},"id":"18982","type":"SaveTool"},{"attributes":{"axis":{"id":"18975"},"dimension":1,"ticker":null},"id":"18978","type":"Grid"},{"attributes":{},"id":"18983","type":"ResetTool"},{"attributes":{},"id":"19005","type":"Selection"},{"attributes":{"formatter":{"id":"19001"},"ticker":{"id":"18972"}},"id":"18971","type":"LinearAxis"},{"attributes":{"axis":{"id":"18971"},"ticker":null},"id":"18974","type":"Grid"},{"attributes":{},"id":"18963","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"18979"},{"id":"18980"},{"id":"18981"},{"id":"18982"},{"id":"18983"},{"id":"18984"}]},"id":"18986","type":"Toolbar"},{"attributes":{},"id":"18972","type":"BasicTicker"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"height":{"units":"data","value":20},"line_alpha":{"value":0.1},"line_color":{"value":"#386CB0"},"line_width":{"value":2},"width":{"units":"data","value":30},"x":{"field":"x"},"y":{"field":"y"}},"id":"18995","type":"Ellipse"},{"attributes":{},"id":"19001","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"18993"}},"id":"18997","type":"CDSView"},{"attributes":{"overlay":{"id":"18985"}},"id":"18981","type":"BoxZoomTool"},{"attributes":{},"id":"18969","type":"LinearScale"},{"attributes":{},"id":"18984","type":"HelpTool"},{"attributes":{"text":""},"id":"18998","type":"Title"},{"attributes":{"fill_color":{"value":null},"height":{"units":"data","value":20},"line_color":{"value":"#386CB0"},"line_width":{"value":2},"width":{"units":"data","value":30},"x":{"field":"x"},"y":{"field":"y"}},"id":"18994","type":"Ellipse"},{"attributes":{"below":[{"id":"18971"}],"center":[{"id":"18974"},{"id":"18978"}],"left":[{"id":"18975"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"18996"}],"title":{"id":"18998"},"toolbar":{"id":"18986"},"x_range":{"id":"18963"},"x_scale":{"id":"18967"},"y_range":{"id":"18965"},"y_scale":{"id":"18969"}},"id":"18962","subtype":"Figure","type":"Plot"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"19005"},"selection_policy":{"id":"19004"}},"id":"18993","type":"ColumnDataSource"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"18985","type":"BoxAnnotation"},{"attributes":{},"id":"18967","type":"LinearScale"},{"attributes":{},"id":"19004","type":"UnionRenderers"},{"attributes":{},"id":"18980","type":"WheelZoomTool"},{"attributes":{},"id":"18965","type":"DataRange1d"},{"attributes":{},"id":"18976","type":"BasicTicker"},{"attributes":{},"id":"19003","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"18993"},"glyph":{"id":"18994"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"18995"},"selection_glyph":null,"view":{"id":"18997"}},"id":"18996","type":"GlyphRenderer"}],"root_ids":["18962"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"cb8e4a24-7655-4096-a0d5-e21d63fc6f2f","root_ids":["18962"],"roots":{"18962":"3c3ca85a-1d89-49bb-a640-3df661569a85"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();