(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("e0e36abf-0c6c-4c9c-a5a2-2d65c1c01872");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'e0e36abf-0c6c-4c9c-a5a2-2d65c1c01872' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"333aa6eb-b3c2-466c-9945-3101c2f84846":{"roots":{"references":[{"attributes":{"data_source":{"id":"19703"},"glyph":{"id":"19704"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"19705"},"selection_glyph":null,"view":{"id":"19707"}},"id":"19706","type":"GlyphRenderer"},{"attributes":{},"id":"19715","type":"Selection"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"19695","type":"BoxAnnotation"},{"attributes":{},"id":"19714","type":"UnionRenderers"},{"attributes":{"formatter":{"id":"19711"},"ticker":{"id":"19682"}},"id":"19681","type":"LinearAxis"},{"attributes":{},"id":"19679","type":"LinearScale"},{"attributes":{"data":{"fill_color":["red","green"],"line_color":["red","green"],"xs":[[[[1,1,2,2]]],[[[1,1,3],[1.5,1.5,2]]]],"ys":[[[[4,3,3,4]]],[[[1,3,1],[1.5,2,1.5]]]]},"selected":{"id":"19715"},"selection_policy":{"id":"19714"}},"id":"19703","type":"ColumnDataSource"},{"attributes":{},"id":"19711","type":"BasicTickFormatter"},{"attributes":{"fill_color":{"field":"fill_color"},"line_color":{"field":"line_color"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"19704","type":"MultiPolygons"},{"attributes":{},"id":"19693","type":"ResetTool"},{"attributes":{},"id":"19690","type":"WheelZoomTool"},{"attributes":{},"id":"19686","type":"BasicTicker"},{"attributes":{"formatter":{"id":"19713"},"ticker":{"id":"19686"}},"id":"19685","type":"LinearAxis"},{"attributes":{},"id":"19713","type":"BasicTickFormatter"},{"attributes":{},"id":"19694","type":"HelpTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"19689"},{"id":"19690"},{"id":"19691"},{"id":"19692"},{"id":"19693"},{"id":"19694"}]},"id":"19696","type":"Toolbar"},{"attributes":{"axis":{"id":"19681"},"ticker":null},"id":"19684","type":"Grid"},{"attributes":{},"id":"19682","type":"BasicTicker"},{"attributes":{},"id":"19675","type":"DataRange1d"},{"attributes":{},"id":"19673","type":"DataRange1d"},{"attributes":{"overlay":{"id":"19695"}},"id":"19691","type":"BoxZoomTool"},{"attributes":{"text":""},"id":"19708","type":"Title"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fill_color"},"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"19705","type":"MultiPolygons"},{"attributes":{},"id":"19689","type":"PanTool"},{"attributes":{"axis":{"id":"19685"},"dimension":1,"ticker":null},"id":"19688","type":"Grid"},{"attributes":{},"id":"19677","type":"LinearScale"},{"attributes":{},"id":"19692","type":"SaveTool"},{"attributes":{"source":{"id":"19703"}},"id":"19707","type":"CDSView"},{"attributes":{"below":[{"id":"19681"}],"center":[{"id":"19684"},{"id":"19688"}],"left":[{"id":"19685"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"19706"}],"title":{"id":"19708"},"toolbar":{"id":"19696"},"x_range":{"id":"19673"},"x_scale":{"id":"19677"},"y_range":{"id":"19675"},"y_scale":{"id":"19679"}},"id":"19672","subtype":"Figure","type":"Plot"}],"root_ids":["19672"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"333aa6eb-b3c2-466c-9945-3101c2f84846","root_ids":["19672"],"roots":{"19672":"e0e36abf-0c6c-4c9c-a5a2-2d65c1c01872"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();