(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("9aa60ab7-1c75-4fe9-af2c-2f2feadd4723");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '9aa60ab7-1c75-4fe9-af2c-2f2feadd4723' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"0392c7e8-34b5-4d4f-9b54-fd5fd9b5868d":{"roots":{"references":[{"attributes":{},"id":"21227","type":"Selection"},{"attributes":{},"id":"21194","type":"BasicTicker"},{"attributes":{"text":""},"id":"21220","type":"Title"},{"attributes":{},"id":"21201","type":"PanTool"},{"attributes":{},"id":"21223","type":"BasicTickFormatter"},{"attributes":{},"id":"21225","type":"BasicTickFormatter"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"21207","type":"BoxAnnotation"},{"attributes":{},"id":"21189","type":"LinearScale"},{"attributes":{"axis":{"id":"21197"},"dimension":1,"ticker":null},"id":"21200","type":"Grid"},{"attributes":{},"id":"21191","type":"LinearScale"},{"attributes":{},"id":"21185","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"21201"},{"id":"21202"},{"id":"21203"},{"id":"21204"},{"id":"21205"},{"id":"21206"}]},"id":"21208","type":"Toolbar"},{"attributes":{"formatter":{"id":"21223"},"ticker":{"id":"21194"}},"id":"21193","type":"LinearAxis"},{"attributes":{},"id":"21205","type":"ResetTool"},{"attributes":{},"id":"21202","type":"WheelZoomTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#fa9fb5"},"line_alpha":{"value":0.1},"line_color":{"value":"#fa9fb5"},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"21217","type":"X"},{"attributes":{"fill_color":{"value":"#fa9fb5"},"line_color":{"value":"#fa9fb5"},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"21216","type":"X"},{"attributes":{"axis":{"id":"21193"},"ticker":null},"id":"21196","type":"Grid"},{"attributes":{},"id":"21187","type":"DataRange1d"},{"attributes":{"source":{"id":"21215"}},"id":"21219","type":"CDSView"},{"attributes":{"overlay":{"id":"21207"}},"id":"21203","type":"BoxZoomTool"},{"attributes":{},"id":"21204","type":"SaveTool"},{"attributes":{},"id":"21198","type":"BasicTicker"},{"attributes":{},"id":"21226","type":"UnionRenderers"},{"attributes":{"below":[{"id":"21193"}],"center":[{"id":"21196"},{"id":"21200"}],"left":[{"id":"21197"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"21218"}],"title":{"id":"21220"},"toolbar":{"id":"21208"},"x_range":{"id":"21185"},"x_scale":{"id":"21189"},"y_range":{"id":"21187"},"y_scale":{"id":"21191"}},"id":"21184","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"21225"},"ticker":{"id":"21198"}},"id":"21197","type":"LinearAxis"},{"attributes":{"data":{"size":[10,20,25],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"21227"},"selection_policy":{"id":"21226"}},"id":"21215","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"21215"},"glyph":{"id":"21216"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"21217"},"selection_glyph":null,"view":{"id":"21219"}},"id":"21218","type":"GlyphRenderer"},{"attributes":{},"id":"21206","type":"HelpTool"}],"root_ids":["21184"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"0392c7e8-34b5-4d4f-9b54-fd5fd9b5868d","root_ids":["21184"],"roots":{"21184":"9aa60ab7-1c75-4fe9-af2c-2f2feadd4723"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();