(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("e201bad9-a282-43c4-8ae1-0f79a9e2f3b2");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'e201bad9-a282-43c4-8ae1-0f79a9e2f3b2' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"d93c25be-3459-4056-a847-d91de3f858d6":{"roots":{"references":[{"attributes":{},"id":"20469","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"20481"},{"id":"20482"},{"id":"20483"},{"id":"20484"},{"id":"20485"},{"id":"20486"}]},"id":"20488","type":"Toolbar"},{"attributes":{},"id":"20486","type":"HelpTool"},{"attributes":{},"id":"20478","type":"BasicTicker"},{"attributes":{},"id":"20506","type":"UnionRenderers"},{"attributes":{},"id":"20482","type":"WheelZoomTool"},{"attributes":{"axis":{"id":"20477"},"dimension":1,"ticker":null},"id":"20480","type":"Grid"},{"attributes":{},"id":"20503","type":"BasicTickFormatter"},{"attributes":{"data":{"size":[10,20,25],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"20507"},"selection_policy":{"id":"20506"}},"id":"20495","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"20505"},"ticker":{"id":"20478"}},"id":"20477","type":"LinearAxis"},{"attributes":{"axis":{"id":"20473"},"ticker":null},"id":"20476","type":"Grid"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"line_alpha":{"value":0.1},"line_color":{"value":"#7FC97F"},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20497","type":"SquareDot"},{"attributes":{"overlay":{"id":"20487"}},"id":"20483","type":"BoxZoomTool"},{"attributes":{},"id":"20505","type":"BasicTickFormatter"},{"attributes":{},"id":"20484","type":"SaveTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"20487","type":"BoxAnnotation"},{"attributes":{},"id":"20474","type":"BasicTicker"},{"attributes":{"source":{"id":"20495"}},"id":"20499","type":"CDSView"},{"attributes":{"fill_color":{"value":null},"line_color":{"value":"#7FC97F"},"size":{"field":"size","units":"screen"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20496","type":"SquareDot"},{"attributes":{},"id":"20465","type":"DataRange1d"},{"attributes":{"text":""},"id":"20500","type":"Title"},{"attributes":{},"id":"20471","type":"LinearScale"},{"attributes":{"data_source":{"id":"20495"},"glyph":{"id":"20496"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"20497"},"selection_glyph":null,"view":{"id":"20499"}},"id":"20498","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"20503"},"ticker":{"id":"20474"}},"id":"20473","type":"LinearAxis"},{"attributes":{},"id":"20467","type":"DataRange1d"},{"attributes":{},"id":"20485","type":"ResetTool"},{"attributes":{},"id":"20507","type":"Selection"},{"attributes":{},"id":"20481","type":"PanTool"},{"attributes":{"below":[{"id":"20473"}],"center":[{"id":"20476"},{"id":"20480"}],"left":[{"id":"20477"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"20498"}],"title":{"id":"20500"},"toolbar":{"id":"20488"},"x_range":{"id":"20465"},"x_scale":{"id":"20469"},"y_range":{"id":"20467"},"y_scale":{"id":"20471"}},"id":"20464","subtype":"Figure","type":"Plot"}],"root_ids":["20464"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"d93c25be-3459-4056-a847-d91de3f858d6","root_ids":["20464"],"roots":{"20464":"e201bad9-a282-43c4-8ae1-0f79a9e2f3b2"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();