(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("5f227c28-3876-4f23-b0a5-0efe3c62cb1d");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '5f227c28-3876-4f23-b0a5-0efe3c62cb1d' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"b9707bcb-cfa1-4b9a-ae7c-9ed1e0f4a38c":{"roots":{"references":[{"attributes":{},"id":"21918","type":"BasicTicker"},{"attributes":{},"id":"21905","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"21921"},{"id":"21922"},{"id":"21923"},{"id":"21924"},{"id":"21925"},{"id":"21926"}]},"id":"21928","type":"Toolbar"},{"attributes":{},"id":"21914","type":"BasicTicker"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"21947"},"selection_policy":{"id":"21946"}},"id":"21935","type":"ColumnDataSource"},{"attributes":{"overlay":{"id":"21927"}},"id":"21923","type":"BoxZoomTool"},{"attributes":{},"id":"21926","type":"HelpTool"},{"attributes":{},"id":"21924","type":"SaveTool"},{"attributes":{"axis":{"id":"21913"},"ticker":null},"id":"21916","type":"Grid"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":null},"line_alpha":{"value":0.1},"line_color":{"value":"#386CB0"},"line_width":{"value":2},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"21937","type":"DiamondCross"},{"attributes":{},"id":"21943","type":"BasicTickFormatter"},{"attributes":{},"id":"21947","type":"Selection"},{"attributes":{},"id":"21909","type":"LinearScale"},{"attributes":{},"id":"21945","type":"BasicTickFormatter"},{"attributes":{},"id":"21907","type":"DataRange1d"},{"attributes":{"fill_color":{"value":null},"line_color":{"value":"#386CB0"},"line_width":{"value":2},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"21936","type":"DiamondCross"},{"attributes":{"formatter":{"id":"21943"},"ticker":{"id":"21914"}},"id":"21913","type":"LinearAxis"},{"attributes":{},"id":"21946","type":"UnionRenderers"},{"attributes":{},"id":"21921","type":"PanTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"21927","type":"BoxAnnotation"},{"attributes":{"axis":{"id":"21917"},"dimension":1,"ticker":null},"id":"21920","type":"Grid"},{"attributes":{"data_source":{"id":"21935"},"glyph":{"id":"21936"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"21937"},"selection_glyph":null,"view":{"id":"21939"}},"id":"21938","type":"GlyphRenderer"},{"attributes":{},"id":"21922","type":"WheelZoomTool"},{"attributes":{},"id":"21911","type":"LinearScale"},{"attributes":{},"id":"21925","type":"ResetTool"},{"attributes":{"formatter":{"id":"21945"},"ticker":{"id":"21918"}},"id":"21917","type":"LinearAxis"},{"attributes":{"below":[{"id":"21913"}],"center":[{"id":"21916"},{"id":"21920"}],"left":[{"id":"21917"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"21938"}],"title":{"id":"21940"},"toolbar":{"id":"21928"},"x_range":{"id":"21905"},"x_scale":{"id":"21909"},"y_range":{"id":"21907"},"y_scale":{"id":"21911"}},"id":"21904","subtype":"Figure","type":"Plot"},{"attributes":{"text":""},"id":"21940","type":"Title"},{"attributes":{"source":{"id":"21935"}},"id":"21939","type":"CDSView"}],"root_ids":["21904"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"b9707bcb-cfa1-4b9a-ae7c-9ed1e0f4a38c","root_ids":["21904"],"roots":{"21904":"5f227c28-3876-4f23-b0a5-0efe3c62cb1d"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();