(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("d5b717de-75aa-422f-96a8-a4451a27bc57");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'd5b717de-75aa-422f-96a8-a4451a27bc57' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"575e15b7-2901-4495-8c1d-16fb8199e428":{"roots":{"references":[{"attributes":{},"id":"18465","type":"LinearScale"},{"attributes":{"fill_alpha":{"value":0.2},"fill_color":{"value":"#DD1C77"},"line_color":{"value":"#DD1C77"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18490","type":"CircleX"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"18475"},{"id":"18476"},{"id":"18477"},{"id":"18478"},{"id":"18479"},{"id":"18480"}]},"id":"18482","type":"Toolbar"},{"attributes":{},"id":"18475","type":"PanTool"},{"attributes":{"formatter":{"id":"18497"},"ticker":{"id":"18468"}},"id":"18467","type":"LinearAxis"},{"attributes":{"below":[{"id":"18467"}],"center":[{"id":"18470"},{"id":"18474"}],"left":[{"id":"18471"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"18492"}],"title":{"id":"18494"},"toolbar":{"id":"18482"},"x_range":{"id":"18459"},"x_scale":{"id":"18463"},"y_range":{"id":"18461"},"y_scale":{"id":"18465"}},"id":"18458","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"18472","type":"BasicTicker"},{"attributes":{},"id":"18476","type":"WheelZoomTool"},{"attributes":{},"id":"18468","type":"BasicTicker"},{"attributes":{},"id":"18459","type":"DataRange1d"},{"attributes":{"text":""},"id":"18494","type":"Title"},{"attributes":{"overlay":{"id":"18481"}},"id":"18477","type":"BoxZoomTool"},{"attributes":{"axis":{"id":"18467"},"ticker":null},"id":"18470","type":"Grid"},{"attributes":{},"id":"18461","type":"DataRange1d"},{"attributes":{},"id":"18478","type":"SaveTool"},{"attributes":{},"id":"18500","type":"UnionRenderers"},{"attributes":{"axis":{"id":"18471"},"dimension":1,"ticker":null},"id":"18474","type":"Grid"},{"attributes":{},"id":"18463","type":"LinearScale"},{"attributes":{},"id":"18497","type":"BasicTickFormatter"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"18481","type":"BoxAnnotation"},{"attributes":{"formatter":{"id":"18499"},"ticker":{"id":"18472"}},"id":"18471","type":"LinearAxis"},{"attributes":{},"id":"18479","type":"ResetTool"},{"attributes":{"data_source":{"id":"18489"},"glyph":{"id":"18490"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"18491"},"selection_glyph":null,"view":{"id":"18493"}},"id":"18492","type":"GlyphRenderer"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"18501"},"selection_policy":{"id":"18500"}},"id":"18489","type":"ColumnDataSource"},{"attributes":{"source":{"id":"18489"}},"id":"18493","type":"CDSView"},{"attributes":{},"id":"18499","type":"BasicTickFormatter"},{"attributes":{},"id":"18480","type":"HelpTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#DD1C77"},"line_alpha":{"value":0.1},"line_color":{"value":"#DD1C77"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"18491","type":"CircleX"},{"attributes":{},"id":"18501","type":"Selection"}],"root_ids":["18458"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"575e15b7-2901-4495-8c1d-16fb8199e428","root_ids":["18458"],"roots":{"18458":"d5b717de-75aa-422f-96a8-a4451a27bc57"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();