(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("71468378-661d-45f5-96b6-b20dacd79e14");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '71468378-661d-45f5-96b6-b20dacd79e14' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"08d26221-d735-4387-8f53-0bcce87a40c0":{"roots":{"references":[{"attributes":{"axis":{"id":"12751"},"ticker":null},"id":"12754","type":"Grid"},{"attributes":{},"id":"12824","type":"BasicTickFormatter"},{"attributes":{},"id":"12763","type":"ResetTool"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"navy"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"12774","type":"Circle"},{"attributes":{},"id":"12828","type":"BasicTickFormatter"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"12802","type":"BoxAnnotation"},{"attributes":{"axis":{"id":"12788"},"ticker":null},"id":"12791","type":"Grid"},{"attributes":{},"id":"12782","type":"DataRange1d"},{"attributes":{},"id":"12826","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"12773"},"glyph":{"id":"12774"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"12775"},"selection_glyph":null,"view":{"id":"12777"}},"id":"12776","type":"GlyphRenderer"},{"attributes":{},"id":"12745","type":"DataRange1d"},{"attributes":{"overlay":{"id":"12765"}},"id":"12761","type":"BoxZoomTool"},{"attributes":{},"id":"12749","type":"LinearScale"},{"attributes":{},"id":"12756","type":"BasicTicker"},{"attributes":{},"id":"12762","type":"SaveTool"},{"attributes":{},"id":"12796","type":"PanTool"},{"attributes":{"formatter":{"id":"12824"},"ticker":{"id":"12756"}},"id":"12755","type":"LinearAxis"},{"attributes":{"child":{"id":"12779"},"title":"line"},"id":"12815","type":"Panel"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"12765","type":"BoxAnnotation"},{"attributes":{},"id":"12799","type":"SaveTool"},{"attributes":{"child":{"id":"12742"},"title":"circle"},"id":"12778","type":"Panel"},{"attributes":{},"id":"12822","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"12810"}},"id":"12814","type":"CDSView"},{"attributes":{},"id":"12832","type":"UnionRenderers"},{"attributes":{},"id":"12747","type":"LinearScale"},{"attributes":{},"id":"12780","type":"DataRange1d"},{"attributes":{},"id":"12743","type":"DataRange1d"},{"attributes":{},"id":"12797","type":"WheelZoomTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"navy"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"12775","type":"Circle"},{"attributes":{},"id":"12760","type":"WheelZoomTool"},{"attributes":{},"id":"12789","type":"BasicTicker"},{"attributes":{"text":""},"id":"12817","type":"Title"},{"attributes":{"axis":{"id":"12792"},"dimension":1,"ticker":null},"id":"12795","type":"Grid"},{"attributes":{},"id":"12800","type":"ResetTool"},{"attributes":{"below":[{"id":"12788"}],"center":[{"id":"12791"},{"id":"12795"}],"left":[{"id":"12792"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"12813"}],"title":{"id":"12819"},"toolbar":{"id":"12803"},"x_range":{"id":"12780"},"x_scale":{"id":"12784"},"y_range":{"id":"12782"},"y_scale":{"id":"12786"}},"id":"12779","subtype":"Figure","type":"Plot"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"12796"},{"id":"12797"},{"id":"12798"},{"id":"12799"},{"id":"12800"},{"id":"12801"}]},"id":"12803","type":"Toolbar"},{"attributes":{},"id":"12833","type":"Selection"},{"attributes":{"below":[{"id":"12751"}],"center":[{"id":"12754"},{"id":"12758"}],"left":[{"id":"12755"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"12776"}],"title":{"id":"12817"},"toolbar":{"id":"12766"},"x_range":{"id":"12743"},"x_scale":{"id":"12747"},"y_range":{"id":"12745"},"y_scale":{"id":"12749"}},"id":"12742","subtype":"Figure","type":"Plot"},{"attributes":{"source":{"id":"12773"}},"id":"12777","type":"CDSView"},{"attributes":{},"id":"12759","type":"PanTool"},{"attributes":{"data_source":{"id":"12810"},"glyph":{"id":"12811"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"12812"},"selection_glyph":null,"view":{"id":"12814"}},"id":"12813","type":"GlyphRenderer"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,2,4,5]},"selected":{"id":"12833"},"selection_policy":{"id":"12832"}},"id":"12810","type":"ColumnDataSource"},{"attributes":{"line_alpha":0.1,"line_color":"navy","line_width":3,"x":{"field":"x"},"y":{"field":"y"}},"id":"12812","type":"Line"},{"attributes":{"formatter":{"id":"12822"},"ticker":{"id":"12752"}},"id":"12751","type":"LinearAxis"},{"attributes":{"formatter":{"id":"12828"},"ticker":{"id":"12793"}},"id":"12792","type":"LinearAxis"},{"attributes":{},"id":"12764","type":"HelpTool"},{"attributes":{"line_alpha":0.5,"line_color":"navy","line_width":3,"x":{"field":"x"},"y":{"field":"y"}},"id":"12811","type":"Line"},{"attributes":{"tabs":[{"id":"12778"},{"id":"12815"}]},"id":"12816","type":"Tabs"},{"attributes":{"formatter":{"id":"12826"},"ticker":{"id":"12789"}},"id":"12788","type":"LinearAxis"},{"attributes":{},"id":"12784","type":"LinearScale"},{"attributes":{},"id":"12752","type":"BasicTicker"},{"attributes":{},"id":"12786","type":"LinearScale"},{"attributes":{"overlay":{"id":"12802"}},"id":"12798","type":"BoxZoomTool"},{"attributes":{},"id":"12829","type":"UnionRenderers"},{"attributes":{},"id":"12830","type":"Selection"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"12759"},{"id":"12760"},{"id":"12761"},{"id":"12762"},{"id":"12763"},{"id":"12764"}]},"id":"12766","type":"Toolbar"},{"attributes":{"text":""},"id":"12819","type":"Title"},{"attributes":{},"id":"12801","type":"HelpTool"},{"attributes":{},"id":"12793","type":"BasicTicker"},{"attributes":{"axis":{"id":"12755"},"dimension":1,"ticker":null},"id":"12758","type":"Grid"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,2,4,5]},"selected":{"id":"12830"},"selection_policy":{"id":"12829"}},"id":"12773","type":"ColumnDataSource"}],"root_ids":["12816"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"08d26221-d735-4387-8f53-0bcce87a40c0","root_ids":["12816"],"roots":{"12816":"71468378-661d-45f5-96b6-b20dacd79e14"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();