(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("29a171c2-bcfb-447d-aee9-e8e557483626");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '29a171c2-bcfb-447d-aee9-e8e557483626' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"b37a639c-385e-4f80-8f36-a84ba48e17f1":{"roots":{"references":[{"attributes":{"axis":null,"ticker":{"id":"10864"}},"id":"10865","type":"Grid"},{"attributes":{"formatter":{"id":"10874"},"ticker":{"id":"10864"}},"id":"10862","type":"LinearAxis"},{"attributes":{"formatter":{"id":"10876"},"ticker":{"id":"10866"}},"id":"10863","type":"LinearAxis"},{"attributes":{"data_source":{"id":"10856"},"glyph":{"id":"10859"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"10861"}},"id":"10860","type":"GlyphRenderer"},{"attributes":{},"id":"10870","type":"LinearScale"},{"attributes":{"below":[{"id":"10862"}],"center":[{"id":"10865"},{"id":"10867"}],"left":[{"id":"10863"}],"min_border":0,"plot_height":300,"plot_width":300,"renderers":[{"id":"10860"}],"title":null,"toolbar":{"id":"10872"},"toolbar_location":null,"x_range":{"id":"10869"},"x_scale":{"id":"10868"},"y_range":{"id":"10871"},"y_scale":{"id":"10870"}},"id":"10857","type":"Plot"},{"attributes":{},"id":"10866","type":"BasicTicker"},{"attributes":{"fill_color":{"value":"#fb9a99"},"line_color":{"value":"white"},"q":{"field":"q"},"r":{"field":"r"}},"id":"10859","type":"HexTile"},{"attributes":{},"id":"10869","type":"DataRange1d"},{"attributes":{},"id":"10871","type":"DataRange1d"},{"attributes":{},"id":"10877","type":"UnionRenderers"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"10872","type":"Toolbar"},{"attributes":{},"id":"10878","type":"Selection"},{"attributes":{"data":{"q":[0,0,-1,-1,1,1,0],"r":[0,-1,0,1,-1,0,1]},"selected":{"id":"10878"},"selection_policy":{"id":"10877"}},"id":"10856","type":"ColumnDataSource"},{"attributes":{},"id":"10868","type":"LinearScale"},{"attributes":{"axis":null,"dimension":1,"ticker":{"id":"10866"}},"id":"10867","type":"Grid"},{"attributes":{},"id":"10864","type":"BasicTicker"},{"attributes":{},"id":"10876","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"10856"}},"id":"10861","type":"CDSView"},{"attributes":{},"id":"10874","type":"BasicTickFormatter"}],"root_ids":["10857"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"b37a639c-385e-4f80-8f36-a84ba48e17f1","root_ids":["10857"],"roots":{"10857":"29a171c2-bcfb-447d-aee9-e8e557483626"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();