(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("bcc53bba-b08c-4f89-830c-401f0e7609a6");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'bcc53bba-b08c-4f89-830c-401f0e7609a6' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"3b36328f-5bac-4535-9004-d8890d565053":{"roots":{"references":[{"attributes":{"line_color":{"value":"#1d91d0"},"line_dash":[6],"mode":"center","x":{"field":"x"},"y":{"field":"y2"}},"id":"12049","type":"Step"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"12065","type":"Toolbar"},{"attributes":{},"id":"12063","type":"LinearScale"},{"attributes":{},"id":"12070","type":"UnionRenderers"},{"attributes":{},"id":"12062","type":"DataRange1d"},{"attributes":{},"id":"12057","type":"BasicTicker"},{"attributes":{"data_source":{"id":"12043"},"glyph":{"id":"12046"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"12048"}},"id":"12047","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"12067"},"ticker":{"id":"12057"}},"id":"12055","type":"LinearAxis"},{"attributes":{},"id":"12061","type":"LinearScale"},{"attributes":{"below":[{"id":"12055"}],"center":[{"id":"12058"},{"id":"12060"}],"left":[{"id":"12056"}],"min_border":0,"plot_height":300,"plot_width":300,"renderers":[{"id":"12047"},{"id":"12050"},{"id":"12053"}],"title":null,"toolbar":{"id":"12065"},"toolbar_location":null,"x_range":{"id":"12062"},"x_scale":{"id":"12061"},"y_range":{"id":"12064"},"y_scale":{"id":"12063"}},"id":"12044","type":"Plot"},{"attributes":{"line_color":{"value":"#cab2d6"},"line_width":{"value":3},"mode":"after","x":{"field":"x"},"y":{"field":"y3"}},"id":"12052","type":"Step"},{"attributes":{},"id":"12067","type":"BasicTickFormatter"},{"attributes":{"line_color":{"value":"#f46d43"},"x":{"field":"x"},"y":{"field":"y1"}},"id":"12046","type":"Step"},{"attributes":{},"id":"12071","type":"Selection"},{"attributes":{},"id":"12059","type":"BasicTicker"},{"attributes":{},"id":"12069","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"12043"},"glyph":{"id":"12052"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"12054"}},"id":"12053","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"12069"},"ticker":{"id":"12059"}},"id":"12056","type":"LinearAxis"},{"attributes":{"axis":null,"ticker":{"id":"12057"}},"id":"12058","type":"Grid"},{"attributes":{},"id":"12064","type":"DataRange1d"},{"attributes":{"source":{"id":"12043"}},"id":"12048","type":"CDSView"},{"attributes":{"source":{"id":"12043"}},"id":"12054","type":"CDSView"},{"attributes":{"axis":null,"dimension":1,"ticker":{"id":"12059"}},"id":"12060","type":"Grid"},{"attributes":{"source":{"id":"12043"}},"id":"12051","type":"CDSView"},{"attributes":{"data_source":{"id":"12043"},"glyph":{"id":"12049"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"12051"}},"id":"12050","type":"GlyphRenderer"},{"attributes":{"data":{"x":{"__ndarray__":"AAAAAAAAAMCamZmZmZn5vzMzMzMzM/O/mJmZmZmZ6b+YmZmZmZnZvwAAAAAAAAAAoJmZmZmZ2T+cmZmZmZnpPzQzMzMzM/M/mpmZmZmZ+T8AAAAAAAAAQA==","dtype":"float64","order":"little","shape":[11]},"y1":{"__ndarray__":"AAAAAAAAEEB8FK5H4XoEQArXo3A9Cvc/eBSuR+F65D94FK5H4XrEPwAAAAAAAAAAhRSuR+F6xD9/FK5H4XrkPwzXo3A9Cvc/fBSuR+F6BEAAAAAAAAAQQA==","dtype":"float64","order":"little","shape":[11]},"y2":{"__ndarray__":"AAAAAAAAGEA+CtejcD0SQIXrUbgehQtAHoXrUbgeBUBI4XoUrkcBQAAAAAAAAABASOF6FK5HAUAghetRuB4FQIbrUbgehQtAPgrXo3A9EkAAAAAAAAAYQA==","dtype":"float64","order":"little","shape":[11]},"y3":{"__ndarray__":"AAAAAAAAIEA+CtejcD0aQML1KFyPwhVAj8L1KFyPEkCkcD0K16MQQAAAAAAAABBApHA9CtejEECQwvUoXI8SQMP1KFyPwhVAPgrXo3A9GkAAAAAAAAAgQA==","dtype":"float64","order":"little","shape":[11]}},"selected":{"id":"12071"},"selection_policy":{"id":"12070"}},"id":"12043","type":"ColumnDataSource"}],"root_ids":["12044"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"3b36328f-5bac-4535-9004-d8890d565053","root_ids":["12044"],"roots":{"12044":"bcc53bba-b08c-4f89-830c-401f0e7609a6"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();