(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("d1a2ebcd-e37a-45f2-abad-926fc14cb472");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'd1a2ebcd-e37a-45f2-abad-926fc14cb472' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"b4a05402-7b5a-4eb0-882f-85622519912c":{"roots":{"references":[{"attributes":{"source":{"id":"10984"}},"id":"10993","type":"CDSView"},{"attributes":{},"id":"11006","type":"LinearScale"},{"attributes":{"anchor":"center","h":{"field":"h1","units":"data"},"url":{"field":"url"},"w":{"field":"w1","units":"data"},"x":{"field":"x1"},"y":{"field":"y1"}},"id":"10991","type":"ImageURL"},{"attributes":{"axis":null,"ticker":{"id":"11002"}},"id":"11003","type":"Grid"},{"attributes":{},"id":"11010","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"10984"}},"id":"10996","type":"CDSView"},{"attributes":{"end":200,"start":-100},"id":"10985","type":"Range1d"},{"attributes":{},"id":"11004","type":"BasicTicker"},{"attributes":{"end":200,"start":-100},"id":"10986","type":"Range1d"},{"attributes":{},"id":"11002","type":"BasicTicker"},{"attributes":{"data_source":{"id":"10984"},"glyph":{"id":"10994"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"10996"}},"id":"10995","type":"GlyphRenderer"},{"attributes":{},"id":"11014","type":"Selection"},{"attributes":{},"id":"11013","type":"UnionRenderers"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"11008","type":"Toolbar"},{"attributes":{"formatter":{"id":"11010"},"ticker":{"id":"11002"}},"id":"11000","type":"LinearAxis"},{"attributes":{"h":{"units":"data","value":20},"url":{"field":"url"},"w":{"units":"data","value":20},"x":{"field":"x2"},"y":{"field":"y2"}},"id":"10994","type":"ImageURL"},{"attributes":{"below":[{"id":"11000"}],"center":[{"id":"11003"},{"id":"11005"}],"left":[{"id":"11001"}],"min_border":0,"plot_height":300,"plot_width":300,"renderers":[{"id":"10992"},{"id":"10995"},{"id":"10998"}],"title":null,"toolbar":{"id":"11008"},"toolbar_location":null,"x_range":{"id":"10985"},"x_scale":{"id":"11006"},"y_range":{"id":"10986"},"y_scale":{"id":"11007"}},"id":"10987","type":"Plot"},{"attributes":{"data_source":{"id":"10984"},"glyph":{"id":"10991"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"10993"}},"id":"10992","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"11012"},"ticker":{"id":"11004"}},"id":"11001","type":"LinearAxis"},{"attributes":{"data":{"h1":{"__ndarray__":"AAAAAAAAJEAAAAAAAAA0QAAAAAAAAD5AAAAAAAAAREAAAAAAAABJQA==","dtype":"float64","order":"little","shape":[5]},"url":["https://static.bokeh.org/logos/logo.png","https://static.bokeh.org/logos/logo.png","https://static.bokeh.org/logos/logo.png","https://static.bokeh.org/logos/logo.png","https://static.bokeh.org/logos/logo.png"],"w1":{"__ndarray__":"AAAAAAAAJEAAAAAAAAA0QAAAAAAAAD5AAAAAAAAAREAAAAAAAABJQA==","dtype":"float64","order":"little","shape":[5]},"x1":{"__ndarray__":"AAAAAAAAAAAAAAAAAMBCQAAAAAAAwFJAAAAAAAAgXEAAAAAAAMBiQA==","dtype":"float64","order":"little","shape":[5]},"x2":{"__ndarray__":"AAAAAAAAScAAAAAAAAAAAAAAAAAAAElAAAAAAAAAWUAAAAAAAMBiQA==","dtype":"float64","order":"little","shape":[5]},"y1":{"__ndarray__":"AAAAAAAAAAAAAAAAAMBCQAAAAAAAwFJAAAAAAAAgXEAAAAAAAMBiQA==","dtype":"float64","order":"little","shape":[5]},"y2":{"__ndarray__":"AAAAAAAAAAAAAAAAAABJQAAAAAAAAFlAAAAAAADAYkAAAAAAAABpQA==","dtype":"float64","order":"little","shape":[5]}},"selected":{"id":"11014"},"selection_policy":{"id":"11013"}},"id":"10984","type":"ColumnDataSource"},{"attributes":{},"id":"11007","type":"LinearScale"},{"attributes":{},"id":"11012","type":"BasicTickFormatter"},{"attributes":{"axis":null,"dimension":1,"ticker":{"id":"11004"}},"id":"11005","type":"Grid"},{"attributes":{"source":{"id":"10984"}},"id":"10999","type":"CDSView"},{"attributes":{"anchor":"bottom_right","url":{"value":"https://static.bokeh.org/logos/logo.png"},"x":{"value":200},"y":{"value":-100}},"id":"10997","type":"ImageURL"},{"attributes":{"data_source":{"id":"10984"},"glyph":{"id":"10997"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"10999"}},"id":"10998","type":"GlyphRenderer"}],"root_ids":["10987"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"b4a05402-7b5a-4eb0-882f-85622519912c","root_ids":["10987"],"roots":{"10987":"d1a2ebcd-e37a-45f2-abad-926fc14cb472"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();