(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("2d2e995b-d7fe-494e-8b3a-4e58be3f25a8");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '2d2e995b-d7fe-494e-8b3a-4e58be3f25a8' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"4dd99c08-2ccc-4855-8191-8e416ad62dd5":{"roots":{"references":[{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"24369"},{"id":"24370"},{"id":"24371"},{"id":"24372"},{"id":"24373"},{"id":"24374"}]},"id":"24376","type":"Toolbar"},{"attributes":{"formatter":{"id":"24392"},"ticker":{"id":"24366"}},"id":"24365","type":"LinearAxis"},{"attributes":{},"id":"24355","type":"DataRange1d"},{"attributes":{},"id":"24362","type":"BasicTicker"},{"attributes":{},"id":"24390","type":"BasicTickFormatter"},{"attributes":{},"id":"24393","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"24385","type":"Circle"},{"attributes":{"source":{"id":"24383"}},"id":"24387","type":"CDSView"},{"attributes":{},"id":"24366","type":"BasicTicker"},{"attributes":{},"id":"24374","type":"HelpTool"},{"attributes":{},"id":"24370","type":"WheelZoomTool"},{"attributes":{},"id":"24394","type":"Selection"},{"attributes":{"axis":{"id":"24361"},"ticker":null},"id":"24364","type":"Grid"},{"attributes":{},"id":"24359","type":"LinearScale"},{"attributes":{"data":{"x":[1,2],"y":[3,4]},"selected":{"id":"24394"},"selection_policy":{"id":"24393"}},"id":"24383","type":"ColumnDataSource"},{"attributes":{},"id":"24372","type":"SaveTool"},{"attributes":{},"id":"24392","type":"BasicTickFormatter"},{"attributes":{"below":[{"id":"24361"}],"center":[{"id":"24364"},{"id":"24368"}],"left":[{"id":"24365"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"24386"}],"title":{"id":"24351"},"title_location":"left","toolbar":{"id":"24376"},"x_range":{"id":"24353"},"x_scale":{"id":"24357"},"y_range":{"id":"24355"},"y_scale":{"id":"24359"}},"id":"24350","subtype":"Figure","type":"Plot"},{"attributes":{"overlay":{"id":"24375"}},"id":"24371","type":"BoxZoomTool"},{"attributes":{},"id":"24373","type":"ResetTool"},{"attributes":{"formatter":{"id":"24390"},"ticker":{"id":"24362"}},"id":"24361","type":"LinearAxis"},{"attributes":{},"id":"24353","type":"DataRange1d"},{"attributes":{"axis":{"id":"24365"},"dimension":1,"ticker":null},"id":"24368","type":"Grid"},{"attributes":{},"id":"24369","type":"PanTool"},{"attributes":{},"id":"24357","type":"LinearScale"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"24375","type":"BoxAnnotation"},{"attributes":{"data_source":{"id":"24383"},"glyph":{"id":"24384"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"24385"},"selection_glyph":null,"view":{"id":"24387"}},"id":"24386","type":"GlyphRenderer"},{"attributes":{"text":"Left Title"},"id":"24351","type":"Title"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"24384","type":"Circle"}],"root_ids":["24350"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"4dd99c08-2ccc-4855-8191-8e416ad62dd5","root_ids":["24350"],"roots":{"24350":"2d2e995b-d7fe-494e-8b3a-4e58be3f25a8"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();