(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("01b7ab15-f90e-4bef-a48c-556f7915c81f");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '01b7ab15-f90e-4bef-a48c-556f7915c81f' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"fbf4b200-c3bd-42fd-854c-361938e1625e":{"roots":{"references":[{"attributes":{"data":{"text":["(0, 0)","(0, -1)","(0, 1)","(-1, 0)","(-1, 1)","(1, -1)","(1, 0)"],"x":{"__ndarray__":"AAAAAAAAAACqTFjoerbrv6pMWOh6tus/qkxY6Hq2+7+qTFjoerbrv6pMWOh6tus/qkxY6Hq2+z8=","dtype":"float64","order":"little","shape":[7]},"y":{"__ndarray__":"AAAAAAAAAIAAAAAAAAD4PwAAAAAAAPi/AAAAAAAAAIAAAAAAAAD4vwAAAAAAAPg/AAAAAAAAAIA=","dtype":"float64","order":"little","shape":[7]}},"selected":{"id":"34177"},"selection_policy":{"id":"34176"}},"id":"34163","type":"ColumnDataSource"},{"attributes":{"source":{"id":"34163"}},"id":"34167","type":"CDSView"},{"attributes":{},"id":"34147","type":"SaveTool"},{"attributes":{"data_source":{"id":"34163"},"glyph":{"id":"34164"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"34165"},"selection_glyph":null,"view":{"id":"34167"}},"id":"34166","type":"GlyphRenderer"},{"attributes":{},"id":"34174","type":"UnionRenderers"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"34144"},{"id":"34145"},{"id":"34146"},{"id":"34147"},{"id":"34148"},{"id":"34149"}]},"id":"34151","type":"Toolbar"},{"attributes":{"data":{"fill_color":["firebrick","firebrick","firebrick","navy","navy","navy","navy"],"q":[0,0,0,-1,-1,1,1],"r":[0,-1,1,0,1,-1,0]},"selected":{"id":"34175"},"selection_policy":{"id":"34174"}},"id":"34158","type":"ColumnDataSource"},{"attributes":{},"id":"34130","type":"DataRange1d"},{"attributes":{"below":[{"id":"34136"}],"center":[{"id":"34139"},{"id":"34143"}],"left":[{"id":"34140"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"34161"},{"id":"34166"}],"title":{"id":"34168"},"toolbar":{"id":"34151"},"toolbar_location":null,"x_range":{"id":"34128"},"x_scale":{"id":"34132"},"y_range":{"id":"34130"},"y_scale":{"id":"34134"}},"id":"34127","subtype":"Figure","type":"Plot"},{"attributes":{"text_align":"center","text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"34164","type":"Text"},{"attributes":{},"id":"34173","type":"BasicTickFormatter"},{"attributes":{},"id":"34175","type":"Selection"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"34165","type":"Text"},{"attributes":{},"id":"34149","type":"HelpTool"},{"attributes":{"data_source":{"id":"34158"},"glyph":{"id":"34159"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"34160"},"selection_glyph":null,"view":{"id":"34162"}},"id":"34161","type":"GlyphRenderer"},{"attributes":{},"id":"34132","type":"LinearScale"},{"attributes":{},"id":"34128","type":"DataRange1d"},{"attributes":{"axis":{"id":"34136"},"ticker":null,"visible":false},"id":"34139","type":"Grid"},{"attributes":{},"id":"34171","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"field":"fill_color"},"line_alpha":{"value":0.5},"line_color":{"value":"white"},"q":{"field":"q"},"r":{"field":"r"}},"id":"34159","type":"HexTile"},{"attributes":{},"id":"34141","type":"BasicTicker"},{"attributes":{},"id":"34177","type":"Selection"},{"attributes":{"source":{"id":"34158"}},"id":"34162","type":"CDSView"},{"attributes":{"text":""},"id":"34168","type":"Title"},{"attributes":{"formatter":{"id":"34173"},"ticker":{"id":"34141"}},"id":"34140","type":"LinearAxis"},{"attributes":{},"id":"34134","type":"LinearScale"},{"attributes":{},"id":"34145","type":"WheelZoomTool"},{"attributes":{},"id":"34137","type":"BasicTicker"},{"attributes":{},"id":"34176","type":"UnionRenderers"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"34150","type":"BoxAnnotation"},{"attributes":{"overlay":{"id":"34150"}},"id":"34146","type":"BoxZoomTool"},{"attributes":{"axis":{"id":"34140"},"dimension":1,"ticker":null,"visible":false},"id":"34143","type":"Grid"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fill_color"},"line_alpha":{"value":0.1},"line_color":{"value":"white"},"q":{"field":"q"},"r":{"field":"r"}},"id":"34160","type":"HexTile"},{"attributes":{},"id":"34148","type":"ResetTool"},{"attributes":{"formatter":{"id":"34171"},"ticker":{"id":"34137"}},"id":"34136","type":"LinearAxis"},{"attributes":{},"id":"34144","type":"PanTool"}],"root_ids":["34127"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"fbf4b200-c3bd-42fd-854c-361938e1625e","root_ids":["34127"],"roots":{"34127":"01b7ab15-f90e-4bef-a48c-556f7915c81f"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();