(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("2100be56-7ac6-45f7-b40d-c9ae3a648557");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '2100be56-7ac6-45f7-b40d-c9ae3a648557' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"34a4ed36-16d9-4c27-a95e-759924cc27cf":{"roots":{"references":[{"attributes":{"formatter":{"id":"35779"},"ticker":{"id":"35753"}},"id":"35752","type":"CategoricalAxis"},{"attributes":{"axis":{"id":"35748"},"ticker":null},"id":"35751","type":"Grid"},{"attributes":{"factors":["a","b","c","d","e","f","g","h"]},"id":"35742","type":"FactorRange"},{"attributes":{"below":[{"id":"35748"}],"center":[{"id":"35751"},{"id":"35754"}],"left":[{"id":"35752"}],"renderers":[{"id":"35772"}],"title":{"id":"35774"},"toolbar":{"id":"35762"},"x_range":{"id":"35740"},"x_scale":{"id":"35744"},"y_range":{"id":"35742"},"y_scale":{"id":"35746"}},"id":"35739","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"35749","type":"BasicTicker"},{"attributes":{"data":{"x":[50,40,65,10,25,37,80,60],"y":["a","b","c","d","e","f","g","h"]},"selected":{"id":"35781"},"selection_policy":{"id":"35780"}},"id":"35769","type":"ColumnDataSource"},{"attributes":{},"id":"35777","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"35752"},"dimension":1,"ticker":null},"id":"35754","type":"Grid"},{"attributes":{},"id":"35781","type":"Selection"},{"attributes":{},"id":"35753","type":"CategoricalTicker"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"35761","type":"BoxAnnotation"},{"attributes":{},"id":"35746","type":"CategoricalScale"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"green"},"line_width":{"value":3},"size":{"units":"screen","value":15},"x":{"field":"x"},"y":{"field":"y"}},"id":"35771","type":"Circle"},{"attributes":{},"id":"35740","type":"DataRange1d"},{"attributes":{},"id":"35780","type":"UnionRenderers"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"35755"},{"id":"35756"},{"id":"35757"},{"id":"35758"},{"id":"35759"},{"id":"35760"}]},"id":"35762","type":"Toolbar"},{"attributes":{},"id":"35760","type":"HelpTool"},{"attributes":{},"id":"35744","type":"LinearScale"},{"attributes":{},"id":"35779","type":"CategoricalTickFormatter"},{"attributes":{},"id":"35756","type":"WheelZoomTool"},{"attributes":{"formatter":{"id":"35777"},"ticker":{"id":"35749"}},"id":"35748","type":"LinearAxis"},{"attributes":{"data_source":{"id":"35769"},"glyph":{"id":"35770"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"35771"},"selection_glyph":null,"view":{"id":"35773"}},"id":"35772","type":"GlyphRenderer"},{"attributes":{"source":{"id":"35769"}},"id":"35773","type":"CDSView"},{"attributes":{"fill_color":{"value":"orange"},"line_color":{"value":"green"},"line_width":{"value":3},"size":{"units":"screen","value":15},"x":{"field":"x"},"y":{"field":"y"}},"id":"35770","type":"Circle"},{"attributes":{"text":""},"id":"35774","type":"Title"},{"attributes":{},"id":"35758","type":"SaveTool"},{"attributes":{},"id":"35759","type":"ResetTool"},{"attributes":{"overlay":{"id":"35761"}},"id":"35757","type":"BoxZoomTool"},{"attributes":{},"id":"35755","type":"PanTool"}],"root_ids":["35739"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"34a4ed36-16d9-4c27-a95e-759924cc27cf","root_ids":["35739"],"roots":{"35739":"2100be56-7ac6-45f7-b40d-c9ae3a648557"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();