(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("cfc2349c-a3a8-4c1f-920c-3f3ff3ab0612");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'cfc2349c-a3a8-4c1f-920c-3f3ff3ab0612' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"92bf2af6-48f1-4129-b062-64a66c5af23f":{"roots":{"references":[{"attributes":{},"id":"28787","type":"BasicTicker"},{"attributes":{},"id":"28743","type":"LinearScale"},{"attributes":{"axis":{"id":"28782"},"ticker":null},"id":"28785","type":"Grid"},{"attributes":{},"id":"28745","type":"LinearScale"},{"attributes":{"children":[{"id":"28828"},{"id":"28826"}]},"id":"28829","type":"Column"},{"attributes":{"overlay":{"id":"28760"}},"id":"28756","type":"LassoSelectTool"},{"attributes":{"axis":{"id":"28747"},"ticker":null},"id":"28750","type":"Grid"},{"attributes":{"fill_alpha":0.5,"fill_color":"lightgrey","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"xs_units":"screen","ys_units":"screen"},"id":"28795","type":"PolyAnnotation"},{"attributes":{"below":[{"id":"28782"}],"center":[{"id":"28785"},{"id":"28789"}],"left":[{"id":"28786"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"28805"}],"title":null,"toolbar":{"id":"28796"},"toolbar_location":null,"x_range":{"id":"28774"},"x_scale":{"id":"28778"},"y_range":{"id":"28776"},"y_scale":{"id":"28780"}},"id":"28772","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"28739","type":"DataRange1d"},{"attributes":{},"id":"28808","type":"BasicTickFormatter"},{"attributes":{},"id":"28752","type":"BasicTicker"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y1"}},"id":"28802","type":"Circle"},{"attributes":{},"id":"28758","type":"HelpTool"},{"attributes":{},"id":"28780","type":"LinearScale"},{"attributes":{"source":{"id":"28734"}},"id":"28771","type":"CDSView"},{"attributes":{"filters":[{"id":"28735"}],"source":{"id":"28734"}},"id":"28736","type":"CDSView"},{"attributes":{"overlay":{"id":"28759"}},"id":"28755","type":"BoxSelectTool"},{"attributes":{"booleans":[true,true,true,true,true,false,false,false,false,false,false,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,false,false,false,false,false,false,true,true,true,true,true]},"id":"28735","type":"BooleanFilter"},{"attributes":{"toolbar":{"id":"28827"},"toolbar_location":"above"},"id":"28828","type":"ToolbarBox"},{"attributes":{"below":[{"id":"28747"}],"center":[{"id":"28750"},{"id":"28754"}],"left":[{"id":"28751"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"28770"}],"title":null,"toolbar":{"id":"28761"},"toolbar_location":null,"x_range":{"id":"28739"},"x_scale":{"id":"28743"},"y_range":{"id":"28741"},"y_scale":{"id":"28745"}},"id":"28737","subtype":"Figure","type":"Plot"},{"attributes":{"data":{"x":[-20,-19,-18,-17,-16,-15,-14,-13,-12,-11,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20],"y0":[20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20],"y1":[400,361,324,289,256,225,196,169,144,121,100,81,64,49,36,25,16,9,4,1,0,1,4,9,16,25,36,49,64,81,100,121,144,169,196,225,256,289,324,361,400]},"selected":{"id":"28812"},"selection_policy":{"id":"28811"}},"id":"28734","type":"ColumnDataSource"},{"attributes":{"overlay":{"id":"28795"}},"id":"28791","type":"LassoSelectTool"},{"attributes":{},"id":"28748","type":"BasicTicker"},{"attributes":{},"id":"28810","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"28818"},"ticker":{"id":"28783"}},"id":"28782","type":"LinearAxis"},{"attributes":{"fill_color":{"value":"firebrick"},"line_color":{"value":"firebrick"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y0"}},"id":"28769","type":"Circle"},{"attributes":{"formatter":{"id":"28808"},"ticker":{"id":"28748"}},"id":"28747","type":"LinearAxis"},{"attributes":{"fill_alpha":0.5,"fill_color":"lightgrey","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"xs_units":"screen","ys_units":"screen"},"id":"28760","type":"PolyAnnotation"},{"attributes":{"callback":null},"id":"28757","type":"HoverTool"},{"attributes":{},"id":"28778","type":"LinearScale"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"28794","type":"BoxAnnotation"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"28755"},{"id":"28756"},{"id":"28757"},{"id":"28758"}]},"id":"28761","type":"Toolbar"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"28790"},{"id":"28791"},{"id":"28792"},{"id":"28793"}]},"id":"28796","type":"Toolbar"},{"attributes":{},"id":"28812","type":"Selection"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"28759","type":"BoxAnnotation"},{"attributes":{},"id":"28783","type":"BasicTicker"},{"attributes":{"data_source":{"id":"28734"},"glyph":{"id":"28767"},"hover_glyph":{"id":"28769"},"muted_glyph":null,"nonselection_glyph":{"id":"28768"},"selection_glyph":null,"view":{"id":"28771"}},"id":"28770","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"28820"},"ticker":{"id":"28787"}},"id":"28786","type":"LinearAxis"},{"attributes":{"callback":null},"id":"28792","type":"HoverTool"},{"attributes":{},"id":"28811","type":"UnionRenderers"},{"attributes":{"overlay":{"id":"28794"}},"id":"28790","type":"BoxSelectTool"},{"attributes":{},"id":"28774","type":"DataRange1d"},{"attributes":{},"id":"28776","type":"DataRange1d"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y0"}},"id":"28768","type":"Circle"},{"attributes":{},"id":"28793","type":"HelpTool"},{"attributes":{"fill_color":{"value":"firebrick"},"line_color":{"value":"firebrick"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y1"}},"id":"28804","type":"Circle"},{"attributes":{"toolbars":[{"id":"28761"},{"id":"28796"}],"tools":[{"id":"28755"},{"id":"28756"},{"id":"28757"},{"id":"28758"},{"id":"28790"},{"id":"28791"},{"id":"28792"},{"id":"28793"}]},"id":"28827","type":"ProxyToolbar"},{"attributes":{},"id":"28741","type":"DataRange1d"},{"attributes":{"axis":{"id":"28751"},"dimension":1,"ticker":null},"id":"28754","type":"Grid"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y0"}},"id":"28767","type":"Circle"},{"attributes":{},"id":"28818","type":"BasicTickFormatter"},{"attributes":{},"id":"28820","type":"BasicTickFormatter"},{"attributes":{"children":[[{"id":"28737"},0,0],[{"id":"28772"},0,1]]},"id":"28826","type":"GridBox"},{"attributes":{"axis":{"id":"28786"},"dimension":1,"ticker":null},"id":"28789","type":"Grid"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y1"}},"id":"28803","type":"Circle"},{"attributes":{"data_source":{"id":"28734"},"glyph":{"id":"28802"},"hover_glyph":{"id":"28804"},"muted_glyph":null,"nonselection_glyph":{"id":"28803"},"selection_glyph":null,"view":{"id":"28736"}},"id":"28805","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"28810"},"ticker":{"id":"28752"}},"id":"28751","type":"LinearAxis"}],"root_ids":["28829"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"92bf2af6-48f1-4129-b062-64a66c5af23f","root_ids":["28829"],"roots":{"28829":"cfc2349c-a3a8-4c1f-920c-3f3ff3ab0612"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();