(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("80c07cac-c184-4ae6-af17-d3175f1ec054");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '80c07cac-c184-4ae6-af17-d3175f1ec054' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"905fb388-6566-4e2d-8c44-4200c8a1fec6":{"roots":{"references":[{"attributes":{"data_source":{"id":"37976"},"glyph":{"id":"37977"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37978"},"selection_glyph":null,"view":{"id":"37980"}},"id":"37979","type":"GlyphRenderer"},{"attributes":{},"id":"37959","type":"BasicTicker"},{"attributes":{},"id":"37965","type":"SaveTool"},{"attributes":{"text":"Some Title","text_color":{"value":"olive"},"text_font":"times","text_font_style":"italic"},"id":"37944","type":"Title"},{"attributes":{},"id":"37946","type":"DataRange1d"},{"attributes":{},"id":"37948","type":"DataRange1d"},{"attributes":{"source":{"id":"37976"}},"id":"37980","type":"CDSView"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"37987"},"selection_policy":{"id":"37986"}},"id":"37976","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"37954"},"ticker":null},"id":"37957","type":"Grid"},{"attributes":{},"id":"37966","type":"ResetTool"},{"attributes":{},"id":"37967","type":"HelpTool"},{"attributes":{},"id":"37983","type":"BasicTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"37962"},{"id":"37963"},{"id":"37964"},{"id":"37965"},{"id":"37966"},{"id":"37967"}]},"id":"37969","type":"Toolbar"},{"attributes":{"below":[{"id":"37954"}],"center":[{"id":"37957"},{"id":"37961"}],"left":[{"id":"37958"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"37979"}],"title":{"id":"37944"},"toolbar":{"id":"37969"},"x_range":{"id":"37946"},"x_scale":{"id":"37950"},"y_range":{"id":"37948"},"y_scale":{"id":"37952"}},"id":"37943","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"37963","type":"WheelZoomTool"},{"attributes":{"formatter":{"id":"37983"},"ticker":{"id":"37955"}},"id":"37954","type":"LinearAxis"},{"attributes":{},"id":"37986","type":"UnionRenderers"},{"attributes":{},"id":"37950","type":"LinearScale"},{"attributes":{"overlay":{"id":"37968"}},"id":"37964","type":"BoxZoomTool"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"37977","type":"Circle"},{"attributes":{"formatter":{"id":"37985"},"ticker":{"id":"37959"}},"id":"37958","type":"LinearAxis"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"37968","type":"BoxAnnotation"},{"attributes":{},"id":"37952","type":"LinearScale"},{"attributes":{},"id":"37955","type":"BasicTicker"},{"attributes":{},"id":"37985","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"37978","type":"Circle"},{"attributes":{},"id":"37987","type":"Selection"},{"attributes":{},"id":"37962","type":"PanTool"},{"attributes":{"axis":{"id":"37958"},"dimension":1,"ticker":null},"id":"37961","type":"Grid"}],"root_ids":["37943"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"905fb388-6566-4e2d-8c44-4200c8a1fec6","root_ids":["37943"],"roots":{"37943":"80c07cac-c184-4ae6-af17-d3175f1ec054"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();