(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("29736fa0-807f-4a18-b3aa-2603564b3cc8");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '29736fa0-807f-4a18-b3aa-2603564b3cc8' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"342328e9-cc1c-49ac-a528-6a1b63e563df":{"roots":{"references":[{"attributes":{},"id":"26941","type":"CategoricalTicker"},{"attributes":{"formatter":{"id":"26960"},"major_label_orientation":1,"ticker":{"id":"26941"}},"id":"26940","type":"CategoricalAxis"},{"attributes":{},"id":"26964","type":"Selection"},{"attributes":{"axis":{"id":"26943"},"dimension":1,"ticker":null},"id":"26946","type":"Grid"},{"attributes":{"bottom":{"expr":{"id":"26950"}},"fill_alpha":{"value":0.1},"fill_color":{"value":"red"},"line_alpha":{"value":0.1},"line_color":{"value":"red"},"top":{"expr":{"id":"26951"}},"width":{"value":0.9},"x":{"field":"x"}},"id":"26969","type":"VBar"},{"attributes":{"text":""},"id":"26957","type":"Title"},{"attributes":{"bottom":{"expr":{"id":"26950"}},"fill_alpha":{"value":0.5},"fill_color":{"value":"red"},"line_alpha":{"value":0.5},"line_color":{"value":"red"},"top":{"expr":{"id":"26951"}},"width":{"value":0.9},"x":{"field":"x"}},"id":"26968","type":"VBar"},{"attributes":{"data_source":{"id":"26930"},"glyph":{"id":"26968"},"hover_glyph":null,"muted_glyph":null,"name":"west","nonselection_glyph":{"id":"26969"},"selection_glyph":null,"view":{"id":"26971"}},"id":"26970","type":"GlyphRenderer"},{"attributes":{"bottom":{"expr":{"id":"26948"}},"fill_alpha":{"value":0.5},"fill_color":{"value":"blue"},"line_alpha":{"value":0.5},"line_color":{"value":"blue"},"top":{"expr":{"id":"26949"}},"width":{"value":0.9},"x":{"field":"x"}},"id":"26953","type":"VBar"},{"attributes":{"axis":{"id":"26940"},"grid_line_color":null,"ticker":null},"id":"26942","type":"Grid"},{"attributes":{"data":{"east":[5,5,6,5,5,4,5,6,7,8,6,9],"west":[5,7,9,4,5,4,7,7,7,6,6,7],"x":[["Q1","jan"],["Q1","feb"],["Q1","mar"],["Q2","apr"],["Q2","may"],["Q2","jun"],["Q3","jul"],["Q3","aug"],["Q3","sep"],["Q4","oct"],["Q4","nov"],["Q4","dec"]]},"selected":{"id":"26964"},"selection_policy":{"id":"26963"}},"id":"26930","type":"ColumnDataSource"},{"attributes":{"bottom":{"expr":{"id":"26948"}},"fill_alpha":{"value":0.1},"fill_color":{"value":"blue"},"line_alpha":{"value":0.1},"line_color":{"value":"blue"},"top":{"expr":{"id":"26949"}},"width":{"value":0.9},"x":{"field":"x"}},"id":"26954","type":"VBar"},{"attributes":{},"id":"26936","type":"CategoricalScale"},{"attributes":{"source":{"id":"26930"}},"id":"26971","type":"CDSView"},{"attributes":{"items":[{"id":"26966"},{"id":"26980"}],"location":"top_center","orientation":"horizontal"},"id":"26965","type":"Legend"},{"attributes":{},"id":"26960","type":"CategoricalTickFormatter"},{"attributes":{},"id":"26963","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"26930"},"glyph":{"id":"26953"},"hover_glyph":null,"muted_glyph":null,"name":"east","nonselection_glyph":{"id":"26954"},"selection_glyph":null,"view":{"id":"26956"}},"id":"26955","type":"GlyphRenderer"},{"attributes":{},"id":"26944","type":"BasicTicker"},{"attributes":{"source":{"id":"26930"}},"id":"26956","type":"CDSView"},{"attributes":{},"id":"26938","type":"LinearScale"},{"attributes":{"label":{"value":"east"},"renderers":[{"id":"26955"}]},"id":"26966","type":"LegendItem"},{"attributes":{},"id":"26962","type":"BasicTickFormatter"},{"attributes":{"fields":["east","west"]},"id":"26951","type":"Stack"},{"attributes":{"formatter":{"id":"26962"},"ticker":{"id":"26944"}},"id":"26943","type":"LinearAxis"},{"attributes":{"label":{"value":"west"},"renderers":[{"id":"26970"}]},"id":"26980","type":"LegendItem"},{"attributes":{"fields":["east"]},"id":"26950","type":"Stack"},{"attributes":{"fields":[]},"id":"26948","type":"Stack"},{"attributes":{"factors":[["Q1","jan"],["Q1","feb"],["Q1","mar"],["Q2","apr"],["Q2","may"],["Q2","jun"],["Q3","jul"],["Q3","aug"],["Q3","sep"],["Q4","oct"],["Q4","nov"],["Q4","dec"]],"range_padding":0.1},"id":"26931","type":"FactorRange"},{"attributes":{"fields":["east"]},"id":"26949","type":"Stack"},{"attributes":{"end":18,"start":0},"id":"26934","type":"DataRange1d"},{"attributes":{"below":[{"id":"26940"}],"center":[{"id":"26942"},{"id":"26946"},{"id":"26965"}],"left":[{"id":"26943"}],"plot_height":250,"renderers":[{"id":"26955"},{"id":"26970"}],"title":{"id":"26957"},"toolbar":{"id":"26947"},"toolbar_location":null,"x_range":{"id":"26931"},"x_scale":{"id":"26936"},"y_range":{"id":"26934"},"y_scale":{"id":"26938"}},"id":"26932","subtype":"Figure","type":"Plot"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"26947","type":"Toolbar"}],"root_ids":["26932"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"342328e9-cc1c-49ac-a528-6a1b63e563df","root_ids":["26932"],"roots":{"26932":"29736fa0-807f-4a18-b3aa-2603564b3cc8"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();