(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("78aaf339-4276-4cb2-9418-ad73cebf6d63");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '78aaf339-4276-4cb2-9418-ad73cebf6d63' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"f496c51c-034f-4468-827d-af750d23100e":{"roots":{"references":[{"attributes":{"formatter":{"id":"33724"},"ticker":{"id":"33688"}},"id":"33687","type":"LinearAxis"},{"attributes":{},"id":"33688","type":"BasicTicker"},{"attributes":{},"id":"33728","type":"Selection"},{"attributes":{"formatter":{"id":"33726"},"ticker":{"id":"33692"}},"id":"33691","type":"LinearAxis"},{"attributes":{},"id":"33696","type":"WheelZoomTool"},{"attributes":{"axis":{"id":"33691"},"dimension":1,"ticker":null},"id":"33694","type":"Grid"},{"attributes":{"fields":["y1"]},"id":"33709","type":"Stack"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","x":{"field":"x"},"y":{"expr":{"id":"33710"}}},"id":"33718","type":"Line"},{"attributes":{},"id":"33700","type":"HelpTool"},{"attributes":{"text":""},"id":"33721","type":"Title"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"33701","type":"BoxAnnotation"},{"attributes":{"data":{"x":[1,2,3,4,5],"y1":[1,2,4,3,4],"y2":[1,4,2,2,3]},"selected":{"id":"33728"},"selection_policy":{"id":"33727"}},"id":"33677","type":"ColumnDataSource"},{"attributes":{"line_color":"#1f77b4","x":{"field":"x"},"y":{"expr":{"id":"33710"}}},"id":"33717","type":"Line"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","x":{"field":"x"},"y":{"expr":{"id":"33709"}}},"id":"33713","type":"Line"},{"attributes":{"source":{"id":"33677"}},"id":"33720","type":"CDSView"},{"attributes":{},"id":"33726","type":"BasicTickFormatter"},{"attributes":{},"id":"33727","type":"UnionRenderers"},{"attributes":{"overlay":{"id":"33701"}},"id":"33697","type":"BoxZoomTool"},{"attributes":{},"id":"33699","type":"ResetTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"33695"},{"id":"33696"},{"id":"33697"},{"id":"33698"},{"id":"33699"},{"id":"33700"}]},"id":"33702","type":"Toolbar"},{"attributes":{"line_color":"#1f77b4","x":{"field":"x"},"y":{"expr":{"id":"33709"}}},"id":"33712","type":"Line"},{"attributes":{},"id":"33724","type":"BasicTickFormatter"},{"attributes":{},"id":"33692","type":"BasicTicker"},{"attributes":{"fields":["y1","y2"]},"id":"33710","type":"Stack"},{"attributes":{"below":[{"id":"33687"}],"center":[{"id":"33690"},{"id":"33694"}],"left":[{"id":"33691"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"33714"},{"id":"33719"}],"title":{"id":"33721"},"toolbar":{"id":"33702"},"x_range":{"id":"33679"},"x_scale":{"id":"33683"},"y_range":{"id":"33681"},"y_scale":{"id":"33685"}},"id":"33678","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"33683","type":"LinearScale"},{"attributes":{"data_source":{"id":"33677"},"glyph":{"id":"33717"},"hover_glyph":null,"muted_glyph":null,"name":"y2","nonselection_glyph":{"id":"33718"},"selection_glyph":null,"view":{"id":"33720"}},"id":"33719","type":"GlyphRenderer"},{"attributes":{},"id":"33679","type":"DataRange1d"},{"attributes":{},"id":"33685","type":"LinearScale"},{"attributes":{},"id":"33681","type":"DataRange1d"},{"attributes":{"source":{"id":"33677"}},"id":"33715","type":"CDSView"},{"attributes":{"axis":{"id":"33687"},"ticker":null},"id":"33690","type":"Grid"},{"attributes":{},"id":"33695","type":"PanTool"},{"attributes":{"data_source":{"id":"33677"},"glyph":{"id":"33712"},"hover_glyph":null,"muted_glyph":null,"name":"y1","nonselection_glyph":{"id":"33713"},"selection_glyph":null,"view":{"id":"33715"}},"id":"33714","type":"GlyphRenderer"},{"attributes":{},"id":"33698","type":"SaveTool"}],"root_ids":["33678"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"f496c51c-034f-4468-827d-af750d23100e","root_ids":["33678"],"roots":{"33678":"78aaf339-4276-4cb2-9418-ad73cebf6d63"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();