(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("4cf5c88d-e625-4f2e-a27c-6917eccec844");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '4cf5c88d-e625-4f2e-a27c-6917eccec844' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"b1a5dd12-b461-4d94-a871-2648c46e8f68":{"roots":{"references":[{"attributes":{"below":[{"id":"24291"}],"center":[{"id":"24294"},{"id":"24298"}],"left":[{"id":"24295"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"24316"}],"title":{"id":"24281"},"toolbar":{"id":"24306"},"x_range":{"id":"24283"},"x_scale":{"id":"24287"},"y_range":{"id":"24285"},"y_scale":{"id":"24289"}},"id":"24280","subtype":"Figure","type":"Plot"},{"attributes":{"data_source":{"id":"24313"},"glyph":{"id":"24314"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"24315"},"selection_glyph":null,"view":{"id":"24317"}},"id":"24316","type":"GlyphRenderer"},{"attributes":{"overlay":{"id":"24305"}},"id":"24301","type":"BoxZoomTool"},{"attributes":{"axis":{"id":"24295"},"dimension":1,"ticker":null},"id":"24298","type":"Grid"},{"attributes":{},"id":"24287","type":"LinearScale"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"24314","type":"Circle"},{"attributes":{},"id":"24285","type":"DataRange1d"},{"attributes":{"formatter":{"id":"24322"},"ticker":{"id":"24296"}},"id":"24295","type":"LinearAxis"},{"attributes":{},"id":"24302","type":"SaveTool"},{"attributes":{"formatter":{"id":"24320"},"ticker":{"id":"24292"}},"id":"24291","type":"LinearAxis"},{"attributes":{},"id":"24299","type":"PanTool"},{"attributes":{},"id":"24303","type":"ResetTool"},{"attributes":{"axis":{"id":"24291"},"ticker":null},"id":"24294","type":"Grid"},{"attributes":{},"id":"24289","type":"LinearScale"},{"attributes":{},"id":"24283","type":"DataRange1d"},{"attributes":{"data":{"x":[1,2],"y":[3,4]},"selected":{"id":"24324"},"selection_policy":{"id":"24323"}},"id":"24313","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"24315","type":"Circle"},{"attributes":{},"id":"24304","type":"HelpTool"},{"attributes":{},"id":"24323","type":"UnionRenderers"},{"attributes":{},"id":"24320","type":"BasicTickFormatter"},{"attributes":{},"id":"24292","type":"BasicTicker"},{"attributes":{},"id":"24324","type":"Selection"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"24305","type":"BoxAnnotation"},{"attributes":{"text":"Basic Title"},"id":"24281","type":"Title"},{"attributes":{"source":{"id":"24313"}},"id":"24317","type":"CDSView"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"24299"},{"id":"24300"},{"id":"24301"},{"id":"24302"},{"id":"24303"},{"id":"24304"}]},"id":"24306","type":"Toolbar"},{"attributes":{},"id":"24296","type":"BasicTicker"},{"attributes":{},"id":"24300","type":"WheelZoomTool"},{"attributes":{},"id":"24322","type":"BasicTickFormatter"}],"root_ids":["24280"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"b1a5dd12-b461-4d94-a871-2648c46e8f68","root_ids":["24280"],"roots":{"24280":"4cf5c88d-e625-4f2e-a27c-6917eccec844"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();