(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("160e5f0d-fd82-49bb-acb2-e3b9b51ef87f");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '160e5f0d-fd82-49bb-acb2-e3b9b51ef87f' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"53521392-798e-40f0-8e48-6a0a0fcadfe6":{"roots":{"references":[{"attributes":{},"id":"29685","type":"BasicTickFormatter"},{"attributes":{},"id":"29699","type":"Selection"},{"attributes":{},"id":"29698","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"29679"},"glyph":{"id":"29678"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"29681"}},"id":"29680","type":"GlyphRenderer"},{"attributes":{},"id":"29690","type":"NodesOnly"},{"attributes":{"end":1.1,"start":-1.1},"id":"29658","type":"Range1d"},{"attributes":{},"id":"29674","type":"Circle"},{"attributes":{"below":[{"id":"29664"}],"center":[{"id":"29667"},{"id":"29671"}],"left":[{"id":"29668"}],"renderers":[{"id":"29673"}],"title":{"id":"29654"},"toolbar":{"id":"29672"},"toolbar_location":null,"x_range":{"id":"29656"},"x_scale":{"id":"29660"},"y_range":{"id":"29658"},"y_scale":{"id":"29662"}},"id":"29653","subtype":"Figure","type":"Plot"},{"attributes":{"data":{"club":["Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Officer","Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Officer","Officer","Mr. Hi","Mr. Hi","Officer","Mr. Hi","Officer","Mr. Hi","Officer","Officer","Officer","Officer","Officer","Officer","Officer","Officer","Officer","Officer","Officer","Officer"],"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33]},"selected":{"id":"29699"},"selection_policy":{"id":"29698"}},"id":"29675","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"29668"},"dimension":1,"ticker":null},"id":"29671","type":"Grid"},{"attributes":{},"id":"29669","type":"BasicTicker"},{"attributes":{},"id":"29701","type":"Selection"},{"attributes":{"data_source":{"id":"29675"},"glyph":{"id":"29674"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"29677"}},"id":"29676","type":"GlyphRenderer"},{"attributes":{},"id":"29665","type":"BasicTicker"},{"attributes":{},"id":"29691","type":"NodesOnly"},{"attributes":{"formatter":{"id":"29697"},"ticker":{"id":"29669"}},"id":"29668","type":"LinearAxis"},{"attributes":{"text":"Networkx Integration Demonstration"},"id":"29654","type":"Title"},{"attributes":{},"id":"29660","type":"LinearScale"},{"attributes":{},"id":"29697","type":"BasicTickFormatter"},{"attributes":{"data":{"end":[1,2,3,4,5,6,7,8,10,11,12,13,17,19,21,31,2,3,7,13,17,19,21,30,3,7,8,9,13,27,28,32,7,12,13,6,10,6,10,16,16,30,32,33,33,33,32,33,32,33,32,33,33,32,33,32,33,25,27,29,32,33,25,27,31,31,29,33,33,31,33,32,33,32,33,32,33,33],"start":[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,4,4,5,5,5,6,8,8,8,9,13,14,14,15,15,18,18,19,20,20,22,22,23,23,23,23,23,24,24,24,25,26,26,27,28,28,29,29,30,30,31,31,32]},"selected":{"id":"29701"},"selection_policy":{"id":"29700"}},"id":"29679","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"29664"},"ticker":null},"id":"29667","type":"Grid"},{"attributes":{"edge_renderer":{"id":"29680"},"inspection_policy":{"id":"29690"},"layout_provider":{"id":"29682"},"node_renderer":{"id":"29676"},"selection_policy":{"id":"29691"}},"id":"29673","type":"GraphRenderer"},{"attributes":{"formatter":{"id":"29685"},"ticker":{"id":"29665"}},"id":"29664","type":"LinearAxis"},{"attributes":{"end":1.1,"start":-1.1},"id":"29656","type":"Range1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"29672","type":"Toolbar"},{"attributes":{},"id":"29678","type":"MultiLine"},{"attributes":{"source":{"id":"29679"}},"id":"29681","type":"CDSView"},{"attributes":{},"id":"29662","type":"LinearScale"},{"attributes":{},"id":"29700","type":"UnionRenderers"},{"attributes":{"source":{"id":"29675"}},"id":"29677","type":"CDSView"},{"attributes":{"graph_layout":{"0":[0.7482063078935166,0.494072752166463],"1":[0.6942877471059145,-0.20261695644905786],"10":[1.1287592397708137,1.1587936217478216],"11":[1.7239606372030103,0.7208883170389577],"12":[1.3136534238904871,0.526640425169022],"13":[0.32399512770163946,-0.19607107119380843],"14":[-1.416158786374625,-0.9918898727659459],"15":[-0.46465920768023655,-1.2853284038585446],"16":[1.6459341737502478,2.0],"17":[1.3823824094132893,0.07216301110712069],"18":[-0.7456528529138635,-1.339592872924927],"19":[0.2129348716245198,0.024063610634151696],"2":[0.0038743472197025597,-0.005721413973103909],"20":[-1.4444150830545817,-0.6279103418217135],"21":[1.3137646890304662,-0.21092577764728598],"22":[-1.0418560873416776,-1.1787639229937588],"23":[-1.2699053903303428,-0.24647666510529048],"24":[-1.1811515308730058,0.7366222629757265],"25":[-1.4119833709201868,0.43321878378313067],"26":[-1.1899894160095585,-1.4265747550586658],"27":[-0.9246161557339964,0.15379513167174472],"28":[-0.48047196880008064,0.03295628374667102],"29":[-1.2189869766914323,-0.8604660501827504],"3":[0.7095579335023858,0.20759121337486536],"30":[-0.012294275183770608,-0.7489626851912117],"31":[-0.5614122806828074,0.27646089096368903],"32":[-0.7410733921425184,-0.6775140551316067],"33":[-0.6538542471712057,-0.5743727717605873],"4":[0.8244186190619753,1.3539563244930914],"5":[1.4229806504191507,1.3678183687871754],"6":[1.1716546834510206,1.5245946635182324],"7":[0.8235480670329037,0.013565848118159784],"8":[-0.02945918131242225,-0.3362640537688857],"9":[-0.6559727248547447,-0.18774983946888046]}},"id":"29682","type":"StaticLayoutProvider"}],"root_ids":["29653"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"53521392-798e-40f0-8e48-6a0a0fcadfe6","root_ids":["29653"],"roots":{"29653":"160e5f0d-fd82-49bb-acb2-e3b9b51ef87f"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();