(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("f3af7482-5bcd-4b91-9417-6ce9888f5cae");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'f3af7482-5bcd-4b91-9417-6ce9888f5cae' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"62fed131-ee2f-4271-a2be-01dbd1febc34":{"roots":{"references":[{"attributes":{},"id":"38126","type":"BasicTickFormatter"},{"attributes":{},"id":"38090","type":"LinearScale"},{"attributes":{},"id":"38106","type":"ResetTool"},{"attributes":{"overlay":{"id":"38108"}},"id":"38104","type":"BoxZoomTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"38102"},{"id":"38103"},{"id":"38104"},{"id":"38105"},{"id":"38106"},{"id":"38107"}]},"id":"38109","type":"Toolbar"},{"attributes":{},"id":"38086","type":"DataRange1d"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"38118","type":"Circle"},{"attributes":{},"id":"38103","type":"WheelZoomTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"38108","type":"BoxAnnotation"},{"attributes":{},"id":"38088","type":"DataRange1d"},{"attributes":{},"id":"38092","type":"LinearScale"},{"attributes":{"axis":{"id":"38098"},"dimension":1,"ticker":null},"id":"38101","type":"Grid"},{"attributes":{"source":{"id":"38116"}},"id":"38120","type":"CDSView"},{"attributes":{"data_source":{"id":"38116"},"glyph":{"id":"38117"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"38118"},"selection_glyph":null,"view":{"id":"38120"}},"id":"38119","type":"GlyphRenderer"},{"attributes":{},"id":"38099","type":"BasicTicker"},{"attributes":{},"id":"38105","type":"SaveTool"},{"attributes":{"axis":{"id":"38094"},"ticker":null},"id":"38097","type":"Grid"},{"attributes":{"formatter":{"id":"38126"},"ticker":{"id":"38099"}},"id":"38098","type":"LinearAxis"},{"attributes":{},"id":"38124","type":"BasicTickFormatter"},{"attributes":{"text":""},"id":"38121","type":"Title"},{"attributes":{},"id":"38095","type":"BasicTicker"},{"attributes":{},"id":"38128","type":"Selection"},{"attributes":{"formatter":{"id":"38124"},"ticker":{"id":"38095"}},"id":"38094","type":"LinearAxis"},{"attributes":{},"id":"38102","type":"PanTool"},{"attributes":{},"id":"38127","type":"UnionRenderers"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"38128"},"selection_policy":{"id":"38127"}},"id":"38116","type":"ColumnDataSource"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"38117","type":"Circle"},{"attributes":{"below":[{"id":"38094"}],"border_fill_color":"whitesmoke","center":[{"id":"38097"},{"id":"38101"}],"left":[{"id":"38098"}],"min_border_left":80,"plot_height":400,"plot_width":400,"renderers":[{"id":"38119"}],"title":{"id":"38121"},"toolbar":{"id":"38109"},"x_range":{"id":"38086"},"x_scale":{"id":"38090"},"y_range":{"id":"38088"},"y_scale":{"id":"38092"}},"id":"38085","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"38107","type":"HelpTool"}],"root_ids":["38085"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"62fed131-ee2f-4271-a2be-01dbd1febc34","root_ids":["38085"],"roots":{"38085":"f3af7482-5bcd-4b91-9417-6ce9888f5cae"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();