(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("b0925356-511f-490c-9358-30c5f48cd70c");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'b0925356-511f-490c-9358-30c5f48cd70c' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"3aca2528-d889-4832-810a-2f9a7d91870d":{"roots":{"references":[{"attributes":{"text":""},"id":"34309","type":"Title"},{"attributes":{},"id":"34293","type":"SaveTool"},{"attributes":{},"id":"34283","type":"BasicTicker"},{"attributes":{"overlay":{"id":"34296"}},"id":"34292","type":"BoxZoomTool"},{"attributes":{},"id":"34315","type":"UnionRenderers"},{"attributes":{"axis":{"id":"34286"},"dimension":1,"ticker":null},"id":"34289","type":"Grid"},{"attributes":{},"id":"34278","type":"LinearScale"},{"attributes":{"fill_color":"#1f77b4","x":{"field":"x"},"y1":{"field":"y1"},"y2":{"field":"y2"}},"id":"34305","type":"VArea"},{"attributes":{"formatter":{"id":"34314"},"ticker":{"id":"34287"}},"id":"34286","type":"LinearAxis"},{"attributes":{"data_source":{"id":"34304"},"glyph":{"id":"34305"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"34306"},"selection_glyph":null,"view":{"id":"34308"}},"id":"34307","type":"GlyphRenderer"},{"attributes":{},"id":"34290","type":"PanTool"},{"attributes":{"fill_alpha":0.1,"fill_color":"#1f77b4","x":{"field":"x"},"y1":{"field":"y1"},"y2":{"field":"y2"}},"id":"34306","type":"VArea"},{"attributes":{},"id":"34294","type":"ResetTool"},{"attributes":{},"id":"34314","type":"BasicTickFormatter"},{"attributes":{},"id":"34291","type":"WheelZoomTool"},{"attributes":{"data":{"x":[1,2,3,4,5],"y1":[2,6,4,3,5],"y2":[1,4,2,2,3]},"selected":{"id":"34316"},"selection_policy":{"id":"34315"}},"id":"34304","type":"ColumnDataSource"},{"attributes":{},"id":"34274","type":"DataRange1d"},{"attributes":{},"id":"34312","type":"BasicTickFormatter"},{"attributes":{},"id":"34276","type":"DataRange1d"},{"attributes":{"source":{"id":"34304"}},"id":"34308","type":"CDSView"},{"attributes":{"formatter":{"id":"34312"},"ticker":{"id":"34283"}},"id":"34282","type":"LinearAxis"},{"attributes":{},"id":"34280","type":"LinearScale"},{"attributes":{"below":[{"id":"34282"}],"center":[{"id":"34285"},{"id":"34289"}],"left":[{"id":"34286"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"34307"}],"title":{"id":"34309"},"toolbar":{"id":"34297"},"x_range":{"id":"34274"},"x_scale":{"id":"34278"},"y_range":{"id":"34276"},"y_scale":{"id":"34280"}},"id":"34273","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"34295","type":"HelpTool"},{"attributes":{"axis":{"id":"34282"},"ticker":null},"id":"34285","type":"Grid"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"34290"},{"id":"34291"},{"id":"34292"},{"id":"34293"},{"id":"34294"},{"id":"34295"}]},"id":"34297","type":"Toolbar"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"34296","type":"BoxAnnotation"},{"attributes":{},"id":"34316","type":"Selection"},{"attributes":{},"id":"34287","type":"BasicTicker"}],"root_ids":["34273"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"3aca2528-d889-4832-810a-2f9a7d91870d","root_ids":["34273"],"roots":{"34273":"b0925356-511f-490c-9358-30c5f48cd70c"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();