(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("dcffed0e-9884-4fc9-855e-6d1787c2f86c");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'dcffed0e-9884-4fc9-855e-6d1787c2f86c' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"46f05689-6cac-43f3-9175-705d2722fbb5":{"roots":{"references":[{"attributes":{},"id":"25447","type":"ResetTool"},{"attributes":{"end":275,"start":140},"id":"25424","type":"Range1d"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":8},"x":{"field":"weight"},"y":{"field":"height"}},"id":"25459","type":"Scatter"},{"attributes":{"axis_label":"Height (in)","formatter":{"id":"25469"},"ticker":{"id":"25440"}},"id":"25439","type":"LinearAxis"},{"attributes":{"background_fill_color":"white","border_line_color":"black","render_mode":"css","text":"Collected by Luke C. 2016-04-01","x":70,"x_units":"screen","y":70,"y_units":"screen"},"id":"25464","type":"Label"},{"attributes":{},"id":"25436","type":"BasicTicker"},{"attributes":{},"id":"25444","type":"WheelZoomTool"},{"attributes":{"axis":{"id":"25435"},"ticker":null},"id":"25438","type":"Grid"},{"attributes":{},"id":"25431","type":"LinearScale"},{"attributes":{"data":{"height":[66,71,72,68,58,62],"names":["Mark","Amir","Matt","Greg","Owen","Juan"],"weight":[165,189,220,141,260,174]},"selected":{"id":"25471"},"selection_policy":{"id":"25470"}},"id":"25423","type":"ColumnDataSource"},{"attributes":{"source":{"id":"25423"}},"id":"25461","type":"CDSView"},{"attributes":{"below":[{"id":"25435"}],"center":[{"id":"25438"},{"id":"25442"},{"id":"25462"},{"id":"25464"}],"left":[{"id":"25439"}],"renderers":[{"id":"25460"}],"title":{"id":"25426"},"toolbar":{"id":"25450"},"x_range":{"id":"25424"},"x_scale":{"id":"25431"},"y_range":{"id":"25429"},"y_scale":{"id":"25433"}},"id":"25425","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"25443","type":"PanTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"25449","type":"BoxAnnotation"},{"attributes":{"text":"Dist. of 10th Grade Students at Lee High"},"id":"25426","type":"Title"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"25443"},{"id":"25444"},{"id":"25445"},{"id":"25446"},{"id":"25447"},{"id":"25448"}]},"id":"25450","type":"Toolbar"},{"attributes":{"level":"glyph","source":{"id":"25423"},"text":{"field":"names"},"x":{"field":"weight"},"x_offset":{"value":5},"y":{"field":"height"},"y_offset":{"value":5}},"id":"25462","type":"LabelSet"},{"attributes":{},"id":"25469","type":"BasicTickFormatter"},{"attributes":{},"id":"25446","type":"SaveTool"},{"attributes":{"axis":{"id":"25439"},"dimension":1,"ticker":null},"id":"25442","type":"Grid"},{"attributes":{},"id":"25433","type":"LinearScale"},{"attributes":{},"id":"25467","type":"BasicTickFormatter"},{"attributes":{},"id":"25470","type":"UnionRenderers"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":8},"x":{"field":"weight"},"y":{"field":"height"}},"id":"25458","type":"Scatter"},{"attributes":{},"id":"25429","type":"DataRange1d"},{"attributes":{},"id":"25440","type":"BasicTicker"},{"attributes":{},"id":"25448","type":"HelpTool"},{"attributes":{"data_source":{"id":"25423"},"glyph":{"id":"25458"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"25459"},"selection_glyph":null,"view":{"id":"25461"}},"id":"25460","type":"GlyphRenderer"},{"attributes":{"axis_label":"Weight (lbs)","formatter":{"id":"25467"},"ticker":{"id":"25436"}},"id":"25435","type":"LinearAxis"},{"attributes":{"overlay":{"id":"25449"}},"id":"25445","type":"BoxZoomTool"},{"attributes":{},"id":"25471","type":"Selection"}],"root_ids":["25425"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"46f05689-6cac-43f3-9175-705d2722fbb5","root_ids":["25425"],"roots":{"25425":"dcffed0e-9884-4fc9-855e-6d1787c2f86c"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();