(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("3198f7e2-4686-44d2-b70f-b4b957db2fef");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '3198f7e2-4686-44d2-b70f-b4b957db2fef' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"867568ab-4e3d-453a-aecf-0cd03d0effdb":{"roots":{"references":[{"attributes":{},"id":"32428","type":"ResetTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#53777a"},"line_alpha":{"value":0.1},"line_color":{"value":"#53777a"},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"32404","type":"Circle"},{"attributes":{"text":""},"id":"32482","type":"Title"},{"attributes":{},"id":"32446","type":"DataRange1d"},{"attributes":{},"id":"32425","type":"WheelZoomTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"32388"},{"id":"32389"},{"id":"32390"},{"id":"32391"},{"id":"32392"},{"id":"32393"}]},"id":"32395","type":"Toolbar"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#c02942"},"line_alpha":{"value":0.1},"line_color":{"value":"#c02942"},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"32440","type":"Triangle"},{"attributes":{},"id":"32372","type":"DataRange1d"},{"attributes":{},"id":"32376","type":"LinearScale"},{"attributes":{},"id":"32391","type":"SaveTool"},{"attributes":{},"id":"32493","type":"BasicTickFormatter"},{"attributes":{},"id":"32453","type":"BasicTicker"},{"attributes":{"text":""},"id":"32484","type":"Title"},{"attributes":{"axis":{"id":"32420"},"dimension":1,"ticker":null},"id":"32423","type":"Grid"},{"attributes":{"data_source":{"id":"32474"},"glyph":{"id":"32475"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"32476"},"selection_glyph":null,"view":{"id":"32478"}},"id":"32477","type":"GlyphRenderer"},{"attributes":{"axis":{"id":"32452"},"ticker":null},"id":"32455","type":"Grid"},{"attributes":{},"id":"32461","type":"WheelZoomTool"},{"attributes":{},"id":"32385","type":"BasicTicker"},{"attributes":{"children":[{"id":"32371"},{"id":"32407"},{"id":"32443"}]},"id":"32479","type":"Row"},{"attributes":{},"id":"32502","type":"Selection"},{"attributes":{},"id":"32491","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"32491"},"ticker":{"id":"32417"}},"id":"32416","type":"LinearAxis"},{"attributes":{"overlay":{"id":"32430"}},"id":"32426","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"32497"},"ticker":{"id":"32457"}},"id":"32456","type":"LinearAxis"},{"attributes":{"data":{"x":[0,1,2,3,4,5,6,7,8,9,10],"y":[5,4,3,2,1,0,1,2,3,4,5]},"selected":{"id":"32505"},"selection_policy":{"id":"32504"}},"id":"32474","type":"ColumnDataSource"},{"attributes":{"background_fill_color":"#fafafa","below":[{"id":"32416"}],"center":[{"id":"32419"},{"id":"32423"}],"left":[{"id":"32420"}],"plot_height":250,"plot_width":250,"renderers":[{"id":"32441"}],"title":{"id":"32482"},"toolbar":{"id":"32431"},"x_range":{"id":"32408"},"x_scale":{"id":"32412"},"y_range":{"id":"32410"},"y_scale":{"id":"32414"}},"id":"32407","subtype":"Figure","type":"Plot"},{"attributes":{"axis":{"id":"32456"},"dimension":1,"ticker":null},"id":"32459","type":"Grid"},{"attributes":{},"id":"32505","type":"Selection"},{"attributes":{"data_source":{"id":"32402"},"glyph":{"id":"32403"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"32404"},"selection_glyph":null,"view":{"id":"32406"}},"id":"32405","type":"GlyphRenderer"},{"attributes":{"data":{"x":[0,1,2,3,4,5,6,7,8,9,10],"y":[0,1,2,3,4,5,6,7,8,9,10]},"selected":{"id":"32499"},"selection_policy":{"id":"32498"}},"id":"32402","type":"ColumnDataSource"},{"attributes":{},"id":"32378","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"32424"},{"id":"32425"},{"id":"32426"},{"id":"32427"},{"id":"32428"},{"id":"32429"}]},"id":"32431","type":"Toolbar"},{"attributes":{},"id":"32487","type":"BasicTickFormatter"},{"attributes":{},"id":"32499","type":"Selection"},{"attributes":{"source":{"id":"32402"}},"id":"32406","type":"CDSView"},{"attributes":{"formatter":{"id":"32495"},"ticker":{"id":"32453"}},"id":"32452","type":"LinearAxis"},{"attributes":{"data":{"x":[0,1,2,3,4,5,6,7,8,9,10],"y":[10,9,8,7,6,5,4,3,2,1,0]},"selected":{"id":"32502"},"selection_policy":{"id":"32501"}},"id":"32438","type":"ColumnDataSource"},{"attributes":{},"id":"32410","type":"DataRange1d"},{"attributes":{},"id":"32450","type":"LinearScale"},{"attributes":{"source":{"id":"32438"}},"id":"32442","type":"CDSView"},{"attributes":{},"id":"32464","type":"ResetTool"},{"attributes":{},"id":"32497","type":"BasicTickFormatter"},{"attributes":{"background_fill_color":"#fafafa","below":[{"id":"32380"}],"center":[{"id":"32383"},{"id":"32387"}],"left":[{"id":"32384"}],"plot_height":250,"plot_width":250,"renderers":[{"id":"32405"}],"title":{"id":"32480"},"toolbar":{"id":"32395"},"x_range":{"id":"32372"},"x_scale":{"id":"32376"},"y_range":{"id":"32374"},"y_scale":{"id":"32378"}},"id":"32371","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"32501","type":"UnionRenderers"},{"attributes":{},"id":"32495","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"32487"},"ticker":{"id":"32381"}},"id":"32380","type":"LinearAxis"},{"attributes":{"data_source":{"id":"32438"},"glyph":{"id":"32439"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"32440"},"selection_glyph":null,"view":{"id":"32442"}},"id":"32441","type":"GlyphRenderer"},{"attributes":{"background_fill_color":"#fafafa","below":[{"id":"32452"}],"center":[{"id":"32455"},{"id":"32459"}],"left":[{"id":"32456"}],"plot_height":250,"plot_width":250,"renderers":[{"id":"32477"}],"title":{"id":"32484"},"toolbar":{"id":"32467"},"x_range":{"id":"32444"},"x_scale":{"id":"32448"},"y_range":{"id":"32446"},"y_scale":{"id":"32450"}},"id":"32443","subtype":"Figure","type":"Plot"},{"attributes":{"overlay":{"id":"32466"}},"id":"32462","type":"BoxZoomTool"},{"attributes":{},"id":"32389","type":"WheelZoomTool"},{"attributes":{},"id":"32498","type":"UnionRenderers"},{"attributes":{},"id":"32489","type":"BasicTickFormatter"},{"attributes":{},"id":"32393","type":"HelpTool"},{"attributes":{"axis":{"id":"32380"},"ticker":null},"id":"32383","type":"Grid"},{"attributes":{},"id":"32408","type":"DataRange1d"},{"attributes":{"fill_alpha":{"value":0.8},"fill_color":{"value":"#d95b43"},"line_alpha":{"value":0.8},"line_color":{"value":"#d95b43"},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"32475","type":"Square"},{"attributes":{},"id":"32465","type":"HelpTool"},{"attributes":{"formatter":{"id":"32489"},"ticker":{"id":"32385"}},"id":"32384","type":"LinearAxis"},{"attributes":{"formatter":{"id":"32493"},"ticker":{"id":"32421"}},"id":"32420","type":"LinearAxis"},{"attributes":{},"id":"32392","type":"ResetTool"},{"attributes":{"axis":{"id":"32384"},"dimension":1,"ticker":null},"id":"32387","type":"Grid"},{"attributes":{},"id":"32448","type":"LinearScale"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#d95b43"},"line_alpha":{"value":0.1},"line_color":{"value":"#d95b43"},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"32476","type":"Square"},{"attributes":{},"id":"32417","type":"BasicTicker"},{"attributes":{},"id":"32374","type":"DataRange1d"},{"attributes":{},"id":"32444","type":"DataRange1d"},{"attributes":{"fill_alpha":{"value":0.8},"fill_color":{"value":"#c02942"},"line_alpha":{"value":0.8},"line_color":{"value":"#c02942"},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"32439","type":"Triangle"},{"attributes":{},"id":"32381","type":"BasicTicker"},{"attributes":{},"id":"32463","type":"SaveTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"32466","type":"BoxAnnotation"},{"attributes":{"overlay":{"id":"32394"}},"id":"32390","type":"BoxZoomTool"},{"attributes":{"text":""},"id":"32480","type":"Title"},{"attributes":{},"id":"32424","type":"PanTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"32430","type":"BoxAnnotation"},{"attributes":{},"id":"32429","type":"HelpTool"},{"attributes":{},"id":"32460","type":"PanTool"},{"attributes":{},"id":"32388","type":"PanTool"},{"attributes":{},"id":"32457","type":"BasicTicker"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"32460"},{"id":"32461"},{"id":"32462"},{"id":"32463"},{"id":"32464"},{"id":"32465"}]},"id":"32467","type":"Toolbar"},{"attributes":{},"id":"32414","type":"LinearScale"},{"attributes":{"fill_alpha":{"value":0.8},"fill_color":{"value":"#53777a"},"line_alpha":{"value":0.8},"line_color":{"value":"#53777a"},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"32403","type":"Circle"},{"attributes":{},"id":"32504","type":"UnionRenderers"},{"attributes":{},"id":"32421","type":"BasicTicker"},{"attributes":{"axis":{"id":"32416"},"ticker":null},"id":"32419","type":"Grid"},{"attributes":{},"id":"32412","type":"LinearScale"},{"attributes":{"source":{"id":"32474"}},"id":"32478","type":"CDSView"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"32394","type":"BoxAnnotation"},{"attributes":{},"id":"32427","type":"SaveTool"}],"root_ids":["32479"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"867568ab-4e3d-453a-aecf-0cd03d0effdb","root_ids":["32479"],"roots":{"32479":"3198f7e2-4686-44d2-b70f-b4b957db2fef"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();