(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("c2f61707-b86e-4f3e-b98f-0c7dc2049fdb");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'c2f61707-b86e-4f3e-b98f-0c7dc2049fdb' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"6f3d7a02-f731-4529-a4dc-ef8b2e2f20fa":{"roots":{"references":[{"attributes":{"formatter":{"id":"33286"},"ticker":{"id":"33259"}},"id":"33258","type":"LinearAxis"},{"attributes":{},"id":"33255","type":"BasicTicker"},{"attributes":{},"id":"33250","type":"LinearScale"},{"attributes":{},"id":"33252","type":"LinearScale"},{"attributes":{},"id":"33248","type":"DataRange1d"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"33268","type":"BoxAnnotation"},{"attributes":{},"id":"33284","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,2,4,5]},"selected":{"id":"33288"},"selection_policy":{"id":"33287"}},"id":"33276","type":"ColumnDataSource"},{"attributes":{"text":""},"id":"33281","type":"Title"},{"attributes":{},"id":"33262","type":"PanTool"},{"attributes":{"overlay":{"id":"33268"}},"id":"33264","type":"BoxZoomTool"},{"attributes":{},"id":"33267","type":"HelpTool"},{"attributes":{},"id":"33259","type":"BasicTicker"},{"attributes":{},"id":"33266","type":"ResetTool"},{"attributes":{},"id":"33286","type":"BasicTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"33262"},{"id":"33263"},{"id":"33264"},{"id":"33265"},{"id":"33266"},{"id":"33267"}]},"id":"33269","type":"Toolbar"},{"attributes":{"below":[{"id":"33254"}],"center":[{"id":"33257"},{"id":"33261"}],"left":[{"id":"33258"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"33279"}],"title":{"id":"33281"},"toolbar":{"id":"33269"},"x_range":{"id":"33246"},"x_scale":{"id":"33250"},"y_range":{"id":"33248"},"y_scale":{"id":"33252"}},"id":"33245","subtype":"Figure","type":"Plot"},{"attributes":{"source":{"id":"33276"}},"id":"33280","type":"CDSView"},{"attributes":{"axis":{"id":"33258"},"dimension":1,"ticker":null},"id":"33261","type":"Grid"},{"attributes":{},"id":"33288","type":"Selection"},{"attributes":{"formatter":{"id":"33284"},"ticker":{"id":"33255"}},"id":"33254","type":"LinearAxis"},{"attributes":{"data_source":{"id":"33276"},"glyph":{"id":"33277"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"33278"},"selection_glyph":null,"view":{"id":"33280"}},"id":"33279","type":"GlyphRenderer"},{"attributes":{"axis":{"id":"33254"},"ticker":null},"id":"33257","type":"Grid"},{"attributes":{},"id":"33246","type":"DataRange1d"},{"attributes":{},"id":"33263","type":"WheelZoomTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"navy"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"33278","type":"Circle"},{"attributes":{},"id":"33265","type":"SaveTool"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"navy"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"33277","type":"Circle"},{"attributes":{},"id":"33287","type":"UnionRenderers"}],"root_ids":["33245"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"6f3d7a02-f731-4529-a4dc-ef8b2e2f20fa","root_ids":["33245"],"roots":{"33245":"c2f61707-b86e-4f3e-b98f-0c7dc2049fdb"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();