(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("8be58143-cff1-4b5e-8b7d-d06505304460");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '8be58143-cff1-4b5e-8b7d-d06505304460' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"b3ac86b5-781c-4975-a98c-9d8d57bea12e":{"roots":{"references":[{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"41407","type":"BoxAnnotation"},{"attributes":{"formatter":{"id":"41426"},"ticker":{"id":"41398"}},"id":"41397","type":"LinearAxis"},{"attributes":{},"id":"41426","type":"BasicTickFormatter"},{"attributes":{},"id":"41389","type":"LinearScale"},{"attributes":{},"id":"41424","type":"BasicTickFormatter"},{"attributes":{},"id":"41401","type":"PanTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"41419","type":"Circle"},{"attributes":{"below":[{"id":"41393"}],"center":[{"id":"41396"},{"id":"41400"}],"left":[{"id":"41397"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"41420"}],"title":{"id":"41383"},"toolbar":{"id":"41409"},"x_range":{"id":"41385"},"x_scale":{"id":"41389"},"y_range":{"id":"41387"},"y_scale":{"id":"41391"}},"id":"41382","subtype":"Figure","type":"Plot"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"41401"},{"id":"41402"},{"id":"41403"},{"id":"41404"},{"id":"41405"},{"id":"41406"},{"id":"41408"}]},"id":"41409","type":"Toolbar"},{"attributes":{"source":{"id":"41381"}},"id":"41421","type":"CDSView"},{"attributes":{},"id":"41404","type":"SaveTool"},{"attributes":{"axis":{"id":"41397"},"dimension":1,"ticker":null},"id":"41400","type":"Grid"},{"attributes":{"overlay":{"id":"41407"}},"id":"41403","type":"BoxZoomTool"},{"attributes":{},"id":"41387","type":"DataRange1d"},{"attributes":{},"id":"41385","type":"DataRange1d"},{"attributes":{},"id":"41402","type":"WheelZoomTool"},{"attributes":{},"id":"41398","type":"BasicTicker"},{"attributes":{},"id":"41427","type":"UnionRenderers"},{"attributes":{},"id":"41428","type":"Selection"},{"attributes":{"data_source":{"id":"41381"},"glyph":{"id":"41418"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"41419"},"selection_glyph":null,"view":{"id":"41421"}},"id":"41420","type":"GlyphRenderer"},{"attributes":{"data":{"desc":["A","b","C","d","E"],"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"41428"},"selection_policy":{"id":"41427"}},"id":"41381","type":"ColumnDataSource"},{"attributes":{},"id":"41391","type":"LinearScale"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"41418","type":"Circle"},{"attributes":{"axis":{"id":"41393"},"ticker":null},"id":"41396","type":"Grid"},{"attributes":{"formatter":{"id":"41424"},"ticker":{"id":"41394"}},"id":"41393","type":"LinearAxis"},{"attributes":{},"id":"41405","type":"ResetTool"},{"attributes":{},"id":"41394","type":"BasicTicker"},{"attributes":{"callback":null,"tooltips":[["index","$index"],["(x,y)","($x, $y)"],["desc","@desc"]]},"id":"41408","type":"HoverTool"},{"attributes":{},"id":"41406","type":"HelpTool"},{"attributes":{"text":"Mouse over the dots"},"id":"41383","type":"Title"}],"root_ids":["41382"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"b3ac86b5-781c-4975-a98c-9d8d57bea12e","root_ids":["41382"],"roots":{"41382":"8be58143-cff1-4b5e-8b7d-d06505304460"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();