(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("55d924f2-6973-4160-9dda-a70490b2d21a");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '55d924f2-6973-4160-9dda-a70490b2d21a' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"bf18bf62-1522-4bc9-b6d4-07b893376c82":{"roots":{"references":[{"attributes":{},"id":"34428","type":"DataRange1d"},{"attributes":{"source":{"id":"34458"}},"id":"34462","type":"CDSView"},{"attributes":{"data_source":{"id":"34458"},"glyph":{"id":"34459"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"34460"},"selection_glyph":null,"view":{"id":"34462"}},"id":"34461","type":"GlyphRenderer"},{"attributes":{},"id":"34432","type":"LinearScale"},{"attributes":{},"id":"34470","type":"Selection"},{"attributes":{"fill_alpha":0.1,"fill_color":"#1f77b4","line_alpha":0.1,"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"34460","type":"Patch"},{"attributes":{"formatter":{"id":"34466"},"ticker":{"id":"34437"}},"id":"34436","type":"LinearAxis"},{"attributes":{},"id":"34447","type":"SaveTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"34450","type":"BoxAnnotation"},{"attributes":{"formatter":{"id":"34468"},"ticker":{"id":"34441"}},"id":"34440","type":"LinearAxis"},{"attributes":{},"id":"34430","type":"DataRange1d"},{"attributes":{"axis":{"id":"34436"},"ticker":null},"id":"34439","type":"Grid"},{"attributes":{"fill_alpha":0.5,"fill_color":"#1f77b4","line_alpha":0.5,"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"34459","type":"Patch"},{"attributes":{},"id":"34469","type":"UnionRenderers"},{"attributes":{},"id":"34444","type":"PanTool"},{"attributes":{},"id":"34441","type":"BasicTicker"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,8,7,3]},"selected":{"id":"34470"},"selection_policy":{"id":"34469"}},"id":"34458","type":"ColumnDataSource"},{"attributes":{"text":""},"id":"34463","type":"Title"},{"attributes":{},"id":"34437","type":"BasicTicker"},{"attributes":{"overlay":{"id":"34450"}},"id":"34446","type":"BoxZoomTool"},{"attributes":{},"id":"34466","type":"BasicTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"34444"},{"id":"34445"},{"id":"34446"},{"id":"34447"},{"id":"34448"},{"id":"34449"}]},"id":"34451","type":"Toolbar"},{"attributes":{},"id":"34445","type":"WheelZoomTool"},{"attributes":{},"id":"34449","type":"HelpTool"},{"attributes":{"axis":{"id":"34440"},"dimension":1,"ticker":null},"id":"34443","type":"Grid"},{"attributes":{},"id":"34448","type":"ResetTool"},{"attributes":{"below":[{"id":"34436"}],"center":[{"id":"34439"},{"id":"34443"}],"left":[{"id":"34440"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"34461"}],"title":{"id":"34463"},"toolbar":{"id":"34451"},"x_range":{"id":"34428"},"x_scale":{"id":"34432"},"y_range":{"id":"34430"},"y_scale":{"id":"34434"}},"id":"34427","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"34434","type":"LinearScale"},{"attributes":{},"id":"34468","type":"BasicTickFormatter"}],"root_ids":["34427"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"bf18bf62-1522-4bc9-b6d4-07b893376c82","root_ids":["34427"],"roots":{"34427":"55d924f2-6973-4160-9dda-a70490b2d21a"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();