(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("5a0bda2b-fba6-4a50-a607-c3bd4d011912");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '5a0bda2b-fba6-4a50-a607-c3bd4d011912' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"afa21310-d0f1-48fe-a5b7-c4df08d049ab":{"roots":{"references":[{"attributes":{},"id":"38865","type":"BasicTicker"},{"attributes":{},"id":"38876","type":"ResetTool"},{"attributes":{"axis":{"id":"38864"},"ticker":null},"id":"38867","type":"Grid"},{"attributes":{},"id":"38872","type":"PanTool"},{"attributes":{},"id":"38897","type":"UnionRenderers"},{"attributes":{"source":{"id":"38886"}},"id":"38890","type":"CDSView"},{"attributes":{},"id":"38860","type":"LinearScale"},{"attributes":{"overlay":{"id":"38878"}},"id":"38874","type":"BoxZoomTool"},{"attributes":{},"id":"38877","type":"HelpTool"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"38898"},"selection_policy":{"id":"38897"}},"id":"38886","type":"ColumnDataSource"},{"attributes":{},"id":"38856","type":"DataRange1d"},{"attributes":{},"id":"38896","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"38886"},"glyph":{"id":"38887"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"38888"},"selection_glyph":null,"view":{"id":"38890"}},"id":"38889","type":"GlyphRenderer"},{"attributes":{},"id":"38873","type":"WheelZoomTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"38888","type":"Circle"},{"attributes":{"below":[{"id":"38864"}],"center":[{"id":"38867"},{"id":"38871"}],"left":[{"id":"38868"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"38889"}],"title":{"id":"38891"},"toolbar":{"id":"38879"},"x_range":{"id":"38856"},"x_scale":{"id":"38860"},"y_range":{"id":"38858"},"y_scale":{"id":"38862"}},"id":"38855","subtype":"Figure","type":"Plot"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"38872"},{"id":"38873"},{"id":"38874"},{"id":"38875"},{"id":"38876"},{"id":"38877"}]},"id":"38879","type":"Toolbar"},{"attributes":{},"id":"38894","type":"BasicTickFormatter"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"38878","type":"BoxAnnotation"},{"attributes":{},"id":"38869","type":"BasicTicker"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"38887","type":"Circle"},{"attributes":{"formatter":{"id":"38896"},"ticker":{"id":"38869"}},"id":"38868","type":"LinearAxis"},{"attributes":{"text":""},"id":"38891","type":"Title"},{"attributes":{"bounds":[2,4],"formatter":{"id":"38894"},"ticker":{"id":"38865"}},"id":"38864","type":"LinearAxis"},{"attributes":{},"id":"38898","type":"Selection"},{"attributes":{},"id":"38875","type":"SaveTool"},{"attributes":{},"id":"38858","type":"DataRange1d"},{"attributes":{},"id":"38862","type":"LinearScale"},{"attributes":{"axis":{"id":"38868"},"dimension":1,"ticker":null},"id":"38871","type":"Grid"}],"root_ids":["38855"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"afa21310-d0f1-48fe-a5b7-c4df08d049ab","root_ids":["38855"],"roots":{"38855":"5a0bda2b-fba6-4a50-a607-c3bd4d011912"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();