(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("a3d4ede3-ab53-43fb-bb0d-07c965b1c481");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'a3d4ede3-ab53-43fb-bb0d-07c965b1c481' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"66de0794-107b-4aed-a29e-0c9c9d3f89ae":{"roots":{"references":[{"attributes":{"below":[{"id":"34580"}],"center":[{"id":"34583"},{"id":"34587"}],"left":[{"id":"34584"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"34605"}],"title":{"id":"34607"},"toolbar":{"id":"34595"},"x_range":{"id":"34572"},"x_scale":{"id":"34576"},"y_range":{"id":"34574"},"y_scale":{"id":"34578"}},"id":"34571","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"34581","type":"BasicTicker"},{"attributes":{},"id":"34574","type":"DataRange1d"},{"attributes":{"fill_alpha":0.5,"fill_color":"#1f77b4","line_alpha":0.5,"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"34603","type":"Patch"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"34594","type":"BoxAnnotation"},{"attributes":{},"id":"34591","type":"SaveTool"},{"attributes":{},"id":"34589","type":"WheelZoomTool"},{"attributes":{},"id":"34612","type":"BasicTickFormatter"},{"attributes":{},"id":"34588","type":"PanTool"},{"attributes":{},"id":"34592","type":"ResetTool"},{"attributes":{"data_source":{"id":"34602"},"glyph":{"id":"34603"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"34604"},"selection_glyph":null,"view":{"id":"34606"}},"id":"34605","type":"GlyphRenderer"},{"attributes":{},"id":"34578","type":"LinearScale"},{"attributes":{"formatter":{"id":"34610"},"ticker":{"id":"34581"}},"id":"34580","type":"LinearAxis"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"34588"},{"id":"34589"},{"id":"34590"},{"id":"34591"},{"id":"34592"},{"id":"34593"}]},"id":"34595","type":"Toolbar"},{"attributes":{"overlay":{"id":"34594"}},"id":"34590","type":"BoxZoomTool"},{"attributes":{},"id":"34614","type":"Selection"},{"attributes":{"data":{"x":[1,2,3,"NaN",4,5,6],"y":[6,7,5,"NaN",7,3,6]},"selected":{"id":"34614"},"selection_policy":{"id":"34613"}},"id":"34602","type":"ColumnDataSource"},{"attributes":{},"id":"34593","type":"HelpTool"},{"attributes":{},"id":"34613","type":"UnionRenderers"},{"attributes":{},"id":"34585","type":"BasicTicker"},{"attributes":{},"id":"34576","type":"LinearScale"},{"attributes":{},"id":"34610","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"34584"},"dimension":1,"ticker":null},"id":"34587","type":"Grid"},{"attributes":{"source":{"id":"34602"}},"id":"34606","type":"CDSView"},{"attributes":{"axis":{"id":"34580"},"ticker":null},"id":"34583","type":"Grid"},{"attributes":{"fill_alpha":0.1,"fill_color":"#1f77b4","line_alpha":0.1,"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"34604","type":"Patch"},{"attributes":{"text":""},"id":"34607","type":"Title"},{"attributes":{"formatter":{"id":"34612"},"ticker":{"id":"34585"}},"id":"34584","type":"LinearAxis"},{"attributes":{},"id":"34572","type":"DataRange1d"}],"root_ids":["34571"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"66de0794-107b-4aed-a29e-0c9c9d3f89ae","root_ids":["34571"],"roots":{"34571":"a3d4ede3-ab53-43fb-bb0d-07c965b1c481"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();