(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("c815221f-34b3-44ff-872a-c5177142f4a0");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'c815221f-34b3-44ff-872a-c5177142f4a0' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"99f67505-8ccc-40ff-842f-77717435caeb":{"roots":{"references":[{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"38036","type":"BoxAnnotation"},{"attributes":{"background_fill_alpha":0.5,"background_fill_color":"beige","below":[{"id":"38022"}],"center":[{"id":"38025"},{"id":"38029"}],"left":[{"id":"38026"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"38047"}],"title":{"id":"38049"},"toolbar":{"id":"38037"},"x_range":{"id":"38014"},"x_scale":{"id":"38018"},"y_range":{"id":"38016"},"y_scale":{"id":"38020"}},"id":"38013","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"38020","type":"LinearScale"},{"attributes":{},"id":"38027","type":"BasicTicker"},{"attributes":{},"id":"38055","type":"UnionRenderers"},{"attributes":{},"id":"38016","type":"DataRange1d"},{"attributes":{},"id":"38034","type":"ResetTool"},{"attributes":{},"id":"38014","type":"DataRange1d"},{"attributes":{},"id":"38031","type":"WheelZoomTool"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"38045","type":"Circle"},{"attributes":{"axis":{"id":"38026"},"dimension":1,"ticker":null},"id":"38029","type":"Grid"},{"attributes":{},"id":"38056","type":"Selection"},{"attributes":{"overlay":{"id":"38036"}},"id":"38032","type":"BoxZoomTool"},{"attributes":{"text":""},"id":"38049","type":"Title"},{"attributes":{},"id":"38030","type":"PanTool"},{"attributes":{},"id":"38052","type":"BasicTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"38030"},{"id":"38031"},{"id":"38032"},{"id":"38033"},{"id":"38034"},{"id":"38035"}]},"id":"38037","type":"Toolbar"},{"attributes":{},"id":"38033","type":"SaveTool"},{"attributes":{"formatter":{"id":"38052"},"ticker":{"id":"38023"}},"id":"38022","type":"LinearAxis"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"38046","type":"Circle"},{"attributes":{},"id":"38018","type":"LinearScale"},{"attributes":{},"id":"38035","type":"HelpTool"},{"attributes":{"source":{"id":"38044"}},"id":"38048","type":"CDSView"},{"attributes":{},"id":"38023","type":"BasicTicker"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"38056"},"selection_policy":{"id":"38055"}},"id":"38044","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"38044"},"glyph":{"id":"38045"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"38046"},"selection_glyph":null,"view":{"id":"38048"}},"id":"38047","type":"GlyphRenderer"},{"attributes":{"axis":{"id":"38022"},"ticker":null},"id":"38025","type":"Grid"},{"attributes":{"formatter":{"id":"38054"},"ticker":{"id":"38027"}},"id":"38026","type":"LinearAxis"},{"attributes":{},"id":"38054","type":"BasicTickFormatter"}],"root_ids":["38013"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"99f67505-8ccc-40ff-842f-77717435caeb","root_ids":["38013"],"roots":{"38013":"c815221f-34b3-44ff-872a-c5177142f4a0"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();