(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("15055bc0-6324-4de6-82bb-b22f7adbb3b1");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '15055bc0-6324-4de6-82bb-b22f7adbb3b1' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"981eafea-e327-4f6e-ba22-55b00338a4cb":{"roots":{"references":[{"attributes":{},"id":"33834","type":"LinearScale"},{"attributes":{},"id":"33843","type":"BasicTicker"},{"attributes":{},"id":"33846","type":"PanTool"},{"attributes":{"data":{"right":[1.2,2.5,3.7],"y":[1,2,3]},"selected":{"id":"33872"},"selection_policy":{"id":"33871"}},"id":"33860","type":"ColumnDataSource"},{"attributes":{},"id":"33836","type":"LinearScale"},{"attributes":{},"id":"33832","type":"DataRange1d"},{"attributes":{},"id":"33839","type":"BasicTicker"},{"attributes":{},"id":"33870","type":"BasicTickFormatter"},{"attributes":{},"id":"33851","type":"HelpTool"},{"attributes":{"overlay":{"id":"33852"}},"id":"33848","type":"BoxZoomTool"},{"attributes":{},"id":"33847","type":"WheelZoomTool"},{"attributes":{"axis":{"id":"33842"},"dimension":1,"ticker":null},"id":"33845","type":"Grid"},{"attributes":{},"id":"33850","type":"ResetTool"},{"attributes":{"below":[{"id":"33838"}],"center":[{"id":"33841"},{"id":"33845"}],"left":[{"id":"33842"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"33863"}],"title":{"id":"33865"},"toolbar":{"id":"33853"},"x_range":{"id":"33830"},"x_scale":{"id":"33834"},"y_range":{"id":"33832"},"y_scale":{"id":"33836"}},"id":"33829","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"33871","type":"UnionRenderers"},{"attributes":{},"id":"33872","type":"Selection"},{"attributes":{"formatter":{"id":"33870"},"ticker":{"id":"33843"}},"id":"33842","type":"LinearAxis"},{"attributes":{"axis":{"id":"33838"},"ticker":null},"id":"33841","type":"Grid"},{"attributes":{"text":""},"id":"33865","type":"Title"},{"attributes":{"source":{"id":"33860"}},"id":"33864","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"navy"},"height":{"value":0.5},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"right":{"field":"right"},"y":{"field":"y"}},"id":"33862","type":"HBar"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"33852","type":"BoxAnnotation"},{"attributes":{},"id":"33830","type":"DataRange1d"},{"attributes":{},"id":"33868","type":"BasicTickFormatter"},{"attributes":{},"id":"33849","type":"SaveTool"},{"attributes":{"data_source":{"id":"33860"},"glyph":{"id":"33861"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"33862"},"selection_glyph":null,"view":{"id":"33864"}},"id":"33863","type":"GlyphRenderer"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"33846"},{"id":"33847"},{"id":"33848"},{"id":"33849"},{"id":"33850"},{"id":"33851"}]},"id":"33853","type":"Toolbar"},{"attributes":{"formatter":{"id":"33868"},"ticker":{"id":"33839"}},"id":"33838","type":"LinearAxis"},{"attributes":{"fill_color":{"value":"navy"},"height":{"value":0.5},"line_color":{"value":"navy"},"right":{"field":"right"},"y":{"field":"y"}},"id":"33861","type":"HBar"}],"root_ids":["33829"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"981eafea-e327-4f6e-ba22-55b00338a4cb","root_ids":["33829"],"roots":{"33829":"15055bc0-6324-4de6-82bb-b22f7adbb3b1"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();