(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("836f79b6-e7d8-46a8-b308-ff7b8d81b0f8");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '836f79b6-e7d8-46a8-b308-ff7b8d81b0f8' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"27d24664-fcc7-4348-a752-783885851e04":{"roots":{"references":[{"attributes":{"formatter":{"id":"38332"},"ticker":{"id":"38313"}},"id":"38312","type":"LinearAxis"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"38320"}]},"id":"38321","type":"Toolbar"},{"attributes":{},"id":"38335","type":"UnionRenderers"},{"attributes":{"below":[{"id":"38312"}],"center":[{"id":"38315"},{"id":"38319"}],"left":[{"id":"38316"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"38326"}],"title":{"id":"38302"},"toolbar":{"id":"38321"},"x_range":{"id":"38304"},"x_scale":{"id":"38308"},"y_range":{"id":"38306"},"y_scale":{"id":"38310"}},"id":"38301","subtype":"Figure","type":"Plot"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"38324","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.2},"fill_color":{"value":"blue"},"line_color":{"value":"firebrick"}},"id":"38329","type":"Circle"},{"attributes":{"fill_color":{"value":"firebrick"},"line_color":{"value":null}},"id":"38328","type":"Circle"},{"attributes":{},"id":"38317","type":"BasicTicker"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"38336"},"selection_policy":{"id":"38335"}},"id":"38323","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"38334"},"ticker":{"id":"38317"}},"id":"38316","type":"LinearAxis"},{"attributes":{"source":{"id":"38323"}},"id":"38327","type":"CDSView"},{"attributes":{},"id":"38304","type":"DataRange1d"},{"attributes":{"data_source":{"id":"38323"},"glyph":{"id":"38324"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"38329"},"selection_glyph":{"id":"38328"},"view":{"id":"38327"}},"id":"38326","type":"GlyphRenderer"},{"attributes":{},"id":"38334","type":"BasicTickFormatter"},{"attributes":{"text":"Select a circle"},"id":"38302","type":"Title"},{"attributes":{"axis":{"id":"38316"},"dimension":1,"ticker":null},"id":"38319","type":"Grid"},{"attributes":{"axis":{"id":"38312"},"ticker":null},"id":"38315","type":"Grid"},{"attributes":{},"id":"38332","type":"BasicTickFormatter"},{"attributes":{},"id":"38336","type":"Selection"},{"attributes":{},"id":"38306","type":"DataRange1d"},{"attributes":{},"id":"38310","type":"LinearScale"},{"attributes":{},"id":"38313","type":"BasicTicker"},{"attributes":{},"id":"38308","type":"LinearScale"},{"attributes":{"callback":null},"id":"38320","type":"TapTool"}],"root_ids":["38301"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"27d24664-fcc7-4348-a752-783885851e04","root_ids":["38301"],"roots":{"38301":"836f79b6-e7d8-46a8-b308-ff7b8d81b0f8"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();