(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("00615ec6-e1aa-47ac-87b1-df33889ca853");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '00615ec6-e1aa-47ac-87b1-df33889ca853' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"47d41565-8c8a-43b9-b221-0e9e9e2b81cb":{"roots":{"references":[{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"38174"},{"id":"38175"},{"id":"38176"},{"id":"38177"},{"id":"38178"},{"id":"38179"}]},"id":"38181","type":"Toolbar"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"38180","type":"BoxAnnotation"},{"attributes":{"source":{"id":"38188"}},"id":"38192","type":"CDSView"},{"attributes":{},"id":"38179","type":"HelpTool"},{"attributes":{},"id":"38200","type":"Selection"},{"attributes":{"axis":{"id":"38170"},"dimension":1,"ticker":null},"id":"38173","type":"Grid"},{"attributes":{"data_source":{"id":"38188"},"glyph":{"id":"38189"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"38190"},"selection_glyph":null,"view":{"id":"38192"}},"id":"38191","type":"GlyphRenderer"},{"attributes":{},"id":"38175","type":"WheelZoomTool"},{"attributes":{},"id":"38198","type":"BasicTickFormatter"},{"attributes":{},"id":"38171","type":"BasicTicker"},{"attributes":{},"id":"38164","type":"LinearScale"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"38200"},"selection_policy":{"id":"38199"}},"id":"38188","type":"ColumnDataSource"},{"attributes":{},"id":"38178","type":"ResetTool"},{"attributes":{},"id":"38167","type":"BasicTicker"},{"attributes":{},"id":"38162","type":"LinearScale"},{"attributes":{},"id":"38158","type":"DataRange1d"},{"attributes":{"formatter":{"id":"38198"},"ticker":{"id":"38171"}},"id":"38170","type":"LinearAxis"},{"attributes":{},"id":"38177","type":"SaveTool"},{"attributes":{},"id":"38160","type":"DataRange1d"},{"attributes":{},"id":"38174","type":"PanTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"38190","type":"Circle"},{"attributes":{},"id":"38199","type":"UnionRenderers"},{"attributes":{"formatter":{"id":"38196"},"ticker":{"id":"38167"}},"id":"38166","type":"LinearAxis"},{"attributes":{"overlay":{"id":"38180"}},"id":"38176","type":"BoxZoomTool"},{"attributes":{"below":[{"id":"38166"}],"center":[{"id":"38169"},{"id":"38173"}],"left":[{"id":"38170"}],"outline_line_alpha":0.3,"outline_line_color":"navy","outline_line_width":7,"plot_height":400,"plot_width":400,"renderers":[{"id":"38191"}],"title":{"id":"38193"},"toolbar":{"id":"38181"},"x_range":{"id":"38158"},"x_scale":{"id":"38162"},"y_range":{"id":"38160"},"y_scale":{"id":"38164"}},"id":"38157","subtype":"Figure","type":"Plot"},{"attributes":{"text":""},"id":"38193","type":"Title"},{"attributes":{},"id":"38196","type":"BasicTickFormatter"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"38189","type":"Circle"},{"attributes":{"axis":{"id":"38166"},"ticker":null},"id":"38169","type":"Grid"}],"root_ids":["38157"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"47d41565-8c8a-43b9-b221-0e9e9e2b81cb","root_ids":["38157"],"roots":{"38157":"00615ec6-e1aa-47ac-87b1-df33889ca853"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();