(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("1002665d-6609-4e40-9012-4b50c0e95ac3");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '1002665d-6609-4e40-9012-4b50c0e95ac3' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"4387bac2-21d0-4e96-b9cb-5d7d74b343f2":{"roots":{"references":[{"attributes":{},"id":"34025","type":"UnionRenderers"},{"attributes":{"source":{"id":"34014"}},"id":"34018","type":"CDSView"},{"attributes":{"below":[{"id":"33992"}],"center":[{"id":"33995"},{"id":"33999"}],"left":[{"id":"33996"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"34017"}],"title":{"id":"34019"},"toolbar":{"id":"34007"},"x_range":{"id":"33984"},"x_scale":{"id":"33988"},"y_range":{"id":"33986"},"y_scale":{"id":"33990"}},"id":"33983","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"33986","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"34000"},{"id":"34001"},{"id":"34002"},{"id":"34003"},{"id":"34004"},{"id":"34005"}]},"id":"34007","type":"Toolbar"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":"#B3DE69"},"left":{"field":"left"},"line_color":{"value":"#B3DE69"},"right":{"field":"right"},"top":{"field":"top"}},"id":"34015","type":"Quad"},{"attributes":{"axis":{"id":"33992"},"ticker":null},"id":"33995","type":"Grid"},{"attributes":{},"id":"34022","type":"BasicTickFormatter"},{"attributes":{},"id":"33997","type":"BasicTicker"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#B3DE69"},"left":{"field":"left"},"line_alpha":{"value":0.1},"line_color":{"value":"#B3DE69"},"right":{"field":"right"},"top":{"field":"top"}},"id":"34016","type":"Quad"},{"attributes":{},"id":"34001","type":"WheelZoomTool"},{"attributes":{},"id":"34004","type":"ResetTool"},{"attributes":{"axis":{"id":"33996"},"dimension":1,"ticker":null},"id":"33999","type":"Grid"},{"attributes":{"formatter":{"id":"34024"},"ticker":{"id":"33997"}},"id":"33996","type":"LinearAxis"},{"attributes":{},"id":"33993","type":"BasicTicker"},{"attributes":{"formatter":{"id":"34022"},"ticker":{"id":"33993"}},"id":"33992","type":"LinearAxis"},{"attributes":{},"id":"34003","type":"SaveTool"},{"attributes":{"data_source":{"id":"34014"},"glyph":{"id":"34015"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"34016"},"selection_glyph":null,"view":{"id":"34018"}},"id":"34017","type":"GlyphRenderer"},{"attributes":{},"id":"33990","type":"LinearScale"},{"attributes":{"data":{"bottom":[1,2,3],"left":[1,2,3],"right":[1.2,2.5,3.7],"top":[2,3,4]},"selected":{"id":"34026"},"selection_policy":{"id":"34025"}},"id":"34014","type":"ColumnDataSource"},{"attributes":{},"id":"33984","type":"DataRange1d"},{"attributes":{},"id":"34024","type":"BasicTickFormatter"},{"attributes":{},"id":"34000","type":"PanTool"},{"attributes":{},"id":"34005","type":"HelpTool"},{"attributes":{},"id":"33988","type":"LinearScale"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"34006","type":"BoxAnnotation"},{"attributes":{"overlay":{"id":"34006"}},"id":"34002","type":"BoxZoomTool"},{"attributes":{},"id":"34026","type":"Selection"},{"attributes":{"text":""},"id":"34019","type":"Title"}],"root_ids":["33983"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"4387bac2-21d0-4e96-b9cb-5d7d74b343f2","root_ids":["33983"],"roots":{"33983":"1002665d-6609-4e40-9012-4b50c0e95ac3"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();