(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("87037e29-c653-42a6-983d-e79ebe94234e");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '87037e29-c653-42a6-983d-e79ebe94234e' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"149198f6-e80c-41bd-b113-1274d0d9dee2":{"roots":{"references":[{"attributes":{"below":[{"id":"33911"}],"center":[{"id":"33914"},{"id":"33918"}],"left":[{"id":"33915"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"33940"},{"id":"33945"}],"title":{"id":"33947"},"toolbar":{"id":"33926"},"x_range":{"id":"33903"},"x_scale":{"id":"33907"},"y_range":{"id":"33905"},"y_scale":{"id":"33909"}},"id":"33902","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"33907","type":"LinearScale"},{"attributes":{"fill_color":{"value":"lightgrey"},"height":{"value":0.8},"left":{"expr":{"id":"33935"}},"line_color":{"value":"lightgrey"},"right":{"expr":{"id":"33936"}},"y":{"field":"y"}},"id":"33943","type":"HBar"},{"attributes":{},"id":"33920","type":"WheelZoomTool"},{"attributes":{},"id":"33922","type":"SaveTool"},{"attributes":{"axis":{"id":"33911"},"ticker":null},"id":"33914","type":"Grid"},{"attributes":{},"id":"33912","type":"BasicTicker"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"lightgrey"},"height":{"value":0.8},"left":{"expr":{"id":"33935"}},"line_alpha":{"value":0.1},"line_color":{"value":"lightgrey"},"right":{"expr":{"id":"33936"}},"y":{"field":"y"}},"id":"33944","type":"HBar"},{"attributes":{},"id":"33924","type":"HelpTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"33925","type":"BoxAnnotation"},{"attributes":{"formatter":{"id":"33950"},"ticker":{"id":"33912"}},"id":"33911","type":"LinearAxis"},{"attributes":{"source":{"id":"33901"}},"id":"33946","type":"CDSView"},{"attributes":{},"id":"33909","type":"LinearScale"},{"attributes":{"fill_color":{"value":"grey"},"height":{"value":0.8},"left":{"expr":{"id":"33933"}},"line_color":{"value":"grey"},"right":{"expr":{"id":"33934"}},"y":{"field":"y"}},"id":"33938","type":"HBar"},{"attributes":{},"id":"33923","type":"ResetTool"},{"attributes":{"fields":["x1","x2"]},"id":"33936","type":"Stack"},{"attributes":{"axis":{"id":"33915"},"dimension":1,"ticker":null},"id":"33918","type":"Grid"},{"attributes":{"data":{"x1":[1,2,4,3,4],"x2":[1,4,2,2,3],"y":[1,2,3,4,5]},"selected":{"id":"33954"},"selection_policy":{"id":"33953"}},"id":"33901","type":"ColumnDataSource"},{"attributes":{"overlay":{"id":"33925"}},"id":"33921","type":"BoxZoomTool"},{"attributes":{"text":""},"id":"33947","type":"Title"},{"attributes":{"fields":[]},"id":"33933","type":"Stack"},{"attributes":{},"id":"33952","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"33901"}},"id":"33941","type":"CDSView"},{"attributes":{"data_source":{"id":"33901"},"glyph":{"id":"33938"},"hover_glyph":null,"muted_glyph":null,"name":"x1","nonselection_glyph":{"id":"33939"},"selection_glyph":null,"view":{"id":"33941"}},"id":"33940","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"33952"},"ticker":{"id":"33916"}},"id":"33915","type":"LinearAxis"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"33919"},{"id":"33920"},{"id":"33921"},{"id":"33922"},{"id":"33923"},{"id":"33924"}]},"id":"33926","type":"Toolbar"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"grey"},"height":{"value":0.8},"left":{"expr":{"id":"33933"}},"line_alpha":{"value":0.1},"line_color":{"value":"grey"},"right":{"expr":{"id":"33934"}},"y":{"field":"y"}},"id":"33939","type":"HBar"},{"attributes":{},"id":"33903","type":"DataRange1d"},{"attributes":{},"id":"33905","type":"DataRange1d"},{"attributes":{"data_source":{"id":"33901"},"glyph":{"id":"33943"},"hover_glyph":null,"muted_glyph":null,"name":"x2","nonselection_glyph":{"id":"33944"},"selection_glyph":null,"view":{"id":"33946"}},"id":"33945","type":"GlyphRenderer"},{"attributes":{},"id":"33919","type":"PanTool"},{"attributes":{"fields":["x1"]},"id":"33934","type":"Stack"},{"attributes":{},"id":"33916","type":"BasicTicker"},{"attributes":{},"id":"33953","type":"UnionRenderers"},{"attributes":{},"id":"33954","type":"Selection"},{"attributes":{"fields":["x1"]},"id":"33935","type":"Stack"},{"attributes":{},"id":"33950","type":"BasicTickFormatter"}],"root_ids":["33902"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"149198f6-e80c-41bd-b113-1274d0d9dee2","root_ids":["33902"],"roots":{"33902":"87037e29-c653-42a6-983d-e79ebe94234e"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();