(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("15c1375d-72cb-41be-acfa-55edfd27fae5");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '15c1375d-72cb-41be-acfa-55edfd27fae5' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"28f9f2a6-2deb-430d-bec6-06c34984ee1d":{"roots":{"references":[{"attributes":{"formatter":{"id":"28650"},"ticker":{"id":"28597"}},"id":"28596","type":"LinearAxis"},{"attributes":{},"id":"28651","type":"UnionRenderers"},{"attributes":{"overlay":{"id":"28604"}},"id":"28601","type":"LassoSelectTool"},{"attributes":{"formatter":{"id":"28648"},"ticker":{"id":"28593"}},"id":"28592","type":"LinearAxis"},{"attributes":{"fill_alpha":0.5,"fill_color":"lightgrey","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"xs_units":"screen","ys_units":"screen"},"id":"28604","type":"PolyAnnotation"},{"attributes":{},"id":"28658","type":"BasicTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"28600"},{"id":"28601"},{"id":"28602"}]},"id":"28605","type":"Toolbar"},{"attributes":{},"id":"28593","type":"BasicTicker"},{"attributes":{},"id":"28652","type":"Selection"},{"attributes":{},"id":"28625","type":"BasicTicker"},{"attributes":{"axis":{"id":"28596"},"dimension":1,"ticker":null},"id":"28599","type":"Grid"},{"attributes":{},"id":"28620","type":"LinearScale"},{"attributes":{"below":[{"id":"28624"}],"center":[{"id":"28627"},{"id":"28631"}],"left":[{"id":"28628"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"28644"}],"title":null,"toolbar":{"id":"28637"},"toolbar_location":null,"x_range":{"id":"28616"},"x_scale":{"id":"28620"},"y_range":{"id":"28618"},"y_scale":{"id":"28622"}},"id":"28614","subtype":"Figure","type":"Plot"},{"attributes":{"data_source":{"id":"28581"},"glyph":{"id":"28642"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"28643"},"selection_glyph":null,"view":{"id":"28645"}},"id":"28644","type":"GlyphRenderer"},{"attributes":{},"id":"28616","type":"DataRange1d"},{"attributes":{},"id":"28650","type":"BasicTickFormatter"},{"attributes":{"toolbars":[{"id":"28605"},{"id":"28637"}],"tools":[{"id":"28600"},{"id":"28601"},{"id":"28602"},{"id":"28632"},{"id":"28633"},{"id":"28634"}]},"id":"28667","type":"ProxyToolbar"},{"attributes":{},"id":"28622","type":"LinearScale"},{"attributes":{"data":{"x":[-20,-19,-18,-17,-16,-15,-14,-13,-12,-11,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20],"y0":[20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20],"y1":[400,361,324,289,256,225,196,169,144,121,100,81,64,49,36,25,16,9,4,1,0,1,4,9,16,25,36,49,64,81,100,121,144,169,196,225,256,289,324,361,400]},"selected":{"id":"28652"},"selection_policy":{"id":"28651"}},"id":"28581","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y0"}},"id":"28611","type":"Circle"},{"attributes":{"below":[{"id":"28592"}],"center":[{"id":"28595"},{"id":"28599"}],"left":[{"id":"28596"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"28612"}],"title":null,"toolbar":{"id":"28605"},"toolbar_location":null,"x_range":{"id":"28584"},"x_scale":{"id":"28588"},"y_range":{"id":"28586"},"y_scale":{"id":"28590"}},"id":"28582","subtype":"Figure","type":"Plot"},{"attributes":{"overlay":{"id":"28603"}},"id":"28600","type":"BoxSelectTool"},{"attributes":{"formatter":{"id":"28658"},"ticker":{"id":"28625"}},"id":"28624","type":"LinearAxis"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y0"}},"id":"28610","type":"Circle"},{"attributes":{},"id":"28588","type":"LinearScale"},{"attributes":{},"id":"28586","type":"DataRange1d"},{"attributes":{"source":{"id":"28581"}},"id":"28613","type":"CDSView"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y1"}},"id":"28642","type":"Circle"},{"attributes":{},"id":"28602","type":"HelpTool"},{"attributes":{},"id":"28597","type":"BasicTicker"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y1"}},"id":"28643","type":"Circle"},{"attributes":{},"id":"28629","type":"BasicTicker"},{"attributes":{"formatter":{"id":"28660"},"ticker":{"id":"28629"}},"id":"28628","type":"LinearAxis"},{"attributes":{"axis":{"id":"28628"},"dimension":1,"ticker":null},"id":"28631","type":"Grid"},{"attributes":{},"id":"28634","type":"HelpTool"},{"attributes":{"fill_alpha":0.5,"fill_color":"lightgrey","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"xs_units":"screen","ys_units":"screen"},"id":"28636","type":"PolyAnnotation"},{"attributes":{"source":{"id":"28581"}},"id":"28645","type":"CDSView"},{"attributes":{"axis":{"id":"28592"},"ticker":null},"id":"28595","type":"Grid"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"28603","type":"BoxAnnotation"},{"attributes":{},"id":"28648","type":"BasicTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"28632"},{"id":"28633"},{"id":"28634"}]},"id":"28637","type":"Toolbar"},{"attributes":{"toolbar":{"id":"28667"},"toolbar_location":"above"},"id":"28668","type":"ToolbarBox"},{"attributes":{},"id":"28590","type":"LinearScale"},{"attributes":{"overlay":{"id":"28635"}},"id":"28632","type":"BoxSelectTool"},{"attributes":{},"id":"28584","type":"DataRange1d"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"28635","type":"BoxAnnotation"},{"attributes":{},"id":"28660","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"28624"},"ticker":null},"id":"28627","type":"Grid"},{"attributes":{"overlay":{"id":"28636"}},"id":"28633","type":"LassoSelectTool"},{"attributes":{"data_source":{"id":"28581"},"glyph":{"id":"28610"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"28611"},"selection_glyph":null,"view":{"id":"28613"}},"id":"28612","type":"GlyphRenderer"},{"attributes":{"children":[[{"id":"28582"},0,0],[{"id":"28614"},0,1]]},"id":"28666","type":"GridBox"},{"attributes":{"children":[{"id":"28668"},{"id":"28666"}]},"id":"28669","type":"Column"},{"attributes":{},"id":"28618","type":"DataRange1d"}],"root_ids":["28669"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"28f9f2a6-2deb-430d-bec6-06c34984ee1d","root_ids":["28669"],"roots":{"28669":"15c1375d-72cb-41be-acfa-55edfd27fae5"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();