(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("3f534045-e5a0-4a0d-b486-6dea59aea4b8");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '3f534045-e5a0-4a0d-b486-6dea59aea4b8' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"8730d810-b25f-4b30-8ca1-3551ec8fedab":{"roots":{"references":[{"attributes":{"axis":{"id":"24579"},"ticker":null},"id":"24582","type":"Grid"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"24593","type":"BoxAnnotation"},{"attributes":{},"id":"24588","type":"WheelZoomTool"},{"attributes":{},"id":"24577","type":"LinearScale"},{"attributes":{},"id":"24584","type":"BasicTicker"},{"attributes":{},"id":"24575","type":"LinearScale"},{"attributes":{},"id":"24571","type":"DataRange1d"},{"attributes":{},"id":"24587","type":"PanTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"24587"},{"id":"24588"},{"id":"24589"},{"id":"24590"},{"id":"24591"},{"id":"24592"}]},"id":"24594","type":"Toolbar"},{"attributes":{"axis":{"id":"24583"},"dimension":1,"ticker":null},"id":"24586","type":"Grid"},{"attributes":{},"id":"24591","type":"ResetTool"},{"attributes":{"text":"Top Title with Toolbar"},"id":"24569","type":"Title"},{"attributes":{"source":{"id":"24601"}},"id":"24605","type":"CDSView"},{"attributes":{},"id":"24612","type":"Selection"},{"attributes":{},"id":"24611","type":"UnionRenderers"},{"attributes":{"below":[{"id":"24579"}],"center":[{"id":"24582"},{"id":"24586"}],"left":[{"id":"24583"}],"plot_height":300,"renderers":[{"id":"24604"}],"title":{"id":"24569"},"toolbar":{"id":"24594"},"toolbar_location":"above","x_range":{"id":"24571"},"x_scale":{"id":"24575"},"y_range":{"id":"24573"},"y_scale":{"id":"24577"}},"id":"24568","subtype":"Figure","type":"Plot"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"24603","type":"Circle"},{"attributes":{"formatter":{"id":"24608"},"ticker":{"id":"24580"}},"id":"24579","type":"LinearAxis"},{"attributes":{"formatter":{"id":"24610"},"ticker":{"id":"24584"}},"id":"24583","type":"LinearAxis"},{"attributes":{},"id":"24590","type":"SaveTool"},{"attributes":{},"id":"24573","type":"DataRange1d"},{"attributes":{},"id":"24608","type":"BasicTickFormatter"},{"attributes":{"overlay":{"id":"24593"}},"id":"24589","type":"BoxZoomTool"},{"attributes":{},"id":"24610","type":"BasicTickFormatter"},{"attributes":{},"id":"24580","type":"BasicTicker"},{"attributes":{"data":{"x":[1,2],"y":[3,4]},"selected":{"id":"24612"},"selection_policy":{"id":"24611"}},"id":"24601","type":"ColumnDataSource"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"24602","type":"Circle"},{"attributes":{"data_source":{"id":"24601"},"glyph":{"id":"24602"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"24603"},"selection_glyph":null,"view":{"id":"24605"}},"id":"24604","type":"GlyphRenderer"},{"attributes":{},"id":"24592","type":"HelpTool"}],"root_ids":["24568"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"8730d810-b25f-4b30-8ca1-3551ec8fedab","root_ids":["24568"],"roots":{"24568":"3f534045-e5a0-4a0d-b486-6dea59aea4b8"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();