(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("ca14f514-679e-434e-81a1-c69807dc78b2");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'ca14f514-679e-434e-81a1-c69807dc78b2' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"b7d4c306-2728-44fd-8beb-630796c6f353":{"roots":{"references":[{"attributes":{"data":{"x":["Alpha+RGBA"],"y":["RGBA"]},"selected":{"id":"37590"},"selection_policy":{"id":"37589"}},"id":"37503","type":"ColumnDataSource"},{"attributes":{"data":{"x":["None"],"y":["Alpha"]},"selected":{"id":"37526"},"selection_policy":{"id":"37525"}},"id":"37343","type":"ColumnDataSource"},{"attributes":{"data":{"x":["Alpha"],"y":["Alpha"]},"selected":{"id":"37538"},"selection_policy":{"id":"37537"}},"id":"37373","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.5},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37509","type":"Circle"},{"attributes":{},"id":"37529","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"37373"},"glyph":{"id":"37374"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37375"},"selection_glyph":null,"view":{"id":"37377"}},"id":"37376","type":"GlyphRenderer"},{"attributes":{},"id":"37325","type":"WheelZoomTool"},{"attributes":{},"id":"37527","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37375","type":"Circle"},{"attributes":{"source":{"id":"37513"}},"id":"37517","type":"CDSView"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"37324"},{"id":"37325"},{"id":"37326"},{"id":"37327"},{"id":"37328"},{"id":"37329"}]},"id":"37331","type":"Toolbar"},{"attributes":{},"id":"37530","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37345","type":"Circle"},{"attributes":{},"id":"37324","type":"PanTool"},{"attributes":{},"id":"37526","type":"Selection"},{"attributes":{"data":{"x":["None"],"y":["RGB"]},"selected":{"id":"37528"},"selection_policy":{"id":"37527"}},"id":"37348","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37510","type":"Circle"},{"attributes":{"data_source":{"id":"37393"},"glyph":{"id":"37394"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37395"},"selection_glyph":null,"view":{"id":"37397"}},"id":"37396","type":"GlyphRenderer"},{"attributes":{},"id":"37525","type":"UnionRenderers"},{"attributes":{"data":{"x":["None"],"y":["RGBA"]},"selected":{"id":"37530"},"selection_policy":{"id":"37529"}},"id":"37353","type":"ColumnDataSource"},{"attributes":{"source":{"id":"37348"}},"id":"37352","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37365","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37405","type":"Circle"},{"attributes":{},"id":"37328","type":"ResetTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37340","type":"Circle"},{"attributes":{"data":{"x":["Alpha"],"y":["RGB"]},"selected":{"id":"37540"},"selection_policy":{"id":"37539"}},"id":"37378","type":"ColumnDataSource"},{"attributes":{"data":{"x":["Alpha"],"y":["Alpha+RGB"]},"selected":{"id":"37544"},"selection_policy":{"id":"37543"}},"id":"37388","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37400","type":"Circle"},{"attributes":{"source":{"id":"37368"}},"id":"37372","type":"CDSView"},{"attributes":{},"id":"37524","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37369","type":"Circle"},{"attributes":{"source":{"id":"37343"}},"id":"37347","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.5},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37394","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37360","type":"Circle"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"37330","type":"BoxAnnotation"},{"attributes":{"data_source":{"id":"37338"},"glyph":{"id":"37339"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37340"},"selection_glyph":null,"view":{"id":"37342"}},"id":"37341","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"37358"},"glyph":{"id":"37359"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37360"},"selection_glyph":null,"view":{"id":"37362"}},"id":"37361","type":"GlyphRenderer"},{"attributes":{"data":{"x":["Alpha"],"y":["None"]},"selected":{"id":"37536"},"selection_policy":{"id":"37535"}},"id":"37368","type":"ColumnDataSource"},{"attributes":{"data":{"x":["Alpha+RGBA"],"y":["Alpha+RGB"]},"selected":{"id":"37592"},"selection_policy":{"id":"37591"}},"id":"37508","type":"ColumnDataSource"},{"attributes":{"source":{"id":"37388"}},"id":"37392","type":"CDSView"},{"attributes":{},"id":"37528","type":"Selection"},{"attributes":{"data":{"x":["Alpha"],"y":["Alpha+RGBA"]},"selected":{"id":"37546"},"selection_policy":{"id":"37545"}},"id":"37393","type":"ColumnDataSource"},{"attributes":{"data":{"x":["Alpha+RGBA"],"y":["Alpha+RGBA"]},"selected":{"id":"37594"},"selection_policy":{"id":"37593"}},"id":"37513","type":"ColumnDataSource"},{"attributes":{"source":{"id":"37353"}},"id":"37357","type":"CDSView"},{"attributes":{"data":{"x":["RGB"],"y":["Alpha"]},"selected":{"id":"37550"},"selection_policy":{"id":"37549"}},"id":"37403","type":"ColumnDataSource"},{"attributes":{},"id":"37327","type":"SaveTool"},{"attributes":{"data_source":{"id":"37348"},"glyph":{"id":"37349"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37350"},"selection_glyph":null,"view":{"id":"37352"}},"id":"37351","type":"GlyphRenderer"},{"attributes":{},"id":"37531","type":"UnionRenderers"},{"attributes":{},"id":"37522","type":"CategoricalTickFormatter"},{"attributes":{"overlay":{"id":"37330"}},"id":"37326","type":"BoxZoomTool"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.5},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37344","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.5},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37514","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37380","type":"Circle"},{"attributes":{"fill_color":{"value":"rgb(242, 44, 64)"},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37399","type":"Circle"},{"attributes":{"data_source":{"id":"37378"},"glyph":{"id":"37379"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37380"},"selection_glyph":null,"view":{"id":"37382"}},"id":"37381","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.5},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37389","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37355","type":"Circle"},{"attributes":{"data":{"x":["RGB"],"y":["None"]},"selected":{"id":"37548"},"selection_policy":{"id":"37547"}},"id":"37398","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"37353"},"glyph":{"id":"37354"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37355"},"selection_glyph":null,"view":{"id":"37357"}},"id":"37356","type":"GlyphRenderer"},{"attributes":{},"id":"37594","type":"Selection"},{"attributes":{"data_source":{"id":"37508"},"glyph":{"id":"37509"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37510"},"selection_glyph":null,"view":{"id":"37512"}},"id":"37511","type":"GlyphRenderer"},{"attributes":{"data":{"x":["None"],"y":["Alpha+RGB"]},"selected":{"id":"37532"},"selection_policy":{"id":"37531"}},"id":"37358","type":"ColumnDataSource"},{"attributes":{"source":{"id":"37378"}},"id":"37382","type":"CDSView"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.5},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37359","type":"Circle"},{"attributes":{"source":{"id":"37503"}},"id":"37507","type":"CDSView"},{"attributes":{},"id":"37329","type":"HelpTool"},{"attributes":{},"id":"37532","type":"Selection"},{"attributes":{},"id":"37523","type":"UnionRenderers"},{"attributes":{},"id":"37593","type":"UnionRenderers"},{"attributes":{"source":{"id":"37363"}},"id":"37367","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#1f77b4"},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37379","type":"Circle"},{"attributes":{"data_source":{"id":"37388"},"glyph":{"id":"37389"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37390"},"selection_glyph":null,"view":{"id":"37392"}},"id":"37391","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"37403"},"glyph":{"id":"37404"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37405"},"selection_glyph":null,"view":{"id":"37407"}},"id":"37406","type":"GlyphRenderer"},{"attributes":{},"id":"37520","type":"CategoricalTickFormatter"},{"attributes":{"source":{"id":"37358"}},"id":"37362","type":"CDSView"},{"attributes":{"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.5},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37404","type":"Circle"},{"attributes":{},"id":"37592","type":"Selection"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.5},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37364","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.5},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37374","type":"Circle"},{"attributes":{"source":{"id":"37508"}},"id":"37512","type":"CDSView"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37354","type":"Circle"},{"attributes":{"source":{"id":"37393"}},"id":"37397","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37515","type":"Circle"},{"attributes":{},"id":"37591","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37395","type":"Circle"},{"attributes":{"data_source":{"id":"37343"},"glyph":{"id":"37344"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37345"},"selection_glyph":null,"view":{"id":"37347"}},"id":"37346","type":"GlyphRenderer"},{"attributes":{"source":{"id":"37398"}},"id":"37402","type":"CDSView"},{"attributes":{"source":{"id":"37383"}},"id":"37387","type":"CDSView"},{"attributes":{"data_source":{"id":"37398"},"glyph":{"id":"37399"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37400"},"selection_glyph":null,"view":{"id":"37402"}},"id":"37401","type":"GlyphRenderer"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37349","type":"Circle"},{"attributes":{"data":{"x":["None"],"y":["Alpha+RGBA"]},"selected":{"id":"37534"},"selection_policy":{"id":"37533"}},"id":"37363","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"37363"},"glyph":{"id":"37364"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37365"},"selection_glyph":null,"view":{"id":"37367"}},"id":"37366","type":"GlyphRenderer"},{"attributes":{},"id":"37590","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37350","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#1f77b4"},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37384","type":"Circle"},{"attributes":{"data_source":{"id":"37503"},"glyph":{"id":"37504"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37505"},"selection_glyph":null,"view":{"id":"37507"}},"id":"37506","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"37513"},"glyph":{"id":"37514"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37515"},"selection_glyph":null,"view":{"id":"37517"}},"id":"37516","type":"GlyphRenderer"},{"attributes":{"source":{"id":"37458"}},"id":"37462","type":"CDSView"},{"attributes":{"data_source":{"id":"37383"},"glyph":{"id":"37384"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37385"},"selection_glyph":null,"view":{"id":"37387"}},"id":"37386","type":"GlyphRenderer"},{"attributes":{"source":{"id":"37373"}},"id":"37377","type":"CDSView"},{"attributes":{},"id":"37589","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"37458"},"glyph":{"id":"37459"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37460"},"selection_glyph":null,"view":{"id":"37462"}},"id":"37461","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37390","type":"Circle"},{"attributes":{"data":{"x":["Alpha"],"y":["RGBA"]},"selected":{"id":"37542"},"selection_policy":{"id":"37541"}},"id":"37383","type":"ColumnDataSource"},{"attributes":{},"id":"37588","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37385","type":"Circle"},{"attributes":{"source":{"id":"37338"}},"id":"37342","type":"CDSView"},{"attributes":{"source":{"id":"37473"}},"id":"37477","type":"CDSView"},{"attributes":{},"id":"37553","type":"UnionRenderers"},{"attributes":{"data":{"x":["None"],"y":["None"]},"selected":{"id":"37524"},"selection_policy":{"id":"37523"}},"id":"37338","type":"ColumnDataSource"},{"attributes":{},"id":"37541","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"37368"},"glyph":{"id":"37369"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37370"},"selection_glyph":null,"view":{"id":"37372"}},"id":"37371","type":"GlyphRenderer"},{"attributes":{"source":{"id":"37463"}},"id":"37467","type":"CDSView"},{"attributes":{"data":{"x":["RGB"],"y":["Alpha+RGBA"]},"selected":{"id":"37558"},"selection_policy":{"id":"37557"}},"id":"37423","type":"ColumnDataSource"},{"attributes":{},"id":"37537","type":"UnionRenderers"},{"attributes":{},"id":"37538","type":"Selection"},{"attributes":{"below":[{"id":"37318"}],"center":[{"id":"37320"},{"id":"37323"}],"left":[{"id":"37321"}],"renderers":[{"id":"37341"},{"id":"37346"},{"id":"37351"},{"id":"37356"},{"id":"37361"},{"id":"37366"},{"id":"37371"},{"id":"37376"},{"id":"37381"},{"id":"37386"},{"id":"37391"},{"id":"37396"},{"id":"37401"},{"id":"37406"},{"id":"37411"},{"id":"37416"},{"id":"37421"},{"id":"37426"},{"id":"37431"},{"id":"37436"},{"id":"37441"},{"id":"37446"},{"id":"37451"},{"id":"37456"},{"id":"37461"},{"id":"37466"},{"id":"37471"},{"id":"37476"},{"id":"37481"},{"id":"37486"},{"id":"37491"},{"id":"37496"},{"id":"37501"},{"id":"37506"},{"id":"37511"},{"id":"37516"}],"title":{"id":"37308"},"toolbar":{"id":"37331"},"toolbar_location":null,"x_range":{"id":"37310"},"x_scale":{"id":"37314"},"y_range":{"id":"37312"},"y_scale":{"id":"37316"}},"id":"37307","subtype":"Figure","type":"Plot"},{"attributes":{"data":{"x":["RGB"],"y":["Alpha+RGB"]},"selected":{"id":"37556"},"selection_policy":{"id":"37555"}},"id":"37418","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"37468"},"glyph":{"id":"37469"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37470"},"selection_glyph":null,"view":{"id":"37472"}},"id":"37471","type":"GlyphRenderer"},{"attributes":{"source":{"id":"37418"}},"id":"37422","type":"CDSView"},{"attributes":{"data":{"x":["RGBA"],"y":["Alpha+RGBA"]},"selected":{"id":"37570"},"selection_policy":{"id":"37569"}},"id":"37453","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37470","type":"Circle"},{"attributes":{"source":{"id":"37468"}},"id":"37472","type":"CDSView"},{"attributes":{"data_source":{"id":"37413"},"glyph":{"id":"37414"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37415"},"selection_glyph":null,"view":{"id":"37417"}},"id":"37416","type":"GlyphRenderer"},{"attributes":{"data":{"x":["RGBA"],"y":["None"]},"selected":{"id":"37560"},"selection_policy":{"id":"37559"}},"id":"37428","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37370","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37420","type":"Circle"},{"attributes":{},"id":"37534","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37455","type":"Circle"},{"attributes":{},"id":"37539","type":"UnionRenderers"},{"attributes":{},"id":"37552","type":"Selection"},{"attributes":{},"id":"37540","type":"Selection"},{"attributes":{"data_source":{"id":"37418"},"glyph":{"id":"37419"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37420"},"selection_glyph":null,"view":{"id":"37422"}},"id":"37421","type":"GlyphRenderer"},{"attributes":{},"id":"37554","type":"Selection"},{"attributes":{"source":{"id":"37413"}},"id":"37417","type":"CDSView"},{"attributes":{"source":{"id":"37453"}},"id":"37457","type":"CDSView"},{"attributes":{},"id":"37536","type":"Selection"},{"attributes":{"data_source":{"id":"37453"},"glyph":{"id":"37454"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37455"},"selection_glyph":null,"view":{"id":"37457"}},"id":"37456","type":"GlyphRenderer"},{"attributes":{},"id":"37545","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"37473"},"glyph":{"id":"37474"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37475"},"selection_glyph":null,"view":{"id":"37477"}},"id":"37476","type":"GlyphRenderer"},{"attributes":{},"id":"37535","type":"UnionRenderers"},{"attributes":{"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.5},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37454","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.5},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37479","type":"Circle"},{"attributes":{"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.5},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37424","type":"Circle"},{"attributes":{"data":{"x":["Alpha+RGB"],"y":["RGBA"]},"selected":{"id":"37578"},"selection_policy":{"id":"37577"}},"id":"37473","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37425","type":"Circle"},{"attributes":{"data":{"x":["Alpha+RGB"],"y":["RGB"]},"selected":{"id":"37576"},"selection_policy":{"id":"37575"}},"id":"37468","type":"ColumnDataSource"},{"attributes":{"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.5},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37419","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"rgb(242, 44, 64)"},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37469","type":"Circle"},{"attributes":{"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37444","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37460","type":"Circle"},{"attributes":{"data_source":{"id":"37443"},"glyph":{"id":"37444"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37445"},"selection_glyph":null,"view":{"id":"37447"}},"id":"37446","type":"GlyphRenderer"},{"attributes":{"source":{"id":"37448"}},"id":"37452","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"rgb(242, 44, 64)"},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37459","type":"Circle"},{"attributes":{"data":{"x":["Alpha+RGB"],"y":["None"]},"selected":{"id":"37572"},"selection_policy":{"id":"37571"}},"id":"37458","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37450","type":"Circle"},{"attributes":{"data_source":{"id":"37493"},"glyph":{"id":"37494"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37495"},"selection_glyph":null,"view":{"id":"37497"}},"id":"37496","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37445","type":"Circle"},{"attributes":{"data":{"x":["RGBA"],"y":["RGBA"]},"selected":{"id":"37566"},"selection_policy":{"id":"37565"}},"id":"37443","type":"ColumnDataSource"},{"attributes":{"source":{"id":"37433"}},"id":"37437","type":"CDSView"},{"attributes":{"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37439","type":"Circle"},{"attributes":{"data_source":{"id":"37428"},"glyph":{"id":"37429"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37430"},"selection_glyph":null,"view":{"id":"37432"}},"id":"37431","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37435","type":"Circle"},{"attributes":{"source":{"id":"37438"}},"id":"37442","type":"CDSView"},{"attributes":{"data_source":{"id":"37448"},"glyph":{"id":"37449"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37450"},"selection_glyph":null,"view":{"id":"37452"}},"id":"37451","type":"GlyphRenderer"},{"attributes":{"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.5},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37434","type":"Circle"},{"attributes":{"data":{"x":["Alpha+RGBA"],"y":["Alpha"]},"selected":{"id":"37586"},"selection_policy":{"id":"37585"}},"id":"37493","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.5},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37494","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37495","type":"Circle"},{"attributes":{"data_source":{"id":"37438"},"glyph":{"id":"37439"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37440"},"selection_glyph":null,"view":{"id":"37442"}},"id":"37441","type":"GlyphRenderer"},{"attributes":{"source":{"id":"37423"}},"id":"37427","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37415","type":"Circle"},{"attributes":{"data":{"x":["RGBA"],"y":["Alpha+RGB"]},"selected":{"id":"37568"},"selection_policy":{"id":"37567"}},"id":"37448","type":"ColumnDataSource"},{"attributes":{"source":{"id":"37428"}},"id":"37432","type":"CDSView"},{"attributes":{"data":{"x":["RGBA"],"y":["Alpha"]},"selected":{"id":"37562"},"selection_policy":{"id":"37561"}},"id":"37433","type":"ColumnDataSource"},{"attributes":{"source":{"id":"37493"}},"id":"37497","type":"CDSView"},{"attributes":{"source":{"id":"37443"}},"id":"37447","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37499","type":"Circle"},{"attributes":{"data_source":{"id":"37433"},"glyph":{"id":"37434"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37435"},"selection_glyph":null,"view":{"id":"37437"}},"id":"37436","type":"GlyphRenderer"},{"attributes":{"data":{"x":["RGB"],"y":["RGBA"]},"selected":{"id":"37554"},"selection_policy":{"id":"37553"}},"id":"37413","type":"ColumnDataSource"},{"attributes":{"data":{"x":["RGBA"],"y":["RGB"]},"selected":{"id":"37564"},"selection_policy":{"id":"37563"}},"id":"37438","type":"ColumnDataSource"},{"attributes":{},"id":"37533","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37440","type":"Circle"},{"attributes":{"data_source":{"id":"37423"},"glyph":{"id":"37424"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37425"},"selection_glyph":null,"view":{"id":"37427"}},"id":"37426","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37430","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37505","type":"Circle"},{"attributes":{"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37429","type":"Circle"},{"attributes":{"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.5},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37449","type":"Circle"},{"attributes":{"source":{"id":"37488"}},"id":"37492","type":"CDSView"},{"attributes":{},"id":"37544","type":"Selection"},{"attributes":{},"id":"37587","type":"UnionRenderers"},{"attributes":{"data":{"x":["RGB"],"y":["RGB"]},"selected":{"id":"37552"},"selection_policy":{"id":"37551"}},"id":"37408","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37485","type":"Circle"},{"attributes":{},"id":"37548","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37475","type":"Circle"},{"attributes":{"factors":["None","Alpha","RGB","RGBA","Alpha+RGB","Alpha+RGBA"]},"id":"37310","type":"FactorRange"},{"attributes":{},"id":"37567","type":"UnionRenderers"},{"attributes":{},"id":"37569","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"37498"},"glyph":{"id":"37499"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37500"},"selection_glyph":null,"view":{"id":"37502"}},"id":"37501","type":"GlyphRenderer"},{"attributes":{},"id":"37556","type":"Selection"},{"attributes":{},"id":"37570","type":"Selection"},{"attributes":{"fill_color":{"value":"rgb(242, 44, 64)"},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37409","type":"Circle"},{"attributes":{},"id":"37571","type":"UnionRenderers"},{"attributes":{},"id":"37314","type":"CategoricalScale"},{"attributes":{"data":{"x":["Alpha+RGBA"],"y":["None"]},"selected":{"id":"37584"},"selection_policy":{"id":"37583"}},"id":"37488","type":"ColumnDataSource"},{"attributes":{},"id":"37550","type":"Selection"},{"attributes":{},"id":"37572","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.5},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37464","type":"Circle"},{"attributes":{"data":{"x":["Alpha+RGB"],"y":["Alpha+RGB"]},"selected":{"id":"37580"},"selection_policy":{"id":"37579"}},"id":"37478","type":"ColumnDataSource"},{"attributes":{},"id":"37573","type":"UnionRenderers"},{"attributes":{"text":"Fill and Line Color Combinations"},"id":"37308","type":"Title"},{"attributes":{},"id":"37551","type":"UnionRenderers"},{"attributes":{},"id":"37561","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"37408"},"glyph":{"id":"37409"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37410"},"selection_glyph":null,"view":{"id":"37412"}},"id":"37411","type":"GlyphRenderer"},{"attributes":{"source":{"id":"37483"}},"id":"37487","type":"CDSView"},{"attributes":{},"id":"37564","type":"Selection"},{"attributes":{},"id":"37574","type":"Selection"},{"attributes":{},"id":"37549","type":"UnionRenderers"},{"attributes":{"source":{"id":"37408"}},"id":"37412","type":"CDSView"},{"attributes":{"data":{"x":["Alpha+RGB"],"y":["Alpha"]},"selected":{"id":"37574"},"selection_policy":{"id":"37573"}},"id":"37463","type":"ColumnDataSource"},{"attributes":{},"id":"37575","type":"UnionRenderers"},{"attributes":{},"id":"37546","type":"Selection"},{"attributes":{},"id":"37562","type":"Selection"},{"attributes":{},"id":"37576","type":"Selection"},{"attributes":{"axis":{"id":"37318"},"grid_line_color":null,"ticker":null},"id":"37320","type":"Grid"},{"attributes":{},"id":"37577","type":"UnionRenderers"},{"attributes":{"factors":["None","Alpha","RGB","RGBA","Alpha+RGB","Alpha+RGBA"]},"id":"37312","type":"FactorRange"},{"attributes":{"source":{"id":"37403"}},"id":"37407","type":"CDSView"},{"attributes":{},"id":"37547","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"37483"},"glyph":{"id":"37484"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37485"},"selection_glyph":null,"view":{"id":"37487"}},"id":"37486","type":"GlyphRenderer"},{"attributes":{},"id":"37578","type":"Selection"},{"attributes":{},"id":"37316","type":"CategoricalScale"},{"attributes":{},"id":"37560","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37465","type":"Circle"},{"attributes":{},"id":"37579","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"37488"},"glyph":{"id":"37489"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37490"},"selection_glyph":null,"view":{"id":"37492"}},"id":"37491","type":"GlyphRenderer"},{"attributes":{},"id":"37542","type":"Selection"},{"attributes":{},"id":"37557","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37410","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37480","type":"Circle"},{"attributes":{},"id":"37580","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37489","type":"Circle"},{"attributes":{},"id":"37581","type":"UnionRenderers"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37339","type":"Circle"},{"attributes":{},"id":"37555","type":"UnionRenderers"},{"attributes":{},"id":"37563","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"rgb(242, 44, 64)"},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37474","type":"Circle"},{"attributes":{"source":{"id":"37498"}},"id":"37502","type":"CDSView"},{"attributes":{},"id":"37322","type":"CategoricalTicker"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.1},"line_color":{"value":"rgb(0, 0, 0)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37500","type":"Circle"},{"attributes":{},"id":"37568","type":"Selection"},{"attributes":{},"id":"37543","type":"UnionRenderers"},{"attributes":{},"id":"37582","type":"Selection"},{"attributes":{"data":{"x":["Alpha+RGB"],"y":["Alpha+RGBA"]},"selected":{"id":"37582"},"selection_policy":{"id":"37581"}},"id":"37483","type":"ColumnDataSource"},{"attributes":{},"id":"37583","type":"UnionRenderers"},{"attributes":{},"id":"37559","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37490","type":"Circle"},{"attributes":{},"id":"37584","type":"Selection"},{"attributes":{"data_source":{"id":"37463"},"glyph":{"id":"37464"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37465"},"selection_glyph":null,"view":{"id":"37467"}},"id":"37466","type":"GlyphRenderer"},{"attributes":{},"id":"37319","type":"CategoricalTicker"},{"attributes":{},"id":"37585","type":"UnionRenderers"},{"attributes":{"axis_label":"Fill Options","formatter":{"id":"37520"},"major_label_orientation":0.7853981633974483,"ticker":{"id":"37319"}},"id":"37318","type":"CategoricalAxis"},{"attributes":{},"id":"37566","type":"Selection"},{"attributes":{"data_source":{"id":"37478"},"glyph":{"id":"37479"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37480"},"selection_glyph":null,"view":{"id":"37482"}},"id":"37481","type":"GlyphRenderer"},{"attributes":{"fill_color":{"value":"rgb(242, 44, 64)"},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37414","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"rgb(242, 44, 64)"},"line_alpha":{"value":0.5},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37484","type":"Circle"},{"attributes":{"data":{"x":["Alpha+RGBA"],"y":["RGB"]},"selected":{"id":"37588"},"selection_policy":{"id":"37587"}},"id":"37498","type":"ColumnDataSource"},{"attributes":{},"id":"37586","type":"Selection"},{"attributes":{},"id":"37558","type":"Selection"},{"attributes":{"source":{"id":"37478"}},"id":"37482","type":"CDSView"},{"attributes":{},"id":"37565","type":"UnionRenderers"},{"attributes":{"axis":{"id":"37321"},"dimension":1,"grid_line_color":null,"ticker":null},"id":"37323","type":"Grid"},{"attributes":{"axis_label":"Line Options","formatter":{"id":"37522"},"ticker":{"id":"37322"}},"id":"37321","type":"CategoricalAxis"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"rgba(242, 44, 64, 0.5)"},"line_color":{"value":"rgba(0, 0, 0, 0.5)"},"line_width":{"value":7},"size":{"units":"screen","value":50},"x":{"field":"x"},"y":{"field":"y"}},"id":"37504","type":"Circle"}],"root_ids":["37307"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"b7d4c306-2728-44fd-8beb-630796c6f353","root_ids":["37307"],"roots":{"37307":"ca14f514-679e-434e-81a1-c69807dc78b2"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();