(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("c040f30c-4d2b-4fd5-876a-4f8b2eeaabb1");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'c040f30c-4d2b-4fd5-876a-4f8b2eeaabb1' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"8c148c83-c41d-4f61-8e2a-b47bbb2bf2c9":{"roots":{"references":[{"attributes":{"text":""},"id":"35185","type":"Title"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"35166"},{"id":"35167"},{"id":"35168"},{"id":"35169"},{"id":"35170"},{"id":"35171"}]},"id":"35173","type":"Toolbar"},{"attributes":{},"id":"35166","type":"PanTool"},{"attributes":{},"id":"35150","type":"DataRange1d"},{"attributes":{},"id":"35192","type":"Selection"},{"attributes":{"line_color":{"value":"#F4A582"},"line_width":{"value":3},"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"35181","type":"Segment"},{"attributes":{},"id":"35167","type":"WheelZoomTool"},{"attributes":{},"id":"35163","type":"BasicTicker"},{"attributes":{},"id":"35154","type":"LinearScale"},{"attributes":{"axis":{"id":"35158"},"ticker":null},"id":"35161","type":"Grid"},{"attributes":{"below":[{"id":"35158"}],"center":[{"id":"35161"},{"id":"35165"}],"left":[{"id":"35162"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"35183"}],"title":{"id":"35185"},"toolbar":{"id":"35173"},"x_range":{"id":"35150"},"x_scale":{"id":"35154"},"y_range":{"id":"35152"},"y_scale":{"id":"35156"}},"id":"35149","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"35171","type":"HelpTool"},{"attributes":{"source":{"id":"35180"}},"id":"35184","type":"CDSView"},{"attributes":{},"id":"35191","type":"UnionRenderers"},{"attributes":{"formatter":{"id":"35188"},"ticker":{"id":"35159"}},"id":"35158","type":"LinearAxis"},{"attributes":{},"id":"35156","type":"LinearScale"},{"attributes":{},"id":"35169","type":"SaveTool"},{"attributes":{},"id":"35190","type":"BasicTickFormatter"},{"attributes":{"overlay":{"id":"35172"}},"id":"35168","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"35190"},"ticker":{"id":"35163"}},"id":"35162","type":"LinearAxis"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#F4A582"},"line_width":{"value":3},"x0":{"field":"x0"},"x1":{"field":"x1"},"y0":{"field":"y0"},"y1":{"field":"y1"}},"id":"35182","type":"Segment"},{"attributes":{},"id":"35170","type":"ResetTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"35172","type":"BoxAnnotation"},{"attributes":{"data":{"x0":[1,2,3],"x1":[1.2,2.4,3.1],"y0":[1,2,3],"y1":[1.2,2.5,3.7]},"selected":{"id":"35192"},"selection_policy":{"id":"35191"}},"id":"35180","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"35162"},"dimension":1,"ticker":null},"id":"35165","type":"Grid"},{"attributes":{"data_source":{"id":"35180"},"glyph":{"id":"35181"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"35182"},"selection_glyph":null,"view":{"id":"35184"}},"id":"35183","type":"GlyphRenderer"},{"attributes":{},"id":"35159","type":"BasicTicker"},{"attributes":{},"id":"35152","type":"DataRange1d"},{"attributes":{},"id":"35188","type":"BasicTickFormatter"}],"root_ids":["35149"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"8c148c83-c41d-4f61-8e2a-b47bbb2bf2c9","root_ids":["35149"],"roots":{"35149":"c040f30c-4d2b-4fd5-876a-4f8b2eeaabb1"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();