(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("5b15ad60-711c-41cd-af8d-a43b9d949721");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '5b15ad60-711c-41cd-af8d-a43b9d949721' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"826b347e-054d-40b6-87fa-5104e7a0d472":{"roots":{"references":[{"attributes":{"below":[{"id":"26328"}],"center":[{"id":"26330"},{"id":"26334"},{"id":"26355"}],"left":[{"id":"26331"}],"outline_line_color":null,"plot_height":250,"renderers":[{"id":"26346"},{"id":"26361"},{"id":"26377"}],"title":{"id":"26318"},"toolbar":{"id":"26335"},"toolbar_location":null,"x_range":{"id":"26320"},"x_scale":{"id":"26324"},"y_range":{"id":"26322"},"y_scale":{"id":"26326"}},"id":"26317","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"26326","type":"LinearScale"},{"attributes":{},"id":"26353","type":"UnionRenderers"},{"attributes":{},"id":"26389","type":"Selection"},{"attributes":{"data_source":{"id":"26342"},"glyph":{"id":"26344"},"hover_glyph":null,"muted_glyph":null,"name":"2015","nonselection_glyph":{"id":"26345"},"selection_glyph":null,"view":{"id":"26347"}},"id":"26346","type":"GlyphRenderer"},{"attributes":{"start":0},"id":"26322","type":"DataRange1d"},{"attributes":{},"id":"26332","type":"BasicTicker"},{"attributes":{},"id":"26371","type":"Selection"},{"attributes":{"axis":{"id":"26328"},"grid_line_color":null,"ticker":null},"id":"26330","type":"Grid"},{"attributes":{"data":{"2015":[2,1,4,3,2,4],"2016":[5,3,4,2,4,6],"2017":[3,2,4,4,5,3],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"26354"},"selection_policy":{"id":"26353"}},"id":"26342","type":"ColumnDataSource"},{"attributes":{},"id":"26350","type":"CategoricalTickFormatter"},{"attributes":{"bottom":{"expr":{"id":"26340"}},"fill_alpha":{"value":0.1},"fill_color":{"value":"#e84d60"},"line_alpha":{"value":0.1},"line_color":{"value":"#e84d60"},"top":{"expr":{"id":"26341"}},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"26376","type":"VBar"},{"attributes":{"bottom":{"expr":{"id":"26336"}},"fill_color":{"value":"#c9d9d3"},"line_color":{"value":"#c9d9d3"},"top":{"expr":{"id":"26337"}},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"26344","type":"VBar"},{"attributes":{"bottom":{"expr":{"id":"26338"}},"fill_alpha":{"value":0.1},"fill_color":{"value":"#718dbf"},"line_alpha":{"value":0.1},"line_color":{"value":"#718dbf"},"top":{"expr":{"id":"26339"}},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"26360","type":"VBar"},{"attributes":{},"id":"26324","type":"CategoricalScale"},{"attributes":{"source":{"id":"26357"}},"id":"26362","type":"CDSView"},{"attributes":{},"id":"26354","type":"Selection"},{"attributes":{"fields":[]},"id":"26336","type":"Stack"},{"attributes":{"formatter":{"id":"26350"},"minor_tick_line_color":null,"ticker":{"id":"26329"}},"id":"26328","type":"CategoricalAxis"},{"attributes":{},"id":"26352","type":"BasicTickFormatter"},{"attributes":{"fields":["2015","2016"]},"id":"26340","type":"Stack"},{"attributes":{"data":{"2015":[2,1,4,3,2,4],"2016":[5,3,4,2,4,6],"2017":[3,2,4,4,5,3],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"26389"},"selection_policy":{"id":"26388"}},"id":"26373","type":"ColumnDataSource"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"26335","type":"Toolbar"},{"attributes":{"items":[{"id":"26356"},{"id":"26372"},{"id":"26390"}],"location":"top_left","orientation":"horizontal"},"id":"26355","type":"Legend"},{"attributes":{"label":{"value":"2016"},"renderers":[{"id":"26361"}]},"id":"26372","type":"LegendItem"},{"attributes":{"data_source":{"id":"26357"},"glyph":{"id":"26359"},"hover_glyph":null,"muted_glyph":null,"name":"2016","nonselection_glyph":{"id":"26360"},"selection_glyph":null,"view":{"id":"26362"}},"id":"26361","type":"GlyphRenderer"},{"attributes":{"source":{"id":"26373"}},"id":"26378","type":"CDSView"},{"attributes":{},"id":"26370","type":"UnionRenderers"},{"attributes":{"axis":{"id":"26331"},"dimension":1,"ticker":null},"id":"26334","type":"Grid"},{"attributes":{"fields":["2015"]},"id":"26338","type":"Stack"},{"attributes":{},"id":"26329","type":"CategoricalTicker"},{"attributes":{"bottom":{"expr":{"id":"26336"}},"fill_alpha":{"value":0.1},"fill_color":{"value":"#c9d9d3"},"line_alpha":{"value":0.1},"line_color":{"value":"#c9d9d3"},"top":{"expr":{"id":"26337"}},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"26345","type":"VBar"},{"attributes":{"fields":["2015"]},"id":"26337","type":"Stack"},{"attributes":{"data_source":{"id":"26373"},"glyph":{"id":"26375"},"hover_glyph":null,"muted_glyph":null,"name":"2017","nonselection_glyph":{"id":"26376"},"selection_glyph":null,"view":{"id":"26378"}},"id":"26377","type":"GlyphRenderer"},{"attributes":{"data":{"2015":[2,1,4,3,2,4],"2016":[5,3,4,2,4,6],"2017":[3,2,4,4,5,3],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"26371"},"selection_policy":{"id":"26370"}},"id":"26357","type":"ColumnDataSource"},{"attributes":{"bottom":{"expr":{"id":"26340"}},"fill_color":{"value":"#e84d60"},"line_color":{"value":"#e84d60"},"top":{"expr":{"id":"26341"}},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"26375","type":"VBar"},{"attributes":{"fields":["2015","2016","2017"]},"id":"26341","type":"Stack"},{"attributes":{"formatter":{"id":"26352"},"minor_tick_line_color":null,"ticker":{"id":"26332"}},"id":"26331","type":"LinearAxis"},{"attributes":{},"id":"26388","type":"UnionRenderers"},{"attributes":{"label":{"value":"2017"},"renderers":[{"id":"26377"}]},"id":"26390","type":"LegendItem"},{"attributes":{"factors":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"],"range_padding":0.1},"id":"26320","type":"FactorRange"},{"attributes":{"text":"Fruit Counts by Year"},"id":"26318","type":"Title"},{"attributes":{"source":{"id":"26342"}},"id":"26347","type":"CDSView"},{"attributes":{"fields":["2015","2016"]},"id":"26339","type":"Stack"},{"attributes":{"label":{"value":"2015"},"renderers":[{"id":"26346"}]},"id":"26356","type":"LegendItem"},{"attributes":{"bottom":{"expr":{"id":"26338"}},"fill_color":{"value":"#718dbf"},"line_color":{"value":"#718dbf"},"top":{"expr":{"id":"26339"}},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"26359","type":"VBar"}],"root_ids":["26317"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"826b347e-054d-40b6-87fa-5104e7a0d472","root_ids":["26317"],"roots":{"26317":"5b15ad60-711c-41cd-af8d-a43b9d949721"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();