(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("05c04b7e-da7f-4c16-b9b3-0e09dacb9d9f");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '05c04b7e-da7f-4c16-b9b3-0e09dacb9d9f' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"710d8423-9625-48d4-8e10-9399c2bf2cb7":{"roots":{"references":[{"attributes":{"line_color":{"field":"line_color"},"line_width":{"value":4},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"25000","type":"MultiLine"},{"attributes":{},"id":"25012","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"24999"},"glyph":{"id":"25000"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"25001"},"selection_glyph":null,"view":{"id":"25003"}},"id":"25002","type":"GlyphRenderer"},{"attributes":{"index":0,"label":{"value":"orange"},"renderers":[{"id":"25002"}]},"id":"25004","type":"LegendItem"},{"attributes":{"data":{"line_color":["orange","red"],"xs":[[1,2,3],[1,2,3]],"ys":[[1,3,2],[3,4,3]]},"selected":{"id":"25014"},"selection_policy":{"id":"25013"}},"id":"24999","type":"ColumnDataSource"},{"attributes":{},"id":"24982","type":"BasicTicker"},{"attributes":{},"id":"24985","type":"PanTool"},{"attributes":{},"id":"24989","type":"ResetTool"},{"attributes":{"text":""},"id":"25007","type":"Title"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"line_width":{"value":4},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"25001","type":"MultiLine"},{"attributes":{"axis":{"id":"24977"},"ticker":null},"id":"24980","type":"Grid"},{"attributes":{},"id":"24978","type":"BasicTicker"},{"attributes":{},"id":"25013","type":"UnionRenderers"},{"attributes":{"source":{"id":"24999"}},"id":"25003","type":"CDSView"},{"attributes":{},"id":"25010","type":"BasicTickFormatter"},{"attributes":{},"id":"25014","type":"Selection"},{"attributes":{},"id":"24990","type":"HelpTool"},{"attributes":{"items":[{"id":"25004"},{"id":"25005"}]},"id":"25006","type":"Legend"},{"attributes":{"overlay":{"id":"24991"}},"id":"24987","type":"BoxZoomTool"},{"attributes":{"axis":{"id":"24981"},"dimension":1,"ticker":null},"id":"24984","type":"Grid"},{"attributes":{},"id":"24986","type":"WheelZoomTool"},{"attributes":{},"id":"24975","type":"LinearScale"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"24991","type":"BoxAnnotation"},{"attributes":{"index":1,"label":{"value":"red"},"renderers":[{"id":"25002"}]},"id":"25005","type":"LegendItem"},{"attributes":{"below":[{"id":"24977"}],"center":[{"id":"24980"},{"id":"24984"},{"id":"25006"}],"left":[{"id":"24981"}],"renderers":[{"id":"25002"}],"title":{"id":"25007"},"toolbar":{"id":"24992"},"x_range":{"id":"24969"},"x_scale":{"id":"24973"},"y_range":{"id":"24971"},"y_scale":{"id":"24975"}},"id":"24968","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"24969","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"24985"},{"id":"24986"},{"id":"24987"},{"id":"24988"},{"id":"24989"},{"id":"24990"}]},"id":"24992","type":"Toolbar"},{"attributes":{},"id":"24988","type":"SaveTool"},{"attributes":{},"id":"24971","type":"DataRange1d"},{"attributes":{"formatter":{"id":"25012"},"ticker":{"id":"24982"}},"id":"24981","type":"LinearAxis"},{"attributes":{"formatter":{"id":"25010"},"ticker":{"id":"24978"}},"id":"24977","type":"LinearAxis"},{"attributes":{},"id":"24973","type":"LinearScale"}],"root_ids":["24968"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"710d8423-9625-48d4-8e10-9399c2bf2cb7","root_ids":["24968"],"roots":{"24968":"05c04b7e-da7f-4c16-b9b3-0e09dacb9d9f"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();