(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("b17b1fd0-974a-46f1-8d05-1f6e3a8a314f");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'b17b1fd0-974a-46f1-8d05-1f6e3a8a314f' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"4d25041c-9302-4c12-9ffe-4070dec0f48b":{"roots":{"references":[{"attributes":{"below":[{"id":"38651"}],"center":[{"id":"38654"},{"id":"38658"}],"left":[{"id":"38655"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"38676"}],"title":{"id":"38641"},"toolbar":{"id":"38666"},"x_range":{"id":"38643"},"x_scale":{"id":"38647"},"y_range":{"id":"38645"},"y_scale":{"id":"38649"}},"id":"38640","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"38645","type":"DataRange1d"},{"attributes":{},"id":"38664","type":"HelpTool"},{"attributes":{},"id":"38660","type":"WheelZoomTool"},{"attributes":{},"id":"38684","type":"UnionRenderers"},{"attributes":{},"id":"38652","type":"BasicTicker"},{"attributes":{},"id":"38656","type":"BasicTicker"},{"attributes":{"source":{"id":"38673"}},"id":"38677","type":"CDSView"},{"attributes":{},"id":"38681","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"38655"},"dimension":1,"ticker":null},"id":"38658","type":"Grid"},{"attributes":{},"id":"38647","type":"LinearScale"},{"attributes":{"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"38674","type":"Line"},{"attributes":{"text":"Toolbar Autohide"},"id":"38641","type":"Title"},{"attributes":{},"id":"38663","type":"ResetTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","autohide":true,"tools":[{"id":"38659"},{"id":"38660"},{"id":"38661"},{"id":"38662"},{"id":"38663"},{"id":"38664"}]},"id":"38666","type":"Toolbar"},{"attributes":{},"id":"38662","type":"SaveTool"},{"attributes":{"data_source":{"id":"38673"},"glyph":{"id":"38674"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"38675"},"selection_glyph":null,"view":{"id":"38677"}},"id":"38676","type":"GlyphRenderer"},{"attributes":{},"id":"38643","type":"DataRange1d"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"38675","type":"Line"},{"attributes":{"formatter":{"id":"38681"},"ticker":{"id":"38652"}},"id":"38651","type":"LinearAxis"},{"attributes":{"formatter":{"id":"38683"},"ticker":{"id":"38656"}},"id":"38655","type":"LinearAxis"},{"attributes":{},"id":"38685","type":"Selection"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"38665","type":"BoxAnnotation"},{"attributes":{"overlay":{"id":"38665"}},"id":"38661","type":"BoxZoomTool"},{"attributes":{"axis":{"id":"38651"},"ticker":null},"id":"38654","type":"Grid"},{"attributes":{},"id":"38683","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"38685"},"selection_policy":{"id":"38684"}},"id":"38673","type":"ColumnDataSource"},{"attributes":{},"id":"38649","type":"LinearScale"},{"attributes":{},"id":"38659","type":"PanTool"}],"root_ids":["38640"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"4d25041c-9302-4c12-9ffe-4070dec0f48b","root_ids":["38640"],"roots":{"38640":"b17b1fd0-974a-46f1-8d05-1f6e3a8a314f"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();