(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("48def683-3ddd-4d3c-9238-64f3b13ecd21");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '48def683-3ddd-4d3c-9238-64f3b13ecd21' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"00072674-636d-4a1c-a8f5-f2dac2f9b660":{"roots":{"references":[{"attributes":{},"id":"41261","type":"PanTool"},{"attributes":{"formatter":{"id":"41282"},"ticker":{"id":"41254"}},"id":"41253","type":"LinearAxis"},{"attributes":{"overlay":{"id":"41267"}},"id":"41263","type":"BoxZoomTool"},{"attributes":{},"id":"41264","type":"SaveTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"41261"},{"id":"41262"},{"id":"41263"},{"id":"41264"},{"id":"41265"},{"id":"41266"}]},"id":"41268","type":"Toolbar"},{"attributes":{},"id":"41282","type":"BasicTickFormatter"},{"attributes":{},"id":"41286","type":"Selection"},{"attributes":{"below":[{"id":"41253"}],"center":[{"id":"41256"},{"id":"41260"}],"left":[{"id":"41257"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"41278"}],"title":null,"toolbar":{"id":"41268"},"toolbar_location":"below","x_range":{"id":"41245"},"x_scale":{"id":"41249"},"y_range":{"id":"41247"},"y_scale":{"id":"41251"}},"id":"41243","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"41254","type":"BasicTicker"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"41286"},"selection_policy":{"id":"41285"}},"id":"41275","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"41275"},"glyph":{"id":"41276"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"41277"},"selection_glyph":null,"view":{"id":"41279"}},"id":"41278","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"41284"},"ticker":{"id":"41258"}},"id":"41257","type":"LinearAxis"},{"attributes":{},"id":"41262","type":"WheelZoomTool"},{"attributes":{},"id":"41285","type":"UnionRenderers"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"41267","type":"BoxAnnotation"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"41277","type":"Circle"},{"attributes":{"axis":{"id":"41253"},"ticker":null},"id":"41256","type":"Grid"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"41276","type":"Circle"},{"attributes":{"axis":{"id":"41257"},"dimension":1,"ticker":null},"id":"41260","type":"Grid"},{"attributes":{},"id":"41266","type":"HelpTool"},{"attributes":{},"id":"41249","type":"LinearScale"},{"attributes":{},"id":"41265","type":"ResetTool"},{"attributes":{},"id":"41251","type":"LinearScale"},{"attributes":{},"id":"41247","type":"DataRange1d"},{"attributes":{},"id":"41258","type":"BasicTicker"},{"attributes":{},"id":"41284","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"41275"}},"id":"41279","type":"CDSView"},{"attributes":{},"id":"41245","type":"DataRange1d"}],"root_ids":["41243"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"00072674-636d-4a1c-a8f5-f2dac2f9b660","root_ids":["41243"],"roots":{"41243":"48def683-3ddd-4d3c-9238-64f3b13ecd21"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();