(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("8bf0be15-1897-45f4-a6ec-839e11dea83e");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '8bf0be15-1897-45f4-a6ec-839e11dea83e' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"e03af109-8079-4334-9803-b390099a9a40":{"roots":{"references":[{"attributes":{"axis":{"id":"35518"},"ticker":null},"id":"35521","type":"Grid"},{"attributes":{"text":""},"id":"35545","type":"Title"},{"attributes":{},"id":"35531","type":"HelpTool"},{"attributes":{"axis":{"id":"35522"},"dimension":1,"ticker":null},"id":"35525","type":"Grid"},{"attributes":{},"id":"35523","type":"BasicTicker"},{"attributes":{"below":[{"id":"35518"}],"center":[{"id":"35521"},{"id":"35525"}],"left":[{"id":"35522"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"35543"}],"title":{"id":"35545"},"toolbar":{"id":"35533"},"x_range":{"id":"35510"},"x_scale":{"id":"35514"},"y_range":{"id":"35512"},"y_scale":{"id":"35516"}},"id":"35509","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"35510","type":"DataRange1d"},{"attributes":{"formatter":{"id":"35548"},"ticker":{"id":"35519"}},"id":"35518","type":"LinearAxis"},{"attributes":{},"id":"35530","type":"ResetTool"},{"attributes":{},"id":"35552","type":"Selection"},{"attributes":{},"id":"35550","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"35540"},"glyph":{"id":"35541"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"35542"},"selection_glyph":null,"view":{"id":"35544"}},"id":"35543","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.6},"fill_color":{"value":"orange"},"inner_radius":{"units":"data","value":0.1},"line_alpha":{"value":0.6},"line_color":{"value":"orange"},"outer_radius":{"units":"data","value":0.25},"x":{"field":"x"},"y":{"field":"y"}},"id":"35541","type":"Annulus"},{"attributes":{},"id":"35548","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"35552"},"selection_policy":{"id":"35551"}},"id":"35540","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"inner_radius":{"units":"data","value":0.1},"line_alpha":{"value":0.1},"line_color":{"value":"orange"},"outer_radius":{"units":"data","value":0.25},"x":{"field":"x"},"y":{"field":"y"}},"id":"35542","type":"Annulus"},{"attributes":{},"id":"35514","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"35526"},{"id":"35527"},{"id":"35528"},{"id":"35529"},{"id":"35530"},{"id":"35531"}]},"id":"35533","type":"Toolbar"},{"attributes":{"formatter":{"id":"35550"},"ticker":{"id":"35523"}},"id":"35522","type":"LinearAxis"},{"attributes":{"overlay":{"id":"35532"}},"id":"35528","type":"BoxZoomTool"},{"attributes":{},"id":"35551","type":"UnionRenderers"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"35532","type":"BoxAnnotation"},{"attributes":{},"id":"35512","type":"DataRange1d"},{"attributes":{},"id":"35529","type":"SaveTool"},{"attributes":{},"id":"35519","type":"BasicTicker"},{"attributes":{},"id":"35527","type":"WheelZoomTool"},{"attributes":{"source":{"id":"35540"}},"id":"35544","type":"CDSView"},{"attributes":{},"id":"35516","type":"LinearScale"},{"attributes":{},"id":"35526","type":"PanTool"}],"root_ids":["35509"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"e03af109-8079-4334-9803-b390099a9a40","root_ids":["35509"],"roots":{"35509":"8bf0be15-1897-45f4-a6ec-839e11dea83e"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();