(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("b1750227-1c22-4a58-bee3-0e7d79938214");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'b1750227-1c22-4a58-bee3-0e7d79938214' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"dc162f04-1028-4d14-8873-b3ccdb47ce82":{"roots":{"references":[{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"38806","type":"BoxAnnotation"},{"attributes":{},"id":"38797","type":"BasicTicker"},{"attributes":{},"id":"38803","type":"SaveTool"},{"attributes":{},"id":"38824","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"38826"},"selection_policy":{"id":"38825"}},"id":"38814","type":"ColumnDataSource"},{"attributes":{},"id":"38825","type":"UnionRenderers"},{"attributes":{},"id":"38804","type":"ResetTool"},{"attributes":{},"id":"38790","type":"LinearScale"},{"attributes":{},"id":"38826","type":"Selection"},{"attributes":{},"id":"38800","type":"PanTool"},{"attributes":{},"id":"38784","type":"DataRange1d"},{"attributes":{"data_source":{"id":"38814"},"glyph":{"id":"38815"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"38816"},"selection_glyph":null,"view":{"id":"38818"}},"id":"38817","type":"GlyphRenderer"},{"attributes":{"axis":{"id":"38796"},"dimension":1,"ticker":null},"id":"38799","type":"Grid"},{"attributes":{"overlay":{"id":"38806"}},"id":"38802","type":"BoxZoomTool"},{"attributes":{},"id":"38786","type":"DataRange1d"},{"attributes":{"text":""},"id":"38819","type":"Title"},{"attributes":{"source":{"id":"38814"}},"id":"38818","type":"CDSView"},{"attributes":{},"id":"38788","type":"LinearScale"},{"attributes":{"axis_label":"Lot Number","axis_label_standoff":30,"axis_label_text_color":"#aa6666","formatter":{"id":"38822"},"ticker":{"id":"38793"}},"id":"38792","type":"LinearAxis"},{"attributes":{"axis":{"id":"38792"},"ticker":null},"id":"38795","type":"Grid"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"38815","type":"Circle"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"38800"},{"id":"38801"},{"id":"38802"},{"id":"38803"},{"id":"38804"},{"id":"38805"}]},"id":"38807","type":"Toolbar"},{"attributes":{},"id":"38801","type":"WheelZoomTool"},{"attributes":{"below":[{"id":"38792"}],"center":[{"id":"38795"},{"id":"38799"}],"left":[{"id":"38796"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"38817"}],"title":{"id":"38819"},"toolbar":{"id":"38807"},"x_range":{"id":"38784"},"x_scale":{"id":"38788"},"y_range":{"id":"38786"},"y_scale":{"id":"38790"}},"id":"38783","subtype":"Figure","type":"Plot"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"38816","type":"Circle"},{"attributes":{},"id":"38822","type":"BasicTickFormatter"},{"attributes":{},"id":"38793","type":"BasicTicker"},{"attributes":{"axis_label":"Bin Count","formatter":{"id":"38824"},"ticker":{"id":"38797"}},"id":"38796","type":"LinearAxis"},{"attributes":{},"id":"38805","type":"HelpTool"}],"root_ids":["38783"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"dc162f04-1028-4d14-8873-b3ccdb47ce82","root_ids":["38783"],"roots":{"38783":"b1750227-1c22-4a58-bee3-0e7d79938214"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();