(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("88404f44-ea1b-417d-a7de-9a51955a54d8");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '88404f44-ea1b-417d-a7de-9a51955a54d8' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"067adb3b-1193-4f72-99c4-5bdaa027b697":{"roots":{"references":[{"attributes":{"data_source":{"id":"34746"},"glyph":{"id":"34747"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"34748"},"selection_glyph":null,"view":{"id":"34750"}},"id":"34749","type":"GlyphRenderer"},{"attributes":{},"id":"34716","type":"DataRange1d"},{"attributes":{},"id":"34757","type":"UnionRenderers"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"34747","type":"MultiPolygons"},{"attributes":{},"id":"34754","type":"BasicTickFormatter"},{"attributes":{},"id":"34733","type":"WheelZoomTool"},{"attributes":{},"id":"34735","type":"SaveTool"},{"attributes":{},"id":"34720","type":"LinearScale"},{"attributes":{"source":{"id":"34746"}},"id":"34750","type":"CDSView"},{"attributes":{},"id":"34732","type":"PanTool"},{"attributes":{},"id":"34737","type":"HelpTool"},{"attributes":{"formatter":{"id":"34756"},"ticker":{"id":"34729"}},"id":"34728","type":"LinearAxis"},{"attributes":{"data":{"xs":[[[[1,2,2,1],[1.2,1.6,1.6],[1.8,1.8,1.6]]]],"ys":[[[[3,3,4,4],[3.2,3.6,3.2],[3.4,3.8,3.8]]]]},"selected":{"id":"34758"},"selection_policy":{"id":"34757"}},"id":"34746","type":"ColumnDataSource"},{"attributes":{},"id":"34756","type":"BasicTickFormatter"},{"attributes":{},"id":"34718","type":"DataRange1d"},{"attributes":{},"id":"34725","type":"BasicTicker"},{"attributes":{},"id":"34758","type":"Selection"},{"attributes":{"text":""},"id":"34751","type":"Title"},{"attributes":{},"id":"34722","type":"LinearScale"},{"attributes":{"below":[{"id":"34724"}],"center":[{"id":"34727"},{"id":"34731"}],"left":[{"id":"34728"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"34749"}],"title":{"id":"34751"},"toolbar":{"id":"34739"},"x_range":{"id":"34716"},"x_scale":{"id":"34720"},"y_range":{"id":"34718"},"y_scale":{"id":"34722"}},"id":"34715","subtype":"Figure","type":"Plot"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"34748","type":"MultiPolygons"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"34738","type":"BoxAnnotation"},{"attributes":{"overlay":{"id":"34738"}},"id":"34734","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"34754"},"ticker":{"id":"34725"}},"id":"34724","type":"LinearAxis"},{"attributes":{},"id":"34736","type":"ResetTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"34732"},{"id":"34733"},{"id":"34734"},{"id":"34735"},{"id":"34736"},{"id":"34737"}]},"id":"34739","type":"Toolbar"},{"attributes":{},"id":"34729","type":"BasicTicker"},{"attributes":{"axis":{"id":"34724"},"ticker":null},"id":"34727","type":"Grid"},{"attributes":{"axis":{"id":"34728"},"dimension":1,"ticker":null},"id":"34731","type":"Grid"}],"root_ids":["34715"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"067adb3b-1193-4f72-99c4-5bdaa027b697","root_ids":["34715"],"roots":{"34715":"88404f44-ea1b-417d-a7de-9a51955a54d8"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();