(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("3c141b3d-3217-402f-a98d-b0aa4861daa7");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '3c141b3d-3217-402f-a98d-b0aa4861daa7' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"c4195c30-1aa1-4579-b6fe-98b7d59eba3f":{"roots":{"references":[{"attributes":{"formatter":{"id":"35260"},"ticker":{"id":"35231"}},"id":"35230","type":"LinearAxis"},{"attributes":{},"id":"35260","type":"BasicTickFormatter"},{"attributes":{"below":[{"id":"35230"}],"center":[{"id":"35233"},{"id":"35237"}],"left":[{"id":"35234"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"35255"}],"title":{"id":"35257"},"toolbar":{"id":"35245"},"x_range":{"id":"35222"},"x_scale":{"id":"35226"},"y_range":{"id":"35224"},"y_scale":{"id":"35228"}},"id":"35221","subtype":"Figure","type":"Plot"},{"attributes":{"axis":{"id":"35234"},"dimension":1,"ticker":null},"id":"35237","type":"Grid"},{"attributes":{},"id":"35264","type":"Selection"},{"attributes":{},"id":"35228","type":"LinearScale"},{"attributes":{},"id":"35226","type":"LinearScale"},{"attributes":{},"id":"35241","type":"SaveTool"},{"attributes":{"overlay":{"id":"35244"}},"id":"35240","type":"BoxZoomTool"},{"attributes":{"angle":{"field":"angle","units":"deg"},"length":{"units":"data","value":45},"line_color":{"value":"#FB8072"},"line_width":{"value":2},"x":{"field":"x"},"y":{"field":"y"}},"id":"35253","type":"Ray"},{"attributes":{},"id":"35222","type":"DataRange1d"},{"attributes":{},"id":"35243","type":"HelpTool"},{"attributes":{},"id":"35262","type":"BasicTickFormatter"},{"attributes":{},"id":"35238","type":"PanTool"},{"attributes":{},"id":"35239","type":"WheelZoomTool"},{"attributes":{"formatter":{"id":"35262"},"ticker":{"id":"35235"}},"id":"35234","type":"LinearAxis"},{"attributes":{"data":{"angle":[30,45,60],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"35264"},"selection_policy":{"id":"35263"}},"id":"35252","type":"ColumnDataSource"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"35238"},{"id":"35239"},{"id":"35240"},{"id":"35241"},{"id":"35242"},{"id":"35243"}]},"id":"35245","type":"Toolbar"},{"attributes":{"text":""},"id":"35257","type":"Title"},{"attributes":{},"id":"35242","type":"ResetTool"},{"attributes":{"source":{"id":"35252"}},"id":"35256","type":"CDSView"},{"attributes":{"axis":{"id":"35230"},"ticker":null},"id":"35233","type":"Grid"},{"attributes":{},"id":"35235","type":"BasicTicker"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"35244","type":"BoxAnnotation"},{"attributes":{"data_source":{"id":"35252"},"glyph":{"id":"35253"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"35254"},"selection_glyph":null,"view":{"id":"35256"}},"id":"35255","type":"GlyphRenderer"},{"attributes":{},"id":"35231","type":"BasicTicker"},{"attributes":{"angle":{"field":"angle","units":"deg"},"length":{"units":"data","value":45},"line_alpha":{"value":0.1},"line_color":{"value":"#FB8072"},"line_width":{"value":2},"x":{"field":"x"},"y":{"field":"y"}},"id":"35254","type":"Ray"},{"attributes":{},"id":"35263","type":"UnionRenderers"},{"attributes":{},"id":"35224","type":"DataRange1d"}],"root_ids":["35221"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"c4195c30-1aa1-4579-b6fe-98b7d59eba3f","root_ids":["35221"],"roots":{"35221":"3c141b3d-3217-402f-a98d-b0aa4861daa7"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();