(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("bdb9e32e-ef28-43db-9a86-b4198f4e60cc");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'bdb9e32e-ef28-43db-9a86-b4198f4e60cc' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"e71392c9-1a12-4e21-8a99-10cdf4907f76":{"roots":{"references":[{"attributes":{"data_source":{"id":"34345"},"glyph":{"id":"34387"},"hover_glyph":null,"muted_glyph":null,"name":"y2","nonselection_glyph":{"id":"34388"},"selection_glyph":null,"view":{"id":"34390"}},"id":"34389","type":"GlyphRenderer"},{"attributes":{},"id":"34394","type":"BasicTickFormatter"},{"attributes":{},"id":"34364","type":"WheelZoomTool"},{"attributes":{"axis":{"id":"34355"},"ticker":null},"id":"34358","type":"Grid"},{"attributes":{"fill_alpha":0.1,"fill_color":"grey","x":{"field":"x"},"y1":{"expr":{"id":"34377"}},"y2":{"expr":{"id":"34378"}}},"id":"34383","type":"VArea"},{"attributes":{"overlay":{"id":"34369"}},"id":"34365","type":"BoxZoomTool"},{"attributes":{},"id":"34353","type":"LinearScale"},{"attributes":{"data_source":{"id":"34345"},"glyph":{"id":"34382"},"hover_glyph":null,"muted_glyph":null,"name":"y1","nonselection_glyph":{"id":"34383"},"selection_glyph":null,"view":{"id":"34385"}},"id":"34384","type":"GlyphRenderer"},{"attributes":{},"id":"34351","type":"LinearScale"},{"attributes":{},"id":"34347","type":"DataRange1d"},{"attributes":{},"id":"34349","type":"DataRange1d"},{"attributes":{"fill_color":"lightgrey","x":{"field":"x"},"y1":{"expr":{"id":"34379"}},"y2":{"expr":{"id":"34380"}}},"id":"34387","type":"VArea"},{"attributes":{"data":{"x":[1,2,3,4,5],"y1":[1,2,4,3,4],"y2":[1,4,2,2,3]},"selected":{"id":"34398"},"selection_policy":{"id":"34397"}},"id":"34345","type":"ColumnDataSource"},{"attributes":{"source":{"id":"34345"}},"id":"34390","type":"CDSView"},{"attributes":{},"id":"34368","type":"HelpTool"},{"attributes":{},"id":"34366","type":"SaveTool"},{"attributes":{},"id":"34363","type":"PanTool"},{"attributes":{"fields":["y1","y2"]},"id":"34380","type":"Stack"},{"attributes":{"formatter":{"id":"34394"},"ticker":{"id":"34356"}},"id":"34355","type":"LinearAxis"},{"attributes":{"formatter":{"id":"34396"},"ticker":{"id":"34360"}},"id":"34359","type":"LinearAxis"},{"attributes":{},"id":"34360","type":"BasicTicker"},{"attributes":{"below":[{"id":"34355"}],"center":[{"id":"34358"},{"id":"34362"}],"left":[{"id":"34359"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"34384"},{"id":"34389"}],"title":{"id":"34391"},"toolbar":{"id":"34370"},"x_range":{"id":"34347"},"x_scale":{"id":"34351"},"y_range":{"id":"34349"},"y_scale":{"id":"34353"}},"id":"34346","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"34398","type":"Selection"},{"attributes":{"fields":["y1"]},"id":"34378","type":"Stack"},{"attributes":{"axis":{"id":"34359"},"dimension":1,"ticker":null},"id":"34362","type":"Grid"},{"attributes":{},"id":"34356","type":"BasicTicker"},{"attributes":{"source":{"id":"34345"}},"id":"34385","type":"CDSView"},{"attributes":{},"id":"34367","type":"ResetTool"},{"attributes":{"fields":[]},"id":"34377","type":"Stack"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"34363"},{"id":"34364"},{"id":"34365"},{"id":"34366"},{"id":"34367"},{"id":"34368"}]},"id":"34370","type":"Toolbar"},{"attributes":{},"id":"34396","type":"BasicTickFormatter"},{"attributes":{"fields":["y1"]},"id":"34379","type":"Stack"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"34369","type":"BoxAnnotation"},{"attributes":{"fill_alpha":0.1,"fill_color":"lightgrey","x":{"field":"x"},"y1":{"expr":{"id":"34379"}},"y2":{"expr":{"id":"34380"}}},"id":"34388","type":"VArea"},{"attributes":{},"id":"34397","type":"UnionRenderers"},{"attributes":{"text":""},"id":"34391","type":"Title"},{"attributes":{"fill_color":"grey","x":{"field":"x"},"y1":{"expr":{"id":"34377"}},"y2":{"expr":{"id":"34378"}}},"id":"34382","type":"VArea"}],"root_ids":["34346"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"e71392c9-1a12-4e21-8a99-10cdf4907f76","root_ids":["34346"],"roots":{"34346":"bdb9e32e-ef28-43db-9a86-b4198f4e60cc"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();