(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("8e8b2618-819b-4299-8aaf-61ef0d1af798");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '8e8b2618-819b-4299-8aaf-61ef0d1af798' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"21ea734c-fa4f-44e7-b96a-114493268d0f":{"roots":{"references":[{"attributes":{"data_source":{"id":"29413"},"glyph":{"id":"29420"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"29415"}},"id":"29414","type":"GlyphRenderer"},{"attributes":{},"id":"29444","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"29444"},"ticker":{"id":"29407"}},"id":"29406","type":"LinearAxis"},{"attributes":{},"id":"29437","type":"NodesOnly"},{"attributes":{},"id":"29438","type":"NodesOnly"},{"attributes":{},"id":"29407","type":"BasicTicker"},{"attributes":{},"id":"29445","type":"UnionRenderers"},{"attributes":{"axis":{"id":"29402"},"ticker":null},"id":"29405","type":"Grid"},{"attributes":{"source":{"id":"29413"}},"id":"29415","type":"CDSView"},{"attributes":{},"id":"29400","type":"LinearScale"},{"attributes":{"fill_color":{"field":"color"},"height":{"units":"data","value":0.1},"width":{"units":"data","value":0.2}},"id":"29420","type":"Ellipse"},{"attributes":{"below":[{"id":"29402"}],"center":[{"id":"29405"},{"id":"29409"}],"left":[{"id":"29406"}],"renderers":[{"id":"29411"}],"title":{"id":"29392"},"toolbar":{"id":"29410"},"toolbar_location":null,"x_range":{"id":"29394"},"x_scale":{"id":"29398"},"y_range":{"id":"29396"},"y_scale":{"id":"29400"}},"id":"29391","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"29398","type":"LinearScale"},{"attributes":{},"id":"29446","type":"Selection"},{"attributes":{"axis":{"id":"29406"},"dimension":1,"ticker":null},"id":"29409","type":"Grid"},{"attributes":{},"id":"29403","type":"BasicTicker"},{"attributes":{},"id":"29447","type":"UnionRenderers"},{"attributes":{"end":1.1,"start":-1.1},"id":"29396","type":"Range1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"29410","type":"Toolbar"},{"attributes":{"data_source":{"id":"29426"},"glyph":{"id":"29425"},"hover_glyph":null,"muted_glyph":null,"view":{"id":"29428"}},"id":"29427","type":"GlyphRenderer"},{"attributes":{"text":"Graph Layout Demonstration"},"id":"29392","type":"Title"},{"attributes":{"source":{"id":"29426"}},"id":"29428","type":"CDSView"},{"attributes":{"edge_renderer":{"id":"29427"},"inspection_policy":{"id":"29437"},"layout_provider":{"id":"29429"},"node_renderer":{"id":"29414"},"selection_policy":{"id":"29438"}},"id":"29411","type":"GraphRenderer"},{"attributes":{},"id":"29432","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"29432"},"ticker":{"id":"29403"}},"id":"29402","type":"LinearAxis"},{"attributes":{"end":1.1,"start":-1.1},"id":"29394","type":"Range1d"},{"attributes":{"data":{"end":[0,1,2,3,4,5,6,7],"start":[0,0,0,0,0,0,0,0]},"selected":{"id":"29448"},"selection_policy":{"id":"29447"}},"id":"29426","type":"ColumnDataSource"},{"attributes":{"graph_layout":{"0":[1.0,0.0],"1":[0.7071067811865476,0.7071067811865475],"2":[6.123233995736766e-17,1.0],"3":[-0.7071067811865475,0.7071067811865476],"4":[-1.0,1.2246467991473532e-16],"5":[-0.7071067811865477,-0.7071067811865475],"6":[-1.8369701987210297e-16,-1.0],"7":[0.7071067811865475,-0.7071067811865477]}},"id":"29429","type":"StaticLayoutProvider"},{"attributes":{},"id":"29425","type":"MultiLine"},{"attributes":{},"id":"29448","type":"Selection"},{"attributes":{"data":{"color":["#3288bd","#66c2a5","#abdda4","#e6f598","#fee08b","#fdae61","#f46d43","#d53e4f"],"index":[0,1,2,3,4,5,6,7]},"selected":{"id":"29446"},"selection_policy":{"id":"29445"}},"id":"29413","type":"ColumnDataSource"}],"root_ids":["29391"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"21ea734c-fa4f-44e7-b96a-114493268d0f","root_ids":["29391"],"roots":{"29391":"8e8b2618-819b-4299-8aaf-61ef0d1af798"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();