(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("12b976b8-fa7b-420f-96b1-0d5d5dd2e72a");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '12b976b8-fa7b-420f-96b1-0d5d5dd2e72a' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"12651f34-c0ea-4d3b-ac16-1be4f17461d1":{"roots":{"references":[{"attributes":{"fill_alpha":0.1,"fill_color":"green","left":1.5,"right":2.5},"id":"37259","type":"BoxAnnotation"},{"attributes":{"source":{"id":"37249"}},"id":"37253","type":"CDSView"},{"attributes":{"line_alpha":0.1,"line_color":"pink","x":{"field":"x"},"y":{"field":"y"}},"id":"37256","type":"Line"},{"attributes":{},"id":"37245","type":"BasicTicker"},{"attributes":{"source":{"id":"37254"}},"id":"37258","type":"CDSView"},{"attributes":{},"id":"37232","type":"DataRange1d"},{"attributes":{},"id":"37241","type":"BasicTicker"},{"attributes":{"line_color":"blue","x":{"field":"x"},"y":{"field":"y"}},"id":"37250","type":"Line"},{"attributes":{"data_source":{"id":"37254"},"glyph":{"id":"37255"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37256"},"selection_glyph":null,"view":{"id":"37258"}},"id":"37257","type":"GlyphRenderer"},{"attributes":{"axis":{"id":"37240"},"ticker":null},"id":"37243","type":"Grid"},{"attributes":{"data_source":{"id":"37249"},"glyph":{"id":"37250"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37251"},"selection_glyph":null,"view":{"id":"37253"}},"id":"37252","type":"GlyphRenderer"},{"attributes":{"data":{"x":[1,2,3],"y":[2,1,2]},"selected":{"id":"37276"},"selection_policy":{"id":"37275"}},"id":"37254","type":"ColumnDataSource"},{"attributes":{"children":[{"id":"37231"}]},"id":"37264","type":"Row"},{"attributes":{},"id":"37276","type":"Selection"},{"attributes":{"formatter":{"id":"37270"},"ticker":{"id":"37241"}},"id":"37240","type":"LinearAxis"},{"attributes":{},"id":"37270","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"37244"},"dimension":1,"ticker":null},"id":"37247","type":"Grid"},{"attributes":{},"id":"37234","type":"DataRange1d"},{"attributes":{"active":true,"button_type":"success","icon":null,"js_property_callbacks":{"change:active":[{"id":"37261"}]},"label":"Green Box"},"id":"37260","type":"Toggle"},{"attributes":{},"id":"37236","type":"LinearScale"},{"attributes":{},"id":"37272","type":"BasicTickFormatter"},{"attributes":{"args":{"other":{"id":"37259"}},"code":"other.visible = this.active"},"id":"37261","type":"CustomJS"},{"attributes":{"args":{"other":{"id":"37257"}},"code":"other.visible = this.active"},"id":"37263","type":"CustomJS"},{"attributes":{},"id":"37275","type":"UnionRenderers"},{"attributes":{"children":[{"id":"37264"},{"id":"37265"}]},"id":"37266","type":"Column"},{"attributes":{"line_color":"pink","x":{"field":"x"},"y":{"field":"y"}},"id":"37255","type":"Line"},{"attributes":{},"id":"37273","type":"UnionRenderers"},{"attributes":{"active":true,"button_type":"success","icon":null,"js_property_callbacks":{"change:active":[{"id":"37263"}]},"label":"Pink Line"},"id":"37262","type":"Toggle"},{"attributes":{"text":""},"id":"37267","type":"Title"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"37248","type":"Toolbar"},{"attributes":{},"id":"37238","type":"LinearScale"},{"attributes":{"line_alpha":0.1,"line_color":"blue","x":{"field":"x"},"y":{"field":"y"}},"id":"37251","type":"Line"},{"attributes":{},"id":"37274","type":"Selection"},{"attributes":{"children":[{"id":"37260"},{"id":"37262"}]},"id":"37265","type":"Row"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,1]},"selected":{"id":"37274"},"selection_policy":{"id":"37273"}},"id":"37249","type":"ColumnDataSource"},{"attributes":{"below":[{"id":"37240"}],"center":[{"id":"37243"},{"id":"37247"},{"id":"37259"}],"left":[{"id":"37244"}],"plot_height":200,"renderers":[{"id":"37252"},{"id":"37257"}],"title":{"id":"37267"},"toolbar":{"id":"37248"},"x_range":{"id":"37232"},"x_scale":{"id":"37236"},"y_range":{"id":"37234"},"y_scale":{"id":"37238"}},"id":"37231","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"37272"},"ticker":{"id":"37245"}},"id":"37244","type":"LinearAxis"}],"root_ids":["37266"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"12651f34-c0ea-4d3b-ac16-1be4f17461d1","root_ids":["37266"],"roots":{"37266":"12b976b8-fa7b-420f-96b1-0d5d5dd2e72a"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();