(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("581e2ac7-8e98-47cf-9518-84255aeb424a");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '581e2ac7-8e98-47cf-9518-84255aeb424a' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"c3ed5f4d-a1dc-4a40-869e-16964d8c4839":{"roots":{"references":[{"attributes":{},"id":"39076","type":"LinearScale"},{"attributes":{"format":"0.0%"},"id":"39105","type":"NumeralTickFormatter"},{"attributes":{},"id":"39087","type":"WheelZoomTool"},{"attributes":{},"id":"39074","type":"LinearScale"},{"attributes":{},"id":"39113","type":"UnionRenderers"},{"attributes":{"overlay":{"id":"39092"}},"id":"39088","type":"BoxZoomTool"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"39101","type":"Circle"},{"attributes":{},"id":"39114","type":"Selection"},{"attributes":{"format":"$0.00"},"id":"39107","type":"NumeralTickFormatter"},{"attributes":{"below":[{"id":"39078"}],"center":[{"id":"39081"},{"id":"39085"}],"left":[{"id":"39082"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"39103"}],"title":{"id":"39109"},"toolbar":{"id":"39093"},"x_range":{"id":"39070"},"x_scale":{"id":"39074"},"y_range":{"id":"39072"},"y_scale":{"id":"39076"}},"id":"39069","subtype":"Figure","type":"Plot"},{"attributes":{"data_source":{"id":"39100"},"glyph":{"id":"39101"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"39102"},"selection_glyph":null,"view":{"id":"39104"}},"id":"39103","type":"GlyphRenderer"},{"attributes":{},"id":"39089","type":"SaveTool"},{"attributes":{},"id":"39091","type":"HelpTool"},{"attributes":{},"id":"39079","type":"BasicTicker"},{"attributes":{"source":{"id":"39100"}},"id":"39104","type":"CDSView"},{"attributes":{"formatter":{"id":"39105"},"ticker":{"id":"39079"}},"id":"39078","type":"LinearAxis"},{"attributes":{"formatter":{"id":"39107"},"ticker":{"id":"39083"}},"id":"39082","type":"LinearAxis"},{"attributes":{},"id":"39086","type":"PanTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"39092","type":"BoxAnnotation"},{"attributes":{"axis":{"id":"39082"},"dimension":1,"ticker":null},"id":"39085","type":"Grid"},{"attributes":{"text":""},"id":"39109","type":"Title"},{"attributes":{},"id":"39083","type":"BasicTicker"},{"attributes":{},"id":"39090","type":"ResetTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"39102","type":"Circle"},{"attributes":{},"id":"39070","type":"DataRange1d"},{"attributes":{"axis":{"id":"39078"},"ticker":null},"id":"39081","type":"Grid"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"39086"},{"id":"39087"},{"id":"39088"},{"id":"39089"},{"id":"39090"},{"id":"39091"}]},"id":"39093","type":"Toolbar"},{"attributes":{},"id":"39072","type":"DataRange1d"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"39114"},"selection_policy":{"id":"39113"}},"id":"39100","type":"ColumnDataSource"}],"root_ids":["39069"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"c3ed5f4d-a1dc-4a40-869e-16964d8c4839","root_ids":["39069"],"roots":{"39069":"581e2ac7-8e98-47cf-9518-84255aeb424a"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();