(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("1e882912-6765-48f6-b0c2-db0a94d39466");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '1e882912-6765-48f6-b0c2-db0a94d39466' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"96e4881c-7bcc-4571-997c-ae63cd7baf7c":{"roots":{"references":[{"attributes":{},"id":"32951","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.8},"fill_color":{"value":"#d95b43"},"line_alpha":{"value":0.8},"line_color":{"value":"#d95b43"},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"32942","type":"Square"},{"attributes":{"toolbars":[{"id":"32862"},{"id":"32898"},{"id":"32934"}],"tools":[{"id":"32855"},{"id":"32856"},{"id":"32857"},{"id":"32858"},{"id":"32859"},{"id":"32860"},{"id":"32891"},{"id":"32892"},{"id":"32893"},{"id":"32894"},{"id":"32895"},{"id":"32896"},{"id":"32927"},{"id":"32928"},{"id":"32929"},{"id":"32930"},{"id":"32931"},{"id":"32932"}]},"id":"32977","type":"ProxyToolbar"},{"attributes":{},"id":"32839","type":"DataRange1d"},{"attributes":{},"id":"32959","type":"BasicTickFormatter"},{"attributes":{},"id":"32852","type":"BasicTicker"},{"attributes":{"source":{"id":"32905"}},"id":"32909","type":"CDSView"},{"attributes":{"formatter":{"id":"32949"},"ticker":{"id":"32848"}},"id":"32847","type":"LinearAxis"},{"attributes":{"text":""},"id":"32946","type":"Title"},{"attributes":{},"id":"32856","type":"WheelZoomTool"},{"attributes":{"overlay":{"id":"32897"}},"id":"32893","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"32971"},"ticker":{"id":"32924"}},"id":"32923","type":"LinearAxis"},{"attributes":{},"id":"32888","type":"BasicTicker"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"32927"},{"id":"32928"},{"id":"32929"},{"id":"32930"},{"id":"32931"},{"id":"32932"}]},"id":"32934","type":"Toolbar"},{"attributes":{},"id":"32884","type":"BasicTicker"},{"attributes":{"source":{"id":"32869"}},"id":"32873","type":"CDSView"},{"attributes":{},"id":"32858","type":"SaveTool"},{"attributes":{"background_fill_color":"#fafafa","below":[{"id":"32919"}],"center":[{"id":"32922"},{"id":"32926"}],"left":[{"id":"32923"}],"plot_height":250,"plot_width":250,"renderers":[{"id":"32944"}],"title":{"id":"32966"},"toolbar":{"id":"32934"},"toolbar_location":null,"x_range":{"id":"32911"},"x_scale":{"id":"32915"},"y_range":{"id":"32913"},"y_scale":{"id":"32917"}},"id":"32910","subtype":"Figure","type":"Plot"},{"attributes":{"data_source":{"id":"32869"},"glyph":{"id":"32870"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"32871"},"selection_glyph":null,"view":{"id":"32873"}},"id":"32872","type":"GlyphRenderer"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"32933","type":"BoxAnnotation"},{"attributes":{"fill_alpha":{"value":0.8},"fill_color":{"value":"#53777a"},"line_alpha":{"value":0.8},"line_color":{"value":"#53777a"},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"32870","type":"Circle"},{"attributes":{},"id":"32911","type":"DataRange1d"},{"attributes":{},"id":"32894","type":"SaveTool"},{"attributes":{"axis":{"id":"32847"},"ticker":null},"id":"32850","type":"Grid"},{"attributes":{"axis":{"id":"32851"},"dimension":1,"ticker":null},"id":"32854","type":"Grid"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"32855"},{"id":"32856"},{"id":"32857"},{"id":"32858"},{"id":"32859"},{"id":"32860"}]},"id":"32862","type":"Toolbar"},{"attributes":{},"id":"32931","type":"ResetTool"},{"attributes":{"background_fill_color":"#fafafa","below":[{"id":"32847"}],"center":[{"id":"32850"},{"id":"32854"}],"left":[{"id":"32851"}],"plot_height":250,"plot_width":250,"renderers":[{"id":"32872"}],"title":{"id":"32946"},"toolbar":{"id":"32862"},"toolbar_location":null,"x_range":{"id":"32839"},"x_scale":{"id":"32843"},"y_range":{"id":"32841"},"y_scale":{"id":"32845"}},"id":"32838","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"32896","type":"HelpTool"},{"attributes":{"data":{"x":[0,1,2,3,4,5,6,7,8,9,10],"y":[0,1,2,3,4,5,6,7,8,9,10]},"selected":{"id":"32953"},"selection_policy":{"id":"32952"}},"id":"32869","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"32887"},"dimension":1,"ticker":null},"id":"32890","type":"Grid"},{"attributes":{"formatter":{"id":"32961"},"ticker":{"id":"32888"}},"id":"32887","type":"LinearAxis"},{"attributes":{"text":""},"id":"32956","type":"Title"},{"attributes":{},"id":"32917","type":"LinearScale"},{"attributes":{},"id":"32963","type":"Selection"},{"attributes":{"background_fill_color":"#fafafa","below":[{"id":"32883"}],"center":[{"id":"32886"},{"id":"32890"}],"left":[{"id":"32887"}],"plot_height":250,"plot_width":250,"renderers":[{"id":"32908"}],"title":{"id":"32956"},"toolbar":{"id":"32898"},"toolbar_location":null,"x_range":{"id":"32875"},"x_scale":{"id":"32879"},"y_range":{"id":"32877"},"y_scale":{"id":"32881"}},"id":"32874","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"32913","type":"DataRange1d"},{"attributes":{"children":[[{"id":"32838"},0,0],[{"id":"32874"},0,1],[{"id":"32910"},1,0]]},"id":"32976","type":"GridBox"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#53777a"},"line_alpha":{"value":0.1},"line_color":{"value":"#53777a"},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"32871","type":"Circle"},{"attributes":{},"id":"32859","type":"ResetTool"},{"attributes":{},"id":"32928","type":"WheelZoomTool"},{"attributes":{"formatter":{"id":"32951"},"ticker":{"id":"32852"}},"id":"32851","type":"LinearAxis"},{"attributes":{"formatter":{"id":"32969"},"ticker":{"id":"32920"}},"id":"32919","type":"LinearAxis"},{"attributes":{},"id":"32891","type":"PanTool"},{"attributes":{},"id":"32881","type":"LinearScale"},{"attributes":{"text":""},"id":"32966","type":"Title"},{"attributes":{"source":{"id":"32941"}},"id":"32945","type":"CDSView"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"32891"},{"id":"32892"},{"id":"32893"},{"id":"32894"},{"id":"32895"},{"id":"32896"}]},"id":"32898","type":"Toolbar"},{"attributes":{"overlay":{"id":"32933"}},"id":"32929","type":"BoxZoomTool"},{"attributes":{},"id":"32971","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.8},"fill_color":{"value":"#c02942"},"line_alpha":{"value":0.8},"line_color":{"value":"#c02942"},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"32906","type":"Triangle"},{"attributes":{},"id":"32953","type":"Selection"},{"attributes":{},"id":"32972","type":"UnionRenderers"},{"attributes":{},"id":"32952","type":"UnionRenderers"},{"attributes":{},"id":"32875","type":"DataRange1d"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#d95b43"},"line_alpha":{"value":0.1},"line_color":{"value":"#d95b43"},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"32943","type":"Square"},{"attributes":{"overlay":{"id":"32861"}},"id":"32857","type":"BoxZoomTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"32897","type":"BoxAnnotation"},{"attributes":{"data_source":{"id":"32905"},"glyph":{"id":"32906"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"32907"},"selection_glyph":null,"view":{"id":"32909"}},"id":"32908","type":"GlyphRenderer"},{"attributes":{},"id":"32915","type":"LinearScale"},{"attributes":{},"id":"32855","type":"PanTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"32861","type":"BoxAnnotation"},{"attributes":{},"id":"32843","type":"LinearScale"},{"attributes":{"toolbar":{"id":"32977"},"toolbar_location":"above"},"id":"32978","type":"ToolbarBox"},{"attributes":{},"id":"32845","type":"LinearScale"},{"attributes":{"formatter":{"id":"32959"},"ticker":{"id":"32884"}},"id":"32883","type":"LinearAxis"},{"attributes":{},"id":"32860","type":"HelpTool"},{"attributes":{"axis":{"id":"32883"},"ticker":null},"id":"32886","type":"Grid"},{"attributes":{},"id":"32927","type":"PanTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#c02942"},"line_alpha":{"value":0.1},"line_color":{"value":"#c02942"},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"32907","type":"Triangle"},{"attributes":{},"id":"32895","type":"ResetTool"},{"attributes":{"data_source":{"id":"32941"},"glyph":{"id":"32942"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"32943"},"selection_glyph":null,"view":{"id":"32945"}},"id":"32944","type":"GlyphRenderer"},{"attributes":{},"id":"32924","type":"BasicTicker"},{"attributes":{"axis":{"id":"32923"},"dimension":1,"ticker":null},"id":"32926","type":"Grid"},{"attributes":{},"id":"32920","type":"BasicTicker"},{"attributes":{},"id":"32969","type":"BasicTickFormatter"},{"attributes":{},"id":"32841","type":"DataRange1d"},{"attributes":{"data":{"x":[0,1,2,3,4,5,6,7,8,9,10],"y":[10,9,8,7,6,5,4,3,2,1,0]},"selected":{"id":"32963"},"selection_policy":{"id":"32962"}},"id":"32905","type":"ColumnDataSource"},{"attributes":{"data":{"x":[0,1,2,3,4,5,6,7,8,9,10],"y":[5,4,3,2,1,0,1,2,3,4,5]},"selected":{"id":"32973"},"selection_policy":{"id":"32972"}},"id":"32941","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"32919"},"ticker":null},"id":"32922","type":"Grid"},{"attributes":{},"id":"32892","type":"WheelZoomTool"},{"attributes":{},"id":"32932","type":"HelpTool"},{"attributes":{},"id":"32879","type":"LinearScale"},{"attributes":{},"id":"32961","type":"BasicTickFormatter"},{"attributes":{},"id":"32930","type":"SaveTool"},{"attributes":{},"id":"32949","type":"BasicTickFormatter"},{"attributes":{},"id":"32973","type":"Selection"},{"attributes":{},"id":"32877","type":"DataRange1d"},{"attributes":{},"id":"32962","type":"UnionRenderers"},{"attributes":{},"id":"32848","type":"BasicTicker"},{"attributes":{"children":[{"id":"32978"},{"id":"32976"}]},"id":"32979","type":"Column"}],"root_ids":["32979"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"96e4881c-7bcc-4571-997c-ae63cd7baf7c","root_ids":["32979"],"roots":{"32979":"1e882912-6765-48f6-b0c2-db0a94d39466"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();