(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("bac05921-c9d1-44bd-b7a3-489ab8917bd2");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'bac05921-c9d1-44bd-b7a3-489ab8917bd2' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"e263bcfb-6c89-467a-b20a-87553b452ebd":{"roots":{"references":[{"attributes":{"axis":{"id":"41953"},"ticker":null},"id":"41956","type":"Grid"},{"attributes":{"active_drag":{"id":"41991"},"active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"41961"},{"id":"41962"},{"id":"41963"},{"id":"41964"},{"id":"41965"},{"id":"41966"},{"id":"41990"},{"id":"41991"}]},"id":"41968","type":"Toolbar"},{"attributes":{"overlay":{"id":"41967"}},"id":"41963","type":"BoxZoomTool"},{"attributes":{"axis":{"id":"41957"},"dimension":1,"ticker":null},"id":"41960","type":"Grid"},{"attributes":{},"id":"41954","type":"BasicTicker"},{"attributes":{"source":{"id":"41985"}},"id":"41989","type":"CDSView"},{"attributes":{"fill_color":{"value":"red"},"line_color":{"value":"red"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"41986","type":"Circle"},{"attributes":{},"id":"42005","type":"Selection"},{"attributes":{"data":{"xs":[],"ys":[]},"selected":{"id":"42001"},"selection_policy":{"id":"42000"}},"id":"41975","type":"ColumnDataSource"},{"attributes":{"renderers":[{"id":"41978"},{"id":"41983"}],"vertex_renderer":null},"id":"41990","type":"PolyDrawTool"},{"attributes":{"below":[{"id":"41953"}],"center":[{"id":"41956"},{"id":"41960"}],"left":[{"id":"41957"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"41978"},{"id":"41983"},{"id":"41988"}],"title":{"id":"41943"},"toolbar":{"id":"41968"},"x_range":{"id":"41945"},"x_scale":{"id":"41949"},"y_range":{"id":"41947"},"y_scale":{"id":"41951"}},"id":"41942","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"41965","type":"ResetTool"},{"attributes":{"end":10},"id":"41947","type":"Range1d"},{"attributes":{"data_source":{"id":"41975"},"glyph":{"id":"41976"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"41977"},"selection_glyph":null,"view":{"id":"41979"}},"id":"41978","type":"GlyphRenderer"},{"attributes":{},"id":"41962","type":"WheelZoomTool"},{"attributes":{"fill_alpha":{"value":0.4},"fill_color":{"value":"green"},"line_color":{"value":"#1f77b4"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"41981","type":"Patches"},{"attributes":{},"id":"41966","type":"HelpTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"41977","type":"Patches"},{"attributes":{},"id":"41999","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[],"y":[]},"selected":{"id":"42005"},"selection_policy":{"id":"42004"}},"id":"41985","type":"ColumnDataSource"},{"attributes":{},"id":"41964","type":"SaveTool"},{"attributes":{"source":{"id":"41975"}},"id":"41979","type":"CDSView"},{"attributes":{},"id":"42001","type":"Selection"},{"attributes":{},"id":"42003","type":"Selection"},{"attributes":{},"id":"42004","type":"UnionRenderers"},{"attributes":{"source":{"id":"41980"}},"id":"41984","type":"CDSView"},{"attributes":{"text":"Poly Edit Tool"},"id":"41943","type":"Title"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"red"},"line_alpha":{"value":0.1},"line_color":{"value":"red"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"41987","type":"Circle"},{"attributes":{"renderers":[{"id":"41978"},{"id":"41983"}],"vertex_renderer":{"id":"41988"}},"id":"41991","type":"PolyEditTool"},{"attributes":{},"id":"42002","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"41985"},"glyph":{"id":"41986"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"41987"},"selection_glyph":null,"view":{"id":"41989"}},"id":"41988","type":"GlyphRenderer"},{"attributes":{"data":{"xs":[[1,2,3]],"ys":[[3,5,2]]},"selected":{"id":"42003"},"selection_policy":{"id":"42002"}},"id":"41980","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"41980"},"glyph":{"id":"41981"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"41982"},"selection_glyph":null,"view":{"id":"41984"}},"id":"41983","type":"GlyphRenderer"},{"attributes":{},"id":"41961","type":"PanTool"},{"attributes":{},"id":"42000","type":"UnionRenderers"},{"attributes":{},"id":"41951","type":"LinearScale"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"41967","type":"BoxAnnotation"},{"attributes":{},"id":"41949","type":"LinearScale"},{"attributes":{"formatter":{"id":"41997"},"ticker":{"id":"41954"}},"id":"41953","type":"LinearAxis"},{"attributes":{"fill_alpha":{"value":0.4},"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"41976","type":"Patches"},{"attributes":{},"id":"41997","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"green"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"41982","type":"Patches"},{"attributes":{},"id":"41958","type":"BasicTicker"},{"attributes":{"formatter":{"id":"41999"},"ticker":{"id":"41958"}},"id":"41957","type":"LinearAxis"},{"attributes":{"end":10},"id":"41945","type":"Range1d"}],"root_ids":["41942"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"e263bcfb-6c89-467a-b20a-87553b452ebd","root_ids":["41942"],"roots":{"41942":"bac05921-c9d1-44bd-b7a3-489ab8917bd2"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();