(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("f5765f12-e808-4c48-9cdf-05814ea00b07");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'f5765f12-e808-4c48-9cdf-05814ea00b07' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"7bdd1e1f-36f1-4eb1-9c83-73b0fe71ca07":{"roots":{"references":[{"attributes":{"formatter":{"id":"29268"},"ticker":{"id":"29269"}},"id":"29270","type":"LinearAxis"},{"attributes":{"dimension":"lat"},"id":"29269","type":"MercatorTicker"},{"attributes":{"data_source":{"id":"29282"},"glyph":{"id":"29284"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"29285"},"selection_glyph":null,"view":{"id":"29287"}},"id":"29286","type":"GlyphRenderer"},{"attributes":{},"id":"29259","type":"Range1d"},{"attributes":{"formatter":{"id":"29263"},"ticker":{"id":"29264"}},"id":"29265","type":"LinearAxis"},{"attributes":{},"id":"29289","type":"LinearScale"},{"attributes":{},"id":"29273","type":"PanTool"},{"attributes":{"api_key":"TUlTU0lOR19BUElfS0VZ","below":[{"id":"29265"}],"left":[{"id":"29270"}],"map_options":{"id":"29255"},"renderers":[{"id":"29286"}],"title":{"id":"29257"},"toolbar":{"id":"29277"},"x_range":{"id":"29258"},"x_scale":{"id":"29288"},"y_range":{"id":"29259"},"y_scale":{"id":"29289"}},"id":"29256","subtype":"GMap","type":"GMapPlot"},{"attributes":{"lat":30.2861,"lng":-97.7394,"zoom":11},"id":"29255","type":"GMapOptions"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"29273"},{"id":"29274"},{"id":"29275"},{"id":"29276"}]},"id":"29277","type":"Toolbar"},{"attributes":{"dimension":"lon"},"id":"29264","type":"MercatorTicker"},{"attributes":{"dimension":"lat"},"id":"29268","type":"MercatorTickFormatter"},{"attributes":{},"id":"29275","type":"ResetTool"},{"attributes":{"source":{"id":"29282"}},"id":"29287","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"blue"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":15},"x":{"field":"lon"},"y":{"field":"lat"}},"id":"29285","type":"Circle"},{"attributes":{"text":"Austin"},"id":"29257","type":"Title"},{"attributes":{"data":{"lat":[30.29,30.2,30.29],"lon":[-97.7,-97.74,-97.78]},"selected":{"id":"29292"},"selection_policy":{"id":"29291"}},"id":"29282","type":"ColumnDataSource"},{"attributes":{},"id":"29276","type":"HelpTool"},{"attributes":{},"id":"29258","type":"Range1d"},{"attributes":{},"id":"29291","type":"UnionRenderers"},{"attributes":{},"id":"29288","type":"LinearScale"},{"attributes":{},"id":"29274","type":"WheelZoomTool"},{"attributes":{},"id":"29292","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.8},"fill_color":{"value":"blue"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":15},"x":{"field":"lon"},"y":{"field":"lat"}},"id":"29284","type":"Circle"},{"attributes":{"dimension":"lon"},"id":"29263","type":"MercatorTickFormatter"}],"root_ids":["29256"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"7bdd1e1f-36f1-4eb1-9c83-73b0fe71ca07","root_ids":["29256"],"roots":{"29256":"f5765f12-e808-4c48-9cdf-05814ea00b07"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();