(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("64acd37a-2942-421a-92bd-406ad71a65cc");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '64acd37a-2942-421a-92bd-406ad71a65cc' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"35958fc6-8842-4983-80e2-ad2ba3fd26eb":{"roots":{"references":[{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"35963","type":"Line"},{"attributes":{},"id":"35950","type":"SaveTool"},{"attributes":{"formatter":{"id":"35974"},"ticker":{"id":"35940"}},"id":"35939","type":"LinearAxis"},{"attributes":{},"id":"35937","type":"LogScale"},{"attributes":{},"id":"35935","type":"LinearScale"},{"attributes":{"data_source":{"id":"35961"},"glyph":{"id":"35962"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"35963"},"selection_glyph":null,"view":{"id":"35965"}},"id":"35964","type":"GlyphRenderer"},{"attributes":{"below":[{"id":"35939"}],"center":[{"id":"35942"},{"id":"35946"}],"left":[{"id":"35943"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"35964"},{"id":"35969"}],"title":{"id":"35971"},"toolbar":{"id":"35954"},"x_range":{"id":"35931"},"x_scale":{"id":"35935"},"y_range":{"id":"35933"},"y_scale":{"id":"35937"}},"id":"35930","subtype":"Figure","type":"Plot"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"35953","type":"BoxAnnotation"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"35947"},{"id":"35948"},{"id":"35949"},{"id":"35950"},{"id":"35951"},{"id":"35952"}]},"id":"35954","type":"Toolbar"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"white"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":8},"x":{"field":"x"},"y":{"field":"y"}},"id":"35968","type":"Circle"},{"attributes":{"axis":{"id":"35943"},"dimension":1,"ticker":null},"id":"35946","type":"Grid"},{"attributes":{},"id":"35974","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[0.1,0.5,1.0,1.5,2.0,2.5,3.0],"y":[1.2589254117941673,3.1622776601683795,10.0,31.622776601683793,100.0,316.22776601683796,1000.0]},"selected":{"id":"35978"},"selection_policy":{"id":"35977"}},"id":"35961","type":"ColumnDataSource"},{"attributes":{},"id":"35933","type":"DataRange1d"},{"attributes":{},"id":"35952","type":"HelpTool"},{"attributes":{},"id":"35979","type":"UnionRenderers"},{"attributes":{"num_minor_ticks":10},"id":"35944","type":"LogTicker"},{"attributes":{},"id":"35951","type":"ResetTool"},{"attributes":{"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"35962","type":"Line"},{"attributes":{"ticker":null},"id":"35976","type":"LogTickFormatter"},{"attributes":{"overlay":{"id":"35953"}},"id":"35949","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"35976"},"ticker":{"id":"35944"}},"id":"35943","type":"LogAxis"},{"attributes":{"fill_color":{"value":"white"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":8},"x":{"field":"x"},"y":{"field":"y"}},"id":"35967","type":"Circle"},{"attributes":{},"id":"35977","type":"UnionRenderers"},{"attributes":{},"id":"35940","type":"BasicTicker"},{"attributes":{"axis":{"id":"35939"},"ticker":null},"id":"35942","type":"Grid"},{"attributes":{"source":{"id":"35966"}},"id":"35970","type":"CDSView"},{"attributes":{},"id":"35980","type":"Selection"},{"attributes":{"data_source":{"id":"35966"},"glyph":{"id":"35967"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"35968"},"selection_glyph":null,"view":{"id":"35970"}},"id":"35969","type":"GlyphRenderer"},{"attributes":{},"id":"35948","type":"WheelZoomTool"},{"attributes":{},"id":"35931","type":"DataRange1d"},{"attributes":{"source":{"id":"35961"}},"id":"35965","type":"CDSView"},{"attributes":{"data":{"x":[0.1,0.5,1.0,1.5,2.0,2.5,3.0],"y":[1.2589254117941673,3.1622776601683795,10.0,31.622776601683793,100.0,316.22776601683796,1000.0]},"selected":{"id":"35980"},"selection_policy":{"id":"35979"}},"id":"35966","type":"ColumnDataSource"},{"attributes":{},"id":"35978","type":"Selection"},{"attributes":{},"id":"35947","type":"PanTool"},{"attributes":{"text":""},"id":"35971","type":"Title"}],"root_ids":["35930"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"35958fc6-8842-4983-80e2-ad2ba3fd26eb","root_ids":["35930"],"roots":{"35930":"64acd37a-2942-421a-92bd-406ad71a65cc"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();