(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("803bc58e-5b37-472e-97e6-54a789b23be2");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '803bc58e-5b37-472e-97e6-54a789b23be2' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"99ee90d3-7899-4775-82bd-d8b782232465":{"roots":{"references":[{"attributes":{"renderers":[{"id":"41895"}],"vertex_renderer":null},"id":"41898","type":"PolyDrawTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"41879","type":"BoxAnnotation"},{"attributes":{},"id":"41904","type":"BasicTickFormatter"},{"attributes":{},"id":"41870","type":"BasicTicker"},{"attributes":{"active_drag":{"id":"41897"},"active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"41873"},{"id":"41874"},{"id":"41875"},{"id":"41876"},{"id":"41877"},{"id":"41878"},{"id":"41897"},{"id":"41898"}]},"id":"41880","type":"Toolbar"},{"attributes":{"data_source":{"id":"41892"},"glyph":{"id":"41893"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"41894"},"selection_glyph":null,"view":{"id":"41896"}},"id":"41895","type":"GlyphRenderer"},{"attributes":{"renderers":[{"id":"41890"}],"vertex_renderer":null},"id":"41897","type":"PolyDrawTool"},{"attributes":{"formatter":{"id":"41904"},"ticker":{"id":"41866"}},"id":"41865","type":"LinearAxis"},{"attributes":{},"id":"41906","type":"BasicTickFormatter"},{"attributes":{},"id":"41863","type":"LinearScale"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"red"},"line_width":{"value":5},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"41894","type":"MultiLine"},{"attributes":{"data_source":{"id":"41887"},"glyph":{"id":"41888"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"41889"},"selection_glyph":null,"view":{"id":"41891"}},"id":"41890","type":"GlyphRenderer"},{"attributes":{},"id":"41907","type":"UnionRenderers"},{"attributes":{},"id":"41908","type":"Selection"},{"attributes":{"axis":{"id":"41869"},"dimension":1,"ticker":null},"id":"41872","type":"Grid"},{"attributes":{"formatter":{"id":"41906"},"ticker":{"id":"41870"}},"id":"41869","type":"LinearAxis"},{"attributes":{"overlay":{"id":"41879"}},"id":"41875","type":"BoxZoomTool"},{"attributes":{},"id":"41878","type":"HelpTool"},{"attributes":{"source":{"id":"41892"}},"id":"41896","type":"CDSView"},{"attributes":{},"id":"41866","type":"BasicTicker"},{"attributes":{"end":10},"id":"41857","type":"Range1d"},{"attributes":{"end":10},"id":"41859","type":"Range1d"},{"attributes":{"fill_alpha":{"value":0.4},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.4},"line_color":{"value":"#1f77b4"},"line_width":{"value":0},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"41888","type":"Patches"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_width":{"value":0},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"41889","type":"Patches"},{"attributes":{"axis":{"id":"41865"},"ticker":null},"id":"41868","type":"Grid"},{"attributes":{},"id":"41874","type":"WheelZoomTool"},{"attributes":{},"id":"41910","type":"Selection"},{"attributes":{},"id":"41877","type":"ResetTool"},{"attributes":{"data":{"xs":[[1,9]],"ys":[[5,5]]},"selected":{"id":"41910"},"selection_policy":{"id":"41909"}},"id":"41892","type":"ColumnDataSource"},{"attributes":{},"id":"41909","type":"UnionRenderers"},{"attributes":{"data":{"xs":[[2,5,8]],"ys":[[2,8,2]]},"selected":{"id":"41908"},"selection_policy":{"id":"41907"}},"id":"41887","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.4},"line_color":{"value":"red"},"line_width":{"value":5},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"41893","type":"MultiLine"},{"attributes":{},"id":"41873","type":"PanTool"},{"attributes":{"source":{"id":"41887"}},"id":"41891","type":"CDSView"},{"attributes":{"below":[{"id":"41865"}],"center":[{"id":"41868"},{"id":"41872"}],"left":[{"id":"41869"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"41890"},{"id":"41895"}],"title":{"id":"41855"},"toolbar":{"id":"41880"},"x_range":{"id":"41857"},"x_scale":{"id":"41861"},"y_range":{"id":"41859"},"y_scale":{"id":"41863"}},"id":"41854","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"41876","type":"SaveTool"},{"attributes":{},"id":"41861","type":"LinearScale"},{"attributes":{"text":"Poly Draw Tool"},"id":"41855","type":"Title"}],"root_ids":["41854"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"99ee90d3-7899-4775-82bd-d8b782232465","root_ids":["41854"],"roots":{"41854":"803bc58e-5b37-472e-97e6-54a789b23be2"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();