(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("0a6a3b01-9099-49ef-bfc1-4ed97b98ac03");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '0a6a3b01-9099-49ef-bfc1-4ed97b98ac03' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"69850244-320f-4fa4-b522-5aefb297ef1b":{"roots":{"references":[{"attributes":{},"id":"41776","type":"LinearScale"},{"attributes":{"data":{"color":["red","green","yellow"],"x":[1,5,9],"y":[1,5,9]},"selected":{"id":"41808"},"selection_policy":{"id":"41807"}},"id":"41787","type":"ColumnDataSource"},{"attributes":{"empty_value":"black","renderers":[{"id":"41791"}]},"id":"41798","type":"PointDrawTool"},{"attributes":{"text":"Point Draw Tool"},"id":"41768","type":"Title"},{"attributes":{},"id":"41813","type":"StringEditor"},{"attributes":{"axis":{"id":"41778"},"ticker":null},"id":"41781","type":"Grid"},{"attributes":{},"id":"41779","type":"BasicTicker"},{"attributes":{"editor":{"id":"41813"},"field":"color","formatter":{"id":"41814"},"title":"color"},"id":"41795","type":"TableColumn"},{"attributes":{},"id":"41806","type":"BasicTickFormatter"},{"attributes":{"background_fill_color":"lightgrey","below":[{"id":"41778"}],"center":[{"id":"41781"},{"id":"41785"}],"left":[{"id":"41782"}],"renderers":[{"id":"41791"}],"title":{"id":"41768"},"toolbar":{"id":"41786"},"x_range":{"id":"41770"},"x_scale":{"id":"41774"},"y_range":{"id":"41772"},"y_scale":{"id":"41776"}},"id":"41767","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"41804"},"ticker":{"id":"41779"}},"id":"41778","type":"LinearAxis"},{"attributes":{"source":{"id":"41787"}},"id":"41792","type":"CDSView"},{"attributes":{},"id":"41811","type":"StringEditor"},{"attributes":{"children":[{"id":"41767"},{"id":"41796"}]},"id":"41801","type":"Column"},{"attributes":{"axis":{"id":"41782"},"dimension":1,"ticker":null},"id":"41785","type":"Grid"},{"attributes":{"end":10},"id":"41772","type":"Range1d"},{"attributes":{},"id":"41809","type":"StringEditor"},{"attributes":{},"id":"41804","type":"BasicTickFormatter"},{"attributes":{},"id":"41808","type":"Selection"},{"attributes":{"editor":{"id":"41809"},"field":"x","formatter":{"id":"41810"},"title":"x"},"id":"41793","type":"TableColumn"},{"attributes":{"columns":[{"id":"41793"},{"id":"41794"},{"id":"41795"}],"editable":true,"height":200,"source":{"id":"41787"},"view":{"id":"41797"}},"id":"41796","type":"DataTable"},{"attributes":{},"id":"41810","type":"StringFormatter"},{"attributes":{"fill_color":{"field":"color"},"line_color":{"field":"color"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"41789","type":"Scatter"},{"attributes":{},"id":"41774","type":"LinearScale"},{"attributes":{"editor":{"id":"41811"},"field":"y","formatter":{"id":"41812"},"title":"y"},"id":"41794","type":"TableColumn"},{"attributes":{"source":{"id":"41787"}},"id":"41797","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"color"},"line_alpha":{"value":0.1},"line_color":{"field":"color"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"41790","type":"Scatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":{"id":"41798"},"tools":[{"id":"41798"}]},"id":"41786","type":"Toolbar"},{"attributes":{"end":10},"id":"41770","type":"Range1d"},{"attributes":{},"id":"41807","type":"UnionRenderers"},{"attributes":{},"id":"41814","type":"StringFormatter"},{"attributes":{},"id":"41783","type":"BasicTicker"},{"attributes":{},"id":"41812","type":"StringFormatter"},{"attributes":{"data_source":{"id":"41787"},"glyph":{"id":"41789"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"41790"},"selection_glyph":null,"view":{"id":"41792"}},"id":"41791","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"41806"},"ticker":{"id":"41783"}},"id":"41782","type":"LinearAxis"}],"root_ids":["41801"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"69850244-320f-4fa4-b522-5aefb297ef1b","root_ids":["41801"],"roots":{"41801":"0a6a3b01-9099-49ef-bfc1-4ed97b98ac03"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();