(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("c5a5adfe-f8c1-4453-a7b1-6ff03ed731d8");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'c5a5adfe-f8c1-4453-a7b1-6ff03ed731d8' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"feec0e9b-acc9-4ef6-8a0b-f8fe1d344ce7":{"roots":{"references":[{"attributes":{"source":{"id":"36267"}},"id":"36271","type":"CDSView"},{"attributes":{"num_minor_ticks":10},"id":"36206","type":"LogTicker"},{"attributes":{},"id":"36230","type":"Selection"},{"attributes":{"data_source":{"id":"36308"},"glyph":{"id":"36309"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"36310"},"selection_glyph":null,"view":{"id":"36312"}},"id":"36311","type":"GlyphRenderer"},{"attributes":{"fill_color":{"value":"red"},"line_color":{"value":"red"},"size":{"units":"screen","value":6},"x":{"field":"x"},"y":{"field":"y"}},"id":"36288","type":"Circle"},{"attributes":{},"id":"36229","type":"UnionRenderers"},{"attributes":{"source":{"id":"36308"}},"id":"36312","type":"CDSView"},{"attributes":{"text":"log axis example"},"id":"36191","type":"Title"},{"attributes":{"fill_color":{"value":"white"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":8},"x":{"field":"x"},"y":{"field":"y"}},"id":"36235","type":"Circle"},{"attributes":{"data":{"x":[0.1,0.5,1.0,1.5,2.0,2.5,3.0],"y":[1.023292992280754,1.7782794100389228,10.0,177.82794100389228,10000.0,1778279.410038923,1000000000.0]},"selected":{"id":"36329"},"selection_policy":{"id":"36328"}},"id":"36308","type":"ColumnDataSource"},{"attributes":{"source":{"id":"36219"}},"id":"36223","type":"CDSView"},{"attributes":{"line_alpha":0.1,"line_color":"red","x":{"field":"x"},"y":{"field":"y"}},"id":"36269","type":"Line"},{"attributes":{"line_alpha":0.1,"line_color":"orange","line_dash":[4,4],"x":{"field":"x"},"y":{"field":"y"}},"id":"36310","type":"Line"},{"attributes":{"line_color":"red","x":{"field":"x"},"y":{"field":"y"}},"id":"36268","type":"Line"},{"attributes":{"axis":{"id":"36201"},"ticker":null},"id":"36204","type":"Grid"},{"attributes":{"source":{"id":"36249"}},"id":"36253","type":"CDSView"},{"attributes":{},"id":"36264","type":"Selection"},{"attributes":{},"id":"36226","type":"BasicTickFormatter"},{"attributes":{"axis_label":"particles","formatter":{"id":"36228"},"ticker":{"id":"36206"}},"id":"36205","type":"LogAxis"},{"attributes":{"label":{"value":"y=10^x"},"renderers":[{"id":"36270"},{"id":"36290"}]},"id":"36286","type":"LegendItem"},{"attributes":{},"id":"36202","type":"BasicTicker"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"white"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":8},"x":{"field":"x"},"y":{"field":"y"}},"id":"36236","type":"Circle"},{"attributes":{},"id":"36197","type":"LinearScale"},{"attributes":{"source":{"id":"36287"}},"id":"36291","type":"CDSView"},{"attributes":{"label":{"value":"y=10^x^2"},"renderers":[{"id":"36311"}]},"id":"36331","type":"LegendItem"},{"attributes":{"data_source":{"id":"36249"},"glyph":{"id":"36250"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"36251"},"selection_glyph":null,"view":{"id":"36253"}},"id":"36252","type":"GlyphRenderer"},{"attributes":{"items":[{"id":"36233"},{"id":"36266"},{"id":"36286"},{"id":"36331"}]},"id":"36232","type":"Legend"},{"attributes":{},"id":"36199","type":"LogScale"},{"attributes":{"label":{"value":"y=x"},"renderers":[{"id":"36222"},{"id":"36237"}]},"id":"36233","type":"LegendItem"},{"attributes":{},"id":"36329","type":"Selection"},{"attributes":{"source":{"id":"36234"}},"id":"36238","type":"CDSView"},{"attributes":{},"id":"36193","type":"DataRange1d"},{"attributes":{"data":{"x":[0.1,0.5,1.0,1.5,2.0,2.5,3.0],"y":[1.2589254117941673,3.1622776601683795,10.0,31.622776601683793,100.0,316.22776601683796,1000.0]},"selected":{"id":"36284"},"selection_policy":{"id":"36283"}},"id":"36267","type":"ColumnDataSource"},{"attributes":{},"id":"36305","type":"UnionRenderers"},{"attributes":{"data":{"x":[0.1,0.5,1.0,1.5,2.0,2.5,3.0],"y":[0.1,0.5,1.0,1.5,2.0,2.5,3.0]},"selected":{"id":"36247"},"selection_policy":{"id":"36246"}},"id":"36234","type":"ColumnDataSource"},{"attributes":{},"id":"36283","type":"UnionRenderers"},{"attributes":{},"id":"36263","type":"UnionRenderers"},{"attributes":{"overlay":{"id":"36213"}},"id":"36210","type":"BoxZoomTool"},{"attributes":{"axis_label":"sections","formatter":{"id":"36226"},"ticker":{"id":"36202"}},"id":"36201","type":"LinearAxis"},{"attributes":{},"id":"36211","type":"ResetTool"},{"attributes":{"data_source":{"id":"36234"},"glyph":{"id":"36235"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"36236"},"selection_glyph":null,"view":{"id":"36238"}},"id":"36237","type":"GlyphRenderer"},{"attributes":{"line_color":"#1f77b4","line_width":3,"x":{"field":"x"},"y":{"field":"y"}},"id":"36250","type":"Line"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","line_width":3,"x":{"field":"x"},"y":{"field":"y"}},"id":"36251","type":"Line"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"red"},"line_alpha":{"value":0.1},"line_color":{"value":"red"},"size":{"units":"screen","value":6},"x":{"field":"x"},"y":{"field":"y"}},"id":"36289","type":"Circle"},{"attributes":{"line_color":"orange","line_dash":[4,4],"x":{"field":"x"},"y":{"field":"y"}},"id":"36309","type":"Line"},{"attributes":{"data_source":{"id":"36219"},"glyph":{"id":"36220"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"36221"},"selection_glyph":null,"view":{"id":"36223"}},"id":"36222","type":"GlyphRenderer"},{"attributes":{"data":{"x":[0.1,0.5,1.0,1.5,2.0,2.5,3.0],"y":[0.010000000000000002,0.25,1.0,2.25,4.0,6.25,9.0]},"selected":{"id":"36264"},"selection_policy":{"id":"36263"}},"id":"36249","type":"ColumnDataSource"},{"attributes":{"below":[{"id":"36201"}],"center":[{"id":"36204"},{"id":"36208"},{"id":"36232"}],"left":[{"id":"36205"}],"renderers":[{"id":"36222"},{"id":"36237"},{"id":"36252"},{"id":"36270"},{"id":"36290"},{"id":"36311"}],"title":{"id":"36191"},"toolbar":{"id":"36214"},"x_range":{"id":"36193"},"x_scale":{"id":"36197"},"y_range":{"id":"36195"},"y_scale":{"id":"36199"}},"id":"36190","subtype":"Figure","type":"Plot"},{"attributes":{"data_source":{"id":"36267"},"glyph":{"id":"36268"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"36269"},"selection_glyph":null,"view":{"id":"36271"}},"id":"36270","type":"GlyphRenderer"},{"attributes":{},"id":"36306","type":"Selection"},{"attributes":{},"id":"36212","type":"SaveTool"},{"attributes":{},"id":"36328","type":"UnionRenderers"},{"attributes":{"data":{"x":[0.1,0.5,1.0,1.5,2.0,2.5,3.0],"y":[1.2589254117941673,3.1622776601683795,10.0,31.622776601683793,100.0,316.22776601683796,1000.0]},"selected":{"id":"36306"},"selection_policy":{"id":"36305"}},"id":"36287","type":"ColumnDataSource"},{"attributes":{},"id":"36246","type":"UnionRenderers"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"36221","type":"Line"},{"attributes":{},"id":"36247","type":"Selection"},{"attributes":{"data_source":{"id":"36287"},"glyph":{"id":"36288"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"36289"},"selection_glyph":null,"view":{"id":"36291"}},"id":"36290","type":"GlyphRenderer"},{"attributes":{"data":{"x":[0.1,0.5,1.0,1.5,2.0,2.5,3.0],"y":[0.1,0.5,1.0,1.5,2.0,2.5,3.0]},"selected":{"id":"36230"},"selection_policy":{"id":"36229"}},"id":"36219","type":"ColumnDataSource"},{"attributes":{"end":100000000000,"start":0.001},"id":"36195","type":"Range1d"},{"attributes":{"label":{"value":"y=x^2"},"renderers":[{"id":"36252"}]},"id":"36266","type":"LegendItem"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"36209"},{"id":"36210"},{"id":"36211"},{"id":"36212"}]},"id":"36214","type":"Toolbar"},{"attributes":{"axis":{"id":"36205"},"dimension":1,"ticker":null},"id":"36208","type":"Grid"},{"attributes":{"ticker":null},"id":"36228","type":"LogTickFormatter"},{"attributes":{},"id":"36284","type":"Selection"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"36213","type":"BoxAnnotation"},{"attributes":{"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"36220","type":"Line"},{"attributes":{},"id":"36209","type":"PanTool"}],"root_ids":["36190"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"feec0e9b-acc9-4ef6-8a0b-f8fe1d344ce7","root_ids":["36190"],"roots":{"36190":"c5a5adfe-f8c1-4453-a7b1-6ff03ed731d8"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();