(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("af63f032-bcc2-49a6-b3d0-5351acda7b7d");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'af63f032-bcc2-49a6-b3d0-5351acda7b7d' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"e7508be0-93a1-47b4-a4a3-60dd96d40f2e":{"roots":{"references":[{"attributes":{"formatter":{"id":"34094"},"ticker":{"id":"34065"}},"id":"34064","type":"LinearAxis"},{"attributes":{},"id":"34077","type":"HelpTool"},{"attributes":{},"id":"34065","type":"BasicTicker"},{"attributes":{},"id":"34072","type":"PanTool"},{"attributes":{"axis":{"id":"34064"},"ticker":null},"id":"34067","type":"Grid"},{"attributes":{"source":{"id":"34086"}},"id":"34090","type":"CDSView"},{"attributes":{"angle":{"units":"rad","value":1.0471975511965976},"fill_color":{"value":"#CAB2D6"},"height":{"units":"screen","value":40},"line_color":{"value":"#CAB2D6"},"width":{"units":"data","value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"34087","type":"Rect"},{"attributes":{},"id":"34060","type":"LinearScale"},{"attributes":{},"id":"34094","type":"BasicTickFormatter"},{"attributes":{"angle":{"units":"rad","value":1.0471975511965976},"fill_alpha":{"value":0.1},"fill_color":{"value":"#CAB2D6"},"height":{"units":"screen","value":40},"line_alpha":{"value":0.1},"line_color":{"value":"#CAB2D6"},"width":{"units":"data","value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"34088","type":"Rect"},{"attributes":{"overlay":{"id":"34078"}},"id":"34074","type":"BoxZoomTool"},{"attributes":{"text":""},"id":"34091","type":"Title"},{"attributes":{},"id":"34062","type":"LinearScale"},{"attributes":{},"id":"34076","type":"ResetTool"},{"attributes":{"axis":{"id":"34068"},"dimension":1,"ticker":null},"id":"34071","type":"Grid"},{"attributes":{},"id":"34096","type":"BasicTickFormatter"},{"attributes":{},"id":"34073","type":"WheelZoomTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"34072"},{"id":"34073"},{"id":"34074"},{"id":"34075"},{"id":"34076"},{"id":"34077"}]},"id":"34079","type":"Toolbar"},{"attributes":{"formatter":{"id":"34096"},"ticker":{"id":"34069"}},"id":"34068","type":"LinearAxis"},{"attributes":{},"id":"34075","type":"SaveTool"},{"attributes":{},"id":"34097","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"34086"},"glyph":{"id":"34087"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"34088"},"selection_glyph":null,"view":{"id":"34090"}},"id":"34089","type":"GlyphRenderer"},{"attributes":{"below":[{"id":"34064"}],"center":[{"id":"34067"},{"id":"34071"}],"left":[{"id":"34068"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"34089"}],"title":{"id":"34091"},"toolbar":{"id":"34079"},"x_range":{"id":"34056"},"x_scale":{"id":"34060"},"y_range":{"id":"34058"},"y_scale":{"id":"34062"}},"id":"34055","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"34069","type":"BasicTicker"},{"attributes":{},"id":"34056","type":"DataRange1d"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"34098"},"selection_policy":{"id":"34097"}},"id":"34086","type":"ColumnDataSource"},{"attributes":{},"id":"34098","type":"Selection"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"34078","type":"BoxAnnotation"},{"attributes":{},"id":"34058","type":"DataRange1d"}],"root_ids":["34055"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"e7508be0-93a1-47b4-a4a3-60dd96d40f2e","root_ids":["34055"],"roots":{"34055":"af63f032-bcc2-49a6-b3d0-5351acda7b7d"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();