(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("2c19b150-3451-412d-96df-ad3f2817388a");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '2c19b150-3451-412d-96df-ad3f2817388a' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"973f88d9-0e81-4e6e-af7b-d35c2071993f":{"roots":{"references":[{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"35700","type":"Circle"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"35689","type":"BoxAnnotation"},{"attributes":{"axis":{"id":"35675"},"ticker":null},"id":"35678","type":"Grid"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"35710"},"selection_policy":{"id":"35709"}},"id":"35698","type":"ColumnDataSource"},{"attributes":{},"id":"35709","type":"UnionRenderers"},{"attributes":{"axis":{"id":"35679"},"dimension":1,"ticker":null},"id":"35682","type":"Grid"},{"attributes":{"formatter":{"id":"35708"},"ticker":{"id":"35680"}},"id":"35679","type":"LinearAxis"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"35683"},{"id":"35684"},{"id":"35685"},{"id":"35686"},{"id":"35687"},{"id":"35688"}]},"id":"35690","type":"Toolbar"},{"attributes":{},"id":"35687","type":"ResetTool"},{"attributes":{},"id":"35688","type":"HelpTool"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"35699","type":"Circle"},{"attributes":{"below":[{"id":"35675"}],"center":[{"id":"35678"},{"id":"35682"}],"left":[{"id":"35679"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"35701"}],"title":{"id":"35703"},"toolbar":{"id":"35690"},"x_range":{"id":"35667"},"x_scale":{"id":"35671"},"y_range":{"id":"35697"},"y_scale":{"id":"35673"}},"id":"35666","subtype":"Figure","type":"Plot"},{"attributes":{"text":""},"id":"35703","type":"Title"},{"attributes":{},"id":"35684","type":"WheelZoomTool"},{"attributes":{},"id":"35706","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"35706"},"ticker":{"id":"35676"}},"id":"35675","type":"LinearAxis"},{"attributes":{"overlay":{"id":"35689"}},"id":"35685","type":"BoxZoomTool"},{"attributes":{"data_source":{"id":"35698"},"glyph":{"id":"35699"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"35700"},"selection_glyph":null,"view":{"id":"35702"}},"id":"35701","type":"GlyphRenderer"},{"attributes":{"end":20},"id":"35667","type":"Range1d"},{"attributes":{},"id":"35683","type":"PanTool"},{"attributes":{},"id":"35673","type":"LinearScale"},{"attributes":{},"id":"35686","type":"SaveTool"},{"attributes":{},"id":"35671","type":"LinearScale"},{"attributes":{"end":15},"id":"35697","type":"Range1d"},{"attributes":{},"id":"35676","type":"BasicTicker"},{"attributes":{},"id":"35708","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"35698"}},"id":"35702","type":"CDSView"},{"attributes":{},"id":"35710","type":"Selection"},{"attributes":{},"id":"35680","type":"BasicTicker"}],"root_ids":["35666"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"973f88d9-0e81-4e6e-af7b-d35c2071993f","root_ids":["35666"],"roots":{"35666":"2c19b150-3451-412d-96df-ad3f2817388a"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();