(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("525462a0-cb35-464d-9790-1002350b0370");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '525462a0-cb35-464d-9790-1002350b0370' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"070e33ce-0b41-4c6d-b51a-dc22392500d3":{"roots":{"references":[{"attributes":{"below":[{"id":"33542"}],"center":[{"id":"33545"},{"id":"33549"}],"left":[{"id":"33546"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"33567"}],"title":{"id":"33569"},"toolbar":{"id":"33557"},"x_range":{"id":"33534"},"x_scale":{"id":"33538"},"y_range":{"id":"33536"},"y_scale":{"id":"33540"}},"id":"33533","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"33572"},"ticker":{"id":"33543"}},"id":"33542","type":"LinearAxis"},{"attributes":{"text":""},"id":"33569","type":"Title"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"line_width":{"value":4},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"33566","type":"MultiLine"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"33556","type":"BoxAnnotation"},{"attributes":{},"id":"33543","type":"BasicTicker"},{"attributes":{},"id":"33551","type":"WheelZoomTool"},{"attributes":{},"id":"33547","type":"BasicTicker"},{"attributes":{"source":{"id":"33564"}},"id":"33568","type":"CDSView"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"33550"},{"id":"33551"},{"id":"33552"},{"id":"33553"},{"id":"33554"},{"id":"33555"}]},"id":"33557","type":"Toolbar"},{"attributes":{},"id":"33553","type":"SaveTool"},{"attributes":{"axis":{"id":"33542"},"ticker":null},"id":"33545","type":"Grid"},{"attributes":{},"id":"33550","type":"PanTool"},{"attributes":{},"id":"33540","type":"LinearScale"},{"attributes":{},"id":"33574","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"33574"},"ticker":{"id":"33547"}},"id":"33546","type":"LinearAxis"},{"attributes":{},"id":"33572","type":"BasicTickFormatter"},{"attributes":{},"id":"33536","type":"DataRange1d"},{"attributes":{},"id":"33575","type":"UnionRenderers"},{"attributes":{"line_alpha":{"field":"line_alpha"},"line_color":{"field":"line_color"},"line_width":{"value":4},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"33565","type":"MultiLine"},{"attributes":{"axis":{"id":"33546"},"dimension":1,"ticker":null},"id":"33549","type":"Grid"},{"attributes":{"data":{"line_alpha":[0.8,0.3],"line_color":["firebrick","navy"],"xs":[[1,3,2],[3,4,6,6]],"ys":[[2,1,4],[4,7,8,5]]},"selected":{"id":"33576"},"selection_policy":{"id":"33575"}},"id":"33564","type":"ColumnDataSource"},{"attributes":{},"id":"33555","type":"HelpTool"},{"attributes":{"data_source":{"id":"33564"},"glyph":{"id":"33565"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"33566"},"selection_glyph":null,"view":{"id":"33568"}},"id":"33567","type":"GlyphRenderer"},{"attributes":{},"id":"33538","type":"LinearScale"},{"attributes":{},"id":"33576","type":"Selection"},{"attributes":{"overlay":{"id":"33556"}},"id":"33552","type":"BoxZoomTool"},{"attributes":{},"id":"33534","type":"DataRange1d"},{"attributes":{},"id":"33554","type":"ResetTool"}],"root_ids":["33533"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"070e33ce-0b41-4c6d-b51a-dc22392500d3","root_ids":["33533"],"roots":{"33533":"525462a0-cb35-464d-9790-1002350b0370"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();