(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("13929210-0cec-4448-a7b8-83e388faa63d");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '13929210-0cec-4448-a7b8-83e388faa63d' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"8eba266e-7c6f-4cb2-9973-cf415a7d03e6":{"roots":{"references":[{"attributes":{},"id":"27046","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"27035"},"glyph":{"id":"27036"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"27037"},"selection_glyph":null,"view":{"id":"27039"}},"id":"27038","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"27045"},"ticker":{"id":"27026"}},"id":"27025","type":"LinearAxis"},{"attributes":{},"id":"27018","type":"CategoricalScale"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.5},"line_color":{"value":"#1f77b4"},"top":{"field":"top"},"width":{"value":0.9},"x":{"field":"x"}},"id":"27031","type":"VBar"},{"attributes":{"below":[{"id":"27022"}],"center":[{"id":"27024"},{"id":"27028"}],"left":[{"id":"27025"}],"plot_height":250,"renderers":[{"id":"27033"},{"id":"27038"}],"title":{"id":"27040"},"toolbar":{"id":"27029"},"toolbar_location":null,"x_range":{"id":"27013"},"x_scale":{"id":"27018"},"y_range":{"id":"27016"},"y_scale":{"id":"27020"}},"id":"27014","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"27026","type":"BasicTicker"},{"attributes":{"text":""},"id":"27040","type":"Title"},{"attributes":{},"id":"27023","type":"CategoricalTicker"},{"attributes":{"data":{"top":[10,12,16,9,10,8,12,13,14,14,12,16],"x":[["Q1","jan"],["Q1","feb"],["Q1","mar"],["Q2","apr"],["Q2","may"],["Q2","jun"],["Q3","jul"],["Q3","aug"],["Q3","sep"],["Q4","oct"],["Q4","nov"],["Q4","dec"]]},"selected":{"id":"27047"},"selection_policy":{"id":"27046"}},"id":"27030","type":"ColumnDataSource"},{"attributes":{"start":0},"id":"27016","type":"DataRange1d"},{"attributes":{"axis":{"id":"27025"},"dimension":1,"ticker":null},"id":"27028","type":"Grid"},{"attributes":{},"id":"27020","type":"LinearScale"},{"attributes":{"data":{"x":["Q1","Q2","Q3","Q4"],"y":[12,9,13,14]},"selected":{"id":"27049"},"selection_policy":{"id":"27048"}},"id":"27035","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"27043"},"major_label_orientation":1,"ticker":{"id":"27023"}},"id":"27022","type":"CategoricalAxis"},{"attributes":{"source":{"id":"27035"}},"id":"27039","type":"CDSView"},{"attributes":{},"id":"27047","type":"Selection"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"27029","type":"Toolbar"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"top":{"field":"top"},"width":{"value":0.9},"x":{"field":"x"}},"id":"27032","type":"VBar"},{"attributes":{"axis":{"id":"27022"},"grid_line_color":null,"ticker":null},"id":"27024","type":"Grid"},{"attributes":{"factors":[["Q1","jan"],["Q1","feb"],["Q1","mar"],["Q2","apr"],["Q2","may"],["Q2","jun"],["Q3","jul"],["Q3","aug"],["Q3","sep"],["Q4","oct"],["Q4","nov"],["Q4","dec"]],"range_padding":0.1},"id":"27013","type":"FactorRange"},{"attributes":{"line_color":"red","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"27036","type":"Line"},{"attributes":{"source":{"id":"27030"}},"id":"27034","type":"CDSView"},{"attributes":{},"id":"27045","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"27030"},"glyph":{"id":"27031"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"27032"},"selection_glyph":null,"view":{"id":"27034"}},"id":"27033","type":"GlyphRenderer"},{"attributes":{},"id":"27048","type":"UnionRenderers"},{"attributes":{},"id":"27049","type":"Selection"},{"attributes":{"line_alpha":0.1,"line_color":"red","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"27037","type":"Line"},{"attributes":{},"id":"27043","type":"CategoricalTickFormatter"}],"root_ids":["27014"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"8eba266e-7c6f-4cb2-9973-cf415a7d03e6","root_ids":["27014"],"roots":{"27014":"13929210-0cec-4448-a7b8-83e388faa63d"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();