(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("04b183a5-1ce0-46d5-92b6-99db87dc138c");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '04b183a5-1ce0-46d5-92b6-99db87dc138c' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"d701275f-89a5-476d-ba7a-54c97f1af2f6":{"roots":{"references":[{"attributes":{"below":[{"id":"39214"}],"center":[{"id":"39217"},{"id":"39221"}],"left":[{"id":"39218"}],"plot_height":500,"plot_width":500,"renderers":[{"id":"39239"}],"title":{"id":"39243"},"toolbar":{"id":"39229"},"x_range":{"id":"39206"},"x_scale":{"id":"39210"},"y_range":{"id":"39208"},"y_scale":{"id":"39212"}},"id":"39205","subtype":"Figure","type":"Plot"},{"attributes":{"source":{"id":"39236"}},"id":"39240","type":"CDSView"},{"attributes":{"axis":{"id":"39218"},"dimension":1,"ticker":null},"id":"39221","type":"Grid"},{"attributes":{"text":""},"id":"39243","type":"Title"},{"attributes":{},"id":"39206","type":"DataRange1d"},{"attributes":{"data":{"x":[0,2,4,6,8,10],"y":[6,2,4,10,8,0]},"selected":{"id":"39249"},"selection_policy":{"id":"39248"}},"id":"39236","type":"ColumnDataSource"},{"attributes":{},"id":"39246","type":"BasicTickFormatter"},{"attributes":{},"id":"39208","type":"DataRange1d"},{"attributes":{},"id":"39225","type":"SaveTool"},{"attributes":{},"id":"39249","type":"Selection"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":30},"x":{"field":"x"},"y":{"field":"y"}},"id":"39237","type":"Circle"},{"attributes":{"formatter":{"id":"39241"},"ticker":{"id":"39219"}},"id":"39218","type":"LinearAxis"},{"attributes":{},"id":"39212","type":"LinearScale"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"39228","type":"BoxAnnotation"},{"attributes":{},"id":"39210","type":"LinearScale"},{"attributes":{},"id":"39215","type":"BasicTicker"},{"attributes":{},"id":"39248","type":"UnionRenderers"},{"attributes":{"formatter":{"id":"39246"},"ticker":{"id":"39215"}},"id":"39214","type":"LinearAxis"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"39222"},{"id":"39223"},{"id":"39224"},{"id":"39225"},{"id":"39226"},{"id":"39227"}]},"id":"39229","type":"Toolbar"},{"attributes":{},"id":"39219","type":"BasicTicker"},{"attributes":{"overlay":{"id":"39228"}},"id":"39224","type":"BoxZoomTool"},{"attributes":{},"id":"39223","type":"WheelZoomTool"},{"attributes":{},"id":"39222","type":"PanTool"},{"attributes":{},"id":"39227","type":"HelpTool"},{"attributes":{"data_source":{"id":"39236"},"glyph":{"id":"39237"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"39238"},"selection_glyph":null,"view":{"id":"39240"}},"id":"39239","type":"GlyphRenderer"},{"attributes":{"axis":{"id":"39214"},"ticker":null},"id":"39217","type":"Grid"},{"attributes":{},"id":"39226","type":"ResetTool"},{"attributes":{"code":"\\n    return Math.floor(tick) + \\" + \\" + (tick % 1).toFixed(2)\\n"},"id":"39241","type":"FuncTickFormatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":30},"x":{"field":"x"},"y":{"field":"y"}},"id":"39238","type":"Circle"}],"root_ids":["39205"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"d701275f-89a5-476d-ba7a-54c97f1af2f6","root_ids":["39205"],"roots":{"39205":"04b183a5-1ce0-46d5-92b6-99db87dc138c"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();