(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("0a3b9748-43af-4a7e-a548-4323215a5ad4");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '0a3b9748-43af-4a7e-a548-4323215a5ad4' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"80a89966-c8a8-46f6-8577-367cd52262a0":{"roots":{"references":[{"attributes":{"fill_color":{"value":"#fee8c8"},"height":{"value":0.9},"left":{"expr":{"id":"26522"}},"line_color":{"value":"#fee8c8"},"right":{"expr":{"id":"26523"}},"y":{"field":"fruits"}},"id":"26557","type":"HBar"},{"attributes":{},"id":"26458","type":"HelpTool"},{"attributes":{"label":{"value":"2016 exports"},"renderers":[{"id":"26492"}]},"id":"26502","type":"LegendItem"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#e34a33"},"height":{"value":0.9},"left":{"expr":{"id":"26518"}},"line_alpha":{"value":0.1},"line_color":{"value":"#e34a33"},"right":{"expr":{"id":"26519"}},"y":{"field":"fruits"}},"id":"26526","type":"HBar"},{"attributes":{"factors":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"],"range_padding":0.1},"id":"26440","type":"FactorRange"},{"attributes":{},"id":"26485","type":"Selection"},{"attributes":{"axis":{"id":"26450"},"dimension":1,"grid_line_color":null,"ticker":null},"id":"26452","type":"Grid"},{"attributes":{"fields":["2015","2016"]},"id":"26522","type":"Stack"},{"attributes":{"data_source":{"id":"26467"},"glyph":{"id":"26475"},"hover_glyph":null,"muted_glyph":null,"name":"2015","nonselection_glyph":{"id":"26476"},"selection_glyph":null,"view":{"id":"26478"}},"id":"26477","type":"GlyphRenderer"},{"attributes":{},"id":"26537","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#43a2ca"},"height":{"value":0.9},"left":{"expr":{"id":"26468"}},"line_alpha":{"value":0.1},"line_color":{"value":"#43a2ca"},"right":{"expr":{"id":"26469"}},"y":{"field":"fruits"}},"id":"26476","type":"HBar"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#e0f3db"},"height":{"value":0.9},"left":{"expr":{"id":"26472"}},"line_alpha":{"value":0.1},"line_color":{"value":"#e0f3db"},"right":{"expr":{"id":"26473"}},"y":{"field":"fruits"}},"id":"26505","type":"HBar"},{"attributes":{"label":{"value":"2015 imports"},"renderers":[{"id":"26527"}]},"id":"26539","type":"LegendItem"},{"attributes":{"fill_color":{"value":"#a8ddb5"},"height":{"value":0.9},"left":{"expr":{"id":"26470"}},"line_color":{"value":"#a8ddb5"},"right":{"expr":{"id":"26471"}},"y":{"field":"fruits"}},"id":"26490","type":"HBar"},{"attributes":{"source":{"id":"26517"}},"id":"26560","type":"CDSView"},{"attributes":{},"id":"26453","type":"PanTool"},{"attributes":{"source":{"id":"26517"}},"id":"26528","type":"CDSView"},{"attributes":{"label":{"value":"2015 exports"},"renderers":[{"id":"26477"}]},"id":"26488","type":"LegendItem"},{"attributes":{"fill_color":{"value":"#fdbb84"},"height":{"value":0.9},"left":{"expr":{"id":"26520"}},"line_color":{"value":"#fdbb84"},"right":{"expr":{"id":"26521"}},"y":{"field":"fruits"}},"id":"26541","type":"HBar"},{"attributes":{"label":{"value":"2016 imports"},"renderers":[{"id":"26543"}]},"id":"26555","type":"LegendItem"},{"attributes":{"fields":["2015","2016"]},"id":"26521","type":"Stack"},{"attributes":{"fill_color":{"value":"#43a2ca"},"height":{"value":0.9},"left":{"expr":{"id":"26468"}},"line_color":{"value":"#43a2ca"},"right":{"expr":{"id":"26469"}},"y":{"field":"fruits"}},"id":"26475","type":"HBar"},{"attributes":{},"id":"26442","type":"LinearScale"},{"attributes":{"fields":["2015"]},"id":"26519","type":"Stack"},{"attributes":{},"id":"26481","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"26517"}},"id":"26544","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#fee8c8"},"height":{"value":0.9},"left":{"expr":{"id":"26522"}},"line_alpha":{"value":0.1},"line_color":{"value":"#fee8c8"},"right":{"expr":{"id":"26523"}},"y":{"field":"fruits"}},"id":"26558","type":"HBar"},{"attributes":{},"id":"26454","type":"WheelZoomTool"},{"attributes":{},"id":"26483","type":"CategoricalTickFormatter"},{"attributes":{},"id":"26444","type":"CategoricalScale"},{"attributes":{"source":{"id":"26467"}},"id":"26493","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#fdbb84"},"height":{"value":0.9},"left":{"expr":{"id":"26520"}},"line_alpha":{"value":0.1},"line_color":{"value":"#fdbb84"},"right":{"expr":{"id":"26521"}},"y":{"field":"fruits"}},"id":"26542","type":"HBar"},{"attributes":{},"id":"26451","type":"CategoricalTicker"},{"attributes":{"axis":{"id":"26446"},"ticker":null},"id":"26449","type":"Grid"},{"attributes":{"formatter":{"id":"26481"},"minor_tick_line_color":null,"ticker":{"id":"26447"}},"id":"26446","type":"LinearAxis"},{"attributes":{"data_source":{"id":"26517"},"glyph":{"id":"26525"},"hover_glyph":null,"muted_glyph":null,"name":"2015","nonselection_glyph":{"id":"26526"},"selection_glyph":null,"view":{"id":"26528"}},"id":"26527","type":"GlyphRenderer"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"26453"},{"id":"26454"},{"id":"26455"},{"id":"26456"},{"id":"26457"},{"id":"26458"}]},"id":"26460","type":"Toolbar"},{"attributes":{"data_source":{"id":"26467"},"glyph":{"id":"26504"},"hover_glyph":null,"muted_glyph":null,"name":"2017","nonselection_glyph":{"id":"26505"},"selection_glyph":null,"view":{"id":"26507"}},"id":"26506","type":"GlyphRenderer"},{"attributes":{"data":{"2015":[2,1,4,3,2,4],"2016":[5,3,4,2,4,6],"2017":[3,2,4,4,5,3],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"26485"},"selection_policy":{"id":"26484"}},"id":"26467","type":"ColumnDataSource"},{"attributes":{"fill_color":{"value":"#e34a33"},"height":{"value":0.9},"left":{"expr":{"id":"26518"}},"line_color":{"value":"#e34a33"},"right":{"expr":{"id":"26519"}},"y":{"field":"fruits"}},"id":"26525","type":"HBar"},{"attributes":{"items":[{"id":"26488"},{"id":"26502"},{"id":"26516"},{"id":"26539"},{"id":"26555"},{"id":"26571"}],"location":"top_left"},"id":"26487","type":"Legend"},{"attributes":{"label":{"value":"2017 imports"},"renderers":[{"id":"26559"}]},"id":"26571","type":"LegendItem"},{"attributes":{"below":[{"id":"26446"}],"center":[{"id":"26449"},{"id":"26452"},{"id":"26487"}],"left":[{"id":"26450"}],"outline_line_color":null,"plot_height":250,"renderers":[{"id":"26477"},{"id":"26492"},{"id":"26506"},{"id":"26527"},{"id":"26543"},{"id":"26559"}],"title":{"id":"26436"},"toolbar":{"id":"26460"},"toolbar_location":null,"x_range":{"id":"26438"},"x_scale":{"id":"26442"},"y_range":{"id":"26440"},"y_scale":{"id":"26444"}},"id":"26435","subtype":"Figure","type":"Plot"},{"attributes":{"source":{"id":"26467"}},"id":"26478","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#a8ddb5"},"height":{"value":0.9},"left":{"expr":{"id":"26470"}},"line_alpha":{"value":0.1},"line_color":{"value":"#a8ddb5"},"right":{"expr":{"id":"26471"}},"y":{"field":"fruits"}},"id":"26491","type":"HBar"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"26459","type":"BoxAnnotation"},{"attributes":{"overlay":{"id":"26459"}},"id":"26455","type":"BoxZoomTool"},{"attributes":{"label":{"value":"2017 exports"},"renderers":[{"id":"26506"}]},"id":"26516","type":"LegendItem"},{"attributes":{"fields":[]},"id":"26468","type":"Stack"},{"attributes":{"fields":["2015","2016"]},"id":"26471","type":"Stack"},{"attributes":{"fields":["2015","2016","2017"]},"id":"26473","type":"Stack"},{"attributes":{},"id":"26447","type":"BasicTicker"},{"attributes":{"fill_color":{"value":"#e0f3db"},"height":{"value":0.9},"left":{"expr":{"id":"26472"}},"line_color":{"value":"#e0f3db"},"right":{"expr":{"id":"26473"}},"y":{"field":"fruits"}},"id":"26504","type":"HBar"},{"attributes":{"fields":["2015"]},"id":"26520","type":"Stack"},{"attributes":{"text":"Fruit import/export, by year"},"id":"26436","type":"Title"},{"attributes":{},"id":"26457","type":"ResetTool"},{"attributes":{"source":{"id":"26467"}},"id":"26507","type":"CDSView"},{"attributes":{},"id":"26456","type":"SaveTool"},{"attributes":{"data_source":{"id":"26517"},"glyph":{"id":"26541"},"hover_glyph":null,"muted_glyph":null,"name":"2016","nonselection_glyph":{"id":"26542"},"selection_glyph":null,"view":{"id":"26544"}},"id":"26543","type":"GlyphRenderer"},{"attributes":{"fields":["2015","2016","2017"]},"id":"26523","type":"Stack"},{"attributes":{"data_source":{"id":"26467"},"glyph":{"id":"26490"},"hover_glyph":null,"muted_glyph":null,"name":"2016","nonselection_glyph":{"id":"26491"},"selection_glyph":null,"view":{"id":"26493"}},"id":"26492","type":"GlyphRenderer"},{"attributes":{"fields":["2015","2016"]},"id":"26472","type":"Stack"},{"attributes":{"fields":["2015"]},"id":"26470","type":"Stack"},{"attributes":{"data_source":{"id":"26517"},"glyph":{"id":"26557"},"hover_glyph":null,"muted_glyph":null,"name":"2017","nonselection_glyph":{"id":"26558"},"selection_glyph":null,"view":{"id":"26560"}},"id":"26559","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"26483"},"minor_tick_line_color":null,"ticker":{"id":"26451"}},"id":"26450","type":"CategoricalAxis"},{"attributes":{},"id":"26484","type":"UnionRenderers"},{"attributes":{"fields":["2015"]},"id":"26469","type":"Stack"},{"attributes":{"end":16,"start":-16},"id":"26438","type":"Range1d"},{"attributes":{"data":{"2015":[-1,0,-1,-3,-2,-1],"2016":[-2,-1,-3,-1,-2,-2],"2017":[-1,-2,-1,0,-2,-2],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"26537"},"selection_policy":{"id":"26536"}},"id":"26517","type":"ColumnDataSource"},{"attributes":{"fields":[]},"id":"26518","type":"Stack"},{"attributes":{},"id":"26536","type":"UnionRenderers"}],"root_ids":["26435"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"80a89966-c8a8-46f6-8577-367cd52262a0","root_ids":["26435"],"roots":{"26435":"0a3b9748-43af-4a7e-a548-4323215a5ad4"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();