(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("6169523d-9b66-4cda-a757-aa2cd5c890a2");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '6169523d-9b66-4cda-a757-aa2cd5c890a2' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"0488fedb-56f3-4127-b6cc-5270b9337c2e":{"roots":{"references":[{"attributes":{"end":7},"id":"24902","type":"Range1d"},{"attributes":{},"id":"24931","type":"BasicTickFormatter"},{"attributes":{},"id":"24918","type":"SaveTool"},{"attributes":{},"id":"24929","type":"BasicTickFormatter"},{"attributes":{"items":[{"id":"24935"}]},"id":"24934","type":"Legend"},{"attributes":{"end":3},"id":"24904","type":"Range1d"},{"attributes":{"formatter":{"id":"24929"},"ticker":{"id":"24911"}},"id":"24910","type":"LinearAxis"},{"attributes":{"fill_color":{"field":"color"},"line_color":{"field":"color"},"radius":{"units":"data","value":0.5},"x":{"field":"x"},"y":{"field":"y"}},"id":"24922","type":"Circle"},{"attributes":{},"id":"24933","type":"Selection"},{"attributes":{"data_source":{"id":"24900"},"glyph":{"id":"24922"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"24923"},"selection_glyph":null,"view":{"id":"24925"}},"id":"24924","type":"GlyphRenderer"},{"attributes":{"text":""},"id":"24926","type":"Title"},{"attributes":{"below":[{"id":"24910"}],"center":[{"id":"24913"},{"id":"24917"},{"id":"24934"}],"left":[{"id":"24914"}],"plot_height":300,"renderers":[{"id":"24924"}],"title":{"id":"24926"},"toolbar":{"id":"24919"},"x_range":{"id":"24902"},"x_scale":{"id":"24906"},"y_range":{"id":"24904"},"y_scale":{"id":"24908"}},"id":"24901","subtype":"Figure","type":"Plot"},{"attributes":{"axis":{"id":"24910"},"ticker":null},"id":"24913","type":"Grid"},{"attributes":{"formatter":{"id":"24931"},"ticker":{"id":"24915"}},"id":"24914","type":"LinearAxis"},{"attributes":{"label":{"field":"label"},"renderers":[{"id":"24924"}]},"id":"24935","type":"LegendItem"},{"attributes":{"data":{"color":["#ef8a62","#67a9cf","#ef8a62","#67a9cf","#ef8a62","#67a9cf"],"label":["hi","lo","hi","lo","hi","lo"],"x":[1,2,3,4,5,6],"y":[2,1,2,1,2,1]},"selected":{"id":"24933"},"selection_policy":{"id":"24932"}},"id":"24900","type":"ColumnDataSource"},{"attributes":{},"id":"24906","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"24918"}]},"id":"24919","type":"Toolbar"},{"attributes":{},"id":"24911","type":"BasicTicker"},{"attributes":{},"id":"24908","type":"LinearScale"},{"attributes":{},"id":"24915","type":"BasicTicker"},{"attributes":{"source":{"id":"24900"}},"id":"24925","type":"CDSView"},{"attributes":{"axis":{"id":"24914"},"dimension":1,"ticker":null},"id":"24917","type":"Grid"},{"attributes":{},"id":"24932","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"color"},"line_alpha":{"value":0.1},"line_color":{"field":"color"},"radius":{"units":"data","value":0.5},"x":{"field":"x"},"y":{"field":"y"}},"id":"24923","type":"Circle"}],"root_ids":["24901"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"0488fedb-56f3-4127-b6cc-5270b9337c2e","root_ids":["24901"],"roots":{"24901":"6169523d-9b66-4cda-a757-aa2cd5c890a2"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();