(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("f1be3ff0-a838-4b98-b496-0488ed7508b5");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'f1be3ff0-a838-4b98-b496-0488ed7508b5' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"adb346a8-7908-421b-a869-0ed3ee566a12":{"roots":{"references":[{"attributes":{},"id":"26849","type":"LinearScale"},{"attributes":{"fill_color":{"value":"#c9d9d3"},"line_color":{"value":"#c9d9d3"},"top":{"field":"2015"},"width":{"value":0.2},"x":{"field":"fruits","transform":{"id":"26859"}}},"id":"26861","type":"VBar"},{"attributes":{"range":{"id":"26843"}},"id":"26874","type":"Dodge"},{"attributes":{"range":{"id":"26843"},"value":0.25},"id":"26888","type":"Dodge"},{"attributes":{"formatter":{"id":"26869"},"ticker":{"id":"26855"}},"id":"26854","type":"LinearAxis"},{"attributes":{"data_source":{"id":"26839"},"glyph":{"id":"26890"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"26891"},"selection_glyph":null,"view":{"id":"26893"}},"id":"26892","type":"GlyphRenderer"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"26858","type":"Toolbar"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#c9d9d3"},"line_alpha":{"value":0.1},"line_color":{"value":"#c9d9d3"},"top":{"field":"2015"},"width":{"value":0.2},"x":{"field":"fruits","transform":{"id":"26859"}}},"id":"26862","type":"VBar"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#718dbf"},"line_alpha":{"value":0.1},"line_color":{"value":"#718dbf"},"top":{"field":"2016"},"width":{"value":0.2},"x":{"field":"fruits","transform":{"id":"26874"}}},"id":"26877","type":"VBar"},{"attributes":{"data_source":{"id":"26839"},"glyph":{"id":"26876"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"26877"},"selection_glyph":null,"view":{"id":"26879"}},"id":"26878","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#e84d60"},"line_alpha":{"value":0.1},"line_color":{"value":"#e84d60"},"top":{"field":"2017"},"width":{"value":0.2},"x":{"field":"fruits","transform":{"id":"26888"}}},"id":"26891","type":"VBar"},{"attributes":{},"id":"26855","type":"BasicTicker"},{"attributes":{"data_source":{"id":"26839"},"glyph":{"id":"26861"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"26862"},"selection_glyph":null,"view":{"id":"26864"}},"id":"26863","type":"GlyphRenderer"},{"attributes":{"text":"Fruit Counts by Year"},"id":"26841","type":"Title"},{"attributes":{"range":{"id":"26843"},"value":-0.25},"id":"26859","type":"Dodge"},{"attributes":{},"id":"26847","type":"CategoricalScale"},{"attributes":{"source":{"id":"26839"}},"id":"26893","type":"CDSView"},{"attributes":{"factors":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"],"range_padding":0.1},"id":"26843","type":"FactorRange"},{"attributes":{"label":{"value":"2017"},"renderers":[{"id":"26892"}]},"id":"26901","type":"LegendItem"},{"attributes":{"source":{"id":"26839"}},"id":"26864","type":"CDSView"},{"attributes":{"formatter":{"id":"26867"},"ticker":{"id":"26852"}},"id":"26851","type":"CategoricalAxis"},{"attributes":{"source":{"id":"26839"}},"id":"26879","type":"CDSView"},{"attributes":{"fill_color":{"value":"#e84d60"},"line_color":{"value":"#e84d60"},"top":{"field":"2017"},"width":{"value":0.2},"x":{"field":"fruits","transform":{"id":"26888"}}},"id":"26890","type":"VBar"},{"attributes":{"fill_color":{"value":"#718dbf"},"line_color":{"value":"#718dbf"},"top":{"field":"2016"},"width":{"value":0.2},"x":{"field":"fruits","transform":{"id":"26874"}}},"id":"26876","type":"VBar"},{"attributes":{"axis":{"id":"26854"},"dimension":1,"ticker":null},"id":"26857","type":"Grid"},{"attributes":{"label":{"value":"2015"},"renderers":[{"id":"26863"}]},"id":"26873","type":"LegendItem"},{"attributes":{"data":{"2015":[2,1,4,3,2,4],"2016":[5,3,3,2,4,6],"2017":[3,2,4,4,5,3],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"26871"},"selection_policy":{"id":"26870"}},"id":"26839","type":"ColumnDataSource"},{"attributes":{},"id":"26867","type":"CategoricalTickFormatter"},{"attributes":{"label":{"value":"2016"},"renderers":[{"id":"26878"}]},"id":"26887","type":"LegendItem"},{"attributes":{"end":10},"id":"26845","type":"Range1d"},{"attributes":{},"id":"26852","type":"CategoricalTicker"},{"attributes":{},"id":"26871","type":"Selection"},{"attributes":{},"id":"26870","type":"UnionRenderers"},{"attributes":{"items":[{"id":"26873"},{"id":"26887"},{"id":"26901"}],"location":"top_left","orientation":"horizontal"},"id":"26872","type":"Legend"},{"attributes":{},"id":"26869","type":"BasicTickFormatter"},{"attributes":{"below":[{"id":"26851"}],"center":[{"id":"26853"},{"id":"26857"},{"id":"26872"}],"left":[{"id":"26854"}],"plot_height":250,"renderers":[{"id":"26863"},{"id":"26878"},{"id":"26892"}],"title":{"id":"26841"},"toolbar":{"id":"26858"},"toolbar_location":null,"x_range":{"id":"26843"},"x_scale":{"id":"26847"},"y_range":{"id":"26845"},"y_scale":{"id":"26849"}},"id":"26840","subtype":"Figure","type":"Plot"},{"attributes":{"axis":{"id":"26851"},"grid_line_color":null,"ticker":null},"id":"26853","type":"Grid"}],"root_ids":["26840"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"adb346a8-7908-421b-a869-0ed3ee566a12","root_ids":["26840"],"roots":{"26840":"f1be3ff0-a838-4b98-b496-0488ed7508b5"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();