(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("c06aa8a5-a7c8-4d5f-84cf-ee2d4801a911");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'c06aa8a5-a7c8-4d5f-84cf-ee2d4801a911' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"f4bfe275-5e0d-4191-a1b2-767f1a49e877":{"roots":{"references":[{"attributes":{},"id":"33411","type":"HelpTool"},{"attributes":{"formatter":{"id":"33430"},"ticker":{"id":"33403"}},"id":"33402","type":"LinearAxis"},{"attributes":{},"id":"33410","type":"ResetTool"},{"attributes":{},"id":"33394","type":"LinearScale"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"33422","type":"Line"},{"attributes":{"source":{"id":"33420"}},"id":"33424","type":"CDSView"},{"attributes":{},"id":"33430","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"33398"},"ticker":null},"id":"33401","type":"Grid"},{"attributes":{},"id":"33396","type":"LinearScale"},{"attributes":{"text":""},"id":"33425","type":"Title"},{"attributes":{"data_source":{"id":"33420"},"glyph":{"id":"33421"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"33422"},"selection_glyph":null,"view":{"id":"33424"}},"id":"33423","type":"GlyphRenderer"},{"attributes":{},"id":"33390","type":"DataRange1d"},{"attributes":{"axis":{"id":"33402"},"dimension":1,"ticker":null},"id":"33405","type":"Grid"},{"attributes":{},"id":"33431","type":"UnionRenderers"},{"attributes":{},"id":"33392","type":"DataRange1d"},{"attributes":{},"id":"33407","type":"WheelZoomTool"},{"attributes":{"formatter":{"id":"33428"},"ticker":{"id":"33399"}},"id":"33398","type":"LinearAxis"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"33412","type":"BoxAnnotation"},{"attributes":{"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"33421","type":"Line"},{"attributes":{},"id":"33406","type":"PanTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"33406"},{"id":"33407"},{"id":"33408"},{"id":"33409"},{"id":"33410"},{"id":"33411"}]},"id":"33413","type":"Toolbar"},{"attributes":{"overlay":{"id":"33412"}},"id":"33408","type":"BoxZoomTool"},{"attributes":{},"id":"33409","type":"SaveTool"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,2,4,5]},"selected":{"id":"33432"},"selection_policy":{"id":"33431"}},"id":"33420","type":"ColumnDataSource"},{"attributes":{},"id":"33403","type":"BasicTicker"},{"attributes":{},"id":"33399","type":"BasicTicker"},{"attributes":{},"id":"33428","type":"BasicTickFormatter"},{"attributes":{"below":[{"id":"33398"}],"center":[{"id":"33401"},{"id":"33405"}],"left":[{"id":"33402"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"33423"}],"title":{"id":"33425"},"toolbar":{"id":"33413"},"x_range":{"id":"33390"},"x_scale":{"id":"33394"},"y_range":{"id":"33392"},"y_scale":{"id":"33396"}},"id":"33389","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"33432","type":"Selection"}],"root_ids":["33389"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"f4bfe275-5e0d-4191-a1b2-767f1a49e877","root_ids":["33389"],"roots":{"33389":"c06aa8a5-a7c8-4d5f-84cf-ee2d4801a911"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();