(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("f91b562e-3aef-408d-8fb1-9fa3287229c5");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'f91b562e-3aef-408d-8fb1-9fa3287229c5' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"0f88cb43-f339-4ed6-a0fd-60933084920e":{"roots":{"references":[{"attributes":{"formatter":{"id":"34898"},"ticker":{"id":"34869"}},"id":"34868","type":"LinearAxis"},{"attributes":{"axis":{"id":"34872"},"dimension":1,"ticker":null},"id":"34875","type":"Grid"},{"attributes":{},"id":"34881","type":"HelpTool"},{"attributes":{"axis":{"id":"34868"},"ticker":null},"id":"34871","type":"Grid"},{"attributes":{},"id":"34862","type":"DataRange1d"},{"attributes":{},"id":"34877","type":"WheelZoomTool"},{"attributes":{"source":{"id":"34890"}},"id":"34894","type":"CDSView"},{"attributes":{},"id":"34876","type":"PanTool"},{"attributes":{},"id":"34873","type":"BasicTicker"},{"attributes":{},"id":"34898","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fill_color"},"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"34892","type":"MultiPolygons"},{"attributes":{},"id":"34860","type":"DataRange1d"},{"attributes":{"formatter":{"id":"34900"},"ticker":{"id":"34873"}},"id":"34872","type":"LinearAxis"},{"attributes":{"below":[{"id":"34868"}],"center":[{"id":"34871"},{"id":"34875"}],"left":[{"id":"34872"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"34893"}],"title":{"id":"34895"},"toolbar":{"id":"34883"},"x_range":{"id":"34860"},"x_scale":{"id":"34864"},"y_range":{"id":"34862"},"y_scale":{"id":"34866"}},"id":"34859","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"34869","type":"BasicTicker"},{"attributes":{},"id":"34901","type":"UnionRenderers"},{"attributes":{},"id":"34880","type":"ResetTool"},{"attributes":{},"id":"34864","type":"LinearScale"},{"attributes":{"fill_color":{"field":"fill_color"},"line_color":{"field":"line_color"},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"34891","type":"MultiPolygons"},{"attributes":{"overlay":{"id":"34882"}},"id":"34878","type":"BoxZoomTool"},{"attributes":{"data":{"fill_color":["blue","red"],"line_color":["blue","red"],"xs":[[[[1,1,2,2],[1.2,1.6,1.6],[1.8,1.8,1.6]],[[3,3,4]]],[[[1,2,2,1],[1.3,1.3,1.7,1.7]]]],"ys":[[[[4,3,3,4],[3.2,3.2,3.6],[3.4,3.8,3.8]],[[1,3,1]]],[[[1,1,2,2],[1.3,1.7,1.7,1.3]]]]},"selected":{"id":"34902"},"selection_policy":{"id":"34901"}},"id":"34890","type":"ColumnDataSource"},{"attributes":{},"id":"34902","type":"Selection"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"34882","type":"BoxAnnotation"},{"attributes":{"data_source":{"id":"34890"},"glyph":{"id":"34891"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"34892"},"selection_glyph":null,"view":{"id":"34894"}},"id":"34893","type":"GlyphRenderer"},{"attributes":{},"id":"34879","type":"SaveTool"},{"attributes":{"text":""},"id":"34895","type":"Title"},{"attributes":{},"id":"34866","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"34876"},{"id":"34877"},{"id":"34878"},{"id":"34879"},{"id":"34880"},{"id":"34881"}]},"id":"34883","type":"Toolbar"},{"attributes":{},"id":"34900","type":"BasicTickFormatter"}],"root_ids":["34859"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"0f88cb43-f339-4ed6-a0fd-60933084920e","root_ids":["34859"],"roots":{"34859":"f91b562e-3aef-408d-8fb1-9fa3287229c5"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();