(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("13500a97-22f0-48b1-a349-e8f02d647add");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '13500a97-22f0-48b1-a349-e8f02d647add' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"31f637f8-0be5-4dfa-9dde-dbb0079852f3":{"roots":{"references":[{"attributes":{},"id":"34936","type":"LinearScale"},{"attributes":{"text":""},"id":"34967","type":"Title"},{"attributes":{"angle":{"units":"rad","value":1.0471975511965976},"fill_alpha":{"value":0.1},"fill_color":{"value":"#CAB2D6"},"height":{"units":"data","value":0.3},"line_alpha":{"value":0.1},"line_color":{"value":"#CAB2D6"},"width":{"field":"width","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"34964","type":"Ellipse"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"34948"},{"id":"34949"},{"id":"34950"},{"id":"34951"},{"id":"34952"},{"id":"34953"}]},"id":"34955","type":"Toolbar"},{"attributes":{},"id":"34974","type":"Selection"},{"attributes":{"axis":{"id":"34944"},"dimension":1,"ticker":null},"id":"34947","type":"Grid"},{"attributes":{"data_source":{"id":"34962"},"glyph":{"id":"34963"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"34964"},"selection_glyph":null,"view":{"id":"34966"}},"id":"34965","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"34972"},"ticker":{"id":"34945"}},"id":"34944","type":"LinearAxis"},{"attributes":{},"id":"34948","type":"PanTool"},{"attributes":{},"id":"34951","type":"SaveTool"},{"attributes":{"axis":{"id":"34940"},"ticker":null},"id":"34943","type":"Grid"},{"attributes":{"angle":{"units":"rad","value":1.0471975511965976},"fill_color":{"value":"#CAB2D6"},"height":{"units":"data","value":0.3},"line_color":{"value":"#CAB2D6"},"width":{"field":"width","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"34963","type":"Ellipse"},{"attributes":{},"id":"34949","type":"WheelZoomTool"},{"attributes":{"overlay":{"id":"34954"}},"id":"34950","type":"BoxZoomTool"},{"attributes":{},"id":"34973","type":"UnionRenderers"},{"attributes":{},"id":"34953","type":"HelpTool"},{"attributes":{},"id":"34938","type":"LinearScale"},{"attributes":{"data":{"width":[0.2,0.3,0.1],"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"34974"},"selection_policy":{"id":"34973"}},"id":"34962","type":"ColumnDataSource"},{"attributes":{"source":{"id":"34962"}},"id":"34966","type":"CDSView"},{"attributes":{},"id":"34941","type":"BasicTicker"},{"attributes":{},"id":"34970","type":"BasicTickFormatter"},{"attributes":{},"id":"34934","type":"DataRange1d"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"34954","type":"BoxAnnotation"},{"attributes":{"below":[{"id":"34940"}],"center":[{"id":"34943"},{"id":"34947"}],"left":[{"id":"34944"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"34965"}],"title":{"id":"34967"},"toolbar":{"id":"34955"},"x_range":{"id":"34932"},"x_scale":{"id":"34936"},"y_range":{"id":"34934"},"y_scale":{"id":"34938"}},"id":"34931","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"34945","type":"BasicTicker"},{"attributes":{"formatter":{"id":"34970"},"ticker":{"id":"34941"}},"id":"34940","type":"LinearAxis"},{"attributes":{},"id":"34972","type":"BasicTickFormatter"},{"attributes":{},"id":"34932","type":"DataRange1d"},{"attributes":{},"id":"34952","type":"ResetTool"}],"root_ids":["34931"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"31f637f8-0be5-4dfa-9dde-dbb0079852f3","root_ids":["34931"],"roots":{"34931":"13500a97-22f0-48b1-a349-e8f02d647add"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();