(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("fef3cab3-251a-4e24-92b7-ff6ae8aa5215");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'fef3cab3-251a-4e24-92b7-ff6ae8aa5215' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function(root, factory) {
              factory(root["Bokeh"]);
          })(this, function(Bokeh) {
            var define;
            return (function outer(modules, entry) {
            if (Bokeh != null) {
              return Bokeh.register_plugin(modules, entry);
            } else {
              throw new Error("Cannot find Bokeh. You have to load it prior to loading plugins.");
            }
          })
          ({
            "custom/main": function(require, module, exports) {
              var models = {
                "Custom": require("custom/bokeh_app_e60e38b75abc4ecba838d015d2f412cd.custom").Custom
              };
              require("base").register_models(models);
              module.exports = models;
            },
            "custom/bokeh_app_e60e38b75abc4ecba838d015d2f412cd.custom": function(require, module, exports) {
          "use strict";
          var __importStar = (this && this.__importStar) || function (mod) {
              if (mod && mod.__esModule) return mod;
              var result = {};
              if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
              result["default"] = mod;
              return result;
          };
          Object.defineProperty(exports, "__esModule", { value: true });
          const html_box_1 = require("models/layouts/html_box");
          const dom_1 = require("core/dom");
          const p = __importStar(require("core/properties"));
          class CustomView extends html_box_1.HTMLBoxView {
              connect_signals() {
                  super.connect_signals();
                  this.connect(this.model.slider.change, () => this._update_text());
              }
              render() {
                  // BokehJS Views create <div> elements by default, accessible as ``this.el``.
                  // Many Bokeh views extend this default <div> with additional elements
                  // (e.g. <canvas>), and instead do things like paint on the HTML canvas.
                  // In this case though, we change the contents of the <div>, based on the
                  // current slider value.
                  super.render();
                  this.content_el = dom_1.div({ style: {
                          textAlign: "center",
                          fontSize: "1.2em",
                          padding: "2px",
                          color: "#b88d8e",
                          backgroundColor: "#2a3153",
                      } });
                  this.el.appendChild(this.content_el);
                  this._update_text();
              }
              _update_text() {
                  this.content_el.textContent = `${this.model.text}: ${this.model.slider.value}`;
              }
          }
          exports.CustomView = CustomView;
          CustomView.__name__ = "CustomView";
          class Custom extends html_box_1.HTMLBox {
              constructor(attrs) {
                  super(attrs);
              }
              static init_Custom() {
                  // If there is an associated view, this is typically boilerplate.
                  this.prototype.default_view = CustomView;
                  // The define block adds corresponding "properties" to the JS model. These
                  // should normally line up 1-1 with the Python model class. Most property
                  // types have counterparts, e.g. bokeh.core.properties.String will be
                  // ``p.String`` in the JS implementation. Any time the JS type system is not
                  // yet as complete, you can use ``p.Any`` as a "wildcard" property type.
                  this.define({
                      text: [p.String],
                      slider: [p.Any],
                  });
                  this.override({
                      margin: 5,
                  });
              }
          }
          exports.Custom = Custom;
          Custom.__name__ = "Custom";
          Custom.init_Custom();
          //# sourceMappingURL=extensions_putting_together_ts.py:Custom.js.map
          }
          }, "custom/main");
          ;
          });
    
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"9cf4ba6a-a6cc-413c-82a6-40b57bef2f23":{"roots":{"references":[{"attributes":{"children":[{"id":"28894"},{"id":"28895"}]},"id":"28896","type":"Column"},{"attributes":{"end":10,"format":"0[.]00","start":0,"step":0.1,"title":"value","value":0},"id":"28894","type":"Slider"},{"attributes":{"slider":{"id":"28894"},"text":"Special Slider Display"},"id":"28895","type":"Custom"}],"root_ids":["28896"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"9cf4ba6a-a6cc-413c-82a6-40b57bef2f23","root_ids":["28896"],"roots":{"28896":"fef3cab3-251a-4e24-92b7-ff6ae8aa5215"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();