(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("f714fc2a-f7b9-4dac-b8de-f717682d0d35");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'f714fc2a-f7b9-4dac-b8de-f717682d0d35' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"8e16f51b-9749-4d8f-a5e3-8386dbe872b1":{"roots":{"references":[{"attributes":{},"id":"38250","type":"ResetTool"},{"attributes":{},"id":"38268","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"38242"},"dimension":1,"ticker":null},"id":"38245","type":"Grid"},{"attributes":{"below":[{"id":"38238"}],"center":[{"id":"38241"},{"id":"38245"}],"left":[{"id":"38242"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"38263"}],"title":{"id":"38265"},"toolbar":{"id":"38253"},"x_range":{"id":"38230"},"x_scale":{"id":"38234"},"y_range":{"id":"38232"},"y_scale":{"id":"38236"}},"id":"38229","subtype":"Figure","type":"Plot"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"38246"},{"id":"38247"},{"id":"38248"},{"id":"38249"},{"id":"38250"},{"id":"38251"}]},"id":"38253","type":"Toolbar"},{"attributes":{"axis":{"id":"38238"},"ticker":null},"id":"38241","type":"Grid"},{"attributes":{"formatter":{"id":"38268"},"ticker":{"id":"38239"}},"id":"38238","type":"LinearAxis"},{"attributes":{"formatter":{"id":"38270"},"ticker":{"id":"38243"}},"id":"38242","type":"LinearAxis"},{"attributes":{},"id":"38234","type":"LinearScale"},{"attributes":{},"id":"38271","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"38260"},"glyph":{"id":"38261"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"38262"},"selection_glyph":null,"view":{"id":"38264"}},"id":"38263","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.2},"fill_color":{"value":"#1f77b4"},"line_color":{"value":"firebrick"},"line_dash":[6,3],"line_width":{"value":2},"size":{"units":"screen","value":60},"x":{"field":"x"},"y":{"field":"y"}},"id":"38261","type":"Circle"},{"attributes":{},"id":"38239","type":"BasicTicker"},{"attributes":{},"id":"38243","type":"BasicTicker"},{"attributes":{},"id":"38232","type":"DataRange1d"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"38252","type":"BoxAnnotation"},{"attributes":{},"id":"38246","type":"PanTool"},{"attributes":{},"id":"38251","type":"HelpTool"},{"attributes":{},"id":"38247","type":"WheelZoomTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"38262","type":"Circle"},{"attributes":{},"id":"38236","type":"LinearScale"},{"attributes":{"source":{"id":"38260"}},"id":"38264","type":"CDSView"},{"attributes":{},"id":"38249","type":"SaveTool"},{"attributes":{},"id":"38270","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"38272"},"selection_policy":{"id":"38271"}},"id":"38260","type":"ColumnDataSource"},{"attributes":{},"id":"38230","type":"DataRange1d"},{"attributes":{"overlay":{"id":"38252"}},"id":"38248","type":"BoxZoomTool"},{"attributes":{},"id":"38272","type":"Selection"},{"attributes":{"text":""},"id":"38265","type":"Title"}],"root_ids":["38229"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"8e16f51b-9749-4d8f-a5e3-8386dbe872b1","root_ids":["38229"],"roots":{"38229":"f714fc2a-f7b9-4dac-b8de-f717682d0d35"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();