(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("483d9305-e90d-428c-ba85-57cceb3c5fec");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '483d9305-e90d-428c-ba85-57cceb3c5fec' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"b945e9a8-8d6d-463d-a1f2-e085a265a0d0":{"roots":{"references":[{"attributes":{"source":{"id":"34530"}},"id":"34534","type":"CDSView"},{"attributes":{},"id":"34519","type":"SaveTool"},{"attributes":{},"id":"34500","type":"DataRange1d"},{"attributes":{},"id":"34521","type":"HelpTool"},{"attributes":{},"id":"34516","type":"PanTool"},{"attributes":{},"id":"34538","type":"BasicTickFormatter"},{"attributes":{"data":{"fill_alpha":[0.8,0.3],"fill_color":["firebrick","navy"],"line_alpha":[0.8,0.3],"line_color":["firebrick","navy"],"xs":[[1,3,2],[3,4,6,6]],"ys":[[2,1,4],[4,7,8,5]]},"selected":{"id":"34542"},"selection_policy":{"id":"34541"}},"id":"34530","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"34540"},"ticker":{"id":"34513"}},"id":"34512","type":"LinearAxis"},{"attributes":{},"id":"34520","type":"ResetTool"},{"attributes":{},"id":"34542","type":"Selection"},{"attributes":{"overlay":{"id":"34522"}},"id":"34518","type":"BoxZoomTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"34516"},{"id":"34517"},{"id":"34518"},{"id":"34519"},{"id":"34520"},{"id":"34521"}]},"id":"34523","type":"Toolbar"},{"attributes":{},"id":"34541","type":"UnionRenderers"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"34522","type":"BoxAnnotation"},{"attributes":{},"id":"34504","type":"LinearScale"},{"attributes":{"fill_alpha":{"field":"fill_alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"line_alpha"},"line_color":{"field":"line_color"},"line_width":{"value":2},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"34531","type":"Patches"},{"attributes":{"axis":{"id":"34508"},"ticker":null},"id":"34511","type":"Grid"},{"attributes":{},"id":"34509","type":"BasicTicker"},{"attributes":{},"id":"34506","type":"LinearScale"},{"attributes":{},"id":"34502","type":"DataRange1d"},{"attributes":{"data_source":{"id":"34530"},"glyph":{"id":"34531"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"34532"},"selection_glyph":null,"view":{"id":"34534"}},"id":"34533","type":"GlyphRenderer"},{"attributes":{"text":""},"id":"34535","type":"Title"},{"attributes":{},"id":"34513","type":"BasicTicker"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fill_color"},"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"line_width":{"value":2},"xs":{"field":"xs"},"ys":{"field":"ys"}},"id":"34532","type":"Patches"},{"attributes":{},"id":"34540","type":"BasicTickFormatter"},{"attributes":{"below":[{"id":"34508"}],"center":[{"id":"34511"},{"id":"34515"}],"left":[{"id":"34512"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"34533"}],"title":{"id":"34535"},"toolbar":{"id":"34523"},"x_range":{"id":"34500"},"x_scale":{"id":"34504"},"y_range":{"id":"34502"},"y_scale":{"id":"34506"}},"id":"34499","subtype":"Figure","type":"Plot"},{"attributes":{"axis":{"id":"34512"},"dimension":1,"ticker":null},"id":"34515","type":"Grid"},{"attributes":{},"id":"34517","type":"WheelZoomTool"},{"attributes":{"formatter":{"id":"34538"},"ticker":{"id":"34509"}},"id":"34508","type":"LinearAxis"}],"root_ids":["34499"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"b945e9a8-8d6d-463d-a1f2-e085a265a0d0","root_ids":["34499"],"roots":{"34499":"483d9305-e90d-428c-ba85-57cceb3c5fec"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();