(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("af453369-2f03-4cc2-a190-27ce32c491ba");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'af453369-2f03-4cc2-a190-27ce32c491ba' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"7207659e-45ea-4fe4-985b-0583b2058bc5":{"roots":{"references":[{"attributes":{"source":{"id":"39306"}},"id":"39310","type":"CDSView"},{"attributes":{"overlay":{"id":"39298"}},"id":"39294","type":"BoxZoomTool"},{"attributes":{"axis":{"id":"39284"},"ticker":null},"id":"39287","type":"Grid"},{"attributes":{},"id":"39289","type":"BasicTicker"},{"attributes":{},"id":"39317","type":"UnionRenderers"},{"attributes":{},"id":"39282","type":"LinearScale"},{"attributes":{},"id":"39292","type":"PanTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"39308","type":"Circle"},{"attributes":{"below":[{"id":"39284"}],"center":[{"id":"39287"},{"id":"39291"}],"left":[{"id":"39288"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"39309"}],"title":{"id":"39311"},"toolbar":{"id":"39299"},"x_range":{"id":"39276"},"x_scale":{"id":"39280"},"y_range":{"id":"39278"},"y_scale":{"id":"39282"}},"id":"39275","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"39297","type":"HelpTool"},{"attributes":{},"id":"39295","type":"SaveTool"},{"attributes":{"axis":{"id":"39288"},"dimension":1,"ticker":null},"id":"39291","type":"Grid"},{"attributes":{"formatter":{"id":"39316"},"major_label_orientation":"vertical","ticker":{"id":"39289"}},"id":"39288","type":"LinearAxis"},{"attributes":{},"id":"39296","type":"ResetTool"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"39307","type":"Circle"},{"attributes":{},"id":"39278","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"39292"},{"id":"39293"},{"id":"39294"},{"id":"39295"},{"id":"39296"},{"id":"39297"}]},"id":"39299","type":"Toolbar"},{"attributes":{"text":""},"id":"39311","type":"Title"},{"attributes":{},"id":"39316","type":"BasicTickFormatter"},{"attributes":{},"id":"39285","type":"BasicTicker"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"39318"},"selection_policy":{"id":"39317"}},"id":"39306","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"39314"},"major_label_orientation":0.7853981633974483,"ticker":{"id":"39285"}},"id":"39284","type":"LinearAxis"},{"attributes":{"data_source":{"id":"39306"},"glyph":{"id":"39307"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"39308"},"selection_glyph":null,"view":{"id":"39310"}},"id":"39309","type":"GlyphRenderer"},{"attributes":{},"id":"39314","type":"BasicTickFormatter"},{"attributes":{},"id":"39318","type":"Selection"},{"attributes":{},"id":"39280","type":"LinearScale"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"39298","type":"BoxAnnotation"},{"attributes":{},"id":"39293","type":"WheelZoomTool"},{"attributes":{},"id":"39276","type":"DataRange1d"}],"root_ids":["39275"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"7207659e-45ea-4fe4-985b-0583b2058bc5","root_ids":["39275"],"roots":{"39275":"af453369-2f03-4cc2-a190-27ce32c491ba"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();