(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("b69a25e3-fa7b-4a97-b7db-1943b59f8ca2");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'b69a25e3-fa7b-4a97-b7db-1943b59f8ca2' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"f3cab5a5-d287-43f1-a3e3-c68c0546a48b":{"roots":{"references":[{"attributes":{"edge_renderer":{"id":"29790"},"inspection_policy":{"id":"29825"},"layout_provider":{"id":"29792"},"node_renderer":{"id":"29786"},"selection_policy":{"id":"29823"}},"id":"29783","type":"GraphRenderer"},{"attributes":{"data_source":{"id":"29789"},"glyph":{"id":"29808"},"hover_glyph":{"id":"29818"},"muted_glyph":null,"selection_glyph":{"id":"29813"},"view":{"id":"29791"}},"id":"29790","type":"GlyphRenderer"},{"attributes":{"line_color":{"value":"#fdae61"},"line_width":{"value":5}},"id":"29813","type":"MultiLine"},{"attributes":{"graph_layout":{"0":[1.0,1.2564497938803791e-09],"1":[0.9829730987548828,0.1837495130944091],"10":[-0.2736629247665405,0.9618256700682479],"11":[-0.445738285779953,0.8951632989096481],"12":[-0.6026346683502197,0.7980172050642806],"13":[-0.7390088438987732,0.6736957443404037],"14":[-0.8502171039581299,0.526432157819255],"15":[-0.9324721693992615,0.3612417889284926],"16":[-0.9829730987548828,0.1837495279955703],"17":[-1.0,-8.616632677959548e-08],"18":[-0.9829730987548828,-0.1837494658780259],"19":[-0.9324722290039062,-0.3612417268109483],"2":[0.9324722290039062,0.3612416697192031],"20":[-0.8502171635627747,-0.5264320957017106],"21":[-0.739008903503418,-0.6736956226182145],"22":[-0.6026347279548645,-0.7980171429467362],"23":[-0.44573837518692017,-0.8951632963967484],"24":[-0.27366289496421814,-0.9618256675553483],"25":[-0.09226816147565842,-0.995734213526265],"26":[0.0922681912779808,-0.995734213526265],"27":[0.27366289496421814,-0.9618256675553483],"28":[0.44573837518692017,-0.8951632963967484],"29":[0.6026347279548645,-0.7980171429467362],"3":[0.8502171039581299,0.526432157819255],"30":[0.7390087246894836,-0.6736958014321488],"31":[0.8502170443534851,-0.5264322745156449],"32":[0.9324722290039062,-0.3612416970086259],"33":[0.9829730987548828,-0.18374943607570352],"4":[0.739008903503418,0.6736956251311141],"5":[0.6026346683502197,0.7980172050642806],"6":[0.4457383453845978,0.8951632989096481],"7":[0.2736629843711853,0.9618256700682479],"8":[0.09226837009191513,0.9957341564345199],"9":[-0.09226834028959274,0.9957341564345199]}},"id":"29792","type":"StaticLayoutProvider"},{"attributes":{},"id":"29843","type":"Selection"},{"attributes":{"data_source":{"id":"29785"},"glyph":{"id":"29793"},"hover_glyph":{"id":"29803"},"muted_glyph":null,"selection_glyph":{"id":"29798"},"view":{"id":"29787"}},"id":"29786","type":"GlyphRenderer"},{"attributes":{"callback":null},"id":"29778","type":"TapTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"29839","type":"BoxAnnotation"},{"attributes":{},"id":"29823","type":"NodesAndLinkedEdges"},{"attributes":{"fill_color":{"value":"#2b83ba"},"size":{"units":"screen","value":15}},"id":"29793","type":"Circle"},{"attributes":{"callback":null,"tooltips":null},"id":"29777","type":"HoverTool"},{"attributes":{"source":{"id":"29785"}},"id":"29787","type":"CDSView"},{"attributes":{},"id":"29841","type":"Selection"},{"attributes":{"end":1.1,"start":-1.1},"id":"29772","type":"Range1d"},{"attributes":{},"id":"29840","type":"UnionRenderers"},{"attributes":{"fill_color":{"value":"#abdda4"},"size":{"units":"screen","value":15}},"id":"29803","type":"Circle"},{"attributes":{"end":1.1,"start":-1.1},"id":"29771","type":"Range1d"},{"attributes":{},"id":"29825","type":"EdgesAndLinkedNodes"},{"attributes":{"text":"Graph Interaction Demonstration"},"id":"29776","type":"Title"},{"attributes":{},"id":"29829","type":"LinearScale"},{"attributes":{"line_color":{"value":"#abdda4"},"line_width":{"value":5}},"id":"29818","type":"MultiLine"},{"attributes":{"data":{"club":["Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Officer","Mr. Hi","Mr. Hi","Mr. Hi","Mr. Hi","Officer","Officer","Mr. Hi","Mr. Hi","Officer","Mr. Hi","Officer","Mr. Hi","Officer","Officer","Officer","Officer","Officer","Officer","Officer","Officer","Officer","Officer","Officer","Officer"],"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33]},"selected":{"id":"29841"},"selection_policy":{"id":"29840"}},"id":"29785","type":"ColumnDataSource"},{"attributes":{},"id":"29827","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"29777"},{"id":"29778"},{"id":"29779"}]},"id":"29780","type":"Toolbar"},{"attributes":{"data":{"end":[1,2,3,4,5,6,7,8,10,11,12,13,17,19,21,31,2,3,7,13,17,19,21,30,3,7,8,9,13,27,28,32,7,12,13,6,10,6,10,16,16,30,32,33,33,33,32,33,32,33,32,33,33,32,33,32,33,25,27,29,32,33,25,27,31,31,29,33,33,31,33,32,33,32,33,32,33,33],"start":[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,4,4,5,5,5,6,8,8,8,9,13,14,14,15,15,18,18,19,20,20,22,22,23,23,23,23,23,24,24,24,25,26,26,27,28,28,29,29,30,30,31,31,32]},"selected":{"id":"29843"},"selection_policy":{"id":"29842"}},"id":"29789","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.8},"line_color":{"value":"#CCCCCC"},"line_width":{"value":5}},"id":"29808","type":"MultiLine"},{"attributes":{"overlay":{"id":"29839"}},"id":"29779","type":"BoxSelectTool"},{"attributes":{},"id":"29842","type":"UnionRenderers"},{"attributes":{"plot_height":400,"plot_width":400,"renderers":[{"id":"29783"}],"title":{"id":"29776"},"toolbar":{"id":"29780"},"x_range":{"id":"29771"},"x_scale":{"id":"29827"},"y_range":{"id":"29772"},"y_scale":{"id":"29829"}},"id":"29773","type":"Plot"},{"attributes":{"source":{"id":"29789"}},"id":"29791","type":"CDSView"},{"attributes":{"fill_color":{"value":"#fdae61"},"size":{"units":"screen","value":15}},"id":"29798","type":"Circle"}],"root_ids":["29773"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"f3cab5a5-d287-43f1-a3e3-c68c0546a48b","root_ids":["29773"],"roots":{"29773":"b69a25e3-fa7b-4a97-b7db-1943b59f8ca2"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();