(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("bd04728c-eec5-426a-8344-341dfe042102");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'bd04728c-eec5-426a-8344-341dfe042102' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"1404c6e9-d2fa-4f0f-9497-506ec793b750":{"roots":{"references":[{"attributes":{},"id":"24863","type":"UnionRenderers"},{"attributes":{"formatter":{"id":"24860"},"ticker":{"id":"24842"}},"id":"24841","type":"LinearAxis"},{"attributes":{"axis":{"id":"24845"},"dimension":1,"ticker":null},"id":"24848","type":"Grid"},{"attributes":{"data_source":{"id":"24831"},"glyph":{"id":"24853"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"24854"},"selection_glyph":null,"view":{"id":"24856"}},"id":"24855","type":"GlyphRenderer"},{"attributes":{"end":3},"id":"24835","type":"Range1d"},{"attributes":{"source":{"id":"24831"}},"id":"24856","type":"CDSView"},{"attributes":{},"id":"24864","type":"Selection"},{"attributes":{},"id":"24839","type":"LinearScale"},{"attributes":{"items":[{"id":"24866"},{"id":"24867"}]},"id":"24865","type":"Legend"},{"attributes":{"fill_color":{"field":"color"},"line_color":{"field":"color"},"radius":{"units":"data","value":0.5},"x":{"field":"x"},"y":{"field":"y"}},"id":"24853","type":"Circle"},{"attributes":{"index":0,"label":{"value":"hi"},"renderers":[{"id":"24855"}]},"id":"24866","type":"LegendItem"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"24849"}]},"id":"24850","type":"Toolbar"},{"attributes":{},"id":"24862","type":"BasicTickFormatter"},{"attributes":{"text":""},"id":"24857","type":"Title"},{"attributes":{"formatter":{"id":"24862"},"ticker":{"id":"24846"}},"id":"24845","type":"LinearAxis"},{"attributes":{},"id":"24846","type":"BasicTicker"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"color"},"line_alpha":{"value":0.1},"line_color":{"field":"color"},"radius":{"units":"data","value":0.5},"x":{"field":"x"},"y":{"field":"y"}},"id":"24854","type":"Circle"},{"attributes":{"data":{"color":["#ef8a62","#67a9cf","#ef8a62","#67a9cf","#ef8a62","#67a9cf"],"label":["hi","lo","hi","lo","hi","lo"],"x":[1,2,3,4,5,6],"y":[2,1,2,1,2,1]},"selected":{"id":"24864"},"selection_policy":{"id":"24863"}},"id":"24831","type":"ColumnDataSource"},{"attributes":{},"id":"24842","type":"BasicTicker"},{"attributes":{"index":1,"label":{"value":"lo"},"renderers":[{"id":"24855"}]},"id":"24867","type":"LegendItem"},{"attributes":{"below":[{"id":"24841"}],"center":[{"id":"24844"},{"id":"24848"},{"id":"24865"}],"left":[{"id":"24845"}],"plot_height":300,"renderers":[{"id":"24855"}],"title":{"id":"24857"},"toolbar":{"id":"24850"},"x_range":{"id":"24833"},"x_scale":{"id":"24837"},"y_range":{"id":"24835"},"y_scale":{"id":"24839"}},"id":"24832","subtype":"Figure","type":"Plot"},{"attributes":{"end":7},"id":"24833","type":"Range1d"},{"attributes":{"axis":{"id":"24841"},"ticker":null},"id":"24844","type":"Grid"},{"attributes":{},"id":"24837","type":"LinearScale"},{"attributes":{},"id":"24860","type":"BasicTickFormatter"},{"attributes":{},"id":"24849","type":"SaveTool"}],"root_ids":["24832"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"1404c6e9-d2fa-4f0f-9497-506ec793b750","root_ids":["24832"],"roots":{"24832":"bd04728c-eec5-426a-8344-341dfe042102"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();