(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("f68aea9f-fce2-4fb9-9c0b-9ea4030cfb69");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'f68aea9f-fce2-4fb9-9c0b-9ea4030cfb69' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"22136131-b8fe-4674-af6a-c2026549280c":{"roots":{"references":[{"attributes":{"data_source":{"id":"24451"},"glyph":{"id":"24452"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"24453"},"selection_glyph":null,"view":{"id":"24455"}},"id":"24454","type":"GlyphRenderer"},{"attributes":{"source":{"id":"24451"}},"id":"24455","type":"CDSView"},{"attributes":{},"id":"24468","type":"Selection"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"24452","type":"Circle"},{"attributes":{},"id":"24434","type":"BasicTicker"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"24453","type":"Circle"},{"attributes":{},"id":"24425","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"24437"},{"id":"24438"},{"id":"24439"},{"id":"24440"},{"id":"24441"},{"id":"24442"}]},"id":"24444","type":"Toolbar"},{"attributes":{},"id":"24421","type":"DataRange1d"},{"attributes":{},"id":"24438","type":"WheelZoomTool"},{"attributes":{"data":{"x":[1,2],"y":[3,4]},"selected":{"id":"24468"},"selection_policy":{"id":"24467"}},"id":"24451","type":"ColumnDataSource"},{"attributes":{},"id":"24442","type":"HelpTool"},{"attributes":{"formatter":{"id":"24466"},"ticker":{"id":"24434"}},"id":"24433","type":"LinearAxis"},{"attributes":{"axis":{"id":"24433"},"dimension":1,"ticker":null},"id":"24436","type":"Grid"},{"attributes":{"formatter":{"id":"24464"},"ticker":{"id":"24430"}},"id":"24429","type":"LinearAxis"},{"attributes":{},"id":"24427","type":"LinearScale"},{"attributes":{},"id":"24464","type":"BasicTickFormatter"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"24443","type":"BoxAnnotation"},{"attributes":{},"id":"24440","type":"SaveTool"},{"attributes":{},"id":"24467","type":"UnionRenderers"},{"attributes":{"below":[{"id":"24429"}],"center":[{"id":"24432"},{"id":"24436"}],"left":[{"id":"24433"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"24454"}],"title":{"id":"24456"},"toolbar":{"id":"24444"},"x_range":{"id":"24421"},"x_scale":{"id":"24425"},"y_range":{"id":"24423"},"y_scale":{"id":"24427"}},"id":"24420","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"24423","type":"DataRange1d"},{"attributes":{},"id":"24437","type":"PanTool"},{"attributes":{"align":"right","background_fill_color":"#aaaaee","text":"Title With Options","text_color":{"value":"orange"},"text_font_size":{"value":"25px"}},"id":"24456","type":"Title"},{"attributes":{},"id":"24466","type":"BasicTickFormatter"},{"attributes":{"overlay":{"id":"24443"}},"id":"24439","type":"BoxZoomTool"},{"attributes":{},"id":"24430","type":"BasicTicker"},{"attributes":{},"id":"24441","type":"ResetTool"},{"attributes":{"axis":{"id":"24429"},"ticker":null},"id":"24432","type":"Grid"}],"root_ids":["24420"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"22136131-b8fe-4674-af6a-c2026549280c","root_ids":["24420"],"roots":{"24420":"f68aea9f-fce2-4fb9-9c0b-9ea4030cfb69"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();