(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("55f8d1c2-a862-48fc-8ee4-327b4d69e9a1");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '55f8d1c2-a862-48fc-8ee4-327b4d69e9a1' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"ec34e410-ba05-4967-a818-98142917cebf":{"roots":{"references":[{"attributes":{"source":{"id":"25154"}},"id":"25158","type":"CDSView"},{"attributes":{},"id":"25124","type":"DataRange1d"},{"attributes":{},"id":"25133","type":"BasicTicker"},{"attributes":{"end":{"id":"25162"},"source":null,"start":null,"x_end":{"value":0.5},"x_start":{"value":1},"y_end":{"value":0.7},"y_start":{"value":0}},"id":"25163","type":"Arrow"},{"attributes":{"formatter":{"id":"25171"},"ticker":{"id":"25133"}},"id":"25132","type":"LinearAxis"},{"attributes":{},"id":"25137","type":"BasicTicker"},{"attributes":{"text":""},"id":"25168","type":"Title"},{"attributes":{"data":{"fill_color":["navy","yellow","red"],"line_color":["navy","yellow","red"],"x":[0,1,0.5],"y":[0,0,0.7]},"selected":{"id":"25175"},"selection_policy":{"id":"25174"}},"id":"25154","type":"ColumnDataSource"},{"attributes":{},"id":"25175","type":"Selection"},{"attributes":{},"id":"25174","type":"UnionRenderers"},{"attributes":{},"id":"25143","type":"SaveTool"},{"attributes":{},"id":"25145","type":"HelpTool"},{"attributes":{},"id":"25171","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fill_color"},"line_color":{"field":"line_color"},"radius":{"units":"data","value":0.1},"x":{"field":"x"},"y":{"field":"y"}},"id":"25155","type":"Circle"},{"attributes":{"formatter":{"id":"25173"},"ticker":{"id":"25137"}},"id":"25136","type":"LinearAxis"},{"attributes":{"axis":{"id":"25136"},"dimension":1,"ticker":null},"id":"25139","type":"Grid"},{"attributes":{},"id":"25128","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"25140"},{"id":"25141"},{"id":"25142"},{"id":"25143"},{"id":"25144"},{"id":"25145"}]},"id":"25147","type":"Toolbar"},{"attributes":{"below":[{"id":"25132"}],"center":[{"id":"25135"},{"id":"25139"},{"id":"25160"},{"id":"25163"},{"id":"25166"}],"left":[{"id":"25136"}],"renderers":[{"id":"25157"}],"title":{"id":"25168"},"toolbar":{"id":"25147"},"x_range":{"id":"25124"},"x_scale":{"id":"25128"},"y_range":{"id":"25126"},"y_scale":{"id":"25130"}},"id":"25123","subtype":"Figure","type":"Plot"},{"attributes":{"axis":{"id":"25132"},"ticker":null},"id":"25135","type":"Grid"},{"attributes":{"line_color":"firebrick","line_width":4},"id":"25159","type":"OpenHead"},{"attributes":{"size":35},"id":"25165","type":"VeeHead"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fill_color"},"line_alpha":{"value":0.1},"line_color":{"field":"line_color"},"radius":{"units":"data","value":0.1},"x":{"field":"x"},"y":{"field":"y"}},"id":"25156","type":"Circle"},{"attributes":{},"id":"25144","type":"ResetTool"},{"attributes":{},"id":"25126","type":"DataRange1d"},{"attributes":{"fill_color":"orange"},"id":"25162","type":"NormalHead"},{"attributes":{"data_source":{"id":"25154"},"glyph":{"id":"25155"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"25156"},"selection_glyph":null,"view":{"id":"25158"}},"id":"25157","type":"GlyphRenderer"},{"attributes":{"end":{"id":"25165"},"line_color":{"value":"red"},"source":null,"start":null,"x_end":{"value":0},"x_start":{"value":0.5},"y_end":{"value":0},"y_start":{"value":0.7}},"id":"25166","type":"Arrow"},{"attributes":{"overlay":{"id":"25146"}},"id":"25142","type":"BoxZoomTool"},{"attributes":{"end":{"id":"25159"},"source":null,"start":null,"x_end":{"value":1},"x_start":{"value":0},"y_end":{"value":0},"y_start":{"value":0}},"id":"25160","type":"Arrow"},{"attributes":{},"id":"25140","type":"PanTool"},{"attributes":{},"id":"25141","type":"WheelZoomTool"},{"attributes":{},"id":"25173","type":"BasicTickFormatter"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"25146","type":"BoxAnnotation"},{"attributes":{},"id":"25130","type":"LinearScale"}],"root_ids":["25123"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"ec34e410-ba05-4967-a818-98142917cebf","root_ids":["25123"],"roots":{"25123":"55f8d1c2-a862-48fc-8ee4-327b4d69e9a1"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();