(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("ae65c2e6-5b2b-41f2-a29e-fa7a01803cf9");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'ae65c2e6-5b2b-41f2-a29e-fa7a01803cf9' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"b1d610b4-bcca-4c05-ad69-ec2ae1035a33":{"roots":{"references":[{"attributes":{},"id":"37173","type":"BasicTicker"},{"attributes":{"line_color":"pink","x":{"field":"x"},"y":{"field":"y"}},"id":"37187","type":"Line"},{"attributes":{},"id":"37196","type":"BasicTickFormatter"},{"attributes":{},"id":"37164","type":"DataRange1d"},{"attributes":{"data_source":{"id":"37181"},"glyph":{"id":"37182"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37183"},"selection_glyph":null,"view":{"id":"37185"}},"id":"37184","type":"GlyphRenderer"},{"attributes":{},"id":"37194","type":"BasicTickFormatter"},{"attributes":{"line_alpha":0.1,"line_color":"pink","x":{"field":"x"},"y":{"field":"y"}},"id":"37188","type":"Line"},{"attributes":{},"id":"37177","type":"BasicTicker"},{"attributes":{"formatter":{"id":"37196"},"ticker":{"id":"37177"}},"id":"37176","type":"LinearAxis"},{"attributes":{},"id":"37170","type":"LinearScale"},{"attributes":{},"id":"37197","type":"UnionRenderers"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto"},"id":"37180","type":"Toolbar"},{"attributes":{},"id":"37198","type":"Selection"},{"attributes":{},"id":"37200","type":"Selection"},{"attributes":{"below":[{"id":"37172"}],"center":[{"id":"37175"},{"id":"37179"}],"left":[{"id":"37176"}],"plot_height":200,"plot_width":500,"renderers":[{"id":"37184"},{"id":"37189"}],"title":{"id":"37191"},"toolbar":{"id":"37180"},"x_range":{"id":"37164"},"x_scale":{"id":"37168"},"y_range":{"id":"37166"},"y_scale":{"id":"37170"}},"id":"37163","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"37166","type":"DataRange1d"},{"attributes":{"formatter":{"id":"37194"},"ticker":{"id":"37173"},"visible":false},"id":"37172","type":"LinearAxis"},{"attributes":{"line_alpha":0.1,"line_color":"blue","x":{"field":"x"},"y":{"field":"y"}},"id":"37183","type":"Line"},{"attributes":{"data":{"x":[1,2,3],"y":[2,1,2]},"selected":{"id":"37200"},"selection_policy":{"id":"37199"}},"id":"37186","type":"ColumnDataSource"},{"attributes":{"line_color":"blue","x":{"field":"x"},"y":{"field":"y"}},"id":"37182","type":"Line"},{"attributes":{"source":{"id":"37186"}},"id":"37190","type":"CDSView"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,1]},"selected":{"id":"37198"},"selection_policy":{"id":"37197"}},"id":"37181","type":"ColumnDataSource"},{"attributes":{},"id":"37168","type":"LinearScale"},{"attributes":{"source":{"id":"37181"}},"id":"37185","type":"CDSView"},{"attributes":{"axis":{"id":"37176"},"dimension":1,"ticker":null},"id":"37179","type":"Grid"},{"attributes":{"axis":{"id":"37172"},"ticker":null,"visible":false},"id":"37175","type":"Grid"},{"attributes":{"data_source":{"id":"37186"},"glyph":{"id":"37187"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37188"},"selection_glyph":null,"view":{"id":"37190"},"visible":false},"id":"37189","type":"GlyphRenderer"},{"attributes":{"text":""},"id":"37191","type":"Title"},{"attributes":{},"id":"37199","type":"UnionRenderers"}],"root_ids":["37163"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"b1d610b4-bcca-4c05-ad69-ec2ae1035a33","root_ids":["37163"],"roots":{"37163":"ae65c2e6-5b2b-41f2-a29e-fa7a01803cf9"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();