(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("d1dad29f-6ee4-40b9-9ed3-42690384b332");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'd1dad29f-6ee4-40b9-9ed3-42690384b332' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"2dcabc40-10e4-4a43-8689-dccd61d317a7":{"roots":{"references":[{"attributes":{"formatter":{"id":"37125"},"ticker":{"id":"37096"}},"id":"37095","type":"LinearAxis"},{"attributes":{"data":{"x":[1,2,3,4,5,7,8,9,10],"y":[1,2,3,4,5,7,8,9,10]},"selected":{"id":"37131"},"selection_policy":{"id":"37130"}},"id":"37083","type":"ColumnDataSource"},{"attributes":{},"id":"37127","type":"BasicTickFormatter"},{"attributes":{},"id":"37103","type":"PanTool"},{"attributes":{"source":{"id":"37083"}},"id":"37121","type":"CDSView"},{"attributes":{},"id":"37093","type":"LinearScale"},{"attributes":{"color_mapper":{"id":"37082"},"formatter":{"id":"37127"},"location":[0,0],"ticker":{"id":"37126"},"width":8},"id":"37122","type":"ColorBar"},{"attributes":{},"id":"37107","type":"ResetTool"},{"attributes":{"axis":{"id":"37099"},"dimension":1,"ticker":null},"id":"37102","type":"Grid"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"37109","type":"BoxAnnotation"},{"attributes":{},"id":"37131","type":"Selection"},{"attributes":{"axis":{"id":"37095"},"ticker":null},"id":"37098","type":"Grid"},{"attributes":{"data_source":{"id":"37083"},"glyph":{"id":"37118"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"37119"},"selection_glyph":null,"view":{"id":"37121"}},"id":"37120","type":"GlyphRenderer"},{"attributes":{},"id":"37096","type":"BasicTicker"},{"attributes":{},"id":"37089","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"37103"},{"id":"37104"},{"id":"37105"},{"id":"37106"},{"id":"37107"},{"id":"37108"}]},"id":"37110","type":"Toolbar"},{"attributes":{},"id":"37104","type":"WheelZoomTool"},{"attributes":{},"id":"37108","type":"HelpTool"},{"attributes":{},"id":"37100","type":"BasicTicker"},{"attributes":{"overlay":{"id":"37109"}},"id":"37105","type":"BoxZoomTool"},{"attributes":{},"id":"37126","type":"BasicTicker"},{"attributes":{},"id":"37129","type":"BasicTickFormatter"},{"attributes":{"fill_color":{"field":"y","transform":{"id":"37082"}},"line_color":{"field":"y","transform":{"id":"37082"}},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"37118","type":"Circle"},{"attributes":{},"id":"37091","type":"LinearScale"},{"attributes":{},"id":"37106","type":"SaveTool"},{"attributes":{},"id":"37087","type":"DataRange1d"},{"attributes":{},"id":"37125","type":"BasicTickFormatter"},{"attributes":{},"id":"37130","type":"UnionRenderers"},{"attributes":{"below":[{"id":"37095"}],"center":[{"id":"37098"},{"id":"37102"}],"left":[{"id":"37099"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"37120"}],"right":[{"id":"37122"}],"title":{"id":"37085"},"toolbar":{"id":"37110"},"x_range":{"id":"37087"},"x_scale":{"id":"37091"},"y_range":{"id":"37089"},"y_scale":{"id":"37093"}},"id":"37084","subtype":"Figure","type":"Plot"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"y","transform":{"id":"37082"}},"line_alpha":{"value":0.1},"line_color":{"field":"y","transform":{"id":"37082"}},"size":{"units":"screen","value":12},"x":{"field":"x"},"y":{"field":"y"}},"id":"37119","type":"Circle"},{"attributes":{"formatter":{"id":"37129"},"ticker":{"id":"37100"}},"id":"37099","type":"LinearAxis"},{"attributes":{"high":10,"low":1,"palette":["#3288bd","#99d594","#e6f598","#fee08b","#fc8d59","#d53e4f"]},"id":"37082","type":"LinearColorMapper"},{"attributes":{"text":"Linear Color Map Based on Y"},"id":"37085","type":"Title"}],"root_ids":["37084"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"2dcabc40-10e4-4a43-8689-dccd61d317a7","root_ids":["37084"],"roots":{"37084":"d1dad29f-6ee4-40b9-9ed3-42690384b332"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();