(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("913bf8e7-3804-4263-964f-28caf0184fc7");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '913bf8e7-3804-4263-964f-28caf0184fc7' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"65cb1786-2482-4c06-b0b6-aa0aaa2b69ee":{"roots":{"references":[{"attributes":{},"id":"38716","type":"LinearScale"},{"attributes":{"axis":{"id":"38720"},"ticker":null},"id":"38723","type":"Grid"},{"attributes":{"below":[{"id":"38720"}],"center":[{"id":"38723"},{"id":"38727"}],"left":[{"id":"38724"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"38745"}],"title":{"id":"38747"},"toolbar":{"id":"38735"},"x_range":{"id":"38712"},"x_scale":{"id":"38716"},"y_range":{"id":"38714"},"y_scale":{"id":"38718"}},"id":"38711","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"38718","type":"LinearScale"},{"attributes":{},"id":"38721","type":"BasicTicker"},{"attributes":{},"id":"38753","type":"UnionRenderers"},{"attributes":{},"id":"38728","type":"PanTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"38734","type":"BoxAnnotation"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"38744","type":"Circle"},{"attributes":{},"id":"38731","type":"SaveTool"},{"attributes":{},"id":"38733","type":"HelpTool"},{"attributes":{},"id":"38754","type":"Selection"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"38743","type":"Circle"},{"attributes":{"overlay":{"id":"38734"}},"id":"38730","type":"BoxZoomTool"},{"attributes":{"data_source":{"id":"38742"},"glyph":{"id":"38743"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"38744"},"selection_glyph":null,"view":{"id":"38746"}},"id":"38745","type":"GlyphRenderer"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"38754"},"selection_policy":{"id":"38753"}},"id":"38742","type":"ColumnDataSource"},{"attributes":{"text":""},"id":"38747","type":"Title"},{"attributes":{"axis":{"id":"38724"},"dimension":1,"ticker":null},"id":"38727","type":"Grid"},{"attributes":{},"id":"38750","type":"BasicTickFormatter"},{"attributes":{},"id":"38725","type":"BasicTicker"},{"attributes":{},"id":"38729","type":"WheelZoomTool"},{"attributes":{},"id":"38752","type":"BasicTickFormatter"},{"attributes":{},"id":"38714","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"38728"},{"id":"38729"},{"id":"38730"},{"id":"38731"},{"id":"38732"},{"id":"38733"}]},"id":"38735","type":"Toolbar"},{"attributes":{},"id":"38732","type":"ResetTool"},{"attributes":{"axis_label":"Temp","axis_line_color":"red","axis_line_width":3,"formatter":{"id":"38750"},"minor_tick_in":-3,"minor_tick_out":6,"ticker":{"id":"38721"}},"id":"38720","type":"LinearAxis"},{"attributes":{},"id":"38712","type":"DataRange1d"},{"attributes":{"axis_label":"Pressure","formatter":{"id":"38752"},"major_label_orientation":"vertical","major_label_text_color":"orange","minor_tick_in":-3,"minor_tick_out":6,"ticker":{"id":"38725"}},"id":"38724","type":"LinearAxis"},{"attributes":{"source":{"id":"38742"}},"id":"38746","type":"CDSView"}],"root_ids":["38711"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"65cb1786-2482-4c06-b0b6-aa0aaa2b69ee","root_ids":["38711"],"roots":{"38711":"913bf8e7-3804-4263-964f-28caf0184fc7"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();