(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("d54ba99f-6e1f-4b9e-8904-a3a329e559c1");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'd54ba99f-6e1f-4b9e-8904-a3a329e559c1' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"ec7e9624-c104-43cc-84fb-3a3826042b34":{"roots":{"references":[{"attributes":{},"id":"36119","type":"LinearScale"},{"attributes":{"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"36144","type":"Line"},{"attributes":{"text":"simple line example"},"id":"36111","type":"Title"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"36145","type":"Line"},{"attributes":{},"id":"36134","type":"HelpTool"},{"attributes":{},"id":"36113","type":"DataRange1d"},{"attributes":{"source":{"id":"36143"}},"id":"36147","type":"CDSView"},{"attributes":{},"id":"36129","type":"PanTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"36129"},{"id":"36130"},{"id":"36131"},{"id":"36132"},{"id":"36133"},{"id":"36134"}]},"id":"36136","type":"Toolbar"},{"attributes":{},"id":"36115","type":"DataRange1d"},{"attributes":{},"id":"36153","type":"UnionRenderers"},{"attributes":{},"id":"36122","type":"BasicTicker"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,2,4,5]},"selected":{"id":"36154"},"selection_policy":{"id":"36153"}},"id":"36143","type":"ColumnDataSource"},{"attributes":{},"id":"36152","type":"BasicTickFormatter"},{"attributes":{"overlay":{"id":"36135"}},"id":"36131","type":"BoxZoomTool"},{"attributes":{"items":[{"id":"36157"}]},"id":"36156","type":"Legend"},{"attributes":{},"id":"36133","type":"ResetTool"},{"attributes":{"axis":{"id":"36125"},"dimension":1,"ticker":null},"id":"36128","type":"Grid"},{"attributes":{"below":[{"id":"36121"}],"center":[{"id":"36124"},{"id":"36128"},{"id":"36156"}],"left":[{"id":"36125"}],"renderers":[{"id":"36146"}],"title":{"id":"36111"},"toolbar":{"id":"36136"},"x_range":{"id":"36113"},"x_scale":{"id":"36117"},"y_range":{"id":"36115"},"y_scale":{"id":"36119"}},"id":"36110","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"36150","type":"BasicTickFormatter"},{"attributes":{},"id":"36154","type":"Selection"},{"attributes":{},"id":"36126","type":"BasicTicker"},{"attributes":{"axis":{"id":"36121"},"ticker":null},"id":"36124","type":"Grid"},{"attributes":{"data_source":{"id":"36143"},"glyph":{"id":"36144"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"36145"},"selection_glyph":null,"view":{"id":"36147"}},"id":"36146","type":"GlyphRenderer"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"36135","type":"BoxAnnotation"},{"attributes":{"axis_label":"y","formatter":{"id":"36152"},"ticker":{"id":"36126"}},"id":"36125","type":"LinearAxis"},{"attributes":{},"id":"36117","type":"LinearScale"},{"attributes":{},"id":"36130","type":"WheelZoomTool"},{"attributes":{"axis_label":"x","formatter":{"id":"36150"},"ticker":{"id":"36122"}},"id":"36121","type":"LinearAxis"},{"attributes":{"label":{"value":"Temp."},"renderers":[{"id":"36146"}]},"id":"36157","type":"LegendItem"},{"attributes":{},"id":"36132","type":"SaveTool"}],"root_ids":["36110"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"ec7e9624-c104-43cc-84fb-3a3826042b34","root_ids":["36110"],"roots":{"36110":"d54ba99f-6e1f-4b9e-8904-a3a329e559c1"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();