(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("0f113a4c-6736-407f-9459-a6b8eb19e377");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '0f113a4c-6736-407f-9459-a6b8eb19e377' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"44c3494b-71b8-4a67-9aee-a5bb52e36b36":{"roots":{"references":[{"attributes":{"end_angle":{"units":"rad","value":4.8},"fill_alpha":{"value":0.6},"fill_color":{"value":"green"},"inner_radius":{"units":"data","value":0.1},"line_alpha":{"value":0.6},"line_color":{"value":"green"},"outer_radius":{"units":"data","value":0.25},"start_angle":{"units":"rad","value":0.4},"x":{"field":"x"},"y":{"field":"y"}},"id":"35469","type":"AnnularWedge"},{"attributes":{"axis":{"id":"35450"},"dimension":1,"ticker":null},"id":"35453","type":"Grid"},{"attributes":{},"id":"35440","type":"DataRange1d"},{"attributes":{},"id":"35447","type":"BasicTicker"},{"attributes":{},"id":"35458","type":"ResetTool"},{"attributes":{"end_angle":{"units":"rad","value":4.8},"fill_alpha":{"value":0.1},"fill_color":{"value":"green"},"inner_radius":{"units":"data","value":0.1},"line_alpha":{"value":0.1},"line_color":{"value":"green"},"outer_radius":{"units":"data","value":0.25},"start_angle":{"units":"rad","value":0.4},"x":{"field":"x"},"y":{"field":"y"}},"id":"35470","type":"AnnularWedge"},{"attributes":{},"id":"35455","type":"WheelZoomTool"},{"attributes":{"overlay":{"id":"35460"}},"id":"35456","type":"BoxZoomTool"},{"attributes":{},"id":"35476","type":"BasicTickFormatter"},{"attributes":{},"id":"35459","type":"HelpTool"},{"attributes":{"text":""},"id":"35473","type":"Title"},{"attributes":{},"id":"35478","type":"BasicTickFormatter"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"35460","type":"BoxAnnotation"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"35454"},{"id":"35455"},{"id":"35456"},{"id":"35457"},{"id":"35458"},{"id":"35459"}]},"id":"35461","type":"Toolbar"},{"attributes":{"axis":{"id":"35446"},"ticker":null},"id":"35449","type":"Grid"},{"attributes":{},"id":"35444","type":"LinearScale"},{"attributes":{},"id":"35454","type":"PanTool"},{"attributes":{},"id":"35479","type":"UnionRenderers"},{"attributes":{},"id":"35438","type":"DataRange1d"},{"attributes":{"source":{"id":"35468"}},"id":"35472","type":"CDSView"},{"attributes":{"formatter":{"id":"35478"},"ticker":{"id":"35451"}},"id":"35450","type":"LinearAxis"},{"attributes":{"data_source":{"id":"35468"},"glyph":{"id":"35469"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"35470"},"selection_glyph":null,"view":{"id":"35472"}},"id":"35471","type":"GlyphRenderer"},{"attributes":{"below":[{"id":"35446"}],"center":[{"id":"35449"},{"id":"35453"}],"left":[{"id":"35450"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"35471"}],"title":{"id":"35473"},"toolbar":{"id":"35461"},"x_range":{"id":"35438"},"x_scale":{"id":"35442"},"y_range":{"id":"35440"},"y_scale":{"id":"35444"}},"id":"35437","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"35476"},"ticker":{"id":"35447"}},"id":"35446","type":"LinearAxis"},{"attributes":{},"id":"35442","type":"LinearScale"},{"attributes":{"data":{"x":[1,2,3],"y":[1,2,3]},"selected":{"id":"35480"},"selection_policy":{"id":"35479"}},"id":"35468","type":"ColumnDataSource"},{"attributes":{},"id":"35451","type":"BasicTicker"},{"attributes":{},"id":"35457","type":"SaveTool"},{"attributes":{},"id":"35480","type":"Selection"}],"root_ids":["35437"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"44c3494b-71b8-4a67-9aee-a5bb52e36b36","root_ids":["35437"],"roots":{"35437":"0f113a4c-6736-407f-9459-a6b8eb19e377"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();