(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("8dfb438c-f67f-4834-8a8c-0e0581f542d1");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '8dfb438c-f67f-4834-8a8c-0e0581f542d1' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"e717d883-6d23-473a-bb8e-dd29fe1e5645":{"roots":{"references":[{"attributes":{},"id":"33625","type":"SaveTool"},{"attributes":{"formatter":{"id":"33646"},"ticker":{"id":"33619"}},"id":"33618","type":"LinearAxis"},{"attributes":{"axis":{"id":"33618"},"dimension":1,"ticker":null},"id":"33621","type":"Grid"},{"attributes":{"text":""},"id":"33641","type":"Title"},{"attributes":{},"id":"33623","type":"WheelZoomTool"},{"attributes":{},"id":"33622","type":"PanTool"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"33638","type":"Line"},{"attributes":{},"id":"33644","type":"BasicTickFormatter"},{"attributes":{},"id":"33608","type":"DataRange1d"},{"attributes":{},"id":"33626","type":"ResetTool"},{"attributes":{"data":{"x":[1,2,3,"NaN",4,5],"y":[6,7,2,4,4,5]},"selected":{"id":"33648"},"selection_policy":{"id":"33647"}},"id":"33636","type":"ColumnDataSource"},{"attributes":{},"id":"33627","type":"HelpTool"},{"attributes":{},"id":"33612","type":"LinearScale"},{"attributes":{"source":{"id":"33636"}},"id":"33640","type":"CDSView"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"33628","type":"BoxAnnotation"},{"attributes":{},"id":"33646","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"33614"},"ticker":null},"id":"33617","type":"Grid"},{"attributes":{"line_color":"#1f77b4","line_width":2,"x":{"field":"x"},"y":{"field":"y"}},"id":"33637","type":"Line"},{"attributes":{},"id":"33647","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"33636"},"glyph":{"id":"33637"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"33638"},"selection_glyph":null,"view":{"id":"33640"}},"id":"33639","type":"GlyphRenderer"},{"attributes":{"overlay":{"id":"33628"}},"id":"33624","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"33644"},"ticker":{"id":"33615"}},"id":"33614","type":"LinearAxis"},{"attributes":{},"id":"33619","type":"BasicTicker"},{"attributes":{"below":[{"id":"33614"}],"center":[{"id":"33617"},{"id":"33621"}],"left":[{"id":"33618"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"33639"}],"title":{"id":"33641"},"toolbar":{"id":"33629"},"x_range":{"id":"33606"},"x_scale":{"id":"33610"},"y_range":{"id":"33608"},"y_scale":{"id":"33612"}},"id":"33605","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"33615","type":"BasicTicker"},{"attributes":{},"id":"33610","type":"LinearScale"},{"attributes":{},"id":"33606","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"33622"},{"id":"33623"},{"id":"33624"},{"id":"33625"},{"id":"33626"},{"id":"33627"}]},"id":"33629","type":"Toolbar"},{"attributes":{},"id":"33648","type":"Selection"}],"root_ids":["33605"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"e717d883-6d23-473a-bb8e-dd29fe1e5645","root_ids":["33605"],"roots":{"33605":"8dfb438c-f67f-4834-8a8c-0e0581f542d1"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();