(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("eea6a406-7402-4a4c-bba0-515ac688aeb5");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'eea6a406-7402-4a4c-bba0-515ac688aeb5' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"dd241762-17f9-4982-8e5e-6ba0189ea82a":{"roots":{"references":[{"attributes":{"end":54.66675212415547},"id":"25500","type":"Range1d"},{"attributes":{},"id":"25541","type":"Selection"},{"attributes":{"axis":{"id":"25510"},"dimension":1,"ticker":null},"id":"25513","type":"Grid"},{"attributes":{},"id":"25537","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],"y":{"__ndarray__":"gEihLx8L7z90D4l6ynAiQGY3eSCd9ShA33UMBy/+NEB8AMt8eYcyQCp5ITg5VDpA/K+PpZ6aOEAaQLPSHlwwQHwqEVbX8D9A1jxpau9CPUD6QxBRQ8w+QCCW4EjKYz5Au1Rh9JWFQkBRVnKcLJg7QM8ZUi7GNkJABvUdh3v8QUB1jZKGyddAQExFCXC39EZAWrKRBT88RUDEckbZONlIQA==","dtype":"float64","order":"little","shape":[20]}},"selected":{"id":"25541"},"selection_policy":{"id":"25540"}},"id":"25528","type":"ColumnDataSource"},{"attributes":{},"id":"25514","type":"PanTool"},{"attributes":{"axis_label":"y","formatter":{"id":"25539"},"ticker":{"id":"25511"}},"id":"25510","type":"LinearAxis"},{"attributes":{},"id":"25539","type":"BasicTickFormatter"},{"attributes":{},"id":"25540","type":"UnionRenderers"},{"attributes":{},"id":"25504","type":"LinearScale"},{"attributes":{"below":[{"id":"25506"}],"center":[{"id":"25509"},{"id":"25513"},{"id":"25533"}],"left":[{"id":"25510"}],"plot_height":450,"plot_width":450,"renderers":[{"id":"25531"}],"title":{"id":"25534"},"toolbar":{"id":"25521"},"x_range":{"id":"25498"},"x_scale":{"id":"25502"},"y_range":{"id":"25500"},"y_scale":{"id":"25504"}},"id":"25497","subtype":"Figure","type":"Plot"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"25514"},{"id":"25515"},{"id":"25516"},{"id":"25517"},{"id":"25518"},{"id":"25519"}]},"id":"25521","type":"Toolbar"},{"attributes":{},"id":"25515","type":"WheelZoomTool"},{"attributes":{},"id":"25502","type":"LinearScale"},{"attributes":{"text":""},"id":"25534","type":"Title"},{"attributes":{"gradient":2,"line_color":"orange","line_dash":[6],"line_width":3.5,"y_intercept":10},"id":"25533","type":"Slope"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"skyblue"},"line_alpha":{"value":0.1},"line_color":{"value":"skyblue"},"size":{"units":"screen","value":5},"x":{"field":"x"},"y":{"field":"y"}},"id":"25530","type":"Circle"},{"attributes":{"source":{"id":"25528"}},"id":"25532","type":"CDSView"},{"attributes":{"overlay":{"id":"25520"}},"id":"25516","type":"BoxZoomTool"},{"attributes":{"data_source":{"id":"25528"},"glyph":{"id":"25529"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"25530"},"selection_glyph":null,"view":{"id":"25532"}},"id":"25531","type":"GlyphRenderer"},{"attributes":{},"id":"25498","type":"DataRange1d"},{"attributes":{},"id":"25511","type":"BasicTicker"},{"attributes":{},"id":"25518","type":"ResetTool"},{"attributes":{},"id":"25519","type":"HelpTool"},{"attributes":{"axis":{"id":"25506"},"ticker":null},"id":"25509","type":"Grid"},{"attributes":{},"id":"25507","type":"BasicTicker"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"25520","type":"BoxAnnotation"},{"attributes":{"axis_label":"x","formatter":{"id":"25537"},"ticker":{"id":"25507"}},"id":"25506","type":"LinearAxis"},{"attributes":{},"id":"25517","type":"SaveTool"},{"attributes":{"fill_color":{"value":"skyblue"},"line_color":{"value":"skyblue"},"size":{"units":"screen","value":5},"x":{"field":"x"},"y":{"field":"y"}},"id":"25529","type":"Circle"}],"root_ids":["25497"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"dd241762-17f9-4982-8e5e-6ba0189ea82a","root_ids":["25497"],"roots":{"25497":"eea6a406-7402-4a4c-bba0-515ac688aeb5"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();