(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("db4cc4a5-56d0-4001-8169-64ba9238282e");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'db4cc4a5-56d0-4001-8169-64ba9238282e' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"0a2487d7-a122-45f5-a69e-515b5ff02101":{"roots":{"references":[{"attributes":{},"id":"29215","type":"ResetTool"},{"attributes":{"axis":{"id":"29195"},"ticker":null},"id":"29202","type":"Grid"},{"attributes":{"end":6000000,"start":-2000000},"id":"29187","type":"Range1d"},{"attributes":{},"id":"29211","type":"PanTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"29211"},{"id":"29212"},{"id":"29213"},{"id":"29214"},{"id":"29215"},{"id":"29216"}]},"id":"29218","type":"Toolbar"},{"attributes":{"overlay":{"id":"29217"}},"id":"29213","type":"BoxZoomTool"},{"attributes":{"dimension":"lon"},"id":"29198","type":"MercatorTickFormatter"},{"attributes":{},"id":"29216","type":"HelpTool"},{"attributes":{},"id":"29193","type":"LinearScale"},{"attributes":{"end":7000000,"start":-1000000},"id":"29189","type":"Range1d"},{"attributes":{},"id":"29214","type":"SaveTool"},{"attributes":{"attribution":"&amp;copy; &lt;a href=\\"https://www.openstreetmap.org/copyright\\"&gt;OpenStreetMap&lt;/a&gt; contributors,&amp;copy; &lt;a href=\\"https://cartodb.com/attributions\\"&gt;CartoDB&lt;/a&gt;","url":"https://tiles.basemaps.cartocdn.com/light_all/{z}/{x}/{y}.png"},"id":"29185","type":"WMTSTileSource"},{"attributes":{"tile_source":{"id":"29185"}},"id":"29225","type":"TileRenderer"},{"attributes":{},"id":"29191","type":"LinearScale"},{"attributes":{"below":[{"id":"29195"}],"center":[{"id":"29202"},{"id":"29210"}],"left":[{"id":"29203"}],"renderers":[{"id":"29225"}],"title":{"id":"29227"},"toolbar":{"id":"29218"},"x_range":{"id":"29187"},"x_scale":{"id":"29191"},"y_range":{"id":"29189"},"y_scale":{"id":"29193"}},"id":"29186","subtype":"Figure","type":"Plot"},{"attributes":{"dimension":"lat"},"id":"29206","type":"MercatorTickFormatter"},{"attributes":{"formatter":{"id":"29198"},"ticker":{"id":"29196"}},"id":"29195","type":"MercatorAxis"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"29217","type":"BoxAnnotation"},{"attributes":{"dimension":"lon"},"id":"29196","type":"MercatorTicker"},{"attributes":{},"id":"29212","type":"WheelZoomTool"},{"attributes":{"text":""},"id":"29227","type":"Title"},{"attributes":{"formatter":{"id":"29206"},"ticker":{"id":"29204"}},"id":"29203","type":"MercatorAxis"},{"attributes":{"dimension":"lat"},"id":"29204","type":"MercatorTicker"},{"attributes":{"axis":{"id":"29203"},"dimension":1,"ticker":null},"id":"29210","type":"Grid"}],"root_ids":["29186"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"0a2487d7-a122-45f5-a69e-515b5ff02101","root_ids":["29186"],"roots":{"29186":"db4cc4a5-56d0-4001-8169-64ba9238282e"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();