(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("88118339-3cb0-48c8-9a67-83c6c22969c9");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '88118339-3cb0-48c8-9a67-83c6c22969c9' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"c2886e0a-ec4d-497c-9fb3-e957f38ebcff":{"roots":{"references":[{"attributes":{"formatter":{"id":"39036"},"major_tick_line_color":"firebrick","major_tick_line_width":3,"major_tick_out":10,"minor_tick_in":-3,"minor_tick_line_color":"orange","minor_tick_out":8,"ticker":{"id":"39007"}},"id":"39006","type":"LinearAxis"},{"attributes":{},"id":"38998","type":"DataRange1d"},{"attributes":{"axis":{"id":"39006"},"ticker":null},"id":"39009","type":"Grid"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"39030","type":"Circle"},{"attributes":{},"id":"39002","type":"LinearScale"},{"attributes":{},"id":"39017","type":"SaveTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"39014"},{"id":"39015"},{"id":"39016"},{"id":"39017"},{"id":"39018"},{"id":"39019"}]},"id":"39021","type":"Toolbar"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"39040"},"selection_policy":{"id":"39039"}},"id":"39028","type":"ColumnDataSource"},{"attributes":{"source":{"id":"39028"}},"id":"39032","type":"CDSView"},{"attributes":{},"id":"39040","type":"Selection"},{"attributes":{},"id":"39007","type":"BasicTicker"},{"attributes":{"overlay":{"id":"39020"}},"id":"39016","type":"BoxZoomTool"},{"attributes":{},"id":"39036","type":"BasicTickFormatter"},{"attributes":{},"id":"39000","type":"DataRange1d"},{"attributes":{},"id":"39018","type":"ResetTool"},{"attributes":{"data_source":{"id":"39028"},"glyph":{"id":"39029"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"39030"},"selection_glyph":null,"view":{"id":"39032"}},"id":"39031","type":"GlyphRenderer"},{"attributes":{"axis":{"id":"39010"},"dimension":1,"ticker":null},"id":"39013","type":"Grid"},{"attributes":{"text":""},"id":"39033","type":"Title"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"39029","type":"Circle"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"39020","type":"BoxAnnotation"},{"attributes":{},"id":"39004","type":"LinearScale"},{"attributes":{},"id":"39011","type":"BasicTicker"},{"attributes":{},"id":"39014","type":"PanTool"},{"attributes":{},"id":"39038","type":"BasicTickFormatter"},{"attributes":{},"id":"39019","type":"HelpTool"},{"attributes":{},"id":"39039","type":"UnionRenderers"},{"attributes":{"below":[{"id":"39006"}],"center":[{"id":"39009"},{"id":"39013"}],"left":[{"id":"39010"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"39031"}],"title":{"id":"39033"},"toolbar":{"id":"39021"},"x_range":{"id":"38998"},"x_scale":{"id":"39002"},"y_range":{"id":"39000"},"y_scale":{"id":"39004"}},"id":"38997","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"39038"},"major_tick_out":10,"minor_tick_in":-3,"minor_tick_line_color":null,"minor_tick_out":8,"ticker":{"id":"39011"}},"id":"39010","type":"LinearAxis"},{"attributes":{},"id":"39015","type":"WheelZoomTool"}],"root_ids":["38997"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"c2886e0a-ec4d-497c-9fb3-e957f38ebcff","root_ids":["38997"],"roots":{"38997":"88118339-3cb0-48c8-9a67-83c6c22969c9"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();