(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("eaf9b4b4-fd11-4981-aa15-a0e6f59df9f3");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'eaf9b4b4-fd11-4981-aa15-a0e6f59df9f3' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"aeedddb4-b6c5-4fff-bdff-d7729cbef47b":{"roots":{"references":[{"attributes":{},"id":"26244","type":"CategoricalScale"},{"attributes":{},"id":"26255","type":"PanTool"},{"attributes":{"items":[{"id":"26284"}],"location":"top_center","orientation":"horizontal"},"id":"26283","type":"Legend"},{"attributes":{"overlay":{"id":"26261"}},"id":"26257","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"26279"},"ticker":{"id":"26252"}},"id":"26251","type":"LinearAxis"},{"attributes":{"below":[{"id":"26248"}],"center":[{"id":"26250"},{"id":"26254"},{"id":"26283"}],"left":[{"id":"26251"}],"plot_height":250,"renderers":[{"id":"26273"}],"title":{"id":"26238"},"toolbar":{"id":"26262"},"toolbar_location":null,"x_range":{"id":"26240"},"x_scale":{"id":"26244"},"y_range":{"id":"26242"},"y_scale":{"id":"26246"}},"id":"26237","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"26277","type":"CategoricalTickFormatter"},{"attributes":{},"id":"26258","type":"SaveTool"},{"attributes":{"fill_color":{"field":"fruits","transform":{"id":"26269"}},"line_color":{"value":"white"},"top":{"field":"counts"},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"26271","type":"VBar"},{"attributes":{},"id":"26249","type":"CategoricalTicker"},{"attributes":{},"id":"26252","type":"BasicTicker"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"26261","type":"BoxAnnotation"},{"attributes":{"formatter":{"id":"26277"},"ticker":{"id":"26249"}},"id":"26248","type":"CategoricalAxis"},{"attributes":{"axis":{"id":"26251"},"dimension":1,"ticker":null},"id":"26254","type":"Grid"},{"attributes":{"data_source":{"id":"26236"},"glyph":{"id":"26271"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"26272"},"selection_glyph":null,"view":{"id":"26274"}},"id":"26273","type":"GlyphRenderer"},{"attributes":{"source":{"id":"26236"}},"id":"26274","type":"CDSView"},{"attributes":{"axis":{"id":"26248"},"grid_line_color":null,"ticker":null},"id":"26250","type":"Grid"},{"attributes":{},"id":"26279","type":"BasicTickFormatter"},{"attributes":{"data":{"counts":[5,3,4,2,4,6],"fruits":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"selected":{"id":"26281"},"selection_policy":{"id":"26280"}},"id":"26236","type":"ColumnDataSource"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"26255"},{"id":"26256"},{"id":"26257"},{"id":"26258"},{"id":"26259"},{"id":"26260"}]},"id":"26262","type":"Toolbar"},{"attributes":{},"id":"26281","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"fruits","transform":{"id":"26269"}},"line_alpha":{"value":0.1},"line_color":{"value":"white"},"top":{"field":"counts"},"width":{"value":0.9},"x":{"field":"fruits"}},"id":"26272","type":"VBar"},{"attributes":{},"id":"26246","type":"LinearScale"},{"attributes":{},"id":"26280","type":"UnionRenderers"},{"attributes":{"factors":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"],"palette":["#3288bd","#99d594","#e6f598","#fee08b","#fc8d59","#d53e4f"]},"id":"26269","type":"CategoricalColorMapper"},{"attributes":{},"id":"26259","type":"ResetTool"},{"attributes":{"text":"Fruit Counts"},"id":"26238","type":"Title"},{"attributes":{"end":9,"start":0},"id":"26242","type":"DataRange1d"},{"attributes":{},"id":"26256","type":"WheelZoomTool"},{"attributes":{"factors":["Apples","Pears","Nectarines","Plums","Grapes","Strawberries"]},"id":"26240","type":"FactorRange"},{"attributes":{"label":{"field":"fruits"},"renderers":[{"id":"26273"}]},"id":"26284","type":"LegendItem"},{"attributes":{},"id":"26260","type":"HelpTool"}],"root_ids":["26237"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"aeedddb4-b6c5-4fff-bdff-d7729cbef47b","root_ids":["26237"],"roots":{"26237":"eaf9b4b4-fd11-4981-aa15-a0e6f59df9f3"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();