(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("f32b7288-3f04-4595-9c74-8d51140c3b48");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'f32b7288-3f04-4595-9c74-8d51140c3b48' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"33514042-a27b-4b33-99df-c7ea6951a84a":{"roots":{"references":[{"attributes":{},"id":"28190","type":"ResetTool"},{"attributes":{"axis":{"id":"28180"},"ticker":null},"id":"28183","type":"Grid"},{"attributes":{"formatter":{"id":"28214"},"ticker":{"id":"28181"}},"id":"28180","type":"LinearAxis"},{"attributes":{},"id":"28208","type":"Selection"},{"attributes":{},"id":"28143","type":"DataRange1d"},{"attributes":{"data_source":{"id":"28137"},"glyph":{"id":"28166"},"hover_glyph":{"id":"28168"},"muted_glyph":null,"nonselection_glyph":{"id":"28167"},"selection_glyph":null,"view":{"id":"28170"}},"id":"28169","type":"GlyphRenderer"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"28191","type":"BoxAnnotation"},{"attributes":{},"id":"28185","type":"BasicTicker"},{"attributes":{},"id":"28145","type":"LinearScale"},{"attributes":{},"id":"28172","type":"DataRange1d"},{"attributes":{"filters":[{"id":"28138"}],"source":{"id":"28137"}},"id":"28139","type":"CDSView"},{"attributes":{"toolbar":{"id":"28222"},"toolbar_location":"above"},"id":"28223","type":"ToolbarBox"},{"attributes":{"callback":null},"id":"28189","type":"HoverTool"},{"attributes":{},"id":"28154","type":"BasicTicker"},{"attributes":{},"id":"28141","type":"DataRange1d"},{"attributes":{},"id":"28150","type":"BasicTicker"},{"attributes":{"source":{"id":"28137"}},"id":"28170","type":"CDSView"},{"attributes":{},"id":"28214","type":"BasicTickFormatter"},{"attributes":{"overlay":{"id":"28160"}},"id":"28157","type":"BoxSelectTool"},{"attributes":{"axis":{"id":"28149"},"ticker":null},"id":"28152","type":"Grid"},{"attributes":{"axis":{"id":"28184"},"dimension":1,"ticker":null},"id":"28187","type":"Grid"},{"attributes":{},"id":"28147","type":"LinearScale"},{"attributes":{"callback":null},"id":"28158","type":"HoverTool"},{"attributes":{},"id":"28174","type":"DataRange1d"},{"attributes":{},"id":"28207","type":"UnionRenderers"},{"attributes":{"children":[{"id":"28223"},{"id":"28221"}]},"id":"28224","type":"Column"},{"attributes":{"fill_color":{"value":"red"},"line_color":{"value":"red"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"28199","type":"Circle"},{"attributes":{"text":""},"id":"28211","type":"Title"},{"attributes":{"indices":[0,2,4]},"id":"28138","type":"IndexFilter"},{"attributes":{"formatter":{"id":"28204"},"ticker":{"id":"28150"}},"id":"28149","type":"LinearAxis"},{"attributes":{},"id":"28176","type":"LinearScale"},{"attributes":{"toolbars":[{"id":"28161"},{"id":"28192"}],"tools":[{"id":"28157"},{"id":"28158"},{"id":"28159"},{"id":"28188"},{"id":"28189"},{"id":"28190"}]},"id":"28222","type":"ProxyToolbar"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"28188"},{"id":"28189"},{"id":"28190"}]},"id":"28192","type":"Toolbar"},{"attributes":{"fill_color":{"value":"red"},"line_color":{"value":"red"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"28168","type":"Circle"},{"attributes":{},"id":"28206","type":"BasicTickFormatter"},{"attributes":{"below":[{"id":"28180"}],"center":[{"id":"28183"},{"id":"28187"}],"left":[{"id":"28184"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"28200"}],"title":{"id":"28211"},"toolbar":{"id":"28192"},"toolbar_location":null,"x_range":{"id":"28172"},"x_scale":{"id":"28176"},"y_range":{"id":"28174"},"y_scale":{"id":"28178"}},"id":"28171","subtype":"Figure","type":"Plot"},{"attributes":{"axis":{"id":"28153"},"dimension":1,"ticker":null},"id":"28156","type":"Grid"},{"attributes":{"data_source":{"id":"28137"},"glyph":{"id":"28197"},"hover_glyph":{"id":"28199"},"muted_glyph":null,"nonselection_glyph":{"id":"28198"},"selection_glyph":null,"view":{"id":"28139"}},"id":"28200","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"28216"},"ticker":{"id":"28185"}},"id":"28184","type":"LinearAxis"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"28167","type":"Circle"},{"attributes":{},"id":"28181","type":"BasicTicker"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"28166","type":"Circle"},{"attributes":{"below":[{"id":"28149"}],"center":[{"id":"28152"},{"id":"28156"}],"left":[{"id":"28153"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"28169"}],"title":{"id":"28201"},"toolbar":{"id":"28161"},"toolbar_location":null,"x_range":{"id":"28141"},"x_scale":{"id":"28145"},"y_range":{"id":"28143"},"y_scale":{"id":"28147"}},"id":"28140","subtype":"Figure","type":"Plot"},{"attributes":{"overlay":{"id":"28191"}},"id":"28188","type":"BoxSelectTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"28198","type":"Circle"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"28160","type":"BoxAnnotation"},{"attributes":{"text":""},"id":"28201","type":"Title"},{"attributes":{},"id":"28216","type":"BasicTickFormatter"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"28157"},{"id":"28158"},{"id":"28159"}]},"id":"28161","type":"Toolbar"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"28197","type":"Circle"},{"attributes":{},"id":"28159","type":"ResetTool"},{"attributes":{},"id":"28204","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[1,2,3,4,5]},"selected":{"id":"28208"},"selection_policy":{"id":"28207"}},"id":"28137","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"28206"},"ticker":{"id":"28154"}},"id":"28153","type":"LinearAxis"},{"attributes":{},"id":"28178","type":"LinearScale"},{"attributes":{"children":[[{"id":"28140"},0,0],[{"id":"28171"},0,1]]},"id":"28221","type":"GridBox"}],"root_ids":["28224"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"33514042-a27b-4b33-99df-c7ea6951a84a","root_ids":["28224"],"roots":{"28224":"f32b7288-3f04-4595-9c74-8d51140c3b48"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();