(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("508e5d34-3c0f-4b5b-9f64-4949543e07f9");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '508e5d34-3c0f-4b5b-9f64-4949543e07f9' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"49370d9c-125d-462e-b70b-2e2d651e4130":{"roots":{"references":[{"attributes":{},"id":"24513","type":"BasicTicker"},{"attributes":{},"id":"24540","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"24530"}},"id":"24534","type":"CDSView"},{"attributes":{"formatter":{"id":"24540"},"ticker":{"id":"24513"}},"id":"24512","type":"LinearAxis"},{"attributes":{},"id":"24519","type":"SaveTool"},{"attributes":{},"id":"24521","type":"HelpTool"},{"attributes":{"data_source":{"id":"24530"},"glyph":{"id":"24531"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"24532"},"selection_glyph":null,"view":{"id":"24534"}},"id":"24533","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"24532","type":"Circle"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"24531","type":"Circle"},{"attributes":{"axis":{"id":"24508"},"ticker":null},"id":"24511","type":"Grid"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"24516"},{"id":"24517"},{"id":"24518"},{"id":"24519"},{"id":"24520"},{"id":"24521"}]},"id":"24523","type":"Toolbar"},{"attributes":{},"id":"24517","type":"WheelZoomTool"},{"attributes":{},"id":"24509","type":"BasicTicker"},{"attributes":{},"id":"24500","type":"DataRange1d"},{"attributes":{"align":"center","text":"Bottom Centered Title"},"id":"24535","type":"Title"},{"attributes":{},"id":"24502","type":"DataRange1d"},{"attributes":{},"id":"24516","type":"PanTool"},{"attributes":{},"id":"24506","type":"LinearScale"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"24522","type":"BoxAnnotation"},{"attributes":{},"id":"24520","type":"ResetTool"},{"attributes":{"text":"Left Title"},"id":"24498","type":"Title"},{"attributes":{},"id":"24541","type":"UnionRenderers"},{"attributes":{},"id":"24542","type":"Selection"},{"attributes":{"overlay":{"id":"24522"}},"id":"24518","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"24538"},"ticker":{"id":"24509"}},"id":"24508","type":"LinearAxis"},{"attributes":{"axis":{"id":"24512"},"dimension":1,"ticker":null},"id":"24515","type":"Grid"},{"attributes":{"below":[{"id":"24508"},{"id":"24535"}],"center":[{"id":"24511"},{"id":"24515"}],"left":[{"id":"24512"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"24533"}],"title":{"id":"24498"},"title_location":"left","toolbar":{"id":"24523"},"x_range":{"id":"24500"},"x_scale":{"id":"24504"},"y_range":{"id":"24502"},"y_scale":{"id":"24506"}},"id":"24497","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"24504","type":"LinearScale"},{"attributes":{},"id":"24538","type":"BasicTickFormatter"},{"attributes":{"data":{"x":[1,2],"y":[3,4]},"selected":{"id":"24542"},"selection_policy":{"id":"24541"}},"id":"24530","type":"ColumnDataSource"}],"root_ids":["24497"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"49370d9c-125d-462e-b70b-2e2d651e4130","root_ids":["24497"],"roots":{"24497":"508e5d34-3c0f-4b5b-9f64-4949543e07f9"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();