(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("6bb32e97-59c1-42de-9279-181170833fc9");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '6bb32e97-59c1-42de-9279-181170833fc9' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"2594cfa2-d6d4-4a3e-9acf-8a03de370f9b":{"roots":{"references":[{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"28341","type":"BoxAnnotation"},{"attributes":{"toolbar":{"id":"28372"},"toolbar_location":"above"},"id":"28373","type":"ToolbarBox"},{"attributes":{"below":[{"id":"28330"}],"center":[{"id":"28333"},{"id":"28337"}],"left":[{"id":"28334"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"28350"}],"title":{"id":"28361"},"toolbar":{"id":"28342"},"toolbar_location":null,"x_range":{"id":"28293"},"x_scale":{"id":"28326"},"y_range":{"id":"28295"},"y_scale":{"id":"28328"}},"id":"28323","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"28358","type":"Selection"},{"attributes":{"booleans":[false,false,true,true,true]},"id":"28290","type":"BooleanFilter"},{"attributes":{"toolbars":[{"id":"28313"},{"id":"28342"}],"tools":[{"id":"28309"},{"id":"28310"},{"id":"28311"},{"id":"28338"},{"id":"28339"},{"id":"28340"}]},"id":"28372","type":"ProxyToolbar"},{"attributes":{"formatter":{"id":"28364"},"ticker":{"id":"28331"}},"id":"28330","type":"LinearAxis"},{"attributes":{"data_source":{"id":"28289"},"glyph":{"id":"28347"},"hover_glyph":{"id":"28349"},"muted_glyph":null,"nonselection_glyph":{"id":"28348"},"selection_glyph":null,"view":{"id":"28291"}},"id":"28350","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"28366"},"ticker":{"id":"28335"}},"id":"28334","type":"LinearAxis"},{"attributes":{},"id":"28335","type":"BasicTicker"},{"attributes":{"axis":{"id":"28305"},"dimension":1,"ticker":null},"id":"28308","type":"Grid"},{"attributes":{},"id":"28297","type":"LinearScale"},{"attributes":{"data_source":{"id":"28289"},"glyph":{"id":"28318"},"hover_glyph":{"id":"28320"},"muted_glyph":null,"nonselection_glyph":{"id":"28319"},"selection_glyph":null,"view":{"id":"28322"}},"id":"28321","type":"GlyphRenderer"},{"attributes":{},"id":"28306","type":"BasicTicker"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"28347","type":"Circle"},{"attributes":{},"id":"28366","type":"BasicTickFormatter"},{"attributes":{},"id":"28293","type":"DataRange1d"},{"attributes":{},"id":"28295","type":"DataRange1d"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"28318","type":"Circle"},{"attributes":{"callback":null},"id":"28310","type":"HoverTool"},{"attributes":{},"id":"28356","type":"BasicTickFormatter"},{"attributes":{"below":[{"id":"28301"}],"center":[{"id":"28304"},{"id":"28308"}],"left":[{"id":"28305"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"28321"}],"title":{"id":"28351"},"toolbar":{"id":"28313"},"toolbar_location":null,"x_range":{"id":"28293"},"x_scale":{"id":"28297"},"y_range":{"id":"28295"},"y_scale":{"id":"28299"}},"id":"28292","subtype":"Figure","type":"Plot"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"28312","type":"BoxAnnotation"},{"attributes":{},"id":"28311","type":"ResetTool"},{"attributes":{"axis":{"id":"28301"},"ticker":null},"id":"28304","type":"Grid"},{"attributes":{"text":""},"id":"28361","type":"Title"},{"attributes":{"formatter":{"id":"28354"},"ticker":{"id":"28302"}},"id":"28301","type":"LinearAxis"},{"attributes":{"children":[{"id":"28373"},{"id":"28371"}]},"id":"28374","type":"Column"},{"attributes":{"fill_color":{"value":"red"},"line_color":{"value":"red"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"28349","type":"Circle"},{"attributes":{"overlay":{"id":"28312"}},"id":"28309","type":"BoxSelectTool"},{"attributes":{"text":""},"id":"28351","type":"Title"},{"attributes":{"callback":null},"id":"28339","type":"HoverTool"},{"attributes":{"children":[[{"id":"28292"},0,0],[{"id":"28323"},0,1]]},"id":"28371","type":"GridBox"},{"attributes":{"axis":{"id":"28334"},"dimension":1,"ticker":null},"id":"28337","type":"Grid"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"28309"},{"id":"28310"},{"id":"28311"}]},"id":"28313","type":"Toolbar"},{"attributes":{},"id":"28299","type":"LinearScale"},{"attributes":{},"id":"28326","type":"LinearScale"},{"attributes":{},"id":"28354","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"28356"},"ticker":{"id":"28306"}},"id":"28305","type":"LinearAxis"},{"attributes":{"fill_color":{"value":"red"},"line_color":{"value":"red"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"28320","type":"Circle"},{"attributes":{},"id":"28340","type":"ResetTool"},{"attributes":{"axis":{"id":"28330"},"ticker":null},"id":"28333","type":"Grid"},{"attributes":{},"id":"28302","type":"BasicTicker"},{"attributes":{"source":{"id":"28289"}},"id":"28322","type":"CDSView"},{"attributes":{},"id":"28364","type":"BasicTickFormatter"},{"attributes":{},"id":"28357","type":"UnionRenderers"},{"attributes":{},"id":"28328","type":"LinearScale"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[1,2,3,4,5]},"selected":{"id":"28358"},"selection_policy":{"id":"28357"}},"id":"28289","type":"ColumnDataSource"},{"attributes":{},"id":"28331","type":"BasicTicker"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"28319","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"28348","type":"Circle"},{"attributes":{"filters":[{"id":"28290"}],"source":{"id":"28289"}},"id":"28291","type":"CDSView"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"28338"},{"id":"28339"},{"id":"28340"}]},"id":"28342","type":"Toolbar"},{"attributes":{"overlay":{"id":"28341"}},"id":"28338","type":"BoxSelectTool"}],"root_ids":["28374"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"2594cfa2-d6d4-4a3e-9acf-8a03de370f9b","root_ids":["28374"],"roots":{"28374":"6bb32e97-59c1-42de-9279-181170833fc9"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();