(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("25436632-cc7f-4197-a585-6c2f6edbbc41");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '25436632-cc7f-4197-a585-6c2f6edbbc41' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"6f3bfe3f-129f-4fcf-9a70-5cf2407d678f":{"roots":{"references":[{"attributes":{"below":[{"id":"27766"}],"center":[{"id":"27769"},{"id":"27773"}],"left":[{"id":"27770"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"27784"}],"title":{"id":"27786"},"toolbar":{"id":"27777"},"x_range":{"id":"27758"},"x_scale":{"id":"27762"},"y_range":{"id":"27760"},"y_scale":{"id":"27764"}},"id":"27757","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"27789"},"ticker":{"id":"27767"}},"id":"27766","type":"LinearAxis"},{"attributes":{},"id":"27789","type":"BasicTickFormatter"},{"attributes":{},"id":"27760","type":"DataRange1d"},{"attributes":{"axis":{"id":"27766"},"ticker":null},"id":"27769","type":"Grid"},{"attributes":{"data":{"x":[1,2.5,3,2],"y":[2,3,1,1.5]},"selected":{"id":"27793"},"selection_policy":{"id":"27792"}},"id":"27781","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"27791"},"ticker":{"id":"27771"}},"id":"27770","type":"LinearAxis"},{"attributes":{},"id":"27758","type":"DataRange1d"},{"attributes":{"axis":{"id":"27770"},"dimension":1,"ticker":null},"id":"27773","type":"Grid"},{"attributes":{},"id":"27791","type":"BasicTickFormatter"},{"attributes":{},"id":"27776","type":"SaveTool"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.5},"line_color":{"value":"#1f77b4"},"radius":{"units":"data","value":0.3},"x":{"field":"x"},"y":{"field":"y"}},"id":"27782","type":"Circle"},{"attributes":{},"id":"27767","type":"BasicTicker"},{"attributes":{"text":""},"id":"27786","type":"Title"},{"attributes":{"data_source":{"id":"27781"},"glyph":{"id":"27782"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"27783"},"selection_glyph":null,"view":{"id":"27785"}},"id":"27784","type":"GlyphRenderer"},{"attributes":{},"id":"27774","type":"PanTool"},{"attributes":{},"id":"27792","type":"UnionRenderers"},{"attributes":{},"id":"27775","type":"ResetTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"27774"},{"id":"27775"},{"id":"27776"}]},"id":"27777","type":"Toolbar"},{"attributes":{},"id":"27762","type":"LinearScale"},{"attributes":{},"id":"27764","type":"LinearScale"},{"attributes":{},"id":"27793","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"units":"data","value":0.3},"x":{"field":"x"},"y":{"field":"y"}},"id":"27783","type":"Circle"},{"attributes":{"source":{"id":"27781"}},"id":"27785","type":"CDSView"},{"attributes":{},"id":"27771","type":"BasicTicker"}],"root_ids":["27757"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"6f3bfe3f-129f-4fcf-9a70-5cf2407d678f","root_ids":["27757"],"roots":{"27757":"25436632-cc7f-4197-a585-6c2f6edbbc41"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();