(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("99ed6085-a1a0-4b40-993b-cd5e70a9628d");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '99ed6085-a1a0-4b40-993b-cd5e70a9628d' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"73d72d3c-fcce-4d7b-a10b-78d7c37ea614":{"roots":{"references":[{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"39462"},"selection_policy":{"id":"39461"}},"id":"39450","type":"ColumnDataSource"},{"attributes":{},"id":"39458","type":"BasicTickFormatter"},{"attributes":{},"id":"39440","type":"ResetTool"},{"attributes":{},"id":"39441","type":"HelpTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"39452","type":"Circle"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"39451","type":"Circle"},{"attributes":{"overlay":{"id":"39442"}},"id":"39438","type":"BoxZoomTool"},{"attributes":{},"id":"39436","type":"PanTool"},{"attributes":{},"id":"39462","type":"Selection"},{"attributes":{},"id":"39426","type":"LinearScale"},{"attributes":{"axis":{"id":"39428"},"ticker":null},"id":"39431","type":"Grid"},{"attributes":{"text":""},"id":"39455","type":"Title"},{"attributes":{},"id":"39420","type":"DataRange1d"},{"attributes":{},"id":"39429","type":"BasicTicker"},{"attributes":{},"id":"39424","type":"LinearScale"},{"attributes":{"formatter":{"id":"39458"},"ticker":{"id":"39429"}},"id":"39428","type":"LinearAxis"},{"attributes":{},"id":"39461","type":"UnionRenderers"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"39436"},{"id":"39437"},{"id":"39438"},{"id":"39439"},{"id":"39440"},{"id":"39441"}]},"id":"39443","type":"Toolbar"},{"attributes":{"data_source":{"id":"39450"},"glyph":{"id":"39451"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"39452"},"selection_glyph":null,"view":{"id":"39454"}},"id":"39453","type":"GlyphRenderer"},{"attributes":{},"id":"39460","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"39432"},"dimension":1,"minor_grid_line_alpha":0.1,"minor_grid_line_color":"navy","ticker":null},"id":"39435","type":"Grid"},{"attributes":{},"id":"39422","type":"DataRange1d"},{"attributes":{},"id":"39439","type":"SaveTool"},{"attributes":{"below":[{"id":"39428"}],"center":[{"id":"39431"},{"id":"39435"}],"left":[{"id":"39432"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"39453"}],"title":{"id":"39455"},"toolbar":{"id":"39443"},"x_range":{"id":"39420"},"x_scale":{"id":"39424"},"y_range":{"id":"39422"},"y_scale":{"id":"39426"}},"id":"39419","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"39460"},"ticker":{"id":"39433"}},"id":"39432","type":"LinearAxis"},{"attributes":{"source":{"id":"39450"}},"id":"39454","type":"CDSView"},{"attributes":{},"id":"39437","type":"WheelZoomTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"39442","type":"BoxAnnotation"},{"attributes":{},"id":"39433","type":"BasicTicker"}],"root_ids":["39419"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"73d72d3c-fcce-4d7b-a10b-78d7c37ea614","root_ids":["39419"],"roots":{"39419":"99ed6085-a1a0-4b40-993b-cd5e70a9628d"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();