(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("feadcc35-13e8-4cdb-a1dc-8b7c07412dd0");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'feadcc35-13e8-4cdb-a1dc-8b7c07412dd0' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"9c153553-e75a-4298-bda3-a3305fdc8a97":{"roots":{"references":[{"attributes":{},"id":"39498","type":"LinearScale"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"39534"},"selection_policy":{"id":"39533"}},"id":"39522","type":"ColumnDataSource"},{"attributes":{},"id":"39511","type":"SaveTool"},{"attributes":{},"id":"39534","type":"Selection"},{"attributes":{},"id":"39494","type":"DataRange1d"},{"attributes":{},"id":"39492","type":"DataRange1d"},{"attributes":{},"id":"39509","type":"WheelZoomTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"39508"},{"id":"39509"},{"id":"39510"},{"id":"39511"},{"id":"39512"},{"id":"39513"}]},"id":"39515","type":"Toolbar"},{"attributes":{},"id":"39505","type":"BasicTicker"},{"attributes":{"formatter":{"id":"39530"},"ticker":{"id":"39501"}},"id":"39500","type":"LinearAxis"},{"attributes":{},"id":"39533","type":"UnionRenderers"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"39514","type":"BoxAnnotation"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"39524","type":"Circle"},{"attributes":{},"id":"39501","type":"BasicTicker"},{"attributes":{"data_source":{"id":"39522"},"glyph":{"id":"39523"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"39524"},"selection_glyph":null,"view":{"id":"39526"}},"id":"39525","type":"GlyphRenderer"},{"attributes":{"text":""},"id":"39527","type":"Title"},{"attributes":{"source":{"id":"39522"}},"id":"39526","type":"CDSView"},{"attributes":{},"id":"39513","type":"HelpTool"},{"attributes":{"overlay":{"id":"39514"}},"id":"39510","type":"BoxZoomTool"},{"attributes":{},"id":"39508","type":"PanTool"},{"attributes":{},"id":"39530","type":"BasicTickFormatter"},{"attributes":{},"id":"39512","type":"ResetTool"},{"attributes":{"axis":{"id":"39504"},"band_fill_alpha":0.1,"band_fill_color":"navy","dimension":1,"ticker":null},"id":"39507","type":"Grid"},{"attributes":{},"id":"39496","type":"LinearScale"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"39523","type":"Circle"},{"attributes":{"below":[{"id":"39500"}],"center":[{"id":"39503"},{"id":"39507"}],"left":[{"id":"39504"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"39525"}],"title":{"id":"39527"},"toolbar":{"id":"39515"},"x_range":{"id":"39492"},"x_scale":{"id":"39496"},"y_range":{"id":"39494"},"y_scale":{"id":"39498"}},"id":"39491","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"39532"},"ticker":{"id":"39505"}},"id":"39504","type":"LinearAxis"},{"attributes":{"axis":{"id":"39500"},"grid_line_color":null,"ticker":null},"id":"39503","type":"Grid"},{"attributes":{},"id":"39532","type":"BasicTickFormatter"}],"root_ids":["39491"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"9c153553-e75a-4298-bda3-a3305fdc8a97","root_ids":["39491"],"roots":{"39491":"feadcc35-13e8-4cdb-a1dc-8b7c07412dd0"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();