(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("c5b855df-e1c0-47dd-a2af-a5af6d2bf542");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'c5b855df-e1c0-47dd-a2af-a5af6d2bf542' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"85a9a851-ec12-438d-a91b-1e5704785b9e":{"roots":{"references":[{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"41345","type":"Circle"},{"attributes":{},"id":"41354","type":"UnionRenderers"},{"attributes":{"source":{"id":"41344"}},"id":"41348","type":"CDSView"},{"attributes":{"below":[{"id":"41322"}],"center":[{"id":"41325"},{"id":"41329"}],"left":[{"id":"41326"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"41347"}],"title":null,"toolbar":{"id":"41337"},"toolbar_location":"below","toolbar_sticky":false,"x_range":{"id":"41314"},"x_scale":{"id":"41318"},"y_range":{"id":"41316"},"y_scale":{"id":"41320"}},"id":"41312","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"41353","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"41322"},"ticker":null},"id":"41325","type":"Grid"},{"attributes":{"data_source":{"id":"41344"},"glyph":{"id":"41345"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"41346"},"selection_glyph":null,"view":{"id":"41348"}},"id":"41347","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"41346","type":"Circle"},{"attributes":{"axis":{"id":"41326"},"dimension":1,"ticker":null},"id":"41329","type":"Grid"},{"attributes":{},"id":"41330","type":"PanTool"},{"attributes":{},"id":"41314","type":"DataRange1d"},{"attributes":{"overlay":{"id":"41336"}},"id":"41332","type":"BoxZoomTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"41330"},{"id":"41331"},{"id":"41332"},{"id":"41333"},{"id":"41334"},{"id":"41335"}]},"id":"41337","type":"Toolbar"},{"attributes":{},"id":"41323","type":"BasicTicker"},{"attributes":{},"id":"41331","type":"WheelZoomTool"},{"attributes":{},"id":"41318","type":"LinearScale"},{"attributes":{},"id":"41333","type":"SaveTool"},{"attributes":{"formatter":{"id":"41351"},"ticker":{"id":"41323"}},"id":"41322","type":"LinearAxis"},{"attributes":{},"id":"41320","type":"LinearScale"},{"attributes":{},"id":"41334","type":"ResetTool"},{"attributes":{},"id":"41316","type":"DataRange1d"},{"attributes":{},"id":"41335","type":"HelpTool"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"41355"},"selection_policy":{"id":"41354"}},"id":"41344","type":"ColumnDataSource"},{"attributes":{},"id":"41327","type":"BasicTicker"},{"attributes":{},"id":"41355","type":"Selection"},{"attributes":{"formatter":{"id":"41353"},"ticker":{"id":"41327"}},"id":"41326","type":"LinearAxis"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"41336","type":"BoxAnnotation"},{"attributes":{},"id":"41351","type":"BasicTickFormatter"}],"root_ids":["41312"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"85a9a851-ec12-438d-a91b-1e5704785b9e","root_ids":["41312"],"roots":{"41312":"c5b855df-e1c0-47dd-a2af-a5af6d2bf542"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();