(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("c0419a36-04df-47f5-ba69-adf0e345ca8b");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'c0419a36-04df-47f5-ba69-adf0e345ca8b' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function(root, factory) {
              factory(root["Bokeh"]);
          })(this, function(Bokeh) {
            var define;
            return (function outer(modules, entry) {
            if (Bokeh != null) {
              return Bokeh.register_plugin(modules, entry);
            } else {
              throw new Error("Cannot find Bokeh. You have to load it prior to loading plugins.");
            }
          })
          ({
            "custom/main": function(require, module, exports) {
              var models = {
                "DrawTool": require("custom/bokeh_app_fa34f9d2faaf4d7b8b05d27bab14c8cc.draw_tool").DrawTool
              };
              require("base").register_models(models);
              module.exports = models;
            },
            "custom/bokeh_app_fa34f9d2faaf4d7b8b05d27bab14c8cc.draw_tool": function(require, module, exports) {
          "use strict";
          var __importStar = (this && this.__importStar) || function (mod) {
              if (mod && mod.__esModule) return mod;
              var result = {};
              if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
              result["default"] = mod;
              return result;
          };
          Object.defineProperty(exports, "__esModule", { value: true });
          const gesture_tool_1 = require("models/tools/gestures/gesture_tool");
          const p = __importStar(require("core/properties"));
          class DrawToolView extends gesture_tool_1.GestureToolView {
              //this is executed when the pan/drag event starts
              _pan_start(_ev) {
                  this.model.source.data = { x: [], y: [] };
              }
              //this is executed on subsequent mouse/touch moves
              _pan(ev) {
                  const { frame } = this.plot_view;
                  const { sx, sy } = ev;
                  if (!frame.bbox.contains(sx, sy))
                      return;
                  const x = frame.x_scale.invert(sx);
                  const y = frame.y_scale.invert(sy);
                  const { source } = this.model;
                  source.get_array("x").push(x);
                  source.get_array("y").push(y);
                  source.change.emit();
              }
              // this is executed then the pan/drag ends
              _pan_end(_ev) { }
          }
          exports.DrawToolView = DrawToolView;
          DrawToolView.__name__ = "DrawToolView";
          class DrawTool extends gesture_tool_1.GestureTool {
              constructor(attrs) {
                  super(attrs);
                  this.tool_name = "Drag Span";
                  this.icon = "bk-tool-icon-lasso-select";
                  this.event_type = "pan";
                  this.default_order = 12;
              }
              static init_DrawTool() {
                  this.prototype.default_view = DrawToolView;
                  this.define({
                      source: [p.Instance],
                  });
              }
          }
          exports.DrawTool = DrawTool;
          DrawTool.__name__ = "DrawTool";
          DrawTool.init_DrawTool();
          //# sourceMappingURL=extensions_example_tool.py:DrawTool.js.map
          }
          }, "custom/main");
          ;
          });
    
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"04a6db97-df1c-4288-91b2-065ab584acd1":{"roots":{"references":[{"attributes":{},"id":"29045","type":"LinearScale"},{"attributes":{"line_alpha":0.1,"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"29062","type":"Line"},{"attributes":{"formatter":{"id":"29070"},"ticker":{"id":"29054"}},"id":"29053","type":"LinearAxis"},{"attributes":{"data":{"x":[],"y":[]},"selected":{"id":"29072"},"selection_policy":{"id":"29071"}},"id":"29038","type":"ColumnDataSource"},{"attributes":{"end":10},"id":"29043","type":"Range1d"},{"attributes":{"below":[{"id":"29049"}],"center":[{"id":"29052"},{"id":"29056"}],"left":[{"id":"29053"}],"renderers":[{"id":"29063"}],"title":{"id":"29059"},"toolbar":{"id":"29057"},"x_range":{"id":"29041"},"x_scale":{"id":"29045"},"y_range":{"id":"29043"},"y_scale":{"id":"29047"}},"id":"29040","subtype":"Figure","type":"Plot"},{"attributes":{"data_source":{"id":"29038"},"glyph":{"id":"29061"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"29062"},"selection_glyph":null,"view":{"id":"29064"}},"id":"29063","type":"GlyphRenderer"},{"attributes":{"axis":{"id":"29049"},"ticker":null},"id":"29052","type":"Grid"},{"attributes":{"line_color":"#1f77b4","x":{"field":"x"},"y":{"field":"y"}},"id":"29061","type":"Line"},{"attributes":{"end":10},"id":"29041","type":"Range1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"29039"}]},"id":"29057","type":"Toolbar"},{"attributes":{"source":{"id":"29038"}},"id":"29039","type":"DrawTool"},{"attributes":{},"id":"29068","type":"BasicTickFormatter"},{"attributes":{},"id":"29071","type":"UnionRenderers"},{"attributes":{},"id":"29047","type":"LinearScale"},{"attributes":{},"id":"29050","type":"BasicTicker"},{"attributes":{},"id":"29072","type":"Selection"},{"attributes":{},"id":"29070","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"29053"},"dimension":1,"ticker":null},"id":"29056","type":"Grid"},{"attributes":{"source":{"id":"29038"}},"id":"29064","type":"CDSView"},{"attributes":{},"id":"29054","type":"BasicTicker"},{"attributes":{"formatter":{"id":"29068"},"ticker":{"id":"29050"}},"id":"29049","type":"LinearAxis"},{"attributes":{"text":"Drag to draw on the plot"},"id":"29059","type":"Title"}],"root_ids":["29040"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"04a6db97-df1c-4288-91b2-065ab584acd1","root_ids":["29040"],"roots":{"29040":"c0419a36-04df-47f5-ba69-adf0e345ca8b"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();