(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("b0cdeef4-1413-42c3-946a-3145d17c2ad5");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'b0cdeef4-1413-42c3-946a-3145d17c2ad5' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://ajax.googleapis.com/ajax/libs/jquery/3.1.0/jquery.min.js", "https://cdnjs.cloudflare.com/ajax/libs/ion-rangeslider/2.1.4/js/ion.rangeSlider.js", "https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = ["https://cdnjs.cloudflare.com/ajax/libs/normalize/4.2.0/normalize.css", "https://cdnjs.cloudflare.com/ajax/libs/ion-rangeslider/2.1.4/css/ion.rangeSlider.css", "https://cdnjs.cloudflare.com/ajax/libs/ion-rangeslider/2.1.4/css/ion.rangeSlider.skinFlat.min.css", "https://cdnjs.cloudflare.com/ajax/libs/ion-rangeslider/2.1.4/img/sprite-skin-flat.png"];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function(root, factory) {
              factory(root["Bokeh"]);
          })(this, function(Bokeh) {
            var define;
            return (function outer(modules, entry) {
            if (Bokeh != null) {
              return Bokeh.register_plugin(modules, entry);
            } else {
              throw new Error("Cannot find Bokeh. You have to load it prior to loading plugins.");
            }
          })
          ({
            "custom/main": function(require, module, exports) {
              var models = {
                "IonRangeSlider": require("custom/bokeh_app_1af8d6eb261f468fa94452f122195e10.ion_range_slider").IonRangeSlider
              };
              require("base").register_models(models);
              module.exports = models;
            },
            "custom/bokeh_app_1af8d6eb261f468fa94452f122195e10.ion_range_slider": function(require, module, exports) {
          "use strict";
          var __importStar = (this && this.__importStar) || function (mod) {
              if (mod && mod.__esModule) return mod;
              var result = {};
              if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
              result["default"] = mod;
              return result;
          };
          Object.defineProperty(exports, "__esModule", { value: true });
          // The "core/properties" module has all the property types
          const p = __importStar(require("core/properties"));
          // HTML construction and manipulation functions
          const dom_1 = require("core/dom");
          // We will subclass in JavaScript from the same class that was subclassed
          // from in Python
          const input_widget_1 = require("models/widgets/input_widget");
          // This model will actually need to render things, so we must provide
          // view. The LayoutDOM model has a view already, so we will start with that
          class IonRangeSliderView extends input_widget_1.InputWidgetView {
              render() {
                  // BokehJS Views create <div> elements by default, accessible as @el.
                  // Many Bokeh views ignore this default <div>, and instead do things
                  // like draw to the HTML canvas. In this case though, we change the
                  // contents of the <div>, based on the current slider value.
                  super.render();
                  if (this.model.title != null) {
                      this.value_el = dom_1.input({ type: "text", class: "bk-input", readonly: true, style: { marginBottom: "5px" } });
                      this.group_el.appendChild(this.value_el);
                  }
                  this.input_el = dom_1.input({ type: "text" });
                  this.group_el.appendChild(dom_1.div({ style: { width: "100%" } }, this.input_el));
                  // Set up parameters
                  const max = this.model.end;
                  const min = this.model.start;
                  const [from, to] = this.model.range || [max, min];
                  const opts = {
                      type: "double",
                      grid: this.model.grid,
                      min,
                      max,
                      from,
                      to,
                      step: this.model.step || (max - min) / 50,
                      disable: this.model.disabled,
                      onChange: (data) => this.slide(data),
                      onFinish: (data) => this.slidestop(data),
                  };
                  jQuery(this.input_el).ionRangeSlider(opts);
                  if (this.value_el != null)
                      this.value_el.value = `${from} - ${to}`;
              }
              slidestop(_data) {
              }
              slide({ from, to }) {
                  if (this.value_el != null)
                      this.value_el.value = `${from} - ${to}`;
                  this.model.range = [from, to];
              }
          }
          exports.IonRangeSliderView = IonRangeSliderView;
          IonRangeSliderView.__name__ = "IonRangeSliderView";
          class IonRangeSlider extends input_widget_1.InputWidget {
              constructor(attrs) {
                  super(attrs);
              }
              static init_IonRangeSlider() {
                  // If there is an associated view, this is boilerplate.
                  this.prototype.default_view = IonRangeSliderView;
                  // The @define block adds corresponding "properties" to the JS model. These
                  // should basically line up 1-1 with the Python model class. Most property
                  // types have counterparts, e.g. bokeh.core.properties.String will be
                  // p.String in the JS implementation. Where the JS type system is not yet
                  // as rich, you can use p.Any as a "wildcard" property type.
                  this.define({
                      range: [p.Any],
                      start: [p.Number, 0],
                      end: [p.Number, 1],
                      step: [p.Number, 0.1],
                      grid: [p.Boolean, true],
                  });
              }
          }
          exports.IonRangeSlider = IonRangeSlider;
          IonRangeSlider.__name__ = "IonRangeSlider";
          IonRangeSlider.init_IonRangeSlider();
          //# sourceMappingURL=extensions_ion_range_slider.js.map
          }
          }, "custom/main");
          ;
          });
    
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"2c51e74f-567d-4cbb-8b50-ce75ed69f650":{"roots":{"references":[{"attributes":{"overlay":{"id":"29121"}},"id":"29117","type":"BoxZoomTool"},{"attributes":{"text":""},"id":"29139","type":"Title"},{"attributes":{"line_alpha":0.6,"line_color":"#ed5565","line_width":3,"x":{"field":"x"},"y":{"field":"y"}},"id":"29130","type":"Line"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"29115"},{"id":"29116"},{"id":"29117"},{"id":"29118"},{"id":"29119"},{"id":"29120"}]},"id":"29122","type":"Toolbar"},{"attributes":{"data":{"x":[0.01,0.015,0.02,0.025,0.03,0.035,0.04,0.045,0.05,0.055,0.06,0.065,0.07,0.075,0.08,0.085,0.09,0.095,0.1,0.105,0.11,0.115,0.12,0.125,0.13,0.135,0.14,0.145,0.15,0.155,0.16,0.165,0.17,0.17500000000000002,0.18,0.185,0.19,0.195,0.2,0.20500000000000002,0.21,0.215,0.22,0.225,0.23,0.23500000000000001,0.24,0.245,0.25,0.255,0.26,0.265,0.27,0.275,0.28,0.28500000000000003,0.29,0.295,0.3,0.305,0.31,0.315,0.32,0.325,0.33,0.335,0.34,0.34500000000000003,0.35000000000000003,0.355,0.36,0.365,0.37,0.375,0.38,0.385,0.39,0.395,0.4,0.405,0.41000000000000003,0.41500000000000004,0.42,0.425,0.43,0.435,0.44,0.445,0.45,0.455,0.46,0.465,0.47000000000000003,0.47500000000000003,0.48,0.485,0.49,0.495,0.5,0.505,0.51,0.515,0.52,0.525,0.53,0.535,0.54,0.545,0.55,0.555,0.56,0.5650000000000001,0.5700000000000001,0.5750000000000001,0.58,0.585,0.59,0.595,0.6,0.605,0.61,0.615,0.62,0.625,0.63,0.635,0.64,0.645,0.65,0.655,0.66,0.665,0.67,0.675,0.68,0.685,0.6900000000000001,0.6950000000000001,0.7000000000000001,0.705,0.71,0.715,0.72,0.725,0.73,0.735,0.74,0.745,0.75,0.755,0.76,0.765,0.77,0.775,0.78,0.785,0.79,0.795,0.8,0.805,0.81,0.8150000000000001,0.8200000000000001,0.8250000000000001,0.8300000000000001,0.835,0.84,0.845,0.85,0.855,0.86,0.865,0.87,0.875,0.88,0.885,0.89,0.895,0.9,0.905,0.91,0.915,0.92,0.925,0.93,0.935,0.9400000000000001,0.9450000000000001,0.9500000000000001,0.9550000000000001,0.96,0.965,0.97,0.975,0.98,0.985],"y":[0.01,0.015,0.02,0.025,0.03,0.035,0.04,0.045,0.05,0.055,0.06,0.065,0.07,0.075,0.08,0.085,0.09,0.095,0.1,0.105,0.11,0.115,0.12,0.125,0.13,0.135,0.14,0.145,0.15,0.155,0.16,0.165,0.17,0.17500000000000002,0.18,0.185,0.19,0.195,0.2,0.20500000000000002,0.21,0.215,0.22,0.225,0.23,0.23500000000000001,0.24,0.245,0.25,0.255,0.26,0.265,0.27,0.275,0.28,0.28500000000000003,0.29,0.295,0.3,0.305,0.31,0.315,0.32,0.325,0.33,0.335,0.34,0.34500000000000003,0.35000000000000003,0.355,0.36,0.365,0.37,0.375,0.38,0.385,0.39,0.395,0.4,0.405,0.41000000000000003,0.41500000000000004,0.42,0.425,0.43,0.435,0.44,0.445,0.45,0.455,0.46,0.465,0.47000000000000003,0.47500000000000003,0.48,0.485,0.49,0.495,0.5,0.505,0.51,0.515,0.52,0.525,0.53,0.535,0.54,0.545,0.55,0.555,0.56,0.5650000000000001,0.5700000000000001,0.5750000000000001,0.58,0.585,0.59,0.595,0.6,0.605,0.61,0.615,0.62,0.625,0.63,0.635,0.64,0.645,0.65,0.655,0.66,0.665,0.67,0.675,0.68,0.685,0.6900000000000001,0.6950000000000001,0.7000000000000001,0.705,0.71,0.715,0.72,0.725,0.73,0.735,0.74,0.745,0.75,0.755,0.76,0.765,0.77,0.775,0.78,0.785,0.79,0.795,0.8,0.805,0.81,0.8150000000000001,0.8200000000000001,0.8250000000000001,0.8300000000000001,0.835,0.84,0.845,0.85,0.855,0.86,0.865,0.87,0.875,0.88,0.885,0.89,0.895,0.9,0.905,0.91,0.915,0.92,0.925,0.93,0.935,0.9400000000000001,0.9450000000000001,0.9500000000000001,0.9550000000000001,0.96,0.965,0.97,0.975,0.98,0.985]},"selected":{"id":"29146"},"selection_policy":{"id":"29145"}},"id":"29097","type":"ColumnDataSource"},{"attributes":{},"id":"29120","type":"HelpTool"},{"attributes":{"end":5,"format":"0[.]00","js_property_callbacks":{"change:value":[{"id":"29134"}]},"start":0,"step":0.1,"title":"Bokeh Slider - Power","value":1},"id":"29136","type":"Slider"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"29121","type":"BoxAnnotation"},{"attributes":{},"id":"29116","type":"WheelZoomTool"},{"attributes":{"formatter":{"id":"29142"},"ticker":{"id":"29108"}},"id":"29107","type":"LinearAxis"},{"attributes":{"source":{"id":"29097"}},"id":"29133","type":"CDSView"},{"attributes":{},"id":"29112","type":"BasicTicker"},{"attributes":{},"id":"29108","type":"BasicTicker"},{"attributes":{"formatter":{"id":"29144"},"ticker":{"id":"29112"}},"id":"29111","type":"LinearAxis"},{"attributes":{"axis":{"id":"29111"},"dimension":1,"ticker":null},"id":"29114","type":"Grid"},{"attributes":{},"id":"29119","type":"ResetTool"},{"attributes":{},"id":"29099","type":"DataRange1d"},{"attributes":{"args":{"source":{"id":"29097"}},"code":"\\n        var data = source.data;\\n        var f = cb_obj.range\\n        var x = data[&#x27;x&#x27;]\\n        var y = data[&#x27;y&#x27;]\\n        var pow = (Math.log(y[100])/Math.log(x[100]))\\n        console.log(pow)\\n        var delta = (f[1] - f[0])/x.length\\n        for (var i = 0; i &lt; x.length; i++) {\\n            x[i] = delta*i + f[0]\\n            y[i] = Math.pow(x[i], pow)\\n        }\\n        source.change.emit();\\n    "},"id":"29135","type":"CustomJS"},{"attributes":{},"id":"29145","type":"UnionRenderers"},{"attributes":{"end":0.99,"js_property_callbacks":{"change:range":[{"id":"29135"}]},"range":[0.01,0.985],"start":0.01,"step":0.01,"title":"Ion Range Slider - Range"},"id":"29137","type":"IonRangeSlider"},{"attributes":{"children":[{"id":"29098"},{"id":"29136"},{"id":"29137"}]},"id":"29138","type":"Column"},{"attributes":{"line_alpha":0.1,"line_color":"#ed5565","line_width":3,"x":{"field":"x"},"y":{"field":"y"}},"id":"29131","type":"Line"},{"attributes":{"data_source":{"id":"29097"},"glyph":{"id":"29130"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"29131"},"selection_glyph":null,"view":{"id":"29133"}},"id":"29132","type":"GlyphRenderer"},{"attributes":{},"id":"29105","type":"LinearScale"},{"attributes":{},"id":"29101","type":"DataRange1d"},{"attributes":{"below":[{"id":"29107"}],"center":[{"id":"29110"},{"id":"29114"}],"left":[{"id":"29111"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"29132"}],"title":{"id":"29139"},"toolbar":{"id":"29122"},"x_range":{"id":"29099"},"x_scale":{"id":"29103"},"y_range":{"id":"29101"},"y_scale":{"id":"29105"}},"id":"29098","subtype":"Figure","type":"Plot"},{"attributes":{"axis":{"id":"29107"},"ticker":null},"id":"29110","type":"Grid"},{"attributes":{},"id":"29144","type":"BasicTickFormatter"},{"attributes":{"args":{"source":{"id":"29097"}},"code":"\\n        var data = source.data;\\n        var f = cb_obj.value\\n        var x = data[&#x27;x&#x27;]\\n        var y = data[&#x27;y&#x27;]\\n        for (var i = 0; i &lt; x.length; i++) {\\n            y[i] = Math.pow(x[i], f)\\n        }\\n        source.change.emit();\\n    "},"id":"29134","type":"CustomJS"},{"attributes":{},"id":"29142","type":"BasicTickFormatter"},{"attributes":{},"id":"29115","type":"PanTool"},{"attributes":{},"id":"29146","type":"Selection"},{"attributes":{},"id":"29103","type":"LinearScale"},{"attributes":{},"id":"29118","type":"SaveTool"}],"root_ids":["29138"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"2c51e74f-567d-4cbb-8b50-ce75ed69f650","root_ids":["29138"],"roots":{"29138":"b0cdeef4-1413-42c3-946a-3145d17c2ad5"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();