(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("a169764d-3083-47ea-99db-48e032ecbbab");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'a169764d-3083-47ea-99db-48e032ecbbab' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function(root, factory) {
              factory(root["Bokeh"]);
          })(this, function(Bokeh) {
            var define;
            return (function outer(modules, entry) {
            if (Bokeh != null) {
              return Bokeh.register_plugin(modules, entry);
            } else {
              throw new Error("Cannot find Bokeh. You have to load it prior to loading plugins.");
            }
          })
          ({
            "custom/main": function(require, module, exports) {
              var models = {
                "MyFormatter": require("custom/bokeh_app_7821f86a48714c71b7fb7f9c6456887b.my_formatter").MyFormatter
              };
              require("base").register_models(models);
              module.exports = models;
            },
            "custom/bokeh_app_7821f86a48714c71b7fb7f9c6456887b.my_formatter": function(require, module, exports) {
          "use strict";
          Object.defineProperty(exports, "__esModule", { value: true });
          const tick_formatter_1 = require("models/formatters/tick_formatter");
          class MyFormatter extends tick_formatter_1.TickFormatter {
              // TickFormatters should implement this method, which accepts a list
              // of numbers (ticks) and returns a list of strings
              doFormat(ticks) {
                  // format the first tick as-is
                  const formatted = [`${ticks[0]}`];
                  for (let i = 1, len = ticks.length; i < len; i++) {
                      formatted.push(`+${(Number(ticks[i]) - Number(ticks[0])).toPrecision(2)}`);
                  }
                  return formatted;
              }
          }
          exports.MyFormatter = MyFormatter;
          MyFormatter.__name__ = "MyFormatter";
          //# sourceMappingURL=extensions_example_ticking.py:MyFormatter.js.map
          }
          }, "custom/main");
          ;
          });
    
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"eda29b8a-edba-487e-811b-ec2b88b3ad6b":{"roots":{"references":[{"attributes":{"overlay":{"id":"28991"}},"id":"28987","type":"BoxZoomTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"28985"},{"id":"28986"},{"id":"28987"},{"id":"28988"},{"id":"28989"},{"id":"28990"}]},"id":"28992","type":"Toolbar"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"29000","type":"Circle"},{"attributes":{},"id":"28986","type":"WheelZoomTool"},{"attributes":{"text":""},"id":"29006","type":"Title"},{"attributes":{"data":{"x":[1,2,3,4,6],"y":[5,7,3,2,4]},"selected":{"id":"29012"},"selection_policy":{"id":"29011"}},"id":"28999","type":"ColumnDataSource"},{"attributes":{},"id":"28973","type":"LinearScale"},{"attributes":{},"id":"29012","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"29001","type":"Circle"},{"attributes":{"formatter":{"id":"29004"},"ticker":{"id":"28978"}},"id":"28977","type":"LinearAxis"},{"attributes":{},"id":"28975","type":"LinearScale"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"28991","type":"BoxAnnotation"},{"attributes":{"axis":{"id":"28977"},"ticker":null},"id":"28980","type":"Grid"},{"attributes":{},"id":"29010","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"28999"}},"id":"29003","type":"CDSView"},{"attributes":{"data_source":{"id":"28999"},"glyph":{"id":"29000"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"29001"},"selection_glyph":null,"view":{"id":"29003"}},"id":"29002","type":"GlyphRenderer"},{"attributes":{},"id":"28985","type":"PanTool"},{"attributes":{},"id":"29011","type":"UnionRenderers"},{"attributes":{"below":[{"id":"28977"}],"center":[{"id":"28980"},{"id":"28984"}],"left":[{"id":"28981"}],"renderers":[{"id":"29002"}],"title":{"id":"29006"},"toolbar":{"id":"28992"},"x_range":{"id":"28969"},"x_scale":{"id":"28973"},"y_range":{"id":"28971"},"y_scale":{"id":"28975"}},"id":"28968","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"29004","type":"MyFormatter"},{"attributes":{},"id":"28990","type":"HelpTool"},{"attributes":{},"id":"28969","type":"DataRange1d"},{"attributes":{},"id":"28971","type":"DataRange1d"},{"attributes":{},"id":"28989","type":"ResetTool"},{"attributes":{"axis":{"id":"28981"},"dimension":1,"ticker":null},"id":"28984","type":"Grid"},{"attributes":{"formatter":{"id":"29010"},"ticker":{"id":"28982"}},"id":"28981","type":"LinearAxis"},{"attributes":{},"id":"28988","type":"SaveTool"},{"attributes":{},"id":"28978","type":"BasicTicker"},{"attributes":{},"id":"28982","type":"BasicTicker"}],"root_ids":["28968"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"eda29b8a-edba-487e-811b-ec2b88b3ad6b","root_ids":["28968"],"roots":{"28968":"a169764d-3083-47ea-99db-48e032ecbbab"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();