(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("a19a9e63-712f-4bb7-8ec0-2134ca2fed74");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'a19a9e63-712f-4bb7-8ec0-2134ca2fed74' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"9f8472cc-7d90-4766-aea8-77a64e746e98":{"roots":{"references":[{"attributes":{},"id":"30443","type":"UnionRenderers"},{"attributes":{"fill_alpha":0.5,"fill_color":"lightgrey","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"xs_units":"screen","ys_units":"screen"},"id":"30420","type":"PolyAnnotation"},{"attributes":{"source":{"id":"30428"}},"id":"30433","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"color"},"line_alpha":{"value":0.1},"line_color":{"field":"color"},"size":{"units":"screen","value":8},"x":{"field":"x"},"y":{"field":"y"}},"id":"30425","type":"Circle"},{"attributes":{"axis":{"id":"30411"},"ticker":null},"id":"30414","type":"Grid"},{"attributes":{},"id":"30412","type":"BasicTicker"},{"attributes":{"args":{"s":{"id":"30399"},"s2":{"id":"30428"}},"code":"\\n    const inds = s.selected.indices;\\n    const d = s.data;\\n    var ym = 0\\n\\n    if (inds.length == 0)\\n        return;\\n\\n    for (var i = 0; i &lt; d[&#x27;color&#x27;].length; i++) {\\n        d[&#x27;color&#x27;][i] = \\"navy\\"\\n    }\\n    for (var i = 0; i &lt; inds.length; i++) {\\n        d[&#x27;color&#x27;][inds[i]] = \\"firebrick\\"\\n        ym += d[&#x27;y&#x27;][inds[i]]\\n    }\\n\\n    ym /= inds.length\\n    s2.data[&#x27;ym&#x27;] = [ym, ym]\\n\\n    s.change.emit();\\n    s2.change.emit();\\n"},"id":"30435","type":"CustomJS"},{"attributes":{"fill_alpha":{"value":0.4},"fill_color":{"field":"color"},"line_alpha":{"value":0.4},"line_color":{"field":"color"},"size":{"units":"screen","value":8},"x":{"field":"x"},"y":{"field":"y"}},"id":"30424","type":"Circle"},{"attributes":{"js_property_callbacks":{"change:indices":[{"id":"30435"}]}},"id":"30434","type":"Selection"},{"attributes":{"source":{"id":"30399"}},"id":"30427","type":"CDSView"},{"attributes":{"data":{"x":[0,1],"ym":[0.5,0.5]},"selected":{"id":"30444"},"selection_policy":{"id":"30443"}},"id":"30428","type":"ColumnDataSource"},{"attributes":{},"id":"30416","type":"BasicTicker"},{"attributes":{"below":[{"id":"30411"}],"center":[{"id":"30414"},{"id":"30418"}],"left":[{"id":"30415"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"30426"},{"id":"30432"}],"title":{"id":"30401"},"toolbar":{"id":"30421"},"x_range":{"id":"30403"},"x_scale":{"id":"30407"},"y_range":{"id":"30405"},"y_scale":{"id":"30409"}},"id":"30400","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"30407","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"30419"}]},"id":"30421","type":"Toolbar"},{"attributes":{"line_alpha":0.1,"line_color":"orange","line_width":5,"x":{"field":"x"},"y":{"field":"ym"}},"id":"30431","type":"Line"},{"attributes":{},"id":"30444","type":"Selection"},{"attributes":{"data_source":{"id":"30399"},"glyph":{"id":"30424"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"30425"},"selection_glyph":null,"view":{"id":"30427"}},"id":"30426","type":"GlyphRenderer"},{"attributes":{"data":{"color":["navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy","navy"],"x":[0.9382731956106168,0.7440129277434808,0.40419921661542424,0.7678464814178771,0.5557793596885074,0.5381506925121952,0.09674032838507163,0.854109813341075,0.709857940308641,0.6827014042454773,0.10170499089369478,0.9386302421099272,0.11802122621004374,0.6518323442341112,0.36761494735665234,0.023250511603248425,0.15541791149318773,0.7336318287299383,0.7621650336449797,0.4148535341355768,0.5351994191814432,0.5018412235057004,0.354168188314967,0.2808037831846727,0.101861513780937,0.10182713907391538,0.8066359122988315,0.05409027123976973,0.7413177742357588,0.08626961676220701,0.06170511695905001,0.6986900176760625,0.3201456399513316,0.5358500356150869,0.005374048887590188,0.7040086045985959,0.10047884501488413,0.1899004665101095,0.8177179809045422,0.17547237732185916,0.742430615335122,0.3546472422341542,0.7391568129063796,0.05449559057982645,0.9498578195958861,0.4072638935865689,0.152454182757228,0.7567089064089073,0.8387459718641327,0.009665657907549585,0.4533335258527025,0.1570012838747692,0.5651068856954783,0.4839077424739646,0.1074586823844681,0.1320654190236097,0.37739704162665677,0.8919881613222076,0.14375405927721352,0.5196158062373685,0.7309374127115056,0.11754784572834853,0.7278800739441484,0.08536788873800294,0.7399013086597326,0.3020651376218325,0.2865676106517867,0.9098169598045037,0.903240201339061,0.3508653364465326,0.13330085031927597,0.8687812816202516,0.3699420990470529,0.033003330543240006,0.2846650255910098,0.906767568862739,0.29464201314623406,0.676478146289793,0.7441150986075517,0.9705820090298594,0.7671658880239357,0.5308615812222829,0.12993170907839235,0.8047636950759686,0.4295429618611123,0.41648846886888835,0.34250018814466,0.4101281149363216,0.8074762015039495,0.7373437448540258,0.2834366938195062,0.982484247897477,0.46070958852522226,0.8569567962977691,0.8306937477810513,0.0901514624738824,0.5325104407071822,0.028886068733692594,0.722648003297345,0.40523271313893605,0.5496479885364101,0.7274766157165843,0.8623155137392179,0.2414200893552021,0.10989505469059391,0.061361493909563025,0.8619442016436211,0.19652839557784496,0.27788784736217087,0.8646867413660108,0.6998943630870399,0.644921083420695,0.2779606945911349,0.185503867150005,0.8614877018076017,0.7805252198054419,0.8414932187595596,0.13460022569280505,0.35450577345382606,0.07453595797741752,0.5851109591221556,0.4078559384832273,0.4563381389984953,0.2966711099461188,0.5723080338155291,0.997129151770173,0.07430048075349094,0.5893291194283592,0.6659905313007416,0.4396162334310332,0.7663343705062439,0.24546261199500952,0.45373820886807015,0.22764638420443684,0.6326008343004909,0.14401123419369222,0.8935575517732881,0.11188278435458798,0.2978458370120015,0.2075207830484771,0.20228170725611916,0.5979511447577043,0.6819915981401854,0.3006394992122039,0.7413840854625705,0.5756550004169517,0.9284304888599308,0.2749890830873244,0.05601662479049607,0.8515918255392249,0.6934008075396436,0.23234657645950174,0.3845225273497468,0.8159866139555694,0.8052299149498701,0.9474339932266069,0.9886162993304014,0.9213091076392318,0.5738808565624224,0.7887608720747079,0.45322190233833803,0.6181143535247203,0.05213131804165294,0.11566888211993631,0.24699560087218875,0.7060871488605666,0.7317191926347095,0.7123610486353121,0.7697438195210751,0.8255665748748325,0.10972417288182501,0.744349242182157,0.2315676623224574,0.9974184872263818,0.6872979339221043,0.8454178057454679,0.8939688806916014,0.8190005305595345,0.1930613309312026,0.2675610202381773,0.03322416491675617,0.6193619764662417,0.9535207482442216,0.6074107885443452,0.7151572929286442,0.6838542585185186,0.6141624622046339,0.5148291341680608,0.1162255320622162,0.709802576364546,0.7853720996552416,0.08009060548560609,0.306984527762725,0.8329767868728898,0.789645421092492,0.10192760036079362,0.8859631453583738,0.3933132750576077,0.024178472230893866,0.46465107772986736,0.745513818145845,0.01965079533180847,0.2480258467858214,0.3077522277268592,0.47921545990467784,0.005745036171352136,0.9972549991031125,0.07764465812645882,0.9578135191990313,0.019658732361273135,0.5024432272581493,0.5811068719290072,0.11676859572791898,0.6323072686344627,0.7160433281683878,0.3685743235438257,0.5868072054225757,0.3084988670188561,0.2505405424779483,0.1216927989107599,0.0002589504928171005,0.5390440541346916,0.13709003410307474,0.6189267166698266,0.06615901585198758,0.933883761497574,0.949451084867965,0.3634753344984707,0.48433711613478636,0.5395590663730234,0.45935744105348186,0.9076795131968168,0.47602949941583694,0.012772749193020627,0.13988213817901718,0.19654241444621068,0.7482822982039975,0.234544805403462,0.15924846858169472,0.31384131541383176,0.03432384830529944,0.8126808406432042,0.48270470890429196,0.0565447875387991,0.1769720975094693,0.5080797770263434,0.2626990412502591,0.6922719848195987,0.3888785640255561,0.43929954901083834,0.9587554574983969,0.3229767074565688,0.8763586866793989,0.24180651503614659,0.8285683109161266,0.03162792131208547,0.9191070310598273,0.9677683659887099,0.1800922592125831,0.5323929508159617,0.34692538727205247,0.13278288715692776,0.9855767294221897,0.46997238000161834,0.5882814093650923,0.40928090449853693,0.8554390937601573,0.4749011665336712,0.35858954071264815,0.713788134347823,0.487567621412648,0.30748069588534777,0.9372525444975786,0.8642444081469173,0.7500704768240007,0.755706686626043,0.1346902372172919,0.5774159486987076,0.356458756626324,0.6024562178920854,0.8388557004999065,0.7846011512360269,0.800651848974049,0.309389644897445,0.6116610550261811,0.900729813806025,0.5134108130353751,0.9716952584522351,0.27765645613141954,0.7332320153868233,0.1639541985441072,0.20936203240241524,0.34482828805449384,0.8039577990708562,0.3878901215288181,0.7834203875061456,0.8971239231649832,0.3796419066840939,0.7060860357334999,0.2166384682559852,0.5355820778024672,0.4840145953079147,0.165519829492482,0.0021860811463727536,0.4174102297595472,0.5786941294126641,0.6247268407053519,0.9857805201762525,0.052394575801160914,0.23598365353492345,0.3762651826988631,0.8676458803605587,0.5331190546468628,0.6383459834705725,0.7294381706717086,0.6544030373223826,0.5835931476942529,0.01765757932259837,0.5039245098920719,0.7988697900938893,0.36263610756988307,0.5961640490404368,0.3688929217874597,0.23857237215615335,0.19210308187894043,0.2749176367366667,0.6459231695808164,0.9312153818167146,0.35438541400739865,0.8564907834153462,0.7045698431727971,0.09001025628345138,0.869941034328464,0.8272190882451322,0.06896527001315977,0.35063031818249324,0.23512458368000033,0.5259580746689226,0.7864705975529062,0.36875177985027907,0.9444261879167085,0.023775410279436526,0.8407150574023875,0.7067683649612702,0.23965342110666754,0.4268186025826005,0.5507959511429188,0.5388359086053506,0.054442632175289996,0.2604670654484311,0.8588489550436157,0.18868047963032675,0.44413718677552316,0.7709217360449184,0.7827670479432789,0.7049982793654401,0.3648334852713927,0.38293655160840323,0.08871502944616783,0.13904897380181702,0.7632746991299822,0.11251454043431086,0.028854166060188535,0.6052005640094291,0.10354894821011451,0.5972965501011563,0.16154580902657845,0.1772010872202594,0.8077475422361428,0.08471811514854033,0.331890990992066,0.732379250480459,0.18575837471123335,0.26025588240307995,0.5123646694212934,0.331986351823473,0.3511333292097194,0.8082130934132719,0.00769292483633266,0.9996899503253985,0.27780232903085345,0.9296619425261768,0.6997657440265221,0.7093451522199569,0.08456040909943985,0.618186977643542,0.491167300666397,0.42700367453137456,0.654581015796094,0.47605437370966197,0.41718781221895396,0.4797584497117031,0.06260039530159589,0.3666436105954144,0.6125968247162585,0.2122381340795878,0.15371883153944388,0.8501578459413619,0.6225160606414498,0.16653978543921055,0.058293148623012936,0.5846275418587069,0.9044070980029064,0.6354315660866894,0.4775598202454061,0.3923985864564806,0.5165662643793901,0.26230367589989645,0.770459332477986,0.267085226009245,0.7137134603810947,0.008716168271932223,0.9887189146674601,0.23752180573187054,0.29066723067091504,0.3668982859905324,0.20422893407905873,0.7804554219789913,0.9540154498999732,0.423052854695385,0.45165321334768616,0.011516943267384616,0.3879408279837925,0.32594777126523333,0.7922797064190705,0.21571404488003854,0.045708632951277695,0.4285725366407547,0.753015043993881,0.3665610690771075,0.7447847796179364,0.20790895044430036,0.946266550801208,0.3691429655435642,0.3324496032579177,0.06627839865770102,0.5888524749666165,0.5715523970156418,0.2226867932482709,0.03367500412955027,0.7920336634837599,0.6663437066645327,0.3313214984921956,0.3247925891679917,0.5950563634817981,0.5252615514595262,0.45471493041014555,0.06105349908582425,0.9206084783354391,0.5197082311407163,0.7105082547839131,0.3668695700411183,0.4710164780513725,0.3593163782128337,0.9014251988834614,0.1509424507956073,0.46295872316033615,0.04381411560559134,0.7533668259549025,0.772519838487539,0.08718847016202536,0.05114892124595283,0.627382207635217,0.8501773775656042,0.5217616284357779,0.9130065267447062,0.7708880212846134,0.40717655913746065,0.9712627071636633,0.13404121386737033,0.12300012512042735,0.4513782754300908,0.1341827537650624,0.6612492860978672,0.40364619421289116,0.9638363437100206,0.6132300188078011,0.33290870880795576,0.5186693192784957,0.7243126778339127,0.2277254481150658,0.41275245332432464,0.018295623179554354,0.4724583563387612,0.023664028515963276,0.5420629833325088,0.9663441609385607,0.265337818186936,0.20382524949811953,0.6906518046350097,0.5434832078383928,0.7234798985312485,0.4727878925772332,0.0057170109956813375,0.005722254249330261,0.2341116454962361,0.017128078303850325,0.15307907100969964,0.7536726556500352,0.47499612126874025],"y":[0.4288983069464142,0.3312777738857384,0.8961582449596803,0.18281896568752942,0.508398242418425,0.37903913202373607,0.08354519275837424,0.824999057522437,0.9102504545276118,0.5381847546626198,0.9296736774554776,0.9374340473287637,0.3200726834838019,0.6530277997315022,0.2569561044287779,0.5509318873962104,0.949825486583851,0.7908169457148287,0.25129492588451874,0.43980400444396295,0.3347839198917193,0.0034570962329742994,0.8995308212702229,0.634578119788968,0.6519464352315818,0.42429273231450493,0.32502483352092215,0.7867875976725484,0.2919444867081221,0.9419376044308055,0.8549142728787582,0.3712350883538227,0.2939512468048343,0.07029482950677601,0.6880292472156039,0.7869930633712386,0.8198287888779936,0.6096868135522159,0.3100161907586785,0.36285099794049214,0.32744419640786804,0.3018828811263712,0.9279023310312503,0.7635279116708608,0.4069322263933023,0.49111597348497615,0.8769455042232301,0.5841056597507668,0.6505652388667157,0.9143523785203325,0.009065212636871656,0.5156337927053967,0.5354404076201732,0.7832429245402945,0.835911825253446,0.5904181387488331,0.3848234529555682,0.4759610251924913,0.5822620669543057,0.2681322838118986,0.1505036416922988,0.06746054387557066,0.24087637655262228,0.3269732483594735,0.29968255926505283,0.08215406571618589,0.7873108052518085,0.7917499694300638,0.5838046910015069,0.25551013642524845,0.639238406179822,0.5436214245476699,0.6039048010260879,0.27100105628488547,0.07461358126270501,0.08319495888400974,0.008393151311508307,0.43825348721303503,0.8490862608665526,0.9247798016858271,0.0070452732908461435,0.7845568409274943,0.4904579598290413,0.2171500431083614,0.3532395892108554,0.7491197195315185,0.7291135057750568,0.5026596380799372,0.3480793984377869,0.7246934218406605,0.09647193940019572,0.5229589953791073,0.6383285122585386,0.17517401104930508,0.63801933341593,0.747319353642425,0.7472865762956942,0.7364173895033747,0.2931259706058901,0.1373882722183446,0.22529234703483614,0.6805984564311873,0.8528833047787815,0.5658434716690162,0.6746394156938229,0.7850798956423087,0.5329359341599034,0.8892450198968538,0.3964907674788142,0.9507976742531223,0.6525458368733161,0.6526024574438503,0.4660246579397824,0.4508712122190126,0.4161375987565882,0.9009905012525931,0.5930044608052261,0.2376194749521452,0.8880366698748331,0.593437373833467,0.20427141674495486,0.7537285001756645,0.8944256982494156,0.4518911623519317,0.7978486401274392,0.22425441621238895,0.6724097282175712,0.9128055098675105,0.93598932381582,0.2646810111090525,0.8104363562162853,0.7864029417573587,0.7826221186728023,0.13319130826980163,0.4514776502892883,0.3328035279002234,0.2932914014628121,0.7920138921239037,0.938848989539502,0.8240541964525444,0.25405426224443384,0.7339632021455335,0.08661246434367675,0.8878261258454433,0.6887141069524498,0.4146585771222884,0.18284762597028892,0.9743477612374611,0.21274753465010043,0.6420070766505399,0.567754323753047,0.4068255217742941,0.8933461623545591,0.47216656831569603,0.008234655830782978,0.9726044383805638,0.530991090980106,0.3078007360585916,0.622972286032533,0.6390108764401926,0.5694403776967827,0.5814474279748649,0.2731044597004506,0.9725934201368531,0.6287246128910445,0.4700523776432114,0.22933470310934612,0.840478660813343,0.9748351938497126,0.3433416652679696,0.03409443179122407,0.023517088140565856,0.5883411318146953,0.03866584032263176,0.5123942950645184,0.460292085760861,0.36589035028977446,0.4454755567118601,0.66287753812788,0.5554155399011331,0.10060840793226877,0.4306786003908014,0.958555303051441,0.6685598487671793,0.3559279000426996,0.47066630087893524,0.6329912315335691,0.7292789984114371,0.7710784381549931,0.7045441803561939,0.7885489177157069,0.060492718927698585,0.9019055635674708,0.45657008122363507,0.2514909200767854,0.13962435498056458,0.10600527829667972,0.6668276060971319,0.1577223961088683,0.322531830735169,0.6020292679799302,0.09910277471137086,0.6368712596910813,0.8858074498162047,0.16625407079454546,0.6056063922112588,0.9021141211790855,0.5690259758721027,0.07298024703390327,0.8524854885506612,0.23167173629344062,0.47403993402747613,0.8394476560885432,0.9716417449323805,0.49579465398284606,0.2625448387941458,0.11118726881475183,0.27189739952859726,0.6864499453096915,0.03130822482992879,0.9672434820338182,0.6960329413159403,0.7721793357574993,0.7289356230628606,0.15710141646654252,0.4087022451703639,0.24184710240580976,0.5563833251807756,0.21289116442113454,0.050159655454319996,0.34903872695485416,0.002184059098672586,0.19590754789046294,0.849655627724618,0.6382675464375092,0.19869666999829194,0.17129608017041276,0.5438926175434463,0.34296998554186964,0.3958562289737019,0.5981532700219082,0.18308673165244138,0.20995845360879917,0.2627802595666856,0.9501750361230638,0.14523242816336945,0.542680778323798,0.7471948778967992,0.19180973798858048,0.1200537071862503,0.9731655137084008,0.6095720038808211,0.7597069194423743,0.5136179311796795,0.3547736880102982,0.49523960907124887,0.9656797844249808,0.6306642620791039,0.7913749131022615,0.8970645052189614,0.9593610412230186,0.5245756935954924,0.5004757122567923,0.39840396463816286,0.24409240900292595,0.43366818112058314,0.9277959162190417,0.2200735669671391,0.060598598064540266,0.5452410463281009,0.8463890735326199,0.3373362445605348,0.217403067479642,0.5288492061707971,0.6670105530855243,0.9519301570275942,0.7720208738964924,0.13715242812054318,0.3230003538026802,0.5193128325784994,0.5320152451681814,0.27077167077442565,0.7568499750584853,0.34257219222763924,0.5576111101342962,0.034626099866182036,0.6116482372535126,0.10468109100967804,0.725310065648999,0.5530782287592115,0.2619218230259076,0.5995939123811213,0.6915765339694013,0.5716104728268441,0.8594212064889598,0.286590600583594,0.8431900149513091,0.27830080311827143,0.12020416114106569,0.7762774750005748,0.9464438470752797,0.6944596076498222,0.8776596849297748,0.4692126744715769,0.713808213114092,0.3962627847803648,0.4085792463565735,0.49046336403707647,0.4210932528938951,0.9694389865043532,0.08087583356319539,0.546935694524261,0.9150234597168838,0.015118780562187073,0.8583814504678937,0.9679866896596253,0.47811147220472383,0.6457383586833982,0.7890289370981166,0.495702431273776,0.9563675346061923,0.09538516525285323,0.5828792365748988,0.6122782562760005,0.9942733997597192,0.4659141019476424,0.9765052356776283,0.976985960637406,0.21405603657199257,0.8648723815904236,0.27277803791383437,0.40276524276028625,0.3190893889848897,0.957365971075802,0.5507328409169011,0.030797165702979412,0.21124207721729926,0.6627825743152048,0.4021626108633075,0.44837616706691263,0.554531894310963,0.7843401602549972,0.773590489477422,0.7565089213153552,0.36013426790864833,0.7958005701757471,0.9054247782216835,0.758014348522164,0.7588349331291495,0.7875865678723737,0.1440890023973933,0.5557320402594657,0.29903588061672937,0.7377245188573375,0.8868325006798958,0.7016364389269051,0.41303447174345,0.3952813194094227,0.3746288899261241,0.03729777942151935,0.439103600404779,0.1767144011491687,0.6124971304956938,0.8636377216928768,0.8183559292482249,0.1895521686613003,0.9475638411690791,0.031032112151065827,0.8968313114649339,0.18633627793281637,0.8092374918761726,0.8638561849781312,0.36315731729704703,0.79776053593285,0.009110090583573038,0.03444846529270873,0.6112028875737036,0.4331231247037083,0.25871425190393116,0.3786287870529904,0.8033669763987333,0.7963620599187899,0.8573261427979644,0.6905336817561123,0.7976455022041232,0.8066785334447565,0.7859478602811637,0.9315439280477832,0.2205227259589363,0.5015873983530438,0.004646600023755831,0.9249607788222001,0.5765460932828429,0.24919869902935055,0.32883019331053354,0.7854607005879289,0.007845104373446321,0.4479184644568448,0.1791737621400582,0.4679704150887162,0.7939722108052871,0.4914860464853258,0.4497038941289784,0.17243146242565077,0.38623191565608694,0.9169615873794934,0.2038970312351822,0.040737927980599054,0.1860346205655674,0.02064828534956864,0.9867957101905203,0.6885861581175899,0.20556327293095678,0.21416723706888086,0.02275479871374464,0.6013608570420736,0.19118716214690068,0.8983146763821128,0.9029292333945094,0.5377800412030085,0.5785404302136106,0.3620357889865434,0.28270031107706106,0.7097356864366798,0.2093479677771095,0.8001783218325261,0.8662161070140167,0.190852159686686,0.8413111457783041,0.3169869614612374,0.6872118314622601,0.7107988399356426,0.9838268062934534,0.14617897306492866,0.35095321029608373,0.3615878403763707,0.34882643475682873,0.8418347282734935,0.5091196998748313,0.1830239855969884,0.4610197102969964,0.8928918998167088,0.32949093427979903,0.4556798910709917,0.27320173270273496,0.5104907691140678,0.5599424662754884,0.7788906384182632,0.6475712616512376,0.1193409545007672,0.8236206554688733,0.07394141622598316,0.28058765988258505,0.2463391998777209,0.5037888283625047,0.7798498491401358,0.054595748425172785,0.951325439422903,0.034985282146977714,0.17830182645790804,0.9332787485414779,0.05849395558063819,0.7553487511865131,0.6065192136540125,0.2483425357986252,0.9044504854519481,0.8229002864014685,0.9252580610653628,0.7659243278473473,0.8972716634388539,0.8775094982683785,0.9161203546018376,0.38640679550103363,0.7532817427628208,0.4164512013112932,0.7111651895184293,0.06892498087826315,0.7729066585889467,0.015765841411597648,0.3481813981782331,0.014278500280840878,0.48140611839053515,0.9401288552853676,0.5383064574686675,0.6587415645270638,0.8996374896147155,0.6049467732258201,0.004781107888364833,0.5923547456839587,0.8434701612873748,0.2648398099480028,0.31314288394541634,0.21816092784713936,0.18925889241432914,0.8477150117655747,0.3490615116051924,0.17221219181637903,0.009525996416018812,0.2660705215859155,0.5680537842312862]},"selected":{"id":"30434"},"selection_policy":{"id":"30441"}},"id":"30399","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"30415"},"dimension":1,"ticker":null},"id":"30418","type":"Grid"},{"attributes":{"overlay":{"id":"30420"}},"id":"30419","type":"LassoSelectTool"},{"attributes":{},"id":"30403","type":"DataRange1d"},{"attributes":{},"id":"30438","type":"BasicTickFormatter"},{"attributes":{"text":"Select Here"},"id":"30401","type":"Title"},{"attributes":{"line_alpha":0.6,"line_color":"orange","line_width":5,"x":{"field":"x"},"y":{"field":"ym"}},"id":"30430","type":"Line"},{"attributes":{},"id":"30405","type":"DataRange1d"},{"attributes":{},"id":"30409","type":"LinearScale"},{"attributes":{"formatter":{"id":"30440"},"ticker":{"id":"30416"}},"id":"30415","type":"LinearAxis"},{"attributes":{},"id":"30441","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"30428"},"glyph":{"id":"30430"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"30431"},"selection_glyph":null,"view":{"id":"30433"}},"id":"30432","type":"GlyphRenderer"},{"attributes":{},"id":"30440","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"30438"},"ticker":{"id":"30412"}},"id":"30411","type":"LinearAxis"}],"root_ids":["30400"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"9f8472cc-7d90-4766-aea8-77a64e746e98","root_ids":["30400"],"roots":{"30400":"a19a9e63-712f-4bb7-8ec0-2134ca2fed74"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();