(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("9a1ee4af-1cfb-439d-ae3e-cdbe07d0741f");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '9a1ee4af-1cfb-439d-ae3e-cdbe07d0741f' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"2fa7aef0-16a4-4c81-8c2d-004092f96598":{"roots":{"references":[{"attributes":{"formatter":{"id":"31760"},"ticker":{"id":"31730"}},"id":"31729","type":"LinearAxis"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"units":"data","value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"31749","type":"Circle"},{"attributes":{},"id":"31758","type":"BasicTickFormatter"},{"attributes":{},"id":"31737","type":"ResetTool"},{"attributes":{"axis":{"id":"31729"},"dimension":1,"ticker":null},"id":"31732","type":"Grid"},{"attributes":{},"id":"31762","type":"Selection"},{"attributes":{},"id":"31734","type":"WheelZoomTool"},{"attributes":{},"id":"31738","type":"HelpTool"},{"attributes":{"args":{"other":{"id":"31748"}},"code":"other.radius = this.value"},"id":"31753","type":"CustomJS"},{"attributes":{},"id":"31761","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"31747"},"glyph":{"id":"31748"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"31749"},"selection_glyph":null,"view":{"id":"31751"}},"id":"31750","type":"GlyphRenderer"},{"attributes":{},"id":"31730","type":"BasicTicker"},{"attributes":{},"id":"31760","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"31725"},"ticker":null},"id":"31728","type":"Grid"},{"attributes":{"formatter":{"id":"31758"},"ticker":{"id":"31726"}},"id":"31725","type":"LinearAxis"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.5},"line_color":{"value":"#1f77b4"},"radius":{"units":"data","value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"31748","type":"Circle"},{"attributes":{},"id":"31719","type":"DataRange1d"},{"attributes":{"children":[{"id":"31716"},{"id":"31752"}]},"id":"31754","type":"Column"},{"attributes":{"source":{"id":"31747"}},"id":"31751","type":"CDSView"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[3,2,5,6,4]},"selected":{"id":"31762"},"selection_policy":{"id":"31761"}},"id":"31747","type":"ColumnDataSource"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"31739","type":"BoxAnnotation"},{"attributes":{"overlay":{"id":"31739"}},"id":"31735","type":"BoxZoomTool"},{"attributes":{},"id":"31721","type":"LinearScale"},{"attributes":{"below":[{"id":"31725"}],"center":[{"id":"31728"},{"id":"31732"}],"left":[{"id":"31729"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"31750"}],"title":{"id":"31755"},"toolbar":{"id":"31740"},"x_range":{"id":"31717"},"x_scale":{"id":"31721"},"y_range":{"id":"31719"},"y_scale":{"id":"31723"}},"id":"31716","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"31723","type":"LinearScale"},{"attributes":{},"id":"31726","type":"BasicTicker"},{"attributes":{},"id":"31717","type":"DataRange1d"},{"attributes":{"end":2,"format":"0[.]00","js_property_callbacks":{"change:value":[{"id":"31753"}]},"start":0.1,"step":0.01,"value":0.2},"id":"31752","type":"Slider"},{"attributes":{"text":""},"id":"31755","type":"Title"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"31733"},{"id":"31734"},{"id":"31735"},{"id":"31736"},{"id":"31737"},{"id":"31738"}]},"id":"31740","type":"Toolbar"},{"attributes":{},"id":"31733","type":"PanTool"},{"attributes":{},"id":"31736","type":"SaveTool"}],"root_ids":["31754"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"2fa7aef0-16a4-4c81-8c2d-004092f96598","root_ids":["31754"],"roots":{"31754":"9a1ee4af-1cfb-439d-ae3e-cdbe07d0741f"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();