(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("ef44d264-be03-4d13-9beb-97b1d87c2749");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'ef44d264-be03-4d13-9beb-97b1d87c2749' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"8c43c3c8-858c-44d4-a72c-46918f3bcd62":{"roots":{"references":[{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"olive"},"line_alpha":{"value":0.1},"line_color":{"value":"olive"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"31436","type":"Square"},{"attributes":{},"id":"31377","type":"BasicTicker"},{"attributes":{"formatter":{"id":"31443"},"ticker":{"id":"31346"}},"id":"31345","type":"LinearAxis"},{"attributes":{"axis":{"id":"31412"},"ticker":null},"id":"31415","type":"Grid"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"31390","type":"BoxAnnotation"},{"attributes":{},"id":"31410","type":"LinearScale"},{"attributes":{},"id":"31349","type":"PanTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"navy"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"31365","type":"Circle"},{"attributes":{},"id":"31425","type":"HelpTool"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"31384"},{"id":"31385"},{"id":"31386"},{"id":"31387"},{"id":"31388"},{"id":"31389"}]},"id":"31391","type":"Toolbar"},{"attributes":{"formatter":{"id":"31452"},"ticker":{"id":"31381"}},"id":"31380","type":"LinearAxis"},{"attributes":{},"id":"31454","type":"Selection"},{"attributes":{},"id":"31453","type":"UnionRenderers"},{"attributes":{},"id":"31450","type":"BasicTickFormatter"},{"attributes":{},"id":"31333","type":"DataRange1d"},{"attributes":{"axis":{"id":"31380"},"dimension":1,"ticker":null},"id":"31383","type":"Grid"},{"attributes":{},"id":"31339","type":"LinearScale"},{"attributes":{},"id":"31388","type":"ResetTool"},{"attributes":{},"id":"31443","type":"BasicTickFormatter"},{"attributes":{},"id":"31417","type":"BasicTicker"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"31349"},{"id":"31350"},{"id":"31351"},{"id":"31352"},{"id":"31353"},{"id":"31354"}]},"id":"31356","type":"Toolbar"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"31420"},{"id":"31421"},{"id":"31422"},{"id":"31423"},{"id":"31424"},{"id":"31425"}]},"id":"31427","type":"Toolbar"},{"attributes":{"below":[{"id":"31341"}],"center":[{"id":"31344"},{"id":"31348"}],"left":[{"id":"31345"}],"plot_height":250,"plot_width":250,"renderers":[{"id":"31366"}],"title":null,"toolbar":{"id":"31356"},"toolbar_location":null,"x_range":{"id":"31333"},"x_scale":{"id":"31337"},"y_range":{"id":"31335"},"y_scale":{"id":"31339"}},"id":"31331","subtype":"Figure","type":"Plot"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"navy"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"31364","type":"Circle"},{"attributes":{},"id":"31342","type":"BasicTicker"},{"attributes":{"source":{"id":"31434"}},"id":"31438","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"olive"},"line_alpha":{"value":0.5},"line_color":{"value":"olive"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"31435","type":"Square"},{"attributes":{},"id":"31353","type":"ResetTool"},{"attributes":{},"id":"31461","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"31461"},"ticker":{"id":"31417"}},"id":"31416","type":"LinearAxis"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"31426","type":"BoxAnnotation"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"31355","type":"BoxAnnotation"},{"attributes":{},"id":"31413","type":"BasicTicker"},{"attributes":{"axis":{"id":"31345"},"dimension":1,"ticker":null},"id":"31348","type":"Grid"},{"attributes":{},"id":"31346","type":"BasicTicker"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"firebrick"},"line_alpha":{"value":0.5},"line_color":{"value":"firebrick"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"31399","type":"Triangle"},{"attributes":{},"id":"31424","type":"ResetTool"},{"attributes":{},"id":"31463","type":"Selection"},{"attributes":{},"id":"31350","type":"WheelZoomTool"},{"attributes":{},"id":"31374","type":"LinearScale"},{"attributes":{},"id":"31445","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"firebrick"},"line_alpha":{"value":0.1},"line_color":{"value":"firebrick"},"size":{"units":"screen","value":10},"x":{"field":"x"},"y":{"field":"y"}},"id":"31400","type":"Triangle"},{"attributes":{"source":{"id":"31398"}},"id":"31402","type":"CDSView"},{"attributes":{},"id":"31385","type":"WheelZoomTool"},{"attributes":{"axis":{"id":"31416"},"dimension":1,"ticker":null},"id":"31419","type":"Grid"},{"attributes":{"below":[{"id":"31412"}],"center":[{"id":"31415"},{"id":"31419"}],"left":[{"id":"31416"}],"plot_height":250,"plot_width":250,"renderers":[{"id":"31437"}],"title":null,"toolbar":{"id":"31427"},"toolbar_location":null,"x_range":{"id":"31333"},"x_scale":{"id":"31408"},"y_range":{"id":"31406"},"y_scale":{"id":"31410"}},"id":"31403","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"31384","type":"PanTool"},{"attributes":{},"id":"31406","type":"DataRange1d"},{"attributes":{},"id":"31423","type":"SaveTool"},{"attributes":{"data_source":{"id":"31398"},"glyph":{"id":"31399"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"31400"},"selection_glyph":null,"view":{"id":"31402"}},"id":"31401","type":"GlyphRenderer"},{"attributes":{},"id":"31389","type":"HelpTool"},{"attributes":{},"id":"31408","type":"LinearScale"},{"attributes":{"below":[{"id":"31376"}],"center":[{"id":"31379"},{"id":"31383"}],"left":[{"id":"31380"}],"plot_height":250,"plot_width":250,"renderers":[{"id":"31401"}],"title":null,"toolbar":{"id":"31391"},"toolbar_location":null,"x_range":{"id":"31333"},"x_scale":{"id":"31372"},"y_range":{"id":"31335"},"y_scale":{"id":"31374"}},"id":"31368","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"31441"},"ticker":{"id":"31342"}},"id":"31341","type":"LinearAxis"},{"attributes":{},"id":"31420","type":"PanTool"},{"attributes":{"data":{"x":[0,1,2,3,4,5,6,7,8,9,10],"y":[5,4,3,2,1,0,1,2,3,4,5]},"selected":{"id":"31463"},"selection_policy":{"id":"31462"}},"id":"31434","type":"ColumnDataSource"},{"attributes":{},"id":"31444","type":"UnionRenderers"},{"attributes":{"children":[[{"id":"31331"},0,0],[{"id":"31368"},0,1],[{"id":"31403"},0,2]]},"id":"31466","type":"GridBox"},{"attributes":{"overlay":{"id":"31426"}},"id":"31422","type":"BoxZoomTool"},{"attributes":{"formatter":{"id":"31450"},"ticker":{"id":"31377"}},"id":"31376","type":"LinearAxis"},{"attributes":{"data_source":{"id":"31363"},"glyph":{"id":"31364"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"31365"},"selection_glyph":null,"view":{"id":"31367"}},"id":"31366","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"31434"},"glyph":{"id":"31435"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"31436"},"selection_glyph":null,"view":{"id":"31438"}},"id":"31437","type":"GlyphRenderer"},{"attributes":{},"id":"31337","type":"LinearScale"},{"attributes":{},"id":"31381","type":"BasicTicker"},{"attributes":{},"id":"31421","type":"WheelZoomTool"},{"attributes":{"data":{"x":[0,1,2,3,4,5,6,7,8,9,10],"y":[0,1,2,3,4,5,6,7,8,9,10]},"selected":{"id":"31445"},"selection_policy":{"id":"31444"}},"id":"31363","type":"ColumnDataSource"},{"attributes":{"overlay":{"id":"31355"}},"id":"31351","type":"BoxZoomTool"},{"attributes":{},"id":"31387","type":"SaveTool"},{"attributes":{"overlay":{"id":"31390"}},"id":"31386","type":"BoxZoomTool"},{"attributes":{},"id":"31459","type":"BasicTickFormatter"},{"attributes":{"axis":{"id":"31376"},"ticker":null},"id":"31379","type":"Grid"},{"attributes":{},"id":"31372","type":"LinearScale"},{"attributes":{"formatter":{"id":"31459"},"ticker":{"id":"31413"}},"id":"31412","type":"LinearAxis"},{"attributes":{"source":{"id":"31363"}},"id":"31367","type":"CDSView"},{"attributes":{},"id":"31335","type":"DataRange1d"},{"attributes":{},"id":"31462","type":"UnionRenderers"},{"attributes":{},"id":"31354","type":"HelpTool"},{"attributes":{"data":{"x":[0,1,2,3,4,5,6,7,8,9,10],"y":[10,9,8,7,6,5,4,3,2,1,0]},"selected":{"id":"31454"},"selection_policy":{"id":"31453"}},"id":"31398","type":"ColumnDataSource"},{"attributes":{"axis":{"id":"31341"},"ticker":null},"id":"31344","type":"Grid"},{"attributes":{},"id":"31441","type":"BasicTickFormatter"},{"attributes":{},"id":"31452","type":"BasicTickFormatter"},{"attributes":{},"id":"31352","type":"SaveTool"}],"root_ids":["31466"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"8c43c3c8-858c-44d4-a72c-46918f3bcd62","root_ids":["31466"],"roots":{"31466":"ef44d264-be03-4d13-9beb-97b1d87c2749"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();