(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("daab65bb-eda1-4cc0-85f8-b4bd5c21c73e");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'daab65bb-eda1-4cc0-85f8-b4bd5c21c73e' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"ee739fda-8d05-475c-9361-a228f4ca35e7":{"roots":{"references":[{"attributes":{"callback":{"id":"30776"}},"id":"30760","type":"TapTool"},{"attributes":{},"id":"30753","type":"BasicTicker"},{"attributes":{},"id":"30774","type":"UnionRenderers"},{"attributes":{},"id":"30748","type":"LinearScale"},{"attributes":{},"id":"30746","type":"DataRange1d"},{"attributes":{},"id":"30757","type":"BasicTicker"},{"attributes":{"axis":{"id":"30752"},"ticker":null},"id":"30755","type":"Grid"},{"attributes":{"axis":{"id":"30756"},"dimension":1,"ticker":null},"id":"30759","type":"Grid"},{"attributes":{},"id":"30771","type":"BasicTickFormatter"},{"attributes":{"source":{"id":"30763"}},"id":"30768","type":"CDSView"},{"attributes":{"below":[{"id":"30752"}],"center":[{"id":"30755"},{"id":"30759"}],"left":[{"id":"30756"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"30767"}],"title":{"id":"30742"},"toolbar":{"id":"30761"},"x_range":{"id":"30744"},"x_scale":{"id":"30748"},"y_range":{"id":"30746"},"y_scale":{"id":"30750"}},"id":"30741","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"30773"},"ticker":{"id":"30757"}},"id":"30756","type":"LinearAxis"},{"attributes":{"fill_color":{"field":"color"},"line_color":{"field":"color"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"30765","type":"Circle"},{"attributes":{},"id":"30744","type":"DataRange1d"},{"attributes":{"data_source":{"id":"30763"},"glyph":{"id":"30765"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"30766"},"selection_glyph":null,"view":{"id":"30768"}},"id":"30767","type":"GlyphRenderer"},{"attributes":{"url":"http://www.html-color-names.com/@color.php"},"id":"30776","type":"OpenURL"},{"attributes":{},"id":"30750","type":"LinearScale"},{"attributes":{},"id":"30773","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"30771"},"ticker":{"id":"30753"}},"id":"30752","type":"LinearAxis"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"field":"color"},"line_alpha":{"value":0.1},"line_color":{"field":"color"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"30766","type":"Circle"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"30760"}]},"id":"30761","type":"Toolbar"},{"attributes":{"data":{"color":["navy","orange","olive","firebrick","gold"],"x":[1,2,3,4,5],"y":[2,5,8,2,7]},"selected":{"id":"30775"},"selection_policy":{"id":"30774"}},"id":"30763","type":"ColumnDataSource"},{"attributes":{},"id":"30775","type":"Selection"},{"attributes":{"text":"Click the Dots"},"id":"30742","type":"Title"}],"root_ids":["30741"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"ee739fda-8d05-475c-9361-a228f4ca35e7","root_ids":["30741"],"roots":{"30741":"daab65bb-eda1-4cc0-85f8-b4bd5c21c73e"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();