(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("6fa84ab5-fda0-4efc-9998-168671b3a454");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '6fa84ab5-fda0-4efc-9998-168671b3a454' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"34841cf4-1075-441e-9d37-9c8933cec048":{"roots":{"references":[{"attributes":{},"id":"32052","type":"BasicTicker"},{"attributes":{},"id":"32085","type":"BasicTickFormatter"},{"attributes":{},"id":"32056","type":"WheelZoomTool"},{"attributes":{"data_source":{"id":"32032"},"glyph":{"id":"32033"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"32034"},"selection_glyph":null,"view":{"id":"32036"}},"id":"32035","type":"GlyphRenderer"},{"attributes":{},"id":"32055","type":"PanTool"},{"attributes":{},"id":"32058","type":"SaveTool"},{"attributes":{},"id":"32089","type":"Selection"},{"attributes":{"below":[{"id":"32010"}],"center":[{"id":"32013"},{"id":"32017"}],"left":[{"id":"32014"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"32035"}],"title":{"id":"32076"},"toolbar":{"id":"32025"},"x_range":{"id":"32002"},"x_scale":{"id":"32006"},"y_range":{"id":"32004"},"y_scale":{"id":"32008"}},"id":"32001","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"32045","type":"LinearScale"},{"attributes":{"child":{"id":"32038"},"title":"line"},"id":"32074","type":"Panel"},{"attributes":{"text":""},"id":"32078","type":"Title"},{"attributes":{"axis":{"id":"32010"},"ticker":null},"id":"32013","type":"Grid"},{"attributes":{},"id":"32002","type":"DataRange1d"},{"attributes":{},"id":"32087","type":"BasicTickFormatter"},{"attributes":{},"id":"32008","type":"LinearScale"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"navy"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"32034","type":"Circle"},{"attributes":{},"id":"32092","type":"Selection"},{"attributes":{"formatter":{"id":"32081"},"ticker":{"id":"32011"}},"id":"32010","type":"LinearAxis"},{"attributes":{"child":{"id":"32001"},"title":"circle"},"id":"32037","type":"Panel"},{"attributes":{},"id":"32006","type":"LinearScale"},{"attributes":{"source":{"id":"32069"}},"id":"32073","type":"CDSView"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"32061","type":"BoxAnnotation"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,2,4,5]},"selected":{"id":"32089"},"selection_policy":{"id":"32088"}},"id":"32032","type":"ColumnDataSource"},{"attributes":{"line_alpha":0.1,"line_color":"navy","line_width":3,"x":{"field":"x"},"y":{"field":"y"}},"id":"32071","type":"Line"},{"attributes":{"overlay":{"id":"32024"}},"id":"32020","type":"BoxZoomTool"},{"attributes":{},"id":"32048","type":"BasicTicker"},{"attributes":{"below":[{"id":"32047"}],"center":[{"id":"32050"},{"id":"32054"}],"left":[{"id":"32051"}],"plot_height":300,"plot_width":300,"renderers":[{"id":"32072"}],"title":{"id":"32078"},"toolbar":{"id":"32062"},"x_range":{"id":"32039"},"x_scale":{"id":"32043"},"y_range":{"id":"32041"},"y_scale":{"id":"32045"}},"id":"32038","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"32039","type":"DataRange1d"},{"attributes":{},"id":"32043","type":"LinearScale"},{"attributes":{},"id":"32015","type":"BasicTicker"},{"attributes":{},"id":"32011","type":"BasicTicker"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"32024","type":"BoxAnnotation"},{"attributes":{"tabs":[{"id":"32037"},{"id":"32074"}]},"id":"32075","type":"Tabs"},{"attributes":{"formatter":{"id":"32083"},"ticker":{"id":"32015"}},"id":"32014","type":"LinearAxis"},{"attributes":{"axis":{"id":"32047"},"ticker":null},"id":"32050","type":"Grid"},{"attributes":{"formatter":{"id":"32087"},"ticker":{"id":"32052"}},"id":"32051","type":"LinearAxis"},{"attributes":{"axis":{"id":"32051"},"dimension":1,"ticker":null},"id":"32054","type":"Grid"},{"attributes":{},"id":"32083","type":"BasicTickFormatter"},{"attributes":{},"id":"32021","type":"SaveTool"},{"attributes":{},"id":"32023","type":"HelpTool"},{"attributes":{"formatter":{"id":"32085"},"ticker":{"id":"32048"}},"id":"32047","type":"LinearAxis"},{"attributes":{"source":{"id":"32032"}},"id":"32036","type":"CDSView"},{"attributes":{},"id":"32018","type":"PanTool"},{"attributes":{"data":{"x":[1,2,3,4,5],"y":[6,7,2,4,5]},"selected":{"id":"32092"},"selection_policy":{"id":"32091"}},"id":"32069","type":"ColumnDataSource"},{"attributes":{},"id":"32041","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"32055"},{"id":"32056"},{"id":"32057"},{"id":"32058"},{"id":"32059"},{"id":"32060"}]},"id":"32062","type":"Toolbar"},{"attributes":{},"id":"32081","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"navy"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"size":{"units":"screen","value":20},"x":{"field":"x"},"y":{"field":"y"}},"id":"32033","type":"Circle"},{"attributes":{},"id":"32091","type":"UnionRenderers"},{"attributes":{},"id":"32019","type":"WheelZoomTool"},{"attributes":{"line_alpha":0.5,"line_color":"navy","line_width":3,"x":{"field":"x"},"y":{"field":"y"}},"id":"32070","type":"Line"},{"attributes":{"text":""},"id":"32076","type":"Title"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"32018"},{"id":"32019"},{"id":"32020"},{"id":"32021"},{"id":"32022"},{"id":"32023"}]},"id":"32025","type":"Toolbar"},{"attributes":{"data_source":{"id":"32069"},"glyph":{"id":"32070"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"32071"},"selection_glyph":null,"view":{"id":"32073"}},"id":"32072","type":"GlyphRenderer"},{"attributes":{},"id":"32022","type":"ResetTool"},{"attributes":{},"id":"32004","type":"DataRange1d"},{"attributes":{},"id":"32060","type":"HelpTool"},{"attributes":{},"id":"32088","type":"UnionRenderers"},{"attributes":{},"id":"32059","type":"ResetTool"},{"attributes":{"axis":{"id":"32014"},"dimension":1,"ticker":null},"id":"32017","type":"Grid"},{"attributes":{"overlay":{"id":"32061"}},"id":"32057","type":"BoxZoomTool"}],"root_ids":["32075"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"34841cf4-1075-441e-9d37-9c8933cec048","root_ids":["32075"],"roots":{"32075":"6fa84ab5-fda0-4efc-9998-168671b3a454"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();