(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("b6094914-1740-4748-a7fa-dc58081a05c2");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'b6094914-1740-4748-a7fa-dc58081a05c2' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"75f5cdc0-07c0-4d96-af53-2739339db872":{"roots":{"references":[{"attributes":{},"id":"31947","type":"HelpTool"},{"attributes":{"source":{"id":"31956"}},"id":"31960","type":"CDSView"},{"attributes":{"below":[{"id":"31934"}],"center":[{"id":"31937"},{"id":"31941"}],"left":[{"id":"31938"}],"renderers":[{"id":"31959"}],"title":{"id":"31965"},"toolbar":{"id":"31949"},"x_range":{"id":"31926"},"x_scale":{"id":"31930"},"y_range":{"id":"31928"},"y_scale":{"id":"31932"}},"id":"31925","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"31935","type":"BasicTicker"},{"attributes":{"children":[{"id":"31963"},{"id":"31925"}]},"id":"31964","type":"Row"},{"attributes":{"formatter":{"id":"31968"},"ticker":{"id":"31935"}},"id":"31934","type":"LinearAxis"},{"attributes":{"children":[{"id":"31961"}],"width":100},"id":"31963","type":"Column"},{"attributes":{},"id":"31971","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"31958","type":"Scatter"},{"attributes":{"formatter":{"id":"31970"},"ticker":{"id":"31939"}},"id":"31938","type":"LinearAxis"},{"attributes":{"data_source":{"id":"31956"},"glyph":{"id":"31957"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"31958"},"selection_glyph":null,"view":{"id":"31960"}},"id":"31959","type":"GlyphRenderer"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"31942"},{"id":"31943"},{"id":"31944"},{"id":"31945"},{"id":"31946"},{"id":"31947"}]},"id":"31949","type":"Toolbar"},{"attributes":{"args":{"other":{"id":"31957"}},"code":"other.size = this.value"},"id":"31962","type":"CustomJS"},{"attributes":{},"id":"31968","type":"BasicTickFormatter"},{"attributes":{},"id":"31945","type":"SaveTool"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"31948","type":"BoxAnnotation"},{"attributes":{},"id":"31939","type":"BasicTicker"},{"attributes":{},"id":"31926","type":"Range1d"},{"attributes":{"fill_color":{"value":"#1f77b4"},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"31957","type":"Scatter"},{"attributes":{"axis":{"id":"31934"},"ticker":null},"id":"31937","type":"Grid"},{"attributes":{},"id":"31943","type":"WheelZoomTool"},{"attributes":{},"id":"31946","type":"ResetTool"},{"attributes":{},"id":"31970","type":"BasicTickFormatter"},{"attributes":{"data":{"x":{"__ndarray__":"PDFazWBh3T8KVZc6VtXQPwVvcdfaqOY/IcPFmjpv5z+AO4f6Dpm1P2pu2AOJqeg/vhyI2VY82j+N1qsE8/zjP8hsVBx/zO0/2kO4NKV35z8=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"yxuNzmqR5T/crMECvbHiP4QS3J356dY/KPibO+881j88LpVmZrDaP5gzRxugub0/nDeo7CbH4z9Y9IMg3S7cPyGucA3vgeg/eA13nYhE4j8=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"31972"},"selection_policy":{"id":"31971"}},"id":"31956","type":"ColumnDataSource"},{"attributes":{},"id":"31972","type":"Selection"},{"attributes":{"format":null,"high":40,"js_property_callbacks":{"change:value":[{"id":"31962"}]},"low":1,"step":0.5,"title":"Glyph size","value":4,"width":80},"id":"31961","type":"Spinner"},{"attributes":{},"id":"31930","type":"LinearScale"},{"attributes":{},"id":"31942","type":"PanTool"},{"attributes":{"axis":{"id":"31938"},"dimension":1,"ticker":null},"id":"31941","type":"Grid"},{"attributes":{"text":""},"id":"31965","type":"Title"},{"attributes":{},"id":"31928","type":"Range1d"},{"attributes":{},"id":"31932","type":"LinearScale"},{"attributes":{"overlay":{"id":"31948"}},"id":"31944","type":"BoxZoomTool"}],"root_ids":["31964"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"75f5cdc0-07c0-4d96-af53-2739339db872","root_ids":["31964"],"roots":{"31964":"b6094914-1740-4748-a7fa-dc58081a05c2"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();