(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("2c9b4251-760c-4e61-8291-bfad09bd24b4");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid '2c9b4251-760c-4e61-8291-bfad09bd24b4' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js": "RKgz0eWtZspMCZVIoEmokuJdx2EgoJcQC/+ua/vPpiyP340jLDd2bVT5xSpdR1iN"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-api-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"19a43126-bb11-4545-8d01-53e8f48ae4d8":{"roots":{"references":[{"attributes":{"source":{"id":"30610"}},"id":"30637","type":"CDSView"},{"attributes":{},"id":"30615","type":"Range1d"},{"attributes":{},"id":"30640","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"30642"},"ticker":{"id":"30628"}},"id":"30627","type":"LinearAxis"},{"attributes":{},"id":"30644","type":"Selection"},{"attributes":{"data_source":{"id":"30610"},"glyph":{"id":"30635"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"30635"},"selection_glyph":{"id":"30635"},"view":{"id":"30637"}},"id":"30636","type":"GlyphRenderer"},{"attributes":{"args":{"source":{"id":"30610"}},"code":"\\n    const geometry = cb_obj[&#x27;geometry&#x27;]\\n    const data = source.data\\n\\n    // calculate Rect attributes\\n    const width = geometry[&#x27;x1&#x27;] - geometry[&#x27;x0&#x27;]\\n    const height = geometry[&#x27;y1&#x27;] - geometry[&#x27;y0&#x27;]\\n    const x = geometry[&#x27;x0&#x27;] + width/2\\n    const y = geometry[&#x27;y0&#x27;] + height/2\\n\\n    // update data source with new Rect attributes\\n    data[&#x27;x&#x27;].push(x)\\n    data[&#x27;y&#x27;].push(y)\\n    data[&#x27;width&#x27;].push(width);\\n    data[&#x27;height&#x27;].push(height)\\n\\n    // emit update of data source\\n    source.change.emit()\\n"},"id":"30611","type":"CustomJS"},{"attributes":{},"id":"30621","type":"LinearScale"},{"attributes":{},"id":"30643","type":"UnionRenderers"},{"attributes":{"text":"Select Below"},"id":"30613","type":"Title"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"30631"}]},"id":"30633","type":"Toolbar"},{"attributes":{"data":{"height":[],"width":[],"x":[],"y":[]},"selected":{"id":"30644"},"selection_policy":{"id":"30643"}},"id":"30610","type":"ColumnDataSource"},{"attributes":{},"id":"30628","type":"BasicTicker"},{"attributes":{},"id":"30642","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.3},"fill_color":{"value":"#009933"},"height":{"field":"height","units":"data"},"width":{"field":"width","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"30635","type":"Rect"},{"attributes":{"axis":{"id":"30623"},"ticker":null},"id":"30626","type":"Grid"},{"attributes":{"overlay":{"id":"30632"}},"id":"30631","type":"BoxSelectTool"},{"attributes":{},"id":"30617","type":"Range1d"},{"attributes":{"below":[{"id":"30623"}],"center":[{"id":"30626"},{"id":"30630"}],"js_event_callbacks":{"selectiongeometry":[{"id":"30611"}]},"left":[{"id":"30627"}],"plot_height":400,"plot_width":400,"renderers":[{"id":"30636"}],"title":{"id":"30613"},"toolbar":{"id":"30633"},"x_range":{"id":"30615"},"x_scale":{"id":"30619"},"y_range":{"id":"30617"},"y_scale":{"id":"30621"}},"id":"30612","subtype":"Figure","type":"Plot"},{"attributes":{"axis":{"id":"30627"},"dimension":1,"ticker":null},"id":"30630","type":"Grid"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"30632","type":"BoxAnnotation"},{"attributes":{},"id":"30619","type":"LinearScale"},{"attributes":{"formatter":{"id":"30640"},"ticker":{"id":"30624"}},"id":"30623","type":"LinearAxis"},{"attributes":{},"id":"30624","type":"BasicTicker"}],"root_ids":["30612"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"19a43126-bb11-4545-8d01-53e8f48ae4d8","root_ids":["30612"],"roots":{"30612":"2c9b4251-760c-4e61-8291-bfad09bd24b4"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();