(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof root._bokeh_onload_callbacks === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      var element = document.getElementById("f8d1adb8-205f-4e1b-ad75-75e3fe84db72");
        if (element == null) {
          console.warn("Bokeh: autoload.js configured with elementid 'f8d1adb8-205f-4e1b-ad75-75e3fe84db72' but no matching script tag was found.")
        }
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) {
            if (callback != null)
              callback();
          });
        } finally {
          delete root._bokeh_onload_callbacks
        }
        console.debug("Bokeh: all callbacks have finished");
      }
    
      function load_libs(css_urls, js_urls, callback) {
        if (css_urls == null) css_urls = [];
        if (js_urls == null) js_urls = [];
    
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.debug("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.debug("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = css_urls.length + js_urls.length;
    
        function on_load() {
          root._bokeh_is_loading--;
          if (root._bokeh_is_loading === 0) {
            console.debug("Bokeh: all BokehJS libraries/stylesheets loaded");
            run_callbacks()
          }
        }
    
        function on_error() {
          console.error("failed to load " + url);
        }
    
        for (var i = 0; i < css_urls.length; i++) {
          var url = css_urls[i];
          const element = document.createElement("link");
          element.onload = on_load;
          element.onerror = on_error;
          element.rel = "stylesheet";
          element.type = "text/css";
          element.href = url;
          console.debug("Bokeh: injecting link tag for BokehJS stylesheet: ", url);
          document.body.appendChild(element);
        }
    
        const hashes = {"https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js": "qkRvDQVAIfzsJo40iRBbxt6sttt0hv4lh74DG7OK4MCHv4C5oohXYoHUM5W11uqS", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js": "Sb7Mr06a9TNlet/GEBeKaf5xH3eb6AlCzwjtU82wNPyDrnfoiVl26qnvlKjmcAd+", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js": "HaJ15vgfmcfRtB4c4YBOI4f1MUujukqInOWVqZJZZGK7Q+ivud0OKGSTn/Vm2iso"};
    
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var element = document.createElement('script');
          element.onload = on_load;
          element.onerror = on_error;
          element.async = false;
          element.src = url;
          if (url in hashes) {
            element.crossOrigin = "anonymous";
            element.integrity = "sha384-" + hashes[url];
          }
          console.debug("Bokeh: injecting script tag for BokehJS library: ", url);
          document.head.appendChild(element);
        }
      };
    
      function inject_raw_css(css) {
        const element = document.createElement("style");
        element.appendChild(document.createTextNode(css));
        document.body.appendChild(element);
      }
    
      
      var js_urls = ["https://cdn.bokeh.org/bokeh/release/bokeh-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-widgets-2.2.1.min.js", "https://cdn.bokeh.org/bokeh/release/bokeh-tables-2.2.1.min.js"];
      var css_urls = [];
      
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"2587aa9e-c433-400a-aad3-c963a96d84f0":{"roots":{"references":[{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"x"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6352","type":"Scatter"},{"attributes":{"source":{"id":"6191"}},"id":"6195","type":"CDSView"},{"attributes":{"source":{"id":"6346"}},"id":"6350","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"circle_y"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6162","type":"Scatter"},{"attributes":{"data":{"x":{"__ndarray__":"JmSLy5TTA0BN7/lF2ukDQOb0er6iuQBAKwMy/4VuAUBLuXjrIVYCQIyosDyqxAVAGRkk3LoLBUAKG9BideQAQJKrlV9JxgJAPaCFw40kAEA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"PP0WNtlmFUBA/f6w1vkWQNbR1tWTVhRAmmwC9jjsF0D80fJJEfYVQHks25/DlRdA2Kpov9/PF0CwWpjtpZQWQLLqpS6/LhZA5OXW/VU9FkA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6381"},"selection_policy":{"id":"6380"}},"id":"6121","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6151"},"glyph":{"id":"6152"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6153"},"selection_glyph":null,"view":{"id":"6155"}},"id":"6154","type":"GlyphRenderer"},{"attributes":{"data":{"x":{"__ndarray__":"AGSWmoZ8A0CmzZTAdVsFQMnzU0pcwwVATMKTvqa0B0BZRCvTQoYFQCKiRMgugARAXiyQxD0QB0CnxULFIhQBQOw4635r/QBAMnCXbD7lB0A=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"/3PQpdOeI0DymZpdyeojQGpfPpcgVSNAxQzQOxK4I0D3woqff/ciQGVUiY/Y5SNA/KdjQD+pI0D5inUEAJMjQJXZubYNpSJAd5n7bFJJIkA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6397"},"selection_policy":{"id":"6396"}},"id":"6161","type":"ColumnDataSource"},{"attributes":{"data":{"x":{"__ndarray__":"yf+G/TKCBEBQe9tQT6MDQFqeW4opPARAeDSbRpHKB0B9Nb9rlhgFQJh72UA97wdAOT9tgI5KB0AJxZSBvWkFQL7JW0W8NwZAAR48Y7x7BkA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"l2tfFa63KkBjJZKC0GIqQGzsBGVzCypAc4XT9i8lK0D0ZqY6wrQqQOYxv1R4oitAbg8YFlLOKkAzu0aZyuMqQF92i05gYStAukrNPs00KkA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6413"},"selection_policy":{"id":"6412"}},"id":"6201","type":"ColumnDataSource"},{"attributes":{"source":{"id":"6121"}},"id":"6125","type":"CDSView"},{"attributes":{"source":{"id":"6161"}},"id":"6165","type":"CDSView"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":15.5}},"id":"6197","type":"Text"},{"attributes":{"data_source":{"id":"6121"},"glyph":{"id":"6122"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6123"},"selection_glyph":null,"view":{"id":"6125"}},"id":"6124","type":"GlyphRenderer"},{"attributes":{"data":{"x":{"__ndarray__":"kFzWFaQY1j8XH5YNX2foP8HCS6ODa+E/6Om/0caE6T9oqk5AlBnEP5//70lhgO4/1z0arMDU5D/I8mPKT1LbPwB8zjzy1O0/ENxyW4Xxvj8=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"Z07X+zThPUAth9zLa+A9QLxKhKgq6D1A/6dkXwBzPUDPYYXoKCQ9QH0NeKnshz1AN50T2lkvPUAfdENPSkI9QE3HMPR2ij1ALMptxG8XPUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6473"},"selection_policy":{"id":"6472"}},"id":"6351","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6191"},"glyph":{"id":"6192"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6193"},"selection_glyph":null,"view":{"id":"6195"}},"id":"6194","type":"GlyphRenderer"},{"attributes":{"data":{"x":{"__ndarray__":"FXp3N8iKE0A0oqXxT8wRQOmo+jAS3RFAMyYR0L4GEEDeE6UX2TsTQFjpSeDxBRFAmySSh6TRE0A5Sp/TUMcRQCqHA1gbXhBAR0/WmlUoEkA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"NR2hz+6HIkCOPcaC/WkjQNY5KER45yJAxSEa7h+YIkChAGm7cMciQGeIT8A1iCNAfhsM9vEAIkAJf3WLk6YjQOENPwLVtyNAEVDzktdtI0A=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6401"},"selection_policy":{"id":"6400"}},"id":"6171","type":"ColumnDataSource"},{"attributes":{"source":{"id":"6351"}},"id":"6355","type":"CDSView"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":11.5}},"id":"6167","type":"Text"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"diamond"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6193","type":"Scatter"},{"attributes":{"data":{"x":{"__ndarray__":"zBaspWJWE0D6fiDrmAUTQPNAhF4IrxNAEUmLh6ZHEkAzeVGHc/QQQHvkEyttShNAK/9uOJvaEkCv7d2Ht1IRQKG2YSDIYxJAJjS2w/D7EEA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"5QLsOfBvFkBiNs+n8qAWQPRt364kYxdAH0JrMRz7F0D0yHDf+1QUQIr2QTUEUxdA8A2TJ/J8F0DN0kEH6EYXQARHwQPocxZAhCnVh/0YFEA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6385"},"selection_policy":{"id":"6384"}},"id":"6131","type":"ColumnDataSource"},{"attributes":{"data":{"x":{"__ndarray__":"GZrFufWmAEDOSbPtB1wHQDMEPGxjXQdAIq5ua6UzAkDK4w6nLfYAQHMQHAvpjANACxqRehG9B0Dj5YDD38UHQOOkDIQAJQNAvaJsZTFhB0A=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"9TNXQJdzPUCrSbATUjY9QHITm1riWz1AtL1rT758PUA0rqzerCc9QKz0WNVkMD1Aa91tz2hlPUAnFH2gDSk9QDQ19LbO/z1AOlnxkG0+PUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6477"},"selection_policy":{"id":"6476"}},"id":"6361","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6161"},"glyph":{"id":"6162"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6163"},"selection_glyph":null,"view":{"id":"6165"}},"id":"6164","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":7.5}},"id":"6127","type":"Text"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":31.5}},"id":"6357","type":"Text"},{"attributes":{"data":{"text":["diamond"]},"selected":{"id":"6411"},"selection_policy":{"id":"6410"}},"id":"6196","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6123","type":"Scatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"circle_y"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6163","type":"Scatter"},{"attributes":{"data_source":{"id":"6351"},"glyph":{"id":"6352"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6353"},"selection_glyph":null,"view":{"id":"6355"}},"id":"6354","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6196"}},"id":"6200","type":"CDSView"},{"attributes":{"data":{"text":["circle"]},"selected":{"id":"6383"},"selection_policy":{"id":"6382"}},"id":"6126","type":"ColumnDataSource"},{"attributes":{"data":{"text":["circle_y"]},"selected":{"id":"6399"},"selection_policy":{"id":"6398"}},"id":"6166","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"diamond_cross"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6202","type":"Scatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"x"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6353","type":"Scatter"},{"attributes":{"source":{"id":"6126"}},"id":"6130","type":"CDSView"},{"attributes":{"source":{"id":"6166"}},"id":"6170","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"circle_cross"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6132","type":"Scatter"},{"attributes":{"data":{"text":["x"]},"selected":{"id":"6475"},"selection_policy":{"id":"6474"}},"id":"6356","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6196"},"glyph":{"id":"6197"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6198"},"selection_glyph":null,"view":{"id":"6200"}},"id":"6199","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6151"}},"id":"6155","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"cross"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6172","type":"Scatter"},{"attributes":{"source":{"id":"6356"}},"id":"6360","type":"CDSView"},{"attributes":{},"id":"6449","type":"Selection"},{"attributes":{"data_source":{"id":"6126"},"glyph":{"id":"6127"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6128"},"selection_glyph":null,"view":{"id":"6130"}},"id":"6129","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"y"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6362","type":"Scatter"},{"attributes":{"data_source":{"id":"6166"},"glyph":{"id":"6167"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6168"},"selection_glyph":null,"view":{"id":"6170"}},"id":"6169","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":15.5}},"id":"6198","type":"Text"},{"attributes":{},"id":"6410","type":"UnionRenderers"},{"attributes":{},"id":"6101","type":"ResetTool"},{"attributes":{"source":{"id":"6201"}},"id":"6205","type":"CDSView"},{"attributes":{},"id":"6446","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"6356"},"glyph":{"id":"6357"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6358"},"selection_glyph":null,"view":{"id":"6360"}},"id":"6359","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":7.5}},"id":"6128","type":"Text"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":11.5}},"id":"6168","type":"Text"},{"attributes":{},"id":"6102","type":"HelpTool"},{"attributes":{"data":{"x":{"__ndarray__":"lSPYf9ExEkDmGmdwGrMQQAq114fqYRJAGZpCEO3sEkCxoy58DPcRQARAskeldhNAL/lJSYMdEUBY9SpuebESQKsZHVb+HBJAZLR+BRsyEkA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"9Wl5ddrWK0DTlMFUeigrQD7NtQej1CtAD6SJN5klKkAp3U9zRbUqQFquX/bLtCtAoeMj74HuK0ClM6CQjCErQALO1FsM4SpA9L7PkeOaK0A=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6417"},"selection_policy":{"id":"6416"}},"id":"6211","type":"ColumnDataSource"},{"attributes":{},"id":"6411","type":"Selection"},{"attributes":{"source":{"id":"6131"}},"id":"6135","type":"CDSView"},{"attributes":{"data_source":{"id":"6111"},"glyph":{"id":"6112"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6113"},"selection_glyph":null,"view":{"id":"6115"}},"id":"6114","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6171"}},"id":"6175","type":"CDSView"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":15.5}},"id":"6207","type":"Text"},{"attributes":{"source":{"id":"6136"}},"id":"6140","type":"CDSView"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":31.5}},"id":"6358","type":"Text"},{"attributes":{"data_source":{"id":"6156"},"glyph":{"id":"6157"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6158"},"selection_glyph":null,"view":{"id":"6160"}},"id":"6159","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"6201"},"glyph":{"id":"6202"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6203"},"selection_glyph":null,"view":{"id":"6205"}},"id":"6204","type":"GlyphRenderer"},{"attributes":{"data":{"x":{"__ndarray__":"/T3IK560GUDgm+tqvW0aQMSDzz74tBpAHAUI0QzaGECMoFix4jAbQLYLeweb9RpARL9nxATmGkA02VZBnEAaQJTXe1pY9hhAokUs1jkcGEA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"otVFfQPrIkAMZYlfUdgiQOUOQPNl8yJAUjfrKlF7IkC0UUPzgb0jQFg9gO+bAiJAUsHrSKVlIkDwMODjSU8iQORUswBIeiNAYeVzoUYXIkA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6405"},"selection_policy":{"id":"6404"}},"id":"6181","type":"ColumnDataSource"},{"attributes":{"source":{"id":"6361"}},"id":"6365","type":"CDSView"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":4.5},"y":{"value":11.5}},"id":"6177","type":"Text"},{"attributes":{},"id":"6412","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"diamond_cross"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6203","type":"Scatter"},{"attributes":{"data_source":{"id":"6131"},"glyph":{"id":"6132"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6133"},"selection_glyph":null,"view":{"id":"6135"}},"id":"6134","type":"GlyphRenderer"},{"attributes":{"axis":{"id":"6093"},"dimension":1,"grid_line_color":null,"ticker":null},"id":"6096","type":"Grid"},{"attributes":{"data_source":{"id":"6171"},"glyph":{"id":"6172"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6173"},"selection_glyph":null,"view":{"id":"6175"}},"id":"6174","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":31.5}},"id":"6367","type":"Text"},{"attributes":{"data":{"text":["diamond_cross"]},"selected":{"id":"6415"},"selection_policy":{"id":"6414"}},"id":"6206","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"circle_cross"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6133","type":"Scatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"cross"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6173","type":"Scatter"},{"attributes":{"data_source":{"id":"6361"},"glyph":{"id":"6362"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6363"},"selection_glyph":null,"view":{"id":"6365"}},"id":"6364","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":4.5},"y":{"value":7.5}},"id":"6137","type":"Text"},{"attributes":{"source":{"id":"6206"}},"id":"6210","type":"CDSView"},{"attributes":{},"id":"6094","type":"BasicTicker"},{"attributes":{},"id":"6447","type":"Selection"},{"attributes":{"data":{"text":["circle_cross"]},"selected":{"id":"6387"},"selection_policy":{"id":"6386"}},"id":"6136","type":"ColumnDataSource"},{"attributes":{"data":{"text":["cross"]},"selected":{"id":"6403"},"selection_policy":{"id":"6402"}},"id":"6176","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"diamond_dot"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6212","type":"Scatter"},{"attributes":{},"id":"6413","type":"Selection"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"y"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6363","type":"Scatter"},{"attributes":{"source":{"id":"6176"}},"id":"6180","type":"CDSView"},{"attributes":{"data":{"text":["y"]},"selected":{"id":"6479"},"selection_policy":{"id":"6478"}},"id":"6366","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6206"},"glyph":{"id":"6207"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6208"},"selection_glyph":null,"view":{"id":"6210"}},"id":"6209","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"dash"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6182","type":"Scatter"},{"attributes":{},"id":"6100","type":"SaveTool"},{"attributes":{"source":{"id":"6366"}},"id":"6370","type":"CDSView"},{"attributes":{},"id":"6414","type":"UnionRenderers"},{"attributes":{"data":{"x":{"__ndarray__":"c7johzCgGUBtqBY55REYQD3/reIkDhlAWYqB3DaUG0C6061grkIbQHVnOaG/VxtAG8psrp/vGEAF2tJCs94aQDaeR3W+SRhA33ayHZ1EG0A=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"eBALv4jFFUAqaDfnaO8XQEDBVc2S1BRAyycsaobOF0DPidNUiFoWQPVSCCvOxBdAoxYUBbJhFEC27qeQkO8VQOT+fEhhoxRAdnpmuFY2F0A=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6389"},"selection_policy":{"id":"6388"}},"id":"6141","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6176"},"glyph":{"id":"6177"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6178"},"selection_glyph":null,"view":{"id":"6180"}},"id":"6179","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":15.5}},"id":"6208","type":"Text"},{"attributes":{"data_source":{"id":"6136"},"glyph":{"id":"6137"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6138"},"selection_glyph":null,"view":{"id":"6140"}},"id":"6139","type":"GlyphRenderer"},{"attributes":{},"id":"6453","type":"Selection"},{"attributes":{"source":{"id":"6141"}},"id":"6145","type":"CDSView"},{"attributes":{"source":{"id":"6211"}},"id":"6215","type":"CDSView"},{"attributes":{"data_source":{"id":"6366"},"glyph":{"id":"6367"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6368"},"selection_glyph":null,"view":{"id":"6370"}},"id":"6369","type":"GlyphRenderer"},{"attributes":{},"id":"6456","type":"UnionRenderers"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":4.5},"y":{"value":11.5}},"id":"6178","type":"Text"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":4.5},"y":{"value":7.5}},"id":"6138","type":"Text"},{"attributes":{"data":{"x":{"__ndarray__":"1Sx+WzFfGUDNmQ058GkZQEOH1I+LXxtASYjzP7+yG0CFpLBqXSAbQCNEE+Rt9RpAkEYDQbfnGECma8YlrlUYQNDwDNLE0hlAQKWmXzDmGUA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"e5aMhS+dK0CJ7gczKvErQGKTug+7ACpATaKzzrBFK0Ax15VXeicqQDhIDjAuIypAtyA7axR/KkB3WLKnP2gqQPVFePKbICtA+xGehuKRKkA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6421"},"selection_policy":{"id":"6420"}},"id":"6221","type":"ColumnDataSource"},{"attributes":{},"id":"6458","type":"UnionRenderers"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"6097"},{"id":"6098"},{"id":"6099"},{"id":"6100"},{"id":"6101"},{"id":"6102"}]},"id":"6104","type":"Toolbar"},{"attributes":{"source":{"id":"6181"}},"id":"6185","type":"CDSView"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":4.5},"y":{"value":15.5}},"id":"6217","type":"Text"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"circle_dot"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6142","type":"Scatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"asterisk"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6113","type":"Scatter"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":31.5}},"id":"6368","type":"Text"},{"attributes":{},"id":"6450","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"6211"},"glyph":{"id":"6212"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6213"},"selection_glyph":null,"view":{"id":"6215"}},"id":"6214","type":"GlyphRenderer"},{"attributes":{"data":{"x":{"__ndarray__":"QNmrbCDu6D9SZD4NunnePzwyEQfFXuw/ghcbdz1w4D8s4XbOi5fIP3BhU6UdLqo//hirWns63T9+TZL7advlP2t/hIwz5eU/vZVOyb/07j8=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"ZDznbrv2KkASQf+V76MqQL7g94OzgypArBeEwj1RK0AgFUH1ijEqQJPP1uswwCtAVnOvjnuwKkAOmjPgV3kqQMpfwR0ySStA/lGNzvTCK0A=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6409"},"selection_policy":{"id":"6408"}},"id":"6191","type":"ColumnDataSource"},{"attributes":{},"id":"6373","type":"BasicTickFormatter"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":6.5},"y":{"value":11.5}},"id":"6187","type":"Text"},{"attributes":{},"id":"6097","type":"PanTool"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":6.5},"y":{"value":7.5}},"id":"6147","type":"Text"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"diamond_dot"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6213","type":"Scatter"},{"attributes":{},"id":"6375","type":"BasicTickFormatter"},{"attributes":{},"id":"6457","type":"Selection"},{"attributes":{"data_source":{"id":"6181"},"glyph":{"id":"6182"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6183"},"selection_glyph":null,"view":{"id":"6185"}},"id":"6184","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6111"}},"id":"6115","type":"CDSView"},{"attributes":{"data_source":{"id":"6141"},"glyph":{"id":"6142"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6143"},"selection_glyph":null,"view":{"id":"6145"}},"id":"6144","type":"GlyphRenderer"},{"attributes":{"data":{"text":["diamond_dot"]},"selected":{"id":"6419"},"selection_policy":{"id":"6418"}},"id":"6216","type":"ColumnDataSource"},{"attributes":{},"id":"6098","type":"WheelZoomTool"},{"attributes":{},"id":"6376","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"dash"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6183","type":"Scatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"circle_dot"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6143","type":"Scatter"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"circle_x"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6152","type":"Scatter"},{"attributes":{"source":{"id":"6216"}},"id":"6220","type":"CDSView"},{"attributes":{"data":{"text":["circle_x"]},"selected":{"id":"6395"},"selection_policy":{"id":"6394"}},"id":"6156","type":"ColumnDataSource"},{"attributes":{},"id":"6377","type":"Selection"},{"attributes":{"data":{"text":["dash"]},"selected":{"id":"6407"},"selection_policy":{"id":"6406"}},"id":"6186","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"dot"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6222","type":"Scatter"},{"attributes":{"overlay":{"id":"6103"}},"id":"6099","type":"BoxZoomTool"},{"attributes":{},"id":"6454","type":"UnionRenderers"},{"attributes":{"data":{"text":["circle_dot"]},"selected":{"id":"6391"},"selection_policy":{"id":"6390"}},"id":"6146","type":"ColumnDataSource"},{"attributes":{},"id":"6378","type":"UnionRenderers"},{"attributes":{"source":{"id":"6186"}},"id":"6190","type":"CDSView"},{"attributes":{},"id":"6409","type":"Selection"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":11.5}},"id":"6157","type":"Text"},{"attributes":{"data_source":{"id":"6216"},"glyph":{"id":"6217"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6218"},"selection_glyph":null,"view":{"id":"6220"}},"id":"6219","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":11.5}},"id":"6158","type":"Text"},{"attributes":{},"id":"6379","type":"Selection"},{"attributes":{},"id":"6408","type":"UnionRenderers"},{"attributes":{"source":{"id":"6156"}},"id":"6160","type":"CDSView"},{"attributes":{},"id":"6380","type":"UnionRenderers"},{"attributes":{"data":{"x":{"__ndarray__":"myxEHqrg4D/ww7Cvx7+nPwQgiE/efM8/7hMVackz6j9Y0s8INlTrP3Df5dhDC60/BBs46RXZ4D/ZBW67zqLmP0wxRlAmcus/BSILA1Wd6j8=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"i35MJwktF0A5wdEeFUgVQM2t+MtlCRVAKB/+uuipFkDx3tuFR6UWQBqgvsJWRxVA8p2vkph4FUDhuReukzEVQMJc1x7vQxZA/RYTNTThF0A=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6377"},"selection_policy":{"id":"6376"}},"id":"6111","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":4.5},"y":{"value":15.5}},"id":"6218","type":"Text"},{"attributes":{},"id":"6452","type":"UnionRenderers"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":6.5},"y":{"value":11.5}},"id":"6188","type":"Text"},{"attributes":{},"id":"6381","type":"Selection"},{"attributes":{},"id":"6451","type":"Selection"},{"attributes":{"data_source":{"id":"6186"},"glyph":{"id":"6187"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6188"},"selection_glyph":null,"view":{"id":"6190"}},"id":"6189","type":"GlyphRenderer"},{"attributes":{"data":{"x":{"__ndarray__":"BiWSy3T75z/oeg1gp4zuPzhqSLS+PcA/vJbbsdIq6T+Im2TQ8PC9P9BlldZdm9Y/fkvWyTLb1T9j7AXBbQLrP0pzWaeJZuA/cgxXhaBn1j8=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"uaZHcNMpIkAWlSgtwGQiQOYlF6IexCNAByBaRGWZIkDg+7xcXHgjQFTN93pzPSJA7K3991f/I0BYdmAUvl0jQIlbyISAliNAmnXiI/8MI0A=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6393"},"selection_policy":{"id":"6392"}},"id":"6151","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"diamond"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6192","type":"Scatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"dot"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6223","type":"Scatter"},{"attributes":{},"id":"6382","type":"UnionRenderers"},{"attributes":{},"id":"6455","type":"Selection"},{"attributes":{"source":{"id":"6221"}},"id":"6225","type":"CDSView"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":6.5},"y":{"value":7.5}},"id":"6148","type":"Text"},{"attributes":{"source":{"id":"6286"}},"id":"6290","type":"CDSView"},{"attributes":{"data":{"x":{"__ndarray__":"Fl1MQKfA7z+jbGvoiP7vP0ZOaWPoidI/gIm+GrBCnD/AnzYi5r/WPwpkyuAr4tI//GMCvNlqzj8NCKFAkQHsP4VJj4fDxOg/ltrZWHsx7z8=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"2BbyBwRsMUDS5+khpxgxQPdp5V5NnjFA9tzPPNmMMUC8XGFfI+MxQG+3At0hLDFA3XCXsYHsMUA/i+H3+5gxQLC/u+AwXDFAK8E729/0MUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6425"},"selection_policy":{"id":"6424"}},"id":"6231","type":"ColumnDataSource"},{"attributes":{"data":{"x":{"__ndarray__":"Gvv6IHMyEUD5Pv3r878RQOfoaZ9vixJACMbtMqf0EkAc+50LD4sTQAyFroyw+hNAPj4kK01KEECTZeLmMJESQDPrIzSpwBBAFEf8FHWuEkA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"LiZpxl+7NUBqmBRPhBE1QCOeI5ZpljVALq5E1mYlNUA6FtMq06U1QM2nOK4h0jVAbAoX4TwBNUCnBQ55US01QOrxvvFrqTVADZ0Rf0gxNUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6449"},"selection_policy":{"id":"6448"}},"id":"6291","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6221"},"glyph":{"id":"6222"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6223"},"selection_glyph":null,"view":{"id":"6225"}},"id":"6224","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":7.5}},"id":"6117","type":"Text"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":6.5},"y":{"value":15.5}},"id":"6227","type":"Text"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"square_dot"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6292","type":"Scatter"},{"attributes":{},"id":"6428","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"6286"},"glyph":{"id":"6287"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6288"},"selection_glyph":null,"view":{"id":"6290"}},"id":"6289","type":"GlyphRenderer"},{"attributes":{"data":{"text":["dot"]},"selected":{"id":"6423"},"selection_policy":{"id":"6422"}},"id":"6226","type":"ColumnDataSource"},{"attributes":{},"id":"6421","type":"Selection"},{"attributes":{"source":{"id":"6226"}},"id":"6230","type":"CDSView"},{"attributes":{"data":{"text":["asterisk"]},"selected":{"id":"6379"},"selection_policy":{"id":"6378"}},"id":"6116","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"hex"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6232","type":"Scatter"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":23.5}},"id":"6288","type":"Text"},{"attributes":{"source":{"id":"6291"}},"id":"6295","type":"CDSView"},{"attributes":{"data_source":{"id":"6226"},"glyph":{"id":"6227"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6228"},"selection_glyph":null,"view":{"id":"6230"}},"id":"6229","type":"GlyphRenderer"},{"attributes":{"data":{"x":{"__ndarray__":"caQGl2HHGUAJ8oKaSV0bQDVfuQDAGhlAUij9PreBGUCHpIKg81IYQHtygCFUChhAcu9/tjPCGEC+//nckdEbQCPnanSlARpAC6CDfp0XGEA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"2PqfrTpaNUCetsC15Vc1QIMqilmBJDVA+nWFC5o+NUD/EpNgEOs1QGyE5UN/6zVAJ3dL2KQcNUCLoKxh6SY1QGO/DrHLbzVAVhhYQ87FNUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6453"},"selection_policy":{"id":"6452"}},"id":"6301","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":4.5},"y":{"value":23.5}},"id":"6297","type":"Text"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":6.5},"y":{"value":15.5}},"id":"6228","type":"Text"},{"attributes":{"data_source":{"id":"6291"},"glyph":{"id":"6292"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6293"},"selection_glyph":null,"view":{"id":"6295"}},"id":"6294","type":"GlyphRenderer"},{"attributes":{},"id":"6427","type":"Selection"},{"attributes":{"source":{"id":"6231"}},"id":"6235","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"square_dot"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6293","type":"Scatter"},{"attributes":{"data":{"x":{"__ndarray__":"4Dh5xEHJAUDWyxRfH8wCQIP0iBylLAFAVPKiKalOAEA4KjTBlEkGQBTz35/z0QJA+If+O5i8BEDOMY7ZTg4HQK9JacFKrQZAzDuP2i4oBkA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"8nGI3PXsMUD4zIkQdoQxQNPIBepdEDFANGJV2UWlMUBO/3JSsIAxQHsn1kBb7DFAu+bf+73pMUC70AwKJ/AxQCdsxLhUxDFAz3afnDb7MUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6429"},"selection_policy":{"id":"6428"}},"id":"6241","type":"ColumnDataSource"},{"attributes":{},"id":"6426","type":"UnionRenderers"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":19.5}},"id":"6237","type":"Text"},{"attributes":{"data":{"text":["square_dot"]},"selected":{"id":"6451"},"selection_policy":{"id":"6450"}},"id":"6296","type":"ColumnDataSource"},{"attributes":{},"id":"6434","type":"UnionRenderers"},{"attributes":{},"id":"6425","type":"Selection"},{"attributes":{},"id":"6440","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"6231"},"glyph":{"id":"6232"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6233"},"selection_glyph":null,"view":{"id":"6235"}},"id":"6234","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6296"}},"id":"6300","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"square_pin"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6302","type":"Scatter"},{"attributes":{},"id":"6424","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"hex"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6233","type":"Scatter"},{"attributes":{},"id":"6423","type":"Selection"},{"attributes":{"data_source":{"id":"6296"},"glyph":{"id":"6297"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6298"},"selection_glyph":null,"view":{"id":"6300"}},"id":"6299","type":"GlyphRenderer"},{"attributes":{"data":{"text":["hex"]},"selected":{"id":"6427"},"selection_policy":{"id":"6426"}},"id":"6236","type":"ColumnDataSource"},{"attributes":{},"id":"6422","type":"UnionRenderers"},{"attributes":{"source":{"id":"6236"}},"id":"6240","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"hex_dot"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6242","type":"Scatter"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":4.5},"y":{"value":23.5}},"id":"6298","type":"Text"},{"attributes":{"bottom_units":"screen","fill_alpha":0.5,"fill_color":"lightgrey","left_units":"screen","level":"overlay","line_alpha":1.0,"line_color":"black","line_dash":[4,4],"line_width":2,"right_units":"screen","top_units":"screen"},"id":"6103","type":"BoxAnnotation"},{"attributes":{"data_source":{"id":"6116"},"glyph":{"id":"6117"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6118"},"selection_glyph":null,"view":{"id":"6120"}},"id":"6119","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6301"}},"id":"6305","type":"CDSView"},{"attributes":{"data_source":{"id":"6236"},"glyph":{"id":"6237"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6238"},"selection_glyph":null,"view":{"id":"6240"}},"id":"6239","type":"GlyphRenderer"},{"attributes":{},"id":"6439","type":"Selection"},{"attributes":{"data":{"x":{"__ndarray__":"s+/Kl2ux4D8c/m2uGoXOP0BOZTMaGr0/WAZbpwTEyD/oEoAS+jXRP6r+U9Id+dU/ZBTcGGM6yD/YDoZlQ8XdP3l26JSDZuE/HCdguepJ4D8=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"OSDfuqqSOUAFmR6Fbu85QAVljQdXojlACgrw9g/dOUDHeZdl9qA5QDQrlzsmlDlAXfprlLr5OUDXGE1bm0Q5QA3hUOHCLzlA4XCSPUq0OUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6457"},"selection_policy":{"id":"6456"}},"id":"6311","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":6.5},"y":{"value":23.5}},"id":"6307","type":"Text"},{"attributes":{},"id":"6438","type":"UnionRenderers"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":19.5}},"id":"6238","type":"Text"},{"attributes":{},"id":"6460","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"6301"},"glyph":{"id":"6302"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6303"},"selection_glyph":null,"view":{"id":"6305"}},"id":"6304","type":"GlyphRenderer"},{"attributes":{},"id":"6437","type":"Selection"},{"attributes":{},"id":"6459","type":"Selection"},{"attributes":{"source":{"id":"6241"}},"id":"6245","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"square_pin"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6303","type":"Scatter"},{"attributes":{"source":{"id":"6116"}},"id":"6120","type":"CDSView"},{"attributes":{},"id":"6436","type":"UnionRenderers"},{"attributes":{"data":{"x":{"__ndarray__":"bw7WDWeCEkDMri/ouJQTQK7bV9l2kBNAaJdzoIsaEEDSMHevn7kSQIgJrQjZ1xNA06H/3cuYE0D9MVc1SbgTQBvFmc8hQhNA+q3gymq2EUA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"rq+ophUqMUACufpSvhsxQFUcaJmpPjFAD68VdgkpMUByFbnMZ6AxQLCFu3DCQjFA0/IL2YhlMUBu3Rgixu0xQDnaBYCNvjFA9p85QUMwMUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6433"},"selection_policy":{"id":"6432"}},"id":"6251","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":19.5}},"id":"6247","type":"Text"},{"attributes":{"data":{"text":["square_pin"]},"selected":{"id":"6455"},"selection_policy":{"id":"6454"}},"id":"6306","type":"ColumnDataSource"},{"attributes":{},"id":"6081","type":"DataRange1d"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6122","type":"Scatter"},{"attributes":{},"id":"6435","type":"Selection"},{"attributes":{"data_source":{"id":"6241"},"glyph":{"id":"6242"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6243"},"selection_glyph":null,"view":{"id":"6245"}},"id":"6244","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6306"}},"id":"6310","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"square_x"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6312","type":"Scatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"hex_dot"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6243","type":"Scatter"},{"attributes":{"data_source":{"id":"6306"},"glyph":{"id":"6307"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6308"},"selection_glyph":null,"view":{"id":"6310"}},"id":"6309","type":"GlyphRenderer"},{"attributes":{"data":{"text":["hex_dot"]},"selected":{"id":"6431"},"selection_policy":{"id":"6430"}},"id":"6246","type":"ColumnDataSource"},{"attributes":{"source":{"id":"6246"}},"id":"6250","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"inverted_triangle"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6252","type":"Scatter"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":6.5},"y":{"value":23.5}},"id":"6308","type":"Text"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":7.5}},"id":"6118","type":"Text"},{"attributes":{"source":{"id":"6311"}},"id":"6315","type":"CDSView"},{"attributes":{"data_source":{"id":"6246"},"glyph":{"id":"6247"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6248"},"selection_glyph":null,"view":{"id":"6250"}},"id":"6249","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6251"}},"id":"6255","type":"CDSView"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":27.5}},"id":"6318","type":"Text"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":27.5}},"id":"6317","type":"Text"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":19.5}},"id":"6248","type":"Text"},{"attributes":{"data_source":{"id":"6311"},"glyph":{"id":"6312"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6313"},"selection_glyph":null,"view":{"id":"6315"}},"id":"6314","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"inverted_triangle"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6253","type":"Scatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"square_x"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6313","type":"Scatter"},{"attributes":{"source":{"id":"6146"}},"id":"6150","type":"CDSView"},{"attributes":{"data_source":{"id":"6251"},"glyph":{"id":"6252"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6253"},"selection_glyph":null,"view":{"id":"6255"}},"id":"6254","type":"GlyphRenderer"},{"attributes":{"data":{"text":["square_x"]},"selected":{"id":"6459"},"selection_policy":{"id":"6458"}},"id":"6316","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6146"},"glyph":{"id":"6147"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6148"},"selection_glyph":null,"view":{"id":"6150"}},"id":"6149","type":"GlyphRenderer"},{"attributes":{},"id":"6467","type":"Selection"},{"attributes":{},"id":"6383","type":"Selection"},{"attributes":{"formatter":{"id":"6375"},"ticker":{"id":"6094"},"visible":false},"id":"6093","type":"LinearAxis"},{"attributes":{},"id":"6090","type":"BasicTicker"},{"attributes":{},"id":"6468","type":"UnionRenderers"},{"attributes":{},"id":"6384","type":"UnionRenderers"},{"attributes":{},"id":"6441","type":"Selection"},{"attributes":{"formatter":{"id":"6373"},"ticker":{"id":"6090"},"visible":false},"id":"6089","type":"LinearAxis"},{"attributes":{},"id":"6469","type":"Selection"},{"attributes":{},"id":"6385","type":"Selection"},{"attributes":{},"id":"6470","type":"UnionRenderers"},{"attributes":{},"id":"6386","type":"UnionRenderers"},{"attributes":{},"id":"6471","type":"Selection"},{"attributes":{},"id":"6387","type":"Selection"},{"attributes":{},"id":"6472","type":"UnionRenderers"},{"attributes":{},"id":"6388","type":"UnionRenderers"},{"attributes":{},"id":"6473","type":"Selection"},{"attributes":{},"id":"6389","type":"Selection"},{"attributes":{},"id":"6474","type":"UnionRenderers"},{"attributes":{},"id":"6390","type":"UnionRenderers"},{"attributes":{},"id":"6475","type":"Selection"},{"attributes":{},"id":"6391","type":"Selection"},{"attributes":{},"id":"6476","type":"UnionRenderers"},{"attributes":{},"id":"6392","type":"UnionRenderers"},{"attributes":{},"id":"6477","type":"Selection"},{"attributes":{},"id":"6393","type":"Selection"},{"attributes":{},"id":"6478","type":"UnionRenderers"},{"attributes":{},"id":"6394","type":"UnionRenderers"},{"attributes":{},"id":"6479","type":"Selection"},{"attributes":{},"id":"6395","type":"Selection"},{"attributes":{},"id":"6396","type":"UnionRenderers"},{"attributes":{},"id":"6397","type":"Selection"},{"attributes":{},"id":"6442","type":"UnionRenderers"},{"attributes":{},"id":"6398","type":"UnionRenderers"},{"attributes":{},"id":"6399","type":"Selection"},{"attributes":{},"id":"6443","type":"Selection"},{"attributes":{},"id":"6400","type":"UnionRenderers"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"circle_x"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6153","type":"Scatter"},{"attributes":{},"id":"6401","type":"Selection"},{"attributes":{},"id":"6402","type":"UnionRenderers"},{"attributes":{},"id":"6403","type":"Selection"},{"attributes":{},"id":"6404","type":"UnionRenderers"},{"attributes":{},"id":"6448","type":"UnionRenderers"},{"attributes":{},"id":"6405","type":"Selection"},{"attributes":{},"id":"6444","type":"UnionRenderers"},{"attributes":{},"id":"6406","type":"UnionRenderers"},{"attributes":{"axis":{"id":"6089"},"grid_line_color":null,"ticker":null},"id":"6092","type":"Grid"},{"attributes":{},"id":"6407","type":"Selection"},{"attributes":{},"id":"6420","type":"UnionRenderers"},{"attributes":{},"id":"6461","type":"Selection"},{"attributes":{},"id":"6419","type":"Selection"},{"attributes":{},"id":"6462","type":"UnionRenderers"},{"attributes":{},"id":"6445","type":"Selection"},{"attributes":{},"id":"6418","type":"UnionRenderers"},{"attributes":{},"id":"6463","type":"Selection"},{"attributes":{},"id":"6417","type":"Selection"},{"attributes":{},"id":"6464","type":"UnionRenderers"},{"attributes":{},"id":"6416","type":"UnionRenderers"},{"attributes":{},"id":"6465","type":"Selection"},{"attributes":{},"id":"6415","type":"Selection"},{"attributes":{},"id":"6466","type":"UnionRenderers"},{"attributes":{},"id":"6087","type":"LinearScale"},{"attributes":{"data":{"x":{"__ndarray__":"gq2Gn3hJGEC0LJhYqVcYQOo+SkbykBpAoxE9XMZUGEBaewUBgWkaQDZ5YXBtERtAhC9K6VHqG0BCoFbdPR4ZQEsUMSVG3BhAYZdG4IsHGUA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"2kIBBihMMUD8BJF0nPsxQIWt9gczDDFAms7tfNL8MUD5OMfsHvUxQGlFTWhKAzFAtuIvbNI9MUD45Ik66LYxQFGJzz3RvDFAWA1rsDUNMUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6437"},"selection_policy":{"id":"6436"}},"id":"6261","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":4.5},"y":{"value":19.5}},"id":"6257","type":"Text"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"triangle"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6322","type":"Scatter"},{"attributes":{"source":{"id":"6316"}},"id":"6320","type":"CDSView"},{"attributes":{"data_source":{"id":"6316"},"glyph":{"id":"6317"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6318"},"selection_glyph":null,"view":{"id":"6320"}},"id":"6319","type":"GlyphRenderer"},{"attributes":{"data":{"text":["inverted_triangle"]},"selected":{"id":"6435"},"selection_policy":{"id":"6434"}},"id":"6256","type":"ColumnDataSource"},{"attributes":{"source":{"id":"6256"}},"id":"6260","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"plus"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6262","type":"Scatter"},{"attributes":{"data":{"x":{"__ndarray__":"u0S1zrJUAUDpAgYKRZ0FQBiLoJre5wBAVjDjQSSgB0D0r0bLbkEGQLVUQlLQVwZA4XXawsTKBECrcgMquG0BQFjD5cVPdAJAR1/8x0kCBEA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"gY0HSN+vOUDy+NoBdNM5QIlEZ9Js8TlAO8Ppza2OOUAuFFo92VE5QNFY/jHa/jlAhYhEOZ/XOUC/ORgq/rc5QAvnMRN1QDlAEmeH+0gmOUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6461"},"selection_policy":{"id":"6460"}},"id":"6321","type":"ColumnDataSource"},{"attributes":{"source":{"id":"6321"}},"id":"6325","type":"CDSView"},{"attributes":{"data_source":{"id":"6256"},"glyph":{"id":"6257"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6258"},"selection_glyph":null,"view":{"id":"6260"}},"id":"6259","type":"GlyphRenderer"},{"attributes":{"data":{"x":{"__ndarray__":"vscfGZ5vE0BPE6DCdcETQINaBvJqFBBAdXN+sotLEECjyAUe+goRQMbc16rhvRNAxcm79ILcEkCAnfyd2kwQQBxqh0HuExJA9mRUxijPE0A=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"3sNQM6QaOUDrp4lebnw5QL7zaC/HWzlADABT3IbWOUBUVAT0HiM5QAGnSxUkxDlAlA8EI3PSOUDZG+Ecg6w5QAaGU/5XKjlAkCtgNCVqOUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6465"},"selection_policy":{"id":"6464"}},"id":"6331","type":"ColumnDataSource"},{"attributes":{"flipped":true},"id":"6083","type":"DataRange1d"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":27.5}},"id":"6327","type":"Text"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":4.5},"y":{"value":19.5}},"id":"6258","type":"Text"},{"attributes":{"data_source":{"id":"6321"},"glyph":{"id":"6322"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6323"},"selection_glyph":null,"view":{"id":"6325"}},"id":"6324","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6261"}},"id":"6265","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"triangle"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6323","type":"Scatter"},{"attributes":{"data":{"x":{"__ndarray__":"pJUYqwaQwD96TnDg4mTUP8i+alXWv9s/ESnO0/mt7z/uf7heEiPpPzcnkYLUB+g/MBUeUKpjuT/UzbP56e7EP+hFICGtpNw/h87tCHU27T8=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"ye484U9UNUAftSO6ZjM1QNiaXDO+XDVAMJGOq2NlNUCKWHjpfVA1QK4EZYVQxDVAYbHTMSuYNUAYII0O4w81QLZs3TKrMDVAZj1+inr1NUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6441"},"selection_policy":{"id":"6440"}},"id":"6271","type":"ColumnDataSource"},{"attributes":{},"id":"6433","type":"Selection"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":6.5},"y":{"value":19.5}},"id":"6267","type":"Text"},{"attributes":{"data":{"text":["triangle"]},"selected":{"id":"6463"},"selection_policy":{"id":"6462"}},"id":"6326","type":"ColumnDataSource"},{"attributes":{},"id":"6432","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"6261"},"glyph":{"id":"6262"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6263"},"selection_glyph":null,"view":{"id":"6265"}},"id":"6264","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6326"}},"id":"6330","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"triangle_dot"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6332","type":"Scatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"plus"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6263","type":"Scatter"},{"attributes":{"data":{"text":["plus"]},"selected":{"id":"6439"},"selection_policy":{"id":"6438"}},"id":"6266","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6326"},"glyph":{"id":"6327"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6328"},"selection_glyph":null,"view":{"id":"6330"}},"id":"6329","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6266"}},"id":"6270","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"square"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6272","type":"Scatter"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":27.5}},"id":"6328","type":"Text"},{"attributes":{"source":{"id":"6331"}},"id":"6335","type":"CDSView"},{"attributes":{"data_source":{"id":"6266"},"glyph":{"id":"6267"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6268"},"selection_glyph":null,"view":{"id":"6270"}},"id":"6269","type":"GlyphRenderer"},{"attributes":{},"id":"6431","type":"Selection"},{"attributes":{"data":{"x":{"__ndarray__":"ltbad4ijGUBBk99dSJEZQIgWbKW4nxhAlCDQ1IQ/GEAOxTHNWtgYQJgNSh/xThpATf1XSgzyGEDcdLbOPmkZQEKSkOVanRhAOdCSXj+fGEA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"KqxUFX8jOUB5dLM6vjg5QGZu0kMP5jlAhFIQRV6uOUBsq8ps8805QGM3sH96+TlAIcuBYSrkOUC9KvT8fps5QMv42oqh1TlAJTiAq7NjOUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6469"},"selection_policy":{"id":"6468"}},"id":"6341","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":4.5},"y":{"value":27.5}},"id":"6337","type":"Text"},{"attributes":{},"id":"6430","type":"UnionRenderers"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":6.5},"y":{"value":19.5}},"id":"6268","type":"Text"},{"attributes":{"data_source":{"id":"6331"},"glyph":{"id":"6332"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6333"},"selection_glyph":null,"view":{"id":"6335"}},"id":"6334","type":"GlyphRenderer"},{"attributes":{},"id":"6429","type":"Selection"},{"attributes":{"source":{"id":"6271"}},"id":"6275","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"triangle_dot"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6333","type":"Scatter"},{"attributes":{"data":{"x":{"__ndarray__":"GVz2yvLxAkCcT0t3w2IEQFphPnuHZgdARLPl2/n0AkB9ky85CfoDQPKdzq9DWwNAGnvBsEkpB0C87kq8uC8HQFjRaPUuYwBArfdJuPUnBkA=","dtype":"float64","order":"little","shape":[10]},"y":{"__ndarray__":"7FHsLUE8NUB4VoeY5gQ1QFAF0mMAPzVAMZ0YHhXWNUCZ6srqSjQ1QPu8+zVXUDVAQGvQ4+dpNUBLt4oFpsU1QJApc5rszjVALJ26ru8TNUA=","dtype":"float64","order":"little","shape":[10]}},"selected":{"id":"6445"},"selection_policy":{"id":"6444"}},"id":"6281","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":23.5}},"id":"6277","type":"Text"},{"attributes":{"data":{"text":["triangle_dot"]},"selected":{"id":"6467"},"selection_policy":{"id":"6466"}},"id":"6336","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6271"},"glyph":{"id":"6272"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6273"},"selection_glyph":null,"view":{"id":"6275"}},"id":"6274","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6336"}},"id":"6340","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"triangle_pin"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6342","type":"Scatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"square"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6273","type":"Scatter"},{"attributes":{"data":{"text":["square"]},"selected":{"id":"6443"},"selection_policy":{"id":"6442"}},"id":"6276","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6336"},"glyph":{"id":"6337"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6338"},"selection_glyph":null,"view":{"id":"6340"}},"id":"6339","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6276"}},"id":"6280","type":"CDSView"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"square_cross"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6282","type":"Scatter"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":4.5},"y":{"value":27.5}},"id":"6338","type":"Text"},{"attributes":{"source":{"id":"6341"}},"id":"6345","type":"CDSView"},{"attributes":{"data_source":{"id":"6276"},"glyph":{"id":"6277"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6278"},"selection_glyph":null,"view":{"id":"6280"}},"id":"6279","type":"GlyphRenderer"},{"attributes":{"background_fill_color":"#eeeeee","below":[{"id":"6089"}],"center":[{"id":"6092"},{"id":"6096"}],"left":[{"id":"6093"}],"output_backend":"webgl","renderers":[{"id":"6114"},{"id":"6119"},{"id":"6124"},{"id":"6129"},{"id":"6134"},{"id":"6139"},{"id":"6144"},{"id":"6149"},{"id":"6154"},{"id":"6159"},{"id":"6164"},{"id":"6169"},{"id":"6174"},{"id":"6179"},{"id":"6184"},{"id":"6189"},{"id":"6194"},{"id":"6199"},{"id":"6204"},{"id":"6209"},{"id":"6214"},{"id":"6219"},{"id":"6224"},{"id":"6229"},{"id":"6234"},{"id":"6239"},{"id":"6244"},{"id":"6249"},{"id":"6254"},{"id":"6259"},{"id":"6264"},{"id":"6269"},{"id":"6274"},{"id":"6279"},{"id":"6284"},{"id":"6289"},{"id":"6294"},{"id":"6299"},{"id":"6304"},{"id":"6309"},{"id":"6314"},{"id":"6319"},{"id":"6324"},{"id":"6329"},{"id":"6334"},{"id":"6339"},{"id":"6344"},{"id":"6349"},{"id":"6354"},{"id":"6359"},{"id":"6364"},{"id":"6369"}],"title":{"id":"6079"},"toolbar":{"id":"6104"},"toolbar_location":null,"x_range":{"id":"6081"},"x_scale":{"id":"6085"},"y_range":{"id":"6083"},"y_scale":{"id":"6087"}},"id":"6078","subtype":"Figure","type":"Plot"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"square_cross"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6283","type":"Scatter"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":6.5},"y":{"value":27.5}},"id":"6347","type":"Text"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":0.5},"y":{"value":23.5}},"id":"6278","type":"Text"},{"attributes":{"data_source":{"id":"6341"},"glyph":{"id":"6342"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6343"},"selection_glyph":null,"view":{"id":"6345"}},"id":"6344","type":"GlyphRenderer"},{"attributes":{"source":{"id":"6281"}},"id":"6285","type":"CDSView"},{"attributes":{"text":"Bokeh Markers"},"id":"6079","type":"Title"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"orange"},"line_alpha":{"value":0.1},"line_color":{"value":"navy"},"marker":{"value":"triangle_pin"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6343","type":"Scatter"},{"attributes":{"text_align":"center","text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":2.5},"y":{"value":23.5}},"id":"6287","type":"Text"},{"attributes":{"fill_alpha":{"value":0.5},"fill_color":{"value":"orange"},"line_alpha":{"value":0.5},"line_color":{"value":"navy"},"marker":{"value":"asterisk"},"size":{"units":"screen","value":14},"x":{"field":"x"},"y":{"field":"y"}},"id":"6112","type":"Scatter"},{"attributes":{"data":{"text":["square_cross"]},"selected":{"id":"6447"},"selection_policy":{"id":"6446"}},"id":"6286","type":"ColumnDataSource"},{"attributes":{"data":{"text":["triangle_pin"]},"selected":{"id":"6471"},"selection_policy":{"id":"6470"}},"id":"6346","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6281"},"glyph":{"id":"6282"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6283"},"selection_glyph":null,"view":{"id":"6285"}},"id":"6284","type":"GlyphRenderer"},{"attributes":{},"id":"6085","type":"LinearScale"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"firebrick"},"text_font_size":{"value":"13px"},"x":{"value":6.5},"y":{"value":27.5}},"id":"6348","type":"Text"},{"attributes":{"data_source":{"id":"6346"},"glyph":{"id":"6347"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"6348"},"selection_glyph":null,"view":{"id":"6350"}},"id":"6349","type":"GlyphRenderer"}],"root_ids":["6078"]},"title":"Bokeh Application","version":"2.2.1"}}';
                  var render_items = [{"docid":"2587aa9e-c433-400a-aad3-c963a96d84f0","root_ids":["6078"],"roots":{"6078":"f8d1adb8-205f-4e1b-ad75-75e3fe84db72"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        clearInterval(timer);
                        embed_document(root);
                      } else {
                        attempts++;
                        if (attempts > 100) {
                          clearInterval(timer);
                          console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        }
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
        
        
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.debug("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(css_urls, js_urls, function() {
          console.debug("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();